using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeWalker.GameFiles
{

    public static class MetaNames
    {
        public static bool TryGetString(uint h, out string str)
        {
            if (Enum.IsDefined(typeof(MetaName), h))
            {
                str = ((MetaName)h).ToString();
                if (str.StartsWith("@")) str = str.Substring(1); //mainly to handle the @null entry
                return true;
            }
            str = null;
            return false;
        }
    }

    
    public class MetaNamesUtil
    {


        public static string GetNameEnumCode()
        {
            //code to generate the enum code with the hash from the list of names
            StringBuilder sb = new StringBuilder();
            string[] names = ShaderParamNames.Split(new[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
            foreach (string name in names)
            {
                uint hash = JenkHash.GenHash(name/*.ToLower()*/, JenkHashInputEncoding.UTF8);
                sb.AppendFormat("{0} = {1},", name, hash);
                sb.AppendLine();
            }
            string result = sb.ToString();
            return result;
        }

        public static string ShaderParamNames = @"";//[redundant list removed]

    }





    public enum MetaName : uint
    {
        aabb = 293662904,
        AABB = 1666779607,
        AbilityType = 229841885,
        Action = 1705836299,
        activeChangesetConditions = 618424668,
        AdditiveDamageClipSet = 1159808383,
        AET_Directed_In_Place = 1450000159,
        AET_Flinch = 2886590336,
        AET_In_Place = 3552718780,
        AET_Interesting = 478982036,
        AET_Threatened = 1152560683,
        AET_Threatening = 56876971,
        aExplosionTagData = 2196546139,
        AFF_POOR = 1885794222,
        Affluence = 2895355855,
        Age = 2099622785,
        aircraftDownwashPtFxDist = 1452685083,
        aircraftDownwashPtFxEnabled = 1469712840,
        aircraftDownwashPtFxNameDefault = 461290670,
        aircraftDownwashPtFxNameDirt = 2734634606,
        aircraftDownwashPtFxNameFoliage = 2573299811,
        aircraftDownwashPtFxNameSand = 1320803722,
        aircraftDownwashPtFxNameWater = 1934771968,
        aircraftDownwashPtFxRange = 192247734,
        aircraftDownwashPtFxSpeedEvoMax = 632867260,
        aircraftDownwashPtFxSpeedEvoMin = 4072762094,
        aircraftSectionDamageSmokePtFxEnabled = 136971974,
        aircraftSectionDamageSmokePtFxName = 345776584,
        aircraftSectionDamageSmokePtFxRange = 2299979830,
        aircraftSectionDamageSmokePtFxSpeedEvoMax = 1864737051,
        aircraftSectionDamageSmokePtFxSpeedEvoMin = 3715270087,
        ALL = 3690519890,
        Allow = 1329228842,
        allowBonnetSlide = 1294495304,
        AllowCloseSpawning = 4019244692,
        ALTERNATE_VARIATIONS_FILE = 611054590,
        AmbientClipsForFlee = 1496688419,
        AmbulanceShouldRespondTo = 2153846297,
        Amount = 42366424,
        Amplitude = 946881915,
        anchor = 1880738441,
        ANCHOR_EARS = 119829315,
        ANCHOR_EYES = 1125276126,
        ANCHOR_HEAD = 2389455644,
        ANCHOR_LEFT_WRIST = 935290624,
        ANCHOR_RIGHT_WRIST = 1131235937,
        AnimalAudioObject = 1131698046,
        AnimatedModel = 1544926406,
        Animations = 212063203,
        AnimDict = 1027851728,
        AnimName = 1300132907,
        AP_LOW = 2695760829,
        AP_MEDIUM = 629290484,
        APF_ISBLENDAUTOREMOVE = 4147018654,
        APF_ISLOOPED = 829168795,
        Apply = 804826100,
        archetypeName = 2686689324,
        archetypes = 25836315,
        areas = 4258609502,
        assetName = 2591541189,
        assetType = 110101682,
        AT_TXD = 3870813049,
        AUDIO_DYNAMIXDATA = 2538787365,
        AUDIO_GAMEDATA = 2568179508,
        AUDIO_SOUNDDATA = 4061522791,
        AUDIO_SPEECHDATA = 2934881832,
        AUDIO_SYNTHDATA = 1488170759,
        AUDIO_WAVEPACK = 1781244916,
        audioApply = 636362136,
        audioId = 3218488635,
        AUDIOMESH_INDEXREMAPPING_FILE = 26529435,
        AutoOpenCloseRateTaper = 838139088,
        AutoOpenCosineAngleBetweenThreshold = 2537405501,
        AutoOpenRadiusModifier = 380434751,
        AutoOpenRate = 4024424870,
        AutoOpensForAllVehicles = 1314594320,
        AutoOpensForLawEnforcement = 711087453,
        AutoOpensForMPPlayerPedsOnly = 2116737868,
        AutoOpensForMPVehicleWithPedsOnly = 4004737101,
        AutoOpensForSPPlayerPedsOnly = 17022999,
        AutoOpensForSPVehicleWithPedsOnly = 883718936,
        AutoOpenVolumeOffset = 2598815900,
        availableInMpSp = 286077157,
        backfirePtFxEnabled = 3590298048,
        backfirePtFxName = 326241207,
        backfirePtFxRange = 2051678496,
        bAppliesContinuousDamage = 1994294878,
        bbMax = 3884623384,
        bbMin = 3656352310,
        bCanSetPedOnFire = 1975010672,
        bDamageObjects = 3087256498,
        bDamageVehicles = 410915188,
        BF_ALLOW_CONFRONT_FOR_TERRITORY_REACTIONS = 135224044,
        BF_BOOST_BRAVERY_IN_GROUP = 1233676580,
        BF_COWARDLY_FOR_SHOCKING_EVENTS = 2349079456,
        Bias = 2130430791,
        BICYCLE = 3348377513,
        bIgnoreExplodingEntity = 558484383,
        BIKE = 1039130067,
        blend = 3933447691,
        Blend = 3998560112,
        BlendOutDelta = 2689634897,
        BlendShapeFileName = 538335227,
        block = 3828602749,
        BLOODFX_FILE = 2150607422,
        bmax = 3220565995,
        bmin = 2028577215,
        bNoOcclusion = 1554370232,
        BOAT = 3921641754,
        boatBowPtFxEnabled = 3846459290,
        boatBowPtFxForwardName = 1639130517,
        boatBowPtFxKeelEvoMax = 237804409,
        boatBowPtFxKeelEvoMin = 3676512912,
        boatBowPtFxRange = 985220618,
        boatBowPtFxReverseName = 547727530,
        boatBowPtFxReverseOffset = 3858334001,
        boatBowPtFxScale = 1915459369,
        boatBowPtFxSpeedEvoMax = 1653246433,
        boatBowPtFxSpeedEvoMin = 2239940421,
        boatEntryPtFxEnabled = 2986953331,
        boatEntryPtFxName = 3178605558,
        boatEntryPtFxRange = 3592388731,
        boatEntryPtFxScale = 2701410410,
        boatEntryPtFxSpeedEvoMax = 2846825758,
        boatEntryPtFxSpeedEvoMin = 690983709,
        boatLowLodWakePtFxEnabled = 1609784914,
        boatLowLodWakePtFxName = 4184644587,
        boatLowLodWakePtFxRangeMax = 2835234692,
        boatLowLodWakePtFxRangeMin = 661173079,
        boatLowLodWakePtFxScale = 3728892023,
        boatLowLodWakePtFxSpeedEvoMax = 3584741482,
        boatLowLodWakePtFxSpeedEvoMin = 1014081258,
        boatPropellerPtFxBackwardSpeedEvoMax = 2824456943,
        boatPropellerPtFxBackwardSpeedEvoMin = 3685235291,
        boatPropellerPtFxDepthEvoMax = 1772973337,
        boatPropellerPtFxDepthEvoMin = 3807963294,
        boatPropellerPtFxEnabled = 620740022,
        boatPropellerPtFxForwardSpeedEvoMax = 4046105228,
        boatPropellerPtFxForwardSpeedEvoMin = 3958699285,
        boatPropellerPtFxName = 2372580323,
        boatPropellerPtFxRange = 333451303,
        boatPropellerPtFxScale = 2960340578,
        boatWashPtFxEnabled = 1083605797,
        boatWashPtFxName = 1782303759,
        boatWashPtFxRange = 3400904137,
        boatWashPtFxScale = 3769797352,
        boatWashPtFxSpeedEvoMax = 1641333397,
        boatWashPtFxSpeedEvoMin = 3421082045,
        bobble_base = 1417117096,
        bobble_head = 1789547068,
        bone = 282216227,
        boneMask = 593061963,
        boneTag = 702019504,
        BONETAG_HEAD = 3914473216,
        BONETAG_INVALID = 3548260605,
        BONETAG_L_CALF = 4031667174,
        BONETAG_L_CLAVICLE = 3253512823,
        BONETAG_L_FINGER0 = 3483436254,
        BONETAG_L_FINGER01 = 3342631108,
        BONETAG_L_FINGER02 = 2503351480,
        BONETAG_L_FINGER1 = 986241836,
        BONETAG_L_FINGER11 = 2527500201,
        BONETAG_L_FINGER12 = 4250526990,
        BONETAG_L_FINGER2 = 1293713363,
        BONETAG_L_FINGER21 = 3526758439,
        BONETAG_L_FINGER22 = 222561854,
        BONETAG_L_FINGER3 = 858967036,
        BONETAG_L_FINGER31 = 3236167907,
        BONETAG_L_FINGER32 = 2527702127,
        BONETAG_L_FINGER4 = 1149791911,
        BONETAG_L_FINGER41 = 3182656438,
        BONETAG_L_FINGER42 = 4127878243,
        BONETAG_L_FOOT = 1655517369,
        BONETAG_L_TOE = 3734897948,
        BONETAG_L_TOE1 = 2497263744,
        BONETAG_L_FOREARM = 2583642279,
        BONETAG_L_HAND = 3058573909,
        BONETAG_L_PH_HAND = 2994337423,
        BONETAG_L_THIGH = 2825836160,
        BONETAG_L_UPPERARM = 3728862758,
        BONETAG_NECK = 1526074386,
        BONETAG_NECK2 = 3577705298,
        BONETAG_PELVIS = 572940669,
        BONETAG_PELVIS1 = 2070754819,
        BONETAG_R_CALF = 1591530804,
        BONETAG_R_CLAVICLE = 623050371,
        BONETAG_R_FINGER0 = 2544970273,
        BONETAG_R_FINGER01 = 1005591915,
        BONETAG_R_FINGER02 = 774537696,
        BONETAG_R_FINGER1 = 4262590177,
        BONETAG_R_FINGER11 = 557114589,
        BONETAG_R_FINGER12 = 308168496,
        BONETAG_R_FINGER2 = 2082763528,
        BONETAG_R_FINGER21 = 2175091220,
        BONETAG_R_FINGER22 = 1557592184,
        BONETAG_R_FINGER3 = 1358503090,
        BONETAG_R_FINGER31 = 1281645843,
        BONETAG_R_FINGER32 = 2136457977,
        BONETAG_R_FINGER4 = 1589098543,
        BONETAG_R_FINGER41 = 1518893755,
        BONETAG_R_FINGER42 = 2295060289,
        BONETAG_R_FOOT = 3872946345,
        BONETAG_R_TOE = 1201239981,
        BONETAG_R_TOE1 = 3004057651,
        BONETAG_R_FOREARM = 3269208355,
        BONETAG_R_HAND = 1128649107,
        BONETAG_R_PH_HAND = 1835505437,
        BONETAG_R_THIGH = 1692969046,
        BONETAG_R_UPPERARM = 868290042,
        BONETAG_ROOT = 102109035,
        BONETAG_SPINE_ROOT = 4085918559,
        BONETAG_SPINE0 = 2529646404,
        BONETAG_SPINE1 = 2239149219,
        BONETAG_SPINE2 = 740327916,
        BONETAG_SPINE3 = 2718199230,
        BONETAG_TAIL0 = 981146734,
        BONETAG_TAIL1 = 1278001105,
        BONETAG_TAIL2 = 2362982695,
        BONETAG_TAIL3 = 2659378300,
        BONETAG_TAIL4 = 1899006424,
        BONETAG_TAIL5 = 2199399847,
        bOnlyAffectsLivePeds = 2543255645,
        bOnlyBulkyItemVariations = 3412263941,
        bonnet = 1704829083,
        boot = 3042873625,
        bottom = 4007699126,
        bPostProcessCollisionsWithNoForce = 1091620747,
        bPreventWaterExplosionVFX = 3664732218,
        BreakableByVehicle = 3427926298,
        BreakingImpulse = 1467901147,
        bsCentre = 3591926527,
        bsRadius = 2196293086,
        bSuppressCrime = 1060477616,
        bumper_f = 3886330357,
        bumper_r = 2370370867,
        bUseDistanceDamageCalc = 1929564509,
        CAiCoverClipVariationHelper__Tunables = 1889755865,
        camAnimatedCameraMetadata = 2493365232,
        camAnimatedShakeMetadata = 830598329,
        camAnimSceneDirectorMetadata = 3688863121,
        CAmbientLookAt__Tunables = 3791958970,
        CAmbientPedModelVariations = 949980109,
        camCatchUpHelperMetadata = 1074754094,
        camCinematicAnimatedCameraMetadata = 597434980,
        camCinematicBustedContextMetadata = 2582741472,
        camCinematicBustedShotMetadata = 46335367,
        camCinematicCameraManCameraMetadata = 1752694078,
        camCinematicCameraManShotMetadata = 3795997700,
        camCinematicCameraOperatorShakeSettings = 267450829,
        camCinematicCameraOperatorShakeTurbulenceSettings = 2761299644,
        camCinematicCameraOperatorShakeUncertaintySettings = 1672408332,
        camCinematicCraningCameraManShotMetadata = 644794406,
        camCinematicDirectorMetadata = 2947939407,
        camCinematicFallFromHeliContextMetadata = 3141653833,
        camCinematicFallFromHeliShotMetadata = 4001219648,
        camCinematicFirstPersonIdleCameraMetadata = 3500761789,
        camCinematicGroupCameraMetadata = 2180005320,
        camCinematicHeliChaseCameraMetadata = 385169240,
        camCinematicHeliTrackingShotMetadata = 50998987,
        camCinematicIdleCameraMetadata = 3818374703,
        camCinematicIdleShots = 3503595515,
        camCinematicInTrainAtStationContextMetadata = 3022638185,
        camCinematicInTrainContextMetadata = 3314933929,
        camCinematicInVehicleContextMetadata = 1660686749,
        camCinematicInVehicleCrashShotMetadata = 35962033,
        camCinematicInVehicleFirstPersonContextMetadata = 976409621,
        camCinematicInVehicleMultiplayerPassengerContextMetadata = 2822987935,
        camCinematicInVehicleOverriddenFirstPersonContextMetadata = 1737743598,
        camCinematicInVehicleWantedContextMetadata = 3656622133,
        camCinematicMissileKillShotMetadata = 947812684,
        camCinematicMountedCameraMetadata = 2185301869,
        camCinematicMountedCameraMetadataFirstPersonPitchOffset = 2402191709,
        camCinematicMountedCameraMetadataFirstPersonRoll = 4132129159,
        camCinematicMountedCameraMetadataLeadingLookSettings = 954561561,
        camCinematicMountedCameraMetadataLookAroundSettings = 1554281348,
        camCinematicMountedCameraMetadataMovementOnAccelerationSettings = 3508760093,
        camCinematicMountedCameraMetadataOrientationSpring = 356764392,
        camCinematicMountedCameraMetadataRelativePitchScalingToThrottle = 745700012,
        camCinematicMountedPartCameraMetadata = 3009480533,
        camCinematicOnFootAssistedAimingContextMetadata = 3749335843,
        camCinematicOnFootAssistedAimingKillShotMetadata = 2251342366,
        camCinematicOnFootFirstPersonIdleShotMetadata = 371427845,
        camCinematicOnFootIdleContextMetadata = 251156589,
        camCinematicOnFootIdleShotMetadata = 1361168617,
        camCinematicOnFootMeleeContextMetadata = 254446303,
        camCinematicOnFootMeleeShotMetadata = 341599647,
        camCinematicOnFootSpectatingContextMetadata = 4029911638,
        camCinematicParachuteCameraManShotMetadata = 4063985916,
        camCinematicParachuteContextMetadata = 13761107,
        camCinematicParachuteHeliShotMetadata = 3350745713,
        camCinematicPedCloseUpCameraMetadata = 3732353935,
        camCinematicPoliceExitVehicleShotMetadata = 3244599436,
        camCinematicPoliceHeliMountedShotMetadata = 216191320,
        camCinematicPoliceInCoverShotMetadata = 971556424,
        camCinematicPoliceRoadBlockShotMetadata = 1663387456,
        camCinematicPositionCameraMetadata = 3193773259,
        camCinematicScriptContextMetadata = 866723283,
        camCinematicScriptedMissionCreatorFailContextMetadata = 1368189925,
        camCinematicScriptedRaceCheckPointContextMetadata = 4197977312,
        camCinematicScriptRaceCheckPointShotMetadata = 1301482539,
        camCinematicShots = 3403418927,
        camCinematicSpectatorNewsChannelContextMetadata = 1655520052,
        camCinematicStuntCameraMetadata = 3215612005,
        camCinematicStuntJumpContextMetadata = 3436792018,
        camCinematicStuntJumpShotMetadata = 3180375976,
        camCinematicTrainPassengerShotMetadata = 1891076392,
        camCinematicTrainRoofMountedShotMetadata = 1375436400,
        camCinematicTrainStationShotMetadata = 4261417377,
        camCinematicTrainTrackingCameraMetadata = 2537902390,
        camCinematicTrainTrackShotMetadata = 2718877126,
        camCinematicTwoShotCameraMetadata = 2296445362,
        camCinematicVehicleBonnetShotMetadata = 3690068033,
        camCinematicVehicleConvertibleRoofShotMetadata = 4253546052,
        camCinematicVehicleGroupShotMetadata = 3216211679,
        camCinematicVehicleLowOrbitCameraMetadata = 1680076183,
        camCinematicVehicleLowOrbitShotMetadata = 357811358,
        camCinematicVehicleOrbitCameraInitalSettings = 3064456407,
        camCinematicVehicleOrbitCameraMetadata = 4218813220,
        camCinematicVehicleOrbitShotMetadata = 723416050,
        camCinematicVehiclePartShotMetadata = 2287426079,
        camCinematicVehicleTrackingCameraMetadata = 2837215026,
        camCinematicWaterCrashCameraMetadata = 1054960932,
        camCinematicWaterCrashShotMetadata = 2640788941,
        camCollisionMetadata = 201950034,
        camCollisionMetadataBuoyancySettings = 3616131743,
        camCollisionMetadataClippingAvoidance = 3777878985,
        camCollisionMetadataOcclusionSweep = 1331207488,
        camCollisionMetadataOrbitDistanceDamping = 2044384768,
        camCollisionMetadataPathFinding = 937440555,
        camCollisionMetadataPullBackTowardsCollision = 1759437459,
        camCollisionMetadataPushBeyondEntitiesIfClipping = 1986022537,
        camCollisionMetadataRotationTowardsLos = 1805808954,
        camControlHelperMetadata = 2587719592,
        camControlHelperMetadataLookAround = 565470605,
        camControlHelperMetaDataPrecisionAimSettings = 3449554353,
        camControlHelperMetadataViewModes = 3633454422,
        camControlHelperMetadataViewModeSettings = 517960737,
        camControlHelperMetadataZoom = 1487224137,
        camCustomTimedSplineCameraMetadata = 4009398869,
        camCutsceneDirectorMetadata = 3410125985,
        camDebugDirectorMetadata = 3499963834,
        camDepthOfFieldSettingsMetadata = 3604381381,
        camEnvelopeMetadata = 2722791558,
        Camera = 2997360705,
        cameraPos = 2339743138,
        camFirstPersonAimCameraMetadataHeadingCorrection = 1094369805,
        camFirstPersonHeadTrackingAimCameraMetadata = 3079183712,
        camFirstPersonPedAimCameraMetadata = 821570743,
        camFirstPersonShooterCameraMetadata = 3837693093,
        camFirstPersonShooterCameraMetadataCoverSettings = 2863258061,
        camFirstPersonShooterCameraMetadataOrientationSpring = 4197661848,
        camFirstPersonShooterCameraMetadataOrientationSpringLite = 1421319957,
        camFirstPersonShooterCameraMetadataRelativeAttachOrientationSettings = 1064503511,
        camFirstPersonShooterCameraMetadataSprintBreakOutSettings = 3371709132,
        camFirstPersonShooterCameraMetadataStickyAim = 2799165301,
        camFollowCameraMetadataFollowOrientationConing = 2364914607,
        camFollowCameraMetadataHighAltitudeZoomSettings = 418469874,
        camFollowCameraMetadataPullAroundSettings = 3437120378,
        camFollowCameraMetadataRollSettings = 1774242875,
        camFollowParachuteCameraMetadata = 736042439,
        camFollowParachuteCameraMetadataCustomSettings = 1574447900,
        camFollowPedCameraMetadata = 3759477553,
        camFollowPedCameraMetadataAssistedMovementAlignment = 559130398,
        camFollowPedCameraMetadataCustomViewModeSettings = 2553880007,
        camFollowPedCameraMetadataDivingShakeSettings = 2182445161,
        camFollowPedCameraMetadataHighFallShakeSettings = 2518615630,
        camFollowPedCameraMetadataLadderAlignment = 947799964,
        camFollowPedCameraMetadataOrbitPitchLimitsForOverheadCollision = 1431341429,
        camFollowPedCameraMetadataPushBeyondNearbyVehiclesInRagdollSettings = 2530185515,
        camFollowPedCameraMetadataRappellingAlignment = 1129712783,
        camFollowPedCameraMetadataRunningShakeSettings = 2053748298,
        camFollowPedCameraMetadataSwimmingShakeSettings = 4069495749,
        camFollowVehicleCameraMetadata = 420909885,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettings = 4113023525,
        camFollowVehicleCameraMetadataDuckUnderOverheadCollisionSettingsCapsuleSettings = 3720026770,
        camFollowVehicleCameraMetadataHandBrakeSwingSettings = 2830469256,
        camFollowVehicleCameraMetadataHighSpeedShakeSettings = 2477380333,
        camFollowVehicleCameraMetadataHighSpeedZoomSettings = 2338842389,
        camFollowVehicleCameraMetadataVerticalFlightModeSettings = 62698329,
        camFollowVehicleCameraMetadataWaterEntryShakeSettings = 3274567537,
        camFreeCameraMetadata = 569456131,
        camGameplayDirectorMetadata = 1800753065,
        camGameplayDirectorMetadataExplosionShakeSettings = 2835005341,
        camGameplayDirectorMetadataVehicleCustomSettings = 3404668154,
        camHintHelperMetadata = 939949516,
        camHintHelperMetadataPivotPositionAdditive = 242159927,
        camInconsistentBehaviourZoomHelperAirborneSettings = 3999425876,
        camInconsistentBehaviourZoomHelperDetectFastCameraTurnSettings = 193557158,
        camInconsistentBehaviourZoomHelperDetectSuddenMovementSettings = 2547763044,
        camInconsistentBehaviourZoomHelperLosSettings = 2655036129,
        camInconsistentBehaviourZoomHelperMetadata = 589272335,
        camLongSwoopSwitchHelperMetadata = 3366863628,
        camLookAheadHelperMetadata = 1630118580,
        camLookAtDampingHelperMetadata = 2621748074,
        camMarketingAToBCameraMetadata = 2461291580,
        camMarketingDirectorMetadata = 1412464790,
        camMarketingDirectorMetadataMode = 1136544428,
        camMarketingFreeCameraMetadata = 1284661433,
        camMarketingFreeCameraMetadataInputResponse = 624552429,
        camMarketingMountedCameraMetadata = 925580290,
        camMarketingOrbitCameraMetadata = 545216445,
        camMarketingStickyCameraMetadata = 915237293,
        camMetadataStore = 1634862667,
        camMotionBlurSettingsMetadata = 2215393933,
        camNearClipScannerMetadata = 2769283405,
        camOscillatorMetadata = 1877334503,
        camPreferredShotSelectionType = 2475841577,
        camReplayBaseCameraMetadataCollisionSettings = 1965600814,
        camReplayBaseCameraMetadataInputResponse = 3315215408,
        camReplayDirectorMetadata = 3250236667,
        camReplayFreeCameraMetadata = 3833530058,
        camReplayPresetCameraMetadata = 3519845310,
        camReplayRecordedCameraMetadata = 68919197,
        camRoundedSplineCameraMetadata = 4144888485,
        camScriptDirectorMetadata = 808165906,
        camScriptedCameraMetadata = 2249792487,
        camScriptedFlyCameraMetadata = 201638894,
        camScriptedFlyCameraMetadataInputResponse = 2912311349,
        camSeatSpecificCameras = 3206558883,
        camShake = 2812731727,
        camShakeMetadata = 2610893148,
        camShakeMetadataFrameComponent = 1092637061,
        camShakeName = 3155961353,
        camShakeRollOffScaling = 1058165836,
        camShortRotationSwitchHelperMetadata = 4216220206,
        camShortTranslationSwitchHelperMetadata = 1635202674,
        camShortZoomInOutSwitchHelperMetadata = 1845372544,
        camShortZoomToHeadSwitchHelperMetadata = 3608544718,
        camSmoothedSplineCameraMetadata = 2992118265,
        camSpeedRelativeShakeSettingsMetadata = 3163469773,
        camSpringMountMetadata = 545475055,
        camSwitchCameraMetadata = 3778407244,
        camSwitchDirectorMetadata = 1186645804,
        camSyncedSceneDirectorMetadata = 3842242989,
        camThirdPersonCameraMetadataBasePivotPosition = 2562557362,
        camThirdPersonCameraMetadataBasePivotPositionRollSettings = 3378401281,
        camThirdPersonCameraMetadataBuoyancySettings = 4280883922,
        camThirdPersonCameraMetadataCollisionFallBackPosition = 2931931466,
        camThirdPersonCameraMetadataCustomBoundingBoxSettings = 542523046,
        camThirdPersonCameraMetadataLookOverSettings = 1204861982,
        camThirdPersonCameraMetadataPivotOverBoungingBoxSettings = 70704803,
        camThirdPersonCameraMetadataPivotPosition = 3548788069,
        camThirdPersonCameraMetadataQuadrupedalHeightSpring = 2372917588,
        camThirdPersonCameraMetadataStealthZoomSettings = 1308532518,
        camThirdPersonCameraMetadataVehicleOnTopOfVehicleCollisionSettings = 1457190622,
        camThirdPersonPedAimCameraMetadata = 1732613077,
        camThirdPersonPedAimCameraMetadataLockOnOrbitDistanceSettings = 2689046040,
        camThirdPersonPedAimCameraMetadataLockOnTargetDampingSettings = 810467818,
        camThirdPersonPedAimInCoverCameraMetadata = 3583421172,
        camThirdPersonPedAimInCoverCameraMetadataAimingSettings = 2711282760,
        camThirdPersonPedAimInCoverCameraMetadataLowCoverSettings = 4274825405,
        camThirdPersonPedAssistedAimCameraCinematicMomentSettings = 2799730898,
        camThirdPersonPedAssistedAimCameraInCoverSettings = 2194812563,
        camThirdPersonPedAssistedAimCameraLockOnAlignmentSettings = 2731233901,
        camThirdPersonPedAssistedAimCameraMetadata = 4075428929,
        camThirdPersonPedAssistedAimCameraPivotScalingSettings = 774378567,
        camThirdPersonPedAssistedAimCameraPlayerFramingSettings = 1026402136,
        camThirdPersonPedAssistedAimCameraRecoilShakeScalingSettings = 3357216290,
        camThirdPersonPedAssistedAimCameraRunningShakeSettings = 1609808531,
        camThirdPersonPedAssistedAimCameraShakeActivityScalingSettings = 3550987017,
        camThirdPersonPedAssistedAimCameraShootingFocusSettings = 4025041103,
        camThirdPersonPedMeleeAimCameraMetadata = 3247898661,
        camThirdPersonVehicleAimCameraMetadata = 1836891244,
        camTimedSplineCameraMetadata = 2703512219,
        camVehicleCustomSettingsMetadata = 2297662625,
        camVehicleCustomSettingsMetadataAdditionalBoundScalingVehicleSettings = 2484857206,
        camVehicleCustomSettingsMetadataDoorAlignmentSettings = 690471002,
        camVehicleCustomSettingsMetadataExitSeatPhaseForCameraExitSettings = 2756864235,
        camVehicleCustomSettingsMetadataInvalidCinematcShotsRefsForVehicleSettings = 4239733162,
        camVehicleCustomSettingsMetadataMultiplayerPassengerCameraHashSettings = 695621723,
        camVehicleCustomSettingsMetadataSeatSpecficCameras = 1805758296,
        CAnimSpeedUps__Tunables = 1899092416,
        CanRideBikeWithNoHelmet = 2247732941,
        CanSpawnInCar = 2174732092,
        CantUse = 4039535360,
        CapsuleHalfHeight = 2163883074,
        CapsuleHalfWidth = 629093761,
        CapsuleLen = 3235184882,
        CapsuleRadius = 1996975203,
        CapsuleZOffset = 1054694912,
        CAR = 185025060,
        CARCOLS_FILE = 869804114,
        carModel = 3176005905,
        CBaseArchetypeDef = 2195127427,
        CBikeLeanAngleHelper__Tunables = 1450700199,
        CCarGen = 1860713439,
        CClipScalingHelper__Tunables = 3772901649,
        CCombatTaskManager__Tunables = 1555503841,
        CCreatureMetaData = 2042092773,
        CCurve = 608533002,
        CCurveSet = 2222014563,
        CDataFileMgr__ContentsOfDataFileXml = 1736702710,
        CDispatchAdvancedSpawnHelper__Tunables = 91788279,
        CDispatchHelperSearchInAutomobile__Tunables = 587339511,
        CDispatchHelperSearchInBoat__Tunables = 2880812777,
        CDispatchHelperSearchInHeli__Tunables = 1963636404,
        CDispatchHelperSearchOnFoot__Tunables = 2463141505,
        CDispatchHelperVolumes__Tunables = 3789346099,
        CDispatchSpawnHelper__Tunables = 487533277,
        CDistantLODLight = 2033467892,
        CDoorTuningFile = 2411310721,
        CDynamicCoverHelper__Tunables = 3153023901,
        centerAndRadius = 4089746177,
        CEntityDef = 3461354627,
        CEventAgitated__Tunables = 2874507431,
        CEventCrimeCryForHelp__Tunables = 2970598878,
        CEventEncroachingPed__Tunables = 30996625,
        CEventExplosionHeard__Tunables = 2586882546,
        CEventFootStepHeard__Tunables = 2570549492,
        CEventGunAimedAt__Tunables = 1810003585,
        CEventGunShot__Tunables = 2246785633,
        CEventMeleeAction__Tunables = 2580170005,
        CEventPedJackingMyVehicle__Tunables = 3230173079,
        CEventPotentialBeWalkedInto__Tunables = 447216401,
        CEventPotentialBlast__Tunables = 3804045499,
        CEventPotentialGetRunOver__Tunables = 4074745581,
        CEventRequestHelp__Tunables = 1097617571,
        CEventRespondedToThreat__Tunables = 1657862556,
        CEventShocking__Tunables = 2688422386,
        CEventSuspiciousActivity__Tunables = 2370193555,
        CExplosionInfoManager = 254220034,
        CExtensionDefAudioCollisionSettings = 366926375,
        CExtensionDefAudioEmitter = 637823035,
        CExtensionDefBuoyancy = 749982947,
        CExtensionDefDoor = 1965932561,
        CExtensionDefExplosionEffect = 104349545,
        CExtensionDefExpression = 3870521079,
        CExtensionDefLadder = 2182960161,
        CExtensionDefLightEffect = 663891011,
        CExtensionDefLightShaft = 2718997053,
        CExtensionDefParticleEffect = 975627745,
        CExtensionDefProcObject = 2565191912,
        CExtensionDefSpawnPoint = 3300062776,
        CExtensionDefSpawnPointOverride = 2716862120,
        CExtensionDefWindDisturbance = 569228403,
        CFiringPatternInfo = 4139644871,
        CFiringPatternInfoManager = 3698419088,
        CGrabHelper__Tunables = 1898505781,
        Chances = 3434267272,
        changeSetName = 3618800523,
        chassis = 3558367838,
        CHDTxdAssetBinding = 1501994083,
        childName = 204594422,
        children = 240949893,
        CLegIkSolver__Tunables = 841524051,
        CLevelData = 75111904,
        CLightAttrDef = 4115341947,
        Clip = 547633373,
        CLIP_SETS_FILE = 4136207125,
        clipDictionaryMetadatas = 3037672124,
        clipDictionaryName = 635311839,
        ClipDictionaryName = 2571958159,
        clipItems = 3294768058,
        clips = 1731275751,
        ClipSet = 230522063,
        ClipSetId = 1769383946,
        clipSets = 2366522350,
        ClipSets = 2460310938,
        CLODLight = 2276214072,
        CLookAtHistory__Tunables = 4214737672,
        CMapData = 3545841574,
        CMapTypes = 3649811809,
        CMiniMap__Tunables = 4077958042,
        CMloArchetypeDef = 273704021,
        CMloEntitySet = 3601308153,
        CMloInstanceDef = 164374718,
        CMloPortalDef = 2572186314,
        CMloRoomDef = 186126833,
        CMloTimeCycleModifier = 807246248,
        CMultiTxdRelationship = 1261337422,
        CNmMessage = 540147835,
        CNmParameterBool = 3201838637,
        CNmParameterFloat = 2458347956,
        CNmParameterInt = 1429899100,
        CNmParameterRandomFloat = 3855903374,
        CNmParameterRandomInt = 213806608,
        CNmParameterResetMessage = 3594683582,
        CNmParameterString = 2290405727,
        CNmParameterVector = 1886176625,
        CNmTuningSet = 1903166467,
        col = 2082703339,
        collisionBone = 3234051813,
        CollisionData = 3547055785,
        CollisionRadius = 2961500813,
        color = 3914595625,
        Color = 1308845671,
        colors = 140995175,
        colour = 1541149667,
        CombatInfo = 894792629,
        Component = 3344490581,
        components = 3094514372,
        compositeEntityTypes = 1709823211,
        CompRestrictions = 1292693219,
        CONDITIONAL_ANIMS_FILE = 7003891,
        CONTENT_UNLOCKING_META_FILE = 138872183,
        contentChangeSets = 614695604,
        contents = 780522884,
        CONTENTS_ANIMATION = 1729429563,
        CONTENTS_CUTSCENE = 1341504475,
        CONTENTS_DLC_MAP_DATA = 2008833657,
        CONTENTS_LODS = 129500478,
        CONTENTS_MAP = 3584173080,
        CONTENTS_PEDS = 2150818969,
        CONTENTS_PROPS = 85688491,
        CONTENTS_VEHICLES = 3204813008,
        Context = 2518983606,
        corners = 1329770163,
        CPackFileMetaData = 2477165103,
        CPedCompExpressionData = 3105947251,
        CPedModelInfo__InitDataList = 3715594014,
        CPedModelInfo__PersonalityDataList = 2428131759,
        CPedPropExpressionData = 2871393870,
        CPedTargetEvaluator__Tunables = 1616944729,
        CPedTargetting__Tunables = 3572343040,
        CPlayerCoverClipVariationHelper__Tunables = 3847977171,
        CPlayerInfo__sPlayerStatInfo = 1168828738,
        CPlayerInfo__sSprintControlData = 2225340824,
        CPlayerInfo__Tunables = 3763924699,
        CPlayerPedTargeting__Tunables = 1955283657,
        CPoliceBoatDispatch__Tunables = 308678703,
        CPrioritizedClipSetRequestManager__Tunables = 76934329,
        CProceduralInfo = 4283490117,
        CPtFxAssetDependencyInfo = 3936596588,
        CPtFxAssetInfoMgr = 3599498566,
        CRandomEventManager__Tunables = 3308217727,
        CreatureMetadataName = 982286538,
        CRelationshipManager__Tunables = 1682166943,
        Crimes = 944438733,
        CScenarioClipHelper__Tunables = 1707736265,
        CScenarioPointGroup = 3383680063,
        CScenarioPointManifest = 1425675487,
        CScenarioPointRegionDef = 1251976652,
        CShaderVariableComponent = 3881120539,
        CSituationalClipSetStreamer__Tunables = 1395325338,
        CTacticalAnalysis__Tunables = 1413047452,
        CTacticalAnalysisCoverPoints__Tunables = 3043164413,
        CTacticalAnalysisCoverPointSearch__Tunables = 2640991648,
        CTacticalAnalysisNavMeshPoints__Tunables = 1220308217,
        CTargettingDifficultyInfo = 1135093158,
        CTaskAdvance__Tunables = 166066110,
        CTaskAgitated__Tunables = 451717787,
        CTaskAimAndThrowProjectile__Tunables = 920055786,
        CTaskAimFromGround__Tunables = 1016413941,
        CTaskAimGunBlindFire__Tunables = 3400346520,
        CTaskAimGunFromCoverIntro__Tunables = 675160047,
        CTaskAimGunFromCoverOutro__Tunables = 753314165,
        CTaskAimGunOnFoot__Tunables = 71881945,
        CTaskAimGunVehicleDriveBy__Tunables = 3042947166,
        CTaskAmbientClips__Tunables = 1589125251,
        CTaskAnimatedHitByExplosion__Tunables = 1117516593,
        CTaskArrestPed__Tunables = 1399891452,
        CTaskBoatChase__Tunables = 3798971738,
        CTaskBoatCombat__Tunables = 2409668190,
        CTaskBoatStrafe__Tunables = 3036495892,
        CTaskCallPolice__Tunables = 2834037164,
        CTaskCarReactToVehicleCollision__Tunables = 2728841566,
        CTaskChat__Tunables = 52767132,
        CTaskCloseVehicleDoorFromInside__Tunables = 3615161210,
        CTaskCombat__Tunables = 1035504443,
        CTaskCombatAdditionalTask__Tunables = 4286320209,
        CTaskCombatFlank__Tunables = 3480084478,
        CTaskComplexEvasiveStep__Tunables = 1335476290,
        CTaskConfront__Tunables = 150142004,
        CTaskConversationHelper__Tunables = 754470627,
        CTaskCoupleScenario__Tunables = 44269074,
        CTaskCover__Tunables = 3452806650,
        CTaskCowerScenario__Tunables = 27789385,
        CTaskDamageElectric__Tunables = 856265530,
        CTaskDraggingToSafety__Tunables = 4043706236,
        CTaskDyingDead__Tunables = 2675734391,
        CTaskEnterCover__Tunables = 1433330874,
        CTaskEnterVehicle__Tunables = 1027962175,
        CTaskEnterVehicleAlign__Tunables = 1636991334,
        CTaskEnterVehicleSeat__Tunables = 135393357,
        CTaskExhaustedFlee__Tunables = 633079219,
        CTaskExitCover__Tunables = 3296810549,
        CTaskExitVehicle__Tunables = 4141614587,
        CTaskExitVehicleSeat__Tunables = 4292350695,
        CTaskFall__Tunables = 3858033844,
        CTaskFishLocomotion__Tunables = 528773834,
        CTaskFlyingWander__Tunables = 2593718369,
        CTaskFlyToPoint__Tunables = 2856283273,
        CTaskGetUp__Tunables = 1454643673,
        CTaskGoToScenario__Tunables = 342235337,
        CTaskGrowlAndFlee__Tunables = 3882342074,
        CTaskGun__Tunables = 1283860553,
        CTaskHeliChase__Tunables = 4167522072,
        CTaskHeliCombat__Tunables = 1828825613,
        CTaskHelicopterStrafe__Tunables = 3763664820,
        CTaskHeliOrderResponse__Tunables = 162290274,
        CTaskHeliPassengerRappel__Tunables = 3828979530,
        CTaskHumanLocomotion__Tunables = 2920137037,
        CTaskInCover__Tunables = 1340552235,
        CTaskIntimidate__Tunables = 1888161203,
        CTaskInVehicleBasic__Tunables = 3591430584,
        CTaskInvestigate__Tunables = 2122351816,
        CTaskJump__Tunables = 1477206380,
        CTaskMeleeActionResult__Tunables = 1673636385,
        CTaskMotionAiming__Tunables = 1860470777,
        CTaskMotionBasicLocomotionLowLod__Tunables = 835509391,
        CTaskMotionInAutomobile__Tunables = 175867186,
        CTaskMotionInCover__Tunables = 1914830328,
        CTaskMotionInTurret__Tunables = 2020941567,
        CTaskMotionInVehicle__Tunables = 2450186166,
        CTaskMotionOnBicycle__Tunables = 1415781118,
        CTaskMotionOnBicycleController__Tunables = 1645332033,
        CTaskMotionSwimming__Tunables = 1000070523,
        CTaskMotionTennis__Tunables = 3629609639,
        CTaskMoveCombatMounted__Tunables = 1568594793,
        CTaskMoveCrossRoadAtTrafficLights__Tunables = 2381559732,
        CTaskMoveFollowNavMesh__Tunables = 418889424,
        CTaskMoveToTacticalPoint__Tunables = 2603381663,
        CTaskMoveWithinAttackWindow__Tunables = 938139729,
        CTaskNMBalance__Tunables = 4156771533,
        CTaskNMBehaviour__Tunables = 1424285270,
        CTaskNMBrace__Tunables = 959283411,
        CTaskNMBuoyancy__Tunables = 2908480529,
        CTaskNMControl__Tunables = 208512313,
        CTaskNMDraggingToSafety__Tunables = 4274630537,
        CTaskNMDrunk__Tunables = 1927528235,
        CTaskNMElectrocute__Tunables = 1986788875,
        CTaskNMExplosion__Tunables = 3668321041,
        CTaskNMFlinch__Tunables = 1394958084,
        CTaskNMHighFall__Tunables = 4010904374,
        CTaskNMInjuredOnGround__Tunables = 3943948180,
        CTaskNMJumpRollFromRoadVehicle__Tunables = 465597172,
        CTaskNMOnFire__Tunables = 749058568,
        CTaskNMPrototype__Tunables = 2697213281,
        CTaskNMPrototype__Tunables__TimedTuning = 1783260611,
        CTaskNMRiverRapids__Tunables = 2208098656,
        CTaskNMShot__Tunables = 365558263,
        CTaskNMSimple__Tunables = 1759871612,
        CTaskNMThroughWindscreen__Tunables = 701095463,
        CTaskOpenVehicleDoorFromOutside__Tunables = 4000867050,
        CTaskParachute__Tunables = 330647109,
        CTaskParachuteObject__Tunables = 533009545,
        CTaskPlaneChase__Tunables = 3362905475,
        CTaskPlayerDrive__Tunables = 2233320042,
        CTaskPlayerOnFoot__Tunables = 2843912235,
        CTaskPoliceOrderResponse__Tunables = 1572997428,
        CTaskPursueCriminal__Tunables = 1017737308,
        CTaskQuadLocomotion__Tunables = 3451166416,
        CTaskRageRagdoll__Tunables = 4111703670,
        CTaskRappel__Tunables = 583393603,
        CTaskReactAimWeapon__Tunables = 3431679747,
        CTaskReactAndFlee__Tunables = 1455936464,
        CTaskReactInDirection__Tunables = 1160501277,
        CTaskReactToBeingAskedToLeaveVehicle__Tunables = 2747883046,
        CTaskReactToBuddyShot__Tunables = 3060185515,
        CTaskReactToExplosion__Tunables = 1714101654,
        CTaskReactToImminentExplosion__Tunables = 2053606685,
        CTaskReactToPursuit__Tunables = 3823017031,
        CTaskRideTrain__Tunables = 85139718,
        CTaskScenarioFlee__Tunables = 4223438874,
        CTaskSearch__Tunables = 2186129008,
        CTaskSearchBase__Tunables = 1006486559,
        CTaskSearchForUnknownThreat__Tunables = 3552809742,
        CTaskSearchInAutomobile__Tunables = 3157865989,
        CTaskSearchInBoat__Tunables = 3740707804,
        CTaskSearchInHeli__Tunables = 2902745725,
        CTaskSearchOnFoot__Tunables = 1589612569,
        CTaskSharkAttack__Tunables = 2411903884,
        CTaskSharkCircle__Tunables = 3798074522,
        CTaskShockingEvent__Tunables = 2668698466,
        CTaskShockingEventBackAway__Tunables = 1421095933,
        CTaskShockingEventGoto__Tunables = 3634782675,
        CTaskShockingEventHurryAway__Tunables = 3936521982,
        CTaskShockingEventReact__Tunables = 1524084241,
        CTaskShockingEventReactToAircraft__Tunables = 1470816321,
        CTaskShockingEventStopAndStare__Tunables = 1473719990,
        CTaskShockingEventWatch__Tunables = 4159743939,
        CTaskShockingPoliceInvestigate__Tunables = 2727614619,
        CTaskShootOutTire__Tunables = 3623406952,
        CTaskShove__Tunables = 2315221829,
        CTaskShoved__Tunables = 2184485071,
        CTaskSmartFlee__Tunables = 2929340853,
        CTaskStandGuard__Tunables = 928089637,
        CTaskStealVehicle__Tunables = 3788906738,
        CTaskSwapWeapon__Tunables = 756021342,
        CTaskSwatOrderResponse__Tunables = 1687602234,
        CTaskSwimmingWander__Tunables = 581692275,
        CTaskTakeOffPedVariation__Tunables = 2581463145,
        CTaskTargetUnreachable__Tunables = 1996880107,
        CTaskTargetUnreachableInExterior__Tunables = 1858966752,
        CTaskTargetUnreachableInInterior__Tunables = 2878804031,
        CTaskTrainBase__Tunables = 2321692150,
        CTaskTryToGrabVehicleDoor__Tunables = 2780911905,
        CTaskUnalerted__Tunables = 3631212269,
        CTaskUseScenario__Tunables = 4286728767,
        CTaskUseVehicleScenario__Tunables = 1105517236,
        CTaskVariedAimPose__Tunables = 572125765,
        CTaskVault__Tunables = 4107041159,
        CTaskVehicleApproach__Tunables = 3998182611,
        CTaskVehicleBlock__Tunables = 946218496,
        CTaskVehicleBlockBackAndForth__Tunables = 3195863117,
        CTaskVehicleBlockBrakeInFront__Tunables = 1783020311,
        CTaskVehicleBlockCruiseInFront__Tunables = 2600077603,
        CTaskVehicleChase__Tunables = 1182936554,
        CTaskVehicleCombat__Tunables = 1479019922,
        CTaskVehicleCrash__Tunables = 3962616343,
        CTaskVehicleCruiseBoat__Tunables = 3100673805,
        CTaskVehicleDeadDriver__Tunables = 2144691340,
        CTaskVehicleFlee__Tunables = 195975428,
        CTaskVehicleFleeBoat__Tunables = 1082281615,
        CTaskVehicleFSM__Tunables = 2154756726,
        CTaskVehicleGoToBoat__Tunables = 1874670628,
        CTaskVehicleGoToHelicopter__Tunables = 505312818,
        CTaskVehicleGoToPlane__Tunables = 2216414081,
        CTaskVehicleGoToPointWithAvoidanceAutomobile__Tunables = 305265911,
        CTaskVehicleLandPlane__Tunables = 2468823445,
        CTaskVehicleMissionBase__Tunables = 3839812632,
        CTaskVehicleParkNew__Tunables = 1266857276,
        CTaskVehiclePersuit__Tunables = 424095714,
        CTaskVehiclePlaneChase__Tunables = 2639568629,
        CTaskVehiclePullAlongside__Tunables = 3971388892,
        CTaskVehiclePursue__Tunables = 1465682442,
        CTaskVehicleRam__Tunables = 4205884753,
        CTaskVehicleShotTire__Tunables = 4029377803,
        CTaskVehicleSpinOut__Tunables = 1106913269,
        CTaskWalkAway__Tunables = 206304570,
        CTaskWander__Tunables = 3543621225,
        CTaskWanderInArea__Tunables = 711403403,
        CTaskWanderingScenario__Tunables = 4183061553,
        CTaskWitness__Tunables = 1436906951,
        CTimeArchetypeDef = 1991296364,
        CTimeCycleModifier = 1733268304,
        CustomTriggerBox = 2579426011,
        CVehicleClipRequestHelper__Tunables = 2857018690,
        CVehicleModelInfoVarGlobal = 3184659407,
        CVehicleModelInfoVariation = 746362187,
        CVehicleScenarioManager__AttractorTuning__Tunables = 1138425769,
        CVfxVehicleInfo = 2566559812,
        CVfxVehicleInfoMgr = 13081091,
        CWanted__Tunables = 2938521871,
        CWantedHelicopterDispatch__Tunables = 3681116455,
        CWildlifeManager__Tunables = 3899878125,
        damageAtCentre = 626304432,
        damageAtEdge = 1456455832,
        dataFiles = 4164602339,
        DECALS_FILE = 721270417,
        decayFactor = 2187394038,
        DecisionMakerName = 71722552,
        Default = 1012917042,
        DefaultBrawlingStyle = 665939989,
        defaultEntitySets = 1407157833,
        DefaultGestureClipSet = 289586118,
        DefaultRemoveRangeMultiplier = 2267082285,
        DefaultSpawningPreference = 3497281775,
        DefaultTaskDataSetName = 2977281996,
        DefaultUnarmedWeapon = 2801601573,
        DefaultVisemeClipSet = 3269491505,
        DelayDoorClosingForPlayer = 2356415658,
        Density = 1026783212,
        DensityRange = 4153067752,
        directedLifeTime = 2075377911,
        directedWidth = 932713096,
        direction = 887068712,
        Direction = 2690021765,
        disableBonnetCamera = 1563940027,
        disabled = 2572083169,
        Disabled = 295298378,
        disabledFiles = 3110537950,
        Dispatch = 3591134869,
        Distance = 1974652584,
        DistanceRange = 1987085678,
        DISTANT_LIGHTS_FILE = 983558349,
        DISTANT_LIGHTS_HD_FILE = 2925996279,
        distBetweenCoronas = 1962520137,
        distBetweenCoronas_far = 232750087,
        DLC_ITYP_REQUEST = 4114167230,
        DLC_SCRIPT_METAFILE = 259967989,
        DLC_WEAPON_PICKUPS = 3168769355,
        dlcName = 2337697442,
        DontCloseWhenTouched = 1465449817,
        door_dside_f = 1744947660,
        door_dside_r = 3782851822,
        door_pside_f = 2553297679,
        door_pside_r = 1096977781,
        DOOR_TUNING_FILE = 57918953,
        drawableDictionary = 4229936891,
        DrawableId = 1166348048,
        DrawableIndex = 1740452767,
        DSP_NORMAL = 1082005734,
        duration = 3674968789,
        Duration = 2193831214,
        Edges = 1456031062,
        effectsData = 3285521232,
        emmissiveBoost = 1697573984,
        EMPTY = 2749884260,
        Enable = 421699355,
        enabled = 1527945487,
        Enabled = 1989893331,
        EnabledByDefault = 3921215899,
        end = 2965669335,
        End = 443072552,
        endHour = 380604338,
        EndModel = 3041118144,
        endPhase = 1600588195,
        endRadius = 306326438,
        enforceLsnSorting = 3949387622,
        engineblock = 2036489924,
        engineDamagePtFxEnabled = 2314702693,
        engineDamagePtFxHasPanel = 811799967,
        engineDamagePtFxHasRotorEvo = 935734665,
        engineDamagePtFxNoPanelName = 2142304406,
        engineDamagePtFxPanelOpenName = 2589870806,
        engineDamagePtFxPanelShutName = 2754603386,
        engineDamagePtFxRange = 1633907331,
        engineDamagePtFxSpeedEvoMax = 4116298751,
        engineDamagePtFxSpeedEvoMin = 1190778122,
        engineStartupPtFxEnabled = 2837195620,
        engineStartupPtFxName = 2081216567,
        engineStartupPtFxRange = 3534688011,
        entities = 3433796359,
        ENTITYFX_FILE = 209619560,
        EventType = 2248400140,
        exclusions = 1912839368,
        executionConditions = 312713139,
        exhaust = 2148626005,
        exhaust_2 = 3047243728,
        exhaust_3 = 4276408918,
        exhaust_4 = 286750395,
        exhaustPtFxCutOffSpeed = 1411922576,
        exhaustPtFxEnabled = 3040982233,
        exhaustPtFxName = 2262693655,
        exhaustPtFxRange = 3636073,
        exhaustPtFxScale = 4006380515,
        exhaustPtFxSpeedEvoMax = 1132138093,
        exhaustPtFxSpeedEvoMin = 2787040150,
        exhaustPtFxTempEvoMax = 2189200497,
        exhaustPtFxTempEvoMin = 2162145396,
        exhaustPtFxThrottleEvoOnGearChange = 1254006862,
        explodeAttachEntityWhenFinished = 2712903420,
        Explosion = 3638218222,
        EXPLOSION_INFO_FILE = 1307223293,
        EXPLOSIONFX_FILE = 2522650906,
        ExpressionDictionaryName = 1760551351,
        expressionName = 1573835099,
        ExpressionName = 3005293958,
        ExpressionSetName = 2352891724,
        extendedRange = 3534580187,
        extensions = 4051599144,
        ExternallyDrivenDOFs = 4106672091,
        extra_1 = 3819846466,
        extra_2 = 3050790801,
        extra_3 = 2297431491,
        extra_4 = 2590320813,
        extra_5 = 2830583129,
        EXTRA_FOLDER_MOUNT_DATA = 374419551,
        EXTRA_TITLE_UPDATE_DATA = 2227896657,
        FacialClipsetGroupName = 1843847949,
        fallbackId = 3378470045,
        Falling = 4171606781,
        falloff = 3429369576,
        falloffExponent = 733168314,
        falloffMax = 2603992812,
        Female = 107208361,
        FFrontOffset = 2475984948,
        Fight = 2236152585,
        filename = 1087019066,
        filesToDisable = 3328021166,
        filesToEnable = 2417471446,
        filesToInvalidate = 3805669424,
        fileType = 345145806,
        FIREFX_FILE = 1731707109,
        FirstPersonDriveByIKOffset = 1272308759,
        flags = 1741842546,
        Flags = 1264718594,
        flash = 2239439183,
        Flee = 1684954205,
        forceFactor = 3761213775,
        Forward = 4076313930,
        Fov = 3926516228,
        fragDamage = 2676323813,
        fRagdollForceModifier = 1451234527,
        frontIndicatorCorona = 3430197797,
        fSelfForceModifier = 3267483248,
        FullBodyDamageClipSet = 4228310587,
        FUpOffset = 4137555685,
        fwClipItem = 4225016529,
        fwClipItemWithProps = 615994212,
        fwClipSet = 3765269019,
        fwClipSetManager = 4032904779,
        fxName = 1920790105,
        fxOffsetPos = 3676475576,
        fxOffsetRot = 1710928362,
        fxType = 529104057,
        GetupSetHash = 1726861708,
        GroundColor = 860002656,
        group = 3391120809,
        Group = 1713610519,
        Groups = 2500839488,
        GTXD_PARENTING_DATA = 2798946644,
        guid = 2591780461,
        HANDLING_FILE = 46800217,
        hash = 1048674328,
        HDDist = 4257505727,
        HDTxd = 1692217392,
        HDTxdBindingArray = 4153080611,
        Heading = 3903571810,
        HeadingLimits = 2310315578,
        headLight = 1105987835,
        headlight_l = 2403350912,
        headlight_r = 3886869072,
        headLightCorona = 1649539989,
        Height = 4052201683,
        HIGH_HEELS = 2100709655,
        highPri = 1331010150,
        HoldDuration = 2367844690,
        hub_lf = 3891344909,
        hub_rf = 2300894090,
        iCosZ = 3735431522,
        id = 459292749,
        Id = 3809113010,
        identifier = 4004242505,
        Idle = 923499413,
        IdleTransitionBlendOutTime = 61709549,
        IdleTransitions = 1687702635,
        ids = 4038920459,
        IgnoreMaxInRange = 3250311224,
        IgnoreOpenDoorTaskEdgeLerp = 975984281,
        IgnorePavementChecks = 1501464625,
        imapDependencies = 735712319,
        imapDependencies_2 = 3712769228,
        imapName = 833569695,
        IN_VEHICLE = 1015874207,
        includedDataFiles = 2354614069,
        includedXmlFiles = 3280956850,
        Index = 1035793140,
        indicator = 801150652,
        indicator_lf = 3403024362,
        indicator_rf = 2051585809,
        indices = 3921649453,
        Infos = 802810900,
        InitDatas = 1512338287,
        initSpeed = 3640438618,
        InjuredStrafeClipSet = 1464530836,
        innerConeAngle = 1245835442,
        installPartition = 3475002187,
        intensity = 4023228733,
        Intensity = 140854398,
        intensity_far = 3542645631,
        IntensityVar = 2813237244,
        interior = 560567274,
        INTERIOR_PROXY_ORDER_FILE = 821873185,
        InteriorNames = 2406565252,
        Interiors = 947288719,
        IPL_FILE = 2251386970,
        iRadius = 1998996693,
        IsHeadBlendPed = 591520311,
        iSinZ = 1351095745,
        IsStreamedGfx = 3353096503,
        Item = 104834034,
        itypDependencies_2 = 3529579673,
        iType = 3252237582,
        JUNCTION_TEMPLATES_FILE = 1075369871,
        JUNCTION_TEMPLATES_PSO_FILE = 1684997832,
        kBoth = 1849703770,
        Key = 1620616462,
        KilledPerceptionRangeModifer = 2618596152,
        kitName = 1513897539,
        kits = 1843360923,
        Kits = 1497090499,
        kitType = 3008983707,
        leakPtFxEnabled = 1064432315,
        leakPtFxOilName = 729665807,
        leakPtFxPetrolName = 3533268990,
        leakPtFxRange = 2910098562,
        leakPtFxSpeedEvoMax = 1705315422,
        leakPtFxSpeedEvoMin = 2575887885,
        length = 2508072249,
        LifeTime = 4209357938,
        Lights = 2854514190,
        lightSettings = 2377329928,
        limitAngle = 2100360280,
        linkedModels = 3815104759,
        linkMods = 769154353,
        LIQUIDFX_FILE = 1699106320,
        liveries = 2791605300,
        livery = 2153615120,
        liveryNames = 1704397081,
        loadCompletely = 713423689,
        LoadOut = 4277349827,
        LOADOUTS_FILE = 808720620,
        locations = 3724288529,
        locked = 2448219441,
        lodDist = 3212107687,
        lodLevel = 1821316885,
        LODTYPES_DEPTH_HD = 3259521980,
        LODTYPES_DEPTH_LOD = 2384644182,
        LODTYPES_DEPTH_SLOD1 = 2554074988,
        LODTYPES_DEPTH_SLOD2 = 315427988,
        LODTYPES_DEPTH_SLOD3 = 2164549889,
        LODTYPES_DEPTH_SLOD4 = 1868383667,
        LODTYPES_DEPTH_ORPHANHD = 2106806081,
        mapChangeSetData = 815157305,
        MapDataGroups = 3039604259,
        MAPZONES_FILE = 2154214988,
        maskID = 2432235300,
        MassMultiplier = 1613940114,
        MATERIALFX_FILE = 905909785,
        max = 1616931012,
        Max = 344563784,
        MaxDistance = 2770481267,
        MaxPassengersInCar = 1694835331,
        MaxScale = 4214801493,
        MaxScaleZ = 1351348251,
        MaxSpeed = 3972966657,
        MaxTime = 786767296,
        MaxTintPalette = 3492298933,
        MaxXRotation = 658255980,
        MaxYRotation = 2609605325,
        MaxZOffset = 1569839200,
        MaxZRotation = 3093288384,
        memoryGroup = 1079355696,
        MicroMovementsFreqH = 215094271,
        MicroMovementsFreqV = 1945002622,
        MicroMovementsScaleH = 2532792329,
        MicroMovementsScaleV = 2313960935,
        min = 4264617715,
        Min = 3358645132,
        MinActivationImpulse = 1033747207,
        MinDistance = 1316787168,
        minorExplosion = 3090421228,
        MinScale = 2118753352,
        MinScaleZ = 572504281,
        MinTime = 614798748,
        MinTintPalette = 2179154468,
        MinXRotation = 3795236509,
        MinYRotation = 2447817968,
        MinZOffset = 1998724326,
        MinZRotation = 2511320236,
        mirrorTexture = 1892759569,
        misc_a = 2172915033,
        misc_b = 2948983260,
        misc_c = 3705750550,
        misc_d = 2334728355,
        misc_e = 3629890315,
        misc_f = 4003129225,
        misc_g = 867496380,
        misc_h = 702996000,
        misc_i = 2672412968,
        misc_j = 2246219354,
        misc_k = 986218535,
        misc_l = 1360178363,
        misc_m = 4199644986,
        misc_n = 3363543951,
        misc_o = 2517907133,
        misc_p = 3821556264,
        misc_q = 101324459,
        misc_r = 332902982,
        misc_s = 3515428266,
        misc_t = 526666079,
        misc_u = 1020363837,
        misc_v = 1257971856,
        misc_w = 1686098841,
        misc_x = 2041970181,
        misc_y = 1413133063,
        misc_z = 2850643555,
        misfirePtFxEnabled = 2760245605,
        misfirePtFxName = 4265177602,
        misfirePtFxRange = 3937313011,
        MKT_SPECIAL = 2316627489,
        MKT_SPORT = 3608585597,
        MKT_STANDARD = 315733923,
        MKT_SUV = 2385734984,
        MLOInstflags = 3761966250,
        mod_col_1 = 1338030889,
        mod_col_2 = 2758960267,
        mod_col_3 = 1785032818,
        mod_col_4 = 1092558310,
        mod_col_5 = 119450078,
        ModelId = 2410101093,
        modelName = 194221603,
        ModelName = 4216861609,
        ModelSet = 1518141539,
        ModelToTuneMapping = 1001913906,
        modifier = 1699237703,
        modShopLabel = 4132169566,
        MotionTaskDataSetName = 1092878940,
        Move = 528166787,
        MOVE_NETWORK_DEFS = 4182086555,
        MoveBlendRatio = 778269991,
        MovementClipSet = 3248325447,
        MovementClipSetId = 549835433,
        MovementModes = 2739474645,
        MovementModeUnholsterData = 523961350,
        MovementToStrafeClipSet = 4177809469,
        moveNetworkFlags = 4273852377,
        MP_STATS_DISPLAY_LIST_FILE = 759160086,
        MP_STATS_UI_LIST_FILE = 2486889377,
        mtlBangPtFxVehicleEvo = 1188575673,
        mtlBangPtFxVehicleScale = 2772539357,
        mtlScrapePtFxVehicleEvo = 1379406366,
        mtlScrapePtFxVehicleScale = 3990432188,
        multiples = 1309656778,
        multiTxdRelationships = 3649984070,
        MustUse = 331851963,
        name = 3873537812,
        Name = 2901156542,
        NamedTuningArray = 2148169260,
        NavCapabilitiesName = 3282019215,
        NAVMESH_INDEXREMAPPING_FILE = 1431019085,
        NAVNODE_INDEXREMAPPING_FILE = 2576484635,
        networkPedModifier = 2824520073,
        networkPlayerModifier = 3578474195,
        Nodes = 804169170,
        none = 493038497,
        None = 1640121937,
        normal = 1330140418,
        Normal = 3599348095,
        NormalMapName = 2845714814,
        NUM_ANCHORS = 665640573,
        numCoronas = 2225470999,
        numExitPortals = 528711607,
        OBJ_COVER_TUNING_FILE = 628815953,
        offset = 2705095151,
        offsetPosition = 3633645315,
        offsetRotation = 1389511464,
        ON_FOOT = 2976953365,
        opacity = 3644411688,
        outerConeAngle = 4179134239,
        overlay = 943450718,
        OVERLAY_INFO_FILE = 3489350694,
        overturnedSmokePtFxAngleThresh = 2735995463,
        overturnedSmokePtFxEnabled = 1633606873,
        overturnedSmokePtFxEngineHealthThresh = 132281413,
        overturnedSmokePtFxName = 1978623397,
        overturnedSmokePtFxRange = 1730945222,
        overturnedSmokePtFxSpeedThresh = 2304473042,
        owner = 2349203824,
        OwnerName = 1481791743,
        Pad = 1592782806,
        parent = 2845591121,
        parentIndex = 3633459645,
        parentName = 2521104825,
        PARTITION_0 = 1376468858,
        PARTITION_1 = 2621625320,
        PARTITION_2 = 2912515733,
        patchFiles = 3524138408,
        PATH_ZONES_FILE = 884764256,
        PED_DAMAGE_APPEND_FILE = 3868325674,
        PED_FIRST_PERSON_ALTERNATE_DATA = 143306029,
        PED_FIRST_PERSON_ASSET_DATA = 348738744,
        PED_METADATA_FILE = 3698391097,
        PED_OVERLAY_FILE = 1407571174,
        PED_PERSONALITY_FILE = 469479865,
        PedCapsuleName = 3605846536,
        pedCompExpressionIndex = 656720598,
        pedCompExpressions = 4168161021,
        pedcompID = 3512253528,
        pedCompID = 3337196122,
        PedComponentClothName = 2679581144,
        PedComponentSetName = 3295015867,
        pedCompVarIndex = 2890646891,
        PedIKSettingsName = 851100275,
        PedLayoutName = 704782517,
        PedPersonalities = 2345512339,
        pedPropExpressionIndex = 3269764788,
        pedPropExpressions = 1538058350,
        pedPropID = 1389713939,
        pedPropVarIndex = 461768873,
        Peds = 4047618778,
        PedScale = 3537940146,
        PEDSTREAM_FILE = 1358252642,
        pedType = 2747160189,
        Pedtype = 3052355362,
        PedVoiceGroup = 1999554162,
        percentage = 2947557653,
        PerceptionInfo = 3174726878,
        PERMANENT_ITYP_FILE = 2437884080,
        persistent = 4183121383,
        Personality = 620072928,
        petrolTankFirePtFxName = 2162940361,
        petrolTankFirePtFxRadius = 2461827139,
        petrolTankFirePtFxRange = 165484253,
        petrolTankFirePtFxSpeedEvoMax = 2172227529,
        petrolTankFirePtFxSpeedEvoMin = 1276446821,
        Pistol = 805949221,
        Pitch = 4037952930,
        PitchChangeRate = 1754758744,
        PitchLimits = 1158567006,
        PitchOffset = 3015997841,
        PLANE = 2676158011,
        planeAfterburnerPtFxEnabled = 3213641538,
        planeAfterburnerPtFxName = 446218229,
        planeAfterburnerPtFxRange = 408793866,
        planeAfterburnerPtFxScale = 2145730461,
        planeDamageFirePtFxEnabled = 3414165598,
        planeDamageFirePtFxName = 1338161444,
        planeDamageFirePtFxRange = 2839206294,
        planeDamageFirePtFxSpeedEvoMax = 571971263,
        planeDamageFirePtFxSpeedEvoMin = 1883098650,
        planeGroundDisturbPtFxDist = 4253009632,
        planeGroundDisturbPtFxEnabled = 3844975759,
        planeGroundDisturbPtFxNameDefault = 648304806,
        planeGroundDisturbPtFxNameDirt = 1349328259,
        planeGroundDisturbPtFxNameFoliage = 3426743478,
        planeGroundDisturbPtFxNameSand = 3528449028,
        planeGroundDisturbPtFxNameWater = 253287460,
        planeGroundDisturbPtFxRange = 2117069571,
        planeGroundDisturbPtFxSpeedEvoMax = 1904205977,
        planeGroundDisturbPtFxSpeedEvoMin = 3750053303,
        planeWingTipPtFxEnabled = 630564551,
        planeWingTipPtFxName = 1116747820,
        planeWingTipPtFxRange = 2911605361,
        planeWingTipPtFxSpeedEvoMax = 1891037280,
        planeWingTipPtFxSpeedEvoMin = 432519559,
        plantInfos = 1195126367,
        PlantTag = 1119170566,
        plateProbabilities = 759151167,
        Player = 2751443189,
        POPGRP_FILE = 2708681290,
        POPSCHED_FILE = 3496245090,
        PoseMatcherName = 407450340,
        PoseMatcherProneName = 1468409568,
        position = 18243940,
        Position = 210930065,
        PositionOffset = 3553152178,
        posn = 967189988,
        PovCameraOffset = 3390378580,
        PreciseUseTime = 196435285,
        priority = 342945216,
        Priority = 2673351645,
        Probabilities = 4251991726,
        probability = 3698534260,
        PROC_META_FILE = 3342716104,
        PROCOBJ_ALIGN_OBJ = 2620161998,
        PROCOBJ_CAST_SHADOW = 1528296021,
        PROCOBJ_FILE = 1526130529,
        PROCOBJ_IS_FLOATING = 3217678483,
        PROCOBJ_NETWORK_GAME = 390676221,
        PROCOBJ_USE_SEED = 2229775436,
        procObjInfos = 4262901725,
        PROCPLANT_CAMERADONOTCULL = 1147935867,
        PROCPLANT_FURGRASS = 3729666926,
        PROCPLANT_GROUNDSCALE1VERT = 389823981,
        PROCPLANT_LOD0 = 1994951555,
        PROCPLANT_LOD1 = 4009819058,
        PROCPLANT_LOD2 = 72099408,
        PROCPLANT_NOGROUNDSKEW_LOD0 = 398505754,
        PROCPLANT_NOGROUNDSKEW_LOD1 = 3381598904,
        PROCPLANT_NOGROUNDSKEW_LOD2 = 885125404,
        PROCPLANT_NOSHADOW = 696619156,
        PROCPLANT_UNDERWATER = 882615863,
        procTagTable = 2377507684,
        PropRestrictions = 465162194,
        props = 2287400538,
        PropsName = 1179225812,
        ptfxAssetDependencyInfos = 493695515,
        PTFXASSETINFO_FILE = 1772520447,
        ptFxHasTint = 3576542357,
        ptFxIsTriggered = 3434402314,
        ptFxName = 1203215085,
        ptFxProbability = 3448174308,
        ptFxScale = 1567144545,
        ptFxSize = 1080281337,
        ptFxSpeedEvoMax = 320256667,
        ptFxSpeedEvoMin = 3884276349,
        ptFxTag = 2524903540,
        ptFxTintB = 2225110962,
        ptFxTintG = 23853287,
        ptFxTintR = 1304072655,
        pull = 350772507,
        pullCoronaIn = 538460876,
        PV_COMP_INVALID = 476847607,
        PV_COMP_ACCS = 3760011790,
        PV_COMP_BERD = 696691459,
        PV_COMP_DECL = 3631275576,
        PV_COMP_FEET = 2300506577,
        PV_COMP_HAIR = 2918472950,
        PV_COMP_HAND = 2793296290,
        PV_COMP_HEAD = 1159394596,
        PV_COMP_JBIB = 2376289126,
        PV_COMP_LOWR = 3254995156,
        PV_COMP_MAX = 920969818,
        PV_COMP_TASK = 1051671594,
        PV_COMP_TEEF = 1520752005,
        PV_COMP_UPPR = 3707586858,
        RADIO_GENRE_CLASSIC_ROCK = 567874491,
        RADIO_GENRE_JAZZ = 3210576665,
        RADIO_GENRE_MEXICAN = 4058039902,
        RADIO_GENRE_MODERN_ROCK = 4200371511,
        RADIO_GENRE_MOTOWN = 1526192047,
        RADIO_GENRE_OFF = 3820886398,
        RADIO_GENRE_PUNK = 2352668725,
        RADIO_GENRE_REGGAE = 2059985335,
        RADIO_GENRE_RIGHT_WING_TALK = 1758684295,
        RADIO_GENRE_SURF = 2495475670,
        Radio1 = 3430266395,
        Radio2 = 3132297878,
        radius = 1337695475,
        Radius = 3144350114,
        RadiusScale = 3245550474,
        rage__fwInstancedMapData = 4048164286,
        rage__phVerletClothCustomBounds = 847348117,
        rage__spdGrid2D = 2599150383,
        range = 332484516,
        Rate = 2986741774,
        rear = 2243100542,
        rearIndicatorCorona = 103408473,
        RegionDefs = 3713107563,
        RelationshipGroup = 4150596315,
        requiredImap = 2090738474,
        requiresLoadingScreen = 3135083525,
        ResetNoCollisionOnCleanUp = 3362749677,
        residentAnims = 2052114030,
        residentResources = 82002169,
        residentTxd = 1079754329,
        Restriction = 26114980,
        reversingLight = 242592930,
        reversingLightCorona = 3960865135,
        RFrontOffset = 1353482245,
        RGBI = 194542898,
        Rifle = 3187352598,
        rimRadius = 1671388815,
        Roll = 2579823494,
        rooms = 3441481640,
        rotate = 3903098393,
        rotation = 2010988560,
        Rotation = 2371198895,
        RotationLimitAngle = 648763416,
        RPF_FILE = 81740897,
        RPF_FILE_PRE_INSTALL = 31119764,
        RumbleDuration = 79170607,
        RUpOffset = 3943427752,
        SAT_NONE = 836773056,
        SCALEFORM_DLC_FILE = 258049916,
        ScaleRange = 2691059430,
        ScaleRangeXYZ = 4267248400,
        ScaleRangeZ = 2934008023,
        ScaleVariationXY = 754964759,
        ScaleVariationZ = 2602640464,
        ScaleXY = 3128382556,
        ScaleZ = 712150328,
        SCENARIO_INFO_FILE = 2244432863,
        SCENARIO_POINTS_PSO_FILE = 1653171061,
        SCENARIO_POP_STREAMING_NORMAL = 79175210,
        ScenarioPoints = 3966518334,
        ScenarioPopStreamingSlot = 3440415111,
        ScenarioType = 191322199,
        SCRIPTFX_FILE = 3176550718,
        SeatIndex = 2604655109,
        Seats = 368310011,
        sets = 4021164785,
        Sets = 778639775,
        settings = 2768156407,
        Settings = 1654011315,
        Sexiness = 867165133,
        SF_HOT_PERSON = 3612284555,
        SF_JEER_AT_HOT_PED = 213733388,
        shaderVariableComponents = 3687287113,
        shaderVariableHashString = 490746723,
        shadowBlur = 3672716153,
        shockingEventAudioRangeOverride = 345540543,
        shockingEventVisualRangeOverride = 2220221975,
        SHOP_PED_APPAREL_META_FILE = 4189023929,
        shortRange = 178074428,
        ShouldLatchShut = 1101824832,
        SidestepClipSet = 1255368790,
        sirenSettings = 2230033165,
        Situations = 2546696905,
        size = 3226656423,
        size_far = 388176731,
        sLevelData = 4248020339,
        SLOD_HUMAN = 2092589681,
        slot = 933689839,
        slotNames = 2198312216,
        SLOWNESS_ZONES_FILE = 819490736,
        Sniper = 3200555378,
        SP_Low = 1535176458,
        SP_Medium = 1318432000,
        SP_MULTIPLAYER_RESIDENT = 330835765,
        SP_SINGLEPLAYER_RESIDENT = 2843514243,
        SP_STATS_DISPLAY_LIST_FILE = 957687860,
        SP_STATS_UI_LIST_FILE = 3848387179,
        SP_STREAMING = 1647646833,
        spacing = 370899326,
        Spacing = 1644991037,
        spawnType = 4261247615,
        specialAttribute = 1813324772,
        speed = 4187447851,
        sphere = 953812642,
        Spheres = 3873229047,
        splashInPtFxEnabled = 2568271272,
        splashInPtFxName = 1671048614,
        splashInPtFxRange = 424335064,
        splashInPtFxSizeEvoMax = 2546557251,
        splashInPtFxSpeedDownwardEvoMax = 2719708920,
        splashInPtFxSpeedDownwardEvoMin = 1110754284,
        splashInPtFxSpeedDownwardThresh = 2861864958,
        splashInPtFxSpeedLateralEvoMax = 717627197,
        splashInPtFxSpeedLateralEvoMin = 1180941296,
        splashOutPtFxEnabled = 265145855,
        splashOutPtFxName = 2228265562,
        splashOutPtFxRange = 2084717992,
        splashOutPtFxSizeEvoMax = 2926629502,
        splashOutPtFxSpeedLateralEvoMax = 4269956697,
        splashOutPtFxSpeedLateralEvoMin = 976640088,
        splashOutPtFxSpeedUpwardEvoMax = 2874671957,
        splashOutPtFxSpeedUpwardEvoMin = 340254431,
        splashTrailPtFxEnabled = 1540336092,
        splashTrailPtFxName = 3437892535,
        splashTrailPtFxRange = 496141127,
        splashTrailPtFxSizeEvoMax = 2112168390,
        splashTrailPtFxSpeedEvoMax = 1320429615,
        splashTrailPtFxSpeedEvoMin = 465674370,
        splashWadePtFxEnabled = 3946923366,
        splashWadePtFxName = 573019250,
        splashWadePtFxRange = 2801117501,
        splashWadePtFxSizeEvoMax = 230363215,
        splashWadePtFxSpeedRiverEvoMax = 3237227592,
        splashWadePtFxSpeedRiverEvoMin = 1052618905,
        splashWadePtFxSpeedVehicleEvoMax = 1036775998,
        splashWadePtFxSpeedVehicleEvoMin = 1176468081,
        sStatsMetadataTuning = 3459433883,
        StaggerFall = 2002487478,
        Standard = 2352402326,
        start = 2229020447,
        Start = 3073138309,
        startHour = 625204231,
        StartModel = 226559569,
        startPhase = 3221846423,
        StationaryReactions = 2620629637,
        statMods = 216311195,
        STATS_METADATA_PSO_FILE = 1289107292,
        StdDoorOpenBothDir = 1469697918,
        StdDoorOpenNegDir = 2656051665,
        StdDoorRotDir = 1083750337,
        steeringwheel = 1325046900,
        Stiffness = 294387850,
        StillToSitPedalGearApproachRate = 2386385168,
        StrafeClipSet = 1514292895,
        STREAMING_REQUEST_LISTS_FILE = 2865461394,
        streamingPolicy = 827725946,
        streamingPriority = 3660169125,
        STREET_VEHICLE_ASSOCIATION_FILE = 3243535945,
        strength = 4280043047,
        Stubble = 2766015245,
        SuperlodType = 868617040,
        Tag = 2215212623,
        tailLight = 1210163367,
        tailLightCorona = 4104001094,
        tailLightMiddleCorona = 3579298804,
        tangent = 2389642153,
        Target = 3866136337,
        targetAsset = 662555360,
        TargetingThreatModifier = 41162556,
        TargetOffset = 2175492938,
        TargetRadius = 1146856098,
        TaskDataName = 653610287,
        TATTOO_SHOP_DLC_FILE = 1223910633,
        TB_WARM = 1158270414,
        TechSavvy = 248494816,
        Teeter = 3508388318,
        template = 3202639186,
        texId = 1785432003,
        TEXTFILE_METAFILE = 1142425891,
        textureDictionary = 1976702369,
        TextureId = 3617584144,
        textureName = 440050042,
        ThermalBehaviour = 3253990041,
        time = 258444835,
        TIME_FILE = 1428695449,
        TIMECYCLE_FILE = 755616351,
        TIMECYCLEMOD_FILE = 2793750187,
        timeCycleModifiers = 2946251737,
        timeTillPedLeaves = 213640539,
        top = 1281216666,
        TorqueAngularVelocityLimit = 3539021765,
        tracks = 794089857,
        TRAILER = 4229025179,
        TRAINCONFIGS_FILE = 751887759,
        TRAINTRACK_FILE = 680882864,
        TriggerBoxMinMax = 2642293346,
        TS_LOW = 4290350623,
        Tunables = 508571515,
        Tuning = 2317966594,
        TuningName = 2921576840,
        Turn = 3647068299,
        turnOffBones = 3764022105,
        turnOffExtra = 2892421376,
        txdRelationships = 110813075,
        txdToLoad = 465628444,
        txdToUnload = 2372422677,
        type = 828747869,
        types = 138573281,
        UnholsterClipData = 1235872865,
        UnholsterClips = 3511043731,
        UnholsterClipSetId = 3278048392,
        unregisterResources = 910312539,
        Update = 575805931,
        UpperBodyFeatheredLeanEnabled = 2028170470,
        UpperBodyShadowExpressionEnabled = 1264317859,
        UseAutoOpenTriggerBox = 4151971060,
        UseLeftHandIk = 1829639529,
        UseWeaponAnimsForGrip = 1775814871,
        Value = 4108660753,
        variationData = 3467549031,
        Variations = 1085728185,
        VEHGEN_MARKUP_FILE = 2433209284,
        VEHICLE_LAYOUTS_FILE = 2004032454,
        VEHICLE_METADATA_FILE = 4125139733,
        VEHICLE_POPULATION_FILE = 4010054647,
        VEHICLE_RESPONSE_DEFAULT = 3986150789,
        VEHICLE_RESPONSE_ARMY_BASE = 317362887,
        VEHICLE_RESPONSE_COUNTRYSIDE = 2467847847,
        VEHICLE_SHOP_DLC_FILE = 3203173146,
        VEHICLE_VARIATION_FILE = 4226342447,
        VEHICLEEXTRAS_FILE = 2814482675,
        VehicleScale = 201238485,
        Velocity = 3642784282,
        version = 1757576755,
        VersionNumber = 1292187579,
        verts = 120498671,
        VFX_SETTINGS_FILE = 1765838387,
        VFXFOGVOLUMEINFO_FILE = 895306,
        VfxInfoName = 3527474215,
        VFXINTERIORINFO_FILE = 354822867,
        VFXPEDINFO_FILE = 962370952,
        VFXREGIONINFO_FILE = 3633596549,
        vfxregioninfo_default = 526963733,
        vfxregioninfo_desert = 1202232026,
        vfxregioninfo_beach = 4239901007,
        vfxregioninfo_slum = 4267832995,
        vfxregioninfo_woodland = 1397181648,
        vfxregioninfo_mountain = 3282595980,
        vfxregioninfo_countryside = 2691334223,
        vfxTagHashName = 1944993828,
        VFXVEHICLEINFO_FILE = 1918258814,
        vfxVehicleInfos = 1829968483,
        VFXWEAPONINFO_FILE = 1215743990,
        visibleMods = 33867712,
        //vlink87812 = 380604338,
        VMCP_DEFAULT = 1688385326,
        VMT_ARMOUR = 2031251422,
        VMT_BONNET = 1157831199,
        VMT_BRAKES = 2354237771,
        VMT_BUMPER_F = 3594621894,
        VMT_BUMPER_R = 2063293755,
        VMT_CHASSIS = 2275972991,
        VMT_CHASSIS2 = 2944517492,
        VMT_CHASSIS3 = 2694326177,
        VMT_CHASSIS4 = 2463042575,
        VMT_CHASSIS5 = 2742201586,
        VMT_DOOR_L = 3833672138,
        VMT_ENGINE = 154537048,
        VMT_ENGINEBAY1 = 3358404671,
        VMT_ENGINEBAY2 = 4274232691,
        VMT_ENGINEBAY3 = 3976067552,
        VMT_EXHAUST = 610039613,
        VMT_GEARBOX = 2500094337,
        VMT_GRILL = 2021558782,
        VMT_HORN = 100765382,
        VMT_HYDRO = 1330081664,
        VMT_ICE = 2442467387,
        VMT_INTERIOR1 = 4022516897,
        VMT_INTERIOR2 = 1135961221,
        VMT_INTERIOR3 = 829865992,
        VMT_INTERIOR4 = 675392926,
        VMT_INTERIOR5 = 368838931,
        VMT_KNOB = 676118374,
        VMT_LIVERY_MOD = 2724696322,
        VMT_PLAQUE = 671395830,
        VMT_PLTHOLDER = 1090914661,
        VMT_PLTVANITY = 1166632877,
        VMT_ROOF = 908701629,
        VMT_SEATS = 4033680966,
        VMT_SKIRT = 380480791,
        VMT_SPOILER = 1049675683,
        VMT_STEERING = 31361425,
        VMT_SUSPENSION = 3334458998,
        VMT_TRUNK = 514422827,
        VMT_WHEELS = 4228473823,
        VMT_WHEELS_REAR_OR_HYDRAULICS = 1919950653,
        VMT_WING_L = 3535906757,
        VMT_WING_R = 2323846985,
        vPos = 587040309,
        WantedLevel1 = 2416800515,
        WantedLevel2 = 1650825140,
        WantedLevel3 = 1939323416,
        WantedLevel4 = 1171840667,
        WantedLevel5 = 1195762037,
        WATER_FILE = 2413655090,
        Weak = 4041095418,
        WEAPON_ANIMATIONS_FILE = 3924289757,
        WEAPON_METADATA_FILE = 2179567645,
        WEAPON_SHOP_INFO_METADATA_FILE = 3762885521,
        WeaponAccuracy = 2027467678,
        WeaponAnimations = 4015456176,
        WeaponClipFilterId = 671807081,
        WeaponClipSetId = 2215753076,
        WEAPONCOMPONENTSINFO_FILE = 2246020636,
        WEAPONFX_FILE = 1805309100,
        WeaponImpulseMultiplier = 86352657,
        WEAPONINFO_FILE = 314037850,
        WEAPONINFO_FILE_PATCH = 4078051975,
        Weapons = 3632627376,
        WEATHER_FILE = 1275718771,
        WeatherTypes = 2541515394,
        weight = 2618193740,
        wheelBurnoutPtFxFricMult = 3985640029,
        wheelBurnoutPtFxTempMult = 4090549898,
        wheelBurstPtFxName = 2298765511,
        wheelBurstPtFxRange = 627010713,
        wheelDisplacementPtFxDispMult = 1903391014,
        wheelFirePtFxName = 1493987177,
        wheelFirePtFxRange = 2979062979,
        wheelFirePtFxSpeedEvoMax = 2074742492,
        wheelFirePtFxSpeedEvoMin = 88414520,
        wheelFrictionPtFxFricMult = 3344943153,
        WHEELFX_FILE = 797011099,
        wheelGenericDecalSet = 42119146,
        wheelGenericPtFxSet = 317708598,
        wheelGenericRangeMult = 3112058125,
        wheelLowLodPtFxScale = 3101484583,
        wheelName = 1946665057,
        wheelPuncturePtFxName = 3306375051,
        wheelPuncturePtFxRange = 1038999289,
        Wheels = 3527735923,
        wheelSkidmarkPressureMult = 3868991234,
        wheelSkidmarkRearOnly = 3924188767,
        wheelSkidmarkSlipMult = 1637659302,
        wheelVariation = 3934106566,
        Width = 2076102628,
        WindBendScale = 2639208686,
        WindBendVariation = 3427496475,
        window_lf = 4283577347,
        window_rf = 498851022,
        windowsWithExposedEdges = 2852673211,
        windscreen_r = 1088105007,
        wing_lf = 491509005,
        wing_rf = 3902761333,
        WORLD_HEIGHTMAP_FILE = 2667598674,
        WORLD_WATERHEIGHT_FILE = 2962141595,
        wreckedFire2OffsetPos = 3365413657,
        wreckedFire2PtFxDurationMax = 3958205758,
        wreckedFire2PtFxDurationMin = 934999495,
        wreckedFire2PtFxEnabled = 942100204,
        wreckedFire2PtFxName = 2665978636,
        wreckedFire2PtFxRadius = 1241381211,
        wreckedFire2UseOverheatBone = 1005799487,
        wreckedFire3OffsetPos = 1884074151,
        wreckedFire3PtFxDurationMax = 3291844506,
        wreckedFire3PtFxDurationMin = 2778506827,
        wreckedFire3PtFxEnabled = 1459332728,
        wreckedFire3PtFxName = 4213089658,
        wreckedFire3PtFxRadius = 19666915,
        wreckedFire3UseOverheatBone = 3745878980,
        wreckedFirePtFxDurationMax = 912287935,
        wreckedFirePtFxDurationMin = 1608647578,
        wreckedFirePtFxEnabled = 1538181140,
        wreckedFirePtFxName = 4220065034,
        wreckedFirePtFxRadius = 1064003341,
        x = 2466489829,
        X = 1252398387,
        xRotation = 712901235,
        y = 2157248776,
        Y = 953119110,
        yRotation = 3411163434,
        z = 3059772574,
        Z = 1848695880,
        zBias = 4001151357,
        ZONEBIND_FILE = 3024721823,
        zRotation = 1366235387,



































        //Shader params - casing issues now fixed here - see ShaderParamNames enum for cased versions!


        _dimensionlod2 = 2213330743,
        _fakedgrassnormal = 3847734030,
        _veccollparams = 1235110448,
        _vecvehcoll0b = 3443329873,
        _vecvehcoll0m = 2054776271,
        _vecvehcoll0r = 3676612388,
        _vecvehcoll1b = 3338172776,
        _vecvehcoll1m = 3731892311,
        _vecvehcoll1r = 1839679119,
        _vecvehcoll2b = 1542889970,
        _vecvehcoll2m = 298913216,
        _vecvehcoll2r = 3503557575,
        _vecvehcoll3b = 2492173731,
        _vecvehcoll3m = 2003587933,
        _vecvehcoll3r = 3129694622,
        _vecvehcollb = 4034110113,
        _vecvehcollm = 4084115603,
        _vecvehcollr = 2902956998,
        acceleration_delta = 4042077187,
        accumulationbuffersampler0 = 8230410,
        accumulationbuffersampler1 = 272905623,
        activeshadowcascades = 2747556057,
        adapdofproj = 711499858,
        adaplumsampler = 2600073949,
        adaptedlummax = 735476279,
        adaptedlummin = 120989687,
        adaptionparams = 994945211,
        adaptive = 2577319765,
        adaptivedofdepthdownsampleparams = 530741887,
        adaptivedofexposuresampler = 2063861440,
        adaptivedoffocusdistancedampingparams1 = 4192702981,
        adaptivedoffocusdistancedampingparams2 = 3918393682,
        adaptivedofoutputbuffer = 2655767810,
        adaptivedofparams0 = 1088399132,
        adaptivedofparams1 = 806028659,
        adaptivedofparams2 = 1767143429,
        adaptivedofparams3 = 2870836122,
        adaptivedofparamsbuffer = 209455569,
        adaptivedofsampler = 2098736783,
        adaptivedofsamplerdepth = 718794333,
        adapttime = 1514540018,
        airresist = 1208302886,
        alphaadjust = 1287606900,
        alphamaskmapsampler = 1705051233,
        alpharange = 1331056747,
        alphascale = 931055822,
        alphatest = 950204405,
        alphatestvalue = 3310830370,
        altremap = 285573515,
        ambientdecalmask = 3686186843,
        ambientlightingparams = 1614910597,
        ambientocclusioncontrast = 633061550,
        ambientoccsampler = 1212577329,
        animatednormalmapmask0sampler = 2630205212,
        animatednormalmapmask1sampler = 1838164585,
        animatednormalmapmask2sampler = 2257753125,
        animatednormalmapmod1 = 96407192,
        animatednormalmapmod2 = 326478341,
        anisonoisespecsampler = 2134197289,
        anisotropicalphabias = 363074471,
        anisotropicspecularcolour = 1673722929,
        anisotropicspecularexponent = 499953092,
        anisotropicspecularintensity = 401654871,
        aplanesampler = 1600333029,
        applydamagesampler = 1117905904,
        approxtangent = 3606611481,
        armourstrength = 3061795481,
        attenuationsampler = 483360323,
        averageluminanceout = 1654447808,
        avgluminancetexture = 1087818619,
        azimuthcolor = 360934156,
        azimuthcoloreast = 1882877478,
        azimutheastcolor = 1044876032,
        azimuthheight = 2649852765,
        azimuthstrength = 2824307566,
        azimuthtransitioncolor = 2670115477,
        azimuthtransitionposition = 2764855899,
        azimuthwestcolor = 1874413695,
        backbuffersampler = 3700325701,
        backbuffertexture = 3200056981,
        basesampler = 2669264211,
        basetexturesampler = 1399472831,
        bdebugdisplaydamagemap = 727005071,
        bdebugdisplaydamagescale = 1720897181,
        billboard = 552363713,
        blitsampler = 4098753311,
        bloodsampler = 1970149772,
        bloodsamplervs = 3796090472,
        bloodzoneadjust = 1011740581,
        bloomlum = 1959356754,
        bloomparams = 1213613006,
        bloomsampler = 1613750243,
        bloomsamplerg = 2187220839,
        bloomtexelsize = 3590118590,
        blueoff = 1614062594,
        blurintensity = 804387779,
        blursampler = 822703767,
        blurvignettingparams = 871768731,
        bokehalphacutoff = 1703140281,
        bokehbrightnessparams = 1737665654,
        bokehenablevar = 643379889,
        bokehglobalalpha = 1022881476,
        bokehnumaddedtobuckets = 2514924683,
        bokehparams1 = 3945388007,
        bokehparams2 = 4184896628,
        bokehpointbuffer = 2084769495,
        bokehsortedindexbuffer = 1533187666,
        bokehsortedlistbuffer = 201662228,
        bokehsortlevel = 2314931517,
        bokehsortlevelmask = 1605336858,
        bokehsorttransposematheight = 3470273647,
        bokehsorttransposematwidth = 821002802,
        bokehspritepointbuffer = 170997925,
        bottomskycolour = 161676916,
        boundradius = 2230834649,
        branchbendpivot = 892666959,
        branchbendstiffnessadjust = 3894262326,
        brightness = 26603225,
        brightnesssetting = 303513935,
        brighttonemapparams0 = 118691255,
        brighttonemapparams1 = 1904208559,
        brokenbumpsampler = 2033191777,
        brokencolor = 2817208061,
        brokendiffusecolor = 878330249,
        brokendiffusesampler = 3349868497,
        brokenglasstilescale = 1356197901,
        brokenspecularcolor = 1359397883,
        brokenspecularsampler = 3872409448,
        bumpiness = 4134611841,
        bumpsampler = 1186448975,
        bumpsampler_layer0 = 1073714531,
        bumpsampler_layer1 = 1422769919,
        bumpsampler_layer2 = 2745359528,
        bumpsampler_layer3 = 2975430677,
        bumpsampler_layer4 = 2417505683,
        bumpsampler_layer5 = 3720106230,
        bumpsampler_layer6 = 4091379000,
        bumpsampler2 = 1893875305,
        bumpsamplerfur = 2030333799,
        bumpselfshadowamount = 2907460320,
        burnoutlimit = 2048742054,
        cbplanesampler = 1648690748,
        chromabparam = 2243268978,
        clearcol = 2021704599,
        clippingplane = 1632555383,
        clipplanes = 4225498643,
        clothdarken = 4285790447,
        clothdarkencolor = 2192646550,
        clothparentmatrix = 2335024113,
        clothsweatmapsampler = 1059055951,
        clothsweatspec = 2469844039,
        cloudbasecolour = 2670795993,
        cloudbaseminusmidcolour = 207551193,
        cloudbias = 1077109597,
        cloudbillboardparams = 1372983410,
        cloudcolor = 3245908258,
        cloudconstants1 = 1542931277,
        cloudconstants2 = 1848698816,
        cloudconstants3 = 3972097247,
        clouddetailconstants = 2178269534,
        cloudfadeout = 1796923256,
        cloudinscatteringrange = 1590938598,
        cloudlayeranimscale1 = 2699058131,
        cloudlayeranimscale2 = 2904978527,
        cloudlayeranimscale3 = 1697604722,
        cloudmidcolour = 3120184161,
        cloudshadowcolour = 2429466598,
        cloudshadowminusbasecolourtimesshadowstrength = 3681751999,
        cloudshadowoffset = 1192276656,
        cloudshadowstrength = 3469302040,
        cloudthicknessedgesmoothdetailscalestrength = 2448643918,
        cloudthreshold = 2011404587,
        clumpbump = 620873514,
        cocoutputtexture = 561614071,
        colorcorrect = 1418724964,
        colorcorrecthighlum = 1002641818,
        colorfringeparams1 = 1315010326,
        colorfringeparams2 = 94922157,
        colorhighlum = 3178323397,
        colorlowlum = 4274011020,
        colorlum = 819694290,
        colorsampler = 3918882525,
        colorscaler = 2433112487,
        colorshift = 3269836664,
        colorshiftlowlum = 2775271800,
        colorshiftscalar = 2106064165,
        colortexture = 934209648,
        comboheightsamplerfur = 455740840,
        comboheightsamplerfur01 = 1709265783,
        comboheightsamplerfur2 = 374924583,
        comboheightsamplerfur23 = 2930074258,
        comboheightsamplerfur3 = 2760212866,
        comboheightsamplerfur4 = 4056161278,
        comboheightsamplerfur45 = 2509158229,
        comboheightsamplerfur67 = 1396547512,
        comboheighttexmask = 285679314,
        contrast = 699508084,
        convertsampler = 4959160,
        coronasdepthmapsampler = 3603235271,
        crackdecalbumpalphathreshold = 3343925161,
        crackdecalbumpamount = 2155296103,
        crackdecalbumptilescale = 730767419,
        crackedgebumpamount = 3420190257,
        crackedgebumptilescale = 492538267,
        crackleintensity = 1771354266,
        cracklesampler = 1774790613,
        crackmatrix = 2644409350,
        crackoffset = 2214698276,
        cracksampler = 3328498618,
        crplanesampler = 3915834095,
        cubeface = 2567801214,
        curlumsampler = 3431586341,
        currentdoftechnique = 3543504858,
        currentlum = 968818364,
        currentresolution = 4182813263,
        curvecoeffs = 2763646717,
        damagedwheeloffsets = 1348413520,
        damagemultiplier = 378227101,
        damagesampler = 3579349756,
        damagespectexturesampler = 3820652825,
        damagetextureoffset = 4318529,
        damagetexturesampler = 4132715990,
        damagevertbuffer = 2811144871,
        darktonemapparams0 = 1554855265,
        darktonemapparams1 = 780523795,
        deathintensity = 2219791851,
        deathsampler = 4146990968,
        debugcloudsparams = 580885775,
        debuglightcolour = 227690714,
        decalsampler = 2811948736,
        decaltint = 3092072610,
        decorationframeinfo = 3729783099,
        decorationtattooadjust = 1578586549,
        decorationtintpalettesel = 2448945809,
        decorationtintpalettetexsampler = 4286164294,
        deferredlightdownsampledepthsampler = 110250107,
        deferredlightparams = 1690620309,
        deferredlightscreensize = 3811483225,
        deferredlightvolumeparams = 2130744975,
        deferredperspectiveshearparams0 = 3433855881,
        deferredperspectiveshearparams1 = 61303170,
        deferredperspectiveshearparams2 = 4125937165,
        deferredprojectionparams = 424764587,
        deferredvolumecolour = 2115695095,
        deferredvolumedepthbuffersamp = 3381865158,
        deferredvolumedirection = 3203966112,
        deferredvolumeposition = 1009422528,
        deferredvolumeshaftcompositemtx = 3101393666,
        deferredvolumeshaftgradient = 404580226,
        deferredvolumeshaftgradientcolourinv = 1067440921,
        deferredvolumeshaftplanes = 3122758957,
        deferredvolumetangentxandshaftradius = 1118228408,
        deferredvolumetangentyandshaftlength = 4283942594,
        densitysampler = 3828368598,
        depthblurhalfressampler = 2333753907,
        depthblurhalfrestexture = 2638246296,
        depthblursampler = 979379647,
        depthblurtexture = 4038110621,
        depthbuffer = 3447665758,
        depthbuffer2 = 1908423578,
        depthbuffer2_sampler = 720934291,
        depthbuffersamp = 2492728818,
        depthbuffersampler = 3497598060,
        depthmappointsampler = 4215380418,
        depthmapsampler = 847477652,
        depthmaptexsampler = 2784473838,
        depthsampler = 383876435,
        depthsourcesampler = 2578937463,
        depthtexture = 4088842947,
        depthtexturems = 4134029566,
        desatcontrastgamma = 1070958827,
        desaturate = 2639337807,
        desaturatetint = 2511699259,
        detailbumpiness = 1675037470,
        detailbumpsampler = 143227613,
        detaildensity2sampler = 2587222892,
        detaildensitysampler = 2270155403,
        detailmapoffset = 3032413960,
        detailmapsampler = 1041827691,
        detailmapuscale = 489333004,
        detailmapvscale = 2830921123,
        detailnormal2sampler = 2004179855,
        detailnormalsampler = 2903840997,
        detailoffset = 2002782257,
        detailsampler = 3393362404,
        detailsettings = 3038654095,
        detailuvscale = 3418497265,
        diffuse2specmod = 1788442252,
        diffusecol = 1517692383,
        diffuseextrasampler = 58635929,
        diffusehfsampler = 2946270081,
        diffusemod = 1685953011,
        diffusenobordertexsampler = 1732587965,
        diffusesampler = 4059966321,
        diffusesampler2 = 181641832,
        DiffuseSampler3 = 1429813046, //thanks CP
        diffusesamplerfur = 1282320680,
        diffusesamplerphase2 = 3227619449,
        diffusesamplerpoint = 4015001285,
        diffusesplattertexsampler = 1412546033,
        diffusetexsampler = 3004704155,
        diffusetexsampler01 = 255045494,
        diffusetexsampler02 = 2707084226,
        diffusetexsampler03 = 2981196911,
        diffusetexsampler04 = 3291650421,
        diffusetextileuv = 2816002123,
        diffusewoundtexsampler = 3758481220,
        diffusionradius = 4024070401,
        dimmerset = 1523312743,
        dimmersetpacked = 4182305072,
        directionalmotionbluriterparams = 2777949533,
        directionalmotionblurlength = 544111294,
        directionalmotionblurparams = 3408424243,
        dirtcolor = 1146381126,
        dirtdecalmask = 1050016400,
        dirtlevel = 47191856,
        dirtlevelmod = 3961814809,
        dirtsampler = 2124031998,
        DirtBumpSampler = 3157820509,//thanks CP
        diskbrakeglow = 1035405954,
        displparams = 1163050293,
        distancemapsampler = 1616890976,
        distepsilonscalemin = 1163639717,
        distmapcenterval = 1612602645,
        distortionparams = 2957679312,
        distortionsampler = 342449994,
        dithersampler = 612917610,
        dofblur = 731686132,
        dofblurweight = 706444485,
        dofdist = 3329041621,
        dofinten = 3552457075,
        dofnoblurblendringsize = 413916545,
        dofnoblurradius = 108398598,
        dofoutputtexture = 3487236658,
        dofproj = 2305108861,
        dofprojcompute = 2729164810,
        dofrendertargetsize = 3995371223,
        dofsampler = 2614429576,
        dofshear = 1387749709,
        dofskyweightmodifier = 1603770318,
        doftargetsize = 3565962906,
        downsampleddepthsampler = 2057740952,
        downsampledepthsampler = 498175796,
        dpmapfarclip = 3395601267,
        dpmapnearclip = 479573217,
        drawbucket = 514782960,
        dreflectionparams = 153627866,
        droopparams = 2926981594,
        druggedeffectcolorshift = 4028255612,
        druggedeffectparams = 858398664,
        dshadowmatrix = 3423656318,
        dshadowoffsetscale = 930807775,
        dshadowparam0123 = 3916656767,
        dshadowparam4567 = 584100066,
        dshadowparam891113 = 1698928349,
        dsttexturesize = 45365902,
        eaaparams2 = 1422359808,
        earlyout = 3422479905,
        earlyout_sampler = 2971523439,
        earlyoutparams = 141437565,
        eastcolor = 1417575779,
        edgemarkparams = 717226593,
        edgethreshold = 2670218238,
        edgethresholdmin = 316543927,
        effectsconstants = 1179101422,
        elapsedtime = 4152310215,
        emissivemultiplier = 1592520008,
        emissivereflectmultiplier = 1347035993,
        emitterparamlifeandspeed = 1295421465,
        emitterparampos = 2286595424,
        emitterparamposrange = 3505097448,
        emitterparamprobablityphase2 = 1652433309,
        emittertransform = 2216438402,
        emittervelocityboxpos = 1027158774,
        emittervelocityboxrange = 3202652030,
        envbloodbinormal = 304838968,
        envblooddata = 2241230170,
        envbloodpos = 3704052925,
        envbloodsampler = 3616483953,
        envbloodtangent = 1134317228,
        envefffatthickness = 436649803,
        enveffscale = 2431974683,
        envefftextileuv = 3670603239,
        enveffthickness = 2702504809,
        environmentsampler = 3317411368,
        exposure = 2538078618,
        exposureclampandhistory = 2911392042,
        exposurecurve = 1836476954,
        exposureparams0 = 2329380491,
        exposureparams1 = 1031924697,
        exposureparams2 = 1253836365,
        exposureparams3 = 301405380,
        exposures = 2947662557,
        exposureswitches = 1784826898,
        facetexturesampler = 624309278,
        facetmask = 4034105764,
        fade_thickness = 205855514,
        fadealphadist = 4164097433,
        fadealphadistumtimer = 3637887135,
        fadealphalod1dist = 3563207876,
        fadealphalod2dist = 1294165969,
        fadealphalod2distfar0 = 4248689351,
        fage = 2063122051,
        falloffandkernelparam = 1703468999,
        fillcolor = 3014106266,
        filmic0 = 2611530409,
        fintensity = 847954571,
        flowsampler = 1214194352,
        foamsampler = 3266349336,
        fogcolor = 3922291195,
        fogparams = 1243028310,
        fograytexsampler = 1487203018,
        fogsampler = 2568933054,
        fogvolumecolor = 2907231751,
        fogvolumedepthsampler = 1087981784,
        fogvolumeinvtransform = 786602411,
        fogvolumeparams = 10424280,
        fogvolumeposition = 2937842810,
        fogvolumetransform = 1406518664,
        foliagebranchbendpivot = 353881103,
        foliagebranchbendstiffnessadjust = 3429332683,
        fontnormalsampler = 3140496408,
        fontnormalscale = 91417371,
        fontsampler = 2048139100,
        fonttexture = 3394800319,
        fourplanedof = 2764191939,
        fpvmotionblursize = 1677050762,
        fpvmotionblurvelocity = 4116905408,
        fpvmotionblurweights = 4038439571,
        framemap = 1835157646,
        framemaptexsampler = 507369750,
        frequency1 = 2441536523,
        frequency2 = 2219624855,
        fresnelrolloff = 3796399242,
        fullsampler = 3157511856,
        furalphaclip03 = 290288684,
        furalphaclip47 = 4280570754,
        furalphadistance = 4141869331,
        furaoblend = 4026629301,
        furattencoef = 2491165204,
        furbendparams = 3489000159,
        furditheralphafadeparams = 3407922321,
        furglobalparams = 443249107,
        furlayerparams = 1122745807,
        furlayerparams2 = 3825466177,
        furlayerparams3 = 1668577832,
        furlayerstep = 1208356461,
        furlength = 1430134069,
        furmasksampler = 3794875320,
        furmaxlayers = 253873259,
        furminlayers = 3007864804,
        furnoiseuvscale = 1008743034,
        furnumlayers = 110936794,
        furselfshadowmin = 3093266608,
        furshadow03 = 1104745269,
        furshadow47 = 711397225,
        furstiffness = 2137279259,
        furuvscales = 897751165,
        g_alphafade = 1960511459,
        g_bloodcolor = 985986992,
        g_bloodsplatparams = 1621619881,
        g_cpqsmix_qsfadein = 2799702011,
        g_currentvalue = 1312005277,
        g_edgehighlightcolour = 1596321467,
        g_f4rtsize = 4169783008,
        g_fbilateralcoefficient = 2015612345,
        g_fbilateraledgethreshold = 2771898508,
        g_fcollisionsqscale = 731874660,
        g_fenablespringforces = 2189248122,
        g_fgrassspringrigidity = 3152689414,
        g_fgrassspringscale = 2339438728,
        g_fripplerainstrength = 2044767128,
        g_fssaobilateralcoef = 145680953,
        g_fssaokernelscale = 3370811738,
        g_fvolumetriclightrayintensitymult = 3709677333,
        g_gbuffertexture3param = 3145202593,
        g_ghostlevel = 1563742563,
        g_hdao_params1 = 1535730194,
        g_hdao_params2 = 3676889419,
        g_hdaoapplyparams = 2705555169,
        g_hdaocomputeparams = 2528000437,
        g_hdaoextraparams = 3628503020,
        g_hdaovalleyparams = 1466262319,
        g_highlightscale = 1705698884,
        g_impostersize = 786569893,
        g_lightningstrikenoiseparams = 390679343,
        g_lightningstrikeparams = 3780586083,
        g_linearclampsampler = 2261256735,
        g_msaapointtexture1_dim = 3319333866,
        g_msaapointtexture2_dim = 3715862146,
        g_occlusiontextureparams = 4007914843,
        g_pointsampler = 3230386348,
        g_projparams = 360593454,
        g_projshear = 1833194361,
        g_puddle_scalexy_range = 529156535,
        g_puddleparams = 3536830402,
        g_resulttexture = 3349637075,
        g_ssaostrength = 1519496158,
        g_targetsize = 1149055682,
        g_textcolour = 3414941892,
        g_textshadowcolour = 3326514923,
        g_textshadowscale = 828975922,
        g_vcollisionparams = 390873962,
        g_vcollisionspheres = 2187899533,
        g_vplayerposition = 148353768,
        g_vrelativeluminancethresholdparams = 1353171807,
        g_vrippleattributes = 1686992389,
        g_vrippletexelsize = 2041279531,
        g_vtexelsize = 1568580394,
        g_wavexoffset = 2340128792,
        g_wavexzoom = 1940934038,
        g_waveyzoom = 936340354,
        g_widthscalar = 1482315230,
        gactiveunit = 247068080,
        galaxyoffset = 2261454336,
        galaxysampler = 304699295,
        galphacutoffminmax = 3012586280,
        galphatest = 2215224122,
        galphatocoveragescale = 955152299,
        gambientamount = 862548646,
        gambientcolor = 2502793579,
        gambientmult = 2621865253,
        gambientshadow = 1730637860,
        gamma = 1617619096,
        gammacorrection = 2923835982,
        ganimatednormalmapparams = 1356180523,
        ganimblendweights = 3438696362,
        ganimcombine = 4162938569,
        ganimsculpt = 732819097,
        gaussianweights = 3546535582,
        gbackgrounddistortionalphabooster = 1266153517,
        gbackgrounddistortionamount = 2358946644,
        gbackgrounddistortionvisibilitypercentage = 1950755416,
        gbiastocamera = 969255365,
        gblitmatrix = 1903406607,
        gblooddata = 2470245206,
        gblooduvboundspage = 318462180,
        gbluramount = 2372939986,
        gbonedamage0 = 493675041,
        gbonedamageenabled = 3445557846,
        gbouncecolor = 3285219193,
        gboxcentrepos = 1213320064,
        gboxforward = 2141719324,
        gboxright = 3950477470,
        gboxsize = 4157270760,
        gbufferstenciltexturesampler = 34323572,
        gbuffertexture0 = 1370576551,
        gbuffertexture2 = 989669695,
        gbuffertexturedepth = 3214151316,
        gbuffertexturesampler0 = 3101514270,
        gbuffertexturesampler1 = 1931628197,
        gbuffertexturesampler2 = 1601349446,
        gbuffertexturesampler3 = 394499945,
        gbuffertexturesamplerdepth = 3001958741,
        gbuffertexturesamplerssaodepth = 566345585,
        gcableparams = 3557855020,
        gcamanglelimits = 1391293880,
        gcamerabias = 481136556,
        gcameradistanceatmaxdisplacement = 894396470,
        gcamerapos = 130109679,
        gcameraposition = 3861036523,
        gcamerashrink = 196757553,
        gclipplanes = 993087185,
        gcloudcolor = 3349623462,
        gcloudviewproj = 1388118204,
        gcollisionlifemodifier = 28882798,
        gcollisionpositionmodifier = 1413333801,
        gcollisionvelocitymodifier = 2917041400,
        gcolortint = 1945696018,
        gcolortintphase2 = 3971978241,
        gcolour = 819380429,
        gcoloursplash = 2769897443,
        gcontrollight = 1458962865,
        gcrossfadedistance = 2123742775,
        gcsmparticleshadowsamp = 18467538,
        gcsmparticleshadowtexture = 1879733647,
        gcsmshadervars_deferred = 4041368736,
        gdaynightscale = 2033466401,
        gdecalchannelselection = 129604674,
        gdecalnormalsampler = 353477773,
        gdecalsampler = 2317915042,
        gdeferredinverseviewprojmatrix = 3129339935,
        gdeferredlightcolourandintensity = 3618208763,
        gdeferredlightconeangle = 1457978794,
        gdeferredlightconeanglei = 3706722404,
        gdeferredlightconeoffset = 2681954581,
        gdeferredlightconescale = 3587849890,
        gdeferredlightdirection = 3096160936,
        gdeferredlightinvsqrradius = 1076369960,
        gdeferredlightposition = 3515628483,
        gdeferredlightradius = 771816156,
        gdeferredlightradiusprojshearparams = 507484242,
        gdeferredlightsampler = 1527752693,
        gdeferredlightsampler0p = 3029377315,
        gdeferredlightsampler1 = 575604989,
        gdeferredlightsampler2 = 1424289320,
        gdeferredlightshadowmap0 = 2826529087,
        gdeferredlightshadowmap1 = 2589969676,
        gdeferredlightshadowmap2 = 2224923016,
        gdeferredlightshadowmap3 = 1962213943,
        gdeferredlightshaftparams = 2784101259,
        gdeferredlighttangent = 3997363695,
        gdeferredlighttype = 874695930,
        gdeferredlightvolumeparams = 371509596,
        gdeferredprojparams = 1174638206,
        gdeferredvolumeradiusscale = 3037897088,
        gdensityshiftscale = 3043875162,
        gdepthviewprojmtx = 512139429,
        gdiffuse = 1220611861,
        gdirectional = 2203405262,
        gdirectionallightshadowamount = 3920559848,
        gdirectionalmotionblurlength = 2219759593,
        gdirectionalmult = 4000928118,
        gdirectionalvelocityadd = 1608450430,
        gdirectionalzoffsetminrange = 955747368,
        gdirnormalbias = 1480114695,
        gdispersalsettings = 570820137,
        gdistancescale = 3645463202,
        geastminuswestcolor = 2332609458,
        gedgesoftness = 867642987,
        generalparams0 = 3458676571,
        generalparams1 = 3166540936,
        gextralightmult = 3645170126,
        gextralights = 2849007823,
        gextraparams0 = 1363351178,
        gextraparams1 = 3423931440,
        gextraparams2 = 4223069043,
        gextraparams3 = 3907306959,
        gextraparams4 = 2518327352,
        gfadeinout = 1682568218,
        gfadenearfar = 1244256289,
        gfadezbaselohi = 542136670,
        gfirsttimeupdate = 92947686,
        gfogcompositeambientcolor = 2918893733,
        gfogcompositedirectionalcolor = 646659969,
        gfogcompositeparams = 3080532465,
        gfogcompositetexoffset = 1705135815,
        gfrustumparameters = 1069442784,
        ggrassskipinstance = 3294601711,
        ggravitywindtimestepcut = 2189578124,
        ggustamplifier = 1813609204,
        ggustspacing = 2572448010,
        ghdrexposure = 1986583430,
        gheathaze = 1822868744,
        gheathazeripplelength = 1850681702,
        gheathazeripplerate = 3558453078,
        gheathazescale = 3312170287,
        gheathazesize = 1319873596,
        gheathazewidth = 3133152963,
        gheatphase = 2721110750,
        ghitplane = 3729639013,
        ghorizscale = 2467525454,
        ghybridaddratio = 3504408232,
        ginstancevars = 3432648184,
        ginstcullparams = 3871720938,
        gintensity = 3311833552,
        ginterpolationfactor = 1392131636,
        gisshadowpass = 1999109769,
        glifefade = 1079477869,
        glifeminmaxclamptoground = 3942952480,
        glifetimescale = 3294686231,
        glightintensityclamp = 4186188647,
        glightintensitymult = 1884220195,
        glightsettings = 1029904424,
        globalanimuv0 = 3617324062,
        globalanimuv1 = 3126116752,
        globalfograyfadeparam = 1248095708,
        globalfograyparam = 1620085657,
        globalfreeaimdir = 3943027507,
        glocallightsmultiplier = 4293612306,
        glodfadecontrolrange = 4185950307,
        glodfadepower = 2662986932,
        glodfaderange = 3264171975,
        glodfadestartdist = 1949054155,
        glodfadetilescale = 1082098581,
        glodinstanttransition = 596864795,
        glodthresholds = 979130770,
        glowresdepthsampler = 2824212180,
        glowresdepthtexture = 3015483598,
        gmaxdisplacement = 1164495840,
        gmaxlife = 3970444018,
        gmirrorbounds = 1887204037,
        gmirrorcrackamount = 1562064116,
        gmirrorcracksampler = 2984091644,
        gmirrordebugparams = 496893366,
        gmirrordistortionamount = 987148199,
        gmotionblur = 294407736,
        gnearfarqmult = 2513511302,
        gnormalarc = 808788377,
        gnormalheight = 3146080364,
        gnormalmapmult = 3282331164,
        gnormaloffset = 2355039984,
        gnormalscale = 2365712398,
        gnumclipplanes = 828848872,
        goffsetparticlepos = 842278893,
        goffsetscale0 = 70492586,
        goffsetscale1 = 428526680,
        goldfactor = 358396505,
        goldfresnelrolloff = 295546023,
        goldreflectcolorbase = 2396384524,
        goldreflectcoloroverlay = 2603016628,
        goldreflectivepower = 2990597200,
        goldspecmapintmask = 1333698176,
        goldspecularfactor = 435211370,
        golftrailtexturesamp = 241657115,
        goodeferredlightscreensize = 3073062802,
        gorienttoterrain = 3165461554,
        gparticlecolorpercentage = 1853363478,
        gparticletexturesize = 2550169896,
        gperspectiveshearparams0 = 2149148446,
        gperspectiveshearparams1 = 509977564,
        gperspectiveshearparams2 = 263128687,
        gpiercinglightpower_strength_normalstrength_thickness = 2302032860,
        gpositionoffset = 2734209203,
        gpositionscale = 4212665338,
        gpower = 1384422613,
        gprevviewproj = 1120562824,
        gprojparams = 2311871851,
        gradientfiltercolbottom = 3762433606,
        gradientfiltercolmiddle = 1794637696,
        gradientfiltercoltop = 4015194706,
        gradius = 526220184,
        graindebug = 1247076385,
        gravitydroop = 3181978688,
        greenoff = 3283681954,
        greflscales = 1520419346,
        grefparticlepos = 2705128804,
        grefraction = 2643069888,
        grescaleuv1 = 724216589,
        grescaleuv2 = 2046871736,
        grescaleuv3 = 2259804698,
        gresetparticles = 2831259018,
        grg_blendenddistance = 3347456804,
        grg_blendstartdistance = 4179423620,
        grotationcenter = 2718167535,
        grotspeedminrange = 3733294048,
        groundcolor = 3169191053,
        gscalediffusefillambient = 397913198,
        gscalefade = 3144708943,
        gscalerange = 4248652172,
        gscatterg_gsquared_phasemult_scale = 987241318,
        gshadowamount = 3297538021,
        gsizeminmax = 1571728947,
        gsizeminrange = 3419056622,
        gskycolor = 3328933361,
        gsoftness = 2874180382,
        gsoftnesscurve = 2667435005,
        gsoftnessshadowmult = 2718764463,
        gsoftnessshadowoffset = 2710273761,
        gsoftparticlerange = 3901093204,
        gspecularexponent = 3204977572,
        gspecularintensity = 247886295,
        gsplashframes = 944333453,
        gsplashsizeminmax = 4062424283,
        gsuncolor = 3007207522,
        gsundirection = 2009439163,
        gsuperalpha = 1225534059,
        gsurfacesettings = 3834090438,
        gtaskydomeclip = 964033580,
        gtaskydomefade = 826009472,
        gtawatercolor = 4280744704,
        gtexcoordscaleoffset0 = 3099617970,
        gtexcoordscaleoffset1 = 2745647232,
        gtexcoordscaleoffset2 = 2499388197,
        gtexcoordscaleoffset3 = 2456002041,
        gtextureanglerads = 241993590,
        gtextureanimation = 20918084,
        gtextureanimratescaleoverlifestart2end2 = 3412279679,
        gtexturerowscols = 1276450911,
        gtexturerowscolsstartend = 1241308942,
        gtotallifetimescale = 2824822244,
        gusecomputeshaderoutputbuffer = 1009029736,
        gusedirectional = 1281964389,
        guseshadows = 345674786,
        guvoffset = 3300015766,
        guvoffset1 = 2565276602,
        guvoffset2 = 2325899053,
        guvoffset3 = 3510465638,
        gvelocitymax = 3037552071,
        gvelocitymin = 507774218,
        gvertscale = 1074904593,
        gviewproj = 4124209033,
        gvolumelightssampler = 1687175937,
        gvolumelightstexture = 2884407863,
        gwaterheight = 446050918,
        gwestcolor = 3223173913,
        gwindbasevel = 3813992546,
        gwindbendingglobals = 709598663,
        gwindbendscalevar = 2552738797,
        gwindgustvel = 2099280216,
        gwindmultparams = 982613925,
        gwindparams = 3536772057,
        gwindvariancevel = 2216170969,
        gworldbinormal = 2267341197,
        gworldinstanceinversetranspose = 1914807,
        gworldinstancematrix = 981286173,
        gworldtangent = 1317093162,
        gwrapbias = 1858190163,
        gwraplighting = 75905342,
        gwraplighting_msaaref = 833328952,
        gwrapscale = 3087563039,
        gzdampen = 2165766204,
        hardalphablend = 3913511942,
        hdrcolortexture = 2362960420,
        hdrexposure = 3039323892,
        hdrexposureclamp = 1487577326,
        hdrintensity = 4136287658,
        hdrintensitymultiplier = 1498595219,
        hdrpointsampler = 3702694755,
        hdrsampler = 1709735268,
        hdrsunexposure = 81989056,
        hdrtextureaa = 2769796592,
        heathazeoffsetparams = 234272229,
        heathazeparams = 3041693270,
        heathazesampler = 2900829390,
        heathazetex1params = 157461750,
        heathazetex2params = 3686416465,
        heightbias = 330974467,
        heightbias0 = 537974167,
        heightbias1 = 820082484,
        heightbias2 = 3378489398,
        heightbias3 = 3161525849,
        heightfogparams = 4202365273,
        heightmapsampler = 1008099585,
        heightmapsamplerlayer0 = 781078585,
        heightmapsamplerlayer1 = 2570495372,
        heightmapsamplerlayer2 = 2346748640,
        heightmapsamplerlayer3 = 2242969217,
        heightmaptransformmtx = 1556799447,
        heightopacity = 2935469584,
        heightsampler = 4049987115,
        heightscale = 947222050,
        heightscale0 = 2807156689,
        heightscale1 = 1898472319,
        heightscale2 = 2178811114,
        heightscale3 = 1536800866,
        heighttexture = 4152773162,
        hemi_bias = 3477916617,
        hemi_near = 4068871657,
        hemi_params = 3188015657,
        hemi_range = 2843854391,
        hemi_res = 3411758646,
        hemicubesampler = 145567721,
        hidofmiscparams = 851407070,
        hidofparams = 3302089350,
        highdetailnoisebumpsampler = 1044331566,
        highdetailnoisesampler = 3822359214,
        highdetailsampler = 860147427,
        highlum = 737146002,
        history = 2023011857,
        hmdwarpparam = 4161661017,
        horizonlevel = 403229780,
        hybridadd = 4234023609,
        hybridaddratio = 1902453223,
        imagefxparams = 3775812724,
        importancebuffersampler = 1983941369,
        imposterdir = 15105794,
        impostersampler = 4013138833,
        imposterworldx = 3187870439,
        imposterworldy = 3495145352,
        imposterworldz = 4037865530,
        initpositiontexsampler = 867916958,
        initvelocitytexsampler = 3796043845,
        inputtex = 2352384719,
        instancebuffer = 571392628,
        interlaceindex = 92545662,
        interlacemapsampler = 4281682490,
        interlacetotalnum = 1200425084,
        intermediatetarget = 2216618306,
        intermediatetarget_sampler = 1179275796,
        intermediatetargetaa = 2580729000,
        jittersampler = 887426944,
        kernelparam = 348424870,
        kernelradius = 1819724113,
        killflashcol = 1705946031,
        killflashuvoff = 1449898229,
        lasersampler = 3973852449,
        laservisibilityminmax = 2050561467,
        lastbuffersize = 878694393,
        lensartefactsparams0 = 1487316152,
        lensartefactsparams1 = 870406958,
        lensartefactsparams2 = 1165295189,
        lensartefactsparams3 = 263361233,
        lensartefactsparams4 = 2409501354,
        lensartefactsparams5 = 1794558296,
        lenscenter = 163655085,
        lensdistortionparams = 705844615,
        letterindex1 = 1794007338,
        letterindex2 = 865825409,
        lettersize = 1497980819,
        licenseplatefontextents = 3015810411,
        licenseplatefonttint = 1846736030,
        lightcolor = 1945364554,
        lightdir = 1608210580,
        lightocclusionsampler = 3039301469,
        lightrayparams = 912013868,
        lightrayparams2 = 3575716412,
        lightstreaksblurdir = 2085391682,
        lightstreakscolorshift0 = 4082051348,
        linearsampler = 2135833848,
        linearsampler1 = 4052371224,
        linearsampler2 = 2627575128,
        linearwrapsampler = 681732347,
        linearwrapsampler2 = 1379901712,
        linearwraptexture3 = 4011882001,
        lookupsampler = 2295086480,
        lowlum = 2175272747,
        lowresdepthmappointsampler = 1894550764,
        lowresdepthpointmap = 4131434726,
        lumfilterparams = 2120745528,
        luminanceconstants = 2215984599,
        luminancedownsampleoosrcdstsize = 1869154352,
        lunarcycle = 3166975708,
        manualdepthtest = 2024632841,
        maskalphareverse = 3046988116,
        masktexturesampler = 2110569141,
        matdiffusecolor = 408880252,
        matdiffusecolor2 = 1577977996,
        matdiffusecolortint = 99676333,
        materialdiffuse = 424198508,
        materialidsampler = 892830080,
        materialwetnessmultiplier = 3170143313,
        matgrasstransform = 72771513,
        matmaterialcolorscale = 2492093682,
        matwheeltransform = 2829072482,
        matwheelworld = 3178367768,
        matwheelworldviewproj = 2078334811,
        mbperspectiveshearparams0 = 1033188477,
        mbperspectiveshearparams1 = 2555242989,
        mbperspectiveshearparams2 = 2292140688,
        mbprevviewprojmatrixw = 556540040,
        mbprevviewprojmatrixx = 2198692937,
        mbprevviewprojmatrixy = 2433876050,
        mipmaplod = 482766300,
        mirrorintensity = 2215660639,
        mirrornormalintensity = 1531688027,
        mirrorparams = 2538518895,
        mirrorreflectionskyintensity = 3525553109,
        mirrorspecmaskintensity = 2901241109,
        mlaaarealutsampler = 2609019681,
        mlaalinearsampler = 655764451,
        mlaapointsampler = 1645524956,
        mooncolor = 2213576281,
        mooncolorconstant = 2616626323,
        moondirection = 3484629706,
        moonglow = 2037987613,
        moonglowsampler = 2151873246,
        moonintensity = 2342189917,
        moonlight = 2593156215,
        moonposition = 124803246,
        moonsampler = 1534106922,
        moontexconvert = 1796762296,
        moontexposition = 1128557715,
        moonvisiblity = 3257982346,
        moonxvector = 1764174018,
        moonyvector = 3157759019,
        motionblurmatrix = 2950235179,
        motionblursampler = 3974544708,
        mp_bullettimeparams = 51894946,
        msaapointsampler1 = 3816347419,
        msaapointtexture1 = 750933622,
        msaapointtexture2 = 989590249,
        nearfarclip = 1899734512,
        noise1sampler = 3941892287,
        noise2sampler = 215717268,
        noisedensityoffset = 3780934309,
        noisefilterarea = 1418684055,
        noisefrequency = 1364176943,
        noisehighlum = 3113827561,
        noiselowlum = 3302331435,
        noiselum = 1493025892,
        noisemapsampler = 2678081716,
        noiseparams = 2296796634,
        noisephase = 1916643725,
        noisesampler = 2461808165,
        noisescale = 4186750186,
        noisesoftness = 984327287,
        noisetexsampler = 651303591,
        noisetexture = 1661149109,
        noisetexturesampler = 4127640691,
        noisethreshold = 188180875,
        noisewarp = 1708817206,
        normalbuffer = 3727614344,
        normalbuffersamp = 3334794412,
        normalmapblendratio = 432051653,
        normalmapmod = 1363116819,
        normalmapsampler = 860923645,
        normalmapsampler1 = 225912280,
        normalmapsampler2 = 4224746123,
        normalmaptexsampler = 2007347265,
        normalsampler = 2327911600,
        normalspecmaptexsampler = 2275171214,
        normaltexture = 3453458978,
        normaltexturesampler = 53266845,
        normbuffersampler = 2450983583,
        normfresnelrolloff = 469438475,
        normreflectivepower = 99909810,
        normspecmapintmask = 4286481776,
        normspecularfactor = 106090312,
        normtable = 478874367,
        numactiveshadowcascades = 2608506194,
        numletters = 1303240218,
        occlusionsampler = 50748941,
        occlusiontexture = 2967810622,
        oceanlocalparams0 = 2333080707,
        offsethighlum = 3768233024,
        offsetlowlum = 1745892694,
        offsetlum = 3139368420,
        ordernumber = 1617153586,
        palettecolor0 = 2390234167,
        palettecolor1 = 345546874,
        palettecolor2 = 650331343,
        palettecolor3 = 1102019239,
        paletteindex = 2499973182,
        palettesampler = 2950395616,
        paletteselector = 2636279676,
        paletteselector2 = 588791948,
        parabsampler = 2604688681,
        parallaxscalebias = 2178632789,
        parallaxselfshadowamount = 242286661,
        param0 = 3022832690,
        param1 = 1630936646,
        param2 = 2407332563,
        param3 = 2110904189,
        param4 = 739161080,
        param5 = 411995384,
        param6 = 1178691677,
        param7 = 947113154,
        params_ = 890816472,
        particlecollisionsampler = 3713958763,
        particlepostexsampler = 2603657112,
        particleposxytexsampler = 2279694207,
        particleposzwtexsampler = 1408622679,
        particleshadowsparams = 2589755661,
        particleveltexsampler = 1792971393,
        particlevelxytexsampler = 3377719961,
        particlevelzwtexsampler = 572101329,
        pedbrightness = 2965570322,
        perlinnoisesampler = 2192344499,
        perlinsampler = 3428612092,
        persistance = 319450804,
        perspectiveshearparam = 686675449,
        phase = 2726250539,
        plantcolor = 1360494706,
        platebgbumpsampler = 1709116366,
        platebgsampler = 1342317448,
        player_mask = 2584097651,
        playerbrightness = 1987993393,
        playerlfootpos = 1466936,
        playerrfootpos = 982297002,
        pointsampler = 1728781698,
        pointsampler1 = 857651826,
        pointsampler2 = 2186729701,
        pointtexture1 = 3319640342,
        pointtexture2 = 463756450,
        pointtexture3 = 715389601,
        pointtexture4 = 4030629335,
        pointtexture5 = 4280230808,
        poisson12 = 3700554683,
        polyrejectthreshold = 3669125377,
        positiontexsampler = 124136329,
        postfxadaptivedofcustomplanesparams = 2921923875,
        postfxadaptivedofenvblurparams = 383528417,
        postfxsampler2 = 3640527007,
        postfxsampler3 = 1268084184,
        postprocess_flipdepth_nearplanefade_params = 1212194473,
        projectionparams = 4041985547,
        prtoccsampler = 3756087939,
        ptfxalphamapsampler = 2528190781,
        ptfxdepthmapsampler = 3549846349,
        puddlebumpsampler = 644999851,
        puddlemasksampler = 1899494261,
        puddleplayerbumpsampler = 375060758,
        quadalpha = 319478650,
        quadposition = 4152407657,
        quadscale = 876246817,
        quadtexcoords = 2382487901,
        qualitysubpix = 1192820550,
        radialblurcenter = 265875256,
        radialblursampler = 6871558,
        radialblursamplescale = 1978511676,
        radialblurscale = 847338530,
        radialblurtexturestep = 3637740945,
        radialfadearea = 3417034203,
        radialfadetime = 820208297,
        radialwaveparam = 4020440334,
        //radius = 1337695475,
        rainnormalcontrols = 2413728713,
        rainnormalsampler = 205121072,
        rawinstancebuffer = 2533822745,
        rcpframe = 3616804746,
        redoff = 550595403,
        reductiondepthtexture = 156102219,
        reductionoutputtexture = 3090928251,
        refblurmapsampler = 553137719,
        reflectancesampler = 2024624668,
        reflectivepower = 1002989215,
        reflectivepowered = 680514554,
        reflecttexturesampler = 2975449189,
        refmipblurparams = 309170118,
        refmipblursampler = 3559513422,
        refractionmaptexsampler = 3189040505,
        refractsampler = 2398824821,
        rendercubemapsampler = 3123859691,
        rendermappointsampler = 1552806584,
        rendermappointsamplermsaa = 840576025,
        renderpointmapint = 3218359854,
        renderpointmapintparam = 945456412,
        rendertargetsize = 2592035668,
        rendertexarray = 183558417,
        rendertexarraysampler = 1776075411,
        rendertexfmask = 334637039,
        rendertexmsaa = 2388364099,
        rendertexmsaaint = 1120019968,
        rendertexmsaaparam = 445950974,
        reserve_vs_const_c253 = 888979958,
        reserve_vs_const_c254 = 572824646,
        reserve_vs_const_c255 = 3578071436,
        resolveddepthsampler = 870591330,
        resolveddepthtexture = 1168394501,
        result = 1204638111,
        rimamount = 3950947166,
        rimpower = 1017175370,
        ripplebumpiness = 3108440880,
        rippledata = 1154845288,
        ripplescale = 3553443429,
        ripplescaleoffset = 1931187426,
        ripplespeed = 1172914979,
        ropecolor = 3402942199,
        samp = 4292969706,
        sampfiltered = 200703167,
        sampleangle = 1030071922,
        samplescale = 65527032,
        Scale_ = 116180525,
        scale_ = 3279249823,
        Scale = 1018839014,
        scale = 1342385372,
        scalein = 1489667163,
        scalerlum = 1241172112,
        scanlinefilterparams = 3994711222,
        screenblurfade = 337464727,
        screencenter = 2855930302,
        screenres = 2982944708,
        screenrez = 1216400687,
        screensizehalfscale = 3116016449,
        seamtexturesampler = 1888072213,
        seethroughcolorfar = 3831201608,
        seethroughcolornear = 3012901639,
        seethroughcolorvisiblebase = 2159046948,
        seethroughcolorvisiblewarm = 3370209405,
        seethroughparams = 4084639067,
        segmentsize = 2511004421,
        selfshadowing = 1840833647,
        sfxwindsampler3d = 2060224441,
        shader_cableambient = 2538368771,
        shader_cablediffuse = 1793087594,
        shader_cablediffuse2 = 115414613,
        shader_cableemissive = 132015748,
        shader_fadeexponent = 2415019593,
        shader_radiusscale = 2225356731,
        shader_windamount = 33262047,
        shadervariables = 2308502112,
        shadowfacingoffset = 2069856698,
        shadowfalloff = 1293272419,
        shadowmap_res = 4230725802,
        shadowmapsamp = 4212336983,
        shadowparams2 = 2293499745,
        skincolourtweak = 2856526403,
        skinparams = 441924618,
        skycolor = 1706854363,
        skymapsampler = 2000097477,
        skyplanecolor = 3575965978,
        skyplaneparams = 2005428036,
        smallcloudcolorhdr = 1741381730,
        smallcloudcolorxhdrintensity = 2180964324,
        smallcloudconstants = 376734756,
        smartblitcubemapsampler = 4204135808,
        smartblitcubemaptexture = 712004116,
        smartblitsampler = 909202272,
        smartblittexture = 4234899854,
        smokeparams = 2945162076,
        smokesampler = 2479196183,
        snowsampler = 3153629680,
        snowsampler0 = 43291740,
        snowsampler1 = 296170113,
        soakframeinfo = 2322806119,
        //Softness = 187712958, //softness is already in the list, used by types other than shaders!
        source = 572563616,
        specdesaturateexponent = 3019471088,
        specdesaturateintensity = 716647240,
        specexp = 191070201,
        specfalloffadjust = 227128491,
        specfresnelexp = 1058370591,
        specfresnelmax = 4192555480,
        specfresnelmin = 1243102889,
        specintensity = 3710484485,
        specintensityadjust = 4171608282,
        specmapexpmask = 1709596004,
        specmapintmask = 4279333149,
        specmapreflectmask = 3348420270,
        specsampler = 1619499462,
        specsampler_layer01 = 2048257998,
        specsampler_layer23 = 3596135066,
        spectextileuv = 1430901041,
        specular2color = 685871723,
        specular2color_dirlerp = 2732605880,
        specular2colorintensity = 3929351910,
        specular2colorintensityed = 1998056897,
        specular2colorintensityre = 4172410899,
        specular2factor = 629012244,
        specular2factored = 3425067163,
        specularcolorfactor = 1212833469,
        specularcolorfactor1 = 475502710,
        specularcolorfactor2 = 1361248780,
        specularcolorfactor3 = 1060953664,
        specularcolorfactored = 1250428158,
        specularfactor = 376311761,
        specularfactor1 = 1627805193,
        specularfactor2 = 2405249722,
        specularfactor3 = 3075146389,
        specularfactored = 2497120655,
        specularfalloff = 3957040118,
        specularfalloffmult = 2272544384,
        specularfalloffmultspecmap = 2748867194,
        specularfresnel = 666481402,
        specularintensity = 2841625909,
        specularintensitymult = 4095226703,
        specularintensitymultspecmap = 1058366663,
        specularnoisemapuvscalefactor = 3472765508,
        specularpower = 2313518026,
        speedconstants = 4031543803,
        spherereflectionskyintensity = 798112437,
        splatterframeinfo = 1795230185,
        srctexturesize = 2371438916,
        sslrcenter = 2233700119,
        sslrparams = 2393555267,
        sslrsampler = 362115574,
        starfieldbrightness = 257351982,
        starfieldintensity = 1720801864,
        starfieldsampler = 4148544921,
        starfielduvrepeat = 2211182669,
        starthreshold = 2069166037,
        stencilcopy = 2849038798,
        stencilcopysampler = 2084502919,
        stencilcopytexture = 526908546,
        stenciltech = 471113370,
        stipplesampler = 3178703610,
        stubblecontrol = 3996109161,
        subcolor = 3318550136,
        subscatwidth = 993622972,
        subscatwrap = 511449331,
        subsurfacecolor = 1759569064,
        subsurfaceintensity = 1096960668,
        subsurfacerolloff = 3870878664,
        subviewportparams = 2820867500,
        sunaxias = 2561150543,
        suncentre = 240054980,
        suncolor = 891485471,
        suncolorhdr = 1049428866,
        suncolour = 1204497173,
        sunconstants = 1546824331,
        sundirection = 2607379178,
        sundisccolor = 3557539369,
        sundisccolorhdr = 1079908950,
        sunelevation = 569130658,
        sunhdrintensity = 3152536124,
        sunposition = 2950046911,
        sunraysparams = 291571442,
        sunsetcolor = 2702399089,
        sunsize = 1478210724,
        surfacetexturesampler = 3864743319,
        sweatmapsampler = 2330958813,
        switchon = 3150944317,
        targetsize = 1880392259,
        targetsizeparam = 1053269285,
        teargasparams = 1288904305,
        terraingridcentrepos = 3625956620,
        terraingridforward = 1519085164,
        terraingridhighheightcol = 580500403,
        terraingridlowheightcol = 2936084960,
        terraingridmidheightcol = 2606299729,
        terraingridparams = 1298168495,
        terraingridparams2 = 3179684830,
        terraingridright = 1294931141,
        tessellationmultiplier = 1934793340,
        texelsize = 3160646551,
        texm = 169731954,
        textureclamp = 812052183,
        texturegrasssampler = 4087226378,
        texturenowrapsampler = 2957556365,
        texturesamp = 485865047,
        texturesampler = 726757629,
        texturesampler_layer0 = 3576369631,
        texturesampler_layer1 = 606121937,
        texturesampler_layer2 = 831736502,
        texturesampler_layer3 = 2025281789,
        texturesampler_layer4 = 235963313,
        texturesampler_layer5 = 1429049834,
        texturesampler_layer6 = 1784855636,
        texturesampler2 = 90460676,
        texturesamplerdiffpal = 2878898974,
        texturesize = 3986548189,
        tiledlightingsampler = 3579496475,
        timeofday = 1778950238,
        tintblendamount = 481228442,
        tintblendlayer0 = 549865893,
        tintblendlayer1 = 3618355041,
        tintblendlayer2 = 3305181708,
        tintblendlayer3 = 4225662918,
        tintbumpiness = 3412667425,
        tintbumpsampler = 3461703736,
        tintintensity = 3676759262,
        tintpalettesampler = 4131954791,
        tintpaletteselector = 4258764495,
        tintsampler = 1530343050,
        tonemapcolorfilterparams0 = 324960120,
        tonemapcolorfilterparams1 = 48979602,
        tonemapparams = 2402343587,
        topcloudbiasdetailthresholdheight = 2470194715,
        topcloudcolor = 2654156795,
        topclouddetail = 3891329052,
        topcloudheight = 1826174990,
        topcloudlight = 1738437051,
        topcloudthreshold = 1907493970,
        toplum = 2532426199,
        totalelapsedtime = 3838297418,
        trackanimuv = 3759799674,
        transcolor = 2460231751,
        transparentdstmapsampler = 2450925918,
        transparentsrcmap = 2768420156,
        transparentsrcmapsampler = 3675757750,
        transpos = 3580147959,
        transtex0 = 719147892,
        transtex1 = 1023997899,
        transtex2 = 88705101,
        treelod2normal = 1105633214,
        treelod2params = 1951298816,
        txabc_texture = 737921561,
        txcoc_texture = 849209715,
        txx_texture = 2443058410,
        txyn_texture = 314367857,
        tyredeformparams = 1573146290,
        tyredeformparams2 = 4085683888,
        tyredeformswitchon = 1318515464,
        uicolor = 2438354415,
        uicolorxformoffset = 805638785,
        uicolorxformscale = 1696850869,
        uiposmtx = 2371642382,
        uipremultiplyalpha = 653605664,
        uitex0mtx = 1320157902,
        uitex1mtx = 2219459259,
        uitexture0 = 3890278027,
        uitexture1 = 3587000932,
        umglobaloverrideparams = 3341722211,
        umglobalparams = 570415642,
        umovementparams = 3156484982,
        umtriwave1params = 1002429420,
        umtriwave2params = 1181853954,
        umtriwave3params = 2191838184,
        underlightstrength = 618284065,
        unsharpamount = 982234565,
        updateoffset = 1690179723,
        updateparams0 = 1210532871,
        updateparams1 = 1947442147,
        usetessellation = 1176544093,
        usetreenormals = 3771895108,
        uvscalar = 2343745306,
        uvscales = 2395163223,
        vbonevelocitiesx = 58804251,
        vbonevelocitiesy = 2266287952,
        vcustomdata = 2809044919,
        vecbatchaabbdelta = 2709975619,
        vecbatchaabbmin = 1568822605,
        veccamerapos = 3890753729,
        vecplayerpos = 2050268192,
        vehglasscracktextureparams = 3043112491,
        vehglasscracktexturesampler = 3541769459,
        velocity1 = 1362920836,
        velocity2 = 1853341690,
        velocitybuffersampler = 415075366,
        velocitymapsampler = 3944176109,
        velocitytexsampler = 2305380067,
        vhairparams = 4131157628,
        viewproj = 1758764692,
        viewtoworldprojectionparam = 3809745575,
        vignettingcolor = 587686680,
        vignettingparams = 2870132669,
        visibleinstancebuffer0 = 3815124047,
        visibleinstancebuffer1 = 774685147,
        visibleinstancebuffer2 = 443193943,
        visibleinstancebuffer3 = 2592414350,
        vnoiseparams = 1120961721,
        vol_offsets = 2154022121,
        volumesampler = 789275230,
        vskinsweat = 3181015961,
        vsweatparams = 3596190507,
        waterbumpparams = 126236009,
        watercolor = 4201563883,
        watercolorsampler = 1938107181,
        watercolour = 217812784,
        waterfogfadecolor = 93338982,
        waterfogptfxparams = 1185901400,
        waterheight = 276101176,
        waterintensity = 3098236963,
        waterreflectionscale = 386931249,
        waterreflectionskyintensity = 4202734524,
        waterrendersimparam = 3115418423,
        waterripplesampler = 3870579404,
        watersimparam = 1441798312,
        watersimparams1 = 764072840,
        watersimparams2 = 2978995088,
        watersurfacesampler = 4239336251,
        watertexresvalue = 1128648105,
        wavemovement = 683816830,
        waveoffset = 2296487471,
        westcolor = 2977103135,
        wetanisotropicspecular = 1297501138,
        wetanisotropicspecularcolour = 4244410187,
        wetdarken = 3170546064,
        wetnessmultiplier = 853385205,
        windglobalparams = 208642390,
        windstr = 3237952635,
        woundframeinfo = 2347313451,
        wrapamount = 477869607,
        wrapligthtingterm = 850731621,
        wrinklemasksampler_0 = 2261465245,
        wrinklemasksampler_1 = 3567506505,
        wrinklemasksampler_2 = 2959477710,
        wrinklemasksampler_3 = 3181913682,
        wrinklemasksampler_4 = 199377605,
        wrinklemasksampler_5 = 498853496,
        wrinklemaskstrengths0 = 3696993600,
        wrinklemaskstrengths1 = 3993356436,
        wrinklemaskstrengths2 = 9399719,
        wrinklemaskstrengths3 = 1226342076,
        wrinklesampler_a = 2285332697,
        wrinklesampler_b = 163310560,
        yplanesampler = 2291309475,
        yuvtorgb = 361269406,
        zenithcolor = 1379881353,
        zenithconstants = 2801684,
        zenithtransitioncolor = 3025743240,
        zoomblurmasksize = 1914884772,
        zoomfocusdistance = 2687037299,
        zshift = 2743864906,
        zshiftscale = 273550094,














        CCompositeEntityType = 1185771007,
        scaleXY = 2627937847,
        scaleZ = 284916802,
        numChildren = 2793909385,
        childLodDist = 3398912973,
        portals = 2314725778,
        entitySets = 1169996080,
        timeFlags = 2248791340,
        rage__spdAABB = 4084721864,
        rage__fwGrassInstanceListDef = 2085051229,
        rage__fwGrassInstanceListDef__InstanceData = 3985044770,
        rage__fwPropInstanceListDef = 3120863088,
        NormalX = 3138065392,
        NormalY = 273792636,

        CImapDependency = 3501026914,
        CImapDependencies = 3240050401,
        CItypDependencies = 1515605584,
        CMapDataGroup = 3260758307, //PSO/YMF
        Bounds = 3298223272,
        HoursOnOff = 4190815249,
        itypName = 2890158180,
        packFileName = 4216494073,
        itypDepArray = 2410949350,





        //dexyfex manual guessing
        CScenarioPointRegion = 1492970064,
        CScenarioPointContainer = 2380938603,
        CScenarioPoint = 4103049490,
        CScenarioChain = 871314709,
        CScenarioChainingNode = 3340683255,
        CScenarioChainingEdge = 4255409560,
        Points = 702683191,
        Chains = 3254907796,
        ChainingGraph = 3696045377,
        rage__spdSphere = 1062159465,
        HasIncomingEdges = 407126079,
        HasOutgoingEdges = 1308720135,
        EdgeIds = 934700563,
        TypeNames = 3057471271,
        GroupNames = 2506712617,
        PedModelSetNames = 3020866217,
        VehicleModelSetNames = 3827910541,
        ModelSetId = 3361647288,
        LookUps = 1097626284,
        RequiredIMapNames = 1767860162,

        vPositionAndDirection = 4685037,
        CScenarioEntityOverride = 4213733800,
        EntityOverrides = 697469539,
        EntityPosition = 642078041,
        CScenarioPointCluster = 750308016,
        Clusters = 3587988394,
        ClusterSphere = 352461053,
        iInterior = 1975994103,
        iRequiredIMapId = 1229525587,
        iTimeTillPedLeaves = 2296188475,
        uAvailableInMpSp = 717991212,

        CPopGroupList = 738910261,

        CStreamingRequestFrame = 999226379,

        CVehicleWheel = 2964364979,

        CVfxPedInfoMgr = 2677836644,
        CVfxPedInfo = 3269469953,
        vfxPedInfos = 1918175602,

        CPedModelInfo__InitData = 3949383814,

        CVfxFogVolumeInfoMgr = 1633161012,
        CVfxFogVolumeInfo = 759946685,
        vfxFogVolumeInfos = 2287400076,

        CVfxWeaponInfoMgr = 623762845,
        CVfxWeaponInfo = 1271168564,

        CVfxInteriorInfoMgr = 4126959192,
        CVfxInteriorInfo = 998078140,
        vfxInteriorInfos = 3759474957,

        CVfxRegionInfoMgr = 3596444566,
        CVfxRegionInfo = 286275649,
        vfxRegionInfos = 4124078855,



        CWanted__Tunables__WantedLevel = 4209402831,
        AFF_AVERAGE = 2722191879,
        AFF_RICH = 1119317219,
        TS_HIGH = 956599249,
        StdDoorOpenPosDir = 2885011506,
        CDataFileMgr__DataFile = 4025199407,
        CDataFileMgr__ContentChangeSet = 2958929574,
        DataFileType = 3864419067,
        DataFileContents = 655728054,
        CONTENTS_DEFAULT = 507224223,
        InstallPartition = 2685892631,
        PARTITION_NONE = 3712881064,
        ExecutionConditions = 1196731409,
        ExecutionCondition = 2539760734,
        CTxdRelationship = 3649202799,
        child = 54445749,
        LODLights = 1326371921,
        BoxOccluder = 975711773,
        OccludeModel = 2741784237,
        sirenLight = 4091688452,
        sirenCorona = 472016577,

        fwClipDictionaryMetadata = 331140115,
        fwMemoryGroupMetadata = 2046450505,
        memoryGroupMetadatas = 3211922640,
        SP_High = 44700989,
        AP_HIGH = 313384972,
        TB_DEAD = 3088554349,
        TB_COLD = 3827341951,
        TB_HOT = 2709699671,

        vehicleLight = 1339481019,
        vehicleLightSettings = 2581049192,
        vehicleCorona = 1860240263,
        CVehicleKit = 679130282,
        CVehicleModVisible = 4238291236,
        CVehicleModLink = 2730707380,
        CVehicleModStat = 243590259,
        CVehicleModelColor = 4213335822,
        CVehicleWindowColor = 2561269966,
        CVehicleMetallicSetting = 2073371064,
        CVehicleXenonLightColor = 2807227399,
        PlateProbabilities = 2135495316,
        CVehicleModColors = 2858318490,
        CVehicleModColor = 1443412025,
        metallic = 2204727143,
        classic = 2458459502,
        matte = 1951049216,
        metals = 2740125593,
        chrome = 1114790148,
        pearlescent = 3095366650,
        spec = 1912906641,
        sirens = 2047330294,
        CCreditItem = 113388969,
        JOB_MED = 568575574,
        JOB_SMALL = 4127034762,

        eVehicleModType = 2363989491,
        eVehicleModCameraPos = 3413962745,

        eVfxGroup = 679492,

        silence = 3503773450, //used in game.dat151.rel
        null_sound = 3817852694, //used in game.dat151.rel
        constant_one = 3454258691, //used in dat .rels

        run = 285848937, //used in game.dat151.rel
        cop_dispatch_interaction_settings = 778268174, //used in game.dat151.rel




        FloatXYZ = 3805007828,

        aPropMetaData = 3902803273,
        ePedVarComp = 884254308,
        ePropRenderFlags = 4212977111,
        CPedPropTexData = 254518642,
        eScenarioPopStreamingSlot = 3029795674,
        eFadeCurveType = 3057039286,
        eSuperlodType = 4015041481,
        ePedRadioGenre = 2942646938,
        eSexinessFlags = 374769227,
        eExternallyDrivenDOFs = 637184392,
        eAnchorPoints = 2834549053,
        SpecialAbilityType = 2011786168,
        DefaultSpawnPreference = 888587604,
        numAlternatives = 2806194106,
        bHasDrawblVariations = 4086467184,

        CScenarioChainingEdge__eAction = 3609807418,
        CScenarioChainingEdge__eNavMode = 3971773454,
        CScenarioChainingEdge__eNavSpeed = 941086046,
        CStreamingRequestCommonSet = 1358189812,

        animal = 974042365, //in peds.ymt
        standard_ped = 2703423328, //in peds.ymt
        standard_male = 1860494962, //in peds.ymt PedCapsuleName - from pedbounds.xml
        standard_female = 3778684510, //in peds.ymt PedCapsuleName
        standard_player_male = 190297546, //in peds.ymt PedCapsuleName
        standard_player_female = 3813733509, //in peds.ymt PedCapsuleName
        large_male = 2182606047, //in peds.ymt PedCapsuleName
        facial_clipset_group_gen_male = 2968316036, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_gen_female = 984918963, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_zero = 3839850645, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_one = 3697506179, //in peds.ymt FacialClipsetGroupName
        facial_clipset_group_p_m_two = 3958944905, //in peds.ymt FacialClipsetGroupName
        anim_group_gesture_m_generic = 4080627616, //in peds.ymt DefaultGestureClipSet
        anim_group_gesture_f_generic = 1375166916, //in peds.ymt DefaultGestureClipSet
        anim_group_visemes_m_lo = 3326036851, //in peds.ymt DefaultVisemeClipSet
        anim_group_visemes_f_lo = 2783456433, //in peds.ymt DefaultVisemeClipSet
        nmbs_slow_getups = 69709351, //peds.ymt GetupSetHash
        clip_set_id_invalid = 2106583169, //in peds.ymt
        move_strafe_injured = 1434752434, //in peds.ymt InjuredStrafeClipSet
        move_ped_to_strafe = 3943634031, //in peds.ymt MovementToStrafeClipSet
        move_ped_strafing = 2464962150, //in peds.ymt StrafeClipSet
        civmale = 45677184, //in peds.ymt Pedtype
        civfemale = 1191392768, //in peds.ymt Pedtype
        vfxpedinfo_human_generic = 1167185222, //in peds.ymt VfxInfoName
        expr_set_ambient_male = 2495275024, //in peds.ymt ExpressionSetName
        expr_set_ambient_female = 3793172393, //in peds.ymt ExpressionSetName
        default_perception = 3537703288, //in peds.ymt PerceptionInfo
        streamed_male = 4014297412, //in peds.ymt Personality
        streamed_female = 991949850, //in peds.ymt Personality
        fitnessmale = 921466782, //in peds.ymt Personality
        fitnessfemale = 419688606, //in peds.ymt Personality
        youngrichman = 3818603935, //in peds.ymt Personality
        youngrichwoman = 367809573, //in peds.ymt Personality
        youngaverageweakman = 3971800366, //in peds.ymt Personality
        youngaverageweakwoman = 806694113, //in peds.ymt Personality
        bs_ai = 2150391885,  //in peds.ymt DefaultBrawlingStyle
        bs_franklin = 1037948029, //in peds.ymt DefaultBrawlingStyle
        bs_michael = 2057220685, //in peds.ymt DefaultBrawlingStyle
        bs_trevor = 1249954968, //in peds.ymt DefaultBrawlingStyle
        weapon_unarmed = 2725352035,  //in peds.ymt DefaultUnarmedWeapon
        silent_pvg = 423993118,  //in peds.ymt PedVoiceGroup
        silent_cutscene_pvg = 1896822940,  //in peds.ymt PedVoiceGroup

        @null = 987444055, // how best to handle this? C# doesn't like it


        exportcamera = 962998194, //cutscene related stuff

        loop = 1281572103, //found in AWCs GranularLoop









        //ped ymt's hashes from Siprus
        numAvailProps = 2598445407,
        numAvailTex = 3371516811,
        ownsCloth = 2828247905,
        aComponentData3 = 3796409423,
        aDrawblData3 = 1756136273,
        bHasTexVariations = 1235281004,
        availComp = 2996560424,
        CPVDrawblData = 1535046754,
        CPVComponentData = 3538495220,
        CPVTextureData = 1036962405,
        propTexId = 672172037,
        propDrawableId = 2095974912,
        compDrawableId = 173599222,
        propAnchorId = 3598106198,
        compTexId = 2991454271,
        PRF_CUTOUT = 3395845123,
        PRF_DECAL = 3735238938,
        PRF_ALPHA = 3757767268,
        ANCHOR_PH_L_HAND = 604819740,
        ANCHOR_PH_R_HAND = 2358626934,

        //occlusion ymt's from Siprus
        DestRoomIdx = 1028873946,
        PortalInfoIdx = 1084559223,
        DestInteriorHash = 57503776,
        InteriorProxyHash = 3748344047,
        PathNodeList = 1142266249,
        PathNodeKey = 2721898107,
        PathNodeChildList = 3530626268,
        PortalEntityList = 3203972140,
        PortalInfoList = 3085292924,

        //vfxinteriorinfo ymt's from Siprus
        CVfxInteriorSetup = 128879576,
        CVfxRoomSetup = 769638437,
        dustPtFxEnabled = 1270885502,
        dustPtFxEvo = 3916956310,
        dustPtFxName = 4061889016,
        interiorInfoName = 3197750225,
        smokePtFxEnabled = 174438245,
        smokePtFxLevelOverride = 1794720348,
        smokePtFxName = 2216385556,
        vfxInteriorSetups = 3147314065,
        vfxRoomSetups = 70742260,

        //entries for vfxinteriorinfo values from Siprus
        vfxinteriorinfo_club_bar = 3012126598,
        vfxinteriorinfo_default = 2186191160,
        vfxinteriorinfo_disabled = 4043117346,
        vfxinteriorinfo_factory = 3704850198,
        vfxinteriorinfo_factory2 = 789288375,
        vfxinteriorinfo_foundry = 3102010781,
        vfxinteriorinfo_methlab = 1747000990,
        vfxinteriorinfo_michael_mansion = 2503389540,
        vfxinteriorinfo_recycle = 3828623237,
        env_bar_haze = 2464653728,
        env_dust_motes_int_hvy = 2388998730,
        env_dust_motes_int_recycle = 1189228428,
        env_gunsmoke = 1283110988,
        env_gunsmoke_paper_factory = 2917372338,
        env_stripclub_haze = 3512462560,
        v_34_deliveryrm = 1873829195,
        v_34_processrm = 2131172512,
        v_64_back = 291590403,
        v_64_back_lower = 2635531210,
        v_64_base2 = 2901364601,
        v_64_cloak = 2699110422,
        v_64_dance = 1921450756,
        v_64_entry = 209242346,
        v_64_entry_trans = 3070346248,
        v_64_rear = 4193595779,
        v_64_rear_trans = 1532913744,
        v_64_side = 2526696518,
        v_64_side_upper = 593969979,
        v_64_upper = 182753347,
        v_recycle_chopper = 2694641996,
        v_recycle_cor1 = 2624371671,
        v_recycle_door = 4022865356,
        v_recycle_main = 1108714138,
        v_recycle_office1 = 4228826032,
        v_recycle_shield = 2720085499,
        v_recycle_stair2 = 3998905162,
        v_recycle_window = 2808950336,

        //more ped.ymt's hashes from Siprus
        shoe_dress_shoes = 3199946566,
        shoe_golf_shoes = 2839919184,
        shoe_heavy_boots = 1032158653,
        shoe_scuba_flippers = 378813016,
        shoe_flip_flops = 2060154316,
        shoe_cowboy_boots = 2839908380,
        shoe_normal_heels = 3937154717,
        shoe_rubber = 3737214528,
        shoe_trainers = 3325651536,
        shoe_heels = 2000019839,
        shoe_barefoot = 1461428428,
        shoe_high_heels = 3928708288,
        shoe_rubber_boots = 3194973734,
        cloth_backpack = 1069599825,
        cloth_ballistic = 4078855526,
        cloth_cop_belt = 4133108633,
        cloth_gas_mask = 4065623745,
        cloth_heavy_bag = 4153104635,
        cloth_lower_ballistic_armour = 4106198121,
        cloth_lower_bare = 1628659471,
        cloth_lower_cop = 1540859016,
        cloth_lower_cotton = 1141160746,
        cloth_lower_extreme = 4088613522,
        cloth_lower_fireman = 1406591853,
        cloth_lower_leather = 3327176319,
        cloth_lower_pants_denim = 4176749571,
        cloth_lower_pants_leather = 529572143,
        cloth_lower_pants_suit = 3685853881,
        cloth_lower_pants_tight = 879250969,
        cloth_lower_shorts = 3301429444,
        cloth_lower_skirt_long = 421389060,
        cloth_lower_skirt_short = 710005800,
        cloth_lower_swat = 291450192,
        cloth_lower_waterproof = 1695056885,
        cloth_rappel_parachute = 3513212182,
        cloth_scuba = 861851786,
        cloth_tool_belt = 2531067209,
        cloth_upper_alien = 2291900169,
        cloth_upper_ballistic_armour = 145524546,
        cloth_upper_bare = 1870774092,
        cloth_upper_bikini_top = 3629254153,
        cloth_upper_coat_scientist = 1946563223,
        cloth_upper_cop = 2483445690,
        cloth_upper_cop_vest = 1515519271,
        cloth_upper_cotton = 830866350,
        cloth_upper_fireman = 669860574,
        cloth_upper_jacket_cotton = 4008082313,
        cloth_upper_jacket_leather = 1106508751,
        cloth_upper_jacket_puffy = 2884411436,
        cloth_upper_jacket_suit = 979848852,
        cloth_upper_leather = 401172640,
        cloth_upper_shirt_cotton_heavy = 3934084272,
        cloth_upper_shirt_cotton_lite = 176526946,
        cloth_upper_shirt_leather = 67091042,
        cloth_upper_shirt_tee = 1237088534,
        cloth_upper_spacesuit = 1018641360,
        cloth_upper_swat = 2783390651,
        cloth_upper_sweater = 3189514483,
        cloth_upper_waterproof = 3748562816,
        upper_cotton = 3438959116,

        //CExtensionDefLightShaft enum value hashes from Siprus
        LIGHTSHAFT_VOLUMETYPE_CYLINDER = 462992848,
        LIGHTSHAFT_DENSITYTYPE_LINEAR = 152140774,
        LIGHTSHAFT_DENSITYTYPE_CONSTANT = 676250331,
        LIGHTSHAFT_DENSITYTYPE_QUADRATIC = 1098824079,
        LIGHTSHAFT_DENSITYTYPE_QUADRATIC_GRADIENT = 1492299290,
        LIGHTSHAFT_DENSITYTYPE_SOFT_SHADOW_HD = 1816804348,
        LIGHTSHAFT_DENSITYTYPE_SOFT_SHADOW = 2057886646,
        LIGHTSHAFT_DENSITYTYPE_LINEAR_GRADIENT = 2088805984,
        LIGHTSHAFT_DENSITYTYPE_SOFT = 2399586564,



        ////various entries from Siprus - thanks!
        // eVfxGroup
        VFXGROUP_TARMAC_BRITTLE = 349722727,
        VFXGROUP_LINOLEUM = 656066551,
        VFXGROUP_TVSCREEN = 688944506,
        VFXGROUP_SAND_LOOSE = 1041698964,
        VFXGROUP_CARDBOARD = 1710619059,
        VFXGROUP_UNDEFINED = 1777437223,
        VFXGROUP_CAR_PLASTIC = 2101842785,
        VFXGROUP_SAND_UNDERWATER = 2143791359,
        VFXGROUP_GENERIC = 2432469028,
        VFXGROUP_SAND_DEEP = 2673689260,
        VFXGROUP_CONCRETE_DUSTY = 3536499660,
        VFXGROUP_LIQUID_MUD = 3745008516,
        VFXGROUP_FOAM = 3912379355,

        // POPGROUPS
        POPGROUP_RARE = 35209924,

        // DataFileType enum
        AMB_PROCEDURAL_BLOOD_FILE = 2738801230,
        COMBAT_BEHAVIOUR_OVERRIDE_FILE = 364263123,
        CONTROLLER_LABELS_FILE_DURANGO = 4129824885,
        CONTROLLER_LABELS_FILE_ORBIS = 91648887,
        CONTROLLER_LABELS_FILE_ORBIS_JPN = 2018868761,
        DELAYED_IDE_FILE = 4115202587,
        DLC_POP_GROUPS = 2421375782,
        FACIAL_CLIPSET_GROUPS_FILE = 1714317514,
        FLIGHTZONES_FILE = 3179455283,
        LEADERBOARD_ICONS_FILE = 1431237327,
        PED_DAMAGE_OVERRIDE_FILE = 3155601669,
        RMPTFX_FILE = 2041822787,
        SCALEFORM_PREALLOC_FILE = 2609475948,
        SCALEFORM_VALID_METHODS_FILE = 3169431862,
        SCENARIO_POINTS_OVERRIDE_FILE = 33804852,
        SCRIPT_BRAIN_FILE = 2678176687,
        SCROLLBARS_FILE = 3993726615,

        // animation clip priority enum
        eAnimPriority = 1498349301,
        AP_FACE_HIGH = 611607097,
        AP_FACE_LOW = 2096169364,
        AP_FACE_MEDIUM = 3509068476,

        // eAnimPlayerFlag
        APF_BLOCK_IK = 1238878851,
        APF_ISPLAYING = 508324092,
        APF_SCRIPT = 2827814553,
        APF_UNUSED_3 = 2727614813,
        APF_UNUSED_4 = 3032530358,
        APF_UNUSED_6 = 3646785267,
        APF_UNUSED_7 = 3914016462,
        APF_UNUSED_8 = 1023626813,
        APF_UNUSED_9 = 1321103795,

        // ped ymts
        bHasLowLODs = 911147899,
        bIsSuperLOD = 315291935,

        //rel categories
        ambience_birds = 2111673525,
        ambience_collectables = 1822293160,
        ambience_general = 605434024,
        ambience_industrial = 3601034378,
        ambience_insects = 1516192474,
        ambience_music = 4061751802,
        ambience_speech = 4118533336,
        ambience_weather = 2993238467,
        collisions_cloth = 4114296646,
        collisions_glass = 3665884229,
        collisions_louder = 3707599549,
        collisions_scripted = 3607066630,
        collisions_vehicles_glass = 40916134,
        cutscenes = 2130818598,
        doors_loud = 4083376175,
        fire = 3540648811,
        fire_louder = 3795113672,
        frontend_game_loud = 1563623315,
        frontend_menu = 3209785070,
        frontend_menu_loud = 2867594907,
        frontend_radio = 130804751,
        game_world = 657061725,
        interactive_music = 1572110022,
        music = 3376826828,
        music_loading = 1691427420,
        peds_clothing = 2705431951,
        peds_collisions = 2898035946,
        peds_collisions_loud = 3672708454,
        peds_wind = 3149982308,
        radio = 1847911863,
        score = 2134238453,
        scripted = 1670758327,
        scripted_alarms = 2563970085,
        scripted_louder = 682050869,
        scripted_tv = 201797022,
        speech = 163313604,
        speech_ambient = 410026006,
        speech_breathing = 2670011790,
        speech_pain = 2021015895,
        speech_scripted = 3078245965,
        underwater_loud = 4027278097,
        underwater_muted = 2969328544,
        underwater_swimming = 2137972630,
        vehicles_bicycles = 3685564039,
        vehicles_bicycles_mechanical = 134197036,
        vehicles_boats_engines = 1823905713,
        vehicles_boats_water = 343703808,
        vehicles_brakes = 1315521004,
        vehicles_car_by = 2709313722,
        vehicles_chassis_rattle = 270455670,
        vehicles_doors = 2640217883,
        vehicles_engines_cooling = 1473309549,
        vehicles_engines_damage = 431436680,
        vehicles_engines_ignition = 325435029,
        vehicles_engines_intake = 266876274,
        vehicles_engines_loud = 607318229,
        vehicles_engines_reflections = 2730342635,
        vehicles_engines_startup = 2812351357,
        vehicles_extras_loud = 1806509607,
        vehicles_helis = 3565904205,
        vehicles_helis_distant = 1203937907,
        vehicles_horns = 3310407619,
        vehicles_horns_loud = 1875957285,
        vehicles_planes = 360518393,
        vehicles_planes_close = 450576074,
        vehicles_planes_distant = 2745068879,
        vehicles_planes_extras = 2970811186,
        vehicles_planes_jet = 2496384807,
        vehicles_planes_prop = 2880809343,
        vehicles_sirens = 3312980540,
        vehicles_suspension = 2521949505,
        vehicles_train = 2900951834,
        vehicles_train_brakes = 400861892,
        vehicles_train_carriage = 3957967078,
        vehicles_train_clack = 1353825976,
        vehicles_wheels = 3141782289,
        vehicles_wheels_loud = 3187816841,
        vehicles_wheels_skids = 1011082280,
        water_loud = 3800267791,
        water_ocean = 3756642183,
        water_swimming = 3392133420,
        weapons_explosions = 217319362,
        weapons_explosions_loud = 3464961727,
        weapons_guns = 1238862244,
        weather_rain = 973848687,
        weather_rain_heavy = 646232623,
        weather_rain_props = 633103322,
        weather_thunder = 1377523001,
        weather_wind = 3506430202,
        weather_wind_foliage = 480273725,


        // particles ShaderVars names from Siprus
        diffusetex2 = 234123336,
        softnesscurve = 415919122,
        directionalmult = 1250560552,
        normalmapmult = 2008564461,
        superalpha = 2445226024,
        normalspecmap = 3009619921,
        normalarc = 3063280732,
        shadowamount = 3218705437,
        refractionmap = 3749494808,
        camerabias = 4030385036,
        ambientmult = 4164128389,
        softnessshadowoffset = 2810291083,
        softnessshadowmult = 341373563,
        extralightmult = 3338535754,
        camerashrink = 2170767496,


        //AWC markers names from Siprus
        tank_jump = 322089989,
        tank_weapon_main_cannon_hit = 2054994489,
        tank_jump_land = 2326210279,
        tank_turret_move = 3770661529,
        tempo = 2051628467,
        beat = 3902465932,
        dj = 148611320,
        //01 = 2740850834,//this one added in RpfManager.BuildBaseJenkIndex
        rockout = 4078653290,
        uihit = 3632555010,//is this right?
        r_p = 295134840,//is this right?
        g_s = 349722558,//is this right?
        m_p = 2304294116,//is this right?








        //GranularSound dat54.rel FileName hashes from NotGigo
        engine_accel = 3748922026,
        exhaust_accel = 598446449,
        engine_decel = 2556723864,
        exhaust_decel = 780159042,
        engine_idle = 1025030561,
        exhaust_idle = 396221610,












        //from dav90's PSO_RBF_XMLExport_V5.7
        AutoJunctionAdjustments = 1352439928,
        vLocation = 929088795,
        fCycleOffset = 1883372816,
        fCycleDuration = 3328650398,

        registerAs = 1419376801,

        CreditItems = 1705522053,
        LineType = 660169259,
        cTextId1 = 4188319879,
        cTextId2 = 2913343627,
        JOB_BIG = 1035407208,

        flee_left = 204999120,
        flee_right = 1266046331,
        flee_forward = 1547194093,
        flee_back = 1622623046,




        //dav90 suggestions
        AccelGrid = 3053155275,
        NavMode = 859022269,
        NavSpeed = 1419316113,
        NodeIndexTo = 2851806039,
        NodeIndexFrom = 3236798246,
        CScenarioPointLookUps = 3019621867,
        ANCHOR_MOUTH = 2032023579,
        ANCHOR_LEFT_HAND = 100074042,
        ANCHOR_RIGHT_HAND = 3693638868,
        ANCHOR_HIP = 2778755006,
        ANCHOR_LEFT_FOOT = 1100801960,
        ANCHOR_RIGHT_FOOT = 1776231225,
        mloFlags = 3590839912,
        floorId = 2187650609,
        timecycleName = 2724323497,
        secondaryTimecycleName = 3255324828,
        portalCount = 1105339827,
        exteriorVisibiltyDepth = 552849982, //not correct = spelling error?
        attachedObjects = 2382704940,
        roomFrom = 4101034749,
        roomTo = 2607060513,
        mirrorPriority = 1185490713,
        audioOcclusion = 1093790004,
        dataSize = 2442753371,
        iCenterX = 48026296,
        iCenterY = 896907229,
        iCenterZ = 1597508449,
        iLength = 2854610661,
        iWidth = 168013536,
        iHeight = 3485277993,
        explosionName = 3301388915,
        explosionTag = 2653034051,
        explosionType = 3379115010,
        cornerA = 3302595027,
        cornerB = 2393877884,
        cornerC = 2692731164,
        cornerD = 4250372814,
        directionAmount = 1441249296,
        densityType = 235100599,
        volumeType = 4021175589,
        softness = 187712958,
        disturbanceType = 3802708370,
        radiusInner = 406390660,
        radiusOuter = 1814053978,
        minScale = 3662913353,
        maxScale = 803384552,
        objectHash = 1951307499,
        LoadSavePoints = 3016741991,
        MyPoints = 1170781136,
        iProbability = 2974610960,
        iScenarioGroup = 2180252673,
        EntityType = 1374199246,
        CStreamingRequestRecord = 135915278,
        Frames = 419044527,
        CommonSets = 4248405899,
        NewStyle = 2333392588,
        AddList = 327274266,
        RemoveList = 3372321331,
        CamPos = 357008256,
        CamDir = 210316193,
        Requests = 2743119154,
        compInfos = 592652859,
        propInfo = 2240851416,
        propMask = 2932859459,
        aTexData = 1251090986,
        clothData = 2464583091,
        distribution = 914976023,
        inclusions = 2172318933,
        aAnchors = 162345210,
        expressionMods = 942761829,
        texData = 4088935562,
        renderFlags = 4239582912,
        propFlags = 1066841901,
        anchorId = 2731224028,
        propId = 3817142252,
        inclusionId = 1938349561,
        exclusionId = 3819522186,
        weaponSlot = 1912311826,
        disableProjectileDriveby = 531190847,
        disableDriveby = 3038752585,
        NoSpawn = 2321493392,   //scenario point flags enum values
        TerritorialScenario = 763077056,
        InWater = 3157896680,
        OpenDoor = 2382141124,
        ExtendedRange = 324643703,
        ShortRange = 3717016373,
        HighPriority = 3426447659,
        IgnoreLoitering = 626032513,
        //ZoomTransformInformations = 3304563391, //this one doesn't make sense
        kOnlySp = 4171042740, //scenario spawn point availability enum
        kOnlyMp = 549935372,
        Direct = 1129153779, //scenario chain edge nav mode enum
        NavMesh = 4272634460,
        Roads = 177164187,
        METAL_LIGHT_LADDER = 846330484,
        CComponentInfo = 1866571721,
        CAnchorProps = 2170383875,
        CBlockDesc = 3072355914,
        CClassNameOfItemType = 440716365, //array type for (PSO) MAP fields
        zones = 2319609287,
        spName = 4254542050,
        CInteriorBoundsFiles = 741495440,
        PortalIdx = 1061685079,
        RoomIdx = 3136588885,
        LinkType = 1812903871,
        MaxOcclusion = 3034993422,
        IsDoor = 474556907,
        IsGlass = 1060358829,

        CellDimX = 2690909759,
        CellDimY = 3691675019,
        MaxCellX = 3824598937,
        MaxCellY = 3374647798,
        MinCellX = 860552138,
        MinCellY = 496029782,
        aSelectionSets = 2131007641,
        creatureMetadataName = 2766477159,
        expressionDictionaryName = 1095612811,
        fadeDistanceEnd = 475013030,
        fadeDistanceStart = 40301253,
        fadeInTimeEnd = 120454521,
        fadeInTimeStart = 1616789093,
        fadeOutTimeEnd = 75548206,
        fadeOutTimeStart = 1297365553,
        initialiseOnCollision = 1562817888,
        maxScaleZ = 147400493,
        maxZOffset = 3889902555,
        minScaleZ = 3913056845,
        minZOffset = 2591582364,
        numTris = 2337695078,
        numVertsInBytes = 853977995,
        scaleBySunIntensity = 59101696,

        CVehicleModPearlescentColors = 1380492417,
        baseCols = 2645876692,
        specCols = 666439252,




        ACTION_TABLE_BRANCHES = 873568416,
        ACTION_TABLE_DAMAGES = 595808921,
        ACTION_TABLE_DEFINITIONS = 1586102416,
        ACTION_TABLE_FACIAL_ANIM_SETS = 2229907729,
        ACTION_TABLE_HOMINGS = 322779061,
        ACTION_TABLE_IMPULSES = 3648540414,
        ACTION_TABLE_INTERRELATIONS = 1160967041,
        ACTION_TABLE_RESULTS = 1389081087,
        ACTION_TABLE_RUMBLES = 2747161193,
        ACTION_TABLE_STEALTH_KILLS = 607800534,
        ACTION_TABLE_STRIKE_BONES = 2040342322,
        ACTION_TABLE_VFX = 387140454,
        AF_AimDirect = 860304717,
        AF_AtEdge = 3386029841,
        AF_CAN_DIVE = 1665251515,
        AF_Center = 3392782621,
        AF_EnterLeft = 3822780995,
        AF_FaceLeft = 754232761,
        AF_Low = 4105818928,
        AF_Scope = 2989860387,
        AF_ToLow = 569621039,
        AF_ToPeek = 1740709742,
        AIEnterCoverClips = 102329791,
        AIEnterTransitionClips = 2915894063,
        AIOneHandedAimingClipSetId = 1351184833,
        AIOnlyReactionRangeScaleFactor = 1284602455,
        AIStandEnterCoverClips = 3619734025,
        AITimeBetweenLookAtsFailureMax = 825960985,
        AITimeBetweenLookAtsFailureMin = 1036503478,
        AITimeWaitingToCrossRoadMax = 242751779,
        AITimeWaitingToCrossRoadMin = 299126851,
        AITwoHandedAimingClipSetId = 1837001601,
        AI_IdleTurnRate = 985371239,
        AI_MBRAcceleration = 2741511192,
        AI_MBRDeceleration = 3394605993,
        AMBIENT_PED_MODEL_SET_FILE = 2585891657,
        AMBIENT_PROP_MODEL_SET_FILE = 1221077490,
        AMBIENT_VEHICLE_MODEL_SET_FILE = 2488014020,
        APF_ADDITIVE = 332392317,
        APF_BLOCK_HEAD_IK = 1871501357,
        APF_FACIAL = 1706286383,
        APF_ISFINISHAUTOREMOVE = 3723366928,
        APF_UPPERBODYONLY = 3541611037,
        APF_USE_SECONDARY_SLOT = 2933717348,
        AUDIO_CURVEDATA = 2270570848,
        AUDIO_LEGALS = 980984444,
        AUDIO_NAME = 1792396879,
        AUTOGYRO = 2983251618,
        AbandonDistance = 3316020555,
        AbortAimedAtMinDistance = 2471124155,
        AccelRate = 1799363495,
        Acceleration = 455772583,
        AccelerationBased = 1199000829,
        AccelerationForce = 4142316102,
        AccelerationLimit = 2807887859,
        AccelerationScaleBike = 1717140709,
        AccelerationSmoothing = 946605886,
        AccelerationSmoothingBike = 1058383858,
        AccelerationToStartLeaning = 3976993041,
        ActionBlendInDuration = 1593645740,
        ActionClipRate = 2230131245,
        ActionCombatAlignRate = 1946397601,
        ActionModeTime = 258368020,
        ActionSets = 4009202106,
        ActionsHandcuffedNetworkId = 2803702095,
        AddPedGenBlockedArea = 3664766217,
        AddToBaseStuckOnVehicleSets = 4027713155,
        AdditionalDistanceForApproach = 3311720447,
        AdditionalDistanceForStrafe = 3249320190,
        AdditionalModifier = 3164975884,
        AdditionalSpeedCap = 3139639651,
        AdditionalWindscreenRagdollForceFwd = 1948944372,
        AdditionalWindscreenRagdollForceUp = 3235771585,
        Adjustment = 1514279376,
        Adjustments = 4147768898,
        AdvanceDistanceSquared = 898987704,
        AdvanceUseTimeRandomMaxProportion = 652219771,
        AggressiveMove = 625597120,
        Agility = 3039521267,
        AgitatedPersonality = 3499834918,
        AgitationTriggers = 1849624842,
        Ai = 237851371,
        AiAimIntroCloseEnoughTolerance = 295831481,
        AiClearedVehicleDelay = 2616874064,
        AiClearedVehicleSmartFallDelay = 2452951318,
        AiEntryHalfAngleTolerance = 2527222356,
        AiEntryMaxRate = 976189127,
        AiEntryMinRate = 2645460108,
        AiMoverFixupMaxExtraHeadingChange = 3215816764,
        AimAssistBlendInTime = 505547665,
        AimAssistBlendOutTime = 3649321767,
        AimAssistCapsuleMaxLength = 134284951,
        AimAssistCapsuleRadius = 2827935386,
        AimAssistDistanceCurve = 390534438,
        AimBehaviourEnvelopeRef = 2238897248,
        AimDirectlyMaxAngle = 3060249921,
        AimDistance = 3825720952,
        AimFov = 3154554341,
        AimIntroClips = 1512682432,
        AimIntroMaxAngleChangeRate = 1952772149,
        AimIntroMaxPhaseChangeRate = 2752952312,
        AimIntroMaxTimedOutPhaseChangeRate = 3521301980,
        AimIntroMinPhaseChangeRate = 1545452032,
        AimIntroRateForAi = 3231686180,
        AimIntroTaskBlendOutDuration = 473976041,
        AimOutroDelayTime = 2973722662,
        AimOutroMinTaskTimeWhenRunPressed = 2511610049,
        AimOutroRateForAi = 1089147792,
        AimOutroTime = 1822973195,
        AimOutroTimeIfAimingOnStick = 1768561713,
        AimPoses = 877489286,
        AimSensitivityScalingLimits = 1539206266,
        AimTurnCosAngleTolerance = 2821466544,
        Aiming = 3260617242,
        AimingOnStickCooldownMs = 1466310013,
        AimingOnStickExitCooldown = 2412774208,
        AimingSettings = 85936843,
        AirResistanceOption = 220567909,
        AlignSuccessMaxDist = 2661149439,
        AlignmentConeAngle = 3992317122,
        AlignmentConeAngleWithTrailer = 3365340087,
        AlignmentConeOffsetTowardsVehicleFrontAngle = 1160959405,
        AllowArmouredKnockdown = 3717266986,
        AllowArmouredLegShot = 1779515548,
        AllowDriveToGetup = 2492839498,
        AllowDriverLockOnToAmbientPeds = 3783727678,
        AllowDriverLockOnToAmbientPedsInSP = 3215957770,
        AllowEntryToMPWarpInSeats = 4265363743,
        AllowIgnoreAsLowPriority = 3215420778,
        AllowMovingArmedMeleeAttack = 2144745273,
        AllowNonPlayerHighFallAbort = 4255515242,
        AllowOffScreenHighFallAbort = 992799658,
        AllowPitchAndRoll = 3861069366,
        AllowPlayerStunned = 3993091983,
        AllowPursuePlayer = 1975950903,
        AllowRoadCrossHurryOnLightChange = 3260171409,
        AllowScanningEvenIfPreviouslyReacted = 3118021097,
        AllowSlowCruisingWithMusic = 2380425018,
        AllowSoftLockFineAim = 297555324,
        AllowWarningActivations = 4197576600,
        AllowWhenBalanced = 2018281497,
        AlternateControlStickInputThreshold = 3417116793,
        AlternativeAnimBlockedHeight = 3876119945,
        AlwaysUse = 715231316,
        AmbientAnimLengthBuffer = 1095839119,
        AmbientAudio = 3268464789,
        AmbientEventLifetime = 1941376054,
        AmbientEventType = 1507389089,
        AmountPinnedDownByBullet = 866380197,
        AmountPinnedDownByDamage = 3456533073,
        AmountPinnedDownByWitnessKill = 1098445330,
        AmplitudeLimits = 2371650129,
        AmplitudeNoise = 312484959,
        AmplitudeScale = 2919368248,
        AngleDelta = 737052146,
        AngleDifferenceForMax = 2207962562,
        AngleDifferenceForMin = 3784903261,
        AngleForMax = 760576493,
        AngleForMin = 485092302,
        AngleForRunway = 2103581552,
        AngleOfCoverWeighting = 2472038331,
        AngleScalingFactor = 1160632805,
        AngleToCameraWeighting = 1431242126,
        AngleToCoverWeighting = 647728646,
        AngleToDynamicCoverWeighting = 3402563167,
        AngledArea = 2592513975,
        AngledAreas = 3530189928,
        AngledClimbScaleVelocityExtensionMax = 2762624828,
        AngledClimbTheshold = 3158074083,
        AngularVelocityLimits = 1247412006,
        AnimMode = 1881596949,
        AnimPostFXManager = 4209092714,
        AnimalBodyScale = 3667685650,
        AnimalPelvisScale = 4074006169,
        AnimatedPostFX = 3205113395,
        AnkleAndWrist = 3435621206,
        ApplyPedScale = 1737474230,
        ApplyRotationScaling = 142881218,
        ApplyTranslationScaling = 2981016968,
        ApplyVehicleScale = 3650822252,
        ApproachTarget = 432947414,
        ApproachingPlayerCosineThreshold = 372581586,
        ApproachingPlayerDistanceThreshold = 1461747338,
        ApproachingPlayerModifier = 2714692767,
        ApproachingTargetVehicleHoldFireDistance = 1135781765,
        AquaticSpawnDepth = 798871205,
        AquaticSpawnMaxHeightAbovePlayer = 1856882404,
        Arc = 1995960590,
        ArcRadius = 1686516854,
        ArcStatus = 743861760,
        ArmShot = 3674358794,
        ArmourEfficiency = 3330066831,
        Armoured = 264772538,
        ArmouredBonus = 81171216,
        ArmouredRapidHitCount = 3537415104,
        Army = 2552595859,
        ArrestDistance = 684815089,
        ArrestDot = 1800609114,
        ArrestHardLockDistance = 1845591318,
        ArrestInVehicleDistance = 1433360068,
        ArrestProbeDistance = 4096940896,
        AspectRatio = 69123357,
        AssetName = 2112595704,
        AssistanceAngle = 763241052,
        AssistedAimCamera = 4068186391,
        AssistedAimInterpolateInDuration = 4032674616,
        AssistedAimOutroTime = 4243324346,
        AtEdgeAnimStateInfos = 1367701780,
        AttachBoneTag = 575433612,
        AttachOffset = 3651374867,
        AttachOffsetX = 1914687253,
        AttachOffsetY = 1407750823,
        AttachOffsetZ = 1694184652,
        AttachOrientationX = 2711684267,
        AttachOrientationY = 2941689878,
        AttachOrientationZ = 1795856235,
        AttachParentHeightRatioToAttain = 2070771362,
        AttachParentHeightRatioToAttainInTightSpace = 2923457671,
        AttachParentHeightScalingForCameraRelativeVerticalOffset = 2685248219,
        AttachParentHeightScalingForCameraRelativeVerticalOffset_AfterAiming = 3654232577,
        AttachParentHeightScalingForExtraCameraRelativeVerticalOffset = 3987821886,
        AttachParentInAirEnvelopeRef = 1789219851,
        AttachParentMatrixForRelativeOrbitSpringConstant = 2521592812,
        AttachParentMatrixForRelativeOrbitSpringDampingRatio = 4067016949,
        AttachParentRelativeHeading = 10648206,
        AttachParentRelativePitch = 3436942647,
        AttachParentRollDampingPitchHardLimits = 1356521412,
        AttachParentRollDampingPitchSoftLimits = 4039533147,
        AttachParentRollSpringConstant = 293341517,
        AttachParentRollSpringDampingRatio = 3607038158,
        AttachParentUpwardSpeedScalingInAirEnvelopeRef = 2960196386,
        AttachParentUpwardSpeedScalingOnGroundEnvelopeRef = 2224847663,
        AttachParentWidthScalingForCameraRelativeSideOffset = 142271562,
        AttachPart = 2289273332,
        AttachPedPelvisOffsetSpringConstant = 1148495425,
        AttachPedPelvisOffsetSpringDampingRatio = 536202543,
        AttachRelativeOffset = 3718710002,
        AttackDelay = 1512162309,
        AttackDuration = 75961662,
        AttackStrengthMax = 3806042807,
        AttackStrengthMin = 2502152653,
        AudioReactionRange = 17870529,
        AutomaticHeadShot = 478190306,
        AutomaticInitialSnapMult = 1689181219,
        AutomaticNeckShot = 451773670,
        AutomobileSpeedModifier = 2432019232,
        AvoidNearbyPedDotThreshold = 2430060993,
        AvoidNearbyPedHorizontal = 2710536525,
        AvoidNearbyPedVertical = 868109097,
        AvoidOffsetXY = 2249292417,
        AvoidOffsetZ = 2919714320,
        AvoidanceMarginForOtherLawEnforcementVehicles = 48543250,
        AvoidanceProbeInterval = 3847609025,
        AvoidanceProbeLength = 715859273,
        AvoidanceProbePullback = 3266740728,
        AvoidanceSteerAngleDegrees = 3581037895,
        Avoids = 394023184,
        AwardParachuteJumpDistanceA = 3004548533,
        AwardParachuteJumpDistanceB = 3235406138,
        AwardParachuteJumpTime = 1740411412,
        AwardVehicleJumpDistanceA = 3662021366,
        AwardVehicleJumpDistanceB = 2301583602,
        AwardVehicleJumpTime = 1801522365,
        AxesFacingTolerance = 1858039250,
        BACKGROUND_SCRIPT_FILE = 1197964820,
        BCRExclusionZone = 3968865312,
        BC_Randomize = 4235841451,
        BC_Retain = 2165534923,
        BF_AGGRESSIVE_AFTER_RUNNING_PED_OVER = 4159638386,
        BF_ARGUMENTATIVE = 168692563,
        BF_CAN_ACCELERATE_IN_CAR = 1160283338,
        BF_CAN_FLEE_WHEN_HIT_BY_CAR = 687848862,
        BF_CAN_GET_OUT_WHEN_HIT_BY_CAR = 2997524846,
        BF_CONFRONTATIONAL = 1200956848,
        BF_DONT_FORCE_FLEE_COMBAT = 1196718962,
        BF_DONT_RUN_ON_MELEE_ATTACK = 914958829,
        BF_DONT_SAY_PANIC_ON_FLEE = 640530450,
        BF_GET_PISSED_WHEN_HIT_BY_CAR = 4164385006,
        BF_INTERVENE_ON_MELEE_ACTION = 294976751,
        BF_INTIMIDATE_PLAYER = 2849017488,
        BF_LIMIT_COMBATANTS = 4202267286,
        BF_PLAY_CAR_HORN = 3634362686,
        BF_PURSUE_WHEN_HIT_BY_CAR = 985531983,
        BF_REACT_ON_COMBAT = 3501709025,
        BF_WATCH_ON_CAR_STOLEN = 1317922943,
        BIG_REACTION = 3804705025,
        BUILDING_META_DISPLACEMENT_FILE = 1815909929,
        BackHeadingInterpRate = 1673427683,
        BackOffTimer = 3890964100,
        BackShot = 3495314353,
        BadRoute = 1572599387,
        BadRouteValue = 3663294436,
        Base = 212355988,
        BaseAttachVelocityToIgnoreEnvelopeRef = 60641442,
        BaseClipId = 1993756531,
        BaseFov = 1865815245,
        BaseFovToEmulateWithFocalLengthMultiplier = 3921296525,
        BaseHeading = 2985933428,
        BaseMotionBlurStrength = 652273141,
        BaseNearClip = 2755051531,
        BaseOrbitPitchOffset = 1778852906,
        BaseOrbitPitchOffsetInTightSpace = 158553507,
        BasePivotHeightScalingForFootRoom = 1397182427,
        BasePivotPosition = 1065618425,
        BaseTimeToLook = 2905104124,
        BasicObjectScore = 1313622498,
        BasicPedScore = 835021064,
        BasicVehicleScore = 3463312294,
        BeJackedBlendInDuration = 2885633587,
        BehindPedModifier = 214316948,
        BehindPedToCoverCosTolerance = 1216157443,
        BehindRotateAngleLookAhead = 3025087075,
        BehindTargetAngle = 2688788428,
        BehindThreshold = 692748984,
        BeingPushedOnGroundTooLongMS = 952442515,
        BiasSide = 1744405318,
        BiasSideTime = 2827348378,
        BicycleDepletionMaxMult = 3428727331,
        BicycleDepletionMidMult = 4027241659,
        BicycleDepletionMinMult = 2709145468,
        BicycleDrivebyFilterId = 939946101,
        BicycleEnterForce = 1607735267,
        BicycleInverseMassScales = 3654250561,
        BicycleMaxDepletionLimit = 1171875727,
        BicycleMidDepletionLimit = 2465303084,
        BicycleMinDepletionLimit = 4176468490,
        BicycleVelocityToUseAnimatedJumpOff = 2218133629,
        BikeDrivebyFilterId = 3931552272,
        BikeEnterForce = 356015597,
        BikeEnterLeanAngleOvershootAmt = 1348653070,
        BikeEnterLeanAngleOvershootRate = 114247175,
        BikeExitForce = 3130040539,
        BikeHornClipId = 1786685138,
        BikeInAirDriveToStandUpTimeMax = 4108731380,
        BikeInAirDriveToStandUpTimeMin = 333974259,
        BikeInverseMassScales = 3619347977,
        BikeMaxRestoreDuration = 4019573548,
        BikeMinRestoreDuration = 1929662760,
        BikePickUpAlignBlendDuration = 3899294511,
        BikePitchSmoothingPassengerRate = 1515003340,
        BikePitchSmoothingRate = 4270612236,
        BikeVehicleMinPhaseToStartRotFixup = 4059105444,
        BikeVelocityToUseAnimatedJumpOff = 553575729,
        BirdHeightMapDeltaMax = 1961626874,
        BirdHeightMapDeltaMin = 597953858,
        BirdSpawnXYRangeMax = 2777866816,
        BirdSpawnXYRangeMin = 3368483780,
        Bitmap = 3540307690,
        BlanketForceScale = 4071693543,
        BlendDuration = 2387941002,
        BlendDurationForEarlyOut = 4197363947,
        BlendInDeltaForPed = 1293637123,
        BlendInDeltaForProp = 639648672,
        BlendInSpringConstant = 2111282409,
        BlendLevel = 42409501,
        BlendOut = 4265715862,
        BlendOutDelayBalanceFailed = 2382871963,
        BlendOutDelayStanding = 3295848876,
        BlendOutDuration = 1231407173,
        BlendOutPhase = 3550098093,
        BlendOutSpringConstant = 165735146,
        BlendOutThreshold = 124792981,
        BlendToIdleTime = 2500851482,
        BlendoutPhase = 160395732,
        BlindFireAnimStateNewInfos = 2740917805,
        BlindFireHighCoverMaxPitchLimit = 3950076744,
        BlindFireHighCoverMinPitchLimit = 1565596444,
        Block = 2210395489,
        BlockOffscreenShotReactions = 83217879,
        BlockingAreas = 20824415,
        BloomMax = 3093400296,
        BoatMaxAvoidanceAngle = 26476902,
        BoatTargetArriveDist = 3249924134,
        BodyWrithe = 1990395340,
        BoneRelativeAttachOffset = 2842669433,
        Bonus = 2733810571,
        BottomComponent = 2168296036,
        BottomSpread = 4172681798,
        Bound = 2111641000,
        BoundAnkles = 4148786995,
        Brake = 3493497994,
        BrakeControl = 2512256335,
        Braking = 3150145630,
        BrakingDifferenceForLinearVZMax = 4258663913,
        BrakingDifferenceForLinearVZMin = 3149009694,
        Bravery = 2511674669,
        BraveryTypes = 1481182292,
        BreakAttachmentMoveSpeedThreshold = 3465127340,
        BreakAttachmentOrientationThreshold = 365892591,
        BringVehicleToHaltDistance = 157002911,
        BuddyShot = 1747672916,
        BufferDistance = 2084497360,
        BumpedByCar = 19643947,
        BumpedByCarFriendly = 1912045929,
        BumpedByObject = 3428812559,
        BumpedByPed = 3386895833,
        BumpedByPedFriendly = 121419715,
        BumpedByPedIsQuadruped = 1002558306,
        BumpedByPedMinDotVel = 1234302495,
        BumpedByPedMinVel = 974350285,
        BumpedByPedRagdoll = 2004593632,
        BumpedByPlayerRagdoll = 1980284711,
        BumperOverlapForMaxSpeed = 3083236924,
        BumperOverlapForMinSpeed = 2926405391,
        BumperOverlapToBeInPosition = 1688870175,
        BuoyancySettings = 1991191506,
        BurnOutBlendInSpeed = 514772223,
        BurnOutBlendInTol = 4038428233,
        BurnOutBlendOutSpeed = 765288989,
        BurnOutClipId = 1402571365,
        BurstFireInitialSnapMult = 2148964650,
        CAMERA_METADATA_FILE = 2801332849,
        CAssassinsDispatch__Tunables = 3584713396,
        CCompEntityAnims = 1980345114,
        CCompEntityEffectsData = 3430328684,
        CCoverTuningFile = 3016688820,
        CCreditArray = 1998252412,
        CF_ALLOWED_COP_PURSUIT = 491616304,
        CF_JACKING = 2861521524,
        CFriendlyIssues = 754458458,
        CHINESE_SHUFFLING_CHECKS_FILE = 1244900227,
        CINEMATIC = 3839202812,
        COLLAR = 87075802,
        COMImpulseComponent = 3129842207,
        COMImpulseMaxRootVelocityMagnitude = 2681040368,
        COMImpulseOnlyWhileBalancing = 2187976068,
        COMImpulseScale = 3040120990,
        CONTENTS_DEBUG_ONLY = 2652598047,
        CONTENTS_MAX = 1137770612,
        CONTROLLER_LABELS_FILE = 1309368403,
        CONTROLLER_LABELS_FILE_360 = 648947982,
        CONTROLLER_LABELS_FILE_PS3 = 2127547113,
        CONTROLLER_LABELS_FILE_PS3_JPN = 2324879915,
        CPedPropInfo = 2858946626,
        CPedPropMetaData = 94549140,
        CPedSelectionSet = 253191135,
        CPedVariationInfo = 376833625,
        CPlantInfo = 1982133670,
        CPlayerSpecialAbilityManager = 2688740668,
        CPopulationGroup = 1530774378,
        CSlownessZoneManager = 3721180525,
        CTCCapsuleRadius = 3651490612,
        CTCClearanceCapsuleEndForwardOffset = 3077258891,
        CTCClearanceCapsuleEndZOffset = 2044226047,
        CTCClearanceCapsuleRadius = 837246042,
        CTCClearanceCapsuleStartForwardOffset = 4089643980,
        CTCClearanceCapsuleStartZOffset = 1328526529,
        CTCDepthDistanceCompletionOffset = 148125195,
        CTCForwardOffset = 3036685456,
        CTCHeightOffset = 1038229473,
        CTCMinDistance = 348835470,
        CTCProbeDepth = 3727526506,
        CTCSideOffset = 2512599606,
        CTCSpacingOffset = 4258697085,
        CTaskBirdLocomotion__Tunables = 1099459847,
        CTaskCuffed__Tunables = 918124422,
        CTaskInCustody__Tunables = 2117468048,
        CTuningFile = 2828759280,
        CVA_WHEEL_REAR_LEFT = 3148884390,
        Calculation = 3703855515,
        CamAttachPositionWeights = 1291841671,
        CamToCoverDirCosAngleTol = 588986036,
        CamToPedDirCosAngleTol = 1553721673,
        CameraDirToCoverMinDot = 4218123581,
        CameraLookAtBlendRate = 3198525203,
        CameraLookAtRotationLimit = 3701159057,
        CameraLookAtTurnRate = 3589690545,
        CameraRef = 1055059023,
        CameraRelativeSideOffset = 1032707911,
        CameraRelativeVerticalOffset = 1114870307,
        CameraSettings = 3095142060,
        CameraWeighting = 3990545757,
        Cameras = 1331283328,
        CanBePaused = 1966573275,
        CanCallPolice = 3833488932,
        CanStealCarsAtLights = 3908221492,
        CanStealParkedCars = 3993007617,
        CanStealPlayersVehicle = 3564233674,
        CanStealStationaryCars = 1365518895,
        CanUseForReactions = 2426586936,
        CapsuleHitForce = 883555571,
        CapsuleLengthForDetection = 322237759,
        CapsuleSettings = 2803013276,
        CapsuleVehicleHitTuning = 1834701470,
        CarSirenModifier = 3642651832,
        CatchFall = 4093402329,
        CatchFallHeightThresholdClipPose = 1581787136,
        CatchFallHeightThresholdRollUp = 2088499253,
        CatchFallHeightThresholdWindmill = 3140918872,
        CatchFallRelaxHeight = 4249251885,
        CatchUpHelperRef = 1443569911,
        CatchUpSpeed = 730064409,
        CausesRumbleWhenCollidesWithPlayer = 2821566375,
        CausesVehicleAvoidance = 1030055336,
        ChanceForGutShotKnockdown = 3055246492,
        ChanceOfFallToKneesAfterLastStand = 4015640822,
        ChanceOfFallToKneesOnCollapse = 3769959610,
        ChanceOfFilmingEventOnPhoneIfWatching = 4002374438,
        ChanceOfPedSeeingCarFromBehind = 315595788,
        ChanceOfWatchRatherThanHurryAway = 273885309,
        ChancePlayingCustomBackAwayAnimBigReact = 2458557466,
        ChancePlayingCustomBackAwayAnimSmallReact = 1713122871,
        ChancePlayingInitalTurnAnimBigReact = 551070027,
        ChancePlayingInitalTurnAnimSmallReact = 1757042582,
        ChanceToDeleteOnExitVehicle = 1276762529,
        ChancesForHesitate = 1095332633,
        ChancesForSwerve = 1825428191,
        ChancesToApplyReactionWhenShootingOutTire = 4058868243,
        ChancesToCallPolice = 2723841400,
        ChancesToDive = 3174431501,
        ChancesToFlipOff = 2395375846,
        ChancesToForceWaitInFront = 987604024,
        ChancesToHonk = 4171049765,
        ChancesToHonkHeldDown = 1871327732,
        ChancesToIntimidateArmedTarget = 2212321440,
        ChancesToIntimidateUnarmedTarget = 2214254758,
        ChancesToReactForGunAimedAt = 1942207582,
        ChancesWhenBuddyKilledWithScaryWeapon = 52194177,
        ChangeRatesForParachuting = 2700491627,
        ChangeRatesForSkydiving = 143335713,
        ChangeStationClipId = 2867244273,
        CharacterLight = 1142553590,
        ChargeTuning = 612012739,
        Chase = 2342544226,
        Cheat = 766857224,
        CheatPowerIncreaseForMatchSpeed = 3640126549,
        CheckForMovingGround = 2224677187,
        ChestForce = 2102302469,
        ChestForcePitch = 347021105,
        CinematicContexts = 1387858,
        CircleRotateAngleLookAhead = 2760165709,
        CircleTestRadii = 1409114490,
        CircleTestsMoveDistToTestNewPos = 3404462,
        CirclingAngularSpeed = 4190486872,
        CirclingMBR = 4203587509,
        ClampImpulse = 1180195582,
        ClavicleImpulseScale = 1905000551,
        ClearVehicleTimeMS = 4245738856,
        ClearZ = 2795607090,
        ClearedVehicle = 3612199348,
        ClimbAlignTolerance = 3652074424,
        ClimbingOrJumpingPedModifier = 2209113178,
        ClipId = 1300775131,
        ClipSetForCasual = 2787113182,
        ClipSetForIntro = 2755047550,
        ClipSetForRuns = 4017342285,
        ClippingAvoidance = 185739126,
        Clips = 3647518623,
        ClonePlayerBumpedByCarActivationModifier = 1036094636,
        ClonePlayerBumpedByCloneCarActivationModifier = 2745991583,
        CloseDistance = 2443685244,
        CloseDoorForceMultiplier = 2238708643,
        ClosePlayerDistanceThreshold = 2302698674,
        ClosePlayerModifier = 2278997613,
        ClosePlayerSpeedupDistanceSquaredThreshold = 2385841716,
        ClosePlayerSpeedupTimeThreshold = 1980022811,
        ClosePointCounterMax = 2874710517,
        ClosePointDistanceSquared = 2832422495,
        CloseSpawningViewMultiplier = 3846222437,
        ClosestPointToLineBonusModifier = 1432381156,
        ClosestPointToLineDist = 3770142196,
        CockGunWeaponClipId = 2737802101,
        Collision = 2519270732,
        CollisionFallBackPosition = 340312382,
        CollisionLosHeightOffset = 706571699,
        CollisionProbe = 961255660,
        CollisionRef = 3424608737,
        CollisionRootPositionFallBackToPivotBlendValue = 4279727627,
        CollisionRootPositionSpringConstant = 3507950586,
        CollisionRootPositionSpringDampingRatio = 3397058689,
        CollisionSettings = 3762874292,
        CollisionTestRadiusSpringConstant = 551575094,
        CollisionTestRadiusSpringDampingRatio = 1557769430,
        Colour = 3346932687,
        CombatAlignRate = 1557395660,
        CombatEntryBlendDuration = 2555911368,
        CombatLoitering = 3029474439,
        CombatOpenDoorClipId = 118829386,
        ComeBackInWhenAimDirectChangeInHighCover = 4276335920,
        CompletionRadius = 1468879986,
        Constant = 2414966970,
        Constraints = 1591913012,
        Contact = 3061072832,
        ContinuousContactTime = 1174887920,
        ContinuousGapHighFallTime = 1425777632,
        ControlDebugBeginAngle = 1147737070,
        ControlDebugEndAngle = 2904615002,
        ControlDebugRadius = 2886272257,
        ControlDebugXPos = 3419184861,
        ControlDebugYPos = 3872178927,
        ControlHelperRef = 2884954151,
        CopInVehicleVisualReactionRange = 2651939713,
        Cops = 1528396268,
        CoreAIMotionClipSetId = 2782502123,
        CoreMotionClipSetId = 2878139548,
        CoreWeaponClipSetId = 1024291853,
        CornerExitClips = 353989914,
        CornerExitHeadingModifier = 2292594697,
        CoverAimOffsetFromBlocked = 2495484427,
        CoverDirToCameraWeightMax = 302988723,
        CoverDirToCameraWeightMaxAimGun = 428630826,
        CoverDirToCameraWeightMaxScaleDist = 3645928265,
        CoverDirToCameraWeightMin = 2777705971,
        CoverEntryHeadingReachedTol = 647951209,
        CoverEntryMaxDirectDistance = 1608065887,
        CoverEntryMaxDistance = 1307601741,
        CoverEntryMaxDistanceAI = 3523536193,
        CoverEntryMinAngleToScale = 3426925695,
        CoverEntryMinDistance = 1391743069,
        CoverEntryMinDistanceAI = 4070109213,
        CoverEntryMinTimeNavigatingAI = 1162149057,
        CoverEntryPositionReachedTol = 1436746072,
        CoverEntryRateAI = 2901436256,
        CoverEntryRatePlayer = 443908416,
        CoverEntryShortDistanceAI = 14209833,
        CoverEntryShortDistancePlayer = 1607017826,
        CoverEntryStandDistance = 1011440787,
        CoverEntryStandStrafeDistance = 1748900014,
        CoverHeadingCloseEnough = 488807312,
        CoverHeadingCloseEnoughTurn = 52868234,
        CoverLeftFireModifier = 3014744113,
        CoverLeftFireModifierLow = 4019978349,
        CoverLeftIncreaseModifier = 314817266,
        CoverMaxDistance = 4142738100,
        CoverMinDistance = 417867439,
        CoverPoint = 2523520621,
        CoverPoints = 3053199956,
        CoverPositionCloseEnough = 2380669878,
        CoverResponseTimeout = 2346320415,
        CoverRightFireModifier = 3586592245,
        CoverRightFireModifierLow = 1508442808,
        CoverRightIncreaseModifier = 1620272884,
        CoverSettings = 3780197314,
        CoverStepClipSetId = 2450446524,
        CoverToCoverAngTol = 1570059814,
        CoverToCoverAnimStateInfos = 3577768695,
        CoverToCoverClipRate = 1687761193,
        CoverToCoverDistTol = 2125677956,
        CoverToCoverDuration = 462269180,
        CoverToCoverEdgeTestEndYOffset = 545166509,
        CoverToCoverEdgeTestStartYOffset = 2470298407,
        CoverToCoverMaxAccel = 3143775651,
        CoverToCoverMaxAngToStep = 446471957,
        CoverToCoverMaxDistToStep = 19390938,
        CoverToCoverMaxRotScalePhase = 372008448,
        CoverToCoverMaxScalePhase = 4228398614,
        CoverToCoverMinAng = 2651943117,
        CoverToCoverMinAngToScale = 3382987159,
        CoverToCoverMinDepthToScale = 1009232455,
        CoverToCoverMinDistToScale = 483457094,
        CoverToCoverMinRotScalePhase = 321218444,
        CoverToCoverMinScalePhase = 2919445883,
        CoverToCoverSmallAnimDist = 392526062,
        CoverWeightDistance = 3336702639,
        CoverWeightUsage = 3908973904,
        CoverWeightValue = 2465106291,
        CoveredInBloodPlayerModifier = 1573945112,
        CoweringForeverDeleteOffscreenTimeMS_MAX = 263563417,
        CoweringForeverDeleteOffscreenTimeMS_MIN = 1966243013,
        CrashLanding = 3151745571,
        CriminalVehicleMinStartSpeed = 4063126636,
        Criminality = 3808740257,
        CriminalityTypes = 1643851287,
        CrouchedLeftFireOffset = 3453306812,
        CrouchedOrLowCover = 3072964466,
        CrouchedRightFireOffset = 2533938546,
        CruiseDuckPrepLeftBikeClipId = 1163109918,
        CruiseDuckPrepLeftCharClipId = 733218,
        CruiseDuckPrepRightBikeClipId = 1089195126,
        CruiseDuckPrepRightCharClipId = 1933131499,
        CruisePedalCharClipId = 196702567,
        CruiseSpeed = 2895901568,
        CruiseSpeedForStrafe = 2482756980,
        CruiseSpeedMultiplierForBackOff = 3659936455,
        CruiseSpeedMultiplierForMaxBackOffDistance = 2134482011,
        CruiseSpeedMultiplierForMaxSlowdown = 2690108566,
        CruiseSpeedMultiplierForMinBackOffDistance = 3537928320,
        CruiseSpeedMultiplierForMinSlowdown = 2016261853,
        CruiseSpeedWhenClose = 587550606,
        CruiseSpeedWhenObstructedByLawEnforcementPed = 1914453083,
        CruiseSpeedWhenObstructedByLawEnforcementVehicle = 1604976859,
        Current = 2479092473,
        CurrentHeading = 413002367,
        CurveSets = 4116334946,
        CustomBoundingBoxSettings = 1022007033,
        CustomCollisionOriginRelativePosition = 4155454260,
        CustomOrbitDistanceLimitsToForce = 1828892401,
        CustomSettings = 2827051945,
        CutsceneBlendSpringConstant = 777008740,
        CutsceneBlendSpringDampingRatio = 2366444870,
        CycleTargetAngularLimit = 1394170274,
        CycleTargetAngularLimitMelee = 3789965859,
        DEFAULT_TASK_DATA_FILE = 2701401283,
        DEFORMABLE_OBJECTS_FILE = 3996479808,
        DEVINS_SNOWLIGHT = 1635759186,
        DISABLE_FILE = 3897970480,
        DISPATCH_DATA_FILE = 1977530558,
        DRIVER_RULES_STD_FILE = 4292163424,
        DSP_AERIAL = 3148113674,
        DSP_AQUATIC = 1563097128,
        DSP_GROUND_WILDLIFE = 2099691605,
        DamageMotionBlurDuration = 304164673,
        DamageMotionBlurMaxDamage = 938189370,
        DamageMotionBlurMaxStrength = 1317618698,
        DamageMotionBlurMinDamage = 3242284698,
        DampenRootTargetHeight = 1671878115,
        DampenRootTargetWeight = 794209155,
        DampeningForce = 1129875775,
        Dead = 2865917470,
        DeadFallOutClipId = 1583960251,
        DeadZoneAnyInputDirection = 1699227528,
        DeadZoneStickNorm = 3681430863,
        DebugDisplayAlwaysUseEventPosition = 387027865,
        DebugDisplayListPlayerInfo = 1307368391,
        DebugDraw = 2418474749,
        DebugLockOnTargets = 3853036348,
        DebugSwapInstantly = 2950978586,
        DebugTargetting = 4090546975,
        Decay = 398571259,
        DecayDuration = 1826449020,
        DecayRate = 1564203967,
        Deceleration = 1627413096,
        DeepWaterThreshold = 3940110369,
        DefaultAlignEndFixupPhase = 1305634921,
        DefaultAlignRate = 2555216789,
        DefaultAlignStartFixupPhase = 717764835,
        DefaultAmnestyTime = 1730819989,
        DefaultBackwardsProjectionRange = 4112548279,
        DefaultBeJackedAlivePedFromOutsideClipId = 3819225408,
        DefaultBeJackedAlivePedFromWaterClipId = 3745870995,
        DefaultBeJackedAlivePedOnVehicleClipId = 2307365987,
        DefaultBeJackedAlivePedOnVehicleIntoWaterClipId = 2347965860,
        DefaultBeJackedDeadPedFromOutsideClipId = 2626413479,
        DefaultBeJackedDeadPedFromWaterClipId = 542641977,
        DefaultBeJackedDeadPedOnVehicleClipId = 988275496,
        DefaultBeJackedDeadPedOnVehicleIntoWaterClipId = 824689766,
        DefaultChanceOfStandingWhileMoving = 3714303368,
        DefaultClimbDownClipId = 2758806077,
        DefaultClimbDownNoDoorClipId = 374589004,
        DefaultClimbUpClipId = 2993991731,
        DefaultClimbUpNoDoorClipId = 4167965920,
        DefaultCloseDoorEndIkPhase = 932416743,
        DefaultCloseDoorEndPhase = 444144670,
        DefaultCloseDoorStartIkPhase = 3092993621,
        DefaultCloseDoorStartPhase = 2181733270,
        DefaultCrashExitOnSideClipId = 828622422,
        DefaultCrouchingPose = 607364341,
        DefaultDistanceFromWorldCenter = 2251904831,
        DefaultEdgeTurnBlendDuration = 3203547922,
        DefaultFleeExitClipId = 1085529957,
        DefaultForcedEntryClipId = 4187378175,
        DefaultFov = 1391977192,
        DefaultGetInClipId = 1776336338,
        DefaultGetOutBlendDuration = 3739360652,
        DefaultGetOutClipId = 1983795837,
        DefaultGetOutNoWindBlendDuration = 2470385571,
        DefaultGetOutNoWingId = 90808597,
        DefaultGetOutOnToVehicleClipId = 2498096438,
        DefaultGetOutToWaterClipId = 4109561514,
        DefaultHiddenEvasionTimeReduction = 115496620,
        DefaultImpactBikeClipId = 2443433960,
        DefaultImpactCharClipId = 628124008,
        DefaultInverseMassScales = 1575645985,
        DefaultJackAlivePedFromOutsideClipId = 2624279103,
        DefaultJackAlivePedFromWaterClipId = 2379662115,
        DefaultJackDeadPedFromOnVehicleClipId = 1982208210,
        DefaultJackDeadPedFromOutsideClipId = 1755247816,
        DefaultJackDeadPedFromWaterClipId = 2061479056,
        DefaultJackDeadPedOnVehicleIntoWaterClipId = 3508843174,
        DefaultJackPedFromOnVehicleClipId = 807201844,
        DefaultJackPedOnVehicleIntoWaterClipId = 1866652328,
        DefaultJackRate = 4256000061,
        DefaultJumpOutClipId = 1640661523,
        DefaultKillShotImpulseMult = 1035940220,
        DefaultLookAtThreshold = 2539614217,
        DefaultMPKillShotImpulseMult = 3207843175,
        DefaultMPRapidFireKillShotImpulseMult = 3825480237,
        DefaultMaxRotationScalingValue = 3714157750,
        DefaultMaxTranslationScalingValue = 589616650,
        DefaultMeleeRange = 318279589,
        DefaultMinRotationScalingValue = 273784445,
        DefaultMinTranslationScalingValue = 4071659392,
        DefaultOpenDoorClipId = 757048139,
        DefaultOpenDoorEndIkPhase = 2631224923,
        DefaultOpenDoorEndPhase = 1506371742,
        DefaultOpenDoorRate = 350729378,
        DefaultOpenDoorStartIkPhase = 2878218804,
        DefaultOpenDoorStartPhase = 462320915,
        DefaultPedalToFreewheelBlendDuration = 811691519,
        DefaultPitch = 2266995505,
        DefaultPitchSmoothingRate = 3114188164,
        DefaultPlayerStandEntryEndMovementPhase = 2445300354,
        DefaultPlayerStandEntryStartMovementPhase = 2787336412,
        DefaultProbeOffset = 4100289588,
        DefaultRapidFireKillShotImpulseMult = 2071204131,
        DefaultRelativePitch = 551950644,
        DefaultReversePitch = 1670344535,
        DefaultSettleBlendDuration = 2855575670,
        DefaultSitToStandBlendDuration = 2455313637,
        DefaultSmallImpactBikeClipId = 2298295044,
        DefaultSmallImpactCharClipId = 2966685819,
        DefaultStandingPose = 836857486,
        DefaultStillToTurnBlendDuration = 1307353498,
        DefaultTargetAimPitchMax = 3414965475,
        DefaultTargetAimPitchMin = 3751177723,
        DefaultTargetAngularLimit = 361676600,
        DefaultTargetAngularLimitClose = 3274621266,
        DefaultTargetAngularLimitCloseDistMax = 2015184340,
        DefaultTargetAngularLimitCloseDistMin = 2598900761,
        DefaultTargetAngularLimitMelee = 3817163838,
        DefaultTargetAngularLimitMeleeLockOnNoStick = 2076997846,
        DefaultTargetAngularLimitVehicleWeapon = 2675889779,
        DefaultTargetDistanceWeightMelee = 908567944,
        DefaultTargetDistanceWeightMeleeRunning = 118717170,
        DefaultTargetHeadingWeightMelee = 3338545377,
        DefaultTargetHeadingWeightMeleeRunning = 3833299605,
        DefaultTimeBetweenIdles = 1544265672,
        DefaultTryLockedDoorClipId = 2087055883,
        DefaultWeaponLoadout = 2744215759,
        Delay = 4112497335,
        DelayBetweenPavementFloodFillSearches = 4087190680,
        DelayTimeWhenOutOfAmmoInScope = 3684533695,
        DeleteOffscreenTimeMS_MAX = 2066926080,
        DeleteOffscreenTimeMS_MIN = 2782271258,
        DeltaForMaxStickChange = 2339537570,
        DeltaScaleWhenPlayerStationary = 397262754,
        DeltaTolerance = 2032147920,
        Deploy = 325816429,
        DepthForLandProbe = 1901477334,
        DesiredDirToCoverAimingWeight = 1242729948,
        DesiredDirToCoverMinDot = 3768160914,
        DesiredDirToCoverWeight = 2932059417,
        DesiredDistanceToCover = 1551121369,
        DesiredDistanceToCoverToRequestStep = 2359940104,
        DesiredLeanAngleRate = 4138940297,
        DesiredLeanAngleRateQuad = 2940067495,
        DesiredLeanAngleTolToBringLegIn = 1030667828,
        DesiredOvershootLeanAngle = 2868091491,
        DesiredPitch = 2095341670,
        DesiredSpeedToBringLegIn = 3420225248,
        DesiredTimeToResolveAngleDifference = 2923527027,
        Despawning = 1606361377,
        DetachExitDefaultPhaseThreshold = 1532444703,
        DetectionRadius = 4278404079,
        Difficulty = 1654675133,
        DirectorList = 1163993726,
        DisableAiCoverEntryStreamCheck = 2504995190,
        DisableBikeHandleArmIk = 1131247892,
        DisableBikePickPullUpOffsetScale = 454797365,
        DisableCloseDoor = 4046635601,
        DisableCoverToCoverRotationScaling = 1227928250,
        DisableCoverToCoverTranslationScaling = 2876044804,
        DisableDoorHandleArmIk = 4238205678,
        DisableInjuredBehaviorDistLimit = 868220978,
        DisableInjuredBehaviorImpulseLimit = 1833631034,
        DisableIntroOverShootCheck = 3598945794,
        DisableIntroScaling = 1465904835,
        DisableJumpOnSteepStairs = 1258832245,
        DisableMoverFixups = 1336261201,
        DisableOutroOverShootCheck = 2745801756,
        DisableOutroScaling = 1212343445,
        DisableReachForWoundOnHeadShot = 390630339,
        DisableReachForWoundOnHeadShotMaxDelay = 702711221,
        DisableReachForWoundOnHeadShotMinDelay = 3271496489,
        DisableReachForWoundOnNeckShot = 249145917,
        DisableReachForWoundOnNeckShotMaxDelay = 266530001,
        DisableReachForWoundOnNeckShotMinDelay = 3192396779,
        DisableRotationOvershoot = 3253125136,
        DisableRotationOvershootCheck = 3699526709,
        DisableRotationScaling = 800236883,
        DisableSeatBoneArmIk = 2336701139,
        DisableStartMessageForSprintExhausted = 3533734703,
        DisableStreamedVehicleAnimRequestHelper = 3950304880,
        DisableTagSyncIntoAlign = 609083866,
        DisableTimeslicingHeadingThresholdD = 484878979,
        DisableTranslationOvershoot = 2434177980,
        DisableTranslationOvershootCheck = 2679767269,
        DisableTranslationScaling = 3134002215,
        DisableVaultForwardDot = 1893591066,
        DisableVehicleDependencies = 1599003681,
        DisableWeaponBlocking = 800840705,
        DisableWhenOffMission = 746028494,
        DisallowGroundProbeVelocity = 7853624,
        DispatchNode = 3360212191,
        DisplacementScaleApproachRateIn = 2671402641,
        DisplacementScaleApproachRateOut = 3023759131,
        Display = 2360416497,
        DisplayAimAssistCurves = 216413736,
        DisplayAimAssistIntersections = 2995853681,
        DisplayFreeAimTargetDebug = 315412703,
        DisplayLockOnAngularRanges = 951183830,
        DisplayLockOnDistRanges = 208459187,
        DisplayRemovedGroups = 1828214902,
        DisplaySoftLockDebug = 1909407402,
        DistConsideredAtAimPosition = 2297046941,
        DistFromCoverToAllowReloadCache = 3441446008,
        DistSquaredThresholdAtCrowdRoundPos = 3622532239,
        DistSquaredThresholdMovingToCrowdRoundPos = 3859213332,
        DistToCoverWeight = 2279531977,
        DistToCoverWeightNoStickBonus = 2996089454,
        DistToCoverWeightThreat = 3255589803,
        DistToEntryToAllowForcedActionMode = 1493908582,
        DistToUseShortestRotation = 3490225320,
        DistVicinityOfCrowd = 803081093,
        DistanceBetweenAiPedsCoverAndPlayersCover = 2013288531,
        DistanceForCarChaseShockingEvents = 1719190513,
        DistanceForFull = 3884700100,
        DistanceForMaxTimeBeforeNewPose = 858243059,
        DistanceForMinTimeBeforeNewPose = 3601324404,
        DistanceForStraightLineModeAlways = 2986369414,
        DistanceForStraightLineModeIfLos = 1150609584,
        DistanceLimits = 335839296,
        DistanceToCapSpeed = 3093267843,
        DistanceToEvaluateDoors = 3475018274,
        DistanceToFollowInCar = 3856148267,
        DistanceToFollowVehicleBeforeFlee = 459862259,
        DistanceToRunToVehicle = 1289358659,
        DistanceToSignalVehiclePursuitToCriminal = 783802328,
        DistanceToStart = 64309451,
        DistanceToStartCappingSpeed = 3739118103,
        DistanceToStopMassIdeal = 3823614053,
        DistanceToStopMassWeight = 979399865,
        DistanceToStopMultiplier = 2798838940,
        DistanceToTerminate = 1737497458,
        DistanceToTestDownForVehiclesToReject = 3416628233,
        DistanceToUseGunfireReactAndFleeAnimations = 2597491379,
        DistanceToWallCoverToCover = 1318415761,
        DistanceToWallCrouching = 575575803,
        DistanceToWallStanding = 2650603299,
        DistanceWeighting = 1241525786,
        DistanceWeightingNoStick = 1793159754,
        DistanceXYToUseHeightMapAvoidance = 1504259891,
        DistanceZThresholdForHighHighFall = 4004286054,
        DiveControlExtraDistanceBlendOutSpeed = 4164582757,
        DiveControlExtraDistanceForDiveFromVehicle = 145933303,
        DiveControlMaxFallDistance = 3177202947,
        DiveDepth = 639055889,
        DiveMBR = 3392297418,
        DiveProjectionDistance = 3492375078,
        DiveRampPow = 3048005225,
        DiveWaterOffsetToHitFullyInControlWeight = 2538011040,
        DoAynchronousProbesWhenFindingFreeAimAssistTarget = 2930848614,
        DoCatchFallRelax = 2414092533,
        DoFinalHeadingFixUp = 3946058806,
        DoInitialHeadingBlend = 311045516,
        DoPostCameraClipUpdateForPlayer = 2949921986,
        DofSettings = 3044898952,
        DofSettingsForMobilePhoneShallowDofMode = 1057367158,
        DofSettingsInTightSpace = 2814402846,
        DontRemoveReticuleDuringBlindFireNew = 4136330299,
        DoorAlignmentSettings = 3950418303,
        DoorRatioToConsiderDoorClosed = 3341844967,
        DoorRatioToConsiderDoorOpen = 2420294542,
        DoorRatioToConsiderDoorOpenCombat = 3006117682,
        DoorRatioToConsiderDoorOpenSteps = 2541408088,
        DotProductBehind = 1100440084,
        DotProductFacing = 2732547664,
        DotThresholdForCenterEnter = 762985941,
        DotToClampSpeedToMaximum = 2850579408,
        DotToClampSpeedToMinimum = 628879039,
        DownHillImpactBikeClipId = 450274249,
        DownHillImpactCharClipId = 4170136432,
        DownHillInAirFreeWheelBikeClipId = 4163976723,
        DownHillInAirFreeWheelCharClipId = 2221169411,
        DownHillMinPitchToStandUp = 1599024557,
        DownHillSmallImpactBikeClipId = 896939326,
        DownHillSmallImpactCharClipId = 2199245470,
        DownStairsPelvisMaxDeltaZMoving = 2173480721,
        DownStairsPelvisMaxNegativeDeltaZMoving = 1295091688,
        DownedThreatModifier = 521885682,
        DownwardSpeedLimits = 1575008605,
        DraggerArmIk = 989307764,
        DrawDebug = 2958876793,
        DrawableAltId = 3029420796,
        DrawableIds = 4176789291,
        DriftX = 1925470428,
        DriftY = 4083276309,
        DriftZ = 422585777,
        DriveToGetup = 1589180219,
        DrivingAbilityMax = 866268907,
        DrivingAbilityMin = 1569329370,
        DrivingAggressivenessMax = 534710722,
        DrivingAggressivenessMin = 1151027181,
        Drop = 2901180925,
        DropDistance = 529669607,
        DropDuration = 1445694321,
        DropForRunway = 3113590399,
        DuckAndCoverCanTriggerForPlayerTime = 760739523,
        DuckUnderOverheadCollisionSettings = 2946100032,
        DuplicateDistanceCheck = 735659884,
        DuplicateTimeCheck = 1621558076,
        DurationHeldDownEnterButtonToJackFriendly = 2689559592,
        DurationRampDownCapsulePushedByVehicle = 4163982628,
        DynamicSet1 = 2970224816,
        DynamicSet2 = 3261705071,
        DynamicSet3 = 3903387629,
        ET_AGGRESSIVE_DRIVER = 2353748938,
        ET_AMBIENT_COP = 1795127718,
        ET_COP_PURSUIT = 1484258773,
        ET_CRIME = 1610395939,
        ET_INTERESTING_DRIVER = 2215450775,
        ET_INVALID = 1195757242,
        ET_JAYWALKING = 2126457811,
        ET_SPAWNED_COP_PURSUIT = 1150557519,
        EVENTS_OVERRIDE_FILE = 350410266,
        EVehicleModelColorMetallic_1 = 969376721,
        EVehicleModelColorMetallic_2 = 731244402,
        EVehicleModelColorMetallic_3 = 3537679873,
        EVehicleModelColorMetallic_4 = 3183119293,
        EVehicleModelColorMetallic_5 = 4039766491,
        EVehicleModelColorMetallic_6 = 3777516184,
        EVehicleModelColorMetallic_7 = 229878718,
        EVehicleModelColorMetallic_8 = 4285337393,
        EVehicleModelColorMetallic_9 = 847803751,
        EVehicleModelColorMetallic_normal = 815563434,
        EXPRESSION_SETS_FILE = 3354018708,
        EXTRAMAP_CONVERSION_OCC_FILE = 1691493964,
        EaseIn = 2993575128,
        EaseOut = 4042229056,
        EasyTargettingDifficultyInfo = 1097471232,
        EdgeCapsuleRadius = 3106353871,
        EdgeCoverWeight = 3910547157,
        EdgeEndXOffset = 1400174762,
        EdgeEndYOffset = 1982386380,
        EdgeHighZOffset = 919529730,
        EdgeLowCoverMoveTime = 205550242,
        EdgeLowZOffset = 3480207128,
        EdgeMaximumOffsetDiff = 3256121602,
        EdgeMinimumOffsetDiff = 3457829957,
        EdgeStartXOffset = 3356016298,
        EdgeStartYOffset = 2250358383,
        EdgeTurnAnimStateInfos = 896061089,
        EdgeWeighting = 1511298321,
        Electrocute = 3856838428,
        EnableActivationsFromCapsuleImpacts = 3247587106,
        EnableAimDirectlyIntros = 4050756282,
        EnableBikePickUpAlign = 2377829258,
        EnableBulletBending = 1473266781,
        EnableCloseDoorHandIk = 734813238,
        EnableConflictingNormalCollisionRemoval = 3464583782,
        EnableCoverIdleVariations = 288573626,
        EnableCoverPeekingVariations = 3781531198,
        EnableCoverPinnedVariations = 2498623969,
        EnableCoverToCover = 1136710348,
        EnableFootTagSyncing = 2493304798,
        EnableForcedFireForTargetProximity = 4012970274,
        EnableIkForAI = 138117989,
        EnableInitialHeadingBlend = 914424597,
        EnableJackRateOverride = 583417184,
        EnableLeftHandIkInCover = 2828343094,
        EnableNewAICoverEntry = 661599637,
        EnableNewBikeEntry = 3299231528,
        EnableOpenDoorHandIk = 2861302055,
        EnableRagdollPooling = 325894988,
        EnableRagdollPoolingMp = 503115024,
        EnableReloadingWhilstMovingInCover = 3367723943,
        EnableRotationScaling = 3088085048,
        EnableSideSwipeActivations = 2716995625,
        EnableStreamedEntryAnims = 3726126567,
        EnableStreamedEntryVariationAnims = 2305444416,
        EnableStreamedInVehicleAnims = 774087018,
        EnableTranslationScaling = 1466859809,
        EnableUseSwatClipSet = 3380579615,
        EnableWalkStops = 2560019435,
        EnclosedSearchRegions = 937610588,
        EndHeadingTolerance = 2243016084,
        EndStuckOnVehicle = 3136215640,
        EndStuckOnVehiclePlayer = 2353506762,
        EndStuckUnderVehicle = 2222643548,
        EndStuckUnderVehiclePlayer = 3275734390,
        EnemyAccuracyScaling = 3589303034,
        EnemyCharging = 2545446674,
        EnergyLostPerSecond = 3136810971,
        EnterClipId = 517541874,
        EnterCoverAIAimingBase1H = 1405654072,
        EnterCoverAIAimingBase2H = 2519142628,
        EnterCoverAIAimingSwat1H = 4262460027,
        EnterCoverAIAimingSwat2H = 2653796808,
        EnterCoverAITransition1H = 1017470219,
        EnterCoverAITransition2H = 1163390260,
        EnterCoverAimInterruptDistanceTolerance = 3320233516,
        EnterCoverAimInterruptHeadingTolerance = 2304671979,
        EnterCoverInterruptDistanceTolerance = 1874728809,
        EnterCoverInterruptHeadingTolerance = 3084434327,
        EnterCoverInterruptMinTime = 3889498778,
        EntryPointSets = 769744308,
        EnvelopeRef = 1811750171,
        EqualizeAmount = 4026600462,
        EquipBestWeapon = 962329419,
        ErrorThreshold = 305674207,
        EvaluateThreatFromCoverPoints = 4040000084,
        EvasionThreshold = 2708798326,
        EventDecayTimeMS = 2722629246,
        EventInitInterval = 3561980965,
        EventInterval = 95033849,
        EventlessSwitchDistanceRequirement = 3437799044,
        EventlessSwitchInactivityTimeRequirement = 1865528825,
        EventlessSwitchStateTimeRequirement = 619528635,
        ExactStopTargetRadius = 2433763429,
        ExcludePedBumpAngleFromPushCalculation = 4060868299,
        ExitAttachmentMoveSpeedThreshold = 788433631,
        ExitClipId = 2518432971,
        ExitCornerDirOffset = 498927550,
        ExitCornerYOffset = 1366592047,
        ExitCornerZOffset = 3182801896,
        ExitCoverBaseClipSetId = 150770804,
        ExitCoverExtraClipSetId = 395871171,
        ExitDistance = 3093573752,
        ExitProbeDistance = 4256472352,
        ExitToAimClipSets = 3606683380,
        ExitToAimClipsName = 1926032835,
        ExitToAimVehicleInfos = 2503125343,
        ExitVehicleAttempToFireBlendOutDuration = 95286584,
        ExitVehicleBlendInDuration = 3090579301,
        ExitVehicleBlendOutDuration = 3420274436,
        ExitVehicleMaxDistance = 2200934401,
        ExitVehicleRouteMinDistance = 1946412733,
        ExitVehicleUnderWaterBlendOutDuration = 873885486,
        ExplosiveDamageMod = 2530332272,
        ExposurePush = 2577299971,
        ExtendedDistanceFromWorldCenter = 769039659,
        Extension = 207195018,
        ExtraCameraRelativeVerticalOffset = 2401664616,
        ExtraDistForGoto = 2347754539,
        ExtraDistanceToPushAway = 3893627623,
        ExtraFleeDistance = 695930878,
        ExtraForces = 1349337627,
        ExtraHeadingRate = 1444953847,
        ExtraHeightForGround = 4011421405,
        ExtraOffsetForGroundCheck = 1326750951,
        ExtraOrbitPitchOffsetForHighAngleMode = 4048007163,
        ExtraOrbitPitchOffsetForThirdPersonFarViewMode = 2477951883,
        ExtraSideOffsetForHangingOnLeftSide = 2610056728,
        ExtraSideOffsetForHangingOnRightSide = 843687785,
        ExtraToleranceForStopWatchDistance = 3333208061,
        ExtraTorqueTwistMax = 1612043114,
        ExtraWaterZGroundFixup = 207811054,
        FCT_HALF_SIGMOID = 3916722287,
        FCT_LINEAR = 2803657832,
        FCT_NONE = 383539244,
        FCT_SIGMOID = 157616235,
        FIRINGPATTERNS_FILE = 3015019398,
        FIRST_PERSON = 70078021,
        FRONTEND_DAT_FILE = 2221411686,
        FRONTEND_MENU_FILE = 1803244175,
        FXStack = 1829495763,
        FakeLungeOffset = 614448068,
        FallLandThreshold = 2788362157,
        FallOffAMovingCar = 1639523711,
        FallTestAngleBlendOutTime = 1882364948,
        FallTimeBeforeHighFallAbort = 2093200171,
        FallToKnees = 1740552960,
        FallingSpeedForHighFall = 3699124688,
        FallsOutofVehicleVelocity = 2846727445,
        FastAlignRate = 2551900503,
        FastApproachRate = 2363497120,
        FastDuckPrepLeftBikeClipId = 2693600057,
        FastDuckPrepLeftCharClipId = 1151736662,
        FastDuckPrepRightBikeClipId = 4229390137,
        FastDuckPrepRightCharClipId = 4061011008,
        FastEnterExitRate = 1506926002,
        FastExitDefaultPhaseThreshold = 2055075186,
        FastMinTurnApproachRate = 892232162,
        FastMovingPedSpeed = 1615867498,
        FastRunRateMax = 684879272,
        FastRunRateMin = 2165656152,
        FastTurnAcceleration = 305608474,
        FastTurnApproachRate = 1148310117,
        FastWalkRateMax = 806948898,
        FastWalkRateMin = 1182689916,
        FatallyInjured = 62148721,
        FeetLiftForce = 1163046056,
        FightingModifier = 2538889403,
        FinalShotImpulseClampMax = 1454653034,
        FindPropInEnvironmentDist = 1136341997,
        FindSpawnPointInDirection = 3455230182,
        FineAimBlendSpringConstant = 4207333442,
        FineAimBlendSpringDampingRatio = 1717370547,
        FineAimDownwardsVerticalMovement = 3411810706,
        FineAimHorSpeedMax = 1036145679,
        FineAimHorSpeedMin = 2633888729,
        FineAimHorSpeedPower = 2444069349,
        FineAimHorWeightSpeedMultiplier = 2407796767,
        FineAimSidewaysScale = 2012228463,
        FineAimSpeedMultiplier = 3282516112,
        FineAimSpeedMultiplierClose = 2679873658,
        FineAimSpeedMultiplierCloseDistMax = 286043552,
        FineAimSpeedMultiplierCloseDistMin = 767482079,
        FineAimVerSpeed = 2689623744,
        FineAimVerticalMovement = 1940999374,
        FireTimeAfterChaseOnFoot = 1325474651,
        FireTimeAfterStaticMovementAbort = 1579430656,
        FireTimeAfterStoppingMoveToCover = 475196801,
        FishOutOfWaterDelay = 3728756551,
        FixieSkidLeftBikeClip0Id = 3950475012,
        FixieSkidLeftBikeClip1Id = 874968111,
        FixieSkidLeftCharClip0Id = 1543557460,
        FixieSkidLeftCharClip1Id = 323139173,
        FixieSkidRightBikeClip0Id = 1348669466,
        FixieSkidRightBikeClip1Id = 2864920648,
        FixieSkidRightCharClip0Id = 2616623374,
        FixieSkidRightCharClip1Id = 3652939154,
        FixieSkidToBalanceLeftBikeClip1Id = 2138292255,
        FixieSkidToBalanceLeftCharClip1Id = 2365139646,
        FixieSkidToBalanceRightBikeClip1Id = 1620728723,
        FixieSkidToBalanceRightCharClip1Id = 963408802,
        FleeDistance = 191817975,
        FleeDuringCombat = 1811637113,
        FleeExitExtraRotationSpeed = 4193052421,
        FleeExitExtraTranslationSpeed = 4180330400,
        FleeExitVehicleBlendOutDuration = 2378492841,
        FleeIfApproachedByOtherEntity = 1542742362,
        FleeIfApproachedBySourceEntity = 2924272020,
        FleeMBR = 1024232437,
        FleeMBRMax = 1178169613,
        FleeMBRMin = 1822017225,
        FleeOffset = 335985570,
        FleeReactions = 603736164,
        FleeSafeDistance = 846083482,
        FleeSpeedInVehicle = 1520777858,
        FleeTargetTooCloseDistance = 882826582,
        FlightAngleLimitsForParachutingBraking = 2890662262,
        FlightAngleLimitsForParachutingNormal = 960147082,
        FlightAngleLimitsForSkydiving = 4264481693,
        FlightHeightAboveTarget = 2016619356,
        Flinch = 764802101,
        FlinchDecayTime = 1944104863,
        FlipForce = 3224113269,
        FocusParentToTargetBlendLevel = 2840529796,
        FollowOffset = 3967034351,
        FollowOrientationConing = 70382085,
        FollowPedLookAtBoneTag = 389542769,
        FollowRadius = 353087997,
        FollowTimeout = 2187967175,
        FollowYOffset = 1895961621,
        FollowZOffset = 647976226,
        FootInterp = 1745248481,
        FootInterpIntersecting = 1545915544,
        FootInterpIntersectingMoving = 3264564387,
        FootInterpMoving = 1979344219,
        FootInterpOnDynamic = 67151581,
        ForceAtMaxVelocity = 2377779348,
        ForceAtMinVelocity = 1864398785,
        ForceCower = 4045684189,
        ForceCrime = 1727634143,
        ForceLowCornerEastFaceNorth = 2740301581,
        ForceLowCornerEastFaceSouth = 1105971590,
        ForceLowCornerNorthFaceEast = 1675103884,
        ForceLowCornerNorthFaceWest = 2231393111,
        ForceLowCornerSouthFaceEast = 1921771349,
        ForceLowCornerSouthFaceWest = 1507251800,
        ForceLowCornerWestFaceNorth = 4153767546,
        ForceLowCornerWestFaceSouth = 3854489506,
        ForceMPAnimRatesInSP = 2345403785,
        ForceMag = 3327649992,
        ForceNewMessage = 3330375348,
        ForceNoTimeslicingHeadingDiff = 810486897,
        ForceOverVehicle = 599992998,
        ForcePinnedDown = 5986942,
        ForceRollUp = 1703031604,
        ForceRunDelayTime = 111777931,
        ForceStandEnterOnly = 1408347563,
        ForceStreamingFailure = 2569732609,
        ForceToApply = 71889384,
        ForceToTarget = 243919456,
        ForceUnderVehicle = 2074671276,
        ForceUpdatesWhenTurningStartThresholdRadians = 3756162272,
        ForceUpdatesWhenTurningStopThresholdRadians = 1213035272,
        ForceWindmill = 3831760128,
        ForcedDoorHandleArmIk = 2101205108,
        ForcedLegUpVelocity = 2821506258,
        Forces = 3184237865,
        ForcesForSkydiving = 590082074,
        ForwardAcceleration = 32744136,
        ForwardDirectionThresholdCosSquared = 745911052,
        ForwardDistToStartSideScale = 3395179822,
        FovAcceleration = 1137737707,
        FovLimits = 4288186671,
        FovScalar = 680981764,
        FrameComponents = 2102911583,
        FramesToLookAheadForProbe = 1260903928,
        FreefallThresold = 2222926220,
        Frequency = 2554379728,
        FrequencyNoise = 1511368071,
        FromCarHit = 1362978742,
        FromCoverExitDistance = 2504179355,
        FromOnFootAccelerationMod = 2358855400,
        FromStrafeAccelerationMod = 971520507,
        FromStrafe_MovingBlendOutTime = 1926561545,
        FromStrafe_WeightRate = 2545261234,
        FromValue = 3814756382,
        FromWantedLevel = 1358049181,
        FutureDistanceForMaxSteerAngle = 1786731261,
        FutureDistanceForMinSteerAngle = 2361783730,
        GangScenarioPedToPlayerModifier = 2883008619,
        GetInCombatClipId = 427276467,
        GetInFromWaterClipId = 2521753678,
        GetInRate = 1556614668,
        GetInStandOnClipId = 2593531090,
        GetOnQuickClipId = 923017874,
        GlobalLateralTorsoOffsetInLeftCover = 3909527233,
        GotoWatchRange = 2651403585,
        GravityScale = 1393168468,
        GroundFixupHeight = 4272192282,
        GroundFixupHeightBoatInWater = 667507334,
        GroundFixupHeightBoatInWaterInitial = 93138639,
        GroundFixupHeightLarge = 1434272564,
        GroundFixupHeightLargeOffset = 3416772737,
        GroundMaterialProbeDepth = 883567309,
        GroundMaterialProbeOffset = 2995052029,
        GroundMaterialSpawnCoordNormalZTolerance = 1328674939,
        GroupId = 1405734818,
        GroupMemberSlowDownDistance = 2525435888,
        GroupMemberWaitDistance = 4219594699,
        GroupMemberWaitMinTime = 2050658669,
        GroupMemberWalkCloseDistance = 3760186281,
        GuardWorldExtents = 1651229959,
        GunShotThresholdDistance = 3483089763,
        HBC_Randomize = 2066966848,
        HBC_Retain = 1409024016,
        HELI = 3778816900,
        HORSE_REINS_FILE = 1866311889,
        HUD_TXD_FILE = 1987285695,
        HandBrakeControl = 1151983218,
        HandBrakeInputEnvelopeRef = 73888528,
        HandBrakeSwingSettings = 3703185618,
        HandGunDamageMod = 1873521687,
        HandcuffedClipSetId = 1015537615,
        HangingAroundVehicleModifier = 420424724,
        HasCreateWeaponTag = 3631567393,
        HasInterruptTag = 1944180374,
        HasSixDirections = 3697908634,
        HasStickInputThreshold = 2573017241,
        HashOrdering = 3243012891,
        Hashes = 2753590613,
        HeadAndNeck = 3404836153,
        HeadLook = 3103279089,
        HeadShot = 800099441,
        HeadShotImpulseMultiplier = 3053385153,
        HeadShotMPImpulseMultiplier = 1084989136,
        HeadingAcceleration = 426969157,
        HeadingChangeRate = 2653769818,
        HeadingCorrection = 472852554,
        HeadingDelta = 2891994847,
        HeadingDiffStartBlendDegrees = 1440906110,
        HeadingOffset = 2344149746,
        HeadingPullAroundErrorScalingBlendLevel = 1199102981,
        HeadingPullAroundMaxMoveSpeed = 3319639913,
        HeadingPullAroundMinMoveSpeed = 3078528158,
        HeadingPullAroundSpeedAtMaxMoveSpeed = 1466199679,
        HeadingPullAroundSpringConstant = 1332565251,
        HeadingPullAroundSpringDampingRatio = 4054409124,
        HeadingReachedTolerance = 452418176,
        HeadingScoreForCoverLockOnRejection = 155512302,
        HeadingToleranceDegrees = 3997955765,
        HeadingWanderChange = 3829108144,
        HeadingWeighting = 328254695,
        HeadingWeightingNoStick = 1613714646,
        HealthBar = 133430210,
        HealthConfigHash = 372913173,
        HealthMultiplierBonus = 2121757492,
        HealthRatioLimit = 2392243130,
        HealthRegenEfficiency = 2721388482,
        HeavyBrakeYAcceleration = 2551415238,
        HeightChangeSettleBlendDuration = 3719483743,
        HeightMapDelta = 1983182002,
        HeightMapLookAheadDist = 552115106,
        HeightScaling = 1920226182,
        HeightToStartLanding = 3067654195,
        HeightToStartWrithe = 2221851990,
        HeliPedModelId = 2549257506,
        HeliSpeedModifier = 641071834,
        HeliTargetArriveDist = 2931101691,
        HeliVehicleModelId = 1696043144,
        Helis = 847633247,
        HighAltitudeZoomSettings = 2054392766,
        HighBlindFireAimingDirectlyLimitAngle = 298108981,
        HighCloseEdgeWallTestYOffset = 1632533833,
        HighCoverBlendInDuration = 4171399035,
        HighCoverClipRate = 677754437,
        HighCoverProbeHeight = 1565700819,
        HighFallProbeLength = 934569024,
        HighFallTimeToBlockInjuredOnGround = 1503093096,
        HighHighFallEnd = 1799229733,
        HighHighFallStart = 1342466268,
        HighImportanceModifier = 786235913,
        HighJumpMaxAngleForVelScale = 2289178459,
        HighJumpMaxVelScale = 3965084574,
        HighJumpMinAngleForVelScale = 910411457,
        HighJumpMinVelScale = 1943815238,
        HighLeftAimStepInfoSet = 80679158,
        HighLodWalkHeadingLerpRate = 2391787980,
        HighOpenDoorClipId = 3849261684,
        HighRightAimStepInfoSet = 2338326271,
        HighSpeedShakeSettings = 3319637384,
        HighSpeedZoomSettings = 2646605713,
        HighVelocity = 4250665956,
        HighVelocityBlendOut = 468457579,
        HintHelperRef = 730193180,
        History = 3024574816,
        HistoryCosineThreshold = 3400740468,
        HitRandomisation = 3061537468,
        HitRandomisationAutomatic = 4009335731,
        HoldLegOutVelocity = 682602058,
        HoldSub = 1878184186,
        HoldingSingleHandedWeapon = 3720463376,
        HoldingTwoHandedWeapon = 3291888789,
        HoldingWeaponBonus = 4170306057,
        HoldingWeaponPlayerModifier = 1493940343,
        HotPedDisableSexinessFlagChecks = 674468988,
        HotPedMaxDistance = 2831412815,
        HotPedMaxDotAngle = 1194287595,
        HotPedMaxHeightDifference = 3233483053,
        HotPedMinDistance = 334092093,
        HotPedMinDotAngle = 101327813,
        HotPedRenderDebug = 248477757,
        HotwireClipId = 2232368689,
        HotwireRate = 1960961110,
        HumanBodyScale = 3219752194,
        HumanPelvisScale = 938878998,
        HumanSpine0Scale = 670734777,
        HumanSpine1Scale = 2267090113,
        HurryAwayInitialMBR = 1287855842,
        HurryAwayMBRChangeDelay = 162073420,
        HurryAwayMBRChangeRange = 2978098349,
        HurryAwayMoveBlendRatioWhenFar = 199132405,
        HurryAwayMoveBlendRatioWhenNear = 3010798658,
        HurryAwayWatchFirst = 3611561302,
        IDE_FILE = 3422262499,
        IN_AIRCRAFT = 3210104948,
        IN_BOAT = 1045637820,
        IN_HELI = 2079134431,
        IN_SUBMARINE = 2742629541,
        IN_TURRET = 4177603501,
        IdealDistance = 2913237777,
        IdealDistanceCouldLeaveCar = 13763777,
        IdealDistanceForPursue = 514678423,
        IdealDistanceIfArmed = 3291058825,
        IdealDistanceIfUnarmed = 172591904,
        IdealDistanceInVehicleAndTargetArmed = 2541599029,
        IdealDistanceInVehicleAndTargetUnarmed = 922557972,
        IdealDistanceOnBikeAndTargetArmed = 1876514812,
        IdealDistanceOnBikeAndTargetUnarmed = 2051473778,
        IdealDistanceShotAt = 150170926,
        IdealHeadingOffsetForLimiting = 3658085406,
        IdealPitchForFiringVariation = 1908604654,
        IdealSpawnDistance = 652074796,
        IdealTurnApproachRate = 1298540281,
        IdentificationRange = 625679404,
        IdleAnimStateInfos = 3037289130,
        IdleCmini = 1252108818,
        IdleHeadingLerpRate = 183241195,
        IdleHigh1HVariationClipsets = 2565051320,
        IdleHigh2HVariationClipsets = 616197965,
        IdleLow1HVariationClipsets = 229574996,
        IdleLow2HVariationClipsets = 754984064,
        IdleTimeRandomFactor = 2115224183,
        IdleTransitionBlendTimeFromActionMode = 639925745,
        IdleTransitionBlendTimeFromStealth = 1990190949,
        IdleVariationAnimStateInfos = 1977186530,
        IdleYStartOffset = 3646563039,
        IgnoreFovForHeadIk = 2404066730,
        IgnoreIfSensingPedIsOtherEntity = 4035148525,
        IgnoreRotationBlend = 2067979515,
        ImmediateHighFallSpeedAi = 696030652,
        ImmediateHighFallSpeedPlayer = 187177991,
        ImpulseMult = 959886766,
        Impulses = 245896742,
        InAir = 1916434556,
        InAirFreeWheelBikeClipId = 3916128451,
        InAirFreeWheelCharClipId = 4285496170,
        InAirHeadingRate = 712615227,
        InAirMovementApproachRate = 2498638030,
        InAirMovementRate = 1308347600,
        InAirProbeDistance = 3752389553,
        InAirProbeForwardOffset = 4171402878,
        InAirZAccelTrigger = 1568293823,
        InBoat = 3499358923,
        InCoverMovementSpeed = 3787797455,
        InCoverMovementSpeedEnterCover = 1291062567,
        InCoverScoreModifier = 1975453329,
        InCoverTolerance = 3968028188,
        InDuration = 2456685333,
        InHeli = 345193988,
        InMotionAlignmentVelocityTolerance = 891286257,
        InMotionTighterTurnsVelocityTolerance = 3646294886,
        InPlaceAlignmentVelocityTolerance = 2324978953,
        InRangeDrivingPlayerModifier = 3099253594,
        InRangePlayerDistanceThreshold = 395317425,
        InRangePlayerInRaceDistanceThreshold = 1849354099,
        InRangePlayerModifier = 3120269183,
        InVehicle = 3094451383,
        InVehicleLookAtDampingRef = 556138114,
        InWaterExitDepth = 1332340783,
        InWaterExitProbeLength = 1768336421,
        IncidentLocation = 2790865931,
        IncreasedAerialSpawningFactor = 3248533699,
        IncreasedAquaticSpawningFactor = 1340414393,
        IncreasedGroundWildlifeSpawningFactor = 1785192888,
        InflectionPitch = 1035721466,
        Info = 4197530443,
        InitialAreaTimeoutWhenCrimeReported = 3003441217,
        InitialAreaTimeoutWhenSeen = 922425823,
        InitialBumpComponent = 406034015,
        InitialBumpForce = 2701068933,
        InitialBumpOffset = 1000319425,
        InitialDelay = 1832992496,
        InitialForce = 2966151540,
        InitialForceComponent = 871993282,
        InitialForceOffset = 279094028,
        InitialLowEdgeTestEndYOffset = 1933569235,
        InitialLowEdgeTestStartYOffset = 1759052099,
        InitialLowEdgeWallTestYOffset = 420444049,
        InitialRagdollDelay = 1901527010,
        InitialRelativeHeadingLimits = 1115426652,
        InitialRelativePitchLimits = 113692134,
        InitialTerrainAvoidanceAngleD = 3968352519,
        InitialWorldPitchLimits = 1692207327,
        InnerDistanceThreshold = 2348909882,
        InputEnvelopeRef = 1933675573,
        InputMagPowerFactor = 3265151949,
        InputMagToIncreaseDeadZoneMax = 4159970100,
        InputMagToIncreaseDeadZoneMin = 3261011203,
        InputType = 1445865118,
        InputYAxisCornerExitValue = 2129665503,
        InputYAxisQuitValue = 1147378819,
        InsideCornerStopDistance = 3341714290,
        InsideEdgeEndXOffset = 2929248824,
        InsideEdgeEndYOffset = 1055186370,
        InsideEdgeStartXOffset = 2121459739,
        InsideEdgeStartYOffset = 2408138725,
        InstantProbeDurationMin = 4060945649,
        InterpRates = 78660797,
        IntroClip0Id = 4104220306,
        IntroClip1Id = 430012531,
        IntroClipId = 3802470907,
        IntroMaxScale = 842076929,
        IntroMovementDuration = 3673514744,
        IntroRate = 1649508716,
        IntroRotScalingDefaultEndPhase = 1894035381,
        IntroRotScalingDefaultStartPhase = 1515476732,
        IntroScalingDefaultEndPhase = 4206558217,
        IntroScalingDefaultStartPhase = 3371499882,
        InvMassScale = 514198685,
        InverseMassScales = 172669903,
        IsBehindVehicleGlass = 3132205970,
        IsCasual = 3169257000,
        IsChild = 2962717212,
        IsCrouching = 1674350800,
        IsDangerousAnimal = 1867113976,
        IsGang = 1945623796,
        IsHuman = 2212592004,
        IsLocal = 3419197588,
        IsMale = 819954510,
        IsSecurity = 622092394,
        IsStationary = 4172129738,
        IsWeird = 1025165367,
        Items = 2880561169,
        JOB_AND_NAME_MED = 1218436764,
        JackingModifier = 2688373686,
        JetskiDrivebyFilterId = 2134287489,
        JumpCollision = 1017102101,
        JumpFallTestAngle = 793837940,
        JumpOutofSubNeutralBuoyancyTime = 2102914796,
        KeepWeapon = 1218243798,
        KickOnGroundTuning = 1543515715,
        KnockOffBikeEjectImpactFriction = 3996231382,
        KnockOffBikeEjectMaxImpactDepth = 301898848,
        KnockOffBikeForwardMaxComponent = 2466946069,
        KnockOffBikeForwardMinComponent = 2251372495,
        KnockOffBikeMaxSpeed = 2357933858,
        KnockOffBikeMaxUpright = 3242658957,
        KnockOffBikeMinSpeed = 2854807360,
        KnockOffBikeMinUpright = 4180033042,
        KnockOffBikePitchMaxComponent = 2962336026,
        KnockOffBikePitchMinComponent = 164203436,
        KnockOffBikeUpMaxComponent = 2641066262,
        KnockOffBikeUpMinComponent = 3963787762,
        LADDER_METADATA_FILE = 873638153,
        LEADERBOARD_DATA_FILE = 153829429,
        LEGALS = 4072415756,
        LEVEL_STREAMING_FILE = 3625514299,
        LOOKIK_BLEND_RATE_FAST = 373155899,
        LOOKIK_BLEND_RATE_FASTEST = 2515903841,
        LOOKIK_BLEND_RATE_INSTANT = 1486063330,
        LOOKIK_BLEND_RATE_NORMAL = 1833278132,
        LOOKIK_BLEND_RATE_SLOW = 986173808,
        LOOKIK_BLEND_RATE_SLOWEST = 3711568277,
        LOOKIK_ROT_LIM_NARROW = 3906611689,
        LOOKIK_ROT_LIM_NARROWEST = 1073022306,
        LOOKIK_ROT_LIM_OFF = 49782489,
        LOOKIK_ROT_LIM_WIDE = 1112780501,
        LOOKIK_ROT_LIM_WIDEST = 1594514833,
        LOOKIK_TURN_RATE_FAST = 2235154210,
        LOOKIK_TURN_RATE_NORMAL = 3984591931,
        LOOKIK_TURN_RATE_SLOW = 2708677357,
        LOOK_FORWARD_RELATIVE_TO_ATTACH = 2580680746,
        LSAcceleration = 2358484554,
        LSDeadZoneAngle = 2899233953,
        LSDeceleration = 4267995471,
        LackOfHostility = 2857118825,
        LadderAlignment = 2014258089,
        LadderPitch = 2326671617,
        LandHeadingModifier = 1347777197,
        LandProbe = 1166908668,
        LandProbeLength = 2205933583,
        LandRollHeight = 3897556344,
        LandRollHeightFromJump = 2847920310,
        LandRollHeightFromVault = 3337751765,
        LandSlopeNoseUpMax = 3983307371,
        LandSlopeNoseUpMin = 564764161,
        Landing = 1163966079,
        LargeVerticalAccelerationDelta = 4247487957,
        LastBattleEventHighEnergyEndTime = 2064072700,
        LastBattleEventHighEnergyStartTime = 271833144,
        LastSpottedDistance = 2553544690,
        LastStand = 1877343639,
        LastStandArmoured = 745594459,
        LastStandMaxArmouredTotalTime = 2286694021,
        LastStandMaxTotalTime = 417172126,
        LateralForce = 2100597904,
        LaunchLeftBikeClipId = 3073315828,
        LaunchLeftCharClipId = 1333997798,
        LaunchRightBikeClipId = 3808805794,
        LaunchRightCharClipId = 945663205,
        LayerA = 3994552921,
        LayerB = 3761008258,
        LayerBlend = 3968024215,
        Layers = 4018703742,
        LeaderExitVehicleDistance = 676285031,
        LeanAngleDefaultRate = 1850650077,
        LeanAngleDefaultRatePassenger = 1393469938,
        LeanAngleReturnRate = 1365613076,
        LeanAngleReturnedTol = 4254763028,
        LeanAngleSmoothingRate = 541806245,
        LeanForwardsAngleSmoothingRate = 4228832635,
        LeanScale = 2484601688,
        LeanSidewaysAngleMaxAccAngle = 4058717361,
        LeanSidewaysAngleMinAccAngle = 4159734133,
        LeanSidewaysAngleSmoothingAcc = 1551960100,
        LeanSidewaysAngleSmoothingRateMax = 1540399603,
        LeanSidewaysAngleSmoothingRateMin = 525349387,
        LeaningExtremeThreshold = 48278855,
        LeftBoneOffset = 416915558,
        LeftGrip = 102733762,
        LeftHandOffset = 2557494577,
        LeftPickUpTargetLerpPhaseEnd = 354147533,
        LeftPickUpTargetLerpPhaseEndBicycle = 3597820233,
        LeftPickUpTargetLerpPhaseStart = 3911832280,
        LeftPickUpTargetLerpPhaseStartBicycle = 706443375,
        LeftPullUpTargetLerpPhaseEnd = 2320755313,
        LeftPullUpTargetLerpPhaseEndBicycle = 3214386681,
        LeftPullUpTargetLerpPhaseStart = 4195927131,
        LeftPullUpTargetLerpPhaseStartBicycle = 2664369195,
        LeftRightStickInputMin = 3223119611,
        LeftRightStickInputSmoothingRate = 1082826303,
        LeftWire = 2742077142,
        LegShot = 2675545657,
        LegShotFallRootImpulseMinUpright = 4252723795,
        LegShotFallRootImpulseMult = 184133535,
        LengthScaling = 4135147407,
        LensArtefact = 661891977,
        LimbStrengthTuning = 2622719195,
        LimitAttachParentRelativePitchAndHeading = 2799648005,
        LimitMeleeRangeToDefault = 1169108573,
        LineOfSight = 2250254670,
        LineOfSightStatus = 682590761,
        LineOfSightTests = 728351840,
        LinearVZForBrakingDifferenceMax = 119610653,
        LinearVZForBrakingDifferenceMin = 950864184,
        LinearVZForPitchRatioMax = 332728501,
        LinearVZForPitchRatioMin = 135326749,
        LocationForNearestCarNodeOverrides = 3346068581,
        LockOnDistanceLimits = 4280147981,
        LockOnDistanceRejectionModifier = 2510305536,
        LockOnEnvelopeRef = 2833081775,
        LockOnOrbitDistanceSettings = 4165908011,
        LockOnRangeModifier = 3927328861,
        LockOnSwitchTimeExtensionBreakLock = 1952125540,
        LockOnSwitchTimeExtensionKillTarget = 2774244387,
        LockOnTargetDampingSettings = 1635236307,
        LockOnTargetStunnedEnvelopeRef = 2209545096,
        LockType = 4263854907,
        LongitudinalBodyLeanApproachRate = 373069342,
        LongitudinalBodyLeanApproachRateSlope = 4228525959,
        LongitudinalBodyLeanApproachRateSlow = 1466153272,
        LookAheadDistanceForBackAway = 1706779012,
        LookAheadForRunway = 1293732320,
        LookAround = 4270549134,
        LookAtBehaviour = 589368866,
        LookAtOffset = 1190303903,
        LookAtTime = 3780096928,
        LookAtUpdateTime = 1858185525,
        LookBehindOutroTimeMS = 537305387,
        LookBehindRelativeAttachPosition = 2548218645,
        LookOverSettings = 3300166924,
        LookingInRangePlayerMaxDotAngle = 1018069509,
        LoopClipId = 3333920819,
        LoopClipSetId = 3859145463,
        LoopMode = 3135858693,
        LostBalanceAndGrabbing = 944999838,
        LowBlindFireAimingDirectlyLimitAngle = 2323225479,
        LowBlockedBlend = 2527050941,
        LowCoverBlendInDuration = 2789076521,
        LowCoverClipRate = 1362808676,
        LowCoverProbeHeight = 4155982221,
        LowImportanceModifier = 592353395,
        LowLeftStep = 4111569262,
        LowLod = 3357299335,
        LowLodBaseClipSetId = 664477457,
        LowLodExtraHeadingAdjustmentRate = 3846215494,
        LowLodIdleClipSetId = 2167334901,
        LowLodWalkHeadingLerpRate = 3008826210,
        LowOffsetCapsuleLength = 568360986,
        LowOffsetCapsuleRadius = 4015224528,
        LowRightStep = 4205427545,
        LowSideZOffset = 1655026590,
        LowStepBackLeftXBlocked = 2531405930,
        LowStepBackLeftYBlocked = 2343990340,
        LowStepBackRightXBlocked = 3516373800,
        LowStepBackRightYBlocked = 3372482096,
        LowStepOutLeftXBlocked = 842428202,
        LowStepOutLeftYBlocked = 3532419784,
        LowStepOutRightXBlocked = 8574286,
        LowStepOutRightYBlocked = 298303912,
        LowVelocityReactionThreshold = 2079428645,
        LowXClearOffsetCapsuleTest = 2818774649,
        LowXOffsetCapsuleTest = 3545526197,
        LowYOffsetCapsuleTest = 717814241,
        LowZOffsetCapsuleTest = 2260315698,
        LowerArmImpulseCap = 3002630191,
        LowerArmNoTorseHitImpulseCap = 2054532609,
        LungeChangeDistance = 1585455214,
        LungeForwardOffset = 2740115372,
        LungeTargetRadius = 2981439007,
        LungeZOffset = 3783579394,
        MOTION_TASK_DATA_FILE = 775482934,
        MOTIVATIONS_FILE = 2957501757,
        MOUNT_TUNE_FILE = 2889043007,
        MPLargeAccidenThresold = 2099608654,
        Mag = 2130375977,
        MagnitudeClamp = 3388239219,
        MatchTargetWeapon = 2028274881,
        MatchTimer = 219280121,
        MaxAbsDotForAvoidDirected = 462717652,
        MaxAbsThrottleForCloseDoor = 1734471519,
        MaxAccelModifier = 150232389,
        MaxAcceleration = 2732255867,
        MaxAccelerationForLean = 419181205,
        MaxAdjustmentLookAhead = 4125886772,
        MaxAiActivationLimit = 1737477488,
        MaxAimFromGroundTime = 3996785209,
        MaxAimTimeOnStickMs = 1480451859,
        MaxAltitudeDelta = 2362779209,
        MaxAmbientVehiclesToSpawnChase = 3549282925,
        MaxAmplitude = 272708601,
        MaxAngle = 3503009483,
        MaxAngleConsidered = 2451123132,
        MaxAngleDeltaForLockOnSwitchBlendScaling = 2783842060,
        MaxAngleForScaleVelocityExtension = 360286196,
        MaxAnglePickPOI = 527596719,
        MaxAngleToBeginRotationScale = 3171601208,
        MaxAngleToSetDirectly = 3073391680,
        MaxAngularDiffBetweenDynamicAndStaticCover = 2761743161,
        MaxAngularHeadingVelocityAi = 4125755684,
        MaxAngularHeadingVelocityPlayer = 63113045,
        MaxAngularHeadingVelocityPlayerForcedStandAim = 1486772652,
        MaxAngularVelocity = 1393994109,
        MaxAngularVelocityScaleFactor = 3006329763,
        MaxArmourImpulseMult = 1393173723,
        MaxAttachParentDepthUnderWaterToRemainBuoyant = 2069938157,
        MaxAttachParentDepthUnderWaterToRemainBuoyantOut = 1698601922,
        MaxAttachParentSpeedToClonePitchFromCinematicMountedCameras = 150825038,
        MaxAttachParentSubmergedLevelToApplyFullAttachParentMatrixForRelativeOrbit = 3039556728,
        MaxBackOffDistance = 2075820886,
        MaxBaseFovScaling = 785828068,
        MaxBlendDurationForInitialLockOn = 1807116888,
        MaxBlendDurationForLockOnSwitch = 3132164856,
        MaxBrake = 1676250682,
        MaxCapsuleTests = 961760330,
        MaxCircleRadius = 3815425058,
        MaxClipsToCheckPerFrame = 1435927021,
        MaxCollisionFallBackBlendLevelToForceUnderWater = 2382802886,
        MaxCollisionRootSpeedToForcePopIn = 35427940,
        MaxCollisionRootSpeedToPausePullBack = 4012884170,
        MaxCollisionTestRadius = 2696635175,
        MaxCombineDistThresholdSquared = 3413677046,
        MaxCruiseSpeed = 2890274297,
        MaxCruiseSpeedMultiplier = 4219085548,
        MaxCruiseSpeedWhenClamped = 3775809407,
        MaxDamageTakenImpulseMult = 253998194,
        MaxDamageTakenThreshold = 4025040637,
        MaxDamageToCheckForRandomDeath = 4042046110,
        MaxDamageToIgnore = 2744941697,
        MaxDeccelModifier = 1410651137,
        MaxDeceleration = 1689883019,
        MaxDefaultAngularVelocity = 2408710412,
        MaxDefendPointWaitTimeMS = 3128562978,
        MaxDelay = 509314747,
        MaxDelayExitTime = 3125460893,
        MaxDelayForGetOff = 1867895091,
        MaxDelayTimeForExitVehicle = 2049624973,
        MaxDelayTimer = 2906908712,
        MaxDifferenceToAverageBrakes = 87152394,
        MaxDirectionVariance = 3433998695,
        MaxDistScanArc = 2704081606,
        MaxDistToConsiderPedGoingToDoorPriority = 4213098799,
        MaxDistToConsiderVehicleValid = 2104384861,
        MaxDistToCoverWhenPlayerIsClose = 2168923712,
        MaxDistToCoverXY = 2157843494,
        MaxDistToCoverZ = 2187323127,
        MaxDistToPathDefault = 819069056,
        MaxDistToVehicle = 1250203641,
        MaxDistUpdateFrequency = 3216270742,
        MaxDistanceAbovePedPositionToClampPitch = 1654280371,
        MaxDistanceAiPedFromTheirCoverToAbortPlayerEnterCover = 1955233508,
        MaxDistanceAroundClosestRoadNode = 1354574680,
        MaxDistanceErrorToIgnore = 1819399769,
        MaxDistanceForAmbientReaction = 2167383018,
        MaxDistanceForAvoid = 1319056930,
        MaxDistanceForAvoidDirected = 1721238833,
        MaxDistanceForBackAway = 2592101241,
        MaxDistanceForDispatchPosition = 43531000,
        MaxDistanceForFineAimScaling = 70391041,
        MaxDistanceForHolster = 3926218692,
        MaxDistanceForLawToReturnToCombatFromFlee = 115479140,
        MaxDistanceForOrientation = 3358534575,
        MaxDistanceForPedToBeVeryCloseToCover = 3273119465,
        MaxDistanceForRiverWaterClippingTest = 753638141,
        MaxDistanceForSearch = 2973796969,
        MaxDistanceForSlowdown = 2085906895,
        MaxDistanceForTaint = 688870759,
        MaxDistanceForWaterClippingTest = 102161666,
        MaxDistanceFromCameraForViewportChecks = 3017247137,
        MaxDistanceFromNavMesh = 1798086221,
        MaxDistanceFromOptimal = 2733041160,
        MaxDistanceFromPed = 1011332177,
        MaxDistanceFromPedToHelpPed = 3390705532,
        MaxDistanceFromRoadNode = 4277520254,
        MaxDistanceFromTargetToForceStraightLineMode = 2229910851,
        MaxDistanceNavmeshMayAdjustPath = 3452202501,
        MaxDistanceToAdjustSpeed = 2070026726,
        MaxDistanceToAlwaysLookAtTarget = 4029768824,
        MaxDistanceToBeConsideredClumped = 2154790128,
        MaxDistanceToBeConsideredOptimal = 1883452103,
        MaxDistanceToCareAboutBlockingLineOfSight = 803259673,
        MaxDistanceToCheckEntryCollisionWhenIgnoring = 3271021322,
        MaxDistanceToClampCruiseSpeed = 3954141229,
        MaxDistanceToConsiderClose = 1501439076,
        MaxDistanceToConsiderCloseToPositionToMoveTo = 2494967040,
        MaxDistanceToConsiderTooClose = 3348150388,
        MaxDistanceToContinueFromPursue = 3842476462,
        MaxDistanceToFindVehicle = 702493934,
        MaxDistanceToHoldFireForArrest = 655626928,
        MaxDistanceToInsult = 3792438004,
        MaxDistanceToMyVehicleToChase = 2374284734,
        MaxDistanceToPersist = 3073979382,
        MaxDistanceToPursueVehicle = 1506267647,
        MaxDistanceToReactToJackForGoToDoor = 3839836820,
        MaxDistanceToReturnToLastUsedVehicle = 1770714176,
        MaxDistanceToScanForNearbyVehicle = 2354829088,
        MaxDistanceToScanLookAts = 491173128,
        MaxDistanceToSearchForAquaticPoints = 1744844248,
        MaxDistanceToSearchForGroundWildlifePoints = 1961260334,
        MaxDistanceToSideOnPavement = 1016024123,
        MaxDistanceToStartFromPursue = 648063710,
        MaxDistanceToStartMatchingSpeed = 2246107998,
        MaxDistanceToTalk = 1179075662,
        MaxDistanceToUseUrgentTransitions = 2236196658,
        MaxDistanceToVehicleForCommandeer = 3887134676,
        MaxDistanceToWatchVehicle = 3050367607,
        MaxDistanceTraveledMultiplier = 713008535,
        MaxDiveHeight = 2479363241,
        MaxDoorSpeedToConsiderClosingDoor = 3503503802,
        MaxDot = 3500436404,
        MaxDotForHandBrake = 1930122576,
        MaxDotToApplyTorque = 403672092,
        MaxDotToContinueFromAnalyze = 126845285,
        MaxDotToStartFromAnalyze = 1082929500,
        MaxDotToTargetToHelpPed = 3200641731,
        MaxDriverTimeToLeaveVehicle = 3023143341,
        MaxDuration = 3115459373,
        MaxDurationForMultiplayerViewModeActivation = 1552516033,
        MaxDurationToTrackVehicles = 2514003172,
        MaxEncumberedClimbHeight = 4241887050,
        MaxEscapeDistance = 1872481699,
        MaxExtraHeightForTowedVehicles = 3584381811,
        MaxExtraHeightForVehicleTrailers = 2086333922,
        MaxExtraMoney = 471524408,
        MaxFacingThreshold = 1107258897,
        MaxFallHeight = 355034181,
        MaxFleeMoveBlendRatio = 2916287204,
        MaxFlinchDistance = 1218603971,
        MaxForceFiringDistance = 2117446694,
        MaxForceFiringStateTime = 1120297675,
        MaxForwardSpeed = 2306378250,
        MaxForwardsPitchFastSpeed = 1535257534,
        MaxForwardsPitchSlope = 1260039600,
        MaxForwardsPitchSlopeBalance = 2058043106,
        MaxForwardsPitchSlowSpeed = 705106159,
        MaxForwardsPitchWheelieBalance = 2198401741,
        MaxFov = 3615529910,
        MaxGameplayNmAgents = 1794949754,
        MaxGameplayNmAgentsMp = 3172335713,
        MaxGrabTime = 2123286016,
        MaxHandToHandleDistance = 2222197615,
        MaxHandleHeightDiff = 474312049,
        MaxHandleHeightDiffVan = 3933910603,
        MaxHeadingAdjustmentRate = 1871838464,
        MaxHeadingAlignmentCosThreshold = 3382384728,
        MaxHeadingAngle = 3669858468,
        MaxHeadingDiffBetweenCTCPoints = 225620543,
        MaxHeadingDifferenceForQuickGlanceInSameDirection = 4164431042,
        MaxHeadingSpeed = 1529419507,
        MaxHealthImpulseMult = 3839056884,
        MaxHealthLossForQuickGetup = 1165801413,
        MaxHeavyCrashDeathChance = 1466872193,
        MaxHeight = 4276410337,
        MaxHeightDifference = 3332963351,
        MaxHeightDifferenceToApproachTarget = 1288859935,
        MaxHeliDamping = 3700594697,
        MaxHoldBreathDuration = 1166926746,
        MaxHoverHeightDistToWarpIntoHeli = 2914709570,
        MaxImpulse = 1400954876,
        MaxInjuredTargetTimerVariation = 1511702574,
        MaxInputForIdleExit = 2059966079,
        MaxInstances = 2118495770,
        MaxIntensity = 1137728512,
        MaxIterations = 3378768739,
        MaxJumpHeightForSmallImpact = 1962859811,
        MaxLateralSkidSpeed = 3579471989,
        MaxLeanInDirectionTime = 2519882664,
        MaxLength = 977032494,
        MaxLift = 489565795,
        MaxLimit = 597877266,
        MaxLinearVelocity = 1416568288,
        MaxLookAroundMoveSpeedMultiplier = 2563263345,
        MaxLookAtArmWoundTime = 2663144521,
        MaxLookAtDistance = 2034399215,
        MaxLookBackAngle = 894057762,
        MaxMag = 3421300414,
        MaxMoveOrientationSpeedDuringLookAround = 1286077706,
        MaxMoveSpeedForFollowOrientation = 1014809841,
        MaxMoveSpeedInCover = 2814625688,
        MaxMoveToDefensiveAreaAngleVariation = 2154434340,
        MaxMovingProbeOffset = 4049257140,
        MaxMovingThreshold = 3214855311,
        MaxNavmeshPatrolRadiusFactor = 1708395848,
        MaxNearbyToFindPerFrame = 1638764838,
        MaxNumPedsAllowedToBeVeryCloseToCover = 1481327584,
        MaxNumPedsChasingOnFoot = 2540858782,
        MaxNumRequestsPerContext = 1337224709,
        MaxNumberCopVehiclesInChase = 1965911345,
        MaxNumberFakeApproaches = 284429428,
        MaxOffset = 826600434,
        MaxOpenRatioForOpenDoorInitialInside = 4028760366,
        MaxOpenRatioForOpenDoorInitialOutside = 4222207562,
        MaxOpenRatioForOpenDoorInside = 2427558104,
        MaxOpenRatioForOpenDoorOutside = 1484783860,
        MaxOscillationDisplacementInside = 2206944099,
        MaxOscillationDisplacementOutside = 1118824342,
        MaxParachutePitch = 1610340719,
        MaxParachuteRoll = 888388965,
        MaxPassengerTimeToLeaveVehicle = 3100475498,
        MaxPassengersForAttraction = 865654234,
        MaxPhoneFilmTime = 3084950400,
        MaxPhoneFilmTimeHurryAway = 2306714989,
        MaxPitch = 4261179401,
        MaxPitchAngle = 1021608480,
        MaxPitchAngle2H = 2966888023,
        MaxPitchDefault = 3807823759,
        MaxPitchDifferenceForFiringVariation = 644208462,
        MaxPitchInAir = 422547942,
        MaxPitchSpeed = 1910928125,
        MaxPitchingAnglePickPOI = 3709479259,
        MaxPlaneControlAbility = 1011508514,
        MaxPlaneDamping = 353529649,
        MaxPlayerActivationLimit = 83737662,
        MaxPlayerCapsulePushTimeForRagdollActivation = 2253067348,
        MaxPlayerScore = 2407947760,
        MaxPlayerToCoverDist = 4030958526,
        MaxPositionVariance = 2240856053,
        MaxPreCollisionCameraSpeedToForcePopIn = 4130418064,
        MaxPreCollisionCameraSpeedToPausePullBack = 2824365723,
        MaxRadius = 466062419,
        MaxRadiusForMaxTimeSinceLastSpotted = 208554060,
        MaxRadiusForMinTimeSinceLastSpotted = 679039028,
        MaxRageRagdolls = 2482945086,
        MaxRageRagdollsMp = 1068424255,
        MaxRangeWithoutRadioForFistFights = 2602588680,
        MaxRate = 1154906885,
        MaxRateForInVehicleAnims = 4219653521,
        MaxRateForSlowBlendDuration = 1735614949,
        MaxRateToPlayCowerReaction = 2442429563,
        MaxRateVariance = 2016189169,
        MaxReactToFireDelay = 3144065170,
        MaxReactToFireRate = 2938880609,
        MaxReactionTime = 2030474037,
        MaxRelativeHeading = 3645576770,
        MaxRoll = 1361361101,
        MaxRollFromBrake = 2707471304,
        MaxRollFromStick = 4013155074,
        MaxRotScale = 3906575696,
        MaxRotSpeed = 2343716985,
        MaxRotationalSpeed = 2507965951,
        MaxRotationalSpeedScale = 502763290,
        MaxRouteLengthForCower = 3858374889,
        MaxRouteSizeForCower = 325049815,
        MaxSearchDistance = 1252284298,
        MaxSearchRadiusForNavMesh = 861953935,
        MaxSecondsAsTopLevelTask = 324489357,
        MaxShakeInstances = 2390340428,
        MaxShellShockedDistance = 1811470108,
        MaxSidePaddingForTurn = 3250501977,
        MaxSpeedDifference = 1143414935,
        MaxSpeedDifferenceForPowerAdjustment = 1861379728,
        MaxSpeedForAvoid = 1592953719,
        MaxSpeedForAvoidDirected = 44796921,
        MaxSpeedForBrace = 508750981,
        MaxSpeedForEarlyCombatExit = 4258519451,
        MaxSpeedForHesitate = 3303023161,
        MaxSpeedForStill = 3869148508,
        MaxSpeedForStillReverse = 1916394191,
        MaxSpeedForVehicle = 2486108674,
        MaxSpeedForVehicleMovingSlowly = 408114095,
        MaxSpeedToActivate = 3555945363,
        MaxSpeedToContinueJackingVehicle = 3826933504,
        MaxSpeedToDive = 4063222790,
        MaxSpeedToStartJackingVehicle = 4182891936,
        MaxSpeedToTriggerFixieSkidTransition = 2271374387,
        MaxSpeedToTriggerTrackStandTransition = 1082334520,
        MaxSpeedToUseHandBrake = 1580566536,
        MaxStairsJumpAngle = 3734083336,
        MaxStaminaDuration = 1624872472,
        MaxStandWaitTimeMS = 3857242043,
        MaxSteerAngle = 3758934792,
        MaxSteeringAngleForAmbientIdles = 1299890657,
        MaxSteeringAngleForSitIdles = 2737592779,
        MaxStepBackDist = 3352731897,
        MaxStepOutDist = 899299281,
        MaxSteps = 3459663346,
        MaxStickChangePerSecond = 1936752322,
        MaxStickInputAngleInfluence = 3234046643,
        MaxStopPhaseToResumeMovement = 1345455105,
        MaxStoppingDuration = 863732031,
        MaxStoppingEdgeCheckProbeOffset = 1469301844,
        MaxStoppingProbeOffset = 38963063,
        MaxStruggleTime = 2216234163,
        MaxStunnedTime = 3892117779,
        MaxSuperJumpInitialVelocity = 988692459,
        MaxSweepAngleWhenAvoidingPopIn = 1583100448,
        MaxSweepAngleWhenMovingTowardsLos = 2848194588,
        MaxTakeOffHeadingChangeRate = 2210871472,
        MaxTakeOffRate = 3524235412,
        MaxTargetAngularMovementForWatch = 3193923873,
        MaxTargetOffsetX = 4229384679,
        MaxTargetOffsetY = 4066129521,
        MaxTargetOffsetZ = 3764687490,
        MaxTargetOffsetZ_TargetInAir = 3283771357,
        MaxTargetSteerAngleToContinueFromPursue = 3306631916,
        MaxTargetSteerAngleToStartFromPursue = 2501833676,
        MaxThrottle = 64513465,
        MaxThrottleForStill = 1906306837,
        MaxThrust = 3597427549,
        MaxTimeBeforeNewPose = 1274013705,
        MaxTimeBeforeReact = 3193578838,
        MaxTimeBetweenIdleVariations = 3648216318,
        MaxTimeBetweenPlayerIdleVariations = 2015526511,
        MaxTimeBetweenSearches = 110388555,
        MaxTimeBetweenShootOutTiresGlobal = 283868640,
        MaxTimeForAmbientReaction = 2937486448,
        MaxTimeForArrestBreakout = 2090607393,
        MaxTimeForAudioReaction = 143794235,
        MaxTimeForBrake = 110293208,
        MaxTimeForHandsUp = 3487053313,
        MaxTimeForInitialState = 478429586,
        MaxTimeForStream = 122331865,
        MaxTimeInBulletReactionState = 1969287622,
        MaxTimeInCombatToShootOutTires = 730951251,
        MaxTimeInStateToContinueFromPursue = 1655056873,
        MaxTimeInSwerve = 4163863357,
        MaxTimeMoveNearCrimeMs = 897487244,
        MaxTimeMoveToLawFailedPathfindingMs = 2062768994,
        MaxTimeMoveToLawMs = 1736715102,
        MaxTimeSearchMs = 3450986312,
        MaxTimeSinceGetUpForAmbientIdles = 2863765530,
        MaxTimeSinceLastSpotted = 1171478055,
        MaxTimeSinceShiftedWeightForwardToAllowWheelie = 2103453391,
        MaxTimeSinceShot = 3302572334,
        MaxTimeStayPinned = 818416092,
        MaxTimeStreamClipSetInBeforeSkippingCloseDoor = 3836837046,
        MaxTimeStreamClipSetInBeforeWarpMP = 1243230599,
        MaxTimeStreamClipSetInBeforeWarpSP = 2153531751,
        MaxTimeStreamInVehicleClipSetBeforeStartingEngine = 559307397,
        MaxTimeStreamShuffleClipSetInBeforeWarp = 3089447490,
        MaxTimeTargetVehicleMoving = 904929247,
        MaxTimeToBeObstructed = 3272441861,
        MaxTimeToCallPolice = 3706002780,
        MaxTimeToClipIntoDynamicCollision = 851288932,
        MaxTimeToConsiderPedGoingToDoorPriority = 2361725074,
        MaxTimeToFleeInVehicle = 454716601,
        MaxTimeToHesitate = 3164535731,
        MaxTimeToHoldFireAtTaskInitialization = 2545130112,
        MaxTimeToLookAheadForFutureTargetPosition = 2027520168,
        MaxTimeToPrepareWeapon = 535072586,
        MaxTimeToReact = 512026668,
        MaxTimeToRejectRespawnedTarget = 2157137274,
        MaxTimeToReserveComponentBeforeWarp = 3107868104,
        MaxTimeToSpendInEarLoopToPutDownPhone = 854541557,
        MaxTimeToSpendOccluded = 2101619543,
        MaxTimeToSpendOccludedByAttachParent = 1735950673,
        MaxTimeToSwerve = 2288728578,
        MaxTimeToTrespassWhileSwimmingBeforeDeath = 3579116253,
        MaxTimeToWait = 2597134309,
        MaxTimeToWaitForShot = 2658068209,
        MaxTimeToWatchVehicle = 3652981848,
        MaxTimeUntilReturnToIdleFromAimAfterAimedAt = 4055554934,
        MaxTimeUntilReturnToIdleFromAimDefault = 263823852,
        MaxTimeWaitForExitBeforeWarp = 1727051436,
        MaxTimeWaitingForBlockingArea = 1799405168,
        MaxTimeWaitingForCircleMs = 1160010076,
        MaxTimeWithNoReferences = 1570040321,
        MaxTimeoutToAcquireLineOfSight = 2480389571,
        MaxTrainClimbHeight = 1979246139,
        MaxTransScale = 2917519651,
        MaxTransVelocity = 766404597,
        MaxTranslationalMoveSpeed = 4264959731,
        MaxTranslationalScale = 3484537704,
        MaxTranslationalStandSpeed = 840729400,
        MaxTurnProbeOffset = 1513492849,
        MaxUprightRatio = 2171339313,
        MaxUsesForIdleVariationChange = 3247168097,
        MaxUsesForOutroReactVariationChange = 2728975961,
        MaxUsesForPeekingVariationChange = 2265825010,
        MaxUsesForPinnedVariationChange = 1988933435,
        MaxValue = 3107625217,
        MaxValueForCorrection = 4282800535,
        MaxVariationForCurrentPitch = 2853820726,
        MaxVariationForDesiredPitch = 1403610920,
        MaxVehSpeedToConsiderClosingDoor = 3267312723,
        MaxVehicleCapsulePushTimeForPlayerRagdollActivation = 3476926475,
        MaxVehicleCapsulePushTimeForRagdollActivation = 2007819517,
        MaxVehicleCollisionDamageScale = 86779191,
        MaxVehicleVelocityForAmbientIdles = 3495687858,
        MaxVel = 2245023424,
        MaxVelMag = 3255660709,
        MaxVelThreshold = 1711478621,
        MaxVelocityForSitIdles = 3221129138,
        MaxVelocityForSlow = 2650334467,
        MaxVelocityForVehicleLookAtSqr = 1245516390,
        MaxVelocityToEnterBike = 2759646652,
        MaxWaitForShotFailures = 3748385313,
        MaxWaitTime = 295850963,
        MaxWaitTimeBetweenTakeOffsMS = 626958998,
        MaxWallAngle = 2100915621,
        MaxWatchTime = 4262514281,
        MaxWatchTimeHurryAway = 3939134595,
        MaxWheelieAbility = 3607524859,
        MaxWorldLimitsPlayerX = 1353421746,
        MaxWorldLimitsPlayerY = 420979855,
        MaxWptAngle = 3402152282,
        MaxWritheTime = 127971633,
        MaxXYAccelerationForLeanBike = 2317632829,
        MaxXYDistanceForNewPosition = 1731877118,
        MaxXYDistanceToApproachTarget = 2074438621,
        MaxYIntentionToUseSlowApproach = 1157744908,
        MaxYaw = 2297479061,
        MaxYawFromRoll = 494928189,
        MaxYawFromStick = 430837016,
        MaxZAccelerationForLeanBike = 3982029176,
        MaxZComponentForCollisionNormal = 3252894044,
        MaxZDiffBetweenCoverPoints = 2570702388,
        MaxZDiffBetweenPedPos = 4136133905,
        MaxZoomFactor = 3357849814,
        MediumImportanceModifier = 3388322333,
        MediumShot = 2976595087,
        Melee = 2945330295,
        MeleeHeadingFalloffPowerRunning = 3977716086,
        MeleeHeadingOverride = 4259971013,
        MeleeHeadingOverrideRunning = 2260731941,
        MeleeLockOnCameraWeighting = 2159755352,
        MeleeLockOnCameraWeightingNoStick = 3188195832,
        MeleeLockOnPedWeightingNoStick = 2452287190,
        MeleeLockOnStickWeighting = 2608892368,
        MeleeLostLOSBreakTime = 3651791969,
        MemoryDuration = 1743809398,
        MemoryGroup = 4286534285,
        Messages = 605698999,
        MetadataList = 4098657407,
        MicroSMG = 1685333671,
        MinAccelModifier = 274966492,
        MinAccumulatedImpactForSideSwipe = 3443143875,
        MinAiSpeedForStandingUp = 510487850,
        MinAimTimeMs = 2221861795,
        MinAircraftContactSpeedToApplyFullAttachParentMatrixForRelativeOrbit = 1190961214,
        MinAircraftGroundSpeedToApplyFullAttachParentMatrixForRelativeOrbit = 1708190798,
        MinAltitudeDelta = 4256613730,
        MinAmplitude = 3172666582,
        MinAngleForScaleVelocityExtension = 2856025533,
        MinAnglePickPOI = 389125880,
        MinAngularVelocityScaleFactor = 40347237,
        MinAnimOffsetMagnitude = 2661194585,
        MinAnimRotationDeltaToScale = 3718056384,
        MinAnimTranslationDeltaToScale = 99937628,
        MinArmourImpulseMult = 3969466346,
        MinAttachParentApproachSpeedForPitchLock = 2127124229,
        MinAttachParentHeightRatioToPushAwayFromCollision = 296951838,
        MinAttachSpeedToUpdateTightSpaceLevel = 2058076685,
        MinBackOffDistance = 1492713734,
        MinBlendDurationForInitialLockOn = 3397272914,
        MinBlendDurationForLockOnSwitch = 3048647846,
        MinBlendLevelAfterPushAwayFromCollision = 527029053,
        MinBlendWeightToUseFarClipEvents = 2057785224,
        MinBlendWeightToUseHighClipEvents = 3370177558,
        MinBrake = 3259827294,
        MinBrakeForCloseUpCamera = 3323891652,
        MinCameraMoveSpeedToSweepInDirectionOfTravel = 1302934580,
        MinCentredSteeringAngleTimeForSitIdles = 3234674890,
        MinCircleRadius = 3257642822,
        MinClearDistanceBelow = 3563387020,
        MinContactDepthForContinuousPushActivation = 4064358618,
        MinCoverToPlayerCoverDist = 4196658405,
        MinCruiseSpeedMultiplier = 2635294172,
        MinCurrentRotationDeltaToScale = 478065483,
        MinDamageTakenImpulseMult = 167326155,
        MinDamageTakenThreshold = 1810182352,
        MinDamageTakenToApplyDamageAI = 2405402680,
        MinDamageTakenToApplyDamagePlayer = 2721586149,
        MinDamageToCheckForRandomDeath = 2190188961,
        MinDeccelModifier = 3966738289,
        MinDefendPointWaitTimeMS = 3250827903,
        MinDefensiveAreaRadiusForWillAdvance = 1909915037,
        MinDelay = 3403479156,
        MinDelayBetweenBuoyancyStateChanges = 1503749012,
        MinDelayExitTime = 3151657361,
        MinDelayForGetOff = 2811169447,
        MinDelayOnSubmerging = 3666052486,
        MinDelayOnSurfacing = 2560927169,
        MinDelayTimeForExitVehicle = 3267921887,
        MinDelayTimer = 564420500,
        MinDepthBelowSurface = 2503381867,
        MinDepthUnderWaterWhenNotBuoyant = 3111702866,
        MinDifferenceBetweenCowerReactionRates = 884159106,
        MinDisplacementScale = 3403073366,
        MinDistAwayFromEntryPointToConsiderFinished = 24914513,
        MinDistFromOtherPeds = 1071466356,
        MinDistFromPlayerToDeleteCoweringForever = 3668424542,
        MinDistFromPlayerToDeleteOffscreen = 162655462,
        MinDistFromPlayerToDeleteOnExitVehicle = 225841828,
        MinDistFromTargetWhenCoweringToCheckForExit = 9265257,
        MinDistPercentageToScaleScanArc = 3089390809,
        MinDistScanArc = 1000280571,
        MinDistToAlwaysClampInitialOrientation = 1420291822,
        MinDistToCoverAnyDir = 449945587,
        MinDistToCoverSpecificDir = 2215019044,
        MinDistToPlayEntryAnim = 525431756,
        MinDistToPriorityCoverToForce = 997332238,
        MinDistToScale = 3131955124,
        MinDistToVehicle = 722704686,
        MinDistUpdateFrequency = 475173943,
        MinDistanceAwayForFilming = 334429677,
        MinDistanceBetweenFilmingPeds = 2758358422,
        MinDistanceBetweenPositionsWithClearLineOfSight = 579362303,
        MinDistanceBetweenPositionsWithoutClearLineOfSightInExteriors = 72559400,
        MinDistanceBetweenPositionsWithoutClearLineOfSightInInteriors = 2086611921,
        MinDistanceForAimIntro = 813193409,
        MinDistanceForAmbientReaction = 946719330,
        MinDistanceForAvoid = 724928304,
        MinDistanceForAvoidDirected = 3043121072,
        MinDistanceForBackAway = 2509346908,
        MinDistanceForFineAimScaling = 1350912934,
        MinDistanceForLawToFleeFromCombat = 871647294,
        MinDistanceForLockOn = 9436207,
        MinDistanceForSearch = 2124766118,
        MinDistanceForSlowdown = 4284975454,
        MinDistanceFromPlayerToDeleteHurriedPed = 3508977239,
        MinDistanceFromPlayerToDeleteStuckBird = 2955815816,
        MinDistanceMovedToStartSearch = 4233283909,
        MinDistanceToAdjust = 4143621306,
        MinDistanceToAdjustSpeed = 1514235773,
        MinDistanceToBeConsideredLaggingBehind = 4205882999,
        MinDistanceToBeConsideredOptimal = 4180445694,
        MinDistanceToCheckClumped = 2096238662,
        MinDistanceToContinue = 3514547823,
        MinDistanceToCoverToStop = 3078439303,
        MinDistanceToEnterVehicleIfTargetEntersVehicle = 3875303030,
        MinDistanceToFindVehicle = 4037909654,
        MinDistanceToLookAhead = 1577260290,
        MinDistanceToLookBehind = 3533260791,
        MinDistanceToMove = 1348357381,
        MinDistanceToScanForNearbyVehicle = 868829697,
        MinDistanceToSearchForAquaticPoints = 3539942532,
        MinDistanceToSearchForGroundWildlifePoints = 303177901,
        MinDistanceToSetApproachPosition = 2521320953,
        MinDistanceToSideOnPavement = 2371258779,
        MinDistanceToStart = 3423985846,
        MinDistanceToStartMatchingSpeed = 820982755,
        MinDistanceToTargetForIdleVariations = 1823873460,
        MinDistanceToTargetForPeek = 4047811579,
        MinDiveHeight = 1331483625,
        MinDot = 1241644828,
        MinDotForInFront = 890881625,
        MinDotForPickupDirection = 1046969538,
        MinDotForSlowdown = 2841547079,
        MinDotMovingAwayFromTargetToStartCruiseInFront = 1195737890,
        MinDotMovingTowardsTargetToContinueBrakeInFront = 2713817702,
        MinDotMovingTowardsTargetToStartBrakeInFront = 935837869,
        MinDotTargetMovingTowardsOurSideToStartBackAndForth = 1212941547,
        MinDotTargetMovingTowardsUsToContinueBackAndForth = 737095977,
        MinDotTargetMovingTowardsUsToContinueBrakeInFront = 67415689,
        MinDotTargetMovingTowardsUsToContinueCruiseInFront = 2961114452,
        MinDotTargetMovingTowardsUsToStartBackAndForth = 4094305061,
        MinDotTargetMovingTowardsUsToStartBrakeInFront = 1917200737,
        MinDotTargetMovingTowardsUsToStartCruiseInFront = 3682638304,
        MinDotToBeConsideredInFront = 4211240273,
        MinDotToClampCruiseSpeed = 1823449253,
        MinDotToConsiderVehicleValid = 1576858885,
        MinDotToContinueFromAnalyze = 158897950,
        MinDotToContinueFromPursue = 2146950936,
        MinDotToInsult = 536817715,
        MinDotToPointGunAtPositionWhenUnableToTurn = 2838815119,
        MinDotToStartFromAnalyze = 2497181955,
        MinDotToStartFromPursue = 1707529261,
        MinDotToTalk = 2101568980,
        MinDriverTimeToLeaveVehicle = 1223491754,
        MinEdgeDistanceForStoppingAnim = 1251038941,
        MinExtraMoney = 1666523442,
        MinFallHeight = 3171739573,
        MinFallSpeedForHighFallAbort = 1512271781,
        MinFallingSpeedForAnimatedDyingFall = 1632351140,
        MinFallingSpeedInRagdoll = 1694228856,
        MinFineAimTime = 1340511632,
        MinFineAimTimeHoldingStick = 64509274,
        MinFleeMoveBlendRatio = 859826315,
        MinFocusToSecondaryFocusDistance = 1225855688,
        MinForDrivebys = 1749910459,
        MinForceFiringDistance = 1845309081,
        MinForceFiringStateTime = 1435641288,
        MinForwardSpeed = 2742393958,
        MinForwardsPitchFastSpeed = 3949027340,
        MinForwardsPitchSlope = 2116015636,
        MinForwardsPitchSlopeBalance = 3525415799,
        MinForwardsPitchSlowSpeed = 3517975074,
        MinForwardsPitchWheelieBalance = 3271949585,
        MinForwardsPitchWheelieBegin = 1825055764,
        MinFov = 2006858266,
        MinFovForNetworkPlay = 1881152859,
        MinGrabTime = 1433408101,
        MinHandleHeightDiffVan = 1408201742,
        MinHeadShotImpulseMultiplier = 3084941871,
        MinHeadingAlignmentCosThreshold = 3690289360,
        MinHeadingAngle = 2186047470,
        MinHealth = 1280594926,
        MinHealthForQuickGetup = 3891222055,
        MinHealthImpulseMult = 4101332336,
        MinHeavyCrashDeathChance = 663937180,
        MinHeight = 1206332797,
        MinHeightAboveTerrain = 2018929951,
        MinHeightAboveVehicleDriverSeat = 3420511035,
        MinHeightAboveWater = 851393034,
        MinHeightAboveWaterWhenBuoyant = 2469744276,
        MinHeliDamping = 2239295053,
        MinHitNormalDotWorldUpForRivers = 2252203055,
        MinHoldBreathDuration = 299633947,
        MinHoldTimeToBlockFullAttachParentMatrixForRelativeOrbit = 897419234,
        MinImpulse = 675904337,
        MinInputToInterruptIdle = 3378374324,
        MinIntensity = 1509127932,
        MinLateralSkidSpeed = 4191348047,
        MinLeanInDirectionTime = 4237013150,
        MinLength = 1352021757,
        MinLookAtArmWoundTime = 1894293331,
        MinMBRToStop = 326250284,
        MinMag = 1967662718,
        MinMagForBikeToBeOnSide = 667864712,
        MinMoveToCoverDistForCoverMeAudio = 3920545059,
        MinMovingProbeOffset = 26449222,
        MinMovingToCoverTimeToStop = 254417857,
        MinNavmeshPatrolRadiusFactor = 1521803727,
        MinNoReticuleAimTime = 2809571307,
        MinNumberFakeApproaches = 2768935848,
        MinOffsetForGetInPosition = 1340388073,
        MinOpenDoorRatioToUseArmIk = 2696374786,
        MinOrientationDeltaToCut = 1055028939,
        MinOrientationDeltaToCutForReverseAngle = 2434688331,
        MinOrientationDeltaToCutWithTrailer = 1873731470,
        MinOrientationSpeedToMaintainDirection = 785961650,
        MinParachutePitch = 1228835903,
        MinPassengerTimeToLeaveVehicle = 3439953457,
        MinPassengersForAttraction = 3561917245,
        MinPathLengthForValidExit = 1596520127,
        MinPedFwdToEntryDotToClampInitialOrientation = 158501595,
        MinPedSpeedToActivateRagdoll = 1213730703,
        MinPhaseToApplyExtraHeadingAi = 2185200792,
        MinPhaseToApplyExtraHeadingPlayer = 3617904707,
        MinPhoneFilmTime = 1169941758,
        MinPhoneFilmTimeHurryAway = 1926295578,
        MinPhysSpeedToActivateRagdoll = 4167152455,
        MinPitch = 509392339,
        MinPitchAngle = 3480847079,
        MinPitchAngle2H = 2669496770,
        MinPitchDefault = 1054799563,
        MinPitchInAir = 2469007968,
        MinPlaneControlAbility = 1670377462,
        MinPlaneDamping = 3955578614,
        MinPlayerJumpOutSpeedBike = 2863410559,
        MinPlayerJumpOutSpeedCar = 2485839112,
        MinPlayerMoveDistanceToSpawnChase = 1676424772,
        MinRate = 1240074404,
        MinRateForInVehicleAnims = 438194982,
        MinRateToPlayCowerReaction = 2568949102,
        MinRatioForClosingDoor = 1807337106,
        MinReactToFireRate = 1887154148,
        MinRelativeHeading = 3137513888,
        MinRemainingAnimDurationToScale = 2357080007,
        MinRemainingRotationForScaling = 1379047521,
        MinRoll = 1178479344,
        MinRotDelta = 1511471000,
        MinRotScale = 614907799,
        MinRotationalSpeedScale = 2167006115,
        MinSafeOrbitDistanceScalingForExtensions = 177572622,
        MinSafeRadiusReductionWithinPedMoverCapsule = 1976571596,
        MinSideNormalForSideSwipe = 48284945,
        MinSnap = 709707651,
        MinSoftLockBreakAtMaxXStickTime = 2357834650,
        MinSoftLockBreakTime = 1649684365,
        MinSoftLockBreakTimeCloseRange = 3539954611,
        MinSpawnTimeForPoliceHeliAfterDestroyed = 4153560394,
        MinSpeed = 1724998945,
        MinSpeedDifferenceForPowerAdjustment = 3207905455,
        MinSpeedForAvoid = 252789847,
        MinSpeedForAvoidDirected = 2493712752,
        MinSpeedForChase = 1337026297,
        MinSpeedForDive = 2304242044,
        MinSpeedForMaxRelativeAttachSpringConstant = 1558815907,
        MinSpeedForSwerve = 2981979817,
        MinSpeedForVehicleMovingQuickly = 1059555640,
        MinSpeedForVehicleToBeConsideredStillSqr = 4258377742,
        MinSpeedForWreck = 2743225815,
        MinSpeedInSwerve = 1487496534,
        MinSpeedLeewayToStartFromPursue = 2231898585,
        MinSpeedToAbortOpenDoor = 492953913,
        MinSpeedToAbortOpenDoorCombat = 3831454313,
        MinSpeedToAbortOpenDoorPlayer = 2387057259,
        MinSpeedToApplyReaction = 672649965,
        MinSpeedToApplyTorque = 601372446,
        MinSpeedToBeConsideredEscapingInVehicle = 2329813458,
        MinSpeedToBlendInDriveFastFacial = 380529072,
        MinSpeedToDeactivate = 3815175242,
        MinSpeedToDive = 152364693,
        MinSpeedToJumpOutOfVehicle = 3352329382,
        MinSpeedToRagdollOpenDoor = 3555981726,
        MinSpeedToRagdollOpenDoorCombat = 820682935,
        MinSpeedToRagdollOpenDoorPlayer = 1024103431,
        MinSprintResultToStand = 3302557202,
        MinSqdDistToSetPos = 2571589718,
        MinStaminaDuration = 1051647876,
        MinStandWaitTimeMS = 1521808097,
        MinSteerAngle = 168285857,
        MinStepOutDist = 427371079,
        MinStickInputToEnableCoverToCover = 1887369799,
        MinStickInputToEnableMoveAroundCorner = 2511576109,
        MinStickInputToMoveAroundCorner = 629671162,
        MinStickInputToMoveInCover = 1261300416,
        MinStickInputXAxisToTurnInCover = 2609438296,
        MinStickMagnitudeForEarlyOutMovement = 2039762038,
        MinStopPhaseToResumeMovement = 2282663253,
        MinStoppingDist = 691235540,
        MinStoppingEdgeCheckProbeOffset = 772858715,
        MinStoppingProbeOffset = 3446268000,
        MinStruggleTime = 2829230620,
        MinStunnedTime = 3100954165,
        MinSuperJumpInitialVelocity = 4057741743,
        MinTakeOffHeadingChangeRate = 72858195,
        MinTakeOffRate = 1117824032,
        MinTargetOffsetX = 69361213,
        MinTargetOffsetY = 3996070487,
        MinTargetOffsetZ = 3765475034,
        MinTargetOffsetZ_TargetInAir = 3515816840,
        MinTargetSpeedToContinueFromPursue = 1829902171,
        MinTargetSpeedToStartFromPursue = 4080325939,
        MinTargetStandingOnTrainSpeed = 3385636076,
        MinThrottle = 1568208081,
        MinTimeBeforeAllowingAutoPeek = 3608928929,
        MinTimeBeforeAllowingCornerMove = 1733226917,
        MinTimeBeforeCanChooseNewPose = 2658395586,
        MinTimeBeforeNewPose = 3603257907,
        MinTimeBeforeReact = 3183040402,
        MinTimeBeforeSwitchLookAt = 1289065068,
        MinTimeBetweenAttemptsToFindNearby = 2714855430,
        MinTimeBetweenAttemptsToFindNewPosition = 765310,
        MinTimeBetweenCloseDoorAttempts = 663934809,
        MinTimeBetweenEyeIkProcesses = 206502145,
        MinTimeBetweenFiringVariations = 817834735,
        MinTimeBetweenFlinches = 2271449308,
        MinTimeBetweenIdleVariations = 2643024561,
        MinTimeBetweenInsults = 3789052240,
        MinTimeBetweenLineOfSightTests = 967712511,
        MinTimeBetweenMeleeJackAttempts = 4106127787,
        MinTimeBetweenMeleeJackAttemptsOnNetworkClone = 1911699676,
        MinTimeBetweenOverheadBulletReactions = 3886708440,
        MinTimeBetweenPlayerIdleVariations = 1573385593,
        MinTimeBetweenQuickGlancesInSameDirection = 1927524225,
        MinTimeBetweenReactionChecksForGunAimedAt = 1752177996,
        MinTimeBetweenReactions = 3817763328,
        MinTimeBetweenSharkDispatches = 4195725397,
        MinTimeBetweenShootOutTiresGlobal = 470555105,
        MinTimeBetweenStatusUpdates = 1814559575,
        MinTimeBetweenStrafeDirectionChanges = 4157008494,
        MinTimeBoatOutOfWaterForExit = 3458993355,
        MinTimeElapsedForGroundWrithe = 3919163430,
        MinTimeForAmbientReaction = 1295611070,
        MinTimeForCornerMove = 4067447650,
        MinTimeForHandsUp = 1376968536,
        MinTimeForInitialState = 3439568038,
        MinTimeInCombatToNotStreamIn = 2838084369,
        MinTimeInCombatToShootOutTires = 1335171882,
        MinTimeInCurrentStateForStill = 2871611248,
        MinTimeInFreewheelState = 3840966049,
        MinTimeInHornState = 3070028166,
        MinTimeInPedalState = 2196376340,
        MinTimeInRagdoll = 3903892409,
        MinTimeInShuntStateBeforeRestart = 3200053693,
        MinTimeInSitToStillStateToReverse = 3389614983,
        MinTimeInStandState = 3553993325,
        MinTimeInStateForForcedFire = 1232297261,
        MinTimeInStateToAllowTransitionFromFixieSkid = 863715729,
        MinTimeInTaskToCheckForDamage = 2132426494,
        MinTimeMovingAwayToGiveToWitness = 1927499316,
        MinTimeRemainingForGroundWrithe = 2331611470,
        MinTimeSinceAnyCircleJoined = 4160428671,
        MinTimeSinceLastHostileAction = 1740762106,
        MinTimeSinceLastSpotted = 3151249820,
        MinTimeSinceSameCircleJoined = 1038805177,
        MinTimeSinceTalkingEndedToMakeCall = 3385798684,
        MinTimeSinceTalkingEndedToSayContextForCall = 4230329614,
        MinTimeSinceTargetTalkingEndedToMakeCall = 2919871050,
        MinTimeSpentInEarLoopToSayContextForCall = 2980295761,
        MinTimeSpentSwimmingToRespectMotionTask = 2968196113,
        MinTimeStayPinned = 2308421233,
        MinTimeTargetHasBeenTalkingToMakeCall = 4048361920,
        MinTimeToBePinnedDown = 3650240986,
        MinTimeToCallPolice = 821642865,
        MinTimeToChangeChaseOnFootSpeed = 615112755,
        MinTimeToConsiderDangerousDriving = 3887812374,
        MinTimeToConsiderPedGoingToDoorPriority = 423470112,
        MinTimeToFleeInVehicle = 3344957179,
        MinTimeToHesitate = 3189387953,
        MinTimeToKeepEngineAndLightsOnWhileParked = 2478597497,
        MinTimeToPrepareWeapon = 3427043837,
        MinTimeToReact = 3649567479,
        MinTimeToRepeatLastAnimation = 1359604368,
        MinTimeToScale = 2681841281,
        MinTimeToSpendInEarLoopToPutDownPhone = 2423924604,
        MinTimeToSpendInTask = 3005241839,
        MinTimeToStandUp = 2267264803,
        MinTimeToStayUprightAfterImpact = 3608841595,
        MinTimeToSwerve = 1907731990,
        MinTimeToWait = 460015891,
        MinTimeToWaitForOtherPedToExit = 746970568,
        MinTimeToWaitForShot = 1841691026,
        MinTimeUntilReturnToIdleFromAimAfterAimedAt = 1630578621,
        MinTimeUntilReturnToIdleFromAimDefault = 360559002,
        MinTimeoutToAcquireLineOfSight = 3438052999,
        MinTransScale = 1999362333,
        MinTranslationalScale = 2870050188,
        MinTurnApproachRate = 1055045198,
        MinTurnProbeOffset = 3317722172,
        MinTurnSpeedMotionOverPOI = 2806951563,
        MinUpdatesBeforeApplyingMotionBlur = 1025607184,
        MinUsesForIdleVariationChange = 3007638827,
        MinUsesForOutroReactVariationChange = 1069071024,
        MinUsesForPeekingVariationChange = 1848963111,
        MinUsesForPinnedVariationChange = 3203888722,
        MinValue = 324547252,
        MinValueForCorrection = 2782043564,
        MinVehVelMagForBicycleSideSwipe = 3048137979,
        MinVehVelMagForSideSwipe = 3804354300,
        MinVehVelocityToGoThroughWindscreen = 1165173355,
        MinVehVelocityToGoThroughWindscreenMP = 2444940549,
        MinVehicleCollisionDamageScale = 1127062988,
        MinVehicleWarning = 798220376,
        MinVel = 66577426,
        MinVelMag = 3279914945,
        MinVelStillStart = 2988949625,
        MinVelStillStop = 2175562542,
        MinVelThreshold = 3891030916,
        MinVelThroughNormalForSideSwipe = 1658632009,
        MinVelocity = 2073951791,
        MinVelocityForDriveByAssistedAim = 3025537526,
        MinVelocityForFast = 2876804674,
        MinVelocityToRagdollPed = 52645552,
        MinVelocityToScale = 3538596479,
        MinWaitTime = 3965435915,
        MinWaitTimeBetweenTakeOffsMS = 3519366748,
        MinWaitTimeToPlayPlayerIdleVariations = 1797303037,
        MinWatchTime = 424721387,
        MinWatchTimeHurryAway = 3859810396,
        MinWheelieAbility = 1924165020,
        MinWorldLimitsPlayerX = 3684109243,
        MinWorldLimitsPlayerY = 164620332,
        MinWritheTime = 4260165656,
        MinXYVelForWantsToMove = 514488562,
        MinimumDownedTime = 3571595842,
        MinimumShotReactionTimeAIMS = 1078427012,
        MinimumShotReactionTimePlayerMS = 3405078066,
        MobileChatScenarioMayAbort = 1434985449,
        MobilePhoneCameraControlHelperRef = 376729145,
        ModelForParachuteInMP = 745109363,
        ModelForParachuteInSP = 1753140963,
        ModelNamesToConsiderPlayersForScoringPurposes = 1071210221,
        Modes = 945555571,
        ModifierName = 2966939369,
        MotionBlurSettings = 490368749,
        MotionBlurStrength = 1859659636,
        MotionLookAtBlendRate = 1566172518,
        MotionLookAtRotationLimit = 3198801841,
        MotionLookAtTurnRate = 1972120707,
        MotivationMax = 2674738037,
        MotivationMin = 4238411479,
        MouseMaxHeadingSpeedMax = 2735899528,
        MouseMaxHeadingSpeedMin = 419948133,
        MouseMaxPitchSpeedMax = 1102394099,
        MouseMaxPitchSpeedMin = 2160264290,
        MoveBlendRatioForFarGoto = 1440512567,
        MoveNetworkBlendoutDuration = 780063382,
        MoveParameters = 1126598037,
        MoveRateOverride = 3469377736,
        MoveToDistanceInVehicle = 1359250131,
        MovementAcceleration = 1913804545,
        MovementAwayWeighting = 1351646535,
        MovementClipRate = 4205396201,
        MovementClipSets = 3053450155,
        MovementCostModifier = 1366066164,
        MovementMotionBlurMaxSpeed = 1743155234,
        MovementMotionBlurMaxStrength = 1328935990,
        MovementMotionBlurMinSpeed = 3274038425,
        Moving = 3575677823,
        MovingAnimStateInfos = 2676261337,
        MovingAwayVelocityMSThreshold = 1549370724,
        MovingDirectionSmoothingAngleMax = 916804787,
        MovingDirectionSmoothingAngleMin = 3163856764,
        MovingDirectionSmoothingForwardAngleRun = 4229364158,
        MovingDirectionSmoothingForwardAngleWalk = 817979133,
        MovingDirectionSmoothingForwardRateAccelerationMod = 206173392,
        MovingDirectionSmoothingForwardRateMod = 4209639571,
        MovingDirectionSmoothingRateAccelerationMax = 1021183862,
        MovingDirectionSmoothingRateAccelerationMin = 4203477475,
        MovingDirectionSmoothingRateMaxRun = 2229072832,
        MovingDirectionSmoothingRateMaxWalk = 2584063876,
        MovingDirectionSmoothingRateMin = 2151433465,
        MovingEdgeTestEndYOffset = 189580395,
        MovingEdgeTestStartYOffset = 1678354404,
        MovingExtraHeadingChangeAngleMax = 3031402448,
        MovingExtraHeadingChangeAngleMin = 243413468,
        MovingExtraHeadingChangeRate = 830448667,
        MovingExtraHeadingChangeRateAcceleration = 932904484,
        MovingExtraHeadingChangeRateAccelerationMax = 3423772986,
        MovingExtraHeadingChangeRateAccelerationMin = 2172130562,
        MovingExtraHeadingChangeRateRun = 2979286721,
        MovingExtraHeadingChangeRateWalk = 3334261987,
        MovingMultiplierBonus = 474003950,
        MovingVarsSet = 2593822105,
        MovingVehicleVelocityThreshold = 309425308,
        MovingWalkAnimRateAcceleration = 3381710529,
        MovingWalkAnimRateMax = 1051732090,
        MovingWalkAnimRateMin = 2563588038,
        MpActivationModifiers = 755518553,
        MpMaxHealthLossForQuickGetup = 1666177823,
        MpMinHealthForQuickGetup = 888956679,
        MpPlayerQuickBlendOut = 558729515,
        MultiplayerClimbClamberRateModifier = 935832867,
        MultiplayerClimbRunningRateModifier = 2530564765,
        MultiplayerClimbStandRateModifier = 367433608,
        MultiplayerCoverIntroRateModifier = 674066505,
        MultiplayerEnterExitJackVehicleRateModifier = 891602871,
        MultiplayerIdleTurnRateModifier = 2570857418,
        MultiplayerLadderRateModifier = 2900803312,
        MultiplayerReloadRateModifier = 1245165468,
        MultiplierForDangerousDriving = 4090325919,
        NAME_BIG = 1877679104,
        NAME_MED = 2980984179,
        NAME_SMALL = 298596333,
        NETWORKOPTIONS_FILE = 3850710962,
        NMBodyScale = 380014673,
        NM_TUNING_FILE = 1639152529,
        NO_REACTION = 3073843763,
        NavMeshPoint = 680699981,
        NavMeshPoints = 2288844751,
        NearClip = 1325746994,
        NearDistanceForOrientation = 4175205823,
        Nearby = 3709090817,
        NeckShot = 256476042,
        NeckStrengthTuning = 2519031107,
        NetworkBlendDuration = 1021030104,
        NetworkBlendDurationOpenDoorCombat = 132682005,
        NetworkBlendInDuration = 8008463,
        NetworkBlendOutDuration = 2175660835,
        NetworkBlendOutDurationRun = 235129999,
        NetworkBlendOutDurationRunStart = 2896892589,
        NeverUse = 2562048776,
        NewLeanSteerApproachRate = 1728172908,
        NextTransitionClipId = 3399412192,
        NextTransitionExtraScalar = 2392693984,
        NoCoverEastFaceCenter = 3014113591,
        NoCoverEastFaceNorth = 4173874730,
        NoCoverEastFaceSouth = 3315722870,
        NoCoverNorthFaceCenter = 1753198982,
        NoCoverNorthFaceEast = 3074030570,
        NoCoverNorthFaceWest = 4102086546,
        NoCoverSouthFaceCenter = 1192754605,
        NoCoverSouthFaceEast = 3712292480,
        NoCoverSouthFaceWest = 3483214048,
        NoCoverVehicleDoors = 4158814707,
        NoCoverWestFaceCenter = 1200088335,
        NoCoverWestFaceNorth = 980667646,
        NoCoverWestFaceSouth = 4149395173,
        NoParachuteMaxCollisionNormalThreshold = 1928060490,
        NoParachuteMaxPitch = 2440882257,
        NoParachuteMinCollisionNormalThreshold = 4262842160,
        NoParachuteTimeForMinCollisionNormalThreshold = 336137001,
        NoReticuleLockOnRangeModifier = 3583828968,
        NoReticuleMaxLockOnRange = 2308178823,
        NoReticuleTargetAimPitchLimit = 1235721286,
        NoReticuleTargetAngularLimit = 4232341165,
        NoReticuleTargetAngularLimitClose = 4081370038,
        NoReticuleTargetAngularLimitCloseDistMax = 3453384537,
        NoReticuleTargetAngularLimitCloseDistMin = 2946314787,
        NonFlyableArea = 3154226565,
        NonFlyableAreaArray = 665455491,
        NormalPreferredDepth = 1606727990,
        NormalTargettingDifficultyInfo = 3104062807,
        NormalThresholds = 3543710223,
        NotBeingPushedDelayMS = 4123949353,
        NotBeingPushedOnGroundDelayMS = 739931697,
        NotProfessional = 931067397,
        NumCapsuleTests = 2133560880,
        NumEarlyVehicleEntryDriversAllowed = 889613745,
        NumFramesToPersistLargeVerticalAcceleration = 2142946869,
        NumTests = 465899626,
        NumToUpdatePerFrame = 575445590,
        NumberOfBurstsMax = 3616069026,
        NumberOfBurstsMin = 236118490,
        NumberOfShotsPerBurstMax = 428905168,
        NumberOfShotsPerBurstMin = 2577107356,
        OCMClearanceCapsuleRadius = 852914750,
        OCMCrouchedForwardClearanceOffset = 3832321302,
        OCMCrouchedHeightOffset = 461310715,
        OCMSideClearanceDepth = 4269848077,
        OCMSideTestDepth = 2079300420,
        OCMStandingForwardClearanceOffset = 1249475394,
        OCMStandingHeightOffset = 708594816,
        ON_BIKE = 1812735189,
        ObjectActivationForceMultiplier = 116532981,
        ObjectMinSpeedForActivation = 602234407,
        ObstructionProbe = 1865732807,
        ObstructionProbeAngleA = 3742382496,
        ObstructionProbeAngleB = 3275063787,
        ObstructionProbeAngleC = 4169133183,
        OcclusionSweep = 1207465912,
        Occupied = 1339021909,
        OffsetLimits = 3479495276,
        OnBalanceFailed = 3974797120,
        OnBalanceFailedSprintExhausted = 3419269985,
        OnBalanceFailedStairs = 1418190490,
        OnBalanceFailure = 494965274,
        OnBeingPushed = 577683658,
        OnBeingPushedOnGround = 258986085,
        OnBeingPushedOnGroundTooLong = 1444135973,
        OnCatchFallSuccess = 4246526405,
        OnDisableDriveToGetup = 553250717,
        OnElectrocuteFinished = 3413282736,
        OnEnableDriveToGetup = 609938430,
        OnFireWeightingMult = 3746655905,
        OnFootBlendInDuration = 1084086108,
        OnFootClipRate = 4280609914,
        OnFootLookAtDampingRef = 2538678656,
        OnMovingGround = 4192987078,
        OnNotBeingPushed = 256038063,
        OnSlopeThreshold = 1801923157,
        OnStairs = 3396170193,
        OnSteepSlope = 3705331241,
        OneHandedClipSetName = 448596277,
        OnlyAllowForShot = 3256506769,
        OnlyInContact = 4063846733,
        OnlyNotInContact = 122191424,
        OnlyUseForGangPeds = 2711794664,
        OnlyUseForLawEnforcementPeds = 4078932877,
        OnlyUseForReactions = 1952942912,
        OpenDoorBlendDurationFromNormalAlign = 1615640364,
        OpenDoorBlendDurationFromOnVehicleAlign = 754839673,
        OpenDoorToJackBlendDuration = 3439162962,
        Optimal = 2980335366,
        OptimumDistToLeftCoverEdge = 796885552,
        OptimumDistToLeftCoverEdgeCrouched = 3881315855,
        OptimumDistToRightCoverEdge = 2188704570,
        OptimumDistToRightCoverEdgeCrouched = 2688479781,
        OrbitDistance = 2733631256,
        OrbitDistanceDamping = 337202266,
        OrbitDistanceLimitScaling = 1688148358,
        OrbitDistanceLimitSpringConstant = 2829148759,
        OrbitDistanceLimitSpringDampingRatio = 1084689577,
        OrbitDistanceLimitsForBasePosition = 2111969249,
        OrbitDistanceScalingForCustomFirstPersonFallBack = 3978450060,
        OrbitDistanceScalingLimits = 1871429041,
        OrbitDistanceScalingSpringConstant = 2983717675,
        OrbitDistanceScalingSpringDampingRatio = 1300443955,
        OrbitDistanceScalingToApplyWhenPushing = 2688276525,
        OrbitPitchLimits = 1974814289,
        OrbitPitchOffsetWhenFullyDucked = 3105010187,
        OrientationSpring = 3781066831,
        OutDuration = 3592760554,
        OuterDistanceThreshold = 2366160443,
        OutroClip0Id = 3585249404,
        OutroMaxScale = 2206745704,
        OutroMovementDuration = 2943938244,
        OutroRate = 2260414033,
        OutroReact1HVariationClipsets = 1976510010,
        OutroReact2HVariationClipsets = 1754157237,
        OutroRotationScalingDefaultEndPhase = 4246951180,
        OutroRotationScalingDefaultStartPhase = 2960195918,
        OutroScalingDefaultEndPhase = 1459623344,
        OutroScalingDefaultStartPhase = 3467497537,
        OverVehicle = 2691364124,
        OverlapSpeedMultiplier = 2358940861,
        Overlay = 370428790,
        OverrideDirections = 198397458,
        OverrideElasticity = 134807671,
        OverrideFleeDirection = 3320627039,
        OverrideFlipForce = 2230782934,
        OverrideFriction = 3907466188,
        OverrideInitialForce = 3258479231,
        OverrideInverseMassScales = 143477949,
        OverrideReactDirection = 3275732457,
        OverrideReactionType = 1094485493,
        OverrideRootLiftForce = 1333505912,
        OverrideStuckOnVehicleSets = 2561285304,
        OverwriteMaxPitch = 2955289081,
        PARTITION_MAX = 2899492762,
        PED_BOUNDS_FILE = 2374071028,
        PED_BRAWLING_STYLE_FILE = 1575806881,
        PED_COMPONENT_CLOTH_FILE = 1241304438,
        PED_COMPONENT_SETS_FILE = 1714450686,
        PED_DRIVES_AVERAGE_CAR = 1662727357,
        PED_DRIVES_BIG_CAR = 1066836384,
        PED_DRIVES_BOAT = 2087263659,
        PED_DRIVES_MOTORCYCLE = 698500424,
        PED_DRIVES_POOR_CAR = 3796340206,
        PED_DRIVES_RICH_CAR = 740214256,
        PED_HEALTH_FILE = 2737334773,
        PED_IK_SETTINGS_FILE = 4183131447,
        PED_NAV_CAPABILITES_FILE = 3376025535,
        PED_PERCEPTION_FILE = 1804477999,
        PED_SPECIAL_ABILITIES_FILE = 3685712067,
        PED_TASK_DATA_FILE = 3947749085,
        PED_VARS_FILE = 915034040,
        PLAYER_CARD_SETUP = 1504533439,
        POILookAtBlendRate = 1217360623,
        POILookAtRotationLimit = 3819703101,
        POILookAtTurnRate = 1321758856,
        POLICE_SCANNER_COLOUR_beige = 2477037232,
        POLICE_SCANNER_COLOUR_black = 52583446,
        POLICE_SCANNER_COLOUR_blue = 2253400966,
        POLICE_SCANNER_COLOUR_brown = 4012089111,
        POLICE_SCANNER_COLOUR_graphite = 437487559,
        POLICE_SCANNER_COLOUR_green = 730308174,
        POLICE_SCANNER_COLOUR_grey = 3129410619,
        POLICE_SCANNER_COLOUR_orange = 1762671403,
        POLICE_SCANNER_COLOUR_pink = 2615326998,
        POLICE_SCANNER_COLOUR_red = 4157715503,
        POLICE_SCANNER_COLOUR_silver = 2969646890,
        POLICE_SCANNER_COLOUR_white = 1645071976,
        POLICE_SCANNER_COLOUR_yellow = 1358390657,
        POLICE_SCANNER_PREFIX_bright = 2318284788,
        POLICE_SCANNER_PREFIX_dark = 3921902053,
        POLICE_SCANNER_PREFIX_light = 840729009,
        POPGROUP_AERIAL = 2486476801,
        POPGROUP_AMBIENT = 2602754504,
        POPGROUP_AQUATIC = 3747129892,
        POPGROUP_IN_VEHICLE = 3190143096,
        POPGROUP_IS_GANG = 198544766,
        POPGROUP_NETWORK_COMMON = 1732741445,
        POPGROUP_SCENARIO = 2037609896,
        POPGROUP_WILDLIFE = 600606236,
        POSTFX_EASE_IN = 2556745525,
        POSTFX_EASE_IN_HOLD_EASE_OUT = 1791815485,
        POSTFX_EASE_OUT = 3362010507,
        POSTFX_IN_HOLD_OUT = 332192867,
        POSTFX_LOOP_ALL = 535426628,
        POSTFX_LOOP_HOLD_ONLY = 2694408850,
        POSTFX_LOOP_NONE = 3585121058,
        PS3_SCRIPT_RPF = 3650318782,
        PadShake = 2667671232,
        PadShakeMaxDuration = 2836403845,
        PadShakeMaxHeight = 2333975606,
        PadShakeMaxIntensity = 1208994934,
        PadShakeMinDuration = 3639487949,
        PadShakeMinHeight = 2222398831,
        PadShakeMinIntensity = 2760872373,
        ParachuteBones = 3328657748,
        ParachuteCamera = 3869597064,
        ParachuteCloseUpCamera = 2309595247,
        ParachuteInitialVelocityY = 1202762864,
        ParachuteInitialVelocityZ = 904794347,
        ParachuteMass = 4131153122,
        ParachuteMassReduced = 3018517000,
        ParachutePack = 2636443310,
        ParachutePackVariations = 1735940634,
        ParachutePhysics = 3256630458,
        ParachuteProbeRadius = 4118156471,
        ParachuteUpThreshold = 739494681,
        Parachuting = 2611998079,
        ParachutingAi = 3248104514,
        ParachutingFilterId = 3728753498,
        ParamSets = 315966693,
        Params = 1933425356,
        ParentRelativeAttachOffset = 1399337810,
        ParentRelativeAttachOffsetAtOrbitHeadingLimits = 442114217,
        ParkingSpaceBlockedMaxAttempts = 4245532224,
        ParkingSpaceBlockedWaitTimePerAttempt = 1316038287,
        Passive = 1672543877,
        PathFinding = 394936210,
        PavementFloodFillSearchRadius = 3609661010,
        PedActivationForceMultiplier = 3758147000,
        PedAngleLimitsForSkydiving = 2243095299,
        PedDirToPedCoverCosAngleTol = 1073641398,
        PedFearImpact = 3170606833,
        PedGenBlockedAreaMinRadius = 3928192642,
        PedGenBlockingAreaLifeTimeMS = 1799800134,
        PedMoveAccel = 1030928652,
        PedMoveDecel = 1966094123,
        PedTestRadius = 2802682741,
        PedTestXOffset = 763167134,
        PedTestYOffset = 3960625221,
        PedTestZOffset = 480380605,
        PedTestZStartOffset = 1752043243,
        PedToCoverCapsuleRadius = 60938529,
        PedToCoverEndPullBackDistance = 1271601300,
        PedToCoverEndZOffset = 649298289,
        PedalGearApproachRate = 2418985851,
        PeekToEdgeTurnBlendDuration = 1163008630,
        PeekingAnimStateInfos = 1958652331,
        PeekingHigh1HVariationClipsets = 86703483,
        PeekingHigh2HVariationClipsets = 1692855661,
        PeekingLow1HVariationClipsets = 3656589599,
        PeekingLow2HVariationClipsets = 4084903537,
        PeekingVariationAnimStateInfos = 2572412881,
        PelvisInterp = 2837302706,
        PelvisInterpMoving = 115587354,
        PelvisInterpOnDynamic = 2709476201,
        Penalty = 581818714,
        Periodic = 1887945139,
        PersonalityName = 4206114216,
        PhaseDuringDeployToConsiderOut = 1259738869,
        PhaseToBlendOut = 4149318965,
        PhoneFov = 732629634,
        PickingUpBikeModifier = 1578175347,
        PinnedDownBlindFireChance = 1504716899,
        PinnedDownByBulletRange = 3328891889,
        PinnedDownDecreaseAmountPerSecond = 2317940667,
        PinnedDownPeekChance = 3488557674,
        PinnedDownTakeCoverAmount = 2529898856,
        PinnedDownThreshold = 2906996848,
        PinnedHigh1HVariationClipsets = 186750731,
        PinnedHigh2HVariationClipsets = 1643071074,
        PinnedIdleAnimStateInfos = 430330313,
        PinnedIntroAnimStateInfos = 2080360880,
        PinnedLow1HVariationClipsets = 1337721029,
        PinnedLow2HVariationClipsets = 3647756430,
        PinnedOutroAnimStateInfos = 3262741183,
        PitchAcceleration = 4133472264,
        PitchChangeRateAcceleration = 724740943,
        PitchClampMax = 4112643692,
        PitchClampMin = 1388744206,
        PitchForBraking = 2154895854,
        PitchForMaxIntensity = 2952102575,
        PitchForMinIntensity = 4133137923,
        PitchForNormal = 2757465295,
        PitchInDirectionComponent = 3608118347,
        PitchInDirectionForce = 2459418685,
        PitchOffsetAtMaxHeight = 2605085544,
        PitchOffsetAtMinHeight = 3346546090,
        PitchPullAroundErrorScalingBlendLevel = 3418263557,
        PitchPullAroundMaxMoveSpeed = 430354724,
        PitchPullAroundMinMoveSpeed = 2976192130,
        PitchPullAroundSpeedAtMaxMoveSpeed = 634917686,
        PitchPullAroundSpringConstant = 835784625,
        PitchPullAroundSpringDampingRatio = 1088580250,
        PitchRatioForLinearVZMax = 3041351606,
        PitchRatioForLinearVZMin = 2724758116,
        PitchSideAngle = 107265024,
        PitchTorqueMax = 3768610799,
        PitchTorqueMin = 2554943154,
        PivotOverBoundingBoxSettings = 588927535,
        PivotPosition = 3256568637,
        PlaneDrivingSubtaskArrivalDist = 1499169614,
        PlaneTargetArriveDist = 370645093,
        PlaneTargetArriveDistTaxiOnGround = 1118749782,
        PlayerBumpedByCar = 3418860704,
        PlayerBumpedByCloneCarActivationModifier = 3611321062,
        PlayerCapsuleMinSpeedForContinuousPushActivation = 3679622218,
        PlayerClearedVehicleDelay = 112556840,
        PlayerClearedVehicleSmartFallDelay = 2235898070,
        PlayerCopCarModifier = 1479577695,
        PlayerCopModifier = 4108478935,
        PlayerDeath = 2720032072,
        PlayerDeathMP = 1586436866,
        PlayerDeathSP = 3600525461,
        PlayerHasslingModifier = 3008009434,
        PlayerIdleHigh0HVariationClipsets = 3420717239,
        PlayerIdleHigh1HVariationClipsets = 2643498096,
        PlayerIdleHigh2HVariationClipsets = 1210186805,
        PlayerIdleIntroAnimRate = 2967257859,
        PlayerIdleLow0HVariationClipsets = 1469086565,
        PlayerIdleLow1HVariationClipsets = 421291191,
        PlayerIdleLow2HVariationClipsets = 2423980252,
        PlayerLookAtDebugDraw = 2179898613,
        PlayerMoveAccel = 3051090926,
        PlayerMoveDecel = 1886735419,
        PlayerMoverFixupMaxExtraHeadingChange = 1887702115,
        PlayerMp = 410406055,
        PlayerPedModifier = 2396547402,
        PlayerQuickBlendOut = 2430282312,
        PlayerSexyPedModifier = 390614501,
        PlayerSprintEntryRate = 1168875174,
        PlayerStatInfos = 977451662,
        PlayerSwankyCarMax = 3873670579,
        PlayerSwankyCarMin = 369519904,
        PlayerSwankyCarModifier = 1078762608,
        PlayerSwimTimeThreshold = 422419421,
        PlayerTimeBetweenLookAtsMax = 408684949,
        PlayerTimeBetweenLookAtsMin = 2542169368,
        PlayerTimeMyVehicleLookAtsMax = 3266178324,
        PlayerTimeMyVehicleLookAtsMin = 831935567,
        Player_IdleTurnRate = 1662197919,
        Player_MBRAcceleration = 3782895898,
        Player_MBRDeceleration = 1302286994,
        PointOnMap = 2637460797,
        PopulationFleeMod = 3370827836,
        Pos = 4135922358,
        PositionDiffStartBlend = 126173811,
        PowerForMaxAdjustment = 3574337729,
        PowerForMinAdjustment = 4239471096,
        PreEmptiveEdgeActivationMaxDistance = 3827728081,
        PreEmptiveEdgeActivationMaxHeadingDiff = 1934953324,
        PreEmptiveEdgeActivationMaxVel = 3639122208,
        PreEmptiveEdgeActivationMinDesiredMBR2 = 3990938220,
        PreEmptiveEdgeActivationMinDotVel = 2370073816,
        PreToPostCollisionLookAtOrientationBlendValue = 3068587259,
        PrecisionAimSettings = 2539872798,
        PredictiveBraceBlendInDuration = 1609589815,
        PredictiveBraceBlendOutDuration = 2469517273,
        PredictiveBraceMaxUpDotSlope = 1011217048,
        PredictiveBraceProbeLength = 2158524964,
        PredictiveBraceStartDelay = 3163116709,
        PredictiveProbeZOffset = 1351443366,
        PredictiveRagdollIntersectionDot = 1107591412,
        PredictiveRagdollProbeLength = 1048227809,
        PredictiveRagdollProbeRadius = 503191318,
        PredictiveRagdollRequiredVelocityMag = 2170844885,
        PredictiveRagdollStartDelay = 3462282137,
        PreferNearWaterSurfaceArrivalRadius = 2212250161,
        PreventDirectTransitionToReverseFromSit = 1025905604,
        PreventRotationOvershoot = 634174859,
        PreventShufflingExtraRange = 1174072295,
        PreventTranslationOvershoot = 570011198,
        PreviousTransitionClipId = 681665994,
        PreviousTransitionExtraScalar = 2390268263,
        PrioHarmless = 3537128593,
        PrioIngangOrFriend = 2239503730,
        PrioMeleeCombatThreat = 3520267510,
        PrioMeleeDead = 2219818555,
        PrioMeleeDownedCombatThreat = 3711072717,
        PrioMeleeInjured = 2459910426,
        PrioMeleePotentialThreat = 1405902341,
        PrioMissionThreat = 1044442786,
        PrioMissionThreatCuffed = 647449150,
        PrioNeutral = 2861651580,
        PrioNeutralInjured = 354050193,
        PrioPlayer2Player = 1964865895,
        PrioPlayer2PlayerAttackers = 762484474,
        PrioPlayer2PlayerCuffed = 1986201193,
        PrioPlayer2PlayerEveryone = 3895688789,
        PrioPlayer2PlayerStrangers = 2061852453,
        PrioPotentialThreat = 1168690220,
        PrioScriptedHighPriority = 1053617936,
        PriorityCoverWeight = 3734777024,
        PriorityCoverWeighting = 1292700163,
        ProbSpawnHeli = 2463315253,
        ProbabilityDrawWeaponWhenLosing = 1774223506,
        ProbabilityWeighting = 51557962,
        Probe = 217069262,
        ProbeHeightAbovePelvis = 1229015521,
        ProbeResults = 3041273548,
        Probes = 1934123857,
        ProcessPhysicsApproachRate = 2123652996,
        Professional = 2673189131,
        ProgressiveTerrainAvoidanceAngleD = 4040142753,
        PullAlongside = 2022288628,
        PullAroundSettings = 1394164846,
        PullAroundSettingsForLookBehind = 914396031,
        PullBackSpringConstant = 1125215459,
        PullBackTowardsCollision = 333745998,
        PullPinClipId = 547753211,
        Pursue = 2777285984,
        PursuitModeExtraHeadingRate = 2496636494,
        PursuitModeGallopRateFactor = 3846643666,
        PushAngleDotTolerance = 1293114690,
        PushBeyondEntitiesIfClipping = 2276761303,
        PushInSpringConstant = 2562227249,
        PushedThresholdOnGround = 476585181,
        PutOnHelmetClipId = 2026680640,
        QUADBIKE = 1011863180,
        QuickBlendOut = 784154981,
        RADIO_FILE = 2322405299,
        RADIO_GENRE_CLASSIC_HIPHOP = 255693040,
        RADIO_GENRE_COUNTRY = 1750835908,
        RADIO_GENRE_DANCE = 43700981,
        RADIO_GENRE_LEFT_WING_TALK = 3586021020,
        RADIO_GENRE_MODERN_HIPHOP = 285221172,
        RADIO_GENRE_POP = 4176867203,
        RADIO_GENRE_UNSPECIFIED = 4132096390,
        RAGDOLL_BUTTOCKS = 540107349,
        RAGDOLL_CLAVICLE_LEFT = 2288805232,
        RAGDOLL_CLAVICLE_RIGHT = 488421620,
        RAGDOLL_FOOT_LEFT = 2446307443,
        RAGDOLL_FOOT_RIGHT = 4158664243,
        RAGDOLL_HAND_LEFT = 3905421121,
        RAGDOLL_HAND_RIGHT = 1124094743,
        RAGDOLL_HEAD = 111082097,
        RAGDOLL_LOWER_ARM_LEFT = 125251313,
        RAGDOLL_NECK = 339046583,
        RAGDOLL_SHIN_LEFT = 2408459571,
        RAGDOLL_SHIN_RIGHT = 3373894112,
        RAGDOLL_SPINE0 = 2548005619,
        RAGDOLL_SPINE1 = 1729141078,
        RAGDOLL_SPINE2 = 1967764936,
        RAGDOLL_SPINE3 = 3266498717,
        RAGDOLL_THIGH_LEFT = 1739907813,
        RAGDOLL_THIGH_RIGHT = 3821605495,
        RAGDOLL_UPPER_ARM_LEFT = 2053403138,
        RAGDOLL_UPPER_ARM_RIGHT = 1968199161,
        RadiusForContact = 1978969151,
        RadiusForFindNearby = 2410167662,
        RadiusForViewportCheck = 3808847755,
        RadiusScalingForClippingTest = 2642729834,
        RadiusScalingForOcclusionTest = 2763528752,
        RagdollAbortPoseDistanceThreshold = 1562486689,
        RagdollAbortPoseMaxVelocity = 445822306,
        RagdollBlendEnvelopeRef = 2513422573,
        RagdollComponentAirResistanceForce = 1187767114,
        RagdollComponentAirResistanceMinStiffness = 3808435735,
        RagdollIntoWaterVelocity = 477015084,
        RagdollPlayerDistanceThreshold = 3324445918,
        RagdollUnderWheelTuning = 2982454130,
        RagdollingModifier = 3445942281,
        RageRagdollImpulseTuning = 3405457664,
        Ram = 3087082769,
        RandomEventData = 4113341331,
        RandomEventName = 790968462,
        RandomEventTimeIntervalMax = 2841351028,
        RandomEventTimeIntervalMin = 2347950667,
        RandomEventType = 2154193106,
        RandomEventTypeName = 2873713085,
        RandomiseLeadingHand = 2410986509,
        RandomiseSettledTime = 2400689426,
        Randomness = 3060363673,
        RangeOffset = 3211719875,
        RangePercentage = 2083139838,
        RangeToUseDynamicCoverPointMax = 2744819135,
        RangeToUseDynamicCoverPointMin = 2676905487,
        RapidFireBoostShotImpulseMult = 926832193,
        RapidFireBoostShotMaxRandom = 2456570730,
        RapidFireBoostShotMinRandom = 3069940419,
        RapidHitCount = 1056935054,
        RappellingAlignment = 4264482777,
        ReactAndFleeBlendOutPhase = 851779527,
        ReactToOtherEntity = 409978509,
        ReactionMode = 3828609944,
        ReactionTime = 1025142686,
        RearExitSideOffset = 1266778169,
        RecentlyLookedAtEntityModifier = 2971794167,
        RecentlyLookedAtPlayerModifier = 975579249,
        RecklessCarModifier = 813645662,
        RecklessCarSpeedMax = 199234802,
        RecklessCarSpeedMin = 1168459099,
        RecoilShakeAmplitudeScaling = 2294924343,
        RecreateWeaponTime = 3706230533,
        ReduceDownedTimeByPerformanceTime = 1128285975,
        ReduceWithPedAngularVelocity = 3126754678,
        ReduceWithPedVelocity = 1660316244,
        ReenterFallLandThreshold = 4199432698,
        Refuel = 3888134503,
        RegainComet = 605981827,
        RegisteredStacks = 3283104082,
        RegularExitDefaultPhaseThreshold = 5170829,
        RejectLockIfBestTargetIsInCover = 3603478229,
        RejectLockonHeadingTheshold = 655402948,
        RelativeAttachPosition = 2323851759,
        RelativeAttachPositionSmoothRate = 2878053132,
        RelativeAttachSpringConstantEnvelopeRef = 4086545075,
        RelativeAttachSpringConstantLimits = 1204776061,
        RelativeAttachSpringConstantLimitsForPassengers = 340115724,
        RelativeAttachSpringDampingRatio = 2918672176,
        RelativeHeadingLimitsForMobilePhoneCamera = 503778969,
        RelativeLookAtPosition = 54415504,
        RelativeOffset = 4287557601,
        RelativeOrbitHeadingLimits = 1654683326,
        Relaxation = 1783791261,
        ReleaseDelay = 4289809678,
        ReleaseDuration = 4066793496,
        ReleaseSub = 2933611601,
        RemoveReticuleDuringBlindFire = 3024014754,
        RenderAimArcDebug = 3262184677,
        RenderArcsAtCoverPosition = 4249860971,
        RenderDebug = 3284686610,
        RenderDebugDraw = 2797308174,
        RenderDebugToTTY = 3670985951,
        RenderId = 2789976084,
        Rendering = 67050499,
        Reservations = 3702072617,
        ReserveLocalPlayerNmAgent = 2584307454,
        ReserveLocalPlayerNmAgentMp = 75381461,
        Reserved = 4030133267,
        Resource = 4037058594,
        Restrictions = 3321094558,
        ResultMult = 2301637192,
        ResumeDistSq = 810755963,
        ReticuleSlowDownCapsuleLength = 1217679840,
        ReticuleSlowDownCapsuleRadius = 494811143,
        ReticuleSlowDownRadius = 1424095429,
        ReturnToNormalDistanceSq = 829574868,
        ReturnZoneThreshold = 4004042226,
        ReverseLeftFootAlignAnims = 1175770299,
        RifleDamageMod = 3362977435,
        RightBoneOffset = 697293397,
        RightGrip = 2936843542,
        RightHandOffset = 4292584457,
        RightPickUpTargetLerpPhaseEnd = 58162742,
        RightPickUpTargetLerpPhaseEndBicycle = 4109701939,
        RightPickUpTargetLerpPhaseStart = 1933869525,
        RightPickUpTargetLerpPhaseStartBicycle = 3395959775,
        RightPullUpTargetLerpPhaseEnd = 2264946778,
        RightPullUpTargetLerpPhaseEndBicycle = 3699582686,
        RightPullUpTargetLerpPhaseStart = 1089127336,
        RightPullUpTargetLerpPhaseStartBicycle = 149985112,
        RightWire = 2577801154,
        RocketSettings = 4146741065,
        RollAcceleration = 802099030,
        RollAngleScale = 2238978991,
        RollForBraking = 3154540810,
        RollForMaxYaw = 1251049479,
        RollForMinYaw = 1128820245,
        RollForNormal = 3016943843,
        RollSettings = 4214646062,
        RollSpringConstant = 261121990,
        RollSpringDampRatio = 1003830880,
        RollUpHeightThreshold = 2106002013,
        RollingFall = 2787586299,
        RootLiftForce = 2143662100,
        RotationChangeRate = 3669742245,
        RotationLookAhead = 3143134944,
        RotationTowardsLos = 1899363737,
        RouteArrivalDistance = 157944410,
        RouteLengthThresholdForApproachOffset = 4290867387,
        RouteLengthThresholdForFinalApproach = 394374347,
        RouteLookAheadDistance = 1396210696,
        RouteRadiusFactor = 4261831117,
        RubberBulletKnockdown = 3062524360,
        RunAndGunAimCamera = 724878846,
        RunAndGunInterpolateInDuration = 674462637,
        RunAndGunOutroTime = 3879469601,
        RunAngAccel = 469859232,
        RunForever = 4079974935,
        Running = 3805238957,
        RunningAgainstBulletImpulseMult = 930478842,
        RunningAgainstBulletImpulseMultMax = 2892741044,
        RunningPedModifier = 1209452937,
        RunningWithBulletImpulseMult = 188546747,
        RunwayProbes = 731090194,
        SAC_Randomize = 1962395292,
        SAC_Retain = 2341131515,
        SAT_BULLET_TIME = 2744852139,
        SAT_CAR_SLOWDOWN = 2137706596,
        SAT_INSULT = 2169367037,
        SAT_RAGE = 3583791984,
        SAT_SNAPSHOT = 977651983,
        SCENARIO_POINTS_FILE = 276092270,
        SCENARIO_POP_STREAMING_SMALL = 1152280719,
        SF_AltBackDriverSide = 2355736970,
        SF_AltBackPassengerSide = 2152776352,
        SF_AltFrontDriverSide = 3757862915,
        SF_AltFrontPassengerSide = 1261964441,
        SF_BackDriverSide = 3935682468,
        SF_BackPassengerSide = 2563045769,
        SF_FrontDriverSide = 982742767,
        SF_FrontPassengerSide = 469567916,
        SLOD_KEEP_LOWEST = 462532381,
        SLOD_LARGE_QUADPED = 3496177438,
        SLOD_NULL = 551739454,
        SLOD_SMALL_QUADPED = 1128152005,
        SMALL_REACTION = 2909022553,
        SPACE_BIG = 652367616,
        SPACE_END = 1961485429,
        SPACE_MED = 2308938833,
        SPACE_SMALL = 3292874000,
        SPECIAL_AIRPORT = 3761654755,
        SPECIAL_NONE = 514090469,
        SPLargeAccidenThresold = 803970846,
        SPRITE_1 = 394130841,
        SP_Variation = 3866220764,
        STREAMING_FILE = 265895563,
        STREAMING_FILE_PLATFORM_OTHER = 1322995281,
        STREAMING_FILE_PLATFORM_PS3 = 4254420265,
        STREAMING_FILE_PLATFORM_XENON = 569488699,
        SUBMARINE = 2537188912,
        SafeDistance = 2538781855,
        SafeTimeBeforeLeavingCover = 4116865999,
        SafetyProportionInDefensiveAreaMax = 189140842,
        SafetyProportionInDefensiveAreaMin = 1022323136,
        ScaleAccelWithDelta = 801104139,
        ScaleHeadShotImpulseWithSpineOrientation = 1833987390,
        ScaleSnapWithSpineOrientation = 125672080,
        ScaleStayUprightWithVel = 3892109820,
        ScaleWithMass = 2640302727,
        ScaleWithUpright = 1033385210,
        ScaleWithVelocity = 2708100865,
        ScalingFactor = 4050830448,
        ScanDistance = 1702320721,
        ScanRadius = 2723670760,
        ScenarioDelayAfterFailureMax = 4009937054,
        ScenarioDelayAfterFailureMin = 4004750790,
        ScenarioDelayAfterFailureWhenStationary = 1166603434,
        ScenarioDelayAfterNotAbleToSearch = 2129795449,
        ScenarioDelayAfterSuccessMax = 2887992243,
        ScenarioDelayAfterSuccessMin = 1467495810,
        ScenarioDelayInitialMax = 1049520739,
        ScenarioDelayInitialMin = 2307005569,
        ScenarioScanOffsetDistance = 1173793332,
        ScenarioScanRadius = 2718645532,
        ScenarioToScenarioPedModifier = 645696278,
        ScoreCalculationsPerFrame = 1815040418,
        Scoring = 3333387022,
        ScreenRatioForMaxFootRoom = 3982287448,
        ScreenRatioForMaxFootRoomInTightSpace = 695725580,
        ScreenRatioForMinFootRoom = 2014345705,
        ScreenRatioForMinFootRoomInTightSpace = 2449849624,
        Scripted = 1420062864,
        ScubaGear = 7473239,
        ScubaGearVariations = 1092654765,
        ScubaGearWithLightsOff = 505931244,
        ScubaGearWithLightsOn = 1478092361,
        ScubaMaskProps = 2321693669,
        SearchRotateAngleLookAhead = 1512295050,
        SearchThreatMaxDot = 1574888900,
        SearchToCoverCosTolerance = 2892923069,
        SeatBlendAngSpeed = 580774094,
        SeatBlendLinSpeed = 3426806263,
        SeatDisplacementSmoothingRateDriver = 3305089148,
        SeatDisplacementSmoothingRatePassenger = 166726527,
        SeatPosition = 788888146,
        SecondaryFocusParentToTargetBlendLevel = 2535634527,
        SecondsBeforeWarpToLeader = 3663548072,
        SecondsSinceInWaterThatCountsAsWet = 3211610412,
        SensesRange = 1188235128,
        SeparationDrag = 3440934413,
        SeparationPickup = 383086153,
        SeparationPutdown = 4100111705,
        SetFallingReactionFallOverVehicle = 246824093,
        SetFallingReactionFallOverWall = 3571002906,
        SetFallingReactionHealthy = 1126347982,
        SetFallingReactionInjured = 3814409847,
        SettingsRef = 926775845,
        SettleAnimStateInfos = 260425135,
        SettledTimeMS = 2088054141,
        SettledTimeMinMS = 2229954249,
        ShakeAmplitude = 415335014,
        ShakeAmplitudeScalingForShootingAbilityLimits = 1149560055,
        ShakeFirstPersonShootingAbilityLimits = 937843974,
        ShakeRef = 1511687083,
        SharkAddRangeInViewMin = 750370993,
        SharkFleeDist = 3147934542,
        SharkModelName = 2326003695,
        ShockingFilmSpeechHash = 1372129940,
        ShockingSpeechChance = 1805287691,
        ShockingSpeechHash = 1884622848,
        ShootRateModifier = 920840724,
        Shot = 2213248546,
        ShotAgainstWall = 2464589752,
        ShotgunChanceToMoveHeadImpulseToSpine2 = 2406131077,
        ShotgunChanceToMoveNeckImpulseToSpine2 = 895546582,
        ShotgunChanceToMoveSpine3ImpulseToSpine2 = 3217262184,
        ShotgunLiftNearThreshold = 4071309368,
        ShotgunMaxLiftImpulse = 3764669870,
        ShotgunMaxSpeedForLiftImpulse = 3579666943,
        Shots = 4029364641,
        ShouldAimSweepOverrideOrbitPitchLimits = 184490319,
        ShouldAlign = 2033261313,
        ShouldAlignOnVehicleExit = 3431976824,
        ShouldAllowInterpolationSourceCameraToPersistReticule = 4238055063,
        ShouldAllowOtherCollisionToConstrainCameraIntoEntities = 615517883,
        ShouldApply = 651835053,
        ShouldApplyAimSensitivityPref = 2185008081,
        ShouldApplyAttachOffsetRelativeToCamera = 3807713258,
        ShouldApplyAttachParentRoll = 4012821505,
        ShouldApplyAttachPedPelvisOffset = 2861227361,
        ShouldApplyBuoyancy = 959048093,
        ShouldApplyDamping = 2339455115,
        ShouldApplyInAttachParentLocalSpace = 3748493944,
        ShouldApplyRoll = 436250856,
        ShouldApplyScaling = 1357431466,
        ShouldApplySniperControlPref = 2355159673,
        ShouldApplyWeaponFov = 2917952843,
        ShouldAttachToFollowPedHead = 2659354456,
        ShouldAttachToFollowPedSeat = 339929903,
        ShouldAttachToParentCentreOfGravity = 372575308,
        ShouldAttachToVehicleBone = 3725196996,
        ShouldAttachToVehicleExitEntryPoint = 2429106995,
        ShouldBlendOutWhenAttachParentIsInAir = 3478105571,
        ShouldBlendOutWhenAttachParentIsOnGround = 1212391588,
        ShouldBlendWithAttachParentMatrixForRelativeOrbitBlend = 3993671513,
        ShouldByPassNearClip = 4107190241,
        ShouldCalculateXYDistance = 9156722,
        ShouldConsiderAttachParentForwardSpeedForPullAround = 3857630189,
        ShouldConsiderAttachParentLocalXYVelocityForPullAround = 4045243730,
        ShouldConsiderData = 3663951405,
        ShouldConstrainCollisionRootPositionAgainstClippingTypes = 823526659,
        ShouldCopyVehicleCameraMotionBlur = 1232220671,
        ShouldDetect = 1134622566,
        ShouldDisplayReticule = 1348911901,
        ShouldDisplayReticuleDuringInterpolation = 870186590,
        ShouldDuck = 1848522270,
        ShouldFleeDistance = 2097584563,
        ShouldFleeFilmingDistance = 2071699275,
        ShouldFleeVehicleDistance = 1339551933,
        ShouldFocusOnLockOnTarget = 4137686847,
        ShouldForceCutToOrbitDistanceLimitsForThirdPersonFarViewMode = 1953360151,
        ShouldIgnoreAttachParentMovementForOrientation = 1256703824,
        ShouldIgnoreAttachParentPitchForLookBehind = 2793581079,
        ShouldIgnoreBuoyancyStateAndAvoidSurface = 134488060,
        ShouldIgnoreCollisionWithAttachParent = 1949881438,
        ShouldIgnoreCollisionWithFollowVehicle = 3863307203,
        ShouldIgnoreFollowVehicleForCollisionOrigin = 3696538081,
        ShouldIgnoreFollowVehicleForCollisionRoot = 2213127338,
        ShouldIgnoreOcclusionWithBrokenFragments = 1921983042,
        ShouldIgnoreOcclusionWithBrokenFragmentsOfIgnoredEntities = 3325779817,
        ShouldIgnoreOcclusionWithRagdolls = 1973279102,
        ShouldIgnoreOcclusionWithSelectCollision = 2656848273,
        ShouldIgnoreVelocityOfAttachParentAttachEntity = 1933402526,
        ShouldIgnoreVerticalPivotOffsetForFootRoom = 881872463,
        ShouldLockHeading = 2098973612,
        ShouldLockOnToTargetEntityPosition = 1419212045,
        ShouldLockVerticalOffset = 1581058504,
        ShouldMakeAttachedEntityInvisible = 1478931781,
        ShouldMakeFollowPedHeadInvisible = 1762086384,
        ShouldMakePedInAttachSeatInvisible = 1538342627,
        ShouldMoveTowardsLos = 1510673380,
        ShouldOrbitRelativeToAttachParentOrientation = 2846809829,
        ShouldPersistOrbitOrientationRelativeToAttachParent = 3002500493,
        ShouldPersistPopInBehaviour = 2762175909,
        ShouldPullAroundToAttachParentFront = 2208576746,
        ShouldPullAroundToBasicAttachParentMatrix = 3468493382,
        ShouldPullAroundUsingSimpleSpringDamping = 3614496996,
        ShouldPullBackByCapsuleRadius = 1356103878,
        ShouldPushBeyondAttachParentIfClipping = 724966028,
        ShouldReportAsCameraTypeTest = 1876340735,
        ShouldRestictToFrontSeat = 523999628,
        ShouldRewardMoneyOnDeath = 89900819,
        ShouldScriptedAimTaskOverrideOrbitPitchLimits = 3180847895,
        ShouldSetBuoyantWhenAttachParentNotFullySubmerged = 448788827,
        ShouldSweepToAvoidPopIn = 1756495672,
        ShouldTerminateForDistanceToTarget = 179124010,
        ShouldTerminateForOcclusion = 474380051,
        ShouldTerminateForPitchAndHeading = 4172426852,
        ShouldTerminateForWorldPitch = 1301968002,
        ShouldTerminateIfOccludedByAttachParent = 1072193524,
        ShouldTestForClipping = 2106075408,
        ShouldTestForMapPenetrationFromAttachPosition = 1051168964,
        ShouldToggleAccurateModeInput = 288255802,
        ShouldToggleViewModeBetweenThirdAndFirstPerson = 3604554750,
        ShouldTorsoIkLimitsOverrideOrbitPitchLimits = 3271563285,
        ShouldUseAccurateModeInput = 2283622261,
        ShouldUseBaseAttachPosition = 2274949645,
        ShouldUseCustomCollisionOrigin = 2702878862,
        ShouldUseCustomFramingInTightSpace = 4033450681,
        ShouldUseDiscreteZoomControl = 1466092206,
        ShouldUseDynamicCentreOfGravity = 799910142,
        ShouldUseGameTime = 820757070,
        ShouldUseLockOnAiming = 1301399000,
        ShouldUseLockOnAimingForDriver = 721433849,
        ShouldUseLockOnAimingForPassenger = 1821508366,
        ShouldUseLookBehindCustomPosition = 956615974,
        ShouldUseLookBehindInput = 4114297506,
        ShouldUseViewModeInput = 509270218,
        ShouldUseZoomInput = 1706209718,
        ShouldValidateLockOnTargetPosition = 114759485,
        ShuntAccelerateMag = 1917995403,
        ShuntAccelerateMagBike = 3020055197,
        ShuntDamageMultiplierAI = 158324629,
        ShuntDamageMultiplierPlayer = 851764695,
        SideOffset = 2119254607,
        SideScale = 1948575789,
        SideSwipeForce = 3413603413,
        SideZoneThreshold = 1333345561,
        SimulationTimeInMs = 3281708108,
        SitToStillBikeClipId = 1718435094,
        SitToStillCharClipId = 2341866800,
        SitToStillClipId = 3951489866,
        SkipGotoHeadingDeltaDegrees = 2090002900,
        SkipGotoXYDist = 699708569,
        SkipGotoZDist = 790344800,
        SkipHolsterWeapon = 45502974,
        SkyDiveProbeDistance = 343578348,
        SkyDivingCamera = 365994391,
        SlideWalkAnimRate = 4171416824,
        SlopeSlide = 862016535,
        SlowApproachRate = 2330583994,
        SlowDown = 1251865784,
        SlowDownDist = 2685821768,
        SlowDownDistance = 4110448569,
        SlowDownDistanceMax = 1781466093,
        SlowDownDistanceMin = 947493336,
        SlowDownSpeed = 2686150441,
        SlowFastSpeedThreshold = 4250418611,
        SlowMinTurnApproachRate = 3696984410,
        SlowPedalToFreewheelBlendDuration = 1900606204,
        SlowRunRateMax = 843042981,
        SlowRunRateMin = 3959772122,
        SlowTurnAcceleration = 3928052593,
        SlowTurnApproachRate = 3661307080,
        SlowdownDistance = 3943951078,
        SmallCapsuleCoverPenalty = 184089910,
        SmallCapsuleCoverRadius = 1348626108,
        SmgDamageMod = 167232035,
        SmoothRate = 1863632928,
        SniperImpulses = 3585973980,
        SniperLegShot = 3003938851,
        SoftLockBreakDistanceMax = 2224486137,
        SoftLockBreakDistanceMin = 1661550302,
        SoftLockBreakValue = 4067802571,
        SoftLockFineAimBreakXYValue = 1403902499,
        SoftLockFineAimBreakZValue = 3553881274,
        SoftLockFineAimXYAbsoluteValue = 352361634,
        SoftLockFineAimXYAbsoluteValueClose = 1117580274,
        SoftLockTime = 2124028122,
        SoftLockTimeToAcquireTarget = 3433060120,
        Sonar = 409760750,
        SpActivationModifiers = 1742296994,
        Spawning = 4197810024,
        SpawningChasesEnabled = 1201683089,
        SpeedDifferenceForMaxDistanceToStartMatchingSpeed = 1979699436,
        SpeedDifferenceForMinDistanceToStartMatchingSpeed = 2025348338,
        SpeedForMinimumDot = 1301007976,
        SpeedForNarrowestAnglePickPOI = 1078877377,
        SpeedLimitsForVerticalMoveSpeedScaling = 1914871967,
        SpeedToAlwaysDive = 2913264363,
        SphereTestRadiusForDeadWaterSettle = 2511398250,
        SpinOut = 1954107545,
        SpineStrengthTuning = 2573019437,
        SpreadLimit = 662073465,
        SpringConstant = 4163819120,
        SpringDampingRatio = 731206835,
        SpringForce = 2286316924,
        SpringMountRef = 4021873979,
        SprintControlData = 3828880770,
        SprintExhausted = 29931670,
        SprintReplenishFinishedPercentage = 3615351832,
        SprintReplenishRateMultiplier = 3211960089,
        SprintReplenishRateMultiplierBike = 600117053,
        Sprinting = 2194212345,
        SprintingDeath = 3676971081,
        SprintingLegShot = 1190774472,
        StairsFootInterp = 3289881556,
        StairsFootInterpCoverAim = 2144071841,
        StairsFootInterpIntersecting = 3671506242,
        StairsPelvisInterp = 2577533666,
        StairsPelvisInterpCoverAim = 1271955779,
        StairsPelvisInterpMoving = 2302577809,
        StairsPelvisMaxNegativeDeltaZCoverAim = 3894253961,
        StairsSpringMultiplierMax = 816343475,
        StairsSpringMultiplierMin = 369470094,
        StaminaEfficiency = 1862920964,
        StandAlignMaxDist = 996663150,
        StandClip0Id = 2845656216,
        StandClip1Id = 1744028122,
        StandClip2Id = 1441580086,
        StandardAI = 1367672446,
        StandardBlendOutThresholds = 2851995582,
        StandingLandHeadingModifier = 176941965,
        StartAggressive = 987294494,
        StartAnimatedTurnsD = 3129761256,
        StartCatchFall = 1213801104,
        StartClipWaitTime = 123069407,
        StartClipWaitTimePlayer = 1412213192,
        StartDefault = 385444229,
        StartDelayDuration = 966603625,
        StartEngineClipId = 723740105,
        StartEngineForce = 3175914177,
        StartExtendedProbeTime = 2633188230,
        StartForceDownHeight = 2371670611,
        StartLocomotionBlendoutThreshold = 1243932439,
        StartLocomotionDefaultBlendDuration = 1266064609,
        StartLocomotionDefaultBlendOutDuration = 1010088937,
        StartLocomotionEarlyOutBlendOutDuration = 3914009351,
        StartLocomotionHeadingDeltaBlendoutThreshold = 562952832,
        StartLocomotionWalkRunBoundary = 1107407285,
        StartPosition = 4070310820,
        StartRollDownStairs = 2633206880,
        StartToIdleDirectlyPhaseThreshold = 265096732,
        StartTurnThresholdDegrees = 1138520829,
        StartWeak = 2862149771,
        StartWindmill = 776602752,
        StartingEnergy = 3024832208,
        StaticLosTest1Offset = 2749521042,
        StaticLosTest2Offset = 4086815177,
        StayUpright = 509938192,
        StayUprightAtMaxVel = 930009703,
        StayUprightAtMinVel = 3524092362,
        StdVehicleMinPhaseToStartRotFixup = 2300124116,
        StealthNoisePeriodMS = 2280670656,
        StealthSpeedThresholdHigh = 2089726799,
        StealthSpeedThresholdLow = 324788932,
        StealthVehicleTypeFactorBicycles = 897691679,
        StealthZoomSettings = 3610920953,
        SteepSlopeStartAnimatedTurnsD = 2582103758,
        SteepSlopeStopAnimatedTurnsD = 1722856329,
        SteepSlopeThresholdD = 3054410305,
        SteerAngleControl = 3605734753,
        SteeringChangeToStartProcessMoveSignals = 2406738390,
        SteeringChangeToStopProcessMoveSignals = 3912339645,
        SteeringDeadZone = 2532196566,
        SteeringDeadZoneCentreTimeMS = 1503418851,
        SteeringDeadZoneTimeMS = 1683629424,
        StepInfos = 1592390985,
        StepOutCapsuleRadiusScale = 2554062878,
        StepOutLeftX = 1144003052,
        StepOutRightX = 3683453861,
        StepOutX = 259942193,
        StepOutY = 4255892364,
        StepTransitionMaxAngle = 1584333756,
        StepTransitionMinAngle = 2533820819,
        SteppingAnimStateInfos = 3007867016,
        SteppingApproachRate = 2556798213,
        SteppingApproachRateFast = 1705449547,
        SteppingApproachRateSlow = 4027315230,
        SteppingEdgeTestEndYOffset = 2621555533,
        SteppingEdgeTestStartYOffset = 1342115678,
        SteppingHeadingApproachRate = 4090917343,
        SteppingMovementSpeed = 2296590808,
        StickDownDuration = 4175251844,
        StickDownMinRange = 488214823,
        StickValueForMax = 2536907014,
        StickValueForMin = 1576728196,
        StickX = 1871798248,
        StickY = 1965746967,
        StickyId = 2164901921,
        StillAccTol = 1079251923,
        StillDelayTime = 3047698562,
        StillPitchAngleTol = 2495843356,
        StillToSitApproachRate = 3504747140,
        StillToSitClipId = 1322656239,
        StillToSitLeanRate = 651496609,
        StopAnimatedTurnsD = 1268028398,
        StopDistSq = 1791608761,
        StopPhaseThreshold = 1520516679,
        StopResponseWhenExpired = 2309582193,
        StopTurnThresholdDegrees = 1142247737,
        StopWatchDistance = 2181133548,
        StoppingAnimStateInfos = 2080209369,
        StoppingDistanceGallopMBR = 3764305197,
        StoppingDistanceRunMBR = 2508724347,
        StoppingDistanceWalkMBR = 792142948,
        StoppingGotoPointRemainingDist = 577153356,
        StrafeAcceleration = 1363831855,
        StrafeDirectionLerpRateMaxAI = 1204182041,
        StrafeDirectionLerpRateMaxPlayer = 2769179410,
        StrafeDirectionLerpRateMinAI = 2509399696,
        StrafeDirectionLerpRateMinPlayer = 1932572913,
        StraightLineDistance = 474269749,
        StreamConnectedSeatAnims = 3147840041,
        StreamEntryAndInVehicleAnimsTogether = 1924248769,
        StreamInVehicleAndEntryAnimsTogether = 4236803127,
        StreamedOneHandedCoverMovementClipSetId = 3568457068,
        StreamedUnarmedCoverMovementClipSetId = 3141671110,
        StreamingName = 692898807,
        StrongBlastMagnitude = 1446526858,
        StuckOnVehicle = 648899635,
        StuckOnVehicleBlendOutThresholds = 2482984819,
        StuckOnVehicleMaxTime = 1360661757,
        StuckOnVehiclePlayer = 2880735205,
        StuckUnderVehicle = 1316017959,
        StuckUnderVehicleMaxUpright = 1218193578,
        StuckUnderVehiclePlayer = 600771112,
        StuckWaitTime = 774340160,
        StuckWaitTimeMp = 4110175468,
        StunnedDistanceSpringConstant = 399773061,
        StunnedDistanceSpringDampingRatio = 340673450,
        StunnedHeadingSpringConstant = 1625429307,
        StunnedHeadingSpringDampingRatio = 2414166560,
        StunnedPitchSpringConstant = 1044796272,
        StunnedPitchSpringDampingRatio = 122790262,
        StuntJump = 2578429326,
        StuntJumpPitchInDirectionComponent = 2080285568,
        StuntJumpPitchInDirectionForce = 2619863448,
        SubmergedBlendOutThreshold = 3512832436,
        SuperHighFallStart = 2200596271,
        SurfaceHeightFallingLerpRate = 3431403282,
        SurfaceHeightFollowingTriggerRange = 3742890223,
        SurfaceHeightRisingLerpRate = 1039725890,
        SurfacePitchLerpRate = 61986925,
        SurfaceProbeHead = 1909345264,
        SurfaceProbeTail = 1086011957,
        SurfaceProjectionDistance = 2147768117,
        SurfaceSkimmerDepth = 1405419534,
        SurfaceZOffset = 2629938407,
        Surprised = 730897041,
        Swat = 507550818,
        SweepClip0Id = 3630917852,
        SweepClip1Id = 3117869494,
        SweepClip2Id = 4068466847,
        SwerveTime = 3588251070,
        SwingSpeedAtMaxSkidSpeed = 2084746057,
        SwitchToNextPointDistJogging = 4287996365,
        SwitchToNextPointDistWalking = 1010415847,
        SwitchToStraightLineDist = 2409655710,
        TC_Randomize = 279516121,
        TC_Retain = 3014288776,
        THIRD_PERSON_FAR = 2770781844,
        THIRD_PERSON_MEDIUM = 3489645472,
        THIRD_PERSON_NEAR = 2573120959,
        THROWNWEAPONINFO_FILE = 1339784773,
        TIME_DEPENDENT = 3029576156,
        TRAIN = 3644569018,
        TUNABLE_OBJECTS_FILE = 3511689339,
        TailgateDistanceMax = 10772112,
        TailgateIdealDistanceMax = 3640450256,
        TailgateIdealDistanceMin = 3101610967,
        TailgateSpeedMultiplierMax = 94249946,
        TailgateSpeedMultiplierMin = 2435522850,
        TailgateVelocityMin = 3105879189,
        TakeCustodyDistance = 116998034,
        TakedownProbability = 3234488441,
        TapAdd = 3672071413,
        TargetArriveDist = 3935882297,
        TargetDirectionMinDot = 3431388800,
        TargetDistance = 2300691636,
        TargetDistanceFallOffMax = 2509546906,
        TargetDistanceFallOffMin = 780951691,
        TargetDistanceFromVehicleEntry = 2654770325,
        TargetDistanceMaxWeightingAimTime = 2894102221,
        TargetDistanceWeightingMax = 1298342428,
        TargetDistanceWeightingMin = 4286470540,
        TargetHeadingWeighting = 379592677,
        TargetInfluenceSphereRadius = 4246707502,
        TargetJackRadius = 1336699435,
        TargetMaxSpeedToStrafe = 2121954925,
        TargetMinDistanceToAwayFacingNavLink = 1032956977,
        TargetMinDistanceToRoute = 1578284711,
        TargetMinSpeedToIgnore = 3344078648,
        TargetOffsetFilter = 4288775642,
        TargetRadiusForCloseNavMeshTask = 1670586696,
        TargetRadiusForMoveToPosition = 4292170157,
        TargetRadiusForOrientatedAlignRun = 2898549300,
        TargetRadiusForOrientatedAlignWalk = 3904376533,
        TargetReached = 2955443375,
        TargetRearDoorOpenRatio = 1172728662,
        TaskMessage = 191752587,
        TeeterControl = 2265693971,
        TeeterEdge = 1040810614,
        TestLowLodIdle = 718713683,
        TexId = 1424942312,
        TextLabel = 2047169098,
        TextureKey = 1994003276,
        ThirdPersonVehicleAimCameraRef = 961264130,
        ThreatDirWeight = 3141504902,
        ThreatEngageDirWeight = 3121364054,
        ThreatResponseArmed = 1842245065,
        ThreatResponseMelee = 2782470584,
        ThreatResponseUnarmed = 1368196689,
        Threshhold = 1066024874,
        ThresholdRun = 317231619,
        ThresholdWatch = 3695837863,
        ThresholdWatchAfterFace = 1236817557,
        ThresholdWatchStop = 3056724293,
        ThrottleControl = 1718221861,
        ThrottleMultiplier = 2515377448,
        ThroughWindScreenBlendInDuration = 1384973258,
        ThroughWindscreenDamageAi = 1443265623,
        ThroughWindscreenDamagePlayer = 91246296,
        ThrowLongClipId = 2511572601,
        ThrowProjectileClipSetId = 76855168,
        ThrowProjectileClips = 1011459206,
        ThrowShortClipId = 573759163,
        ThrowSmokeGrenadeTuning = 3088747583,
        TightSpaceSpringConstant = 488216999,
        TightSpaceSpringDampingRatio = 1406371922,
        TighterTurn = 2775606479,
        Tiles = 2501703395,
        TimeAfterAttractionMs = 3415237781,
        TimeAfterChainTestFailedMs = 884187023,
        TimeAfterFailedConditionsMs = 281170344,
        TimeAfterGunshotForPlayerToPlayIdles = 3057149274,
        TimeAfterGunshotToPlayIdles = 1718176557,
        TimeAfterNoBoundsMs = 2108114328,
        TimeAheadForBrake = 1369613048,
        TimeAheadForBrakeOnWideRoads = 3279921996,
        TimeAheadForGetInPosition = 1751757949,
        TimeBefore = 353469799,
        TimeBeforeDriverAnimCheck = 2064516214,
        TimeBeforeFiringMax = 6520997,
        TimeBeforeFiringMin = 1761265942,
        TimeBeforeInitialForcedFire = 1561898282,
        TimeBeforeOvertakeToMatchSpeedWhenCruising = 3069250390,
        TimeBeforeOvertakeToMatchSpeedWhenPulledOver = 847675324,
        TimeBetweenAddingDangerousVehicleEvents = 3877124457,
        TimeBetweenArmedMeleeAttemptsInMs = 3218253966,
        TimeBetweenBlockingAreaChecksMS = 3384585290,
        TimeBetweenBrokenPointChecks = 1732510557,
        TimeBetweenBurstsAbsoluteMin = 913069912,
        TimeBetweenBurstsMax = 1662854346,
        TimeBetweenBurstsMaxRandomPercent = 3041121812,
        TimeBetweenBurstsMin = 1007771611,
        TimeBetweenCarChaseShockingEvents = 2475600241,
        TimeBetweenChecksToLeaveCowering = 3836158716,
        TimeBetweenCoverPointSearches = 2294664490,
        TimeBetweenDifficultyUpdates = 2905197964,
        TimeBetweenDoorChecks = 910622893,
        TimeBetweenExitVehicleDueToRouteChecks = 4172879726,
        TimeBetweenForcedFireStates = 1133862058,
        TimeBetweenGroundProbes = 2107629661,
        TimeBetweenHandsUpChecks = 1422617106,
        TimeBetweenIncreasingAvoidanceAngle = 530164593,
        TimeBetweenInfluenceSphereChecks = 847783567,
        TimeBetweenInvalidateInvalidDispatchVehicles = 606050838,
        TimeBetweenLineOfSightChecks = 2789360544,
        TimeBetweenLookAts = 3284365585,
        TimeBetweenMarkDispatchVehiclesForDespawn = 2966580682,
        TimeBetweenPeeksWithoutLOS = 1685929346,
        TimeBetweenPlayerArrestAttempts = 1777999076,
        TimeBetweenPlayerEvents = 3786622949,
        TimeBetweenPointUpdates = 933911179,
        TimeBetweenReactionIdlesMax = 1213974814,
        TimeBetweenReactionIdlesMin = 1003164741,
        TimeBetweenRouteAdjustments = 368954988,
        TimeBetweenScenarioScans = 95380765,
        TimeBetweenSearchesForNextScenarioInChain = 2148143287,
        TimeBetweenSeekChecksAtTacticalPoint = 2565736146,
        TimeBetweenShotsAbsoluteMin = 4134391333,
        TimeBetweenShotsMax = 2449042043,
        TimeBetweenShotsMin = 965484170,
        TimeBetweenShoutTargetPosition = 3942172091,
        TimeBetweenSpawnAttempts = 3078950392,
        TimeBetweenSpawnAttemptsModifier = 296253880,
        TimeBetweenSwitchToClearTasks = 2109232134,
        TimeBetweenTestSpheresIntersectingRoute = 4076542446,
        TimeBetweenWaterHeightMapChecks = 1094365177,
        TimeBetweenWaterProbes = 3534467233,
        TimeEvadingForMaxValue = 3674050950,
        TimeForEyeIk = 420989827,
        TimeForRunAndGunOutroDelays = 1555086572,
        TimeForTakedownTargetAcquiry = 2979929207,
        TimeInSeconds = 704872957,
        TimeInWheelieToEnforceMinPitch = 2654954309,
        TimeMinBeforeLastPoint = 3697919373,
        TimeMinBeforeLastPointType = 3167164487,
        TimeOfDayRandomnessHours = 643049118,
        TimeOnGroundToDrive = 4081532692,
        TimeScale = 3983645896,
        TimeSinceLastSpottedToLeaveEngineOn = 3885866805,
        TimeSinceNotWantingToTrackStandToAllowStillTransition = 3469844948,
        TimeStillToTransitionToTrackStand = 3178576793,
        TimeToAllowCachedStickInputForMelee = 694461643,
        TimeToApplyPushFromVehicleForce = 2802719757,
        TimeToAvoidTargetAfterDamaged = 4228837765,
        TimeToCircle = 432972202,
        TimeToConsiderEnterInputValid = 195183113,
        TimeToCower = 2520530295,
        TimeToDelayChaseOnFoot = 259290858,
        TimeToFlapMax = 177240921,
        TimeToFlapMin = 2321281590,
        TimeToGiveUp = 2406795129,
        TimeToHoldFireAfterJack = 2874514021,
        TimeToLeaveMinBetweenAnybody = 2913322701,
        TimeToLeaveRandomAmount = 3638708710,
        TimeToLeaveRandomFraction = 3090913677,
        TimeToLive = 4175948694,
        TimeToLookAhead = 3717085729,
        TimeToLookAheadForCollision = 1222335592,
        TimeToLookBehind = 2632846246,
        TimeToSignalVehiclePursuitToCriminalMax = 3952273225,
        TimeToSignalVehiclePursuitToCriminalMin = 972295474,
        TimeToStare = 3623978511,
        TimeToStartCatchFall = 3622461286,
        TimeToStartCatchFallPlayer = 2616410929,
        TimeToThrowWeaponMS = 4154063324,
        TimeToThrowWeaponPlayerMS = 2820766976,
        TimeToUseUrgentTransitionsWhenThreatened = 2561996113,
        TimeToWait = 1118835093,
        TimeToWaitAtPosition = 3070881148,
        TimeUntilDeletionWhenHurrying = 4026550489,
        TimeUntilDeletionWhenStuckOffscreen = 731604244,
        TimeUntilRelease = 331709996,
        TimeWhenStuckToIgnoreBird = 2942205087,
        TimedMessages = 2683667002,
        Timers = 577434903,
        TimesliceMinDistToTarget = 2393149687,
        TimesliceTimeAfterAvoidanceMs = 47710483,
        ToPose = 1765007258,
        TopComponent = 883722394,
        TopSpread = 1191223326,
        TorqueMultiplier = 2183062202,
        TotalStickInput = 4050970672,
        TowardsDoorPushAngleDotTolerance = 3263047395,
        TrackStandLeftBikeClipId = 413582134,
        TrackStandLeftCharClipId = 1792476542,
        TrackStandRightBikeClipId = 688331024,
        TrackStandRightCharClipId = 697395711,
        TrackStandToStillLeftBikeClipId = 2145122814,
        TrackStandToStillLeftCharClipId = 1736721816,
        TrackStandToStillRightBikeClipId = 2112680596,
        TrackStandToStillRightCharClipId = 2306546493,
        TransitionReactionTime = 4282065899,
        Transitions = 2275723194,
        TranslationChangeRate = 86992154,
        TrespassGuardModelName = 560650271,
        TriggerAmbientReactionChances = 449694767,
        TripleHeadNearClip = 1634093344,
        TuckFreeWheelToTrackStandRightBikeClipId = 182997087,
        TuckFreeWheelToTrackStandRightCharClipId = 4218531778,
        TurbulenceSettings = 668098498,
        Turn180ActivationAngle = 956068907,
        Turn180ConsistentAngleTolerance = 997046562,
        TurnAcceleration = 660335017,
        TurnClipRate = 849148447,
        TurnEndAnimStateInfos = 2833513553,
        TurnEnterAnimStateInfos = 313911161,
        TurnFromRoll = 320841962,
        TurnFromStick = 914788843,
        TurnLeftFastClipId = 139557085,
        TurnLeftSlowClipId = 1974526496,
        TurnResetThresholdD = 3939547333,
        TurnRightFastClipId = 3609018768,
        TurnRightSlowClipId = 3624061968,
        TurnSpeedMBRThreshold = 545188344,
        TurnTime = 992439102,
        TurnToIdleTransitionDelay = 246989054,
        TurnTransitionDelay = 3543637314,
        TurnWalkStartAnimStateInfos = 2132068389,
        TurningEnergyLowerThreshold = 2301662345,
        TurningEnergyUpperThreshold = 3891776628,
        TurningRate = 2265632345,
        TurningTolerance = 3607448121,
        TwoHandedClipSetName = 646946550,
        UnarmedBonus = 1120630761,
        UnarmedInCoverTargetingDistance = 1369945566,
        UncertaintySettings = 71599683,
        UncuffDistance = 85726558,
        UnderCarMaxVelocity = 3776343247,
        UnderVehicle = 3262694177,
        UnderVehicleContinuousContactTime = 3606585778,
        UnderVehicleInitialDelay = 2055428725,
        UnderVehicleVelocityThreshold = 1061400063,
        Underwater = 3260924144,
        UnderwaterRelax = 1203310844,
        UpDownStickInputMin = 2758926922,
        UpDownStickInputSmoothingRate = 1495829016,
        UpHillMinPitchToStandUp = 221837246,
        UpStairsPelvisMaxDeltaZMoving = 2784569431,
        UpStairsPelvisMaxNegativeDeltaZMoving = 1210483821,
        UpdateOnVehicle = 2664008333,
        UpdateOnVehiclePlayer = 2214161412,
        UpdatesBeforeShiftingBounds = 2237139323,
        UpperArmImpulseCap = 3575120372,
        UpperArmNoTorsoHitImpulseCap = 3342224597,
        UpperBodyAimBlendInDuration = 1388147608,
        UpperBodyAimBlendOutDuration = 870279090,
        UpwardMoveSpeedScalingInAir = 2018965896,
        UpwardMoveSpeedScalingOnGround = 1487131765,
        Urgent = 638477469,
        UseAttachDuringAlign = 1827422982,
        UseAutoPeekAimFromCoverControls = 1366091002,
        UseBalanceForEdgeActivation = 1435456656,
        UseButtonToMoveAroundCorner = 92660424,
        UseByDefault = 3330866903,
        UseCameraOrientationForBackwardsDirection = 4080484940,
        UseCameraOrientationWeighting = 3262493116,
        UseCameraOrientationWhenStill = 2656290976,
        UseCapsuleTests = 3032938120,
        UseCombatEntryForAiJack = 2341452292,
        UseConstantIntroScaling = 1930123256,
        UseConstantOutroScaling = 28269420,
        UseDriveByAssistedAim = 2834495058,
        UseEnclosedSearchRegions = 759464384,
        UseExtraHeading = 1171907848,
        UseFineAimSpring = 1815260878,
        UseInitialLeanForcing = 1694816095,
        UseLastSeenPosition = 2888264108,
        UseLegIkOnBikes = 3852741535,
        UseLockOnTargetSwitching = 2942037123,
        UseMeleeHeadingOverride = 2400008353,
        UseMoverPositionWhilePeeking = 3860983555,
        UseMovingDirectionDiff = 26697373,
        UseNewSlowDownCode = 1214053169,
        UseNewStepAndWalkStarts = 4236998281,
        UseNewTurnWalkStarts = 2618193402,
        UseNewTurns = 2597341356,
        UseNonNormalisedScoringForPlayer = 1619169047,
        UseOrientationFromParachuteBone = 3610904814,
        UsePreEmptiveEdgeActivation = 2870540718,
        UsePreEmptiveEdgeActivationMp = 89764064,
        UseRagdollTargetIfNoAssistTarget = 2837888679,
        UseRelaxBehaviour = 2811070889,
        UseRemainingMinTimeForGroundWrithe = 3956869012,
        UseReticuleSlowDown = 3139641677,
        UseReticuleSlowDownForRunAndGun = 2667436072,
        UseReticuleSlowDownStrafeClamp = 1791816512,
        UseReturnOvershoot = 347971119,
        UseShortDistAngleRotation = 2589136465,
        UseSlowInOut = 2172495855,
        UseSprintButtonForCoverToCover = 3117448440,
        UseStickHistoryForCoverSearch = 3891560208,
        UseThreatWeighting = 1056793189,
        UseVerticalAxis = 2547715741,
        UserData1 = 647685198,
        UserData2 = 4202662936,
        VEHICLE_CAMERA_OFFSETS_FILE = 321643698,
        VFXCullRangeScaleNotVisible = 3493766854,
        VMCP_BOTTOM = 2770495034,
        VMCP_FRONT = 3001706694,
        VMCP_FRONT_LEFT = 1148399176,
        VMCP_FRONT_RIGHT = 2057559994,
        VMCP_LEFT = 1629770278,
        VMCP_REAR = 1556139353,
        VMCP_REAR_LEFT = 1830737308,
        VMCP_REAR_RIGHT = 457854237,
        VMCP_RIGHT = 2879151926,
        VMCP_TOP = 3193071790,
        VMT_DOOR_R = 514696742,
        VMT_HYDRAULICS = 3919652883,
        VMT_TURBO = 2334449168,
        VMT_TYRE_SMOKE = 3968559424,
        VMT_XENON_LIGHTS = 2656522436,
        ValidityProbes = 1879187973,
        ValueForMax = 1433159873,
        ValueForMaxDistanceFromOptimal = 502596100,
        ValueForMaxDistanceFromPed = 2889265507,
        ValueForMin = 2828335077,
        ValueForMinDistanceFromOptimal = 744506381,
        ValueForMinDistanceFromPed = 1140912184,
        ValueForTooCloseToTarget = 3390301810,
        ValueForUnableToFind = 1083242382,
        Vault = 224741676,
        VaultDepth = 428832696,
        VaultExtraZGroundTest = 3090504223,
        VaultFallTestAngle = 1723088470,
        VaultHorizClearance = 3626807160,
        VaultVertClearance = 1828436652,
        VehicleActivationForceMultiplierBicycle = 1598687789,
        VehicleActivationForceMultiplierBike = 2070345117,
        VehicleActivationForceMultiplierBoat = 1538253009,
        VehicleActivationForceMultiplierDefault = 1953114585,
        VehicleActivationForceMultiplierHeli = 2815969152,
        VehicleActivationForceMultiplierPlane = 2575088986,
        VehicleActivationForceMultiplierQuadBike = 1027107196,
        VehicleActivationForceMultiplierTrain = 1298279329,
        VehicleAttachPart = 1760348159,
        VehicleCentreZOffset = 3606813162,
        VehicleCollisionElasticityMult = 4203888010,
        VehicleCollisionFrictionMult = 1270097093,
        VehicleCollisionNormalPitchOverVehicle = 1698949999,
        VehicleCollisionNormalPitchUnderVehicle = 760529768,
        VehicleCustomSettingsList = 3282527658,
        VehicleEdgeProbeXOffset = 1461993132,
        VehicleEdgeProbeZOffset = 370845448,
        VehicleEntryExitPitchLevelSmoothRate = 135621085,
        VehicleFallingSpeedWeight = 3356594861,
        VehicleForwardInitialScale = 99981148,
        VehicleForwardScale = 399270735,
        VehicleJumpLookAtBlendRate = 3988230675,
        VehicleJumpLookAtTurnRate = 3786041740,
        VehicleMinSpeedForAiActivation = 999125689,
        VehicleMinSpeedForContinuousPushActivation = 1115174900,
        VehicleMinSpeedForPlayerActivation = 1493712076,
        VehicleMinSpeedForStationaryAiActivation = 2568028856,
        VehicleMinSpeedForStationaryPlayerActivation = 3804386946,
        VehicleMinSpeedForWarningActivation = 3383227946,
        VehicleOnTopOfVehicleCollisionSettings = 227846107,
        VehicleOverrides = 2892094444,
        VehicleSlowDown = 144280219,
        VehicleSpeedToAbortCloseDoor = 2994929358,
        VehicleTypes = 101865872,
        VehicleVelToImpactNormalMinDot = 670176362,
        VelMagStairsSpringMax = 1652778083,
        VelMagStairsSpringMin = 1875736055,
        VelStartCircling = 3146864305,
        VelStopCircling = 3555988495,
        VelocityDeltaThrownOut = 3562480846,
        VelocityDeltaThrownOutPlayerMP = 935626028,
        VelocityDeltaThrownOutPlayerSP = 1359095251,
        VelocityInheritance = 3529865731,
        VelocityMax = 3727574793,
        VelocityMin = 3439766974,
        VelocityThreshold = 3597443216,
        VelocityZThresholdForHighHighFall = 1373544668,
        VelocityZThresholdForSuperHighFall = 2767003073,
        VerifyCoverInterval = 3544497884,
        VerticalAcceleration = 335505697,
        VerticalFlightModeSettings = 2663165374,
        VerticalMoveSpeedScaling = 3594576614,
        VerticalMoveSpeedScalingAtMaxSpeed = 1880225385,
        VeryCloseIgnoreDesAndCamToleranceDist = 3378257781,
        VeryCloseIgnoreDesAndCamToleranceDistAimGun = 1824902254,
        VeryCloseToCoverDist = 3671850988,
        VeryCloseToCoverWeight = 3278990871,
        Vibration = 3143512563,
        ViewModeBlendEnvelopeRef = 1610750427,
        ViewModes = 2142445901,
        VisualReactionRange = 2272290579,
        WEATHER_DEPENDENT = 211193083,
        WaitForFootPlant = 3115377094,
        WaitTimeAfterFailedVehExit = 637992620,
        WaitTimeForJackingSlowedVehicle = 3405855740,
        WaitingOffsets = 2967055211,
        WalkAngAccel = 214999846,
        WalkStartAnimStateInfos = 3590260370,
        Walking = 3122448379,
        WalkingRoundPedModifier = 4057155416,
        WallHighTestZOffset = 2168664060,
        WallProbeDistance = 180206572,
        WallProbeRadius = 3138282762,
        WallTestEndXOffset = 1396197980,
        WallTestStartXOffset = 1813675586,
        WallTestYOffset = 1784425794,
        WanderInfluenceSphereRadius = 3384130276,
        WantedClean = 651905954,
        WantedLevel = 1092646882,
        WatchSayFightCheers = 1461520922,
        WatchSayShocked = 3973997152,
        WaterBobShakeRef = 572898954,
        WaterCannon = 3460531080,
        WaterEntryShakeSettings = 3250603115,
        WaterHeightSmoothRate = 3243646861,
        WaterProbeDepth = 519277350,
        WaterProbeOffset = 2825120069,
        Waveform = 579825085,
        WeaponAccuracyModifierForAimedAt = 2268167532,
        WeaponAccuracyModifierForEvasiveMovement = 409082717,
        WeaponAccuracyModifierForOffScreen = 3234043128,
        WeaponAnimsFPSIdle = 961290246,
        WeaponAnimsFPSLT = 3087874789,
        WeaponAnimsFPSRNG = 2940814298,
        WeaponAnimsFPSScope = 1227904788,
        WeaponBlockingLengthOffset = 68994958,
        WeaponBlockingOffsetInLeftCover = 1375297558,
        WeaponBlockingOffsetInRightCover = 2238616520,
        WeaponLongBlockingOffsetInLeftCover = 1090704787,
        WeaponSets = 1399921457,
        WeaponZoomFactorSpringConstant = 447200092,
        WeaponZoomFactorSpringDampingRatio = 3347315427,
        Wearing = 4006165571,
        Weight = 2283156278,
        WeightToBlockFromPursue = 46040720,
        WeightToPullAlongsideFromPursue = 3622347383,
        WeightToRamFromPursue = 355255193,
        WeightToSpinOutFromPursue = 1145877267,
        Weights = 3025359898,
        WheelieAccelerateControlThreshold = 908927858,
        WheelieApproachRate = 1223047739,
        WheelieDesiredLeanAngleTol = 830782336,
        WheelieMaxSpeedThreshold = 2115168466,
        WheelieShiftThreshold = 524252818,
        WheelieSitToStandBlendDuration = 1137589274,
        WheelieStickPullBackMinIntention = 2587752772,
        WheelieUpDownControlThreshold = 301666014,
        WideShot = 742934843,
        WideTargetAngularLimit = 1280045894,
        WitnessPersonality = 1504162135,
        Witnesses = 473322006,
        WorldPitchLimits = 759759236,
        X360_SCRIPT_RPF = 2882324974,
        Yaw = 2514469802,
        ZAccForHighImpact = 3275703461,
        ZAccForLowImpact = 2682740739,
        ZAccForMedImpact = 819470063,
        ZAccelerationToStartLeaning = 1346841624,
        ZThresholdForApproachOffset = 1712423423,
        ZeroRateOnDirectionChange = 3627404834,
        ZeroValue = 1611654117,
        Zoom = 2983410641,
        ZoomDuration = 2271271663,
        ZoomFactor = 447392537,
        ZoomMotionBlurMaxFovDelta = 3100931510,
        ZoomMotionBlurMaxStrengthForFov = 1238524664,
        ZoomMotionBlurMinFovDelta = 1054008152,
        aSlownessZone = 1652130128,
        activeAnimSet = 4032486415,
        angleToTargetDegreesToNotUseMinRadius = 2986015914,
        animPoseAttachDefault = 1043632907,
        animPoseAttachToVehicle = 3798182907,
        animPoseDefault = 1916209420,
        animPoseHandsCuffed = 2725274669,
        attributeList = 1107288906,
        attributes = 1956494238,
        avoidHeadingChangeSpeed = 1518108829,
        avoidHeadingJump = 3036720225,
        avoidLockDuration = 3551843612,
        avoidPitchChangeSpeed = 1623304217,
        avoidPitchJump = 1597259961,
        bAllowSmashDuringJump = 2841425601,
        bAllowUnderwaterExplosion = 2310120635,
        bApplyVehicleEMP = 178952880,
        bApplyVehicleSlick = 1236241772,
        bApplyVehicleSlowdown = 1509365439,
        bApplyVehicleTyrePop = 1334397542,
        bBlockJumpCollisionAgainstRagdollBlocked = 69785967,
        bBox = 1231029245,
        bCanSetPlayerOnFire = 3710755331,
        bChargeTargetEnabled = 3037590705,
        bControlledByPlayerSprintInput = 3904393624,
        bDebugRender = 1991353814,
        bDisable2HandedGetups = 1782949708,
        bDrawIdleHeadLookTarget = 2274869694,
        bEnableDebugDraw = 3665067262,
        bEnableGaitAdditive = 3236417550,
        bEnableJumpCollisions = 787384491,
        bEnableJumpCollisionsMp = 1816652759,
        bEnabled = 1409504843,
        bFaceAndBodyAreMerged = 2435794203,
        bForcePetrolTankDamage = 3983992955,
        bForceVehicleExplosion = 3312297335,
        bFoundFaceAnimation = 259776703,
        bHorizontalRighting = 2237132872,
        bIgnoreRatioCheckForFire = 2400251666,
        bOverrideFaceAnimation = 1741651815,
        bStatic = 2375647859,
        bThrowSmokeGrenadeEnabled = 2007829514,
        bTrafficLightPositioning = 956704533,
        bUseClipPoseHelper = 2006791804,
        bUseStayUpright = 2778976875,
        bValue = 208974921,
        bVerticalRighting = 1056777533,
        blurType = 2749488155,
        boatBowPtFxForwardMountedName = 2402780585,
        boatBowPtFxForwardMountedOffset = 1426207057,
        boatExitPtFxEnabled = 913361740,
        boatExitPtFxName = 276219657,
        boatExitPtFxRange = 3427519025,
        boatExitPtFxScale = 2913951911,
        boatExitPtFxSpeedEvoMax = 669705932,
        boatExitPtFxSpeedEvoMin = 501212370,
        bobble_hand = 785162942,
        bodyshell = 1970334199,
        boneSize = 60123590,
        break_extra_1 = 2190258525,
        break_extra_10 = 2734584581,
        break_extra_2 = 1950749904,
        break_extra_3 = 1709504522,
        break_extra_4 = 1480285367,
        break_extra_5 = 1213709552,
        break_extra_6 = 848662892,
        break_extra_7 = 3990325233,
        break_extra_8 = 367056899,
        break_extra_9 = 3413787451,
        cAnimCompressionFile = 2016919075,
        cAnimExportCtrlSpecFile = 2982365822,
        cExtraRoom = 2952522139,
        cFaceDir = 399683105,
        cFaceExportCtrlSpecFile = 3382327909,
        cHandle = 1251016415,
        cName = 1286194959,
        cRemoveBoneNameList = 1501402472,
        cSceneName = 3148363891,
        camCinematicPoliceCarMountedShotMetadata = 1537399056,
        camInterpolatorMetadata = 2380636687,
        camVehicleRocketSettings = 2211164655,
        cameraCutList = 2618346740,
        cascadeIndex = 311972855,
        chargeMultiplier = 510925374,
        colA = 4130410962,
        colB = 193412222,
        colG = 2816570672,
        colR = 960927728,
        colTint = 690075466,
        colorShift = 4254456164,
        concatDataList = 1452216515,
        continuousCharge = 463466415,
        curves = 1403691063,
        cutfAttributes = 2237184102,
        damageAtMid = 3010331635,
        damageMultiplier = 18336056,
        decalId = 2371851021,
        decalLength = 1229088392,
        decalLife = 96058849,
        decalWidth = 2398011309,
        defenseMultiplier = 2057680844,
        density = 3843932311,
        depletionMultiplier = 3653186651,
        depthMult = 1469744358,
        destroySuppressor = 1745227706,
        dirtBlue = 365907991,
        dirtGreen = 986658337,
        dirtRed = 3463006534,
        disableDrivebySeat = 161724223,
        disableDrivebySeatSecondary = 484538291,
        eImpactConeRagdollComponent = 100413071,
        eModKitType = 3865430600,
        entries = 934859523,
        exhaust_10 = 2600343066,
        exhaust_11 = 3598945568,
        exhaust_12 = 3896619164,
        exhaust_13 = 2989016171,
        exhaust_14 = 3320572913,
        exhaust_15 = 529211190,
        exhaust_16 = 823345734,
        exhaust_5 = 1666652977,
        exhaust_6 = 1972682668,
        exhaust_7 = 3204862618,
        exhaust_8 = 3503093287,
        exhaust_9 = 442599751,
        extra_10 = 2125833567,
        extra_11 = 2431830489,
        extra_12 = 2720558148,
        extra_13 = 903844796,
        extra_14 = 1202337617,
        extra_6 = 3145755371,
        extra_7 = 2360446286,
        extra_8 = 2661527858,
        extra_9 = 1913477126,
        fAIGreetingDistanceMax = 2521394702,
        fAIGreetingDistanceMin = 2740963979,
        fAIGreetingPedModifier = 383049694,
        fAbsoluteMinDistanceToTarget = 3835533225,
        fAccuracyReductionFloor = 552287921,
        fAccuracyReductionPerEnemy = 887750836,
        fAimToIdleAngleLimitLeft = 867760403,
        fAimToIdleAngleLimitRight = 3299346053,
        fAimToIdleBreakOutAngle = 2204270248,
        fAmbientAnimsMaxDistToTargetSq = 2501949685,
        fAmbientAnimsMinDistToTargetSq = 2971689701,
        fAnimalImpulseMultMax = 3454936156,
        fAnimalImpulseMultMin = 3492529421,
        fAnimalMassMult = 3679879803,
        fArgumentProbability = 2595564437,
        fBaseAlpha = 3124083955,
        fBlockedLosAimTime = 547548618,
        fBlockedLosWeighting = 1239531869,
        fBulletReactionPosAdjustmentZ = 2724641994,
        fCancelTargetInCoverMovedDist = 2002565392,
        fCancelTargetOutOfCoverMovedDist = 2120328830,
        fCargoFuel = 304399001,
        fChanceOfArgumentChallenge = 784723777,
        fChanceOfArgumentChallengeBeingAccepted = 2295557741,
        fChanceOfConversationRant = 1878691053,
        fChanceOfDynamicRun = 7313110,
        fChargeGoalBehindCoverCentralOffset = 1417010304,
        fChargeGoalCompletionRadius = 3325627586,
        fChargeGoalLateralOffset = 1507206306,
        fChargeGoalMaxAdjustRadius = 1141048876,
        fChargeGoalRearOffset = 2183058530,
        fConeAngle = 1743670592,
        fConversationSoundReductionAmount = 3201590411,
        fConversationSoundReductionDistance = 1212129799,
        fCoronaIntensity = 1078847881,
        fCoronaSize = 1810161173,
        fCoronaZBias = 1698708840,
        fCounterImpulseRatio = 3072803950,
        fCounterImpulseScale = 2189152686,
        fCoverPointScoreMultiplier = 1893361518,
        fDecideToRunChance = 1248305822,
        fDefaultDescendRate = 1487680899,
        fDefaultRopeLength = 1491518630,
        fDirectionTestProbeLength = 2195773039,
        fDirtLevel = 3834082948,
        fDisplayZ = 806477731,
        fDistSearch = 2679850916,
        fDistToHidingTarget_Inner = 1373272095,
        fDistToHidingTarget_Outer = 1408109790,
        fDistToPickNewPoint = 3620765866,
        fDistanceBetweenInfluenceSpheres = 2500728149,
        fDoInjuredOnGroundChance = 3434153865,
        fDotMinThrowerToTarget = 1053509475,
        fDurationStage1 = 3898851432,
        fDurationStage2 = 498117381,
        fEndStrength = 649526198,
        fExistingTargetScoreWeight = 1679672363,
        fExitDescendRate = 2768160631,
        fExtraRopeLength = 2199025334,
        fFadeInCutsceneDuration = 969234229,
        fFadeInGameDuration = 3025199107,
        fFadeOutCutsceneDuration = 953346839,
        fFadeOutGameDuration = 473400434,
        fFallOff = 391886097,
        fFallingSpeedForHighFall = 906382083,
        fFallingSpeedThreshold = 715813748,
        fFarDrawDistance = 3688268720,
        fFastCarPushImpulseMult = 2370876339,
        fFinisherShotgunBonusArmedSpeedModifier = 1950052429,
        fFireContinuouslyDistMax = 884701582,
        fFireContinuouslyDistMin = 3652101978,
        fFireWeaponStrengthForceMultiplier = 336969407,
        fFleeProjectRange = 1574250361,
        fFleeRange = 3546053113,
        fFlinchTargetZOffset = 1502498286,
        fFlinchTargetZOffsetOnGround = 3223569917,
        fForceLeanInDirectionAmountMax = 615835079,
        fForceLeanInDirectionAmountMin = 481812193,
        fForceRampMaxSpeed = 2515092116,
        fForceRampMinSpeed = 3439085926,
        fForceStrafeDistance = 679941746,
        fGlassBreakRadius = 3567409373,
        fGlassDamage = 2130522201,
        fGoToDefAreaTimeOut = 2145163833,
        fHeadLookHeadingRandomizationRange = 1337934970,
        fHeadLookPitchRandomizationRange = 1747662930,
        fHeadLookZOffset = 3439106982,
        fHeadLookZOffsetOnGround = 3990998153,
        fHeadingRandomizationRange = 1290250752,
        fHeight = 4242690206,
        fHorizontalRightingStrength = 3772786175,
        fHorizontalRightingTime = 3419496233,
        fImpactConeAngleBack = 3437539423,
        fImpactConeAngleFront = 2987127575,
        fImpulseMultLimbs = 2222583561,
        fImpulseMultSpine = 2449600555,
        fImpulseRecoveryPerSecond = 3098879897,
        fImpulseReductionPerShot = 702174865,
        fImpulseReductionScaleMax = 1706111854,
        fIndent = 3956347885,
        fInfluenceSphereCheckRouteRadius = 2889725249,
        fInfluenceSphereInnerWeight = 3016470091,
        fInfluenceSphereOuterWeight = 983725397,
        fInfluenceSphereRequestRadius = 3585286231,
        fInitialDelay = 79279568,
        fInitialHitImpulseMult = 664247322,
        fInitialSearchRadius = 2790363538,
        fInjuredGetupImpulseMag2 = 461478411,
        fInputMax = 541735427,
        fIntensity = 3937240636,
        fJumpDescendRate = 564993371,
        fJumpToSmashWindowPhaseChange = 3670878450,
        fLifeTime = 2257773206,
        fLongJumpDescendRate = 1357105096,
        fLostTargetTime = 593698055,
        fMaxAboveHeadForOverheadReactions = 2841960409,
        fMaxAllyDistance = 1305363589,
        fMaxAngleBetweenTargets = 1848729150,
        fMaxAngleOffset = 3595841120,
        fMaxArmAmplitude = 3679690700,
        fMaxArmPeriod = 2396268986,
        fMaxArmStiffness = 3395352877,
        fMaxAttemptMoveToCoverDelay = 1947279181,
        fMaxAttemptMoveToCoverDelayGlobal = 3581780763,
        fMaxBuoyancy = 2562294840,
        fMaxDistForOverheadReactions = 1522624465,
        fMaxDistanceFromCorner = 1719840119,
        fMaxDistanceToTarget = 624502137,
        fMaxDstanceToMoveAwayFromAlly = 3914650526,
        fMaxDynamicStrafeDistance = 1721763990,
        fMaxHeliSpeedForRappel = 210693397,
        fMaxImpulseModifier = 628688906,
        fMaxJumpPhaseAllowDescend = 3096283176,
        fMaxJumpPhaseAllowSmashWindow = 1851998260,
        fMaxLeavingCornerDistance = 2930793396,
        fMaxRandomAdditionalOffset = 3574291632,
        fMaxRouteDistanceModifier = 685847089,
        fMaxSecondsDelayBetweenChatLines = 1048379145,
        fMaxSecondsDelayBetweenPhoneLines = 3637331931,
        fMaxStroke = 2122555922,
        fMaxTargetDistToUpdateFlinch = 3171415609,
        fMaxTargetDistToUpdateFlinchOnGround = 2588071080,
        fMaxTimeBeforeReactToExplosion = 1679184192,
        fMaxTimeBetweenBulletReactions = 433744442,
        fMaxTimeBetweenFrustratedPeds = 2786807653,
        fMaxTimeBetweenLookAt = 3890597462,
        fMaxTimeStrafing = 630125920,
        fMaxTimeToWait = 328649625,
        fMaxWaitForCoverExitTime = 1074424476,
        fMaxWaitSeconds = 1143137996,
        fMidStrength = 494142166,
        fMinAlliesForMaxAngleOffset = 1154727971,
        fMinArmAmplitude = 1774619724,
        fMinArmPeriod = 2926397774,
        fMinArmStiffness = 966292507,
        fMinAttemptMoveToCoverDelay = 449264633,
        fMinAttemptMoveToCoverDelayGlobal = 1975275563,
        fMinBuoyancy = 3789430640,
        fMinDistBetweenTargetAndOtherEnemies = 3248381180,
        fMinDistToNonTargetEnemy = 3283971281,
        fMinDistanceBetweenPeds = 398266299,
        fMinDistanceForAltCover = 1192276059,
        fMinDistanceFromPrimaryTarget = 2423717597,
        fMinDistanceSavingToUseVehicle = 3352862788,
        fMinDistanceSquaredToPlayerForAudio = 4242148097,
        fMinDistanceToBeConsideredSameEvent = 4233735310,
        fMinDistanceToBreakWindow = 1608634776,
        fMinDistanceToClearCorner = 2829098503,
        fMinDistanceToTarget = 2783817407,
        fMinDistanceToUseVehicle = 3455250403,
        fMinFinisherShotgunTotalImpulseBraced = 1412443494,
        fMinFinisherShotgunTotalImpulseNormal = 1471062121,
        fMinForwardVectorToFlinch = 729908938,
        fMinForwardVectorToFlinchOnGround = 3628130093,
        fMinHeadingDeltaToFixTurn = 1358716283,
        fMinHeadingDeltaToIdleTurn = 890221191,
        fMinHeightToRappel = 2869375884,
        fMinHoldThrowPitch = 1407383707,
        fMinImpulseModifier = 4043035065,
        fMinJumpPhaseAllowDescend = 2330528087,
        fMinJumpPhaseAllowSmashWindow = 425134671,
        fMinListenerRangeToDrawSonarBlips = 2604348013,
        fMinLoiteringTimeSeconds = 2196178671,
        fMinOtherPedDistanceDiff = 2587275512,
        fMinRiverFlowForRapids = 978248567,
        fMinRiverGroundClearanceForRapids = 2761683393,
        fMinSecondsDelayBetweenChatLines = 3930402274,
        fMinSecondsDelayBetweenPhoneLines = 2156082331,
        fMinSmashWindowPhase = 2105176291,
        fMinSpeedForPush = 1105441606,
        fMinStickValueAllowDescend = 4109388444,
        fMinStroke = 1198151288,
        fMinTimeAfterAimPoseForStateChange = 3273513642,
        fMinTimeBeforeReactToExplosion = 4258831091,
        fMinTimeBetweenBulletReactions = 1300484749,
        fMinTimeBetweenFrustratedPeds = 919558869,
        fMinTimeBetweenLookAt = 2167660448,
        fMinTimeBetweenRunDirectlyChecks = 3866357326,
        fMinTimeInCombatSeconds = 197521501,
        fMinTimeInGetUpToAllowCover = 266220607,
        fMinTimeInState = 1959218646,
        fMinTimeRunning = 1041070680,
        fMinTimeStandingAtCover = 4116440083,
        fMinTimeToWait = 1415555709,
        fMoveBlendRatioLerpTime = 599255143,
        fMuscleAngleStrengthRampDownRate = 3498784443,
        fMuscleSpeedStrengthRampDownRate = 3163227947,
        fNearDrawDistance = 1690336060,
        fNewPositionThreshold = 445998819,
        fOffset = 1293919506,
        fParachutingZoom = 105068200,
        fPitch = 632986329,
        fPlayerBeingTargetedExtraDistance = 3975640219,
        fPlayerDirectThreatDistance = 4134350078,
        fPlayerHighThreatWeighting = 2927479807,
        fPlayerMoveDistToResetChargeGoals = 1014164585,
        fPlayerMoveDistToResetLoiterPosition = 2426887593,
        fPlayerObstructionCheckRadius = 2115554015,
        fPlayerObstructionRadius = 2354781986,
        fPlayerThreatDistance = 1772648844,
        fPow = 2680890523,
        fPreferInjuredGetupPlayerHealthThreshold = 1193017389,
        fProbeLength = 586057169,
        fPronePedKickImpulse = 2891493908,
        fRadioSoundReductionAmount = 1747790072,
        fRadioSoundReductionDistance = 1838053251,
        fRadius = 315509558,
        fRagdollComponentBuoyancy = 2460325000,
        fRagdollScore = 4246262885,
        fRainSnowSoundReductionAmount = 801070127,
        fResultMax = 2372087104,
        fRetreatTime = 2224359067,
        fRoll = 2689106272,
        fRopeUnwindRate = 2890096206,
        fRotation = 2963173633,
        fSearchRangeMax = 3314827784,
        fSearchScaler = 2543804780,
        fSecondsInAirBeforePassengerComment = 156254164,
        fSecondsInRainTransitionPeriod = 3510850224,
        fSectionByTimeSliceDuration = 3421999474,
        fShadowBlur = 1632842349,
        fShotBlindFireProbability = 2977969682,
        fShotHeadAngleToFireGun = 3872529888,
        fShotWeaponAngleToFireGun = 3753244842,
        fShoutBlockingLosInterval = 1257619633,
        fShoutTargetPositionInterval = 2226395755,
        fSmallInfluenceSphereRadius = 304969557,
        fSoundRange_BarelyAudible = 347298932,
        fSoundRange_CarHighSpeed = 29182579,
        fSoundRange_CarHorn = 2428401420,
        fSoundRange_CarLowSpeed = 871660954,
        fSoundRange_ClearlyAudible = 2698396339,
        fSoundRange_Explosion = 1114733078,
        fSoundRange_FootstepBase = 3197086918,
        fSoundRange_FootstepFoliage = 1197726055,
        fSoundRange_GlassBreak = 1070205007,
        fSoundRange_Gunshot = 4073295642,
        fSoundRange_HeavyFootstep = 1578589400,
        fSoundRange_LandFromFall = 3329995088,
        fSoundRange_Megaphone = 121379805,
        fSoundRange_MostlyAudible = 1166640595,
        fSoundRange_ObjectCollision = 819051225,
        fSoundRange_Shouting = 2190165672,
        fSoundRange_SilencedGunshot = 3759114450,
        fSoundRange_Talking = 496127271,
        fSoundRange_WaterSplashLarge = 807986206,
        fSoundRange_WaterSplashSmall = 1532863616,
        fSoundRange_WeaponSpinUp = 3813597325,
        fSoundRange_Whisper = 1593818711,
        fSpecialAbilityRageKickImpulseModifier = 913654553,
        fStaminaDepletionBlinkPercentage = 420083265,
        fStartAimingDistance = 2899412417,
        fStartDescendingDistToTargetSq = 2804961359,
        fStartStrength = 2901808706,
        fStayUprightForceIdle = 604632997,
        fStayUprightForceMoving = 603776431,
        fStayUprightForceNonVelocityBased = 230707381,
        fStopAimingDistance = 1894206862,
        fSubtitleDuration = 1836544003,
        fTargetScenarioRadius = 1578763478,
        fTargetThreatOverride = 925392687,
        fTargetTooCloseDistance = 970868308,
        fTargetableDistance = 1046040592,
        fTargetingInactiveDisableTime = 3550430565,
        fTempInitialStiffnessWhenShot = 3121676006,
        fTime = 1591208228,
        fTimeBetweenAllyProximityChecks = 1201850831,
        fTimeBetweenAltCoverSearches = 1187764077,
        fTimeBetweenCombatDirectorUpdates = 687676716,
        fTimeBetweenCoverSearchesMax = 379663563,
        fTimeBetweenCoverSearchesMin = 4141996221,
        fTimeBetweenDragsMin = 697272720,
        fTimeBetweenFailedGestureMax = 1249935741,
        fTimeBetweenFailedGestureMin = 562041905,
        fTimeBetweenGestureAnimsMax = 853543838,
        fTimeBetweenGestureAnimsMin = 1148925964,
        fTimeBetweenGesturesMaxGlobal = 1473938462,
        fTimeBetweenGesturesMinGlobal = 3136547752,
        fTimeBetweenJackingAttempts = 2673669317,
        fTimeBetweenPassiveAnimsMax = 2278473263,
        fTimeBetweenPassiveAnimsMin = 3683572550,
        fTimeBetweenQuickGlancesMax = 3389707560,
        fTimeBetweenQuickGlancesMin = 2756383457,
        fTimeBetweenRouteSearches = 1932437978,
        fTimeBetweenSecondaryTargetUsesMax = 3340527808,
        fTimeBetweenSecondaryTargetUsesMin = 610577934,
        fTimeBetweenUpdates = 4202105817,
        fTimeSinceLastAimedAtForGesture = 2237966956,
        fTimeToIgnoreBlockedLosWeighting = 3653083064,
        fTimeToPickNewPoint = 330577879,
        fTimeToStandAtPerimeter = 2009665019,
        fTimeToUseSecondaryTargetMax = 3128077167,
        fTimeToUseSecondaryTargetMin = 3243108638,
        fTotalDuration = 1185457940,
        fTransitionInDuration = 2279341021,
        fTransitionOutDuration = 1271134520,
        fValue = 198751340,
        fVehicleOffset = 285457106,
        fVehicleTilt = 382138818,
        fVerticalRightingStrength = 3868696870,
        fVerticalRightingTime = 1372422790,
        fVolumeIntensity = 3963210786,
        fWidth = 658992148,
        fWorldH = 2995953429,
        fWorldW = 3885599006,
        fWorldX = 4115899538,
        fWorldY = 70992481,
        faceAnimationNodeName = 555167272,
        faceAttributesFilename = 3123042911,
        fadeCurveType = 2259012140,
        fadeInColor = 1910831709,
        fadeInTime = 3161810789,
        fadeOutColor = 2234426246,
        fadeOutTime = 2157942304,
        fblade_1fast = 1032498025,
        fblade_1mod = 1157497495,
        fblade_2fast = 930609265,
        fblade_2mod = 2573434709,
        fblade_3fast = 411536741,
        fblade_3mod = 879315983,
        forceFall = 569763335,
        forks_l = 991413023,
        forks_u = 837923007,
        frames = 580974885,
        futureHeightmapSampleTime = 892450737,
        futureSampleTime = 2996388896,
        fwClipSetWithGetup = 4285341798,
        fwDirectedClipItemWithProps = 3883314999,
        gpuPtFxEnabled = 4158673537,
        halfSigmoidConstant = 3368438810,
        handlebars = 2921986035,
        hdrMult = 271126249,
        iBulletEventResponseLengthMs = 2255380962,
        iComponent = 505193016,
        iCutsceneFlags = 2110267871,
        iDrawable = 2231657823,
        iEventArgsIndex = 4289498236,
        iEventId = 3149172832,
        iHeadLookRandomizationTimeMin = 1333092266,
        iHeadingRandomizationTimeMax = 72944862,
        iHeadingRandomizationTimeMin = 15793390,
        iHeadlookRandomizationTimeMax = 3088121500,
        iHealthDepletionBlinkPercentage = 4066516916,
        iLanguageID = 1537748314,
        iLightProperty = 2477126074,
        iLightType = 1233248098,
        iLivery = 756943177,
        iLivery2 = 2453634574,
        iMainBodyColour = 4067992989,
        iMaxLookAtTime = 2834021629,
        iMaxNumInjuredOnGroundAgents = 2495781827,
        iMaxPedsAtTrafficLights = 3623500230,
        iMaxPedsInCombatTask = 269064650,
        iMaxRandomExplosionTime = 3153397162,
        iMaxTime = 2235294119,
        iMaxTimeBeforeSearchingForNewHidingPlace = 3217586928,
        iMinLookAtTime = 1571509424,
        iMinNumEnemiesForScaling = 2189340328,
        iMinTime = 4168588760,
        iMinTimeBeforeSearchingForNewHidingPlace = 3618288355,
        iObjectId = 1657245540,
        iObjectIdList = 1236477325,
        iOverlayType = 211975133,
        iPlayerDirectThreatTimeMs = 653564341,
        iRandomDurationMax = 2620945991,
        iRandomDurationMin = 18835671,
        iRangeEnd = 398786672,
        iRangeStart = 1047819622,
        iRunningTimeForVelocityBasedStayupright = 971008663,
        iShotMaxBlindFireTimeH = 4263173023,
        iShotMaxBlindFireTimeL = 3609300401,
        iShotMaxTimeBeforeGunThreaten = 3639036861,
        iShotMaxTimeBetweenFireGun = 655022274,
        iShotMinTimeBeforeGunThreaten = 3985239087,
        iShotMinTimeBetweenFireGun = 3419541350,
        iSpecularColour = 1609620374,
        iTargetNotSeenIgnoreTimeMs = 3270779927,
        iTexture = 467155910,
        iTimeToStandAtSearchPoint = 1751162602,
        iTransitionIn = 2643240271,
        iTransitionOut = 2810110094,
        iVectorDefault = 178027873,
        indicator_lr = 3979005071,
        indicator_rr = 112742354,
        initialUnlockedCap = 1709960891,
        interiorHash = 595627342,
        interpTime = 3980674446,
        isUnderwater = 2320897552,
        largeCharge = 1846583548,
        lawResponseTime = 218173601,
        lawResponseType = 1915622273,
        layers = 197915343,
        leanKd = 664693842,
        leanKi = 814841404,
        leanKp = 2222663190,
        lightingType = 2671568709,
        limbId = 970730558,
        lookAtVelProbIfNoBumpTarget = 1708224645,
        maxCruiseSpeed = 3454970252,
        maxDesiredAnglePitchDegrees = 1673702936,
        maxDesiredAngleRollDegrees = 1731534963,
        maxDesiredAngleYawDegrees = 3035684229,
        maxDistanceAfterAimingToApplyAlternateScalingMax = 2968415887,
        maxHangoutChatDistSq = 1876536698,
        maxMinDistanceForRollComputation = 2791696823,
        maxPitch = 2569057742,
        maxPitchRoll = 139171723,
        maxRoll = 682642275,
        maxSecondsNearPlayerUntilHangoutQuit = 2302651663,
        maxThrottle = 2384591971,
        maxYaw = 4244700983,
        mediumCharge = 3545223222,
        midRadius = 3099411482,
        minMinDistanceForRollComputation = 502368761,
        minSecondsNearPlayerUntilHangoutQuit = 232011649,
        misc_1 = 2690009945,
        misc_2 = 1385115596,
        mod_a = 3654959273,
        mod_aa = 3843353624,
        mod_ab = 3135215534,
        mod_ac = 3364434689,
        mod_ad = 2723112578,
        mod_ae = 2970026993,
        mod_af = 2245832093,
        mod_ag = 2492156666,
        mod_ah = 1765012564,
        mod_ai = 2014155263,
        mod_aj = 1286290243,
        mod_ak = 1535367412,
        mod_b = 808381781,
        mod_c = 4268165574,
        mod_col_10 = 3033709986,
        mod_col_11 = 2249285664,
        mod_col_12 = 1498318491,
        mod_col_13 = 1787603223,
        mod_col_14 = 1573326728,
        mod_col_15 = 1862676998,
        mod_col_16 = 1044598917,
        mod_col_6 = 1547719720,
        mod_col_7 = 580018373,
        mod_col_8 = 4191162177,
        mod_col_9 = 3257212908,
        mod_d = 3579951032,
        mod_e = 2733953759,
        mod_f = 4123490435,
        mod_g = 3342441320,
        mod_h = 1726175929,
        mod_i = 1947366679,
        mod_j = 2065498928,
        mod_k = 2572238744,
        mod_l = 730555402,
        mod_m = 4194074861,
        mod_n = 1343696161,
        mod_o = 506677594,
        mod_p = 4167728581,
        mod_q = 3326122354,
        mod_r = 217851628,
        mod_s = 3666821647,
        mod_t = 2168885119,
        mod_u = 2399611648,
        mod_v = 3519328378,
        mod_w = 2958716326,
        mod_x = 3292501248,
        mod_y = 2651277456,
        mod_z = 3888995355,
        models = 4042130640,
        neon_b = 728001778,
        neon_f = 3850133799,
        neon_l = 4084563217,
        neon_r = 556062831,
        nonFlyableAreas = 3958481819,
        numFutureSamples = 54155191,
        numHeightmapFutureSamples = 1335540990,
        outFxName = 3344142251,
        overrideFaceAnimationFilename = 2464163899,
        pCutsceneEventArgsList = 101111438,
        pCutsceneEventList = 873743947,
        pCutsceneLoadEventList = 1537015366,
        pCutsceneObjects = 1337787258,
        pExtraBoneIds = 814194086,
        parameterIntensity = 3579895798,
        patchFile = 246845325,
        pedGroups = 3299118270,
        pitchKd = 1584865556,
        pitchKi = 665138033,
        pitchKp = 2427028852,
        playerNearToHangoutDistanceInMetersSquared = 724033442,
        ptFxDepthEvoMax = 3186421174,
        ptFxDepthEvoMin = 1171785422,
        rage__cutfAnimatedLightObject = 425672361,
        rage__cutfAnimatedParticleEffectObject = 3750235532,
        rage__cutfAnimationManagerObject = 162924556,
        rage__cutfAssetManagerObject = 68930034,
        rage__cutfAudioObject = 204478241,
        rage__cutfBlockingBoundsObject = 1024212505,
        rage__cutfBoolValueEventArgs = 2483426166,
        rage__cutfCameraCutCharacterLightParams = 2335868993,
        rage__cutfCameraCutEventArgs = 1032739425,
        rage__cutfCameraCutTimeOfDayDofModifier = 1378659296,
        rage__cutfCameraObject = 2665839426,
        rage__cutfCascadeShadowEventArgs = 852034231,
        rage__cutfCutsceneFile2 = 3527760993,
        rage__cutfCutsceneFile2__SConcatData = 1737539928,
        rage__cutfDecalEventArgs = 3570809234,
        rage__cutfDecalObject = 576081308,
        rage__cutfEvent = 2587541103,
        rage__cutfEventArgs = 534106966,
        rage__cutfFinalNameEventArgs = 80958073,
        rage__cutfFixupModelObject = 989168939,
        rage__cutfFloatValueEventArgs = 1609567909,
        rage__cutfHiddenModelObject = 979016746,
        rage__cutfLightObject = 1781777258,
        rage__cutfLoadSceneEventArgs = 3528166281,
        rage__cutfNameEventArgs = 1160694198,
        rage__cutfObjectIdEvent = 3787091478,
        rage__cutfObjectIdEventArgs = 3132728576,
        rage__cutfObjectIdListEventArgs = 1377451264,
        rage__cutfObjectIdNameEventArgs = 4198689239,
        rage__cutfObjectVariationEventArgs = 2095750852,
        rage__cutfOverlayObject = 2083739024,
        rage__cutfParticleEffectObject = 1696721139,
        rage__cutfPedModelObject = 462317467,
        rage__cutfPlayParticleEffectEventArgs = 222809975,
        rage__cutfPropModelObject = 2296489151,
        rage__cutfRayfireObject = 578480161,
        rage__cutfScreenFadeEventArgs = 303942334,
        rage__cutfScreenFadeObject = 2841702621,
        rage__cutfSubtitleEventArgs = 3215026609,
        rage__cutfSubtitleObject = 307438872,
        rage__cutfTriggerLightEffectEventArgs = 3654996547,
        rage__cutfVehicleExtraEventArgs = 4113944278,
        rage__cutfVehicleModelObject = 2042362651,
        rage__cutfVehicleVariationEventArgs = 918254035,
        rage__cutfWeaponModelObject = 3028272477,
        rage__parAttributeList = 1334016442,
        rblade_1fast = 451472348,
        rblade_1mod = 4141162370,
        rblade_2fast = 3599310922,
        rblade_2mod = 1768767594,
        rblade_3fast = 3929521030,
        rblade_3mod = 1496111458,
        rollKd = 2739053876,
        rollKi = 1158342846,
        rollKp = 3696891742,
        sampleSize = 1245538595,
        scoop_1mod = 2292220415,
        scoop_2mod = 2166816405,
        scoop_3mod = 2486991428,
        sectionSplitList = 4212477189,
        sigmoidConstant = 3286738338,
        sizeEvo = 1814735825,
        slowDistance = 2171885531,
        smallCharge = 2475436365,
        sortIndex = 2685533834,
        specialAbilities = 1644716366,
        speedMult = 1478381657,
        spike_1mod = 2796607005,
        spike_2mod = 3978311755,
        spike_3mod = 4063416457,
        strRequestRecording = 1353902600,
        streakDirection = 2002769312,
        streamedMusc = 4241737797,
        swingarm = 3929033220,
        tacticalXml = 2014698042,
        taillight_l = 3008822349,
        taillight_r = 914195096,
        throttleKd = 528950431,
        throttleKi = 974150069,
        throttleKp = 2573768812,
        timeAfterAimingToApplyAlternateScalingMax = 4000301303,
        timeAfterAimingToApplyAlternateScalingMin = 1097326038,
        timeAfterAimingToApplyDistanceBlend = 2278684726,
        timeToCatchfallMS = 382034967,
        timeWarpScale = 448101701,
        turret_a1 = 3992710274,
        turret_a2 = 1077448950,
        turret_a3 = 1382757723,
        turret_a4 = 614062521,
        turret_b1 = 3783807571,
        turret_b2 = 2839830988,
        turret_b3 = 3138651499,
        turret_b4 = 2400824695,
        typeFile = 2221257278,
        uAITimeBetweenGreeting = 4188496022,
        uAimToIdleLookAtTime = 1015010494,
        uCheckForChargeTargetPeriodMS = 1748071312,
        uCheckForSmokeThrowPeriodMS = 1637328324,
        uConsiderRecentChargeAsActiveTimeoutMS = 698042866,
        uConsiderRecentThrowAsActiveTimeoutMS = 865965443,
        uDistanceCheckPeriodMS = 2454614730,
        uMaxNumActiveChargers = 1678873512,
        uMaxNumActiveThrowers = 2870486361,
        uMaxTimeInMSToPlayRingTone = 3917563062,
        uMinTimeBetweenChargesAtSameTargetMS = 2705750728,
        uMinTimeBetweenThrowsAtSameTargetMS = 4240191943,
        uMinTimeForSamePedToChargeAgainMS = 921957248,
        uMinTimeForSamePedToThrowAgainMS = 2208519322,
        uNumPedsToTransitionToRainPerPeriod = 3616711897,
        uRepeatedAttemptsBeforeTeleportToLeader = 3188916891,
        uTicksUntilHangoutConversationCheck = 1226852111,
        uTimeBetweenLookBacks = 891569975,
        uTimeInMSUntilNewWeirdPedComment = 1037671842,
        uTimeToLookBack = 3027972140,
        uTimeToWaitAfterNewSayFailureInSeconds = 1968341934,
        vColour = 3313809689,
        vCorners = 2013990738,
        vDirection = 3788713491,
        vExtraRoomPos = 1493683017,
        vHaltFrequency = 220202594,
        vOffset = 281069076,
        vPosition = 1835178760,
        vRotation = 330442780,
        vRotationQuaternion = 1522820057,
        vScale = 1805863696,
        vScroll = 2514516235,
        vStartPosition = 2268451071,
        vTriggerOffset = 1263529604,
        vehGroups = 3356170168,
        vfxGroup = 222345803,
        weaponSlotSecondary = 2656206330,
        whiskerForwardSpeedScale = 3367104276,
        whiskerForwardTestDistance = 4280868953,
        whiskerLateralTestDistance = 369724672,
        whiskerTestAngle = 1412479638,
        whiskerVerticalTestDistance = 2043681017,
        widthRatio = 2261099445,
        wildlifeHabitats = 2772741337,
        windDebrisPtFxEnabled = 3909318761,
        windDebrisPtFxName = 1353578052,
        window_lm = 2675373130,
        window_lr = 2639884295,
        window_rm = 3523659197,
        window_rr = 2355575415,
        yawKd = 3266080932,
        yawKi = 1366920760,
        yawKp = 922081581,


        Velocity2 = 2944635386,


















        //from rubidium / dav90 PSO XML / zonebind
        mpName = 2031203854,
        zoneName = 257000,
        vfxRegion = 3384955624,
        vehDirtMin = 1831590592,
        vehDirtMax = 625824556,
        vehDirtGrowScale = 2919812941,
        pedDirtMin = 1861946207,
        pedDirtMax = 3150688023,



        //dilapidated list - from dav90 hash collider
        ActivateVehicleSiren = 3401359988,
        AerialVehiclePoint = 1653545417,
        MoveFollowMaster = 3724117664,
        AggressiveVehicleDriving = 2626064871,
        UseSearchlight = 1524211135,
        IgnoreWeatherRestrictions = 176469077,









        //from 0x1F9F1 - from companion app - thanks!!
        AbsoluteIntensityEnabled = 2168731396,
        AllowAnimatedDeadFall = 2283074537,
        AnimStreamingBase = 1324611103,
        AnimatedDeadFallSet = 1451470102,
        AttachedParentName = 734609027,
        CDataFileMgr__ChangeSetData = 666520515,
        CDataFileMgr__DataFileArray = 3044571784,
        CDataFileMgr__ResourceReference = 4089109759,
        CScenarioPointFlags__Flags = 700327466,
        DeadBlendOutSet = 4254591792,
        DirectionalLightMultiplier = 4246749927,
        DisableDirectionalLighting = 22229384,
        DisableHighQualityDof = 4064056507,
        FreezeReflectionMap = 2666061934,
        GenericWeaponType = 4160620743,
        GetupSet = 1940051574,
        LensArtefactMultiplier = 1253384283,
        LightFadeDistanceMult = 3267149471,
        LightShadowFadeDistanceMult = 3063864558,
        LightSpecularFadeDistMult = 71148997,
        LightVolumetricFadeDistanceMult = 2331545500,
        LodMultHD = 2245753507,
        LodMultLod = 129942887,
        LodMultOrphanedHD = 3792964618,
        LodMultSLod1 = 1682304034,
        LodMultSLod2 = 1316012152,
        LodMultSLod3 = 1218720991,
        LodMultSLod4 = 872811427,
        LookIkBlendRate = 1931302076,
        LookIkRotationLimit = 4044698613,
        LookIkTurnRate = 454750378,
        ReflectionLodRangeEnd = 2269408044,
        ReflectionLodRangeStart = 3995079835,
        ReflectionSLodRangeEnd = 1455403991,
        ReflectionSLodRangeStart = 2792355072,
        SSAOLightInten = 1099319606,
        TextureDictID = 2104882549,
        TimeOfDayDofModifers = 3502363965,
        WaterReflectionFarClip = 1832730358,
        allowedFolders = 3665250723,
        athFxListHash = 1844888803,
        bCanApplyRealDamage = 3754821582,
        bUseTimeCycleValues = 1299282176,
        bValidForPlayBack = 1999956592,
        cRenderTargetName = 4294123624,
        cameraCutHashName = 1262004121,
        clipVariationSets = 1333660780,
        discardFrameList = 1234565986,
        eAnimBoneTag = 2363471356,
        eAnimPlayerFlag = 224899699,
        eCurveType = 3921015781,
        eStreamingPolicy = 1631789397,
        eStreamingPriority = 733577798,
        fExponentialFallOff = 1342101,
        fExteriorFootZoom = 3725084347,
        fExteriorFootZoomRunning = 4112712376,
        fExteriorFootZoomWanted = 646913210,
        fExteriorFootZoomWantedRunning = 397988749,
        fFowWaterHeight = 1452712925,
        fInnerConeAngle = 2725338958,
        fInteriorFootZoom = 3533921583,
        fMapLodScale = 3931395097,
        fRangeZoomedScalarPlane = 928938887,
        fRangeZoomedScalarStandard = 707151806,
        fVehicleMovingWantedZoom = 709315443,
        fVehicleMovingZoom = 4088397509,
        fVehicleSpeedZoomScalar = 1734631491,
        fVehicleStaticWantedZoom = 3692711717,
        fVehicleStaticZoom = 2402173156,
        fVolumeSizeScale = 75610905,
        fwClipVariationSet = 1005381910,
        fwProfanityFilter = 932638721,
        iAltRangeEnd = 4079543520,
        iAttachBoneHash = 3936668519,
        iAttachParentId = 867510818,
        iBlendOutCutsceneDuration = 1783584102,
        iBlendOutCutsceneOffset = 660302675,
        iSecondBodyColour = 1237172464,
        iWheelTrimColour = 2225359196,
        interpolateToDisabled = 2862808673,
        modelHashName = 2549745289,
        pChildEvents = 3754530640,
        profaneTerms = 4259179796,
        rage__cutfAttributeList = 1016128875,
        rage__eLodType = 1264241711,
        rage__ePriorityLevel = 648413703,
        rage__fwArchetypeDef__eAssetType = 1991964615,
        rage__fwContainerLodDef = 372253349,
        reservedFSCharacters = 3574026465,
        reservedTerms = 3705267857,
        strRecordedRequest = 3356301454,
        strResourceReference = 2548004600,
        uHourFlags = 2759730476,
        uLightFlags = 2428927641,
        vInitialBoneOffset = 583681460,
        vInitialBoneRotation = 1039931786,

        //from 0x1F9F1
        PROCOBJ_USE_GRID = 2886679239,
        VFXGROUP_BRICK = 3154734852,
        VFXGROUP_BUSHES = 1128169606,
        VFXGROUP_CARPET_FABRIC = 3026080462,
        VFXGROUP_CARPET_FABRIC_DUSTY = 267379975,
        VFXGROUP_CAR_GLASS = 2254996260,
        VFXGROUP_CAR_METAL = 1472286989,
        VFXGROUP_CERAMIC = 2224745689,
        VFXGROUP_CLAY = 340754025,
        VFXGROUP_CONCRETE = 3909664268,
        VFXGROUP_DIRT_DRY = 3010631297,
        VFXGROUP_DRIED_MEAT = 2465001478,
        VFXGROUP_FEATHERS = 1671778076,
        VFXGROUP_FRESH_MEAT = 3221146268,
        VFXGROUP_GLASS = 676227960,
        VFXGROUP_GLASS_BULLETPROOF = 1453403596,
        VFXGROUP_GRASS = 415809717,
        VFXGROUP_GRASS_SHORT = 349709635,
        VFXGROUP_GRAVEL = 1433594767,
        VFXGROUP_GRAVEL_DEEP = 455532549,
        VFXGROUP_HAY = 1126885779,
        VFXGROUP_ICE = 646994767,
        VFXGROUP_LEAVES = 1143575659,
        VFXGROUP_LIQUID_BLOOD = 4066674550,
        VFXGROUP_LIQUID_OIL = 2971250354,
        VFXGROUP_LIQUID_PETROL = 3406258685,
        VFXGROUP_LIQUID_WATER = 2626785081,
        VFXGROUP_MARBLE = 1577332483,
        VFXGROUP_METAL = 3837427351,
        VFXGROUP_MUD_DEEP = 3891414216,
        VFXGROUP_MUD_SOFT = 2357888979,
        VFXGROUP_MUD_UNDERWATER = 3403853718,
        VFXGROUP_PAPER = 4159761865,
        VFXGROUP_PAVING = 2355147898,
        VFXGROUP_PED_CAPSULE = 55400259,
        VFXGROUP_PED_FOOT = 1875610286,
        VFXGROUP_PED_HEAD = 2268340744,
        VFXGROUP_PED_LIMB = 2787107962,
        VFXGROUP_PED_TORSO = 2473728071,
        VFXGROUP_PLASTER_BRITTLE = 3891593880,
        VFXGROUP_PLASTIC = 3864441807,
        VFXGROUP_PLASTIC_HOLLOW = 1987630632,
        VFXGROUP_PUDDLE = 1875581587,
        VFXGROUP_RUBBER = 3735882313,
        VFXGROUP_SANDSTONE = 1961167048,
        VFXGROUP_SANDSTONE_BRITTLE = 2694183171,
        VFXGROUP_SAND_COMPACT = 350030577,
        VFXGROUP_SAND_WET = 3640634991,
        VFXGROUP_SAND_WET_DEEP = 3942228219,
        VFXGROUP_SNOW_COMPACT = 4165326180,
        VFXGROUP_SNOW_LOOSE = 3285173209,
        VFXGROUP_STONE = 3533829783,
        VFXGROUP_TARMAC = 1181702304,
        VFXGROUP_TREE_BARK = 2219631463,
        VFXGROUP_VOID = 2399258053,
        VFXGROUP_WOOD = 59976830,
        VFXGROUP_WOOD_DUSTY = 1551687812,
        VFXGROUP_WOOD_SPLINTER = 4047674909,












        //from junctions.xml -dexy
        CJunctionTemplateArray = 313816480,
        CJunctionTemplate = 2985578477,
        Entries = 3580294544,
        iFlags = 1490815345,
        iNumJunctionNodes = 3730457984,
        iNumEntrances = 3629382379,
        iNumPhases = 4284697782,
        iNumTrafficLightLocations = 2024774002,
        fSearchDistance = 3543631740,
        fPhaseOffset = 33051442, //from dav90
        vJunctionMin = 4254986313,
        vJunctionMax = 2705763988,
        vJunctionNodePositions = 1140501121,
        Entrances = 2079778626,
        PhaseTimings = 970330902,
        TrafficLightLocations = 3688283693,
        vNodePosition = 137333670,
        iPhase = 1580401081,
        fStoppingDistance = 4131936721,
        fOrientation = 2674216667,
        fAngleFromCenter = 253800508,
        bCanTurnRightOnRedLight = 4189109284,
        bLeftLaneIsAheadOnly = 15530841,
        bRightLaneIsRightOnly = 1190125928,
        iLeftFilterLanePhase = 478748718,
        fStartTime = 1971943265,
        fDuration = 3674620953,
        iPosX = 681100199,
        iPosY = 1574841905,
        iPosZ = 176392061,


        //from openIV
        dependencies = 1013942340,
        hdTextureDist = 2908576588,
        clipDictionary = 424089489,
        physicsDictionary = 3553040380,
        priorityLevel = 647098393,
        ambientOcclusionMultiplier = 415356295,
        artificialAmbientOcclusion = 599844163,
        tintValue = 1015358759,
        contentFlags = 1785155637,
        streamingExtentsMin = 3710026271,
        streamingExtentsMax = 2720965429,
        entitiesExtentsMin = 477478129,
        entitiesExtentsMax = 1829192759,
        containerLods = 2935983381,
        boxOccluders = 3983590932,
        occludeModels = 2132383965,
        physicsDictionaries = 949589348,
        instancedData = 2569067561,
        carGenerators = 3254823756,
        LODLightsSOA = 1774371066,
        DistantLODLightsSOA = 2954466641,
        Ao = 2996378564,
        BatchAABB = 1859041902,
        InstanceList = 470289337,
        LodFadeStartDist = 2216273066,
        LodInstFadeRange = 1405992723,
        OrientToTerrain = 3341475578,
        ImapLink = 2142127586,
        PropInstanceList = 3551474528,
        GrassInstanceList = 255292381,
        numStreetLights = 3708891211,
        category = 2052871693,
        exportedBy = 1983184981,
        StartImapFile = 2462971690,
        EndImapFile = 2059586669,
        PtFxAssetName = 2497993358,
        punchInPhase = 3142377407,
        punchOutPhase = 2164219370,

        AvailabilityInMpSp = 2932681318,
        iTimeStartOverride = 591476992,
        iTimeEndOverride = 2688038523,
        TimeTillPedLeaves = 4073598194,
        instances = 274177522,
        flashiness = 3829693202,
        lightType = 482065968,
        groupId = 2501631252,
        cullingPlane = 1689591312,
        padding1 = 3180641850,
        padding2 = 2346113727,
        padding3 = 3521603295,
        volIntensity = 689780512,
        volSizeScale = 2029533327,
        volOuterColour = 2283994062,
        lightHash = 643049222,
        volOuterIntensity = 3008198647,
        coronaSize = 1705000075,
        volOuterExponent = 2758849250,
        lightFadeDistance = 1307926275,
        shadowFadeDistance = 1944267876,
        specularFadeDistance = 4150887048,
        volumetricFadeDistance = 2066998816,
        shadowNearClip = 954647178,
        coronaIntensity = 2292363771,
        coronaZBias = 2520359283,
        coneInnerAngle = 1163671864,
        coneOuterAngle = 4175029060,
        extents = 759134656,
        projectedTextureKey = 1076718994,
        timeAndStateFlags = 3112418278,
        coneOuterAngleOrCapExt = 3161894080,

        minExtents = 1731020657,
        maxExtents = 2554806840,

        orientX = 735213009,
        orientY = 979440342,
        perpendicularLength = 124715667,
        bodyColorRemap1 = 1429703670,
        bodyColorRemap2 = 1254848286,
        bodyColorRemap3 = 1880965569,
        bodyColorRemap4 = 1719152247,
        popGroup = 911358791,

        enableLimitAngle = 1979299226,
        startsLocked = 3204572347,
        canBreak = 2756786344,
        doorTargetRatio = 770433283,
        audioHash = 224069936,

        effectHash = 2982223448,
        materialType = 932754174,
        canGetOffAtTop = 564839673,
        canGetOffAtBottom = 923729576,

        manifestFlags = 1683136603,

        AT_DRB = 1956121915,
        AT_FRG = 2872363693,
        AT_DWD = 474212588,
        INTERIOR_DATA = 559321238,

        METAL_SOLID_LADDER = 1101797524,

        PRI_REQUIRED = 1943361227,
        PRI_OPTIONAL_HIGH = 3993616791,
        PRI_OPTIONAL_MEDIUM = 515598709,
        PRI_OPTIONAL_LOW = 329627604,


        ASSET_TYPE_UNINITIALIZED = 189734893,
        ASSET_TYPE_FRAGMENT = 571047911,
        ASSET_TYPE_DRAWABLE = 130075505,
        ASSET_TYPE_DRAWABLEDICTIONARY = 1580165652,
        ASSET_TYPE_ASSETLESS = 4161085041,

        aLevelsData = 1643066032,
        cFriendlyName = 2077026003,
        cTitle = 834048882,
        cFilename = 3760135447,
        cBugstarName = 3970741067,



        //openIV carcols.ymt
        VehiclePlates = 593302648,
        Textures = 1767854039,
        TextureSetName = 539384795,
        DiffuseMapName = 1085051633,
        FontExtents = 1008020858,
        MaxLettersOnPlate = 1247956775,
        FontColor = 1707432934,
        FontOutlineColor = 2386115193,
        IsFontOutlineEnabled = 3610161521,
        FontOutlineMinMaxDepth = 1248154675,
        DefaultTexureIndex = 3080794991,
        NumericOffset = 4285827253,
        AlphabeticOffset = 1050521113,
        SpaceOffset = 1314537973,
        RandomCharOffset = 2935763181,
        NumRandomChar = 3588975658,
        Colors = 721554909,
        metallicID = 2578478329,
        audioColor = 1773594779,
        audioPrefix = 2369251831,
        audioColorHash = 2318773127,
        audioPrefixHash = 319619186,
        colorName = 3636206675,
        MetallicSettings = 1425754958,
        specInt = 583457853,
        specFalloff = 4263701895,
        specFresnel = 3304136448,
        WindowColors = 923621137,
        Sirens = 2599949557,
        timeMultiplier = 1771951321,
        lightFalloffMax = 154568665,
        lightFalloffExponent = 1650161522,
        lightInnerConeAngle = 1576817313,
        lightOuterConeAngle = 3797248043,
        lightOffset = 1620490850,
        sequencerBpm = 1335282710,
        sequencer = 3240773244,
        leftHeadLight = 649479127,
        rightHeadLight = 1381853174,
        leftTailLight = 1551657213,
        rightTailLight = 3049986329,
        leftHeadLightMultiples = 3399909735,
        rightHeadLightMultiples = 3461946667,
        leftTailLightMultiples = 4275157148,
        rightTailLightMultiples = 2310746177,
        useRealLights = 804083006,
        delta = 1117510170,
        syncToBpm = 43887647,
        corona = 3191162493,
        faceCamera = 992261783,
        lightGroup = 2689509391,
        scaleFactor = 3961827348,
        light = 1118124053,
        spotLight = 1568651848,
        castShadows = 3640997727,
        livery2Names = 3280812844,
        GlobalVariationData = 4171652890,
        xenonLightColor = 4198188279,
        xenonCoronaColor = 4113209874,
        xenonLightIntensityModifier = 849227792,
        xenonCoronaIntensityModifier = 3145775573,
        XenonLightColors = 2580788834,
        lightColor = 78766281,
        coronaColor = 3615736814,
        lightIntensityModifier = 1981979787,
        coronaIntensityModifier = 3155797354,
        plate01 = 3793757640,
        plate01_n = 2329256829,
        plate02 = 3066416908,
        plate02_n = 78526510,
        plate03 = 3311627335,
        plate03_n = 1477063549,
        plate04 = 3031091930,
        plate04_n = 3852780795,
        plate05 = 3328732757,
        plate05_n = 1362454864,
        yankton_plate = 1105760996,
        yankton_plate_n = 2879046597,
        vehiclelight_car_oldsquare = 4167891426,
        vehiclelight_car_standardmodern = 1589248857,
        vehiclelight_car_standard70s = 2715410525,
        vehiclelight_misc_searchlight = 3175349370,
        vehiclelight_bicycle = 3795628543,
        vehiclelight_car_led1 = 1544471332,
        vehiclelight_car_led2 = 240428977,
        vehiclelight_bike_sport = 4252173109,
        vehiclelight_bike_round = 2436766032,
        vehiclelight_car_utility = 37930801,
        vehiclelight_misc_squarelight = 1293462541,
        vehiclelight_car_antique = 708414868,
        vehiclelight_sirenlight = 3203227048,



        //entity sets names
        gunclubwallhooks = 222589842,
        csr_aftermissiona = 3324720001,
        csr_beforemission = 507019248,
        shutter_closed = 135028740,
        shutter_open = 3779056592,
        csr_aftermissionb = 2132157784,
        csr_inmission = 3771216531,
        apart_mid_strip_c = 1767490248,
        apart_mid_strip_b = 1454546298,
        apart_mid_strip_a = 2361756067,
        apart_mid_booze_a = 537743492,
        apart_mid_booze_b = 3984386920,
        apart_mid_booze_c = 60430238,
        apart_mid_smoke_a = 873487239,
        apart_mid_smoke_b = 1169882844,
        apart_mid_smoke_c = 1231029802,
        v_19_trevor_mess = 1408412140,
        gunstorehooks = 932770399,
        franklin_settled = 505210044,
        showhome_only = 3108035823,
        bong_and_wine = 724771030,
        unlocked = 427136516,
        franklin_unpacking = 3574333214,
        progress_tux = 2759063603,
        progress_flyer = 3881703893,
        progress_tshirt = 3988026567,
        v_26_michael_stay1 = 1395004567,
        v_26_trevor_helmet1 = 1452356424,
        v_24_trevor_briefcase1 = 1453947231,
        jewel_gasmasks = 385665833,
        v_35_fireman = 2416265113,
        v_35_kitbag = 2855230688,
        v_35_body_armour = 3555206809,
        v_35_bigscore_prints = 3408699224,
        v_53_agency_blueprint = 945099816,
        hospitaldoorsanim = 1281911721,
        hospitaldoorsfixed = 870979149,
        v_michael_d_items = 1498315651,
        v_michael_m_items = 2068492081,
        v_michael_m_items_swap = 3724496899,
        v_michael_s_items = 1854531638,
        v_michael_s_items_swap = 3752057267,
        burgershot_yoga = 129445262,
        michael_premier = 4073680526,
        v_michael_d_moved = 3346431884,
        v_michael_m_moved = 3292302209,
        v_michael_l_moved = 1403018978,
        v_michael_l_items = 4108105115,
        v_michael_jewelheist = 579494349,
        v_michael_fameshame = 1036032624,
        v_michael_plane_ticket = 902180143,
        v_michael_bed_messy = 2948872357,
        v_michael_bed_tidy = 2316632657,
        v_michael_book = 1527302884,
        clotheslowhipster = 2035297716,
        clotheslowcheap = 302988260,
        v_57_franklinstuff = 4129415530,
        v_57_franklin_left = 1434517950,
        v_57_gangbandana = 2316500832,
        v_57_safari = 1408201669,
        hanger_blood_splat = 911698731,
        layer_debra_pic = 1711238434,
        layer_wade_shit = 1684980259,
        layer_whiskey = 1360975868,
        layer_mess_a = 1540591373,
        swap_clean_apt = 321581955,
        layer_mess_b = 2492268691,
        layer_mess_c = 99443542,
        layer_torture = 2882227973,
        swap_sofa_a = 2863807359,
        swap_sofa_b = 2629869468,
        swap_mrjam_c = 225211868,
        swap_mrjam_b = 4280768850,
        swap_mrjam_a = 3994105638,
        swap_wade_sofa_a = 4075872417,
        swap_sofa_c = 3329159928,
        layer_sextoys_a = 3621825005,
        v_fib04_set_ah3a = 1224238458,
        v_fib02_set_ah3b = 681005436,
        v_fib02_set_ah3 = 1474689261,
        little_seoul_station = 567974529,
        del_perro_station = 1761791276,
        burton_station = 1422151076,
        lsia_parking_station = 1470070868,
        lsia_terminal4_station = 667754166,
        portola_station = 2133802285,

        //entity sets mpbusiness2/mpapartment
        apart_hi_booze_b = 1677965315,
        apart_hi_strip_b = 2749402076,
        apart_hi_smokes_b = 203816847,
        apart_hi_booze_a = 792645238,
        apart_hi_smokes_c = 2521175017,
        apart_hi_strip_a = 3041144483,
        apart_hi_smokes_a = 4192164610,
        apart_hi_booze_c = 1381078175,
        apart_hi_strip_c = 415790506,

        //entity sets mpapartment
        stilts_kitchen_window = 1335225960,

        //entity sets mpbattle
        dj_01_lights_01 = 2931965245,
        dj_01_lights_02 = 3175668298,
        dj_01_lights_03 = 2350807030,
        dj_01_lights_04 = 2578060045,
        dj_02_lights_01 = 3812217177,
        dj_02_lights_02 = 300297905,
        dj_02_lights_03 = 4289432124,
        dj_02_lights_04 = 780330986,
        dj_03_lights_01 = 2155647719,
        dj_03_lights_02 = 1457274795,
        dj_03_lights_03 = 1681578600,
        dj_03_lights_04 = 406274658,
        dj_04_lights_01 = 2842406476,
        dj_04_lights_02 = 2543389351,
        dj_04_lights_03 = 47964355,
        dj_04_lights_04 = 4103095340,
        int01_ba_bar_content = 310525184,
        int01_ba_booze_01 = 2420839796,
        int01_ba_booze_02 = 2659561961,
        int01_ba_booze_03 = 2980239395,
        int01_ba_clubname_01 = 1400945938,
        int01_ba_clubname_02 = 1126177917,
        int01_ba_clubname_03 = 1364310240,
        int01_ba_clubname_04 = 1604507010,
        int01_ba_clubname_05 = 1879143999,
        int01_ba_clubname_06 = 3998937844,
        int01_ba_clubname_07 = 2090405746,
        int01_ba_clubname_08 = 2323688257,
        int01_ba_clubname_09 = 2532492325,
        int01_ba_clutter = 3776296111,
        int01_ba_deliverytruck = 3565776669,
        int01_ba_dj01 = 3704085289,
        int01_ba_dj02 = 2979103933,
        int01_ba_dj03 = 2671173640,
        int01_ba_dj04 = 2515389814,
        int01_ba_dry_ice = 3348096996,
        int01_ba_equipment_setup = 2428285476,
        int01_ba_equipment_upgrade = 3899265928,
        int01_ba_lightgrid_01 = 3361871562,
        int01_ba_lights_screen = 3775050651,
        int01_ba_screen = 874196787,
        int01_ba_security_upgrade = 3191014004,
        int01_ba_style01 = 3080584485,
        int01_ba_style01_podium = 2318530949,
        int01_ba_style02 = 3374850105,
        int01_ba_style02_podium = 2599037099,
        int01_ba_style03 = 3142419588,
        int01_ba_style03_podium = 2128978564,
        int01_ba_trad_lights = 1317387632,
        int01_ba_trophy01 = 3419254565,
        int01_ba_trophy02 = 1432339015,
        int01_ba_trophy03 = 1203054322,
        int01_ba_trophy04 = 4202925196,
        int01_ba_trophy05 = 1808854825,
        int01_ba_trophy07 = 2023885003,
        int01_ba_trophy08 = 3012296350,
        int01_ba_trophy09 = 2630209810,
        int01_ba_trophy10 = 3464413748,
        int01_ba_trophy11 = 2368094084,
        int01_ba_worklamps = 460578945,
        int02_ba_cash01 = 1557518127,
        int02_ba_cash02 = 2334438348,
        int02_ba_cash03 = 2154733152,
        int02_ba_cash04 = 3529753153,
        int02_ba_cash05 = 3906596653,
        int02_ba_cash06 = 4274363140,
        int02_ba_cash07 = 230701305,
        int02_ba_cash08 = 2876273755,
        int02_ba_cash_eqp = 1764666248,
        int02_ba_clutterstuff = 3955677234,
        int02_ba_coke01 = 2212289418,
        int02_ba_coke02 = 2510520087,
        int02_ba_coke_eqp = 1866838446,
        int02_ba_deskpc = 3413087677,
        int02_ba_equipment_upgrade = 2880237713,
        int02_ba_fanblocker01 = 3145588074,
        int02_ba_floor01 = 3098322372,
        int02_ba_floor02 = 120373959,
        int02_ba_floor03 = 477031755,
        int02_ba_floor04 = 3948350236,
        int02_ba_floor05 = 26359698,
        int02_ba_forged01 = 3570303896,
        int02_ba_forged02 = 17292298,
        int02_ba_forged03 = 378013438,
        int02_ba_forged04 = 2276911450,
        int02_ba_forged05 = 1374354883,
        int02_ba_forged06 = 590454865,
        int02_ba_forged07 = 4038802277,
        int02_ba_forged08 = 3805061000,
        int02_ba_forged09 = 202895902,
        int02_ba_forged10 = 2509507236,
        int02_ba_forged11 = 1614094255,
        int02_ba_forged12 = 1753231429,
        int02_ba_forged_eqp = 276834259,
        int02_ba_garage_blocker = 3610586026,
        int02_ba_meth01 = 1203583087,
        int02_ba_meth02 = 1439192197,
        int02_ba_meth03 = 2624676314,
        int02_ba_meth04 = 978623902,
        int02_ba_meth_eqp = 278040560,
        int02_ba_sec_desks_l1 = 3102887022,
        int02_ba_sec_desks_l2345 = 2535978010,
        int02_ba_sec_upgrade_desk = 629230780,
        int02_ba_sec_upgrade_desk02 = 361718895,
        int02_ba_sec_upgrade_grg = 1541022547,
        int02_ba_sec_upgrade_strg = 4152620011,
        int02_ba_storage_blocker = 1725754299,
        int02_ba_truckmod = 2601107811,
        int02_ba_weed01 = 1584471883,
        int02_ba_weed02 = 2360540110,
        int02_ba_weed03 = 297797110,
        int02_ba_weed04 = 1064755555,
        int02_ba_weed05 = 132248122,
        int02_ba_weed06 = 4270317446,
        int02_ba_weed07 = 1518704512,
        int02_ba_weed08 = 2286973717,
        int02_ba_weed09 = 890883241,
        int02_ba_weed10 = 2958674643,
        int02_ba_weed11 = 276433682,
        int02_ba_weed12 = 1111748261,
        int02_ba_weed13 = 2300640350,
        int02_ba_weed14 = 514992002,
        int02_ba_weed15 = 3665076044,
        int02_ba_weed16 = 146045899,
        int02_ba_weed_eqp = 2458612981,
        int_03_ba_bikemod = 2663587726,
        int_03_ba_design_01 = 1732106335,
        int_03_ba_design_02 = 1505770852,
        int_03_ba_design_03 = 1256890297,
        int_03_ba_design_04 = 2619556393,
        int_03_ba_design_05 = 2369561692,
        int_03_ba_design_06 = 2138671318,
        int_03_ba_design_07 = 4056345971,
        int_03_ba_design_08 = 3826045439,
        int_03_ba_design_09 = 3560059466,
        int_03_ba_design_10 = 318253677,
        int_03_ba_design_11 = 558712599,
        int_03_ba_design_12 = 797893530,
        int_03_ba_design_13 = 4138398163,
        int_03_ba_design_14 = 3421281367,
        int_03_ba_design_15 = 2469374686,
        int_03_ba_design_16 = 3900003688,
        int_03_ba_design_17 = 2944623493,
        int_03_ba_design_18 = 2227244545,
        int_03_ba_design_19 = 1278352612,
        int_03_ba_design_20 = 2489068527,
        int_03_ba_design_21 = 1639040667,
        int_03_ba_design_22 = 1870029348,
        int_03_ba_design_23 = 504151926,
        int_03_ba_design_24 = 173709330,
        int_03_ba_design_25 = 4179916198,
        int_03_ba_drone = 47979954,
        int_03_ba_light_rig1 = 1608546420,
        int_03_ba_light_rig2 = 4062125299,
        int_03_ba_light_rig3 = 2621206839,
        int_03_ba_light_rig4 = 777655668,
        int_03_ba_light_rig5 = 2147793096,
        int_03_ba_light_rig6 = 2447400063,
        int_03_ba_light_rig7 = 3578913633,
        int_03_ba_light_rig8 = 1675985034,
        int_03_ba_light_rig9 = 3104058054,
        int_03_ba_tint = 633509008,
        int_03_ba_weapons_mod = 4096055828,
        light_rigs_off = 4015140297,

        //entity sets mpbiker
        mod_booth = 1242352420,
        no_mod_booth = 3731175334,
        walls_01 = 650945726,
        walls_02 = 888815897,
        furnishings_02 = 538312089,
        furnishings_01 = 157077543,
        decorative_01 = 2398112523,
        mural_01 = 636349742,
        mural_02 = 264159440,
        mural_03 = 40969781,
        mural_04 = 4225833237,
        mural_05 = 2093849324,
        mural_06 = 1854209627,
        mural_07 = 1498076135,
        mural_08 = 1255749380,
        mural_09 = 3655488880,
        gun_locker = 2708193190,
        no_gun_locker = 1913101980,
        decorative_02 = 1406325969,
        meth_stash1 = 1250796991,
        meth_stash2 = 943128850,
        meth_stash3 = 1217700329,
        coke_stash1 = 1663583957,
        coke_stash2 = 2117106917,
        coke_stash3 = 2285801729,
        weed_stash1 = 1013918893,
        weed_stash2 = 239390809,
        weed_stash3 = 534410116,
        cash_stash1 = 2653961146,
        cash_stash2 = 278208642,
        cash_stash3 = 106630158,
        id_stash1 = 4256794006,
        id_stash2 = 2715143632,
        id_stash3 = 2957273773,
        counterfeit_stash1 = 3581027591,
        counterfeit_stash2 = 600326578,
        counterfeit_stash3 = 264247714,

        //entity sets mpchristmas2017
        control_1 = 2393334974,
        control_2 = 690788794,
        weapons_mod = 508835643,
        vehicle_mod = 1924399170,
        shell_tint = 3614325340,
        control_3 = 970668823,
        gold_bling = 1381669486,
        set_int_02_cannon = 3108328803,
        set_int_02_sleep = 2111776833,
        set_int_02_security = 409096378,
        set_int_02_shell = 1588987531,
        set_int_02_decal_01 = 2498415559,
        set_int_02_decal_02 = 2732189605,
        set_int_02_decal_03 = 347065327,
        set_int_02_decal_04 = 4192704095,
        set_int_02_decal_05 = 137442034,
        set_int_02_decal_06 = 3714309456,
        set_int_02_decal_07 = 3940186173,
        set_int_02_decal_08 = 2967471177,
        set_int_02_decal_09 = 3259868964,
        set_int_02_lounge2 = 385551580,
        set_int_02_no_cannon = 1036341571,
        set_int_02_lounge3 = 3838126193,
        set_int_02_lounge1 = 79849579,
        set_int_02_sleep2 = 2278578919,
        set_int_02_sleep3 = 758949329,
        set_int_02_no_security = 251551060,
        set_int_02_no_sleep = 1428038294,
        set_int_02_trophy1 = 1385047109,
        set_int_02_trophy_sub = 2363826375,
        set_int_02_trophy_iaa = 706732192,
        set_int_02_parts_avenger1 = 1177071611,
        set_int_02_parts_avenger2 = 351915422,
        set_int_02_parts_avenger3 = 582183185,
        set_int_02_parts_cheno2 = 2457454169,
        set_int_02_parts_cheno1 = 1261090748,
        set_int_02_parts_cheno3 = 2697421556,
        set_int_02_parts_panther1 = 1624260135,
        set_int_02_parts_panther2 = 714985923,
        set_int_02_parts_panther3 = 1013740896,
        set_int_02_parts_riot2 = 2683943874,
        set_int_02_parts_riot3 = 4056735591,
        set_int_02_parts_riot1 = 1145373786,
        set_int_02_parts_thruster3 = 915604303,
        set_int_02_parts_thruster1 = 1865643151,
        set_int_02_parts_thruster2 = 4252307732,
        set_int_02_clutter1 = 2163025381,
        set_int_02_clutter2 = 3063943498,
        set_int_02_clutter3 = 3831655630,
        set_int_02_clutter4 = 1834057370,
        set_int_02_clutter5 = 1066607390,
        set_int_02_crewemblem = 3273149262,
        set_int_02_paramedic_complete = 360721780,
        set_int_02_forcedentry_complete = 963060290,
        set_int_02_aqualungs_complete = 3718418644,
        set_int_02_daylightrob_complete = 933014207,
        set_int_02_burglary_complete = 3859335091,
        set_int_02_flightrecord_complete = 3601726509,
        set_int_02_outfit_paramedic = 4207506483,
        set_int_02_outfit_morgue = 3567809529,
        set_int_02_outfit_serverfarm = 2644260000,
        set_int_02_outfit_iaa = 3773553453,
        set_int_02_outfit_steal_avenger = 4042002313,
        set_int_02_outfit_foundry = 3365764693,
        set_int_02_outfit_riot_van = 2778800210,
        set_int_02_outfit_stromberg = 3237449761,
        set_int_02_outfit_sub_finale = 4058674657,
        set_int_02_outfit_predator = 28637809,
        set_int_02_outfit_khanjali = 4236450218,
        set_int_02_outfit_volatol = 746550596,
        iaa_conf2_chairs = 1255002051,
        iaa_coverpoints_01 = 1908652377,
        iaa_benches = 639653527,

        //entity sets mpchristmas2018
        set_pit_high = 1140297499,
        set_pit_low = 2190010148,
        set_pit_mid = 3082448067,
        set_pit_fence_closed = 1999365999,
        set_pit_fence_demolition = 2746534438,
        set_pit_fence_oval = 2950022145,
        set_wall_no_pit = 775863387,
        set_turrets = 1843422879,
        set_scifi_02 = 3516509261,
        set_team_band_a = 2891976669,
        set_team_band_b = 3096553536,
        set_scifi_03 = 476070361,
        set_scifi_04 = 774301030,
        set_scifi_05 = 170106208,
        set_scifi_06 = 452017915,
        set_scifi_07 = 1687802447,
        set_scifi_08 = 1997174576,
        set_scifi_09 = 1183618613,
        set_scifi_10 = 3183248795,
        set_dystopian_09 = 456074120,
        set_animation_seats = 2721138173,
        set_dystopian_07 = 1187248817,
        set_dystopian_04 = 3508047712,
        set_dystopian_03 = 4292635879,
        set_dystopian_05 = 3022607746,
        set_dystopian_01 = 2024889999,
        set_dystopian_02 = 2046386463,
        set_dystopian_10 = 3458242684,
        set_dystopian_12 = 3012223825,
        set_dystopian_17 = 2548411387,
        set_pit_fence_ovala = 3064725123,
        set_pit_fence_ovalb = 2753190240,
        set_lights_evening = 1424424116,
        set_lights_midday = 958081836,
        set_lights_hell = 319299891,
        set_lights_night = 3870080710,
        set_lights_sandstorm = 2267758495,
        set_lights_saccharine = 1033433310,
        set_lights_morning = 1981732865,
        set_lights_storm = 1193586390,
        set_lights_toxic = 4166698082,
        set_scifi_01 = 3243674567,
        set_team_band_d = 2636509545,
        set_team_band_c = 2396738772,
        set_wasteland_scene = 1241741637,
        set_dystopian_scene = 3622433164,
        set_scifi_scene = 1319003485,
        set_pit_fence_wall = 76312971,
        set_crowd_b = 4146082774,
        set_crowd_d = 1405316379,
        set_crowd_c = 496107705,
        set_crowd_a = 1223055201,
        set_centreline_scifi_05 = 738055143,
        set_centreline_wasteland_05 = 3126843237,
        set_centreline_dystopian_05 = 1455784682,
        set_lights_atlantis = 140276175,
        set_turrets_wasteland = 2636125702,
        set_turrets_scifi = 3901322765,
        set_dystopian_06 = 3312220168,
        set_dystopian_08 = 403053878,
        set_lights_sfnight = 267571573,
        set_wasteland_03 = 563860229,
        set_wasteland_09 = 1194237482,
        set_wasteland_04 = 873363434,
        set_wasteland_05 = 4230416412,
        set_wasteland_06 = 244624631,
        set_wasteland_07 = 1756717367,
        set_wasteland_08 = 2062026144,
        set_wasteland_10 = 3599547240,
        set_wasteland_02 = 3960334314,
        set_wasteland_01 = 3652535097,
        set_int_mod_booth_def = 664855356,
        set_int_mod_shell_def = 1359631407,
        set_int_mod_booth_ben = 190865663,
        set_int_mod_booth_wp = 3700524473,
        set_int_mod_booth_combo = 4065735760,
        set_int_mod_trophy_career = 2768537778,
        set_int_mod_trophy_score = 1510298775,
        set_int_mod_trophy_time_served = 1688458647,
        set_int_mod_trophy_got_one = 3192057316,
        set_int_mod_trophy_outta_here = 4175516452,
        set_int_mod_trophy_shunt = 3698038079,
        set_int_mod_trophy_bobby = 3538190458,
        set_int_mod_trophy_killed = 2788446579,
        set_int_mod_trophy_crowd = 137065421,
        set_int_mod_trophy_duck = 2576185477,
        set_int_mod_trophy_bandito = 2794929414,
        set_int_mod_trophy_spinner = 2936243981,
        set_int_mod_trophy_lens = 2722006686,
        set_int_mod_trophy_war = 1866046411,
        set_int_mod_trophy_unstoppable = 371302121,
        set_int_mod_trophy_contact = 4145788076,
        set_int_mod_trophy_tower = 3521429210,
        set_int_mod_trophy_step = 2536390901,
        set_int_mod_trophy_pegasus = 3501664733,
        set_int_mod_trophy_wageworker = 3425326047,
        set_mod1_style_09 = 1060339572,
        set_mod1_style_07 = 449885871,
        set_mod1_style_04 = 612289039,
        set_mod1_style_03 = 917991040,
        set_mod1_style_02 = 2663497363,
        set_mod1_style_01 = 2705703835,
        set_mod1_style_08 = 168367392,
        set_arena_peds = 1859769479,
        set_xmas_decorations = 1904805429,
        set_int_mod_construction_01 = 77455365,
        set_int_mod_construction_02 = 73981851,
        set_int_mod_construction_03 = 4063836988,
        set_bandito_rc = 1713599962,
        set_bench_clutter = 3431602909,
        set_int_mod_bedroom_blocker = 1323116540,
        set_office_industrial = 2914130492,
        set_office_standard = 2871182565,
        set_office_hitech = 1005091504,
        set_mod1_style_05 = 1784305093,
        set_office_trinket_01 = 149228489,
        set_office_trinket_02 = 3474004002,
        set_office_trinket_03 = 1097563349,
        set_office_trinket_04 = 1574679989,
        set_office_trinket_06 = 2050322024,
        set_office_trinket_07 = 1818448580,
        set_mod1_style_06 = 1478144326,
        set_int_mod2_b2 = 3040902015,
        set_int_mod2_b1 = 2085063054,
        set_mod2_style_01 = 2062907856,
        set_mod2_style_02 = 1288609155,
        set_mod2_style_03 = 2519543871,
        set_mod2_style_04 = 1807342425,
        set_mod2_style_05 = 99717066,
        set_mod2_style_06 = 400143258,
        set_mod2_style_07 = 562251501,
        set_mod2_style_08 = 850291011,
        set_mod2_style_09 = 3973340556,
        set_int_mod2_b_tint = 895665649,
        vip_xmas_decs = 2530799286,

        //entity sets mpexecutive
        office_booze = 3103366149,
        room_blocker = 1469071850,
        cash_set_01 = 918900987,
        cash_set_02 = 1825291535,
        cash_set_03 = 2948219631,
        cash_set_04 = 3849367131,
        cash_set_05 = 2638061046,
        cash_set_06 = 3405543795,
        cash_set_07 = 681718973,
        cash_set_08 = 404984768,
        cash_set_10 = 2374004060,
        cash_set_09 = 3574533528,
        cash_set_11 = 1419213703,
        cash_set_12 = 1775609351,
        cash_set_13 = 2124533667,
        cash_set_14 = 2889919200,
        cash_set_15 = 1518208860,
        cash_set_16 = 2288378667,
        cash_set_17 = 3302710293,
        cash_set_18 = 4089067982,
        cash_set_19 = 2707526946,
        cash_set_20 = 127234000,
        cash_set_21 = 281444914,
        cash_set_22 = 588064447,
        cash_set_23 = 1839479892,
        cash_set_24 = 1567005657,
        office_chairs = 1865863901,
        swag_drugbags = 31941447,
        swag_booze_cigs = 1798046558,
        swag_electronic = 2711709785,
        swag_drugstatue = 3605847555,
        swag_ivory = 1197210140,
        swag_pills = 349603924,
        swag_jewelwatch = 1957687967,
        swag_furcoats = 2113738437,
        swag_silver = 55039468,
        swag_art = 3624265177,
        swag_guns = 1924155486,
        swag_med = 2645937774,
        swag_gems = 62355088,
        swag_drugbags2 = 541880637,
        swag_booze_cigs2 = 4187406111,
        swag_electronic2 = 3623506281,
        swag_drugstatue2 = 1019826829,
        swag_ivory2 = 1296128175,
        swag_pills2 = 341986727,
        swag_jewelwatch2 = 699356245,
        swag_furcoats2 = 1027779347,
        swag_silver2 = 3250436562,
        swag_art2 = 935908579,
        swag_guns2 = 1121872501,
        swag_med2 = 3215413152,
        swag_gems2 = 3204549432,
        swag_gems3 = 3961316718,
        swag_guns3 = 306350398,
        swag_med3 = 2834375220,
        swag_drugstatue3 = 780645898,
        swag_ivory3 = 2660989842,
        swag_pills3 = 3046215687,
        swag_electronic3 = 4003430067,
        swag_furcoats3 = 590509807,
        swag_silver3 = 3547290933,
        swag_art3 = 3983392814,
        swag_booze_cigs3 = 3889109904,
        swag_jewelwatch3 = 938537176,
        swag_drugbags3 = 285069984,
        swag_counterfeit2 = 1608828597,
        swag_counterfeit3 = 3222538006,
        swag_counterfeit = 1004517720,

        //entity sets mpgunrunning
        upgrade_bunker_set = 813810962,
        standard_bunker_set = 2638480177,
        bunker_style_a = 3639850880,
        bunker_style_b = 4257972527,
        bunker_style_c = 861334597,
        office_upgrade_set = 4141058745,
        office_blocker_set = 317624595,
        gun_locker_upgrade = 983140809,
        gun_range_blocker_set = 75131033,
        security_upgrade = 685729147,
        standard_security_set = 1982709917,
        gun_wall_blocker = 3763915514,
        gun_range_lights = 3694464237,
        gun_schematic_set = 4207741272,
        upgrade_bunker_set_more = 230806892,
        standard_bunker_set_more = 2642898740,
        grdlc_int_02_trailer_cave = 3633941630,

        //entity sets mpheist3
        set_casino_bar_chairs = 346805908,
        entity_set_arcade_set_ceiling_beams = 4085182947,
        entity_set_arcade_set_ceiling_flat = 3118670434,
        entity_set_arcade_set_derelict = 1339270078,
        prop_ch_corridor_door_derelict = 2673849083,
        prop_ch_toilet_door_derelict = 2863732715,
        entity_set_arcade_set_streetx4 = 817577158,
        entity_set_screens = 3758018156,
        entity_set_arcade_set_derelict_clean_up = 4023160296,
        entity_set_arcade_set_derelict_carpet = 3352764664,
        entity_set_arcade_set_ceiling_mirror = 4280336555,
        entity_set_constant_geometry = 2836582169,
        entity_set_big_screen = 3820618732,
        entity_set_hip_light_no_neon = 2510716665,
        entity_set_ret_light_no_neon = 636766813,
        entity_set_arcade_set_trophy_claw = 1669048092,
        entity_set_arcade_set_trophy_monkey = 3219385685,
        entity_set_arcade_set_trophy_patriot = 4281710418,
        entity_set_arcade_set_trophy_brawler = 130776512,
        entity_set_arcade_set_trophy_retro = 3573734624,
        entity_set_arcade_set_trophy_racer = 976053317,
        entity_set_arcade_set_trophy_love = 1576835470,
        entity_set_arcade_set_trophy_cabs = 544350153,
        entity_set_arcade_set_trophy_gunner = 2656167961,
        entity_set_arcade_set_trophy_teller = 2513728132,
        entity_set_arcade_set_trophy_strife = 2594337031,
        entity_set_arcade_set_trophy_king = 2363080759,
        entity_set_plushie_07 = 1426191774,
        entity_set_plushie_08 = 583012635,
        entity_set_plushie_09 = 863154816,
        entity_set_plushie_01 = 119724517,
        entity_set_plushie_02 = 2311020316,
        entity_set_plushie_03 = 2549808019,
        entity_set_plushie_04 = 1818338401,
        entity_set_plushie_05 = 3124150282,
        entity_set_plushie_06 = 1046726754,
        entity_set_arcade_set_plugs_cables = 855993306,
        entity_set_mural_neon_option_01 = 832696288,
        entity_set_mural_neon_option_02 = 526994287,
        entity_set_mural_neon_option_03 = 3556095113,
        entity_set_mural_neon_option_04 = 3253604474,
        entity_set_mural_neon_option_05 = 4145052350,
        entity_set_mural_neon_option_06 = 3862026497,
        entity_set_mural_neon_option_07 = 2147093619,
        entity_set_mural_neon_option_08 = 2505455403,
        entity_set_mural_option_08 = 4218711811,
        entity_set_mural_option_07 = 3921267598,
        entity_set_mural_option_06 = 2622959818,
        entity_set_mural_option_05 = 2324958532,
        entity_set_floor_option_08 = 3124991389,
        entity_set_floor_option_07 = 2816536792,
        entity_set_floor_option_06 = 3718667362,
        entity_set_floor_option_05 = 3446717431,
        entity_set_mural_option_04 = 3475019360,
        entity_set_mural_option_03 = 1020522949,
        entity_set_mural_option_01 = 3782720270,
        entity_set_floor_option_04 = 2389458383,
        entity_set_floor_option_03 = 2621561210,
        entity_set_floor_option_02 = 2852189432,
        entity_set_floor_option_01 = 3081474125,
        entity_set_mural_option_02 = 4090388411,
        set_plan_casino = 2649508200,
        set_plan_computer = 3440898848,
        set_plan_keypad = 1285218278,
        set_plan_hacker = 4146751425,
        set_plan_weapons = 2415415260,
        set_plan_mechanic = 3428815110,
        set_plan_vault = 2184434991,
        set_plan_wall = 1696380918,
        set_plan_setup = 3285872715,
        set_plan_bed = 1036538771,
        set_plan_pre_setup = 1874689858,
        set_plan_no_bed = 3187752645,
        set_plan_garage = 3855630273,
        set_plan_scribbles = 2359689726,
        set_plan_arcade_x4 = 1986731573,
        set_plan_plans = 1082159886,
        set_plan_plastic_explosives = 3283959311,
        set_plan_cockroaches = 1623352757,
        set_plan_electric_drill = 829454241,
        set_plan_vault_drill = 2090230169,
        set_plan_vault_laser = 1023365057,
        set_plan_stealth_outfits = 1076026381,
        set_plan_hacking_device = 2691228738,
        set_plan_gruppe_sechs_outfits = 1134950565,
        set_plan_fireman_helmet = 236782984,
        set_plan_drone_parts = 2256257613,
        set_plan_vault_keycard_01a = 2758302557,
        set_plan_swipe_card_01b = 1033224418,
        set_plan_swipe_card_01a = 1339843951,
        set_plan_vault_drill_alt = 2115444521,
        set_plan_vault_laser_alt = 1277288488,
        set_tunnel_collapse = 3170675291,
        casino_back_laundry_damage = 3289504233,
        set_vault_door_closed = 365621037,
        set_spawn_group1 = 2122061393,
        set_vault_door = 2510200356,
        set_vault_door_broken = 2333725130,
        set_spawn_group2 = 2224071294,
        set_vault_dressing = 1884553845,
        set_vault_cash_01 = 4087811601,
        set_vault_cash_02 = 1643276966,
        set_vault_art_01 = 2304028969,
        set_vault_art_02 = 2129370199,
        set_vault_gold_01 = 2267032898,
        set_vault_gold_02 = 2499463415,
        set_vault_diamonds_01 = 2660054666,
        set_vault_diamonds_02 = 128977106,

        //entity sets mpheist4
        entity_set_brig = 767312704,
        entity_set_weapons = 4294236907,
        entity_set_guide = 3043738597,
        entity_set_hatch_lights_on = 1490546636,
        entity_set_hatch_lights_off = 1564872300,
        entity_set_demolition = 4260362478,
        entity_set_acetylene = 335756799,
        entity_set_plasma = 2618982734,
        entity_set_fingerprint = 2704946544,
        entity_set_suppressors = 4194453183,
        entity_set_jammer = 171629080,
        int01_ba_dj_palms_trax = 4218252250,
        int01_ba_dj_keinemusik = 1764320121,
        int01_ba_dj_moodyman = 988735114,
        entityset_dj_lighting = 109135015,
        files_set = 3159243469,
        bonds_set = 3829276324,
        panther_set = 3422990272,
        pink_diamond_set = 984660650,
        pearl_necklace_set = 1264795531,
        tequila_set = 1830087340,

        //entity sets mpimportexport
        garage_decor_01 = 3131449458,
        garage_decor_02 = 435674900,
        garage_decor_03 = 674986907,
        garage_decor_04 = 4118091279,
        lighting_option01 = 4051486699,
        lighting_option02 = 4282344304,
        lighting_option03 = 1780300082,
        lighting_option04 = 3090077012,
        lighting_option05 = 2499776246,
        lighting_option06 = 2729912933,
        lighting_option07 = 590719836,
        lighting_option08 = 1893287594,
        lighting_option09 = 2112872663,
        numbering_style01_n1 = 167404657,
        numbering_style02_n1 = 1164028444,
        numbering_style03_n1 = 868925983,
        numbering_style04_n1 = 524345905,
        numbering_style05_n1 = 3519979170,
        numbering_style06_n1 = 1684861539,
        numbering_style07_n1 = 4272366555,
        numbering_style08_n1 = 916293378,
        numbering_style09_n1 = 1782533508,
        numbering_style05_n2 = 4094223126,
        numbering_style02_n2 = 726300142,
        numbering_style03_n2 = 2113721986,
        numbering_style04_n2 = 3173260785,
        numbering_style09_n2 = 1479453027,
        numbering_style06_n2 = 1520623311,
        numbering_style07_n2 = 4176943227,
        numbering_style08_n2 = 1148527281,
        numbering_style01_n2 = 404947142,
        numbering_style05_n3 = 3850061307,
        numbering_style02_n3 = 3505668419,
        numbering_style03_n3 = 762230119,
        numbering_style04_n3 = 3401169180,
        numbering_style09_n3 = 480326217,
        numbering_style06_n3 = 769164603,
        numbering_style07_n3 = 2452277976,
        numbering_style08_n3 = 3780205671,
        numbering_style01_n3 = 779955578,
        impexp_interior_01_lift = 245377307,
        pump_01 = 3286363936,
        pump_02 = 2990033869,
        pump_03 = 1601611339,
        pump_04 = 1304691430,
        pump_05 = 3684409059,
        pump_06 = 3915987582,
        pump_07 = 939448232,
        pump_08 = 1171616597,
        urban_style_set = 2844941168,
        basic_style_set = 3999336696,
        car_floor_hatch = 3904439380,
        door_blocker = 286694969,
        branded_style_set = 1478196572,
        floor_vinyl_10 = 2462055877,
        floor_vinyl_01 = 1998145496,
        floor_vinyl_02 = 543267434,
        floor_vinyl_03 = 1279980112,
        floor_vinyl_04 = 3741095861,
        floor_vinyl_05 = 816331531,
        floor_vinyl_06 = 997347487,
        floor_vinyl_07 = 58024102,
        floor_vinyl_08 = 2518615523,
        floor_vinyl_09 = 3890260349,
        floor_vinyl_11 = 2508391251,
        floor_vinyl_12 = 2875338513,
        floor_vinyl_13 = 4053482362,
        floor_vinyl_14 = 6084861,
        floor_vinyl_15 = 1548718317,
        floor_vinyl_16 = 1919728935,
        floor_vinyl_17 = 3098134944,
        floor_vinyl_18 = 3471832620,
        floor_vinyl_19 = 2336386758,

        //entity sets mpsecurity
        entity_set_armoury = 291582462,
        entity_set_art_1 = 534870131,
        entity_set_art_2 = 3823304823,
        entity_set_art_3 = 4129072362,
        entity_set_blocker = 1713608845,
        entity_set_m_50 = 3255504367,
        entity_set_m_attack = 988648898,
        entity_set_m_ballas = 1026613352,
        entity_set_m_billionaire = 526578714,
        entity_set_m_construction = 1730164362,
        entity_set_m_families = 3072356244,
        entity_set_m_fire_booth = 2343961417,
        entity_set_m_golf_intro = 591008784,
        entity_set_m_gone_golfing = 2662847237,
        entity_set_m_hit_list = 3380893167,
        entity_set_m_hood = 2134893064,
        entity_set_m_limo_photo = 1469453497,
        entity_set_m_limo_wallet = 3038100777,
        entity_set_m_motel = 1742691330,
        entity_set_m_nightclub = 978920849,
        entity_set_m_promoter = 648193062,
        entity_set_m_setup = 3140732957,
        entity_set_m_taxi = 2480274126,
        entity_set_m_the_way = 96508492,
        entity_set_m_trip_01 = 2679967067,
        entity_set_m_trip_02 = 3523113437,
        entity_set_m_trip_03 = 2117585489,
        entity_set_m_tuner = 1361926298,
        entity_set_m_vehicles = 665177099,
        entity_set_m_yacht = 723902435,
        entity_set_moving = 3708813057,
        entity_set_player_desk = 2145233343,
        entity_set_player_seats = 1233348863,
        entity_set_spare_seats = 152801599,
        entity_set_standard_office = 2123146218,
        entity_set_tint_ag = 4044350209,
        entity_set_wpaper_1 = 3985876815,
        entity_set_wpaper_2 = 2730398114,
        entity_set_wpaper_3 = 3488607236,
        entity_set_wpaper_4 = 2290343213,
        entity_set_wpaper_5 = 3065624984,
        entity_set_wpaper_6 = 1809130448,
        entity_set_wpaper_7 = 2571534002,
        entity_set_wpaper_8 = 1810506766,
        entity_set_wpaper_9 = 1512865939,
        entity_set_disc_01 = 3747330668,
        entity_set_disc_02 = 3380612785,
        entity_set_disc_03 = 3610618396,
        entity_set_disc_04 = 3853698838,
        entity_set_disc_05 = 4093469611,
        entity_set_disc_06 = 3190880275,
        entity_set_art_1_nomod = 1547458240,
        entity_set_art_2_nomod = 1387540786,
        entity_set_art_3_nomod = 594989034,
        entity_set_tints = 1231221852,
        entity_set_wallpaper_01 = 3986516495,
        entity_set_wallpaper_02 = 3696641921,
        entity_set_wallpaper_03 = 596202986,
        entity_set_wallpaper_04 = 289976681,
        entity_set_wallpaper_05 = 3033659513,
        entity_set_wallpaper_06 = 2744178167,
        entity_set_wallpaper_07 = 3391988528,
        entity_set_wallpaper_08 = 3336936608,
        entity_set_wallpaper_09 = 1898508580,
        entity_set_workshop_lights = 4073289792,
        entity_set_workshop_wall = 3948301261,
        entity_set_fix_stu_ext_p1 = 2506143259,
        entity_set_fix_stu_ext_p3a1 = 1858181337,
        entity_set_fix_trip1_int_p2 = 896172025,
        entity_set_fire = 916407562,
        entity_set_default = 638583960,

        //entity sets mpsmuggler
        set_floor_decal_1 = 2331341195,
        set_floor_decal_2 = 1633689185,
        set_floor_decal_3 = 642656318,
        set_floor_decal_4 = 2094847322,
        set_floor_decal_5 = 2581598056,
        set_floor_decal_6 = 2821041139,
        set_floor_decal_7 = 3041379895,
        set_floor_decal_8 = 3278922376,
        set_floor_decal_9 = 4244264343,
        set_floor_1 = 1850829312,
        set_floor_2 = 1515667980,
        set_tint_shell = 4267883119,
        set_office_modern = 674072417,
        set_bedroom_modern = 3938111980,
        set_modarea = 3394979985,
        set_office_basic = 1462599078,
        set_office_traditional = 2735186194,
        set_bedroom_traditional = 1042792893,
        set_bedroom_blinds_closed = 1873665612,
        set_bedroom_blinds_open = 625028744,
        set_bedroom_tint = 538246886,
        set_crane_tint = 2781496053,
        set_lighting_wall_tint02 = 3115711409,
        set_lighting_wall_tint01 = 2765410799,
        set_lighting_hangar_c = 2011509526,
        set_lighting_hangar_b = 2769128806,
        set_lighting_hangar_a = 3536611555,
        set_lighting_wall_tint03 = 1207998532,
        set_lighting_wall_tint04 = 1570423672,
        set_lighting_wall_tint05 = 1931538052,
        set_lighting_wall_tint06 = 1628588651,
        set_lighting_wall_tint07 = 1993831925,
        set_lighting_wall_tint08 = 69144710,
        set_lighting_wall_tint09 = 435764282,
        set_lighting_wall_neutral = 2407408749,
        set_lighting_tint_props = 2476966671,
        set_bedroom_clutter = 1469952541,

        //entity sets mpvinewood
        casino_manager_default = 807669009,
        casino_manager_workout = 2747833266,
        set_pent_tint_shell = 781557962,
        set_pent_media_bar_open = 571735177,
        set_pent_spa_bar_open = 3101310327,
        set_pent_dealer = 301447849,
        set_pent_nodealer = 2494422032,
        set_pent_media_bar_closed = 77995874,
        set_pent_spa_bar_closed = 605561206,
        set_pent_pattern_01 = 374794136,
        set_pent_pattern_02 = 71058275,
        set_pent_pattern_03 = 3255090933,
        set_pent_pattern_04 = 1037219471,
        set_pent_pattern_05 = 730599938,
        set_pent_pattern_06 = 1231179182,
        set_pent_pattern_07 = 4145031435,
        set_pent_pattern_08 = 2527979592,
        set_pent_pattern_09 = 2284079925,
        set_pent_arcade_modern = 2684847595,
        set_pent_arcade_retro = 1667328146,
        set_pent_clutter_03 = 2850820314,
        set_pent_clutter_02 = 3148002375,
        set_pent_clutter_01 = 3459111269,
        set_pent_lounge_blocker = 1744605517,
        set_pent_guest_blocker = 902990595,
        set_pent_office_blocker = 883043044,
        set_pent_cine_blocker = 2498175818,
        set_pent_spa_blocker = 4268487961,
        set_pent_bar_blocker = 3761221325,
        set_pent_bar_party_after = 1043975880,
        set_pent_bar_clutter = 3678482553,
        set_pent_bar_party_2 = 3248945638,
        set_pent_bar_light_01 = 3935546307,
        set_pent_bar_light_0 = 3166224574,
        set_pent_bar_light_02 = 3697348446,
        set_pent_bar_party_0 = 1477224115,
        set_pent_bar_party_1 = 1384422307,


















        //entity sets los santos tuners
        entity_set_bedroom,
        entity_set_bedroom_empty,
        entity_set_bombs,
        entity_set_box_clutter,
        entity_set_cabinets,
        entity_set_car_lift_cutscene,
        entity_set_car_lift_default,
        entity_set_car_lift_purchase,
        entity_set_chalkboard,
        entity_set_container,
        entity_set_cut_seats,
        entity_set_def_table,
        entity_set_drive,
        entity_set_ecu,
        entity_set_IAA,
        entity_set_jammers,
        entity_set_laptop,
        entity_set_lightbox,
        entity_set_methLab,
        entity_set_plate,
        entity_set_scope,
        entity_set_style_1,
        entity_set_style_2,
        entity_set_style_3,
        entity_set_style_4,
        entity_set_style_5,
        entity_set_style_6,
        entity_set_style_7,
        entity_set_style_8,
        entity_set_style_9,
        entity_set_table,
        entity_set_thermal,
        entity_set_train,
        entity_set_virus,
        entity_set_meet_crew,
        entity_set_meet_lights,
        entity_set_meet_lights_cheap,
        entity_set_player,
        entity_set_test_crew,
        entity_set_test_lights,
        entity_set_test_lights_cheap,
        entity_set_time_trial,






















        //popgroups.ymt - From FiveM
        //For the pedgroups/item/name field
        richman_glen_bevhills = 1916548608,
        marlowe_drive_bevhills = 3724985487,
        baytree_canyon_bevhills = 1095587898,
        galileo_park_bevhills = 3773030709,
        galileo_park_hipsters = 1226562551,
        galileo_park_tourists = 2437681877,
        ocean_general = 699946682,
        pacific_bluffs_beach = 1771635400,
        pacific_bluffs_streetgeneral = 2128557429,
        del_perro_streetgeneral = 4003270267,
        del_perro_bums = 3222414768,
        vespucci_pier_beach = 2175040393,
        vespucci_streetgeneral = 853940634,
        vespucci_bums = 908912315,
        vespucci_canals_streetgeneral = 4149286830,
        vespucci_canals_bevhills = 2120071986,
        puerto_business = 2592745348,
        puerto_streetgeneral = 3620209527,
        puerto_bevhills = 2096726272,
        puerto_hipsters = 4241471320,
        lsa_airport = 3523754501,
        lsa_streetgeneral = 3526862920,
        elysian_island_streetgeneral = 851640179,
        elysian_island_genped = 398248766,
        terminal_construction = 3440476579,
        terminal_specificjob = 3674390882,
        beachparty = 2592453449,
        banning_construction = 46699983,
        banning_specificjob = 2575047138,
        banning_streetgeneral = 3474460204,
        banning_tramps = 2130175499,
        el_burro_general = 2730520509,
        cypress_general = 1446780254,
        cypress_tramps = 3214037884,
        la_mesa_general = 2636968603,
        la_mesa_tramps = 748862053,
        murrieta_general = 697895317,
        murrieta_tramps = 3052120512,
        murrieta_gang = 2843705451,
        hippy = 944887848,
        cult = 2010391401,
        racecourse_bevhills = 1764904172,
        racecourse_streetgeneral = 1498417612,
        east_vinewood_local = 1545421012,
        east_vinewood_hipster = 271987258,
        east_vinewood_streetgeneral = 3366133940,
        paleto_bay_general = 3474455539,
        mirror_park_business = 777133455,
        mirror_park_hipsters = 2253228929,
        mirror_park_streetgeneral = 61725078,
        west_vinewood_hipsters = 1283940400,
        west_vinewood_streetgeneral = 310058182,
        west_vinewood_vinewood = 3235047195,
        eclipse_hipsters = 3720433148,
        eclipse_streetgeneral = 2052334107,
        eclipse_vinewood = 2593057275,
        eclipse_sexuals = 2351577296,
        club_nighttime = 2022489214,
        downtown_tramps = 987833330,
        downtown_bevhills = 809773694,
        downtown_hipsters = 180130592,
        downtown_streetgeneral = 3523779044,
        fish_ = 1207004798,
        birds_city = 589253797,
        birds_ground_city = 1230242748,
        birds_countryside = 390908839,
        birds_ocean = 3168035254,
        birds_ground_ocean = 3110385855,
        burton_tramps = 256463428,
        burton_business = 3165443402,
        burton_bevhills = 3155703512,
        burton_hipsters = 2194132880,
        burton_vinewood = 1651740194,
        burton_streetgeneral = 3056012715,
        hawick_bevhills = 1318738468,
        hawick_hipsters = 3708634492,
        hawick_streetgeneral = 1267713346,
        hawick_tramps = 2932194291,
        hawick_vinewood = 360078400,
        alta_business = 485106051,
        alta_tramps = 3962261894,
        alta_bevhills = 3657786126,
        alta_streetgeneral = 2583180649,
        rockford_shop_bevhills = 4171238205,
        rockford_shop_streetgeneral = 2899076840,
        rockford_residential_bluecollar = 2323943313,
        rockford_residential_bevhills = 577684089,
        rockford_hills_day = 2546072613,
        rockford_hills_night = 3291264832,
        richman_bevhills = 2279583243,
        richman_streetgeneral = 3757962161,
        morningwood_tramps = 501399946,
        morningwood_bevhills = 763676531,
        morningwood_hipsters = 2303048052,
        morningwood_streetgeneral = 115436112,
        backlot_film = 897751036,
        backlot_streetgeneral = 1689692965,
        little_seoul_koreatown = 3058390933,
        little_seoul_gang = 3164653322,
        little_seoul_streetgeneral = 2782104137,
        pillbox_business = 325325429,
        pillbox_bevhills = 2147006744,
        pillbox_tramps = 578868739,
        textile_bluecollar = 3279161038,
        textile_tramps = 187018675,
        textile_streetgeneral = 2072811124,
        mission_tramps = 1765836040,
        mission_streetgeneral = 477790886,
        strawberry_sc = 3513229903,
        strawberry_tramps = 3763929697,
        strawberry_gang = 1084379725,
        chamberlain_sc = 3488106941,
        chamberlain_tramps = 3657678612,
        chamberlain_gang = 411250856,
        davis_hookers = 263474307,
        davis_sc = 2938794522,
        davis_gang = 2259354683,
        davis_tramps = 80817981,
        rancho_sc = 116771963,
        rancho_gang = 3730883993,
        rancho_tramps = 282950945,
        incar_general = 1725824697,
        stadium_streetgeneral = 3270139100,
        los_puerta_armenian = 2855646127,
        los_puerta_streetgeneral = 1461524714,
        vespucci_magdemo = 1443256237,
        rockford = 601104499,
        beach_fat = 1495265263,
        fat_general = 3194660753,
        s_central = 1270994027,
        fashion = 2922437723,
        bohemian = 2527915385,
        hipsters = 1206548044,
        eastla = 3903831171,
        business = 942215692,
        restaurant_night = 2230335161,
        tramp = 295674176,
        tourists = 4052103791,
        prisoners = 3489630150,
        freeway_countryside = 141741896,
        freeway_haulage = 2921281021,
        gang_chinese = 344476045,
        gang_south_la = 1434944763,
        net_common = 1475419019,
        net_uncommon = 3944733161,
        rampage_south_ls = 855514417,
        rampage_little_seoul = 1518670552,
        rampage_rockford_hills = 154314028,
        veh_poor = 454752152,
        veh_poor_mp = 226581960,
        veh_mid = 3112896464,
        veh_mid_mp = 326963640,
        veh_rich = 4160258559,
        veh_rich_mp = 3705405835,
        veh_haulage = 2260594341,
        veh_haulage_mp = 443246348,
        veh_utility = 2942896063,
        veh_utility_mp = 3737227278,
        veh_freeway = 4222100980,
        veh_freeway_mp = 2591138726,
        veh_large_city = 3079238267,
        veh_large_city_mp = 4156290791,
        veh_countryside_offroad = 3880382407,
        veh_countryside_offroad_mp = 2218713197,
        veh_countryside_onroad = 1817408484,
        veh_countryside_onroad_mp = 1218898747,
        veh_yankton = 2030452436,
        veh_yankton_mp = 3116561190,
        veh_bikes = 347476719,
        veh_bikes_mp = 3953384100,
        native_zon_only = 3826828622,
        veh_salt = 1026046820,
        veh_salt_mp = 2143875649,
        veh_army = 2983944587,
        veh_army_mp = 1478794142,
        veh_boats = 1968910249,
        veh_boats_mp = 769254936,
        veh_boats_freeway = 800811870,
        veh_boats_freeway_mp = 2697936629,
        veh_bicycles = 1387773269,
        veh_bicycles_mp = 3588295793,
        veh_beach_bike = 875099148,
        veh_beach_bike_mp = 2956724466,
        veh_lost = 927861950,
        veh_lost_mp = 2710493793,
        veh_copcar = 113873283,
        veh_copcar_mp = 3625575212,
        veh_taxi = 2516826768,
        veh_taxi_mp = 3476042821,
        veh_airport = 3318832790,
        veh_airport_mp = 3494166071,
        veh_test_simple = 2438558856,
        veh_test_complex = 297209538,
        veh_transport = 2042289260,
        veh_transport_mp = 1022555546,
        veh_countrycoach = 4024372987,
        veh_countrycoach_mp = 2395407794,
        veh_prologue = 3821814614,
        veh_prologue_mp = 595582180,
        // wildlifeHabitats/Item
        sand_loose = 2549909946,
        sand_compact = 2397730525,
        sand_wet = 1064898850,
        grass_long = 4160773303,
        grass_short = 1200682253,










        //vfxvehicleinfo CVfxVehicleInfo keys
        vfxvehicleinfo_bulldozer = 12300880,
        vfxvehicleinfo_car_deluxo = 193226246,
        vfxvehicleinfo_car_generic_small = 267479565,
        vfxvehicleinfo_boat_suntrap = 285789004,
        vfxvehicleinfo_train_generic = 341505255,
        vfxvehicleinfo_car_offroad = 352539006,
        vfxvehicleinfo_rc = 364273431,
        vfxvehicleinfo_car_generic = 398747547,
        vfxvehicleinfo_truck_apc = 432634462,
        vfxvehicleinfo_forklift = 439414653,
        vfxvehicleinfo_plane_duster = 460220863,
        vfxvehicleinfo_heli_skylift = 476793892,
        vfxvehicleinfo_submersible = 478347832,
        vfxvehicleinfo_motorbike_faggio = 528628720,
        vfxvehicleinfo_boat_jetmax = 565430038,
        vfxvehicleinfo_boat_tug = 597101868,
        vfxvehicleinfo_trailer_grain = 607976407,
        vfxvehicleinfo_tank_scarab = 625436129,
        vfxvehicleinfo_trailer_small = 669566203,
        vfxvehicleinfo_trailer_generic = 782560007,
        vfxvehicleinfo_plane_generic = 815092152,
        vfxvehicleinfo_quad_generic = 863941205,
        vfxvehicleinfo_plane_pyro = 957605478,
        vfxvehicleinfo_bus_generic = 1276791650,
        vfxvehicleinfo_motorbike_sanctus = 1336855951,
        vfxvehicleinfo_heli_cargobob = 1431569536,
        vfxvehicleinfo_truck_yosemite2 = 1459413353,
        vfxvehicleinfo_plane_cuban800 = 1555127620,
        vfxvehicleinfo_jetski_generic = 1566387680,
        vfxvehicleinfo_tank_rhino = 1607944266,
        vfxvehicleinfo_trailer_tanker = 1708270255,
        vfxvehicleinfo_plane_dodo = 1850680346,
        vfxvehicleinfo_car_hotknife = 1851808812,
        vfxvehicleinfo_car_amphibious = 1877246371,
        vfxvehicleinfo_plane_molotok = 1919247874,
        vfxvehicleinfo_car_electric = 2013519764,
        vfxvehicleinfo_plane_vulkan = 2073365728,
        vfxvehicleinfo_plane_strikeforce = 2323129017,
        vfxvehicleinfo_plane_seabreeze = 2437703682,
        vfxvehicleinfo_rc_tank = 2501528518,
        vfxvehicleinfo_plane_cargo = 2524440911,
        vfxvehicleinfo_boat_generic = 2560783619,
        vfxvehicleinfo_truck_rig = 2591507893,
        vfxvehicleinfo_truck_offroad = 2628360287,
        vfxvehicleinfo_spacecraft_generic = 2648742720,
        vfxvehicleinfo_heli_frogger = 2669495177,
        vfxvehicleinfo_golf_car = 2745384957,
        vfxvehicleinfo_heli_generic = 2839459097,
        vfxvehicleinfo_trailer_bale = 2859808673,
        vfxvehicleinfo_boat_dinghy = 2896583062,
        vfxvehicleinfo_motorbike_oppressor = 2934587053,
        vfxvehicleinfo_quad_amphibious = 2952651468,
        vfxvehicleinfo_plane_starling = 3030608204,
        vfxvehicleinfo_plane_mammatus = 3041307345,
        vfxvehicleinfo_plane_tula = 3105010270,
        vfxvehicleinfo_boat_marquis = 3118564227,
        vfxvehicleinfo_trailer_home = 3168638753,
        vfxvehicleinfo_plane_volatol = 3349751374,
        vfxvehicleinfo_boat_tropic = 3434372937,
        vfxvehicleinfo_heli_annihilator = 3465419791,
        vfxvehicleinfo_plane_bombushka = 3557327940,
        vfxvehicleinfo_car_bullet = 3565048690,
        vfxvehicleinfo_truck_generic = 3567618790,
        vfxvehicleinfo_truck_hidden_exhaust = 3618308064,
        vfxvehicleinfo_thruster = 3826189364,
        vfxvehicleinfo_trailer_log = 3865777938,
        vfxvehicleinfo_car_stromberg = 3908332917,
        vfxvehicleinfo_motorbike_generic = 3966923368,
        vfxvehicleinfo_bicycle_generic = 4125608199,
        vfxvehicleinfo_plane_avenger = 4170389369,
        vfxvehicleinfo_plane_velum = 4243898520,
        vfxvehicleinfo_plane_titan = 4275366687,

        //vfxvehicleinfo - exhaustPtFxName engineStartupPtFxName misfirePtFxName backfirePtFxName engineDamagePtFxNoPanelName engineDamagePtFxPanelOpenName 
        //engineDamagePtFxPanelShutName leakPtFxOilName leakPtFxPetrolName wheelPuncturePtFxName wheelBurstPtFxName wheelFirePtFxName wreckedFirePtFxName 
        //wreckedFire2PtFxName wreckedFire3PtFxName petrolTankFirePtFxName splashInPtFxName splashOutPtFxName splashWadePtFxName splashTrailPtFxName
        _water_splash_veh_in = 1317936600,
        _water_splash_veh_out = 1188557193,
        _water_splash_veh_trail = 3793687577,
        _water_splash_veh_wade = 841119790,
        fire_petroltank_bike = 4058238859,
        fire_petroltank_boat = 3781917422,
        fire_petroltank_car = 286531323,
        fire_petroltank_car_bullet = 325101383,
        fire_petroltank_heli = 469524969,
        fire_petroltank_plane = 822770859,
        fire_petroltank_truck = 556948249,
        fire_wheel = 2564117782,
        fire_wheel_bike = 286338882,
        fire_wrecked_bike = 2159199551,
        fire_wrecked_boat = 2453269583,
        fire_wrecked_bus = 3683539591,
        fire_wrecked_car = 1033454750,
        fire_wrecked_car_vent = 2390742284,
        fire_wrecked_heli = 3334905053,
        fire_wrecked_heli_cockpit = 977177896,
        fire_wrecked_plane = 2046075258,
        fire_wrecked_plane_cockpit = 16421732,
        fire_wrecked_rc = 3285882749,
        fire_wrecked_tank = 711770263,
        fire_wrecked_tank_cockpit = 3365914925,
        fire_wrecked_train = 202963129,
        fire_wrecked_truck = 2114054471,
        fire_wrecked_truck_vent = 1676943215,
        veh_backfire = 302124928,
        veh_exhaust_boat = 3991639095,
        veh_exhaust_car = 4278361511,
        veh_exhaust_cargo = 3625867230,
        veh_exhaust_cuban800 = 3320655354,
        veh_exhaust_heli = 1064411126,
        veh_exhaust_heli_cargobob = 1842168540,
        veh_exhaust_heli_cargobob_misfire = 1279967671,
        veh_exhaust_heli_misfire = 442429522,
        veh_exhaust_heli_skylift = 966577375,
        veh_exhaust_hidden = 144796140,
        veh_exhaust_misfire = 3217063320,
        veh_exhaust_plane = 1299879749,
        veh_exhaust_plane_misfire = 3078711485,
        veh_exhaust_plane_start = 1139235276,
        veh_exhaust_spacecraft = 1276587689,
        veh_exhaust_starling = 1317403759,
        veh_exhaust_start = 3164339072,
        veh_exhaust_start_bike = 2038672349,
        veh_exhaust_strikeforce = 3876913684,
        veh_exhaust_titan = 1905226107,
        veh_exhaust_trailer_chimney = 3683009021,
        veh_exhaust_truck = 2723278228,
        veh_exhaust_truck_rig = 2363972594,
        veh_exhaust_tug = 2527588925,
        veh_exhaust_velum = 2187349811,
        veh_exhaust_vulkan = 2325868249,
        veh_faggio_exhaust = 3405851763,
        veh_oil_leak = 4038693171,
        veh_panel_open_car = 608828042,
        veh_panel_open_carhk = 2562161046,
        veh_panel_open_truck = 2830143211,
        veh_panel_shut_car = 976692688,
        veh_panel_shut_tank = 2160667314,
        veh_panel_shut_truck = 1012438887,
        veh_petrol_leak = 4202984037,
        veh_petrol_leak_bike = 4087050880,
        veh_petrol_leak_bullet = 2473542845,
        veh_sanctus_backfire = 2901830062,
        veh_sanctus_exhaust = 1674950331,
        veh_sanctus_exhaust_start = 3935546497,
        veh_sm_car_small_backfire = 1489543669,
        veh_vent_bike = 3812572075,
        veh_vent_boat = 1895506455,
        veh_vent_heli = 2917572657,
        veh_vent_heli_anh = 139550781,
        veh_vent_heli_cargobob = 892160507,
        veh_vent_heli_frogger = 567422941,
        veh_vent_heli_skylift = 361833230,
        veh_vent_plane = 3252279465,
        veh_vent_plane_bom = 2138528253,
        veh_vent_plane_duster = 2112623789,
        veh_vent_plane_lazer = 2156998603,
        veh_vent_plane_starling = 2625845552,
        veh_vent_plane_titan = 3591328632,
        veh_vent_plane_tula = 1836402424,
        veh_vent_plane_volatol = 921445090,
        veh_vent_rc = 357002104,
        veh_wheel_burst = 3039521151,
        veh_wheel_puncture = 3869685395,
        veh_wheel_puncture_rc = 3871952608,
        veh_xm_strom_underwater_trail = 1211754772,
        veh_xm_thruster_engine_damage = 2492561356,
        veh_xm_thruster_wreck_fire = 1925614570,
        veh_xm_vent_plane_avenger = 4012218664,
        water_splash_bicycle_in = 3869191077,
        water_splash_bicycle_out = 3104338404,
        water_splash_bicycle_trail = 3908760766,
        water_splash_bicycle_wade = 3977089222,
        water_splash_bike_in = 4182206171,
        water_splash_bike_out = 1267020131,
        water_splash_bike_trail = 3888624892,
        water_splash_bike_wade = 703565724,
        water_splash_plane_in = 238058964,
        water_splash_plane_out = 3327807348,
        water_splash_plane_trail = 438571176,
        water_splash_plane_wade = 3061312190,
        water_splash_sub_in = 2259958166,
        water_splash_sub_out = 2513782849,
        water_splash_sub_wade = 223452235,
        water_splash_veh_in = 2045224279,
        water_splash_veh_out = 858904440,
        water_splash_veh_trail = 2953510466,
        water_splash_veh_wade = 3800884192,






        //Carl Johnson: I discovered  in zonebind
        specialZoneAttribute = 218662697,








        // Siprus and Carl Johnson
        ABON_YEA = 3148884390,
        AET_No_Type = 1637555008,
        AF_AVOID_IMMINENT_DANGER = 665056449,
        AF_BALANCE_STRONG = 2727636155,
        AF_DONT_FLINCH_ON_EXPLOSION = 3233981661,
        AF_DONT_FLINCH_ON_MELEE = 3036600251,
        AF_GET_UP_FAST = 301163182,
        AF_RAGDOLL_BRACE_STRONG = 1838090773,
        AF_RAGDOLL_HIGH_FALL_STRONG = 335156894,
        AF_RAGDOLL_ON_FIRE_STRONG = 1429252732,
        AF_RECOVER_BALANCE = 1995789406,
        AF_STRONG_WITH_HEAVY_WEAPON = 2154274359,
        AIBirdTurnApproachRate = 2032071225,
        AICurvePoints = 630211059,
        AIHandling = 2447501364,
        AIHandlingInfos = 1651271079,
        AIPitchTurnApproachRate = 1918070033,
        AI_BLIND_FIRE_MODIFIER = 3800306812,
        AI_DISTANCE_FOR_MAX_ACCURACY_BOOST = 984612846,
        AI_DISTANCE_FOR_MIN_ACCURACY_BOOST = 544544740,
        AI_GLOBAL_MODIFIER = 2160505037,
        AI_HURT_MODIFIER = 3039036537,
        AI_HURT_ON_GROUND_MODIFIER = 141208709,
        AI_PROFESSIONAL_PISTOL_VS_AI_MODIFIER = 809314153,
        AI_TARGET_COMING_OUT_OF_COVER_MODIFIER = 362467269,
        AI_TARGET_DRIVING_AT_SPEED_MODIFIER = 4026427400,
        AI_TARGET_IN_AIR_MODIFIER = 1298004858,
        AI_TARGET_IN_COMBAT_ROLL_MODIFIER = 2756405783,
        AI_TARGET_IN_COVER_MODIFIER = 255159988,
        AI_TARGET_RUNNING_MODIFIER = 2936519657,
        AI_TARGET_WALKING_MODIFIER = 2976676666,
        APF_SELFSIXD = 2715402776,
        APF_SELFSIXI = 1604795828,
        APF_SELFSIXJ = 2237335835,
        APF_SELFSIXK = 1984129772,
        APF_SELFSIXL = 334669388,
        APF_SELFSIXM = 46138343,
        APF_XPCOOLBD = 2559750026,
        APF_XPCOOLBE = 3730225937,
        APF_XPCOOLBG = 1772376494,
        ARROW_ALL = 3432198296,
        ARROW_DOWN = 2589990612,
        ARROW_LEFT = 2546654829,
        ARROW_LEFTRIGHT = 2127923857,
        ARROW_RIGHT = 3337535610,
        ARROW_UP = 384390016,
        ARROW_UPDOWN = 2750800581,
        AT_ANY = 238608420,
        AT_BLOCK = 3934186184,
        AT_BecomingArmed = 710158800,
        AT_Bumped = 1547305466,
        AT_BumpedByVehicle = 233053281,
        AT_BumpedInVehicle = 4171748947,
        AT_CONDITION = 2375648419,
        AT_COUNTER = 3703529780,
        AT_DAZED_HIT_REACTION = 878928082,
        AT_Dodged = 4263796656,
        AT_DodgedVehicle = 132321723,
        AT_FROM_ON_FOOT = 1341468964,
        AT_Following = 4108858390,
        AT_Griefing = 3878703385,
        AT_HIT_REACTION = 109893268,
        AT_Harassed = 1377284369,
        AT_HonkedAt = 1745569177,
        AT_Hostile = 280245171,
        AT_INTRO = 159040261,
        AT_Insulted = 1469879636,
        AT_Intervene = 1916271223,
        AT_Intimidate = 1259082935,
        AT_Loitering = 889198510,
        AT_MELEE = 677621203,
        AT_RECOIL = 55464040,
        AT_Ranting = 842151222,
        AT_SWIMMING = 1996208862,
        AT_TAUNT = 1640002693,
        AT_TerritoryIntruded = 4090312239,
        AbortOnIdle = 1480990261,
        AbsoluteMinSpeed = 3279839573,
        AcceptRadius = 4216130587,
        AccessableSeats = 407866914,
        AccuracyModifier = 2692038263,
        AccuracyOffsetShakeHash = 2742704368,
        AccuracySpread = 2810396437,
        AccurateModeAccuracyModifier = 640087692,
        ActionBranchSet = 784175908,
        ActionFlags = 2411876154,
        ActionResult = 1498777678,
        ActionRumble = 3659153199,
        ActionType = 314245090,
        Actions = 408055434,
        ActivationDistance = 4098254835,
        ActivationRange = 62355232,
        ActiveBoundExclusions = 2525193569,
        AdapterIndex = 4107173103,
        Add = 2308063186,
        AddSmokeOnExplosion = 3620839075,
        AdditionalFlagsForMP = 3334183000,
        AdditionalFlagsForSP = 2983510006,
        AdditionalPartVelocityMaxAngle = 1828588624,
        AdditionalPartVelocityMaxMagnitude = 3422152811,
        AdditionalPartVelocityMinAngle = 784057054,
        AdditionalPartVelocityMinMagnitude = 1230567078,
        AdjustHeight = 3197019338,
        AdjustStep0LClipId = 1465756410,
        AdjustStep0RClipId = 2997429282,
        AdjustStep180LClipId = 790728667,
        AdjustStep180RClipId = 356569692,
        AdjustStep90LClipId = 1144665981,
        AdjustStep90RClipId = 2148334725,
        AdvancedData = 3001857377,
        AggressiveAssetTouching = 3373837155,
        AgitatedClipSet = 635910266,
        AgitatedType = 1914024618,
        AiPotentialBlastEventRange = 2050022834,
        AiSoundRange = 2397158564,
        AimAssistCapsuleMaxLengthInVehicle = 1099784311,
        AimAssistCapsuleRadiusInVehicle = 2152729841,
        AimCameraHash = 841426764,
        AimGrenadeThrowAlternateClipsetHash = 2115459301,
        AimGrenadeThrowNormalClipsetHash = 2006670066,
        AimOffsetEndPosMaxFPSIdle = 2629724308,
        AimOffsetEndPosMaxFPSLT = 442201956,
        AimOffsetEndPosMedFPSIdle = 159678902,
        AimOffsetEndPosMedFPSLT = 4021404711,
        AimOffsetEndPosMinFPSIdle = 490657227,
        AimOffsetEndPosMinFPSLT = 4114413908,
        AimOffsetMax = 2819886543,
        AimOffsetMaxFPSIdle = 1354520323,
        AimOffsetMaxFPSLT = 3012363023,
        AimOffsetMaxFPSRNG = 3154201429,
        AimOffsetMaxFPSScope = 3491320217,
        AimOffsetMedFPSIdle = 3963853682,
        AimOffsetMin = 1773410084,
        AimOffsetMinFPSIdle = 1762316152,
        AimOffsetMinFPSLT = 2508633469,
        AimOffsetMinFPSRNG = 2490856062,
        AimOffsetMinFPSScope = 1705130713,
        AimOutroAnimStateInfos = 2828309925,
        AimOutroDelayTimeFPS = 3531438516,
        AimOutroDelayTimeFPSScope = 796325569,
        AimOutroDelayWhenPeekingOnly = 2152868269,
        AimProbeLengthMax = 4083367535,
        AimProbeLengthMin = 48031326,
        AimProbeRadiusOverrideFPSIdle = 1396927221,
        AimProbeRadiusOverrideFPSIdleStealth = 3754674731,
        AimProbeRadiusOverrideFPSLT = 113207446,
        AimProbeRadiusOverrideFPSRNG = 4120241000,
        AimProbeRadiusOverrideFPSScope = 2947162430,
        AimTurnCrouchingClipSetHash = 2657385646,
        AimTurnStandingClipSetHash = 555605495,
        AimTurnThreshold = 1642837247,
        AimingBreathingAdditiveWeight = 250359939,
        AimingDownTheBarrel = 3088433743,
        AimingInfo = 2222714477,
        AimingInfos = 312159731,
        AimingLeanAdditiveWeight = 4147149803,
        AirborneAircraftLockOnMultiplier = 4023972158,
        AirbornePickup = 383102,
        AircraftToAircraftRejectionModifier = 680689338,
        Alias = 1649079736,
        Aliases = 2789050407,
        AlignPitchToWavesInFishLocomotion = 2802719002,
        AlignWithTrajectory = 181259366,
        AlignWithTrajectoryYAxis = 3894937597,
        Align_Right = 2798427077,
        AlignmentEnvelopeRef = 2541847736,
        AllLods = 2087132698,
        AllowArticulation = 4088108644,
        AllowBodyColorMapping = 2350074776,
        AllowCloseQuarterKills = 3833097801,
        AllowConversations = 1261111969,
        AllowCrouchedMovement = 1408446664,
        AllowDamageToVehicle = 1930307181,
        AllowDamageToVehicleOccupants = 1507264081,
        AllowEarlyDoorAndSeatUnreservation = 1392627969,
        AllowEarlyExitFromFireAnimAfterBulletFired = 1180731573,
        AllowEquippedWeapons = 1296343621,
        AllowFPSAnalogStickRunInInteriors = 1138836382,
        AllowInvestigation = 1269249358,
        AllowJoyriding = 1531576100,
        AllowLookback = 2842733918,
        AllowMeleeBlock = 753248190,
        AllowMeleeIntroAnim = 3953923129,
        AllowMovementDuringFirstPersonScope = 2865340900,
        AllowParachuting = 80800205,
        AllowPretendOccupants = 3604791466,
        AllowRepeat = 3671364910,
        AllowSimplifiedColliders = 250554556,
        AllowSingleSideOvershoot = 3059176356,
        AllowStealthMovement = 1789931801,
        AllowSundayDriving = 3342301649,
        AllowUFlip = 534096194,
        AllowVFlip = 14982293,
        AllowWrapping = 1155714879,
        Alpha = 3188992159,
        AlphaCardOnlyGlobalStiffness = 2717347431,
        AltFirstPersonDriveByClipSets = 126472490,
        AltLowRiderBlendDuration = 1743777174,
        AltLowriderLeanClipSet = 2508026904,
        AlternateAimingCrouchingClipSetHash = 2391712363,
        AlternateAimingStandingClipSetHash = 3429042611,
        AlternateBeJackedFromOutSideClipId = 203282629,
        AlternateEntryPointClipSetId = 101269206,
        AlternateForcedEntryClipId = 3438947470,
        AlternateJackFromOutSideClipId = 2992153534,
        AlternateTryLockedDoorClipId = 3160473053,
        AlternateWaitTime = 172194044,
        Alternative = 1895484428,
        AlternativeClipSetWhenBlocked = 972739572,
        AlternativeOrScopedCameraHash = 2399473077,
        AlwaysFixed = 2096408236,
        AlwaysKeepMovingWhilstFollowingLeaderPath = 3197920922,
        AlwaysSprintWhenFleeingInThreatResponse = 1422184172,
        AlwaysUseButtons = 800057922,
        AmbientClips = 3773211500,
        AmbientPedsMultiplier = 1529543569,
        AmbientPedsMultiplier_Base = 4108705316,
        AmbulanceSpawnDelayMax = 4092621748,
        AmbulanceSpawnDelayMin = 1884943389,
        Ammo = 3700748833,
        AmmoDiminishingRate = 220580627,
        AmmoFlags = 3459941894,
        AmmoInfo = 375910550,
        AmmoMax = 4089216737,
        AmmoMax100 = 773313746,
        AmmoMax100MP = 1630803618,
        AmmoMax50 = 4154804270,
        AmmoMax50MP = 3378589949,
        AmmoMaxMP = 2351234779,
        AmmoMaxMPBonus = 1795472692,
        AmmoRef = 3293768610,
        AmmoSpecialType = 2705942513,
        AnalogRange = 4093171906,
        Anger = 991116719,
        AngerRate = 3715658831,
        Angle = 772580522,
        AngleThreshold = 1910481513,
        AngleThresholdDegrees = 3702961077,
        AngleToBlendInExtraPitch = 1378727889,
        AngleToBlendInOffset = 2495561481,
        AngularWidthFactor = 942001293,
        Anim = 4216856702,
        AnimBlendInRate = 3102000831,
        AnimBlendOutRate = 2852489708,
        AnimBlindFireRateModifier = 78898466,
        AnimCombatEntry = 608046949,
        AnimCrouchFire = 4118663994,
        AnimFireRateModifier = 2635039392,
        AnimPlaybackRate = 3315731181,
        AnimRateModifier = 2029810088,
        AnimRateSet = 2389917811,
        AnimRateSets = 591040518,
        AnimReload = 2570196920,
        AnimReloadRate = 20351644,
        AnimWantingToShootFireRateModifier = 2041524798,
        AnimatedCameraRef = 1814055656,
        AnimationFPS = 105980334,
        AnimationFrameCount = 3407876559,
        AnimationTimeMax = 823964753,
        AnimationTimeMin = 4112696610,
        AnisotropicFiltering = 1725816471,
        Any = 3190565597,
        ApplyBulletForce = 2063316609,
        ApplyDamageOnImpact = 1506398052,
        ApplyExtraHeadingChangesInFishLocomotion = 188576109,
        ApplyRelativeTargetPitch = 1325471768,
        ApplyVehicleDamageToEngine = 977752655,
        ApplyWeaponTint = 3549216656,
        ApproachSpeedToWithinMaxBlendDelta = 2190296471,
        ArchiveCount = 2655289749,
        ArmorPiercing = 1429006929,
        Armour = 948484514,
        ArmourPenetrating = 601119279,
        ArmouredVehicleGlassDamageOverride = 1042329515,
        ArrayOfMaximumTextLines = 3635458031,
        Arresting = 2447807752,
        ArrestingCopMaxDistanceFromTarget = 1425198943,
        Arrows = 3162118079,
        Arrows_LeftRight = 2711933695,
        Arrows_UpDown = 1120585455,
        AssassinLvl1Accuracy = 2394623568,
        AssassinLvl1HealthMod = 2477967991,
        AssassinLvl1ShootRate = 3368196277,
        AssassinLvl1WeaponPrimary = 3376433583,
        AssassinLvl1WeaponSecondary = 689054964,
        AssassinLvl2Accuracy = 147587300,
        AssassinLvl2HealthMod = 4035657267,
        AssassinLvl2ShootRate = 201820320,
        AssassinLvl2WeaponPrimary = 3058832678,
        AssassinLvl2WeaponSecondary = 2649613364,
        AssassinLvl3Accuracy = 4282874513,
        AssassinLvl3HealthMod = 2143223731,
        AssassinLvl3ShootRate = 969882415,
        AssassinLvl3WeaponPrimary = 1149455399,
        AssassinLvl3WeaponSecondary = 835576115,
        AssistedAimVehicleWeapon = 2911959137,
        AssociatedSpeech = 1782654006,
        AttachBone = 3503654809,
        AttachFPSLeftHandIKToRight = 2637971006,
        AttachLeftFoot = 1621935620,
        AttachLeftHand = 415945555,
        AttachPed = 2572794893,
        AttachPoints = 3223658082,
        AttachReloadObjectToRightHand = 2394517394,
        AttachRightFoot = 3541798023,
        AttachRightHand = 797980608,
        AttachmentBone = 995270121,
        AttachmentOffset = 3576448206,
        AttachmentRotation = 3148341122,
        AttackFrequencyBestFighterMaxInMs = 2966230785,
        AttackFrequencyBestFighterMinInMs = 615122375,
        AttackFrequencyWorstFighterMaxInMs = 2861434389,
        AttackFrequencyWorstFighterMinInMs = 3764863863,
        AttackProbabilityToComboMax = 3773478080,
        AttackProbabilityToComboMin = 2709441882,
        AttackRangeMax = 1512182719,
        AttackRanges = 2397081448,
        AttackWindowDistanceForCover = 2307014649,
        Audio = 3093697535,
        Audio3d = 245634021,
        AudioBodyHealth = 2834583842,
        AudioCollisionHash = 3730098480,
        AudioEngineHealth = 1277862239,
        AudioRef = 1891847422,
        Audios = 4038606149,
        AutoCloseThisDoor = 2713459202,
        Automatic = 3229633001,
        AutomaticCloseDoor = 616245883,
        AvoidFire = 2354562214,
        AvoidObjects = 478086722,
        Axis = 3277341140,
        AxisDefinitions = 2304270293,
        BARBED_WIRE = 1435562976,
        BASIC_MOUSE_AXIS_MAX = 2087355036,
        BC_Maximum = 2650352944,
        BC_Minimum = 1834753809,
        BF_Aggressive = 527229254,
        BF_AllowDogFighting = 671535224,
        BF_AlwaysEquipBestWeapon = 4103436472,
        BF_AlwaysFight = 2599797237,
        BF_AlwaysFlee = 259037441,
        BF_BlindFireWhenInCover = 2382401309,
        BF_CanBust = 491094445,
        BF_CanCharge = 1158639902,
        BF_CanChaseTargetOnFoot = 1242006486,
        BF_CanCommandeerVehicles = 4092558147,
        BF_CanDoDrivebys = 711948085,
        BF_CanFightArmedPedsWhenNotArmed = 2485499456,
        BF_CanFlank = 323904962,
        BF_CanInvestigate = 2388027105,
        BF_CanLeaveVehicle = 4200622033,
        BF_CanSeeUnderwaterPeds = 3715917878,
        BF_CanTauntInVehicle = 2793870991,
        BF_CanThrowSmokeGrenade = 4264575611,
        BF_CanUseCover = 1640445582,
        BF_CanUseDynamicStrafeDecisions = 4259560164,
        BF_CanUseFrustratedAdvance = 4052930181,
        BF_CanUsePeekingVariations = 2257210821,
        BF_CanUseVehicles = 1789226058,
        BF_DONT_SCREAM_ON_FLEE = 2870992946,
        BF_DisableBlockFromPursueDuringVehicleChase = 511085499,
        BF_DisableBulletReactions = 2290601428,
        BF_DisableCruiseInFrontDuringBlockDuringVehicleChase = 139883471,
        BF_DisableFleeFromCombat = 424806380,
        BF_DisableReactToBuddyShot = 3240480803,
        BF_DisableRespondedToThreatBroadcast = 1577992553,
        BF_DisableSpinOutDuringVehicleChase = 1966619262,
        BF_FleesFromInvincibleOpponents = 2092917322,
        BF_HasRadio = 4180913680,
        BF_MaintainMinDistanceToTarget = 2281462030,
        BF_NonMissionPedsFleeFromThisPedUnlessArmed = 3612371359,
        BF_PerfectAccuracy = 92399290,
        BF_PermitChargeBeyondDefensiveArea = 2781932208,
        BF_SetDisableShoutTargetPositionOnCombatStart = 2133372603,
        BF_SwitchToAdvanceIfCantFindCover = 1454411280,
        BF_SwitchToDefensiveIfInCover = 3540955421,
        BF_UseEnemyAccuracyScaling = 719977005,
        BF_UseProximityFiringRate = 3014467618,
        BF_WillDragInjuredPedsToSafety = 1334619848,
        BIKE_DRIVEBY = 1981221953,
        BIRD = 148966430,
        BIRD_ON_FOOT = 265565800,
        BITFIELD = 4022267004,
        BOAR = 227100837,
        BOAR_ON_FOOT = 366615058,
        BONE = 2289744486,
        BONETAG_BAGBODY = 2560977519,
        BONETAG_BAGPIVOT = 3875905388,
        BONETAG_BAGPIVOTROOT = 1823061586,
        BONETAG_BAGROOT = 1473028002,
        BONETAG_CAMERA = 2650851428,
        BONETAG_FACING_DIR = 3452992357,
        BONETAG_HAIR_HEIGHT = 2644806883,
        BONETAG_HAIR_SCALE = 2421563540,
        BONETAG_HEAD_X = 3159424443,
        BONETAG_HIGH_HEELS = 2263842006,
        BONETAG_JAW = 601675397,
        BONETAG_LOOK_DIR = 3473614855,
        BONETAG_L_ARMROLL = 1648548119,
        BONETAG_L_CLAW = 62423933,
        BONETAG_L_EYE = 1949780854,
        BONETAG_L_EYE2 = 1556908436,
        BONETAG_L_FOREARMROLL = 2013152691,
        BONETAG_L_IK_FOOT = 2034893792,
        BONETAG_L_IK_HAND = 3870648046,
        BONETAG_L_PH_FOOT = 633057706,
        BONETAG_L_STIRRUP = 2379061275,
        BONETAG_L_THIGHROLL = 2720329662,
        BONETAG_NECKROLL = 1914315501,
        BONETAG_NECK_X = 1939403075,
        BONETAG_NECK_Y = 1097108699,
        BONETAG_NECK_Z = 428522884,
        BONETAG_PELVISROOT = 1724691876,
        BONETAG_R_ARMROLL = 533252846,
        BONETAG_R_CLAW = 2641889475,
        BONETAG_R_EYE = 3296017019,
        BONETAG_R_EYE2 = 3030868822,
        BONETAG_R_FOREARMROLL = 1274264606,
        BONETAG_R_IK_FOOT = 974447640,
        BONETAG_R_IK_HAND = 3398180204,
        BONETAG_R_PH_FOOT = 3570968304,
        BONETAG_R_STIRRUP = 176026430,
        BONETAG_R_THIGHROLL = 2841566254,
        BONETAG_WEAPON_GRIP = 3721004313,
        BONETAG_WEAPON_GRIP2 = 1646663439,
        BOSF_AllowRootSlopeFixup = 553367046,
        BOSF_AllowWhenDead = 1151168358,
        BOSF_DontAbortOnFall = 794851930,
        BOSF_ForceDefaultBlendOutSet = 980901059,
        BOSF_ForceNoBlendOutSet = 1425845101,
        BOUND_DEF_IS_PLANE = 997866013,
        BULLET = 176874320,
        BULLET_RUBBER = 3309321920,
        BUTTONS_BUMPERS = 2634435576,
        BUTTONS_TRIGGERS = 3929394922,
        BUTTON_A = 523551665,
        BUTTON_B = 4230643101,
        BUTTON_BACK = 4201632932,
        BUTTON_L1 = 192282600,
        BUTTON_L2 = 3030602308,
        BUTTON_R1 = 3431671271,
        BUTTON_R2 = 3184330859,
        BUTTON_START = 2971254081,
        BUTTON_X = 1621706497,
        BUTTON_Y = 225058948,
        BZGAS = 2842195391,
        BackMenuId = 439086446,
        BackupCopMaxDistanceFromTarget = 4218266421,
        BaseAnims = 3416748085,
        BaseColor = 3835454875,
        BaseCoronaSize = 701167700,
        BaseElementLocations = 3402759838,
        BaseElementLocationsMap = 4032545520,
        BaseElementLocationsMap_HighApt = 3256826999,
        BaseElements = 1743700635,
        BaseShopItem = 1897212518,
        BaseShopPedApparel = 4218762814,
        BaseWeight = 1144176514,
        BaseX = 3704674878,
        BaseY = 3231031752,
        BaseZ = 4180841209,
        BasisWaves = 2821570241,
        BatchSpread = 2548411929,
        BehaviourFlags = 1179525,
        BicycleInfo = 586158244,
        BicycleInfos = 732322334,
        BikeEntryCapsuleRadiusScale = 1835160785,
        BikeHornIntroClipId = 1920935636,
        BikeHornOutroClipId = 4017603423,
        BikeLeansUnlessMoving = 3005072637,
        BindingInfo = 3176250120,
        BirdWeaponHash = 3328482583,
        BitFlags = 3919519923,
        BlendInDelta = 1444366527,
        BlindFireChance = 1464236914,
        BlockAmbientIdles = 986554254,
        BlockFirstPersonStateTransitionWhileFiring = 1573680488,
        BlockGestures = 809922371,
        BlockIdleTurnsInSmartFleeWhileWaitingOnPath = 1377557187,
        BlockJackReactionSides = 2641266910,
        BlockJackReactionUntilJackerIsReady = 1610101408,
        BlockLeftHandIKWhileAiming = 556025401,
        BlockLegIk = 1936477688,
        BlockPlayerFishPitchingWhenSlow = 950847658,
        BlockProbabilityMax = 554561558,
        BlockProbabilityMin = 2578864153,
        BlockedModels = 2381616097,
        Blocker = 2014149228,
        BlockerLength = 3539773325,
        BlockerRadius = 1046764279,
        BlockerSlot = 3853436417,
        BlockerXRotation = 966752528,
        BlockerYOffset = 2957448977,
        BlockerZOffset = 687388576,
        BloodColor = 3684200812,
        BloodData = 2733425626,
        BloodFadeStartTime = 2840607771,
        BloodFadeTime = 2602101636,
        BloodFresnel = 3420616868,
        BloodReflection = 1257137425,
        BloodSpecExponent = 3834486234,
        BloodSpecIntensity = 3964548830,
        BlurPasses = 2941861809,
        BlurType = 1763445053,
        BoatBlockerHeadHeight = 114894238,
        BoatBlockerZOffset = 1243655401,
        Body = 1566662287,
        BodyColour1 = 4214880000,
        BodyColour2 = 170693861,
        BodyColour3 = 3163355555,
        BodyColour4 = 3462307142,
        BodyColour5 = 3626873060,
        BodyColour6 = 3934016897,
        BodyLeanXApproachSpeed = 1854236393,
        BodyLeanXDeltaFromCenterMaxBikeLean = 3920912890,
        BodyLeanXDeltaFromCenterMinBikeLean = 231774160,
        BodyLeanXSmallDelta = 3635851871,
        Bomb = 2853213664,
        BoneID = 2279041969,
        BoneIndex = 3821112550,
        BoneIndexMap = 1618867041,
        BoneName = 3359662533,
        BoneTag = 847714150,
        BoolData = 1997104514,
        BottomLod = 829440843,
        BoundBox = 259818442,
        BoundComposite = 498777609,
        BoundingBoxMaxXYZMarginW = 2511388439,
        BoundingBoxMinXYZRefCountW = 2117360693,
        BoundingSpheres = 455826654,
        BreakForNearbyPlayer = 2340865157,
        BreakPresets = 2225933948,
        BreakingFrameRateLimit = 437150447,
        BreakoutTestPoint = 1370184537,
        BrokenEventFlags = 678418005,
        Build = 2627648817,
        BulletBendingFarMultiplier = 1204531501,
        BulletBendingFarRadius = 2649501669,
        BulletBendingNearMultiplier = 1715236167,
        BulletBendingNearRadius = 649847353,
        BulletBendingZoomMultiplier = 2894104098,
        BulletBendingZoomedRadius = 322042670,
        BulletDirectionOffsetInDegrees = 2164983425,
        BulletDirectionPitchHomingOffset = 1012151441,
        BulletDirectionPitchOffset = 2198518997,
        BulletImpactDetectionRange = 327582449,
        BulletsInBatch = 1660595343,
        BulletsPerAnimLoop = 2195217100,
        BumpTexture = 30177615,
        BurstDurationInCover = 1040979833,
        BurstDurationMax = 4293607926,
        BurstDurationMin = 4146178647,
        BurstIntensityMax = 486888848,
        BurstIntensityMin = 4723066,
        BurstSeqCount = 2826938767,
        BurstSeqOrbitXVariance = 867092332,
        BurstSeqOrbitYVariance = 1105283732,
        BurstThresholdIntensity = 263671582,
        ButtonInput = 2087442028,
        ButtonInputGroup = 878483897,
        ButtonList = 3438031068,
        ButtonPrompts = 3307463612,
        Buttons = 3213575983,
        C2dEffectConfig = 466112053,
        CAICurvePoint = 3141449129,
        CAIHandlingInfo = 2955401113,
        CAIHandlingInfoMgr = 2346814415,
        CARGRP_FILE = 3783701680,
        CAT_ON_FOOT = 4011820749,
        CA_Average = 665767240,
        CA_NumTypes = 2794975978,
        CA_Poor = 1741533283,
        CA_Professional = 4290540434,
        CActionBranch = 3243322573,
        CActionBranchSet = 1909819311,
        CActionCondPedOther = 1532501414,
        CActionCondSpecial = 3495444084,
        CActionDefinition = 1382875680,
        CActionFacialAnimSet = 538237438,
        CActionResult = 1889011007,
        CActionRumble = 2880578782,
        CActionVfx = 2757259018,
        CAdditionalVfxWaterSample = 2578159688,
        CAdvancedData = 623413648,
        CAgitatedAction = 205794446,
        CAgitatedActionAnger = 7068199,
        CAgitatedActionApplyAgitation = 1351793074,
        CAgitatedActionCallPolice = 559712557,
        CAgitatedActionChangeResponse = 1379617166,
        CAgitatedActionClearHash = 2799261502,
        CAgitatedActionConditional = 3383537842,
        CAgitatedActionConfront = 659016751,
        CAgitatedActionEnterVehicle = 1726890630,
        CAgitatedActionExitVehicle = 2091554238,
        CAgitatedActionFace = 1712878361,
        CAgitatedActionFear = 3488155682,
        CAgitatedActionFight = 1310826764,
        CAgitatedActionFlee = 848341528,
        CAgitatedActionFlee__Flags = 2640382104,
        CAgitatedActionFlipOff = 790532802,
        CAgitatedActionFollow = 4183455035,
        CAgitatedActionHurryAway = 1472458908,
        CAgitatedActionIgnoreForcedAudioFailures = 1350994944,
        CAgitatedActionMakeAggressiveDriver = 845878731,
        CAgitatedActionMulti = 1221513331,
        CAgitatedActionReportCrime = 1662729619,
        CAgitatedActionReset = 2404218169,
        CAgitatedActionSay = 3870843999,
        CAgitatedActionSayAgitator = 2626530948,
        CAgitatedActionSetFleeAmbientClips = 3752729945,
        CAgitatedActionSetFleeMoveBlendRatio = 574538,
        CAgitatedActionSetHash = 2862836345,
        CAgitatedActionStopVehicle = 4064026753,
        CAgitatedActionTask = 3085441316,
        CAgitatedActionTurnOnSiren = 2480256069,
        CAgitatedCondition = 1431214492,
        CAgitatedConditionAnd = 4262262065,
        CAgitatedConditionCanCallPolice = 638063199,
        CAgitatedConditionCanFight = 2320485480,
        CAgitatedConditionCanHurryAway = 3139176891,
        CAgitatedConditionCanStepOutOfVehicle = 2390321604,
        CAgitatedConditionCanWalkAway = 2777647446,
        CAgitatedConditionCheckBraveryFlags = 490726986,
        CAgitatedConditionHasBeenHostileFor = 1578160471,
        CAgitatedConditionHasContext = 2002095327,
        CAgitatedConditionHasFriendsNearby = 1659414427,
        CAgitatedConditionHasLeader = 3591387831,
        CAgitatedConditionHasLeaderBeenFightingFor = 2209744810,
        CAgitatedConditionHasPavement = 3586115914,
        CAgitatedConditionHasVehicle = 1632424930,
        CAgitatedConditionIntruderLeft = 1701051392,
        CAgitatedConditionIsAGunPulled = 387035187,
        CAgitatedConditionIsAgitatorArmed = 1527561454,
        CAgitatedConditionIsAgitatorEnteringVehicle = 3055521181,
        CAgitatedConditionIsAgitatorInOurTerritory = 1694966293,
        CAgitatedConditionIsAgitatorInVehicle = 3732914287,
        CAgitatedConditionIsAgitatorInjured = 1156381707,
        CAgitatedConditionIsAgitatorMovingAway = 966249875,
        CAgitatedConditionIsAngry = 3267226651,
        CAgitatedConditionIsArgumentative = 1623088064,
        CAgitatedConditionIsAvoiding = 2769373528,
        CAgitatedConditionIsBecomingArmed = 2899145879,
        CAgitatedConditionIsBumped = 1746707583,
        CAgitatedConditionIsBumpedByVehicle = 2084329118,
        CAgitatedConditionIsBumpedInVehicle = 2335787969,
        CAgitatedConditionIsCallingPolice = 610757980,
        CAgitatedConditionIsConfrontational = 2695184474,
        CAgitatedConditionIsConfronting = 4068723614,
        CAgitatedConditionIsContext = 1234455414,
        CAgitatedConditionIsDodged = 3396217340,
        CAgitatedConditionIsDodgedVehicle = 3726406893,
        CAgitatedConditionIsDrivingVehicle = 1480257191,
        CAgitatedConditionIsExitingScenario = 731623146,
        CAgitatedConditionIsFacing = 3434899389,
        CAgitatedConditionIsFearful = 1805855929,
        CAgitatedConditionIsFighting = 3925606501,
        CAgitatedConditionIsFleeing = 473145945,
        CAgitatedConditionIsFlippingOff = 226904498,
        CAgitatedConditionIsFollowing = 1313533700,
        CAgitatedConditionIsFriendlyTalking = 1116184928,
        CAgitatedConditionIsGettingUp = 3508628274,
        CAgitatedConditionIsGriefing = 1926944189,
        CAgitatedConditionIsGunAimedAt = 965782371,
        CAgitatedConditionIsHarassed = 4189420450,
        CAgitatedConditionIsHash = 1783735184,
        CAgitatedConditionIsHostile = 3161499436,
        CAgitatedConditionIsHurryingAway = 3755753988,
        CAgitatedConditionIsInVehicle = 229441974,
        CAgitatedConditionIsInjured = 3905341682,
        CAgitatedConditionIsInsulted = 1446004423,
        CAgitatedConditionIsIntervene = 3481175636,
        CAgitatedConditionIsIntimidate = 1569094737,
        CAgitatedConditionIsLastAgitationApplied = 1812182034,
        CAgitatedConditionIsLawEnforcement = 2457164355,
        CAgitatedConditionIsLeaderAgitated = 2765391152,
        CAgitatedConditionIsLeaderFighting = 3604362401,
        CAgitatedConditionIsLeaderInState = 2756317689,
        CAgitatedConditionIsLeaderStill = 582672410,
        CAgitatedConditionIsLeaderTalking = 720540654,
        CAgitatedConditionIsLeaderUsingResponse = 374106296,
        CAgitatedConditionIsLoitering = 1503237596,
        CAgitatedConditionIsMale = 3122491667,
        CAgitatedConditionIsOutsideClosestDistance = 2071529953,
        CAgitatedConditionIsOutsideDistance = 3228391764,
        CAgitatedConditionIsPlayingAmbientsInScenario = 2710621647,
        CAgitatedConditionIsProvoked = 1219073285,
        CAgitatedConditionIsRanting = 359883061,
        CAgitatedConditionIsReadyForScenarioResponse = 799096528,
        CAgitatedConditionIsSirenOn = 2509637748,
        CAgitatedConditionIsStanding = 39682177,
        CAgitatedConditionIsSwimming = 2940079793,
        CAgitatedConditionIsTalking = 2381353942,
        CAgitatedConditionIsTargetDoingAMeleeMove = 3475679926,
        CAgitatedConditionIsTerritoryIntruded = 3220616342,
        CAgitatedConditionIsUsingRagdoll = 3317837475,
        CAgitatedConditionIsUsingScenario = 2946293761,
        CAgitatedConditionIsUsingTerritoryScenario = 3238982303,
        CAgitatedConditionIsWandering = 3006554781,
        CAgitatedConditionMulti = 286766287,
        CAgitatedConditionNot = 3493390072,
        CAgitatedConditionOr = 3795658924,
        CAgitatedConditionRandom = 1446808188,
        CAgitatedConditionTimeout = 220569280,
        CAgitatedConditionWasLeaderHit = 2102042648,
        CAgitatedConditionWasRecentlyBumpedWhenStill = 3753107411,
        CAgitatedConditionWasUsingTerritorialScenario = 673471233,
        CAgitatedConditionalAction = 456829274,
        CAgitatedConditionalSay = 463470553,
        CAgitatedContext = 384847550,
        CAgitatedPersonalities = 1650666411,
        CAgitatedPersonality = 932871372,
        CAgitatedPersonality__Flags = 2037242932,
        CAgitatedReaction = 1815310392,
        CAgitatedReaction__Flags = 1740593176,
        CAgitatedResponse = 1102544417,
        CAgitatedResponse__Flags = 2704775815,
        CAgitatedResponses = 4173175510,
        CAgitatedSay = 1699889864,
        CAgitatedSay__Flags = 2918829007,
        CAgitatedScenarioExit = 3340603132,
        CAgitatedScenarioFastCowardExit = 738087856,
        CAgitatedScenarioFleeExit = 2591602931,
        CAgitatedScenarioNormalCowardExit = 2173134606,
        CAgitatedSetWaterSurvivalTime = 2008442412,
        CAgitatedSituation = 1909181459,
        CAgitatedState = 3932762295,
        CAgitatedState__Flags = 3953028652,
        CAgitatedTrigger = 1204364621,
        CAgitatedTriggers = 1555417986,
        CAimingInfo = 351720063,
        CAlternateVariations = 3674088734,
        CAmbientAudio = 1882658854,
        CAmbientAudio__Flags = 3159232986,
        CAmbientAudios = 1462458485,
        CAmbientModel = 1607721222,
        CAmbientModelSet = 3562913804,
        CAmbientModelSets = 1946330348,
        CAmbientModelVariations = 2967451,
        CAmbientVehicleModelVariations = 2714062937,
        CAmbientVehicleModelVariations__Mod = 1719897955,
        CAmbientVehicleModelVariations__UseExtra = 3816750630,
        CAmmoInfo = 4234622439,
        CAmmoInfo__Flags = 4004350922,
        CAmmoProjectileInfo = 2649921127,
        CAmmoProjectileInfo__Flags = 2401637208,
        CAmmoProjectileInfo__sExplosion = 330736104,
        CAmmoRocketInfo = 3832913185,
        CAmmoThrownInfo = 2086854704,
        CAnimRateSet = 1593662014,
        CAnimScene = 3865675032,
        CAnimSceneBoolean = 323697097,
        CAnimSceneCamera = 916147050,
        CAnimSceneClip = 204428087,
        CAnimSceneClipSet = 490994540,
        CAnimSceneCreateObjectEvent = 1044213179,
        CAnimSceneCreatePedEvent = 4089621313,
        CAnimSceneCreateVehicleEvent = 318954633,
        CAnimSceneDictionary = 3053957440,
        CAnimSceneEntity = 2533167258,
        CAnimSceneEntityHandle = 1917557297,
        CAnimSceneEvent = 4243732980,
        CAnimSceneEventList = 3409957559,
        CAnimSceneForceMotionStateEvent = 811875969,
        CAnimSceneHelperBase = 4259026364,
        CAnimSceneInternalLoopEvent = 3069830665,
        CAnimSceneLeadInData = 3326797263,
        CAnimSceneMatrix = 658452109,
        CAnimSceneObject = 2968893744,
        CAnimScenePed = 722578573,
        CAnimScenePlayAnimEvent = 495193874,
        CAnimScenePlayCameraAnimEvent = 3151818686,
        CAnimScenePlaySceneEvent = 1801307749,
        CAnimScenePlayVfxEvent = 1132947353,
        CAnimScenePlaybackList = 3748770928,
        CAnimSceneSection = 3374413951,
        CAnimSceneVehicle = 3514501932,
        CArrowData = 2373226735,
        CAudioSettings = 1748199755,
        CAutoJunctionAdjustment = 2111264667,
        CB_FALSE = 3706707783,
        CB_INHERIT = 3702982772,
        CB_TRUE = 2973879674,
        CBaseCapsuleInfo = 1949057615,
        CBaseElementLocation = 1910346763,
        CBaseElementLocationsMap = 2521896188,
        CBaseElements = 2092750346,
        CBaseStatsSaveStructure = 2234816020,
        CBaseStatsSaveStructure__CBoolStatStruct = 1522851170,
        CBaseStatsSaveStructure__CFloatStatStruct = 567432821,
        CBaseStatsSaveStructure__CInt64StatStruct = 3391349587,
        CBaseStatsSaveStructure__CIntStatStruct = 2199017832,
        CBaseStatsSaveStructure__CStringStatStruct = 1832424966,
        CBaseStatsSaveStructure__CUInt16StatStruct = 2826465508,
        CBaseStatsSaveStructure__CUInt32StatStruct = 2109600065,
        CBaseStatsSaveStructure__CUInt64StatStruct = 3101376297,
        CBaseStatsSaveStructure__CUInt8StatStruct = 3852795153,
        CBaseSubHandlingData = 3882259421,
        CBicycleInfo = 483273065,
        CBikeHandlingData = 3658150531,
        CBipedCapsuleInfo = 1908365754,
        CBirdCapsuleInfo = 2368549953,
        CBoatHandlingData = 2375236175,
        CBrawlingStyleData = 877438671,
        CBrawlingStyleManager = 411366964,
        CBroadcastDataEntry = 3888434693,
        CCameraSaveStructure = 3482698475,
        CCarHandlingData = 835224938,
        CClipSetMap = 2349458107,
        CClothCollisionData = 714812419,
        CCombatInfo = 1826951659,
        CCombatInfoMgr = 1823162092,
        CCompositeEntityAnimation = 3694653796,
        CCompositeEntityArchetypeDef = 1100620366,
        CCompositeEntityEffectsSetting = 2220707169,
        CConditionalAnimManager = 1648185893,
        CConditionalAnims = 2176504456,
        CConditionalAnimsGroup = 2763792854,
        CConditionalClipSet = 663201735,
        CConditionalClipSetVFX = 2613882359,
        CConfigMediaTranscoding = 2023165535,
        CConfigNetScriptBroadcastData = 197320117,
        CConfigOnlineServices = 2397787233,
        CConfigScriptResourceExpectedMaximums = 2596554675,
        CConfigScriptStackSizes = 3786322028,
        CConfigScriptTextLines = 993317819,
        CConfigStreamingEngine = 2004502230,
        CConfigUGCDescriptions = 726232659,
        CContentsOfWeatherXmlFile = 355493353,
        CContextMenu = 3412563496,
        CContextMenuOption = 4120070365,
        CCoverTuning = 61864478,
        CCrimeInfoManager = 3281607587,
        CCrimeInformation = 2353008937,
        CCrimeInformations = 4140223252,
        CCrimeWitnesses__Tunables = 2614231977,
        CCrimeWitnesses__Tunables__Scoring = 1406829096,
        CCustomShaderEffectTree__BRANCH_BEND_AND_TRI_WAVE_MICRO_MOVEMENTS_GLOBALS = 3074723383,
        CCustomShaderEffectTree__BRANCH_BEND_AND_TRI_WAVE_MICRO_MOVEMENTS_LOCALS = 1370018514,
        CCustomShaderEffectTree__BRANCH_BEND_AND_TRI_WAVE_MICRO_MOVEMENTS_LOCALS__BASIS_WAVE = 1321906236,
        CCustomShaderEffectTree__BRANCH_BEND_AND_TRI_WAVE_MICRO_MOVEMENTS_LOCALS__TRIANGLE_WAVE = 4282088314,
        CCustomShaderEffectTree__BRANCH_BEND_AND_TRI_WAVE_MICRO_MOVEMENTS_SFX_GLOBALS = 1550375594,
        CDLCScript = 532882792,
        CDamageAndReaction = 3819966238,
        CDefaultCrimeInfo = 879515392,
        CDefaultTaskDataManager = 3714310317,
        CDefaultTaskDataSet = 2172819232,
        CDeformableBoneData = 2768217506,
        CDeformableObjectManager = 4083322195,
        CDispatchAdvancedSpawnHelper__Tunables__Rendering = 3744572044,
        CDispatchData = 396793225,
        CDispatchHelperSearch__Constraints = 2350715434,
        CDispatchHelperVolumes__Tunables__AngledArea = 3558216355,
        CDispatchHelperVolumes__Tunables__AngledAreaWithPosition = 1419890352,
        CDispatchHelperVolumes__Tunables__BlockingAreas = 2312163633,
        CDispatchHelperVolumes__Tunables__EnclosedSearchAngledArea = 2129766809,
        CDispatchHelperVolumes__Tunables__EnclosedSearchRegionFlags = 4002001992,
        CDispatchHelperVolumes__Tunables__EnclosedSearchRegions = 898276026,
        CDispatchHelperVolumes__Tunables__EnclosedSearchSphere = 253441159,
        CDispatchHelperVolumes__Tunables__LocationForNearestCarNodeOverrides = 3249772165,
        CDispatchHelperVolumes__Tunables__Position = 2431379611,
        CDispatchHelperVolumes__Tunables__Rendering = 3452608618,
        CDispatchHelperVolumes__Tunables__Sphere = 1335944774,
        CDispatchHelperVolumes__Tunables__SphereWithPosition = 3809247475,
        CDispatchResponse = 2684108423,
        CDispatchSpawnHelper__Tunables__Rendering = 3541869149,
        CDispatchSpawnHelper__Tunables__Restrictions = 2369454477,
        CDoorStiffnessInfo = 1742575499,
        CDoorTuning = 2175119364,
        CDrivebyWeaponGroup = 2015418329,
        CDriverInfo = 1707609959,
        CEntryAnimVariations = 3170207336,
        CEventDataDecisionMaker = 3165291783,
        CEventDataManager = 1233556775,
        CEventDataResponseAggressiveRubberneck = 119408345,
        CEventDataResponseDeferToScenarioPointFlags = 4216612323,
        CEventDataResponseFriendlyAimedAt = 2773607819,
        CEventDataResponseFriendlyNearMiss = 2209234376,
        CEventDataResponsePlayerDeath = 1388273275,
        CEventDataResponsePoliceTaskWanted = 2195359331,
        CEventDataResponseSwatTaskWanted = 951777444,
        CEventDataResponseTask = 1867671327,
        CEventDataResponseTaskAgitated = 1872175148,
        CEventDataResponseTaskCombat = 1232518845,
        CEventDataResponseTaskCower = 2895921280,
        CEventDataResponseTaskCrouch = 4137326837,
        CEventDataResponseTaskDuckAndCover = 3498030900,
        CEventDataResponseTaskEscapeBlast = 3209628671,
        CEventDataResponseTaskEvasiveStep = 2890432381,
        CEventDataResponseTaskExhaustedFlee = 237343884,
        CEventDataResponseTaskExplosion = 4184958963,
        CEventDataResponseTaskFlee = 3595274740,
        CEventDataResponseTaskFlyAway = 4165427877,
        CEventDataResponseTaskGrowlAndFlee = 3944278791,
        CEventDataResponseTaskGunAimedAt = 1462292985,
        CEventDataResponseTaskHandsUp = 4004790752,
        CEventDataResponseTaskHeadTrack = 3132741954,
        CEventDataResponseTaskLeaveCarAndFlee = 1141386699,
        CEventDataResponseTaskScenarioFlee = 1109721597,
        CEventDataResponseTaskSharkAttack = 3769404406,
        CEventDataResponseTaskShockingEventBackAway = 631971837,
        CEventDataResponseTaskShockingEventGoto = 954775009,
        CEventDataResponseTaskShockingEventHurryAway = 3773042657,
        CEventDataResponseTaskShockingEventReact = 2315862749,
        CEventDataResponseTaskShockingEventReactToAircraft = 1777630943,
        CEventDataResponseTaskShockingEventStopAndStare = 323763544,
        CEventDataResponseTaskShockingEventThreatResponse = 767509969,
        CEventDataResponseTaskShockingEventWatch = 2519884596,
        CEventDataResponseTaskShockingNiceCar = 2043126590,
        CEventDataResponseTaskShockingPoliceInvestigate = 1919308075,
        CEventDataResponseTaskThreat = 193587689,
        CEventDataResponseTaskTurnToFace = 2510714654,
        CEventDataResponseTaskWalkAway = 1464747102,
        CEventDataResponseTaskWalkRoundEntity = 2821352877,
        CEventDataResponseTaskWalkRoundFire = 2031885260,
        CEventDataResponse_Decision = 3665205924,
        CEventDecisionMakerResponse = 1290698652,
        CEventDecisionMakerResponse__sCooldown = 3962344874,
        CEventShocking__ShockingEventReactionMode = 1809724872,
        CExplosionData = 1347263508,
        CExplosionTagData = 2541591167,
        CExtensionConfig = 2175576306,
        CExtensionDef = 2226571238,
        CExtensionDefClimbHandHold = 3846820479,
        CExtensionDefDecal = 1603354667,
        CExtensionDefLadderMaterialType = 1294270217,
        CExtensionDefLight = 3847218957,
        CExtensionDefLightShaftDensityType = 1931949281,
        CExtensionDefLightShaftVolumeType = 2266515059,
        CExtensionDefScript = 2837988111,
        CExtensionDefScriptChild = 2626018860,
        CExtensionDefScrollbars = 153722093,
        CExtensionDefSwayableEffect = 4270197178,
        CExtensionDefWalkDontWalk = 1989609596,
        CExtraContentCloudManifest = 1103396941,
        CExtraContentSaveStructure = 1387411544,
        CExtraContentSaveStructure__CInstalledPackagesStruct = 148315982,
        CExtraTextMetaFile = 2534304315,
        CExtraVehiclePoint = 3120323930,
        CExtraVehiclePoint__eLocationType = 1144296734,
        CExtraVehiclePoint__ePointType = 3495955287,
        CF_BreakInAnims = 2007130746,
        CF_CommonAnims = 4243892251,
        CF_EntryAnims = 3411143741,
        CF_ExitAnims = 2689206538,
        CF_InVehicleAnims = 3648354860,
        CF_JackingAnims = 2649466346,
        CFirstPersonDriveByLookAroundData = 1352929635,
        CFishCapsuleInfo = 665132565,
        CFlareFX = 2109693593,
        CFlyingHandlingData = 1476460942,
        CGOffsetXYZMaterialId1W = 1964524051,
        CGameConfig = 4224276707,
        CGarages__CGarageInitData = 3678982392,
        CGarages__CGarageInitDataList = 2776701926,
        CGeneralPauseData = 1285447743,
        CGradient = 2907630476,
        CGraphicsSettings = 2539056885,
        CGrassScalingParams = 1927029838,
        CGrassScalingParams_AllLODs = 2830146773,
        CGrassShadowParams_AllLODs = 2934433607,
        CGroup = 1206036020,
        CHIMP = 2830923621,
        CHandlingData = 244606161,
        CHandlingDataMgr = 3480173905,
        CHandlingObject = 4177839580,
        CHealthConfigInfo = 1948857540,
        CHealthConfigInfoManager = 4151525650,
        CHoming = 3497045207,
        CImpulse = 3960327291,
        CImpulseCombo = 1883821118,
        CImpulseTest = 273276595,
        CInVehicleOverrideInfo = 4071371393,
        CInterrelationTest = 163056741,
        CIplCullBoxEntry = 322201475,
        CIplCullBoxFile = 1056751197,
        CItemInfo = 2685769051,
        CJunctionTemplate__CEntrance = 1057820426,
        CJunctionTemplate__CPhaseTiming = 38018516,
        CJunctionTemplate__CTrafficLightLocation = 2279781599,
        CLIMB_UP_FIXUP_POINT = 2285025085,
        CLO_SHOP_AMB = 2840816001,
        CLO_SHOP_CASINO = 3640679453,
        CLO_SHOP_GUN_LARGE = 436138988,
        CLO_SHOP_GUN_SMALL = 401132042,
        CLO_SHOP_HIGH = 744271705,
        CLO_SHOP_LOW = 1068049584,
        CLO_SHOP_MID = 320597145,
        CLO_SHOP_NONE = 1758155824,
        CLadderMetadata = 1455808320,
        CLadderMetadataManager = 3859134265,
        CLayoutNode = 3988609493,
        CLegIkSolver__Tunables__InterpolationSettings = 1560218317,
        CLensFlareSettings = 3544946296,
        CLoadOutItem = 3696626585,
        CLoadOutRandom = 1027894692,
        CLoadOutRandom__sRandomItem = 1552156153,
        CLoadOutWeapon = 4063177247,
        CLoadOutWeapon__Flags = 4270431060,
        CMPApparelData = 494364798,
        CMPOutfits = 3476914261,
        CMPOutfitsData = 201648887,
        CMPOutfitsMap = 1395473003,
        CM_Defensive = 1646472673,
        CM_Stationary = 2572945689,
        CM_WillAdvance = 2881594853,
        CM_WillRetreat = 2232337678,
        CMapParentTxds = 2935248897,
        CMapZone = 1609262955,
        CMapZoneArea = 83121176,
        CMapZonesContainer = 2552382426,
        CMenuArray = 1299257965,
        CMenuButton = 1378813870,
        CMenuButtonList = 776160624,
        CMenuDisplayOption = 3424016330,
        CMenuDisplayValue = 1697788701,
        CMenuItem = 2684763257,
        CMenuScreen = 3304447183,
        CMenuVersion = 3744669285,
        CMiloInterior = 772333974,
        CMiloRoom = 454999816,
        CMiniMapSaveStructure = 531671910,
        CMiniMapSaveStructure__CPointOfInterestStruct = 3924185226,
        CMiniMap_BitmapTunables = 2026887270,
        CMiniMap_CameraTunables = 283649933,
        CMiniMap_DisplayTunables = 1640186987,
        CMiniMap_FogOfWarTunables = 1690619373,
        CMiniMap_HealthBarTunables = 1902464991,
        CMiniMap_OverlayTunables = 2449081679,
        CMiniMap_SonarTunables = 53366421,
        CMiniMap_TileTunables = 3031405081,
        CModelInfoConfig = 2087712435,
        CMotionTaskDataManager = 263418239,
        CMotionTaskDataSet = 1515229600,
        CMovieSubtitleContainer = 2415356487,
        CMovieSubtitleEvent = 1855430138,
        CMovieSubtitleEventArg = 1317284923,
        CMultiplayerStatsSaveStructure = 1344722143,
        CNetworkShoppingMgr = 3529268134,
        CNmBlendOutBlendItem = 3494781989,
        CNmBlendOutItem = 3081261225,
        CNmBlendOutMotionStateItem = 760100476,
        CNmBlendOutPoseItem = 3796248068,
        CNmBlendOutReactionItem = 1785363697,
        CNmBlendOutSet = 2106376725,
        CNmBlendOutSetManager = 3418665864,
        CNmParameter = 3036251262,
        CNmTuningSetGroup = 2070432509,
        COLLISION = 2825505032,
        COL_1 = 2988140884,
        COL_2 = 2684110102,
        COL_3 = 3654793424,
        COL_DATA_TYPE_AUDIO_LIST = 3681758052,
        COL_DATA_TYPE_LOAD_FILES = 2478522080,
        COL_DATA_TYPE_STANDARD = 1532940017,
        COL_TYPE_BASIC_PAGE = 390619240,
        COL_TYPE_LIST = 103874456,
        COL_TYPE_LIST_LONG_AUDIO = 1179323687,
        COL_TYPE_LOAD_PROJ_INFO = 3762293760,
        COL_TYPE_TEXT_PLACEMENT = 553688109,
        COUGAR_ON_FOOT = 3755136335,
        COW = 2589829503,
        COW_ON_FOOT = 3968126243,
        COYOTE = 1574096478,
        COYOTE_ON_FOOT = 574176215,
        CPBlendDistanceMax = 2918632959,
        CPBlendDistanceMin = 4106122381,
        CPED_CONFIG_FLAG_CanBeArrested = 677197233,
        CPED_CONFIG_FLAG_DisableMelee = 4094129056,
        CPED_CONFIG_FLAG_DisablePotentialToBeWalkedIntoResponse = 2874024361,
        CPED_CONFIG_FLAG_EdgeDetected = 1010964272,
        CPED_CONFIG_FLAG_ForceReload = 2910852680,
        CPED_CONFIG_FLAG_ForcedAim = 3581631429,
        CPED_CONFIG_FLAG_HasBrandishedWeapon = 976980533,
        CPED_CONFIG_FLAG_HasHelmet = 4044609607,
        CPED_CONFIG_FLAG_InVehicle = 2941446461,
        CPED_CONFIG_FLAG_IsAgitated = 2812623098,
        CPED_CONFIG_FLAG_IsAimingGun = 3803499046,
        CPED_CONFIG_FLAG_IsFiring = 1387252672,
        CPED_CONFIG_FLAG_IsInCustody = 3026986739,
        CPED_CONFIG_FLAG_IsInTheAir = 1179730833,
        CPED_CONFIG_FLAG_IsInjured = 3788216868,
        CPED_CONFIG_FLAG_IsScuba = 454297464,
        CPED_CONFIG_FLAG_IsStanding = 2953230997,
        CPED_CONFIG_FLAG_IsSwimming = 3452224410,
        CPED_CONFIG_FLAG_IsSwitchingWeapon = 1313708599,
        CPED_CONFIG_FLAG_OnStairs = 3756180547,
        CPED_CONFIG_FLAG_SlopeDetected = 1111886396,
        CPED_CONFIG_FLAG_UseHelmet = 2148893822,
        CPED_CONFIG_FLAG_UsingScenario = 1874652232,
        CPED_CONFIG_FLAG_VisibleOnScreen = 606408771,
        CPED_CONFIG_FLAG_WillArrestRatherThanJack = 3043568096,
        CPNormalOffset = 46549237,
        CPOVTuningInfo = 775112536,
        CPQSMix_Parameters = 3959827468,
        CPRadius = 3663279115,
        CPRelativeStrength = 1298942807,
        CPStrengthClose = 1258297715,
        CPVDrawblData__CPVClothComponentData = 2236980467,
        CPathZone = 2952665595,
        CPathZoneArray = 1313716218,
        CPathZoneData = 4290562366,
        CPathZoneMapping = 1858804798,
        CPathZoneMappingArray = 4247646381,
        CPauseMenuPersistentData = 896097663,
        CPedBloodDamageInfo = 24857490,
        CPedCapsuleInfoManager = 3996993879,
        CPedClothCollision = 140488899,
        CPedCompRestriction = 3553377863,
        CPedCompRestriction__Restriction = 2065671281,
        CPedComponentClothInfo = 4230607411,
        CPedComponentClothManager = 1545319535,
        CPedComponentSetInfo = 1943914184,
        CPedComponentSetManager = 2221977248,
        CPedDamageCylinderInfo = 2197973642,
        CPedDamageCylinderInfoSet = 4026094465,
        CPedDamageData = 400908801,
        CPedDamageDecalInfo = 4149611732,
        CPedDamagePack = 523884128,
        CPedDamagePackEntry = 1030849141,
        CPedFacialOverlays = 216129257,
        CPedIKSettingsInfo = 4287154031,
        CPedIKSettingsInfoManager = 358228855,
        CPedInventoryLoadOut = 1096779993,
        CPedInventoryLoadOutManager = 3863147306,
        CPedModelInfo__PersonalityAgility = 265080325,
        CPedModelInfo__PersonalityBravery = 905918498,
        CPedModelInfo__PersonalityCriminality = 2072330808,
        CPedModelInfo__PersonalityData = 4185391031,
        CPedModelInfo__PersonalityFleeDuringCombat = 651017172,
        CPedModelInfo__PersonalityMovementModes = 29118966,
        CPedModelInfo__PersonalityMovementModes__MovementMode = 1727236615,
        CPedModelInfo__PersonalityMovementModes__MovementMode__ClipSets = 3455138791,
        CPedModelInfo__PersonalityMovementModes__sUnholsterClipData = 1111461724,
        CPedModelInfo__PersonalityMovementModes__sUnholsterClipData__sUnholsterClip = 2934735155,
        CPedModelInfo__PersonalityThreatResponse = 3637970520,
        CPedModelInfo__PersonalityThreatResponse__Action = 3450423538,
        CPedModelInfo__PersonalityThreatResponse__Action__Weights = 3954379444,
        CPedModelInfo__PersonalityThreatResponse__Fight = 301719986,
        CPedModelInfo__PersonalityThreatResponse__Fight__Weights = 272028034,
        CPedMotivationInfo = 2543863252,
        CPedMotivationInfoManager = 3649008975,
        CPedNavCapabilityInfoManager = 863774033,
        CPedPerceptionInfoManager = 428720484,
        CPedPropRestriction = 3159204365,
        CPedPropRestriction__Restriction = 4014426920,
        CPedSkinTones = 3657614324,
        CPickupActionAudio = 906127104,
        CPickupActionData = 2334715423,
        CPickupActionGroup = 4047652660,
        CPickupActionPadShake = 1569143834,
        CPickupActionVfx = 1538001586,
        CPickupData = 1054201726,
        CPickupDataManager = 725548767,
        CPickupRewardAmmo = 2987575824,
        CPickupRewardArmour = 3847538277,
        CPickupRewardBulletMP = 1027615837,
        CPickupRewardData = 3103005981,
        CPickupRewardFireworkMP = 1962296115,
        CPickupRewardGrenadeLauncherMP = 392701876,
        CPickupRewardHealth = 2012711062,
        CPickupRewardHealthVariable = 260193267,
        CPickupRewardMissileMP = 2048800229,
        CPickupRewardMoneyFixed = 3182346544,
        CPickupRewardMoneyVariable = 2270700255,
        CPickupRewardStat = 652149562,
        CPickupRewardStatVariable = 2052529619,
        CPickupRewardVehicleFix = 2101142360,
        CPickupRewardWeapon = 665513894,
        CPlayerInfo__Tunables__CombatLoitering = 2859355160,
        CPlayerInfo__Tunables__EnemyCharging = 2968011987,
        CPlayerPedSaveStructure = 2383497134,
        CPlayerPedSaveStructure__CPlayerDecorationStruct = 3299804829,
        CPlayerPedSaveStructure__SPedCompPropConvData = 4029920929,
        CPlayerSwitchEstablishingShotMetadata = 1595071351,
        CPlayerSwitchEstablishingShotMetadataStore = 1918996500,
        CPlayerSwitchInterface = 981025448,
        CPopAllocation = 8532814,
        CPopModelAndVariations = 3852980612,
        CPopSchedule = 3295641048,
        CPopScheduleList = 988066194,
        CPopZoneData = 62557530,
        CPopZoneData__sZone = 3112305802,
        CPopulationConfig = 1070111882,
        CPosixTimeStampForMultiplayerSaves = 3212005632,
        CProcObjInfo = 2143317860,
        CProperties = 947229524,
        CPropertyData = 4055429938,
        CPropertyItem = 4249583633,
        CQuadrupedCapsuleInfo = 2040625054,
        CR_Far = 1924923312,
        CR_Medium = 4072159921,
        CR_Near = 2889478869,
        CR_NumRanges = 2524664009,
        CR_VeryFar = 1177828923,
        CRadioStationSaveStructure = 1356276358,
        CRadioStationSaveStructure__CRadioStationStruct = 1193335790,
        CRandomEventManager__RandomEventData = 2790883352,
        CRandomEventManager__RandomEventType = 1980648971,
        CRelativeRange = 3225298269,
        CReplayPostFxData = 3529922180,
        CReplayPostFxRegistry = 1831470479,
        CReportArray = 2726290710,
        CReportList = 3395271156,
        CReportOption = 2919856666,
        CRiots__Tunables = 3123798914,
        CRsRef = 3403315862,
        CSaveDoors = 2232696115,
        CSaveDoors__DoorState = 121325990,
        CSaveGarages = 1109755184,
        CSaveGarages__CSaveGarage = 2138386124,
        CSaveGarages__CSavedVehicle = 2541711729,
        CSaveGarages__CSavedVehicleVariationInstance = 2181085963,
        CSaveGarages__CSavedVehiclesInSafeHouse = 1095704148,
        CScenarioAction = 4231362914,
        CScenarioActionCombatExit = 65859126,
        CScenarioActionCondition = 1480361351,
        CScenarioActionConditionCanDoQuickBlendout = 2752711454,
        CScenarioActionConditionCloseOrRecent = 779799094,
        CScenarioActionConditionCurrentlyRespondingToOtherEvent = 1495745330,
        CScenarioActionConditionEvent = 2760081863,
        CScenarioActionConditionForceAction = 3092192225,
        CScenarioActionConditionHasCowardReact = 1919445169,
        CScenarioActionConditionHasShockingReact = 790880812,
        CScenarioActionConditionInRange = 2422295863,
        CScenarioActionConditionIsACopPed = 3874793237,
        CScenarioActionConditionIsAGangPed = 3592014483,
        CScenarioActionConditionIsASecurityPed = 3051764654,
        CScenarioActionConditionNot = 4246034282,
        CScenarioActionConditionResponseTask = 4065859377,
        CScenarioActionConditionResponseType = 2313464203,
        CScenarioActionCowardExitThenRespondToEvent = 324287053,
        CScenarioActionFlee = 262906968,
        CScenarioActionHeadTrack = 2206715854,
        CScenarioActionImmediateExit = 1221591685,
        CScenarioActionNormalExit = 1754109286,
        CScenarioActionNormalExitThenRespondToEvent = 1784720531,
        CScenarioActionScriptExit = 372274610,
        CScenarioActionShockReaction = 1475189745,
        CScenarioActionThreatResponseExit = 1527825320,
        CScenarioActionTrigger = 4116023810,
        CScenarioActionTriggers = 1495463115,
        CScenarioChainingGraph = 4023740759,
        CScenarioCondition = 1317223596,
        CScenarioConditionAffluence = 1168018000,
        CScenarioConditionAlert = 2895223630,
        CScenarioConditionAmbientEventDirection = 1763431418,
        CScenarioConditionAmbientEventTypeCheck = 2871434050,
        CScenarioConditionArePedConfigFlagsSet = 1942856791,
        CScenarioConditionArePedConfigFlagsSetOnOtherPed = 1847173722,
        CScenarioConditionAttachedToPropOfType = 991511752,
        CScenarioConditionBraveryFlagSet = 3342113969,
        CScenarioConditionCanPlayInCarIdle = 2113401905,
        CScenarioConditionCanStartNewPhoneConversation = 1868659780,
        CScenarioConditionCrouched = 920031791,
        CScenarioConditionDistanceToPlayer = 1601862257,
        CScenarioConditionEquippedWeapon = 1672302572,
        CScenarioConditionFullyInIdle = 1486301749,
        CScenarioConditionHasComponentWithFlag = 3505600781,
        CScenarioConditionHasHighHeels = 1915528810,
        CScenarioConditionHasNoProp = 1489575917,
        CScenarioConditionHasParachute = 3079400637,
        CScenarioConditionHasProp = 3864466379,
        CScenarioConditionHeadbobMusicGenre = 2613505630,
        CScenarioConditionHealth = 3423409258,
        CScenarioConditionInCover = 1637565399,
        CScenarioConditionInInterior = 3752489901,
        CScenarioConditionInStationaryVehicleScenario = 10816361,
        CScenarioConditionInVehicleOfType = 3671653820,
        CScenarioConditionInVehicleSeat = 2552940481,
        CScenarioConditionIsHeadbobbingToRadioMusicEnabled = 829425543,
        CScenarioConditionIsMale = 1448697653,
        CScenarioConditionIsMultiplayerGame = 3718489859,
        CScenarioConditionIsPanicking = 3979357694,
        CScenarioConditionIsPlayer = 1839958521,
        CScenarioConditionIsPlayerInMultiplayerGame = 2217137492,
        CScenarioConditionIsPlayerTired = 2424630021,
        CScenarioConditionIsRadioPlaying = 1819849789,
        CScenarioConditionIsRadioPlayingMusic = 2802845691,
        CScenarioConditionIsReaction = 2517955173,
        CScenarioConditionIsSwat = 235104127,
        CScenarioConditionIsTwoHandedWeaponEquipped = 1589666234,
        CScenarioConditionJustGotUp = 1621859314,
        CScenarioConditionModel = 2288895494,
        CScenarioConditionMovementModeType = 1606874778,
        CScenarioConditionOnFootClipSet = 163168979,
        CScenarioConditionOnStraightPath = 3812377708,
        CScenarioConditionOutOfBreath = 339645412,
        CScenarioConditionPedHeading = 682198207,
        CScenarioConditionPhoneConversationAvailable = 2922597148,
        CScenarioConditionPhoneConversationStarting = 2956031861,
        CScenarioConditionPlayerHasSpaceForIdle = 829976330,
        CScenarioConditionPlayingAnim = 1562434465,
        CScenarioConditionPopulation = 215212731,
        CScenarioConditionRaining = 827194976,
        CScenarioConditionRoleInSyncedScene = 1231042199,
        CScenarioConditionSet = 3164477143,
        CScenarioConditionSetOr = 231178150,
        CScenarioConditionSnowing = 2151017773,
        CScenarioConditionSpeed = 1081100722,
        CScenarioConditionSpeed__Speed = 291617045,
        CScenarioConditionSunny = 2487057905,
        CScenarioConditionTechSavvy = 283086198,
        CScenarioConditionTime = 1421087004,
        CScenarioConditionTime__Time = 1157994180,
        CScenarioConditionUsingLRAltClipset = 351065663,
        CScenarioConditionWet = 2622547379,
        CScenarioConditionWindy = 92217396,
        CScenarioConditionWorld = 3836203766,
        CScenarioConditionWorldPosWithinSphere = 1342309501,
        CScenarioConditionWorldSet = 3097977465,
        CScenarioCondition__Result = 2392040142,
        CScenarioControlAmbientInfo = 2409476622,
        CScenarioCoupleInfo = 73597380,
        CScenarioDeadPedInfo = 2999869700,
        CScenarioFleeInfo = 2215336586,
        CScenarioGroupInfo = 2200874709,
        CScenarioInfo = 1854615373,
        CScenarioInfoManager = 2816946525,
        CScenarioJoggingInfo = 1571877876,
        CScenarioLookAtInfo = 3940391455,
        CScenarioMoveBetweenInfo = 896527093,
        CScenarioParkedVehicleInfo = 1148595664,
        CScenarioPhoneConversationInProgress = 848337070,
        CScenarioPlayAnimsInfo = 1295485559,
        CScenarioSkiLiftInfo = 1944967572,
        CScenarioSkiingInfo = 1079811498,
        CScenarioSniperInfo = 260125574,
        CScenarioTransitionInfo = 813771681,
        CScenarioTypeGroup = 3815779878,
        CScenarioTypeGroupEntry = 2823669052,
        CScenarioVehicleInfo = 1145380565,
        CScenarioVehicleParkInfo = 3416803111,
        CScenarioWanderingInRadiusInfo = 2711093208,
        CScenarioWanderingInfo = 3076592047,
        CScriptMetadata = 1286970367,
        CScriptResourceExpectedMaximum = 2738195225,
        CScriptStackSizeDataEntry = 983309015,
        CScriptTextLines = 781855995,
        CScriptedGunTaskInfo = 694833427,
        CScriptedGunTaskMetadataMgr = 1690213644,
        CSeaPlaneHandlingData = 4035040093,
        CSeatOverrideAnimInfo = 1329238713,
        CSeatOverrideAnimInfo__eSeatOverrideAnimFlags = 1295345607,
        CSeatOverrideInfo = 783439082,
        CSettings = 4271886789,
        CSettingsManager = 2724602499,
        CShopData = 1720410478,
        CSimpleImpulseTest = 1642635078,
        CSimpleVariablesSaveStructure = 1712306115,
        CSituationalClipSetStreamer__Tunables__Avoids = 2341712397,
        CSituationalClipSetStreamer__Tunables__Avoids__Variation = 1095110195,
        CSituationalClipSetStreamer__Tunables__FleeReactions = 178027873,
        CSlownessZone = 1778476350,
        CSpawnPoint__AvailabilityMpSp = 3573596290,
        CSpecialAbilityData = 4125685004,
        CSpinnerData = 1472390754,
        CStatsSaveStructure = 1273070568,
        CStatsVehicleUsage = 2887610400,
        CStealVehicleCrime = 2897198185,
        CStealthKillTest = 1938006650,
        CStreamingRequestMasterList = 1492003704,
        CStrikeBone = 3416460934,
        CStrikeBoneSet = 3119136731,
        CStuntJumpSaveStructure = 3231658286,
        CSubmarineHandlingData = 2988792164,
        CSystemSettings = 15379163,
        CTVPlayList = 362052332,
        CTVPlayListSlot = 2602410586,
        CTVPlaylistContainer = 1460727602,
        CTVVideoInfo = 1534590686,
        CT_PED_CHEST = 4142688534,
        CT_PED_HEAD = 298723,
        CT_PED_KNEE_LEFT = 2637933202,
        CT_PED_KNEE_RIGHT = 2688203514,
        CT_PED_NECK = 1749390323,
        CT_PED_ROOT = 3371977080,
        CTacticalAnalysisCoverPointSearch__Tunables__Scoring = 850484111,
        CTacticalAnalysis__Tunables__BadRoute = 1310298123,
        CTacticalAnalysis__Tunables__Rendering = 1230349399,
        CTaskAgitated__Tunables__Rendering = 588501678,
        CTaskAimGunBlindFire__BlindFireAnimStateInfoNew = 994532516,
        CTaskAimGunBlindFire__BlindFirePitchAnimAngles = 4209697792,
        CTaskAimGunFromCoverIntro__AimIntroClip = 4162893736,
        CTaskAimGunFromCoverIntro__AimStepInfo = 2996437115,
        CTaskAimGunFromCoverIntro__AimStepInfoSet = 791301518,
        CTaskAimGunFromCoverOutro__Tunables__AnimStateInfos = 1280972310,
        CTaskBoatCombat__Tunables__Rendering = 384450892,
        CTaskCarReactToVehicleCollision__Tunables__SlowDown = 3933935552,
        CTaskCombat__Tunables__BuddyShot = 4144542252,
        CTaskCombat__Tunables__ChargeTuning = 3736726978,
        CTaskCombat__Tunables__EnemyAccuracyScaling = 1818844971,
        CTaskCombat__Tunables__LackOfHostility = 455065356,
        CTaskCombat__Tunables__LackOfHostility__WantedLevel = 2841666617,
        CTaskCombat__Tunables__ThrowSmokeGrenadeTuning = 1530415684,
        CTaskCover__CoverAnimStateInfo = 3038580099,
        CTaskCover__eAnimFlags = 1559228487,
        CTaskDataInfo = 2090924332,
        CTaskDataInfoManager = 4282804050,
        CTaskDraggingToSafety__Tunables__ObstructionProbe = 1469164696,
        CTaskDraggingToSafety__Tunables__Rendering = 512689970,
        CTaskEnterCover__EnterClip = 711010751,
        CTaskEnterCover__StandingEnterClips = 3590219800,
        CTaskEnterCover__Tunables__AnimStateInfos = 1285383250,
        CTaskExitCover__ExitClip = 4010326834,
        CTaskExitCover__Tunables__AnimStateInfos = 246682624,
        CTaskExitVehicleSeat__ExitToAimClipSet = 609992288,
        CTaskExitVehicleSeat__ExitToAimSeatInfo = 1118518303,
        CTaskExitVehicleSeat__ExitToAimVehicleInfo = 3736014569,
        CTaskExitVehicleSeat__eSeatPosition = 894416699,
        CTaskHeliChase__Tunables__Drift = 1407012688,
        CTaskHeliCombat__Tunables__Chase = 960897278,
        CTaskHumanLocomotion__Tunables__sMovingVars = 1246324819,
        CTaskHumanLocomotion__Tunables__sMovingVarsSet = 2557519583,
        CTaskInCover__ThrowProjectileClip = 1466791495,
        CTaskMotionAiming__Tunables__Turn = 150934045,
        CTaskMotionInCover__Tunables__AnimStateInfos = 2625948332,
        CTaskMotionSwimming__PedVariation = 2354064210,
        CTaskMotionSwimming__PedVariationSet = 2469984956,
        CTaskMotionSwimming__ScubaGearVariation = 3020467458,
        CTaskMotionSwimming__ScubaGearVariations = 4258712195,
        CTaskMotionSwimming__Tunables__ScubaMaskProp = 304399001,
        CTaskMoveCrossRoadAtTrafficLights__WaitingOffset = 645072887,
        CTaskMoveToTacticalPoint__Tunables__Scoring = 2164459263,
        CTaskMoveToTacticalPoint__Tunables__Scoring__CoverPoint = 3018405043,
        CTaskMoveToTacticalPoint__Tunables__Scoring__CoverPoint__Bonus = 1890577968,
        CTaskMoveToTacticalPoint__Tunables__Scoring__CoverPoint__Penalty = 3436208238,
        CTaskMoveToTacticalPoint__Tunables__Scoring__CoverPoint__Penalty__BadRoute = 532562236,
        CTaskMoveToTacticalPoint__Tunables__Scoring__NavMeshPoint = 1211016943,
        CTaskMoveToTacticalPoint__Tunables__Scoring__NavMeshPoint__Bonus = 1762528765,
        CTaskMoveToTacticalPoint__Tunables__Scoring__NavMeshPoint__Penalty = 2194913513,
        CTaskMoveToTacticalPoint__Tunables__Scoring__NavMeshPoint__Penalty__BadRoute = 333617339,
        CTaskMoveToTacticalPoint__Tunables__Scoring__Position = 3791189200,
        CTaskNMBehaviour__Tunables__ActivationLimitModifiers = 2720813484,
        CTaskNMBehaviour__Tunables__BlendOutThreshold = 3749122641,
        CTaskNMBehaviour__Tunables__BoundWeight = 4115910995,
        CTaskNMBehaviour__Tunables__InverseMassScales = 1267291753,
        CTaskNMBehaviour__Tunables__KickOnGroundTuning = 2578171686,
        CTaskNMBehaviour__Tunables__PedCapsuleVehicleImpactTuning = 1040069698,
        CTaskNMBehaviour__Tunables__RagdollUnderWheelTuning = 267001783,
        CTaskNMBehaviour__Tunables__StandardBlendOutThresholds = 3979439077,
        CTaskNMBehaviour__Tunables__TunableForce = 760338219,
        CTaskNMBrace__Tunables__ApplyForce = 3816043274,
        CTaskNMBrace__Tunables__InitialForce = 2808943365,
        CTaskNMBrace__Tunables__StuckOnVehicle = 1649426998,
        CTaskNMBrace__Tunables__VehicleTypeOverrides = 1768633733,
        CTaskNMBrace__Tunables__VehicleTypeTunables = 2216090795,
        CTaskNMBrace__Tunables__VelocityLimits = 238499603,
        CTaskNMControl__Tunables__DriveToGetup = 3336326859,
        CTaskNMDraggingToSafety__Tunables__Constraints = 2410537644,
        CTaskNMDraggingToSafety__Tunables__DraggerArmIk = 1214269741,
        CTaskNMDraggingToSafety__Tunables__Forces = 2059054874,
        CTaskNMDraggingToSafety__Tunables__Stiffness = 2241487041,
        CTaskNMExplosion__Tunables__Explosion = 3490848491,
        CTaskNMRiverRapids__Tunables__BodyWrithe = 2361842970,
        CTaskNMShot__Tunables__ArmShot = 2149258416,
        CTaskNMShot__Tunables__HitPointRandomisation = 996969243,
        CTaskNMShot__Tunables__Impulses = 209088469,
        CTaskNMShot__Tunables__Impulses__SniperImpulses = 3192684380,
        CTaskNMShot__Tunables__ParamSets = 436100430,
        CTaskNMShot__Tunables__ShotAgainstWall = 2342621138,
        CTaskNMShot__Tunables__StayUpright = 1001943080,
        CTaskNMSimple__Tunables__Tuning = 2610655349,
        CTaskParachute__ParachutePackVariation = 1192596872,
        CTaskParachute__ParachutePackVariations = 974228846,
        CTaskParachute__PedVariation = 3901274641,
        CTaskParachute__PedVariationSet = 3788247444,
        CTaskParachute__Tunables__Aiming = 2787675897,
        CTaskParachute__Tunables__Allow = 202257215,
        CTaskParachute__Tunables__CameraSettings = 892940524,
        CTaskParachute__Tunables__ChangeRatesForParachuting = 1918103038,
        CTaskParachute__Tunables__ChangeRatesForSkydiving = 2342773550,
        CTaskParachute__Tunables__CrashLanding = 954219518,
        CTaskParachute__Tunables__ExtraForces = 889782022,
        CTaskParachute__Tunables__ExtraForces__FromStick = 3387028743,
        CTaskParachute__Tunables__ExtraForces__FromValue = 3597070589,
        CTaskParachute__Tunables__ExtraForces__Parachuting = 1386112053,
        CTaskParachute__Tunables__ExtraForces__Parachuting__Braking = 3310740500,
        CTaskParachute__Tunables__ExtraForces__Parachuting__Normal = 899207522,
        CTaskParachute__Tunables__ExtraForces__Value = 162458425,
        CTaskParachute__Tunables__FlightAngleLimitsForParachuting = 4209854321,
        CTaskParachute__Tunables__FlightAngleLimitsForSkydiving = 3788337195,
        CTaskParachute__Tunables__ForcesForSkydiving = 2934924657,
        CTaskParachute__Tunables__Landing = 2206940602,
        CTaskParachute__Tunables__Landing__NormalThreshold = 1558938460,
        CTaskParachute__Tunables__Landing__NormalThresholds = 3954319942,
        CTaskParachute__Tunables__LowLod = 196547756,
        CTaskParachute__Tunables__MoveParameters = 560894723,
        CTaskParachute__Tunables__MoveParameters__Parachuting = 801836577,
        CTaskParachute__Tunables__MoveParameters__Parachuting__InterpRates = 2238420428,
        CTaskParachute__Tunables__PadShake = 947557087,
        CTaskParachute__Tunables__PadShake__Deploy = 2930279050,
        CTaskParachute__Tunables__PadShake__Falling = 3452040071,
        CTaskParachute__Tunables__ParachuteBones = 1078023650,
        CTaskParachute__Tunables__ParachuteBones__Attachment = 2874150626,
        CTaskParachute__Tunables__ParachutePhysics = 3266862316,
        CTaskParachute__Tunables__ParachutingAi = 2046463254,
        CTaskParachute__Tunables__ParachutingAi__Brake = 1021020250,
        CTaskParachute__Tunables__ParachutingAi__Drop = 209420440,
        CTaskParachute__Tunables__ParachutingAi__Pitch = 2131363216,
        CTaskParachute__Tunables__ParachutingAi__Roll = 1305267132,
        CTaskParachute__Tunables__ParachutingAi__Target = 4228543633,
        CTaskParachute__Tunables__PedAngleLimitsForSkydiving = 3009185102,
        CTaskParachute__Tunables__Rendering = 629460530,
        CTaskPlayerOnFoot__Tunables__JetpackData = 2770060121,
        CTaskPlayerOnFoot__Tunables__JetpackData__VelocityInheritance = 549752042,
        CTaskPlayerOnFoot__Tunables__ParachutePack = 810561649,
        CTaskPlayerOnFoot__Tunables__ParachutePack__VelocityInheritance = 1276417684,
        CTaskPlayerOnFoot__Tunables__ScubaGear = 4252665724,
        CTaskPlayerOnFoot__Tunables__ScubaGear__VelocityInheritance = 2201360486,
        CTaskRageRagdoll__Tunables__RageRagdollImpulseTuning = 2715073781,
        CTaskRageRagdoll__Tunables__WritheStrengthTuning = 2579680791,
        CTaskReactAimWeapon__Tunables__Ability = 3326118529,
        CTaskReactAimWeapon__Tunables__Ability__Situation = 2563725968,
        CTaskReactAimWeapon__Tunables__Ability__Situation__Weapon = 3972028972,
        CTaskShove__Tunables__Rendering = 838054604,
        CTaskSubmarineChase__Tunables = 4191322333,
        CTaskSubmarineCombat__Tunables = 3579412180,
        CTaskVariedAimPose__AimPose = 896772506,
        CTaskVariedAimPose__AimPose__Transition = 2263463390,
        CTaskVariedAimPose__AimPose__Transition__Flags = 966624441,
        CTaskVehicleBlockCruiseInFront__Tunables__Probes = 3985328803,
        CTaskVehicleBlockCruiseInFront__Tunables__Probes__Collision = 1883924946,
        CTaskVehicleBlockCruiseInFront__Tunables__Rendering = 999261493,
        CTaskVehicleChase__Tunables__AggressiveMove = 2082149421,
        CTaskVehicleChase__Tunables__Block = 45194904,
        CTaskVehicleChase__Tunables__Cheat = 3284002922,
        CTaskVehicleChase__Tunables__CloseDistance = 653343499,
        CTaskVehicleChase__Tunables__PullAlongside = 3309127383,
        CTaskVehicleChase__Tunables__Pursue = 2956630463,
        CTaskVehicleChase__Tunables__Ram = 533527745,
        CTaskVehicleChase__Tunables__SpinOut = 2379651736,
        CTaskVehicleDeadDriver__BrakeControl = 3374036042,
        CTaskVehicleDeadDriver__HandBrakeControl = 4001255574,
        CTaskVehicleDeadDriver__SteerAngleControl = 888350649,
        CTaskVehicleDeadDriver__ThrottleControl = 2055586340,
        CTaskVehicleHeliProtect__Tunables = 1585332545,
        CTaskVehiclePersuit__Tunables__ApproachTarget = 2385857407,
        CTaskVehiclePursue__Tunables__Drift = 42267357,
        CTemplate = 4278410690,
        CTemplateData = 397663940,
        CTextTemplateXML = 3853601141,
        CTrailerHandlingData = 2409026010,
        CTunableObjectEntry = 472929260,
        CTunableObjectManager = 1973018942,
        CTuning = 1455109553,
        CUTSCENESCENTRED = 1242774608,
        CVehGenMarkUpSpheres = 1808318708,
        CVehicleConditionEntryPointHasOpenableDoor = 688816786,
        CVehicleConditionRoofState = 52004049,
        CVehicleCoverBoundOffsetInfo = 231712129,
        CVehicleDamage__Tunables = 2163918664,
        CVehicleDriveByAnimInfo = 721969319,
        CVehicleDriveByInfo = 4196177967,
        CVehicleEntryPointAnimInfo = 3784525642,
        CVehicleEntryPointInfo = 282085008,
        CVehicleExplosionInfo = 1572648484,
        CVehicleExplosionLOD = 2463502837,
        CVehicleExtraPointsInfo = 2329533047,
        CVehicleKit__sSlotNameOverride = 427606548,
        CVehicleLayoutInfo = 3264072483,
        CVehicleLayoutInfo__eLayoutFlags = 1206674129,
        CVehicleLayoutInfo__sCellphoneClipsets = 2814163180,
        CVehicleLayoutInfo__sEntryPoint = 2049503406,
        CVehicleLayoutInfo__sSeat = 1275391043,
        CVehicleMetadataMgr = 4258649703,
        CVehicleModVisible__eVehicleModBone = 3635907608,
        CVehicleModelColorIndices = 2575850962,
        CVehicleModelInfoFlags__Flags = 1956151339,
        CVehicleModelInfoPlateTextureSet = 3027500557,
        CVehicleModelInfoPlates = 465922034,
        CVehicleModelInfo__CVehicleOverrideRagdollThreshold = 2354231744,
        CVehicleModelInfo__InitData = 2186332931,
        CVehicleModelInfo__InitDataList = 3519515122,
        CVehiclePopulationTuning = 2809170050,
        CVehicleScenarioLayoutInfo = 2750283957,
        CVehicleSeatAnimInfo = 4275431694,
        CVehicleSeatInfo = 4182532604,
        CVehicleSet = 1312455121,
        CVehicleVariationData = 418053801,
        CVehicleVariationGlobalData = 3062246906,
        CVehicleWeaponHandlingData = 3326485260,
        CVehicleWeaponHandlingData__sTurretPitchLimits = 1857365388,
        CVehicleWeaponInfo = 3488518232,
        CVfxExtraInfo = 1067473880,
        CVideoEditorErrorMessage = 963984800,
        CVideoEditorErrorMessages = 4282420847,
        CVideoEditorMenuArray = 2581105074,
        CVideoEditorMenuItem = 2911668481,
        CVideoEditorMenuItems = 4129774907,
        CVideoEditorPositioning = 3203596964,
        CVideoEditorPositions = 3127147534,
        CVideoSettings = 4180594066,
        CWantedResponse = 1529657824,
        CWanted__Tunables__CrimeInfo = 4115548472,
        CWanted__Tunables__Difficulty = 2685546187,
        CWanted__Tunables__Difficulty__Despawning = 1602748523,
        CWanted__Tunables__Difficulty__Dispatch = 3840146119,
        CWanted__Tunables__Difficulty__Peds = 3209293959,
        CWanted__Tunables__Difficulty__Peds__Attributes = 2022711333,
        CWanted__Tunables__Difficulty__Peds__Attributes__Situations = 1181208064,
        CWanted__Tunables__Difficulty__Peds__Attributes__Situations__Situation = 3795144262,
        CWanted__Tunables__Difficulty__Range = 2528332511,
        CWanted__Tunables__Difficulty__Spawning = 2145739988,
        CWanted__Tunables__Difficulty__Spawning__Scoring = 3801009121,
        CWanted__Tunables__Difficulty__Spawning__Scoring__Weights = 2379615087,
        CWanted__Tunables__Rendering = 1581603972,
        CWanted__Tunables__Timers = 4245193745,
        CWanted__Tunables__WantedLevel__Difficulty = 3660423994,
        CWanted__Tunables__WantedLevel__Difficulty__Calculation = 1037717481,
        CWanted__Tunables__WantedLevel__Difficulty__Calculation__Decay = 3442100148,
        CWanted__Tunables__WantedLevel__Difficulty__Calculation__Weights = 1310408174,
        CWanted__Tunables__WantedLevel__Difficulty__Helis = 3986648608,
        CWanted__Tunables__WantedLevel__Difficulty__Helis__Refuel = 2123007699,
        CWeaponAccuracyModifier = 1103362827,
        CWeaponActionResult = 321292939,
        CWeaponActionResultList = 3722084094,
        CWeaponAnimations = 1006973649,
        CWeaponAnimationsSet = 3834776756,
        CWeaponAnimationsSets = 2534868329,
        CWeaponBoneId = 2532248336,
        CWeaponComponentClipInfo = 1061299420,
        CWeaponComponentData = 1389998692,
        CWeaponComponentFlashLightInfo = 1678168506,
        CWeaponComponentGroupInfo = 389444997,
        CWeaponComponentInfo = 3853231241,
        CWeaponComponentInfoBlob = 374249497,
        CWeaponComponentLaserSightInfo = 1332400338,
        CWeaponComponentPoint = 1908380799,
        CWeaponComponentPoint__sComponent = 803666994,
        CWeaponComponentProgrammableTargetingInfo = 777803364,
        CWeaponComponentReloadData = 887214561,
        CWeaponComponentReloadLoopedData = 3056283030,
        CWeaponComponentScopeInfo = 2892313670,
        CWeaponComponentScopeInfo__SpecialScopeType = 2471242659,
        CWeaponComponentSuppressorInfo = 283333359,
        CWeaponComponentVariantModelInfo = 2701823762,
        CWeaponDamageModifier = 3243443179,
        CWeaponFallOffModifier = 117075958,
        CWeaponFiringPatternAliases = 2704113599,
        CWeaponFiringPatternAliases__CFiringPatternAlias = 1818499411,
        CWeaponInfo = 82511886,
        CWeaponInfoBlob = 3782356203,
        CWeaponInfoBlob__SlotEntry = 1255720682,
        CWeaponInfoBlob__sWeaponGroupArmouredGlassDamage = 2199702744,
        CWeaponInfoBlob__sWeaponSlotList = 3179909394,
        CWeaponInfoFlags__Flags = 3233194336,
        CWeaponInfo__sExplosion = 3798365785,
        CWeaponInfo__sFirstPersonScopeAttachmentData = 1666579112,
        CWeaponInfo__sFrontClearTestParams = 3548419392,
        CWeaponInfo__sFx = 1507429391,
        CWeaponModelInfo__InitData = 3647105837,
        CWeaponModelInfo__InitDataList = 3616603979,
        CWeaponSwapData = 258291195,
        CWeaponTintSpecValues = 3848490769,
        CWeaponTintSpecValues__CWeaponSpecValue = 4218236948,
        CWeaponUpperBodyFixupExpressionData = 2495887878,
        CWeaponUpperBodyFixupExpressionData__Data = 972996908,
        CWitnessInformation = 1339102571,
        CWitnessInformation__Flags = 1595124575,
        CWitnessInformations = 2152932187,
        CWitnessPersonality = 1334787441,
        CWitnessPersonality__Flags = 1576358260,
        CZonedAssets = 1094156997,
        CacheCatalogParsableInfo = 1590630569,
        CacheParsableInfo = 1833791348,
        CalmingQuad = 593191059,
        CalmingQuads = 3959992596,
        CameraAnimLeft = 4282412095,
        CameraAnimRight = 964860769,
        CameraFov = 118313611,
        CameraHash = 718736143,
        CameraMtx = 3187751929,
        CameraNameHash = 1810025730,
        CameraTarget = 83449887,
        CamoDiffuseTexIdxs = 3232579340,
        CanAlwaysSenseEncroachingPlayers = 2913189446,
        CanBeAimedLikeGunWithoutFiring = 877526218,
        CanBeDamaged = 3781664111,
        CanBeDestroyedByDamage = 2498233908,
        CanBeFiredLikeGun = 958162613,
        CanBePlaced = 3006942492,
        CanBeShoved = 766114274,
        CanBeTalkedTo = 2234608535,
        CanBlowUpVehicleAtZeroBodyHealth = 1810129372,
        CanBounce = 2977515014,
        CanCanter = 2472773206,
        CanDetachViaRagdoll = 4124898265,
        CanExitEarlyInCombat = 2919892387,
        CanFreeAim = 1318616200,
        CanInterrupt = 131732003,
        CanLockonInVehicle = 116614875,
        CanLockonOnFoot = 3395702705,
        CanMountBehind = 2980817048,
        CanMountFromInAir = 3319528567,
        CanPauseSoftLockTimer = 3708089905,
        CanPerformArrest = 3902995608,
        CanReverse = 1349231648,
        CanScreamDuringFlee = 2090744376,
        CanShove = 1736936438,
        CanSlide = 157419834,
        CanSprintInFollowLeaderSeekEntity = 415812526,
        CanTrackStand = 77675310,
        CanTrot = 641427370,
        CanUseInVehMelee = 804227875,
        CanWarpToDriverSeatIfNoDriver = 176072764,
        CanWitnessCrimes = 2061043750,
        CannotBeJacked = 2549135563,
        CannotBeUsedByCuffedPed = 722999533,
        CantBeReused = 3476027735,
        CapsuleLength = 4080036951,
        CarDensityForCurrentZone = 2780388990,
        CargenPriorityAreas = 2084826590,
        CargenPriorityAreas__Area = 929440014,
        CarriedInHand = 2453458098,
        CatchUpFov = 853678953,
        CatchUpOrientation = 3827317456,
        CatchUpPosition = 1341938216,
        Categories = 1043838514,
        CeilingZ = 1603832352,
        CellphoneClipsetDS = 1041158628,
        CellphoneClipsetDS_FPS = 2379982362,
        CellphoneClipsetPS = 1186874378,
        CellphoneClipsetPS_FPS = 3131844978,
        CellphoneClipsets = 3758493357,
        Center = 2195506502,
        CenterOffset = 3352507320,
        CentreFieldOfGazeMaxAngle = 2945102124,
        CentroidOffsetXYZMaterialId0W = 3776303401,
        Chance = 3794360293,
        ChanceOfRunningTowards = 632917193,
        ChanceOfSpawningWithAnything = 3868674001,
        ChanceToUseCasualAvoidAgainstRunningPed = 1651660816,
        Chance_SourceFriend = 547194127,
        Chance_SourceOther = 1595880702,
        Chance_SourcePlayer = 2616251660,
        Chance_SourceThreat = 49405843,
        ChancesToBeCasual = 4246045187,
        ChancesToReactToRunningPedsBehindUs = 3689187240,
        ChangeToSafeTypeOnResume = 2864970982,
        CharacterId = 3591126827,
        ChargedLaunchSpeedMult = 1014203292,
        ChargedLaunchTime = 759963485,
        CheckAnimTime = 688790761,
        CheckCrossedArrivalPlane = 3304563391,
        ChildEvents = 2536187449,
        ChooseTurretSeatWhenOnGround = 1405627810,
        CinematicShootingAlternativeOrScopedCameraHash = 3973186554,
        CinematicShootingCameraHash = 3508565377,
        CityDensity = 1844614627,
        ClearHostility = 406394893,
        ClimbUpAfterOpenDoor = 2221816622,
        ClimbUpOnly = 1880967367,
        ClipRate = 2841854998,
        ClipSetForIntroV1 = 3696584734,
        ClipSetForIntroV2 = 4027846555,
        ClipSetForRunsV1 = 3482724306,
        ClipSetForRunsV2 = 551602790,
        ClipSetHash = 4160387967,
        ClipSetMaps = 1368294466,
        ClipSize = 1381725255,
        ClipUserData = 1494374252,
        ClonePedBumpedByCarActivationModifier = 2048881690,
        ClothDisplayMap = 717851063,
        ClothSetID = 2948679477,
        Cloud = 665215196,
        CloudAmbientColor = 3283561472,
        CloudBounceColor = 2204630080,
        CloudBurstCommonSettings = 2963090331,
        CloudBurstSettings = 3074626268,
        CloudColor = 441120091,
        CloudDensityShift_Scale_ScatteringConst_Scale = 3682079196,
        CloudEastColor = 684486182,
        CloudHatFragContainer = 576365935,
        CloudHatFragLayer = 1636413744,
        CloudHatManager = 67448120,
        CloudHatSettings = 2324404773,
        CloudLightColor = 3137279611,
        CloudLightDeltaPos = 545924745,
        CloudLightFallOffExponent = 2103228870,
        CloudLightIntensityMult = 999646035,
        CloudLightRadius = 2088451865,
        CloudList = 1235427873,
        CloudListController = 1399211432,
        CloudPiercingLightPower_Strength_NormalStrength_Thickness = 3711022754,
        CloudScaleDiffuseFillAmbient_WrapAmount = 316718287,
        CloudScaleFillColors = 234916634,
        CloudSettingsMap = 4127188341,
        CloudSettingsName = 2222873655,
        CloudSkyColor = 544421657,
        CloudWestColor = 1508150642,
        Cluster = 2703969485,
        ClusterExplosionCount = 2314074977,
        ClusterExplosionTag = 3075911797,
        ClusterInbetweenDelay = 3488893887,
        ClusterInitialDelay = 2004950200,
        ClusterMaxRadius = 4132668335,
        ClusterMinRadius = 4061715285,
        CockGunClip0Id = 3610728325,
        CockGunClip1Id = 1018316975,
        CollectableInBoat = 3713864913,
        CollectableInCar = 662522821,
        CollectableInCarByPassengers = 4225821273,
        CollectableInPlane = 814447413,
        CollectableOnFoot = 4166764483,
        CollectableOnShot = 3098696975,
        CollectablesPickedUp = 1406323973,
        CollectionRadius = 3874149112,
        CollectionRadiusFirstPerson = 1977620988,
        CollisionDamageMaxThreshold = 4171936526,
        CollisionDamageMinThreshold = 3187378178,
        CollisionDamageScale = 2544372820,
        CollisionReflectedTargetPosition = 1537468920,
        CollisionReflectionDirection = 2932215080,
        ColourCombination = 3102508599,
        CombatAbility = 1587184111,
        CombatEntryPickUpPullUpRate = 509809270,
        CombatInfos = 1898310292,
        CombatJackEntry = 1360735141,
        CombatMovement = 1988612850,
        CombatReactionOverrideClipSetHash = 3401818708,
        CommonClipSetMap = 125119849,
        Comparison = 509593339,
        CompatibilityPacks = 3685140444,
        ComponentDescription = 2221740848,
        ComponentDrawables = 1931014018,
        ComponentID = 3838847656,
        ComponentModel = 2839979765,
        ComponentName = 942641821,
        ComponentNames = 522835353,
        ComponentTargetID = 633075426,
        ComponentTextures = 1477511174,
        ComponentVariations = 3613884743,
        Components = 406520256,
        CompressionWeight = 313922453,
        CondPedOther = 1658547752,
        Condition = 2260981766,
        ConditionFlags = 722562221,
        ConditionalAction = 2250405124,
        ConditionalActions = 2285940311,
        ConditionalAnims = 1642464922,
        ConditionalAnimsGroup = 3859646453,
        ConditionalExchanges = 1656068125,
        ConditionalSay = 28908747,
        ConditionalSays = 4138873227,
        ConditionalVehicleSets = 2782406880,
        Conditions = 2480115161,
        Config = 3024267270,
        Config2dEffects = 4029960601,
        ConfigArray = 3700541532,
        ConfigBool = 3931319565,
        ConfigExtensions = 1963960164,
        ConfigFlags = 2003126379,
        ConfigMediaTranscoding = 19768805,
        ConfigModelInfo = 167372961,
        ConfigNetScriptBroadcastData = 2212206253,
        ConfigOnlineServices = 964628221,
        ConfigPopulation = 2811672756,
        ConfigScriptResourceExpectedMaximums = 2686852687,
        ConfigScriptStackSizes = 4290680255,
        ConfigScriptTextLines = 3289615104,
        ConfigStreamingEngine = 2737507933,
        ConfigThreadPriority = 1332727661,
        ConfigUGCDescriptions = 828863907,
        ConflictExceptions = 1884073740,
        ConflictList = 2414639136,
        ConsiderAsInWaterInLowLodPhysics = 3161697105,
        ConsiderOrientation = 3317837716,
        Content = 238098365,
        ContentChangeSetGroup = 3845248862,
        ContentChangeSets = 3544879917,
        ContextDuration = 3819582671,
        ContextMenu = 1228407611,
        ContextMenuId = 176531315,
        ContextMenuOptions = 3769532820,
        ContextViewModeMap = 1278229754,
        Contexts = 505469409,
        ContinuousGapHighFallSpeed = 1694135928,
        ControlFlags = 738502804,
        ControlPoints = 438343221,
        ControlSettings = 2864423936,
        Convergence = 1723761198,
        CookWhileAiming = 2809884192,
        Cooldown = 2006342327,
        CoorX = 3694422059,
        CoorY = 1566763666,
        CoorZ = 1218560272,
        CoreMotionFPSClipSetId = 1642317087,
        CoreWeaponAimingClipSetId = 3902347552,
        CoreWeaponAimingFPSClipSetId = 2620277506,
        CoronaIntensity = 4127572493,
        CoronaIntensityMult = 26542422,
        CoronaSize = 1910482057,
        CoronaZBias = 192614110,
        CounterProbabilityMax = 1700530218,
        CounterProbabilityMin = 2845865506,
        CoverAlternateMovementClipSetHash = 128128023,
        CoverBoundInfos = 3733022744,
        CoverCameraHash = 3573783063,
        CoverDirectionOffsetForInCoverTarget = 1109599945,
        CoverLeftFireModifierCloseToEdge = 2625425324,
        CoverMovementClipSetHash = 3031319999,
        CoverMovementExtraClipSetHash = 39197948,
        CoverReadyToFireCameraHash = 3796106419,
        CoverWeaponClipSetHash = 4153429480,
        CoverageType = 250202879,
        CpuAffinity = 2470966486,
        CrackType = 2829183216,
        CreateBulletExplosionWhenOutOfTime = 901516985,
        CreateObject = 3337387549,
        CreateVisibleOrdnance = 3119679213,
        CreateWeaponWithNoModel = 331862070,
        CreatesAPotentialExplosionEventWhenFired = 4167056514,
        CrimeInformations = 733844154,
        CrouchedCapsuleOffsetZ = 829852762,
        CruiseGearClipSpeeds = 1794962103,
        CruiseSpeedTooManyNearbyEntities = 1208093369,
        CurrentMatrices = 3923615715,
        CurrentProps = 3075220599,
        CustomEdgeData = 1739385202,
        CustomShuffleBeJackedClipId = 1495472466,
        CustomShuffleBeJackedDeadClipId = 1345368814,
        CustomShuffleJackClipId = 536807372,
        CustomShuffleJackDeadClipId = 1857752806,
        CustomShuffleJackDead_180ClipId = 298521545,
        CustomShuffleJack_180ClipId = 3045129247,
        CutoffPixels = 2884060215,
        CutsceneLODDistanceScale = 2205537343,
        CycleName = 745669489,
        CylinderInfoSets = 1094772489,
        DA_AI_ENTRY_ACTION = 3628068277,
        DA_ALLOW_IN_WATER = 4258736646,
        DA_DISABLE_IN_FIRST_PERSON = 525198465,
        DA_IS_ENABLED = 2861541108,
        DA_PLAYER_ENTRY_ACTION = 460689421,
        DA_PREFER_BODY_IK_RESULT = 2254427862,
        DA_PREFER_RAGDOLL_RESULT = 2446377259,
        DA_REQUIRE_NO_TARGET = 3527920777,
        DA_REQUIRE_NO_TARGET_LOCK_ON = 908172144,
        DA_REQUIRE_TARGET = 1394425597,
        DA_REQUIRE_TARGET_LOCK_ON = 979496510,
        DD_ANY = 2311328542,
        DD_BACKWARD_LEFT = 4145649713,
        DD_BACKWARD_RIGHT = 3087499504,
        DD_FORWARD = 4021807208,
        DD_LEFT = 1463977926,
        DD_RIGHT = 3990909168,
        DEER = 1671125237,
        DEER_ON_FOOT = 1756004639,
        DELAYED_HIT = 2744166261,
        DELIVERY_DRIVER = 2714685706,
        DEPRECATED_MAPPER = 2628051544,
        DIR_FLAME = 3104008017,
        DIR_GAS_CANISTER = 2595012252,
        DIR_STEAM = 2142446780,
        DIR_WATER_HYDRANT = 1448622972,
        DOG = 3604676829,
        DONTCARE = 1630927272,
        DO_NOTHING = 743973546,
        DPAD_ALL = 1474493779,
        DPAD_DOWN = 3786156837,
        DPAD_LEFT = 1952661223,
        DPAD_LEFTRIGHT = 3288250455,
        DPAD_NONE = 3781037212,
        DPAD_RIGHT = 974629070,
        DPAD_UP = 2449991244,
        DPAD_UPDOWN = 1981742144,
        DRA_ADD_SMALL_ABILITY_CHARGE = 2981163965,
        DRA_DISABLE_INJURED_GROUND_BEHAVIOR = 2969927695,
        DRA_DONT_DAMAGE_PEDS = 1263743974,
        DRA_DROP_WEAPON = 1871607900,
        DRA_FATAL_HEAD_SHOT = 445197922,
        DRA_FATAL_SHOT = 2686665351,
        DRA_FORCE_IMMEDIATE_REACTION = 2585317258,
        DRA_IGNORE_ARMOR = 3315928775,
        DRA_IGNORE_STAT_MODIFIERS = 184975235,
        DRA_INVOKE_FACIAL_PAIN_ANIMATION = 2623272803,
        DRA_KNOCK_OFF_PROPS = 3695494818,
        DRA_MOVE_LOWER_ARM_AND_HAND_HITS_TO_CLAVICLE = 2317774468,
        DRA_PRESERVE_STEALTH_MODE = 2097857518,
        DRA_STOP_TARGET_DISTANCE_HOMING = 3214495288,
        DRA_USE_DEFAULT_UNARMED_WEAPON = 1454321491,
        DRIVER_SEAT_RELATIVE = 459030377,
        DRIVE_TYPE_NONE = 3630286959,
        DRIVE_TYPE_RAIN = 2479298674,
        DRIVE_TYPE_REGION = 3587183720,
        DRIVE_TYPE_SNOW = 3175922581,
        DRIVE_TYPE_UNDERWATER = 3378552556,
        DROWN = 3403707840,
        DT_AmbulanceDepartment = 1515089942,
        DT_ArmyVehicle = 3752366593,
        DT_Assassins = 2422789234,
        DT_BikerBackup = 1167346168,
        DT_FireDepartment = 1659227261,
        DT_Gangs = 1405160431,
        DT_Invalid = 33246701,
        DT_Max = 1048182399,
        DT_PoliceAutomobile = 2480603590,
        DT_PoliceAutomobileWaitCruising = 2476971860,
        DT_PoliceAutomobileWaitPulledOver = 405619910,
        DT_PoliceBoat = 974492150,
        DT_PoliceHelicopter = 1699748362,
        DT_PoliceRiders = 3706284404,
        DT_PoliceRoadBlock = 712407947,
        DT_PoliceVehicleRequest = 1978472651,
        DT_SwatAutomobile = 1765108225,
        DT_SwatHelicopter = 2515739946,
        DX_Version = 2872300311,
        DYNAMIC_MAPPING_MOUSE_X = 4062893593,
        DYNAMIC_MAPPING_MOUSE_Y = 10056438,
        Damage = 2293866356,
        DamageAndReaction = 4188380341,
        DamageCausesDisputes = 334720378,
        DamageComponent = 3740365919,
        DamageDecalData = 222804945,
        DamageFallOffModifier = 866828484,
        DamageFallOffRangeMax = 318815217,
        DamageFallOffRangeMin = 1973132721,
        DamageHealth = 3771813898,
        DamageModifier = 3625213741,
        DamageName = 3083451727,
        DamagePacks = 2625737634,
        DamageReactionAttrs = 2253056237,
        DamageTime = 1678432257,
        DamageTimeInVehicle = 2672087117,
        DamageTimeInVehicleHeadShot = 3029340530,
        DamageType = 4154903711,
        DampenRecoil = 1079514317,
        Damping = 2078229548,
        DangerousLookingMeleeWeapon = 1609637212,
        DarkGlowIntensity = 2602211138,
        Data = 3021077118,
        DataHigh = 718848909,
        DataLeft = 221887005,
        DataLow = 2203793936,
        DataRight = 2600044476,
        DayCoCHours = 619896503,
        DeadJackIncludesGetIn = 2138935416,
        DeathShakeRef = 3075522471,
        Debug = 4196472043,
        DebugScriptsPath = 1904453131,
        Decision = 2492399123,
        DecisionMakerParentRef = 2455656627,
        DecorationList = 603148471,
        DeepOceanScale = 1204462316,
        DeepWaterModDepth = 3967555953,
        DeepWaterModFade = 3893053853,
        DefaultArmour = 994517567,
        DefaultBeJackedAlivePedFromOutsideAltClipId = 2529144140,
        DefaultBeJackedDeadPedFromOutsideAltClipId = 3459414413,
        DefaultButtonList = 3900115058,
        DefaultCameraHash = 578048331,
        DefaultCarTask = 511401048,
        DefaultClimbDownWaterClipId = 115688447,
        DefaultHealth = 1639751964,
        DefaultJackAlivePedFromOutsideAltClipId = 3431653792,
        DefaultJackDeadPedFromOutsideAltClipId = 1983954745,
        DefaultMaxSlopeNavigable = 3265426268,
        DefaultMoveFollowLeaderRunDistance = 4023463890,
        DefaultMoveFollowLeaderSprintDistance = 3218222159,
        DefaultSet = 2466746417,
        DefaultShuntToIdleBlendDuration = 3645563068,
        DefaultTakeoffBlendoutPhase = 2759154614,
        DefaultTargetDistanceWeightMeleeFPS = 2485794835,
        DefaultTargetDistanceWeightMeleeRunningFPS = 2082223604,
        DefaultTargetHeadingWeightMeleeFPS = 3532059041,
        DefaultTargetHeadingWeightMeleeRunningFPS = 1974328161,
        DefaultTaskType = 1251374703,
        DeferFallBlockTestAngle = 3844027585,
        DeferFallBlockTestDistance = 3197570465,
        DeferFallBlockTestRadius = 391736247,
        DeferHighFallTime = 2495576534,
        DefinitionAttrs = 2979301414,
        Definitions = 3483415720,
        DeformableBones = 828985416,
        DeformableObjects = 3224821362,
        DelayMax = 4163680701,
        DelayMin = 284221956,
        DelayMovementDuration = 3062906436,
        DelayTimeMs = 222832116,
        DelayUntilSettled = 2647905685,
        DelayedFiringAfterAutoSwap = 3242376304,
        DelayedFiringAfterAutoSwapPreviousWeapon = 2944446945,
        Delta1X = 955824271,
        Delta1Y = 739385026,
        Delta2X = 4132385941,
        Delta2Y = 3826749478,
        DeltaHeadingDirectionChange = 2540703340,
        DeltaHeadingTurnThreshold = 3512769803,
        DeltaLimits = 1080885234,
        DensityBasedRemovalRateScale = 4292534602,
        DensityBasedRemovalRateScale_Base = 4144293488,
        DensityBasedRemovalTargetHeadroom = 982809584,
        DensityBasedRemovalTargetHeadroom_Base = 1338964715,
        DependentAction = 3792766896,
        DependentAmbientFriend = 3388934279,
        DeployShakeRef = 2028447415,
        DepthWeightPower = 336334250,
        Description = 711683582,
        DesiredDirection = 3674143525,
        DesiredMbrLowerBoundInMoveFollowLeader = 2295151866,
        DesiredSitRateMult = 3214018147,
        DesiredStandingInAirRateMult = 1449479649,
        DesiredStandingRateMult = 3074326111,
        DespawnOnUse = 1042758918,
        DestKey = 4103548643,
        DestroyOnImpact = 3308826994,
        DestroyPropInsteadOfDrop = 2713027071,
        Detonator = 2545188707,
        DeviationDecay = 3621840112,
        DeviationForwardMax = 3810218573,
        DeviationForwardMin = 1068003454,
        DeviationRightVariance = 292521259,
        Devices = 3700213786,
        DidNotTalkToTargetLast = 1704321241,
        DiesInstantlyToFire = 1274293812,
        DiesInstantlyToMelee = 1976227349,
        DiesOnEnteringRagdoll = 2250642666,
        DiffuseTextureName = 3177511561,
        Dim = 1310250255,
        DirectionalBurstSettings = 3257891168,
        DisableAbnormalExits = 3745015552,
        DisableAgitation = 1282593235,
        DisableAimAngleChecksForReticule = 186077889,
        DisableBraceForImpact = 3710356331,
        DisableCameraPullAround = 1826062115,
        DisableCombatRoll = 4012332828,
        DisableCover = 855764460,
        DisableCower = 1586044357,
        DisableCrouch = 188051152,
        DisableEvasiveStep = 3482147127,
        DisableFPSAimForScope = 780239069,
        DisableFPSScope = 1332620901,
        DisableFastPoseWhenDrivebying = 25406600,
        DisableFinerAlignTolerance = 1397257030,
        DisableHandsUp = 2840809124,
        DisableIdleAnimationFilter = 3473341781,
        DisableIdleAnimationFilterWhenReloading = 1916030022,
        DisableIdleVariations = 2417854563,
        DisableJacking = 3369724445,
        DisableJackingAndBusting = 2982392572,
        DisableLeftHandIkInCover = 3599104206,
        DisableLeftHandIkInDriveby = 2263318679,
        DisableLeftHandIkWhenOnFoot = 1203324692,
        DisableMeleeIntroAnimation = 2781259819,
        DisableNonStandardDamageTypes = 1387417483,
        DisablePlayerBlockingInMP = 3831332682,
        DisablePotentialBlastResponse = 728919475,
        DisablePotentialToBeWalkedIntoResponse = 2863591032,
        DisableReactAndFleeAnimation = 2590520581,
        DisableRightHandIk = 3377614732,
        DisableStealth = 3668072723,
        DisableTargetRearDoorOpenRatio = 1559208784,
        DisableTorsoIKAboveAngleThreshold = 972361478,
        DisableUseScenariosWithNoModelSet = 1802098686,
        DisableVehicleExit = 2640753637,
        DisableVehicleUsage = 1906732829,
        DisableWallHitAnimation = 2049914727,
        DisableWhenAgitated = 1816090255,
        DisableWhenFriendlyIsAgitated = 606022547,
        DisableWhenStill = 264341997,
        DisableWhenTrailerAttached = 1229142576,
        DiscardWhenOutOfAmmo = 1032204068,
        DispatchOrderDistances = 1231655231,
        DispatchServices = 1040018117,
        DispatchType = 3254482139,
        DispatchVehicleSets = 2105902464,
        DisplayAimAssistTest = 2235947157,
        DisplayRechargeTimeHUD = 4232416389,
        DisplayText = 4076056242,
        DisplayValues = 2919234518,
        DistDriven = 1053812154,
        DistanceMaxSq = 2616041762,
        DistanceMinSq = 187665630,
        DistanceThreshold = 2871491030,
        DistanceToConsiderCloseEntitiesTarget = 4019091857,
        DistanceToConsiderEntityBlocking = 2510151940,
        DistantGroundVehicleSpawn = 270352145,
        DisturbFoamScale = 3226971377,
        DisturbFxDefault = 1205402126,
        DisturbFxDirt = 2285808541,
        DisturbFxFoliage = 1251305733,
        DisturbFxProbeDist = 1593939783,
        DisturbFxSand = 1505576055,
        DisturbFxScale = 12849552,
        DisturbFxWater = 4173273862,
        DjSoloHistorySpace = 230756008,
        DjSoloHistoryWriteIndex = 4175010013,
        DjSpeechHistory = 2957808621,
        DjSpeechHistoryWriteIndex = 3526681585,
        DoF = 844171620,
        DoGroundDisturbanceFx = 461257548,
        DoSimpleBlendoutForEvents = 2543564501,
        DoesNotGetTired = 1834379285,
        DoesRevivableDamage = 2608024670,
        DoesntCollideWithPeds = 3316824230,
        DoesntCollideWithRagdolls = 3254219484,
        DoesntCollideWithVehicles = 958396996,
        DofStrengthModifier = 2421020028,
        DogTakedownThreshold = 2352657544,
        DontActivatePhysicsOnRelease = 1918378909,
        DontActivateRagdollForCollisionWithPlayerBumpImpact = 2696526659,
        DontAdjustStationaryReactionStatus = 87730337,
        DontAutoSwapOnPickUp = 1260237947,
        DontBlendFireOutro = 2727059720,
        DontBreakRopes = 2935104643,
        DontClearFlags = 1173375455,
        DontClearSay = 3493886364,
        DontCloseDoorInside = 2304656723,
        DontCloseDoorOutside = 3318701721,
        DontDetachOnWorldCollision = 2708676113,
        DontFireAnyEvents = 3612726030,
        DontInfluenceWantedLevel = 3578321756,
        DontPickOnEnter = 1503891940,
        DontPlayDryFireAnim = 3831822112,
        DontReset = 267699472,
        DontSpawnIfCopsAreOff = 4039470094,
        DontSpawnIfUnderStreamingPressure = 3224977106,
        DontSpawnInRain = 1710386011,
        DontSwapWeaponIfNoAmmo = 2437516310,
        DontTimeoutUntilBaseFinishes = 2990716281,
        DontTimeoutUntilIdleFinishes = 3811288224,
        DoorBoneName = 3460562478,
        DoorHandleBoneName = 933579285,
        Dot = 112767592,
        DoubleDamping = 470408540,
        DrawableID = 3133733294,
        DriveByAnimInfos = 2139431394,
        DriveByCamera = 2654346704,
        DriveByClipSet = 4067075899,
        DriveByFlags = 1140452041,
        DriveByInfo = 178555478,
        DriveByMPOnly = 3425411272,
        DriveByToDuckBlendDuration = 3474960988,
        DrivebyWeaponGroups = 3526808035,
        DropForwardVelocity = 1383582083,
        DropSettingName = 1948377459,
        DropWhenCooked = 2926729235,
        DuckBikeSteerThreshold = 2044390676,
        DuckControlThreshold = 2713284751,
        DuckShuffleBlendDuration = 2067860370,
        DuckedClipSet = 310049931,
        DurationMax = 4002678431,
        DurationMin = 3792793301,
        DyingHealthThreshold = 1209766467,
        DynamicMappings = 3262597186,
        ELECTRIC = 1468008931,
        ELK = 3684224986,
        ENTER_VEHICLE_STD = 3707927710,
        ENTITY_RELATIVE = 3517692388,
        EVENT_ACQUAINTANCE_PED_DEAD = 1818974467,
        EVENT_ACQUAINTANCE_PED_DISLIKE = 3521920378,
        EVENT_ACQUAINTANCE_PED_HATE = 3952268511,
        EVENT_ACQUAINTANCE_PED_LIKE = 312602065,
        EVENT_ACQUAINTANCE_PED_RESPECT = 1092538992,
        EVENT_ACQUAINTANCE_PED_WANTED = 690960375,
        EVENT_AGITATED = 1294580708,
        EVENT_AGITATED_ACTION = 947969233,
        EVENT_CALL_FOR_COVER = 2180131666,
        EVENT_CAR_UNDRIVEABLE = 1623953312,
        EVENT_CLIMB_LADDER_ON_ROUTE = 2195828632,
        EVENT_CLIMB_NAVMESH_ON_ROUTE = 1003737794,
        EVENT_CLOUD_FILE_RESPONSE = 1588626155,
        EVENT_COMBAT_TAUNT = 4071642353,
        EVENT_COMMUNICATE_EVENT = 3502826565,
        EVENT_COP_CAR_BEING_STOLEN = 3971781566,
        EVENT_CRIME_CRY_FOR_HELP = 403992222,
        EVENT_CRIME_REPORTED = 288114386,
        EVENT_DAMAGE = 2323728598,
        EVENT_DEAD_PED_FOUND = 863261034,
        EVENT_DEATH = 2980276608,
        EVENT_DISTURBANCE = 823547181,
        EVENT_DRAGGED_OUT_CAR = 2196975557,
        EVENT_DUMMY_CONVERSION = 1234887899,
        EVENT_ENCROACHING_PED = 1779540722,
        EVENT_ENTITY_DAMAGED = 2402775041,
        EVENT_ENTITY_DESTROYED = 2703724315,
        EVENT_ERRORS_ARRAY_OVERFLOW = 2382838478,
        EVENT_ERRORS_INSTRUCTION_LIMIT = 2786595355,
        EVENT_ERRORS_STACK_OVERFLOW = 580690220,
        EVENT_ERRORS_UNKNOWN_ERROR = 2807802044,
        EVENT_EXPLOSION = 2308210835,
        EVENT_EXPLOSION_HEARD = 3429615887,
        EVENT_FIRE_NEARBY = 737023703,
        EVENT_FLUSH_TASKS = 2137614471,
        EVENT_FOOT_STEP_HEARD = 2979991082,
        EVENT_FRIENDLY_AIMED_AT = 471379808,
        EVENT_FRIENDLY_FIRE_NEAR_MISS = 1085109342,
        EVENT_GET_OUT_OF_WATER = 1724371685,
        EVENT_GIVE_PED_TASK = 2382406030,
        EVENT_GUN_AIMED_AT = 1019012771,
        EVENT_HELP_AMBIENT_FRIEND = 3946910818,
        EVENT_HURT_TRANSITION = 927195651,
        EVENT_INCAPACITATED = 1619720960,
        EVENT_INJURED_CRY_FOR_HELP = 4080743193,
        EVENT_INVALID = 912218761,
        EVENT_IN_AIR = 3083823945,
        EVENT_IN_WATER = 596135196,
        EVENT_LEADER_ENTERED_CAR_AS_DRIVER = 2876269706,
        EVENT_LEADER_ENTERED_COVER = 424979973,
        EVENT_LEADER_EXITED_CAR_AS_DRIVER = 4176863693,
        EVENT_LEADER_HOLSTERED_WEAPON = 2349694081,
        EVENT_LEADER_LEFT_COVER = 4003813659,
        EVENT_LEADER_UNHOLSTERED_WEAPON = 2128686379,
        EVENT_MELEE_ACTION = 3012876619,
        EVENT_MUST_LEAVE_BOAT = 744001909,
        EVENT_NETWORK_APP_LAUNCHED = 3330398853,
        EVENT_NETWORK_CHEAT_TRIGGERED = 3206883356,
        EVENT_NETWORK_CLOUD_EVENT = 68234329,
        EVENT_NETWORK_DAMAGE_ENTITY = 2402048437,
        EVENT_NETWORK_HOST_MIGRATION = 685233611,
        EVENT_NETWORK_INCREMENT_STAT = 2656097259,
        EVENT_NETWORK_NETWORK_BAIL = 1363747103,
        EVENT_NETWORK_PED_LEFT_BEHIND = 3915565817,
        EVENT_NETWORK_PICKUP_RESPAWNED = 3420002464,
        EVENT_NETWORK_PLAYER_ARREST = 429995347,
        EVENT_NETWORK_PRESENCE_EMAIL = 2390260809,
        EVENT_NETWORK_PRESENCE_STAT_UPDATE = 2951946585,
        EVENT_NETWORK_PRESENCE_TRIGGER = 4156868,
        EVENT_NETWORK_REQUEST_DELAY = 4078848554,
        EVENT_NETWORK_SCRIPT_EVENT = 1131185341,
        EVENT_NETWORK_SESSION_EVENT = 247430792,
        EVENT_NETWORK_SPECTATE_LOCAL = 100577647,
        EVENT_NEW_TASK = 1244445543,
        EVENT_NONE = 3520254231,
        EVENT_OBJECT_COLLISION = 3150679591,
        EVENT_ON_FIRE = 3187729830,
        EVENT_OPEN_DOOR = 2753031663,
        EVENT_PED_COLLISION_WITH_PED = 3393944649,
        EVENT_PED_COLLISION_WITH_PLAYER = 545405234,
        EVENT_PED_ENTERED_MY_VEHICLE = 2277675656,
        EVENT_PED_JACKING_MY_VEHICLE = 3299213183,
        EVENT_PED_ON_CAR_ROOF = 3075049917,
        EVENT_PED_SEEN_DEAD_PED = 2779797362,
        EVENT_PED_TO_CHASE = 33044613,
        EVENT_PED_TO_FLEE = 1018398291,
        EVENT_PLAYER_COLLISION_WITH_PED = 3653950866,
        EVENT_PLAYER_DEATH = 3662980510,
        EVENT_PLAYER_UNABLE_TO_ENTER_VEHICLE = 23144070,
        EVENT_POTENTIAL_BE_WALKED_INTO = 3925998613,
        EVENT_POTENTIAL_BLAST = 2054741430,
        EVENT_POTENTIAL_GET_RUN_OVER = 2792376985,
        EVENT_POTENTIAL_WALK_INTO_FIRE = 921583873,
        EVENT_POTENTIAL_WALK_INTO_OBJECT = 2033695785,
        EVENT_POTENTIAL_WALK_INTO_VEHICLE = 3124526694,
        EVENT_PROVIDING_COVER = 846929147,
        EVENT_RADIO_TARGET_POSITION = 336611872,
        EVENT_RAN_OVER_PED = 738307608,
        EVENT_REACTION_ENEMY_PED = 4020212332,
        EVENT_REACTION_INVESTIGATE_DEAD_PED = 587527474,
        EVENT_REACTION_INVESTIGATE_THREAT = 912888054,
        EVENT_REQUEST_HELP_WITH_CONFRONTATION = 375708703,
        EVENT_RESPONDED_TO_THREAT = 3849285395,
        EVENT_REVIVED = 2273064476,
        EVENT_SCENARIO_FORCE_ACTION = 1853926609,
        EVENT_SCRIPT_COMMAND = 1098684840,
        EVENT_SHOCKING_BICYCLE_CRASH = 573962143,
        EVENT_SHOCKING_BICYCLE_ON_PAVEMENT = 442019013,
        EVENT_SHOCKING_BROKEN_GLASS = 1086464713,
        EVENT_SHOCKING_CAR_ALARM = 4204055724,
        EVENT_SHOCKING_CAR_CHASE = 3046768693,
        EVENT_SHOCKING_CAR_CRASH = 313007658,
        EVENT_SHOCKING_CAR_ON_CAR = 898978587,
        EVENT_SHOCKING_CAR_PILE_UP = 3784416669,
        EVENT_SHOCKING_DANGEROUS_ANIMAL = 1466939242,
        EVENT_SHOCKING_DEAD_BODY = 4190381652,
        EVENT_SHOCKING_DRIVING_ON_PAVEMENT = 626113993,
        EVENT_SHOCKING_ENGINE_REVVED = 209536923,
        EVENT_SHOCKING_EXPLOSION = 3502286288,
        EVENT_SHOCKING_FIRE = 1464626131,
        EVENT_SHOCKING_GUNSHOT_FIRED = 4114140858,
        EVENT_SHOCKING_GUN_FIGHT = 3422389638,
        EVENT_SHOCKING_HELICOPTER_OVERHEAD = 2470279476,
        EVENT_SHOCKING_HORN_SOUNDED = 3278108000,
        EVENT_SHOCKING_INJURED_PED = 2034012429,
        EVENT_SHOCKING_IN_DANGEROUS_VEHICLE = 169792556,
        EVENT_SHOCKING_MAD_DRIVER = 1198071041,
        EVENT_SHOCKING_MAD_DRIVER_BICYCLE = 419019505,
        EVENT_SHOCKING_MAD_DRIVER_EXTREME = 2361058288,
        EVENT_SHOCKING_MUGGING = 2732211379,
        EVENT_SHOCKING_NON_VIOLENT_WEAPON_AIMED_AT = 3004121545,
        EVENT_SHOCKING_PARACHUTER_OVERHEAD = 2873965806,
        EVENT_SHOCKING_PED_KNOCKED_INTO_BY_PLAYER = 3342345991,
        EVENT_SHOCKING_PED_RUN_OVER = 2851247060,
        EVENT_SHOCKING_PED_SHOT = 1015226677,
        EVENT_SHOCKING_PLANE_FLY_BY = 4254596782,
        EVENT_SHOCKING_POTENTIAL_BLAST = 2093121613,
        EVENT_SHOCKING_PROPERTY_DAMAGE = 4070428775,
        EVENT_SHOCKING_RUNNING_PED = 2032747827,
        EVENT_SHOCKING_RUNNING_STAMPEDE = 2331080968,
        EVENT_SHOCKING_SEEN_CAR_STOLEN = 3142466007,
        EVENT_SHOCKING_SEEN_CONFRONTATION = 4273631171,
        EVENT_SHOCKING_SEEN_GANG_FIGHT = 662167552,
        EVENT_SHOCKING_SEEN_INSULT = 3954725761,
        EVENT_SHOCKING_SEEN_MELEE_ACTION = 4067606417,
        EVENT_SHOCKING_SEEN_NICE_CAR = 2040908877,
        EVENT_SHOCKING_SEEN_PED_KILLED = 2884446926,
        EVENT_SHOCKING_SEEN_VEHICLE_TOWED = 2137069643,
        EVENT_SHOCKING_SEEN_WEAPON_THREAT = 3835787417,
        EVENT_SHOCKING_SEEN_WEIRD_PED = 1367878669,
        EVENT_SHOCKING_SEEN_WEIRD_PED_APPROACHING = 980194618,
        EVENT_SHOCKING_SIREN = 2318214189,
        EVENT_SHOCKING_STUDIO_BOMB = 3685898526,
        EVENT_SHOCKING_VISIBLE_WEAPON = 210371703,
        EVENT_SHOT_FIRED = 2315236420,
        EVENT_SHOT_FIRED_BULLET_IMPACT = 2833489762,
        EVENT_SHOT_FIRED_WHIZZED_BY = 86053334,
        EVENT_SHOUT_BLOCKING_LOS = 4229355638,
        EVENT_SHOUT_TARGET_POSITION = 1307525517,
        EVENT_SHOVE_PED = 506429998,
        EVENT_STATIC_COUNT_REACHED_MAX = 2194177187,
        EVENT_STAT_VALUE_CHANGED = 513573863,
        EVENT_STUCK_IN_AIR = 1219138112,
        EVENT_SUSPICIOUS_ACTIVITY = 1880756587,
        EVENT_TEXT_MESSAGE_RECEIVED = 2387084452,
        EVENT_UNIDENTIFIED_PED = 836870694,
        EVENT_VEHICLE_COLLISION = 1329775279,
        EVENT_VEHICLE_DAMAGE_WEAPON = 1147373995,
        EVENT_VEHICLE_ON_FIRE = 2486074422,
        EVENT_WHISTLING_HEARD = 1590460986,
        EVENT_WRITHE = 2766469638,
        EVehicleModelAudioColor = 544262540,
        EVehicleModelAudioPrefix = 2065815796,
        EVehicleModelColorMetallicID = 360458334,
        EXPLOSIVE = 2765246062,
        EXP_TAG_AIR_DEFENCE = 2465285273,
        EXP_TAG_APCSHELL = 1277718621,
        EXP_TAG_BARREL = 570594117,
        EXP_TAG_BIRD_CRAP = 3341507266,
        EXP_TAG_BLIMP = 3497153673,
        EXP_TAG_BLIMP2 = 2559598565,
        EXP_TAG_BOMBUSHKA_CANNON = 1417884182,
        EXP_TAG_BOMB_CLUSTER = 1914063510,
        EXP_TAG_BOMB_CLUSTER_SECONDARY = 1283653351,
        EXP_TAG_BOMB_GAS = 2009960515,
        EXP_TAG_BOMB_INCENDIARY = 1168496177,
        EXP_TAG_BOMB_STANDARD = 2901865356,
        EXP_TAG_BOMB_STANDARD_WIDE = 1062227695,
        EXP_TAG_BOMB_WATER = 462436393,
        EXP_TAG_BOMB_WATER_SECONDARY = 2312912877,
        EXP_TAG_BURIEDMINE = 550805899,
        EXP_TAG_DIR_FLAME_EXPLODE = 3250287170,
        EXP_TAG_EXPLOSIVEAMMO = 1688956154,
        EXP_TAG_EXPLOSIVEAMMO_SHOTGUN = 242971327,
        EXP_TAG_FIREWORK = 1783612987,
        EXP_TAG_FLASHGRENADE = 2804180415,
        EXP_TAG_GAS_TANK = 2138638203,
        EXP_TAG_HUNTER_BARRAGE = 3738385791,
        EXP_TAG_HUNTER_CANNON = 2558400003,
        EXP_TAG_MINE_UNDERWATER = 2215599605,
        EXP_TAG_MORTAR_KINETIC = 1975696133,
        EXP_TAG_OPPRESSOR2_CANNON = 395405967,
        EXP_TAG_ORBITAL_CANNON = 941099566,
        EXP_TAG_PIPEBOMB = 1911581278,
        EXP_TAG_PROPANE = 1377083955,
        EXP_TAG_PROXMINE = 441564516,
        EXP_TAG_RAILGUN = 59377480,
        EXP_TAG_RAYGUN = 2404860048,
        EXP_TAG_RCTANK_ROCKET = 1774432025,
        EXP_TAG_ROGUE_CANNON = 2160141416,
        EXP_TAG_SCRIPT_DRONE = 2584690003,
        EXP_TAG_SCRIPT_MISSILE = 3711190244,
        EXP_TAG_SNOWBALL = 3003973440,
        EXP_TAG_STUNGRENADE = 1977659022,
        EXP_TAG_TANKER = 1335551851,
        EXP_TAG_TORPEDO = 2258795781,
        EXP_TAG_TORPEDO_UNDERWATER = 1764006484,
        EXP_TAG_TRAIN = 2761366929,
        EXP_TAG_VALKYRIE_CANNON = 3248320386,
        EXP_TAG_VEHICLEMINE = 303678590,
        EXP_TAG_VEHICLEMINE_EMP = 2865924154,
        EXP_TAG_VEHICLEMINE_KINETIC = 1038314368,
        EXP_TAG_VEHICLEMINE_SLICK = 3377079218,
        EXP_TAG_VEHICLEMINE_SPIKE = 3399734114,
        EXP_TAG_VEHICLEMINE_TAR = 3837387642,
        EXP_TAG_VEHICLE_BULLET = 1971175288,
        EXTINGUISHER = 1250722095,
        EXTRACONTENT_COMPAT_PACK = 3848388222,
        EXTRACONTENT_LEVEL_PACK = 1223619432,
        EXTRACONTENT_PAID_PACK = 3044913321,
        EXTRACONTENT_TU_PACK = 1412533067,
        EXTRA_1 = 1535512201,
        EXTRA_10 = 2664339198,
        EXTRA_11 = 235468153,
        EXTRA_12 = 189263859,
        EXTRA_13 = 4102210153,
        EXTRA_2 = 3393022970,
        EXTRA_3 = 1963770262,
        EXTRA_4 = 1699357201,
        EXTRA_5 = 375325756,
        EXTRA_6 = 2230673767,
        EXTRA_7 = 1137565465,
        EXTRA_8 = 840448942,
        EXTRA_9 = 3915459125,
        EdgeData = 1323101883,
        EdgeLength2 = 1010730498,
        EffectGroup = 3830440106,
        Either = 2106680950,
        EmergencyResponses = 1356602110,
        EmergencyStopInterceptionMaxForwardDistance = 1653710895,
        EmergencyStopInterceptionMaxSideDistance = 916666022,
        EmergencyStopInterceptionMaxTime = 4172340609,
        EmergencyStopInterceptionMinTime = 2850307001,
        EmergencyStopTimeBetweenChecks = 1156561437,
        EnableAimOutroDelay = 1536785516,
        EnableAimOutroToPeekAnims = 3098272438,
        EnableBlindFireToPeek = 2038512667,
        EnableFPSIdleOnly = 1858375891,
        EnableFPSRNGOnly = 1430844306,
        EnableFirstPersonAimingAnimations = 1949874056,
        EnableFirstPersonLocoAnimations = 1230607954,
        EnableKinematicPhysicsForPed = 1457000362,
        EnableSideSwipeActivationsFirstPerson = 2302810051,
        EnabledOnlyWhenVehTransformed = 300244918,
        EncroachmentCloseRange = 1973266093,
        EncroachmentRange = 4075348531,
        EndPointOffsetXVariance = 4007176683,
        EndScenarioIfPlayerWithinRadius = 3690227693,
        EndsInWalk = 984384191,
        EnforceAimingRestrictions = 3721647093,
        EnforceFiringAngularThreshold = 3204254602,
        EnterHeadingSpeedModifier = 2395321832,
        EnterMenuOnMouseClick = 2849653199,
        EnterPitchSpeedModifier = 1707713717,
        EnterVehicleMoveNetwork = 2214818416,
        Enters = 2960506012,
        EntityMayNotAlwaysExist = 538733109,
        EntityModelHashkey = 3815194629,
        Entry = 3829672579,
        EntryAnimVariations = 872688746,
        EntryAnims = 1247469462,
        EntryClipSetMap = 801074649,
        EntryHeadingChange = 1357476534,
        EntryPointAnimInfo = 926618337,
        EntryPointFlags = 1166497631,
        EntryPointInfo = 3406749500,
        EntryPoints = 242755476,
        EntryTranslation = 3244273697,
        Equal = 697477197,
        Equip = 8773640,
        EquipThisWeapon = 237676235,
        Event = 1741051250,
        EventInstance = 4257918225,
        EventList = 4007123039,
        EventResponse = 1631793989,
        EventResponseDecisionFlags = 3022530695,
        EventResponseFleeFlags = 1828766064,
        EventTypeHash = 2001515911,
        EventsInRadiusTriggerDisputes = 3441065168,
        EventsInRadiusTriggerThreatResponse = 1601179199,
        Exchange = 4166134960,
        Exchanges = 346204455,
        ExitAnimHasLongDrop = 3008417658,
        ExitAnims = 1734825145,
        ExitClipSetMap = 1233915924,
        ExitCoverBaseFPSClipSetId = 2123164199,
        ExitCoverExtraFPSClipSetId = 1757551615,
        ExitPitchSpeedModifier = 1059545904,
        ExitProbeCapsuleRadiusOverride = 611567023,
        ExitProbeZOverride = 1984726489,
        ExitToAimInfoName = 2970210601,
        ExitVehicleDueToRoute = 2976849785,
        Exits = 4156488510,
        ExpandAvoidanceRadius = 299512073,
        ExpandPedCapsuleRadius = 4103647853,
        ExpectedMaximum = 400342874,
        ExpectedMaximumsArray = 2123513628,
        ExpertTargettingDifficultyInfo = 933644170,
        ExplodeAtTrailFxPos = 2646813356,
        ExplosionData = 3662995320,
        ExplosionScale = 772397858,
        ExplosionShakeAmplitude = 217186542,
        ExplosionTag = 2490913838,
        ExplosionTime = 3122788763,
        Explosive = 1394099955,
        Extents = 3575335131,
        ExteriorBoxIDX = 467418377,
        Extra1 = 1354164609,
        Extra10 = 162475978,
        Extra2 = 1048364301,
        Extra3 = 725917341,
        Extra4 = 2566584840,
        Extra5 = 420444719,
        Extra6 = 132208595,
        Extra7 = 4121015124,
        Extra8 = 3797716170,
        Extra9 = 3259223197,
        ExtraBackwardOffset = 3330608209,
        ExtraBaseElementLocMap1 = 3039211046,
        ExtraBaseElementLocMap2 = 2278773632,
        ExtraBaseElementLocMap3 = 2100444738,
        ExtraBaseElementLocMap4 = 1342235616,
        ExtraBaseElementLocMap5 = 566495079,
        ExtraBaseElementLocMap6 = 840837147,
        ExtraBaseElementLocMap7 = 71847024,
        ExtraBaseElementLocMap8 = 379547934,
        ExtraComponents = 2036705331,
        ExtraForce = 1211373309,
        ExtraForwardOffset = 2285272393,
        ExtraPinRadiusChannels = 3627260570,
        ExtraRelativePitch = 3581122959,
        ExtraSideOffset = 3371701319,
        ExtraStartHiddenEvasionDelay = 2940774268,
        ExtraVehiclePoints = 2556294920,
        ExtraZForMPPlaneWarp = 2330746773,
        ExtraZOffset = 3731905702,
        ExtraZoomFactorForAccurateMode = 2374457938,
        FALL = 557139494,
        FIRE = 289879133,
        FIRE_EXTINGUISHER = 1217174970,
        FIRST_INPUT = 2727219906,
        FISH = 4022530165,
        FISH_IN_WATER = 2983602517,
        FLAG_ALLOWS_RAPPEL = 2488668750,
        FLAG_ALLOW_HATS_NO_ROOF = 1954471110,
        FLAG_ALLOW_OBJECT_LOW_LOD_COLLISION = 3317978609,
        FLAG_ALLOW_RAPPEL_AI_ONLY = 3247906521,
        FLAG_ALLOW_TARGETING_OF_OCCUPANTS = 4234503131,
        FLAG_ATTACH_TRAILER_IN_CITY = 1859869819,
        FLAG_ATTACH_TRAILER_ON_HIGHWAY = 4268864910,
        FLAG_AVERAGE_CAR = 2301044555,
        FLAG_AVOID_TURNS = 522483366,
        FLAG_BIG = 3521156183,
        FLAG_BIKE_CLAMP_PICKUP_LEAN_RATE = 1501750912,
        FLAG_BLOCK_FROM_ATTRACTOR_SCENARIO = 3984127838,
        FLAG_BOOT_IN_FRONT = 2048007724,
        FLAG_CANNOT_BE_DRIVEN_BY_PLAYER = 1386640295,
        FLAG_CANNOT_BE_MODDED = 1187010597,
        FLAG_CANNOT_BE_PICKUP_BY_CARGOBOB = 911329154,
        FLAG_CANNOT_TAKE_COVER_WHEN_STOOD_ON = 655038201,
        FLAG_CAN_BE_DRIVEN_ON = 2851680744,
        FLAG_CAN_HAVE_NEONS = 1987167610,
        FLAG_CAN_HONK_WHEN_FLEEING = 3993171882,
        FLAG_CAN_NAVIGATE_TO_ON_VEHICLE_ENTRY = 3510285779,
        FLAG_CARGOBOB_HOOK_UP_CHASSIS = 4151490262,
        FLAG_CHECK_WARP_TASK_FLAG_DURING_ENTER = 268767044,
        FLAG_CONSIDERED_FOR_VEHICLE_ENTRY_WHEN_STOOD_ON = 4247314322,
        FLAG_COUNT_AS_FACEBOOK_DRIVEN = 4105357127,
        FLAG_CREATE_WEAPON_MANAGER_ON_SPAWN = 4195274060,
        FLAG_CRUSHES_OTHER_VEHICLES = 2257706787,
        FLAG_DAMPEN_STICKBOMB_DAMAGE = 942840865,
        FLAG_DELIVERY = 680579589,
        FLAG_DISABLE_AUTO_VAULT_ON_VEHICLE = 794975130,
        FLAG_DISABLE_BUSTING = 1927760734,
        FLAG_DISABLE_CAMERA_PUSH_BEYOND = 2490439721,
        FLAG_DISABLE_DEFORMATION = 101568703,
        FLAG_DISABLE_THROUGH_WINDSCREEN = 1120900807,
        FLAG_DISABLE_WEAPON_WHEEL_IN_FIRST_PERSON = 43426567,
        FLAG_DONT_CLOSE_DOOR_UPON_EXIT = 1678546452,
        FLAG_DONT_CRASH_ABANDONED_NEAR_GROUND = 2637343260,
        FLAG_DONT_HOLD_LOW_GEARS_WHEN_ENGINE_UNDER_LOAD = 3502436067,
        FLAG_DONT_LINK_BOOT2 = 3768857020,
        FLAG_DONT_ROTATE_TAIL_ROTOR = 245771061,
        FLAG_DONT_SPAWN_AS_AMBIENT = 3086118633,
        FLAG_DONT_SPAWN_IN_CARGEN = 129199918,
        FLAG_DONT_STOP_WHEN_GOING_TO_CLIMB_UP_POINT = 2370525290,
        FLAG_DONT_TIMESLICE_WHEELS = 3897119412,
        FLAG_DRIVER_NO_DRIVE_BY = 3427242805,
        FLAG_DRIVER_SHOULD_BE_FEMALE = 3786082032,
        FLAG_DRIVER_SHOULD_BE_MALE = 384893011,
        FLAG_DROP_SUSPENSION_WHEN_STOPPED = 4177656512,
        FLAG_EMERGENCY_SERVICE = 936606406,
        FLAG_EQUIP_UNARMED_ON_ENTER = 914466948,
        FLAG_EXPLODE_ON_CONTACT = 3727631202,
        FLAG_EXTRAS_ALL = 1986967520,
        FLAG_EXTRAS_CONVERTIBLE = 3087420563,
        FLAG_EXTRAS_GANG = 1534229967,
        FLAG_EXTRAS_MATCH_LIVERY = 1157086635,
        FLAG_EXTRAS_ONLY_BREAK_WHEN_DESTROYED = 4253746331,
        FLAG_EXTRAS_RARE = 1798152012,
        FLAG_EXTRAS_REQUIRE = 3997361645,
        FLAG_EXTRAS_SCRIPT = 329242052,
        FLAG_EXTRAS_STRONG = 430060933,
        FLAG_EXTRAS_TAXI = 2937319788,
        FLAG_FAKE_EXTRALIGHTS = 67144400,
        FLAG_FLEE_FROM_COMBAT = 407533606,
        FLAG_FORCE_BONNET_CAMERA_INSTEAD_OF_POV = 326337311,
        FLAG_FORCE_ENABLE_CHASSIS_COLLISION = 696680441,
        FLAG_FRONT_BOOT = 4247947143,
        FLAG_GEN_NAVMESH = 1835715066,
        FLAG_GIVE_SCUBA_GEAR_ON_EXIT = 3388743167,
        FLAG_HALF_TRACK = 2157826670,
        FLAG_HAS_BULLETPROOF_GLASS = 3061491451,
        FLAG_HAS_BULLET_RESISTANT_GLASS = 2910397313,
        FLAG_HAS_CAPPED_EXPLOSION_DAMAGE = 2689370915,
        FLAG_HAS_DIRECTIONAL_SHUFFLES = 3045722771,
        FLAG_HAS_EJECTOR_SEATS = 2442041409,
        FLAG_HAS_EXTENDED_COLLISION_MODS = 3226163843,
        FLAG_HAS_EXTRA_SHUFFLE_SEAT_ON_VEHICLE = 880167195,
        FLAG_HAS_FRONT_SPIKE_MOD = 3044808413,
        FLAG_HAS_GLIDER = 3750640923,
        FLAG_HAS_GULL_WING_DOORS = 2427030236,
        FLAG_HAS_HELI_STRAFE_MODE = 914669159,
        FLAG_HAS_INCREASED_RAMMING_FORCE = 1123545594,
        FLAG_HAS_INCREASED_RAMMING_FORCE_WITH_CHASSIS_MOD = 618222716,
        FLAG_HAS_INTERIOR_EXTRAS = 4026204423,
        FLAG_HAS_JATO_BOOST_MOD = 2323834521,
        FLAG_HAS_JUMP_MOD = 1997407989,
        FLAG_HAS_LIVERY = 3576001425,
        FLAG_HAS_LOWRIDER_DONK_HYDRAULICS = 791006512,
        FLAG_HAS_LOWRIDER_HYDRAULICS = 3937922042,
        FLAG_HAS_NITROUS_MOD = 59791353,
        FLAG_HAS_NO_ROOF = 967570892,
        FLAG_HAS_OUTRIGGER_LEGS = 4162076300,
        FLAG_HAS_PARACHUTE = 2245546856,
        FLAG_HAS_RAMMING_BAR_MOD = 2818919098,
        FLAG_HAS_RAMMING_SCOOP_MOD = 1658142317,
        FLAG_HAS_REAR_MOUNTED_TURRET = 4189491638,
        FLAG_HAS_REAR_SEAT_ACTIVITIES = 1255851983,
        FLAG_HAS_ROCKET_BOOST = 1725913275,
        FLAG_HAS_SIDE_SHUNT = 2865874312,
        FLAG_HAS_SUPERCHARGER = 2524458822,
        FLAG_HAS_SUPER_BRAKES_MOD = 1189649489,
        FLAG_HAS_TOMBSTONE = 3149801539,
        FLAG_HAS_TURRET_SEAT_ON_VEHICLE = 3090053632,
        FLAG_HAS_TWO_BONNET_BONES = 1185348746,
        FLAG_HAS_VERTICAL_FLIGHT_MODE = 2710142501,
        FLAG_HAS_VERTICAL_ROCKET_BOOST = 1156899578,
        FLAG_HAS_WEAPON_BLADE_MODS = 743916430,
        FLAG_HAS_WEAPON_SPIKE_MODS = 2062874634,
        FLAG_HEADLIGHTS_ON_LANDINGGEAR = 2942106557,
        FLAG_HEADLIGHTS_ON_TAP_ONLY = 817412995,
        FLAG_HEADLIGHTS_USE_ACTUAL_BONE_POS = 3758757045,
        FLAG_HELICOPTER_WITH_LANDING_GEAR = 3875633342,
        FLAG_HELI_USES_FIXUPS_ON_OPEN_DOOR = 1414546034,
        FLAG_HOLD_TO_SHUFFLE = 1308868616,
        FLAG_IGNORE_ON_SIDE_CHECK = 1566578323,
        FLAG_IGNORE_RWINDOW_COLLISION = 3780477307,
        FLAG_IGNORE_TRAPPED_HULL_CHECK = 654725240,
        FLAG_INCREASE_CAMBER_WITH_SUSPENSION_MOD = 2522166960,
        FLAG_INCREASE_LOW_SPEED_TORQUE = 2836688924,
        FLAG_INCREASE_PED_COMMENTS = 3976626482,
        FLAG_INTERIOR_BLOCKED_BY_BOOT = 1428724174,
        FLAG_IS_BULKY = 1225372460,
        FLAG_IS_BUS = 320661719,
        FLAG_IS_DIGGER = 4011287777,
        FLAG_IS_ELECTRIC = 2830619661,
        FLAG_IS_FORMULA_VEHICLE = 537451299,
        FLAG_IS_JETSKI = 709826942,
        FLAG_IS_OFFROAD_VEHICLE = 881076666,
        FLAG_IS_QUADBIKE_USING_BIKE_ANIMATIONS = 2861132292,
        FLAG_IS_TANK = 45790091,
        FLAG_IS_TANK_WITH_FLAME_DAMAGE = 3445676259,
        FLAG_IS_TRACKED_FOR_TRAILS = 4017678002,
        FLAG_IS_VAN = 2352900511,
        FLAG_JUMPING_CAR = 4239935791,
        FLAG_KEEP_ALL_TURRETS_SYNCHRONISED = 3090217417,
        FLAG_LAW_ENFORCEMENT = 524363548,
        FLAG_LIVERY_MATCH_EXTRA = 1969704628,
        FLAG_NO_BOOT = 3065315860,
        FLAG_NO_BROKEN_DOWN_SCENARIO = 2267130436,
        FLAG_NO_HEAVY_BRAKE_ANIMATION = 1472006129,
        FLAG_NO_RESPRAY = 884260745,
        FLAG_NO_REVERSING_ANIMATION = 1195147056,
        FLAG_ONLY_DURING_OFFICE_HOURS = 322902255,
        FLAG_ONLY_ON_HIGHWAYS = 1335526114,
        FLAG_PARKING_SENSORS = 3746539187,
        FLAG_PEDS_CAN_STAND_ON_TOP = 62833273,
        FLAG_PEDS_INSIDE_CAN_BE_SET_ON_FIRE_MP = 3995467380,
        FLAG_PLANE_WEAR_ALTERNATIVE_HELMET = 308835965,
        FLAG_POOR_CAR = 3551804580,
        FLAG_PREFER_ENTER_TURRET_AFTER_DRIVER = 2093498452,
        FLAG_RAMMING_SCOOP = 255556133,
        FLAG_RAMP = 1478915074,
        FLAG_RAMP_MOD = 4204984048,
        FLAG_RECESSED_HEADLIGHT_CORONAS = 2533275170,
        FLAG_RECESSED_TAILLIGHT_CORONAS = 1307744961,
        FLAG_REPORT_CRIME_IF_STANDING_ON = 993754567,
        FLAG_RESET_TURRET_SEAT_HEADING = 788190129,
        FLAG_RICH_CAR = 4163203119,
        FLAG_SECOND_TURRET_MOD = 2658756305,
        FLAG_SET_WANTED_FOR_ATTACHED_VEH = 2384831555,
        FLAG_SMALL_WORKER = 768263977,
        FLAG_SPAWN_BOAT_ON_TRAILER = 2942510129,
        FLAG_SPAWN_ON_TRAILER = 1230913021,
        FLAG_SPOILER_MOD_DOESNT_INCREASE_GRIP = 386198672,
        FLAG_SPORTS = 2501233432,
        FLAG_SPRAY_PETROL_BEFORE_EXPLOSION = 16158201,
        FLAG_TALL_SHIP = 4052970194,
        FLAG_THIRD_TURRET_MOD = 1657556030,
        FLAG_TURRET_ENTRY_ATTACH_TO_DRIVER_SEAT = 3962349695,
        FLAG_TURRET_MODS_ON_CHASSIS5 = 1739570810,
        FLAG_TURRET_MODS_ON_ROOF = 1594871037,
        FLAG_TURRET_MOD_WITH_NO_STOCK_TURRET = 3225670229,
        FLAG_TWO_DOORS_ONE_SEAT = 51179154,
        FLAG_UPDATE_WEAPON_BATTERY_BONES = 2309060569,
        FLAG_USE_AIRCRAFT_STYLE_WEAPON_TARGETING = 3181726798,
        FLAG_USE_COVERBOUND_INFO_FOR_COVERGEN = 504774461,
        FLAG_USE_FAT_INTERIOR_LIGHT = 2193417101,
        FLAG_USE_FIVE_ANIM_THROW_FP = 2320136390,
        FLAG_USE_FULL_ANIMS_FOR_MP_WARP_ENTRY_POINTS = 146360019,
        FLAG_USE_HEADING_ONLY_IN_TURRET_MATRIX = 172306502,
        FLAG_USE_HIGHER_DOOR_TORQUE = 3963160372,
        FLAG_USE_INTERIOR_RED_LIGHT = 3376437702,
        FLAG_USE_LIGHTING_INTERIOR_OVERRIDE = 3267736726,
        FLAG_USE_PILOT_HELMET = 1862488006,
        FLAG_USE_RESTRICTED_DRIVEBY_HEIGHT = 478311937,
        FLAG_USE_RESTRICTED_DRIVEBY_HEIGHT_HIGH = 1574977805,
        FLAG_USE_RESTRICTED_DRIVEBY_HEIGHT_MID_ONLY = 3286337750,
        FLAG_USE_ROOT_AS_BASE_LOCKON_POS = 865156728,
        FLAG_USE_SMALLER_OPEN_DOOR_RATIO_TOLERANCE = 656489084,
        FLAG_USE_STANDARD_FLIGHT_HELMET = 2701150442,
        FLAG_USE_STEERING_PARAM_FOR_LEAN = 2291220982,
        FLAG_USE_STRICTER_EXIT_COLLISION_TESTS = 1347115503,
        FLAG_USE_TURRET_RELATIVE_AIM_CALCULATION = 2984700545,
        FLAG_USE_WEAPON_WHEEL_WITHOUT_HELMET = 3713911247,
        FLARE = 3932442833,
        FLIGHTLESS_BIRD_ON_FOOT = 4081450485,
        FMJ = 2967963329,
        FPSAimOutroBlendOutPelvisOffsetTime = 1862046997,
        FPSBlindFireOutroBlendOutPelvisOffsetTime = 3698046827,
        FPSDefaultBlendDurationHigh = 1335048013,
        FPSDefaultBlendDurationLow = 2787523036,
        FPSFidgetClipsetHashes = 2740913584,
        FPSForceUse180s = 827074596,
        FPSForceUseStarts = 122800807,
        FPSForceUseStops = 259313148,
        FPSForceUseStopsMinTimeInStartState = 2900191858,
        FPSMaxSteeringRateOverride = 477036462,
        FPSMinSteeringRateOverride = 1005448169,
        FPSOnlyExitFireAnimAfterRecoilEnds = 1224403382,
        FPSPeekToAimBlendDurationHigh = 1686691958,
        FPSPeekToAimBlendDurationLow = 3171144783,
        FPSPeekToBlindFireBlendDurationHigh = 1788624470,
        FPSPeekToBlindFireBlendDurationLow = 1235126752,
        FPSStrafeClipSetHash = 3570837702,
        FPSTransitionFromIdleHash = 3658635453,
        FPSTransitionFromLTHash = 2026128200,
        FPSTransitionFromRNGHash = 612591970,
        FPSTransitionFromScopeHash = 309411533,
        FPSTransitionFromStealthHash = 446817704,
        FPSTransitionFromUnholsterHash = 3047625588,
        FPSTransitionToStealthFromUnholsterHash = 1409487949,
        FPSTransitionToStealthHash = 3786283787,
        FPTC_LINEAR = 328600706,
        FPTC_POW2 = 457470404,
        FPTC_POW4 = 3222879087,
        FRONTEND = 2913778804,
        FRONT_LEFT = 3347537565,
        FRONT_RIGHT = 2839645826,
        FRONT_WINDSCREEN = 3373972077,
        FXAA_Enabled = 3094153551,
        Face = 3746820715,
        FacePlayer = 4276701841,
        FadeInCheckTreshold = 3688130725,
        FadeInTime = 158609973,
        FadeOutCheckTreshold = 2253324809,
        FadeOutStartTime = 1450693361,
        FadeOutTime = 1373643375,
        FadeoutDist = 436044262,
        FakeSeat = 515714932,
        FallClipSetHash = 2641261434,
        FallExitThreshold = 44269645,
        FallOffModifier = 2596043848,
        FallOffRadius = 2142900924,
        FallUpperbodyClipSetHash = 1670865686,
        Fallback = 513663279,
        FallsOutWhenDead = 933181556,
        False = 3932829108,
        FastGearClipSpeeds = 3213918618,
        FastPitchingApproachRate = 3350282721,
        FastReload = 1770698022,
        FatiguedHealthThreshold = 4050703156,
        Fear = 3888704889,
        FearRate = 1361364394,
        FemaleClipSet = 2494101656,
        FemaleGestureClipSetId = 1060752382,
        File = 2559637581,
        FileTable = 49830254,
        Files = 546794142,
        Filter = 430908456,
        FinalState = 2211458030,
        FinishExitAnimationBeforeLeaving = 33360014,
        FireCameraHash = 1157692871,
        FireProof = 1402367612,
        FireSpawnDelayMax = 2110623806,
        FireSpawnDelayMin = 552233460,
        FireType = 3272594625,
        FiringBreathingAdditiveWeight = 767344828,
        FiringEntityIgnoresExplosionDamage = 709300496,
        FiringLeanAdditiveWeight = 3683391481,
        FiringPattern = 2405572211,
        FiringPatternAliases = 3537530522,
        FiringPatternHash = 1850135176,
        FiringVariationsCrouchingClipSetHash = 3726743189,
        FiringVariationsStandingClipSetHash = 3598491580,
        FirstPersonAdditiveIdleClipSets = 3267943076,
        FirstPersonAdditiveIdleSteeringCentreThreshold = 1039484179,
        FirstPersonAimFovMax = 2611882207,
        FirstPersonAimFovMin = 317169768,
        FirstPersonAlternateData = 2779622629,
        FirstPersonAnimStateInfos = 80713034,
        FirstPersonAsThirdPersonIdleOffset = 2605705121,
        FirstPersonAsThirdPersonLTOffset = 611460869,
        FirstPersonAsThirdPersonRNGOffset = 1864770575,
        FirstPersonAsThirdPersonScopeOffset = 2974026750,
        FirstPersonAsThirdPersonWeaponBlockedOffset = 982396565,
        FirstPersonAssetData = 9030157,
        FirstPersonAssetDataManager = 3904609649,
        FirstPersonBulletBendingFarRadius = 3278519134,
        FirstPersonBulletBendingNearRadius = 1491613793,
        FirstPersonBulletBendingZoomedRadius = 1192246915,
        FirstPersonClipSet = 1490931829,
        FirstPersonDofMaxNearInFocusDistance = 2675501121,
        FirstPersonDofMaxNearInFocusDistanceBlendLevel = 1561513481,
        FirstPersonDofSubjectMagnificationPowerFactorNear = 1115062229,
        FirstPersonDriveByClipSet = 3099361074,
        FirstPersonDriveByLeftPassengerIKOffset = 1932593099,
        FirstPersonDriveByLeftPassengerUnarmedIKOffset = 1910853578,
        FirstPersonDriveByLookAroundData = 3363485992,
        FirstPersonDriveByRightPassengerIKOffset = 568808048,
        FirstPersonDriveByRightPassengerUnarmedIKOffset = 2331234536,
        FirstPersonDriveByRightRearPassengerIKOffset = 607256196,
        FirstPersonDriveByUnarmedIKOffset = 1763037126,
        FirstPersonDrivebyIKOffset = 3526719560,
        FirstPersonEasyTargettingDifficultyInfo = 1051298047,
        FirstPersonExpertTargettingDifficultyInfo = 1604857901,
        FirstPersonFireLeftClipId = 2684719351,
        FirstPersonFireRightClipId = 4246561663,
        FirstPersonGripLeftClipId = 2221302483,
        FirstPersonGripRightClipId = 3323392529,
        FirstPersonHardTargettingDifficultyInfo = 3769742750,
        FirstPersonHotwireClipId = 1348667163,
        FirstPersonLTOffset = 27483712,
        FirstPersonLTRotationOffset = 1778178346,
        FirstPersonMaxAimSweepHeadingAngleDegs = 218778344,
        FirstPersonMaxSteeringRate = 3123171906,
        FirstPersonMaxVelocityToModifyRate = 1104842114,
        FirstPersonMinAimSweepHeadingAngleDegs = 1016548317,
        FirstPersonMinSteeringRate = 3193879405,
        FirstPersonMinVelocityToModifyRate = 1771118662,
        FirstPersonMobilePhoneOffset = 3509212005,
        FirstPersonMobilePhoneSeatIKOffset = 1842903784,
        FirstPersonNormalTargettingDifficultyInfo = 1712651720,
        FirstPersonPassengerMobilePhoneOffset = 3073630375,
        FirstPersonPedData = 1757581386,
        FirstPersonPersonBlindFirePitchAngles = 465339689,
        FirstPersonProjectileDriveByIKOffset = 2968653835,
        FirstPersonProjectileDriveByPassengerIKOffset = 3590135225,
        FirstPersonProjectileDriveByRearLeftIKOffset = 3083678245,
        FirstPersonProjectileDriveByRearRightIKOffset = 3345802888,
        FirstPersonRNGOffset = 2466814043,
        FirstPersonRNGRotationOffset = 1336354977,
        FirstPersonReticuleStyleHash = 368672379,
        FirstPersonRoadRageClipSets = 2877140879,
        FirstPersonScope = 2847316090,
        FirstPersonScopeAttachmentData = 38766507,
        FirstPersonScopeAttachmentFov = 48106762,
        FirstPersonScopeAttachmentOffset = 542433576,
        FirstPersonScopeAttachmentRotationOffset = 3620724279,
        FirstPersonScopeFov = 1784019957,
        FirstPersonScopeOffset = 1718352662,
        FirstPersonScopeRotationOffset = 793820969,
        FirstPersonSmoothRateToFastSteering = 2175428814,
        FirstPersonSmoothRateToSlowSteering = 346108670,
        FirstPersonStartEngineClipId = 2195918560,
        FirstPersonSteeringSafeZone = 3604323696,
        FirstPersonSteeringSplineEnd = 2895820001,
        FirstPersonSteeringSplineStart = 2029080904,
        FirstPersonSteeringTangentT0 = 1295618163,
        FirstPersonSteeringTangentT1 = 622968896,
        FirstPersonSteeringWheelAngleApproachSpeed = 2001571571,
        FirstPersonTimeCycleData = 3898008193,
        FirstPersonTimeToAllowFastSteering = 2239621028,
        FirstPersonTimeToAllowSlowSteering = 7898446,
        FirstPersonUnarmedMaxAimSweepHeadingAngleDegs = 436068152,
        FirstPersonUnarmedMinAimSweepHeadingAngleDegs = 406352791,
        FirstPersonVehicleMeleeClipSet = 2612001128,
        FirstPersonVisorSwitchIKOffset = 1112942641,
        FixUpMoverToEntryPointOnExit = 2328577521,
        FixedAfterExplosion = 3278372410,
        FixedFrame = 2524804304,
        Flag = 3380163521,
        FlagsLocal = 458594451,
        FlashFx = 3223354487,
        FlashFxAlt = 2260653864,
        FlashFxAltChance = 1139551,
        FlashFxChanceMP = 473489890,
        FlashFxChanceSP = 406190940,
        FlashFxFP = 133162439,
        FlashFxFPAlt = 1835504537,
        FlashFxLightCastsShadows = 480618688,
        FlashFxLightEnabled = 30100486,
        FlashFxLightFalloffMinMax = 1286411119,
        FlashFxLightIntensityMinMax = 4033238517,
        FlashFxLightOffsetDist = 372010183,
        FlashFxLightRGBAMax = 132136742,
        FlashFxLightRGBAMin = 186264162,
        FlashFxLightRangeMinMax = 2333494201,
        FlashFxScale = 3065537676,
        FlashLightBone = 467390275,
        FlashLightBoneBulbOff = 2235888438,
        FlashLightBoneBulbOn = 1258320460,
        FlattenCollisionNormals = 3410016379,
        FlattenZ = 376978979,
        FleeFromCombatWhenTargetIsInVehicle = 3260255334,
        FlipUVFlags = 1629587946,
        FloatData = 222890077,
        FlyOffToOblivion = 3490317520,
        Fog = 2843730157,
        FogColor = 1188353904,
        FogMax = 2538949622,
        FogMin = 2198472860,
        FogOfWar = 1791333322,
        FogPierceIntensity = 2579838761,
        FogQuad = 4026963361,
        FolderMounts = 236867344,
        FoliageStrength = 3544130300,
        FollowLeaderResetTargetDistanceSquaredOverride = 1805316728,
        FollowLeaderSeekEntityRunSpeedRange = 3463130797,
        FollowLeaderSeekEntityWalkSpeedRange = 2464327489,
        FollowUps = 3817473336,
        Force = 72987158,
        ForceAlertWhenVehicleStartedByPlayer = 2917006092,
        ForceBack = 2383114741,
        ForceBaseUntilIdleStreams = 3341256716,
        ForceEjectShellAfterFiring = 610586026,
        ForceFalloffMin = 3620014174,
        ForceFalloffRangeEnd = 2151953569,
        ForceFalloffRangeStart = 3922188596,
        ForceFireFromCamera = 2822502007,
        ForceFront = 4216880384,
        ForceFullFireAnimation = 4242773486,
        ForceHitFlyingHeli = 3776535376,
        ForceHitPed = 921831602,
        ForceHitVehicle = 1939798467,
        ForceIdleThroughBlendOut = 1432286929,
        ForceMaxStrengthMult = 4032977478,
        ForceModel = 4111757377,
        ForceNoTurningInFishLocomotion = 1326416119,
        ForcePedAsFiringEntity = 3391126176,
        ForcePlay = 3626918676,
        ForceSlowChaseInAnimalMelee = 1003795577,
        ForceSlowSwimWhenUnderPlayerControl = 3882642664,
        ForceToApplyAfterInterrupt = 3586541171,
        ForceTransmissionDown = 2978551013,
        ForceTransmissionUp = 1190336578,
        ForcedAiming = 3332631138,
        ForcedEntry = 3329647118,
        ForcedEntryIncludesGetIn = 3988773988,
        ForcedFrame = 2858557206,
        ForcedSelfDamageBoneTag = 786918577,
        ForcedWeatherType = 2393427567,
        ForcesActionMode = 3927723405,
        ForkPoint = 3229608109,
        ForkZigZagSplitPoint = 3893167533,
        ForwardDragCoeff = 3174990502,
        ForwardOffset = 3809527380,
        FractionMax = 1225280262,
        FractionMin = 2535840476,
        FragDebug1 = 627034560,
        FragDebug2 = 849273918,
        FragImpulse = 560863805,
        FrameCounter = 754924107,
        FrameFilterDictionaries = 1288083256,
        FrameFilters = 2143140442,
        FrameFlags = 3074078203,
        FrameMax = 2038924682,
        FrameMin = 1588517165,
        FreeCameraRef = 2750009688,
        FreewheelToPedalBlendDuration = 1376837275,
        FrictionMultiplier = 3508457117,
        Friends = 2836312,
        FromStrafeTransitionUpperBodyClipSetHash = 2491495581,
        FromVehicleLifeTime = 3692892448,
        FrontClearTestParams = 7740826,
        Fuse = 3436556436,
        FuseFx = 2388521127,
        FuseFxFP = 1791142054,
        Fx = 395567172,
        GARAGE_FOR_SCRIPT_TO_OPEN_AND_CLOSE = 1655119644,
        GARAGE_MISSION = 1043437180,
        GARAGE_NONE = 1343414948,
        GARAGE_SAFEHOUSE_PARKING_ZONE = 2414663717,
        GAS_CANISTER = 3257454189,
        GENDER_DONTCARE = 146281742,
        GENDER_FEMALE = 2380852995,
        GENDER_MALE = 237387675,
        GENRE_COUNTRY = 490313996,
        GENRE_GENERIC = 2960513132,
        GENRE_HIPHOP = 1953570947,
        GENRE_MEXICAN = 646809158,
        GENRE_MOTOWN = 1401298004,
        GENRE_PUNK = 2537979871,
        GET_IN = 1182157739,
        GET_IN_2 = 3996602998,
        GET_IN_3 = 3764696785,
        GET_IN_4 = 2307721503,
        GET_OUT = 2388898078,
        GRENADE = 1116910649,
        GRENADELAUNCHER = 42274542,
        GaitlessRateBoost = 1984559896,
        GameClockDay = 3687515787,
        GameClockHour = 3364437253,
        GameClockMinute = 4220276760,
        GameClockMonth = 3143936405,
        GameClockSecond = 2925909707,
        GameClockYear = 2663103167,
        GameType = 1411859793,
        GamerIdHigh = 1701763722,
        GamerIdLow = 4230505629,
        GarageType = 496824781,
        Gender = 362349222,
        GeneralData = 2245614546,
        GenerationRange = 645240413,
        GenericAdvertHistorySpace = 302251960,
        GenericAdvertHistoryWriteIndex = 3702981706,
        GestureBeckonOverrideClipSetHash = 1177686956,
        GestureClipSetId = 2688179759,
        GestureGlancesOverrideClipSetHash = 153313540,
        GestureHaltOverrideClipSetHash = 2910065001,
        GestureOverThereOverrideClipSetHash = 2737845147,
        GivePilotHelmetForSeat = 54113828,
        GlobalBreakHealthScale = 3191410875,
        GlobalDamageHealthScale = 4287401192,
        GlobalForceTransmissionScaleDown = 1848990755,
        GlobalForceTransmissionScaleUp = 100090658,
        GlobalMaxDrawingDistance = 19276643,
        GlobalRootBreakHealthScale = 3540685241,
        GlowBlue = 4128255183,
        GlowGreen = 757138583,
        GlowIntensity = 283927635,
        GlowRange = 2892398012,
        GlowRed = 183164936,
        GodRaysLerpEnd = 1624446532,
        GodRaysLerpStart = 3342221112,
        GotoTargetInitialLookAheadDistance = 3464503121,
        GotoTargetLookAheadDistance = 1837214838,
        GotoTargetLookAheadDistanceIncrement = 3530961430,
        Gradient = 2457930378,
        GrassQuality = 4188560773,
        GravityFactor = 2579053381,
        GreaterThan = 299219798,
        GroundDisturbFxDist = 525766488,
        GroundDisturbFxEnabled = 3658911486,
        GroundDisturbFxNameDefault = 3390942674,
        GroundDisturbFxNameDirt = 463278447,
        GroundDisturbFxNameFoliage = 2806265580,
        GroundDisturbFxNameSand = 1486434134,
        GroundDisturbFxNameWater = 571914036,
        GroundFxProbeDistance = 1086644458,
        GroundHeightRange = 702796411,
        GroundInstanceDamage = 2206183673,
        GroundOffsetExtend = 416661453,
        GroundSettingName = 2838489079,
        GroundToRootOffset = 3289459179,
        GroupHash = 2915870891,
        GroupIndex = 2561104100,
        GroupList = 4037556797,
        GroupName = 925663419,
        Gun = 3488029008,
        GunFeedBone = 3165272361,
        HANDLING_TYPE_BIKE = 582724258,
        HANDLING_TYPE_BOAT = 206857209,
        HANDLING_TYPE_CAR = 3485762579,
        HANDLING_TYPE_FLYING = 3029651589,
        HANDLING_TYPE_MAX_TYPES = 3915141222,
        HANDLING_TYPE_SEAPLANE = 696106373,
        HANDLING_TYPE_SUBMARINE = 2798431947,
        HANDLING_TYPE_TRAILER = 2586316259,
        HANDLING_TYPE_TRAIN = 3773956291,
        HANDLING_TYPE_VERTICAL_FLYING = 435676260,
        HANDLING_TYPE_WEAPON = 2896744549,
        HA_CHECK_TARGET_DISTANCE = 1536696087,
        HA_CHECK_TARGET_HEADING = 2532119622,
        HA_IGNORE_SPEED_MATCHING_CHECK = 1644557826,
        HA_USE_ACTIVATION_DISTANCE = 2521632091,
        HA_USE_CACHED_POSITION = 1557793142,
        HA_USE_DISPLACEMENT_MAGNITUDE = 2845060106,
        HA_USE_LOW_ROOT_Z_OFFSET = 3174821055,
        HAlign = 1427913443,
        HBAOBlendDistance = 2030694880,
        HBAOFalloffExponent = 2255272462,
        HBAORadius0 = 512719983,
        HBAORadius1 = 213899472,
        HBAORelativeStrength = 3179335125,
        HBAO_Parameters = 3542126898,
        HBC_Maximum = 1024930189,
        HBC_Minimum = 2508718569,
        HDAO2_ScenePreset = 3666556163,
        HDAO_ScenePreset = 4069244622,
        HDDistance = 4095925965,
        HDTextureDist = 3433689757,
        //HIDE_IT = 1095875445, //causes hash collision with something in scenario .ymt's which is obviously not this
        HIGH = 1475850173,
        HI_OCTANE = 3613106599,
        HORSE_ON_FOOT = 140327661,
        HORSE_SWIMMING = 2516114038,
        HUMAN = 309431268,
        HairScale = 4274993772,
        HandlesDisplayDataSlot = 3888273029,
        HandlingData = 1103683271,
        HandsUpClipSetId = 4034782367,
        Happy = 2580326281,
        HappyRate = 1365932334,
        HardTargettingDifficultyInfo = 2843442022,
        HasClimbDown = 994106978,
        HasClimbDownToWater = 205948887,
        HasClimbUp = 1522422806,
        HasClimbUpFromWater = 3497012015,
        HasCmplxTurnGaits = 2204881919,
        HasCombatEntry = 2716534762,
        HasDualGaits = 520070645,
        HasFPSProjectileWeaponAnims = 118454741,
        HasFacial = 3235007956,
        HasGetInFromWater = 3537238172,
        HasGetOutToVehicle = 1057238924,
        HasHelmet = 1706976641,
        HasImpactAnims = 4198062836,
        HasInventory = 4007783168,
        HasLimitedDepth = 3724327686,
        HasLowCoverReloads = 1308837909,
        HasLowCoverSwaps = 1389685055,
        HasLowLodMotionTask = 214471809,
        HasOnVehicleEntry = 1015768998,
        HasPanicAnims = 2641004512,
        HasPhone = 2702132183,
        HasQuickStops = 1532090295,
        HasRagdollConstraints = 953860759,
        HasReins = 1727538467,
        HasRoof = 1591839082,
        HasRunStarts = 1429690279,
        HasShockingEventReponse = 2120670318,
        HasSlopeGaits = 1302796150,
        HasSpeech = 416049486,
        HasTargetAchievedCombatVictory = 1833277456,
        HasVaultUp = 2170350474,
        HasVfx = 208135784,
        HasWalkStarts = 4102362367,
        HdStreamingInFlight = 2217680555,
        HeadDeltaLimits = 433074837,
        HeadHeight = 2767145844,
        HeadHeightCrouched = 2337425127,
        HeadShotDamageModifierAI = 2060587862,
        HeadShotDamageModifierPlayer = 172657647,
        Header = 2475995967,
        HeadingLimit = 3563993639,
        HeadingLimitsLeft = 3859092169,
        HeadingLimitsRight = 1438201133,
        Health = 4051380586,
        HearingRange = 3521022127,
        Heavy = 2684323927,
        HeightAboveGround = 2241187664,
        HeightAboveTarget = 3504182592,
        HeightDifference = 3510078361,
        HeightSpringConstant = 940306022,
        HeliSensesRange = 2576015827,
        HiResTargetDistanceCutoff = 1836718058,
        HiddenEvasionTimes = 1016241672,
        HiddenFromWeaponWheel = 3481198751,
        HideBirdProjectile = 1221942053,
        HideDrawable = 3691830452,
        HideReticule = 753633662,
        HighEnergy = 2490373860,
        HighFallExtraHeightWaterDepthMax = 4036569890,
        HighFallExtraHeightWaterDepthMin = 2776570354,
        HighFallWaterDepthMax = 3807299066,
        HighFallWaterDepthMin = 2581310221,
        HighLodPhysicsPitchIdealApproachRate = 1242076965,
        HighSpinRate = 2325961664,
        HighestJumpDistance = 2321624610,
        HighestSpeed = 3776903026,
        HistorySupport = 4157035600,
        HitBike = 731586847,
        HitBoat = 1516648846,
        HitCar = 2217304201,
        HitLimbsDamageModifier = 1735978407,
        HitPlane = 3515397349,
        HitTruck = 1058035633,
        HollowPoint = 1966004408,
        Homing = 1635025496,
        HomingAttractor = 1262502906,
        HomingAttrs = 3542548830,
        HomingToggle = 1342202930,
        HorizontalOffset = 346974809,
        HornSoundIndex = 770907700,
        HostBroadcastData = 2682137534,
        Hours = 1955380487,
        HudAccuracy = 49865421,
        HudCapacity = 2006655128,
        HudDamage = 1152492718,
        HudRange = 1046492899,
        HudSpeed = 2060238927,
        HumanNameHash = 418461615,
        Hunger = 3596154812,
        HungerRate = 3202367513,
        HurtHealthThreshold = 1477889213,
        ICON_INVALID = 2385664671,
        ICON_SPINNER = 3477836147,
        IF_JackedPedExitsWillingly = 3638644218,
        IF_ScriptFlagOnly = 1834391103,
        IKSolversDisabled = 1240586112,
        INPUTGROUP_CELLPHONE_NAVIGATE = 2920665998,
        INPUTGROUP_CELLPHONE_NAVIGATE_LR = 91958321,
        INPUTGROUP_CELLPHONE_NAVIGATE_UD = 2310252599,
        INPUTGROUP_CURSOR = 1175935062,
        INPUTGROUP_CURSOR_SCROLL = 3935028206,
        INPUTGROUP_FLY = 4176446903,
        INPUTGROUP_FRONTEND_BUMPERS = 2559897783,
        INPUTGROUP_FRONTEND_DPAD_ALL = 1191870203,
        INPUTGROUP_FRONTEND_DPAD_LR = 167215337,
        INPUTGROUP_FRONTEND_DPAD_UD = 94432856,
        INPUTGROUP_FRONTEND_GENERIC_ALL = 2572861339,
        INPUTGROUP_FRONTEND_GENERIC_LR = 3991067835,
        INPUTGROUP_FRONTEND_GENERIC_UD = 770794759,
        INPUTGROUP_FRONTEND_LSTICK_ALL = 2637687090,
        INPUTGROUP_FRONTEND_RSTICK_ALL = 671041515,
        INPUTGROUP_FRONTEND_STICKS = 3651016539,
        INPUTGROUP_FRONTEND_TRIGGERS = 565691566,
        INPUTGROUP_INVALID = 3920110043,
        INPUTGROUP_LOOK = 1932331302,
        INPUTGROUP_MOVE = 2276258325,
        INPUTGROUP_SCRIPT_BUMPERS = 2396071303,
        INPUTGROUP_SCRIPT_DPAD_ALL = 2273611964,
        INPUTGROUP_SCRIPT_DPAD_LR = 1379547501,
        INPUTGROUP_SCRIPT_DPAD_UD = 2186482570,
        INPUTGROUP_SCRIPT_LSTICK_ALL = 878920507,
        INPUTGROUP_SCRIPT_RSTICK_ALL = 3608298470,
        INPUTGROUP_SCRIPT_TRIGGERS = 3472311201,
        INPUTGROUP_SNIPER_ZOOM_SECONDARY = 3309890892,
        INPUTGROUP_SUB = 2365229036,
        INPUTGROUP_VEH_HYDRAULICS_CONTROL = 1719668156,
        INPUTGROUP_VEH_MOVE_ALL = 3805086621,
        INPUTGROUP_WEAPON_WHEEL_CYCLE = 2996396704,
        INPUTGROUP_WHEEL = 3190191553,
        INPUT_ACCURATE_AIM = 1196102930,
        INPUT_AIM = 2051276170,
        INPUT_ARREST = 633662318,
        INPUT_ATTACK = 1637520514,
        INPUT_ATTACK2 = 73656747,
        INPUT_CELLPHONE_CAMERA_DOF = 3360531844,
        INPUT_CELLPHONE_CAMERA_EXPRESSION = 2875570794,
        INPUT_CELLPHONE_CAMERA_FOCUS_LOCK = 1402389129,
        INPUT_CELLPHONE_CAMERA_GRID = 4227890197,
        INPUT_CELLPHONE_CAMERA_SELFIE = 2469585406,
        INPUT_CELLPHONE_CANCEL = 1137947507,
        INPUT_CELLPHONE_DOWN = 1095545579,
        INPUT_CELLPHONE_EXTRA_OPTION = 3182894066,
        INPUT_CELLPHONE_LEFT = 2205510738,
        INPUT_CELLPHONE_OPTION = 92143349,
        INPUT_CELLPHONE_RIGHT = 1166281373,
        INPUT_CELLPHONE_SCROLL_BACKWARD = 775241834,
        INPUT_CELLPHONE_SCROLL_FORWARD = 1686723916,
        INPUT_CELLPHONE_SELECT = 789791881,
        INPUT_CELLPHONE_UP = 3497044939,
        INPUT_CHARACTER_WHEEL = 2040159056,
        INPUT_CINEMATIC_SLOWMO = 3157769547,
        INPUT_CONTEXT = 2850467903,
        INPUT_CONTEXT_SECONDARY = 4249609636,
        INPUT_COVER = 2511156552,
        INPUT_CREATOR_ACCEPT = 2635425151,
        INPUT_CREATOR_DELETE = 1556386179,
        INPUT_CREATOR_LS = 2199043586,
        INPUT_CREATOR_LT = 2506220192,
        INPUT_CREATOR_MENU_TOGGLE = 1362397504,
        INPUT_CREATOR_RS = 1781563718,
        INPUT_CREATOR_RT = 2633459411,
        INPUT_CURSOR_ACCEPT = 4047924407,
        INPUT_CURSOR_CANCEL = 1283631161,
        INPUT_CURSOR_SCROLL_DOWN = 1116964245,
        INPUT_CURSOR_SCROLL_UP = 2684775656,
        INPUT_CURSOR_X = 1797840370,
        INPUT_CURSOR_Y = 1424142694,
        INPUT_DETONATE = 2909164717,
        INPUT_DIVE = 1071653992,
        INPUT_DROP_AMMO = 1825781776,
        INPUT_DROP_WEAPON = 1751331824,
        INPUT_DUCK = 405884375,
        INPUT_ENTER = 3138229389,
        INPUT_ENTER_CHEAT_CODE = 782780421,
        INPUT_FRONTEND_ACCEPT = 2144297219,
        INPUT_FRONTEND_AXIS_X = 2535383589,
        INPUT_FRONTEND_AXIS_Y = 1271548793,
        INPUT_FRONTEND_CANCEL = 4252177765,
        INPUT_FRONTEND_DELETE = 1555700889,
        INPUT_FRONTEND_DOWN = 2158412211,
        INPUT_FRONTEND_ENDSCREEN_ACCEPT = 184244163,
        INPUT_FRONTEND_ENDSCREEN_EXPAND = 1868158711,
        INPUT_FRONTEND_LB = 3354808144,
        INPUT_FRONTEND_LEADERBOARD = 2457357530,
        INPUT_FRONTEND_LEFT = 830007293,
        INPUT_FRONTEND_LS = 3037342076,
        INPUT_FRONTEND_LT = 926789109,
        INPUT_FRONTEND_PAUSE = 1623369316,
        INPUT_FRONTEND_PAUSE_ALTERNATE = 67839746,
        INPUT_FRONTEND_RB = 2861730045,
        INPUT_FRONTEND_RDOWN = 3941539001,
        INPUT_FRONTEND_RIGHT = 1752799004,
        INPUT_FRONTEND_RIGHT_AXIS_X = 2830767840,
        INPUT_FRONTEND_RIGHT_AXIS_Y = 3254471010,
        INPUT_FRONTEND_RLEFT = 4153167517,
        INPUT_FRONTEND_RRIGHT = 2383327225,
        INPUT_FRONTEND_RS = 1470817071,
        INPUT_FRONTEND_RT = 2716202916,
        INPUT_FRONTEND_RUP = 329401983,
        INPUT_FRONTEND_SELECT = 1349125062,
        INPUT_FRONTEND_SOCIAL_CLUB = 3503657456,
        INPUT_FRONTEND_SOCIAL_CLUB_SECONDARY = 2095936327,
        INPUT_FRONTEND_UP = 3817536545,
        INPUT_FRONTEND_X = 418061343,
        INPUT_FRONTEND_Y = 1188952068,
        INPUT_HUDMARKER_SELECT = 2560708802,
        INPUT_HUD_SPECIAL = 742855489,
        INPUT_INTERACTION_MENU = 4006463794,
        INPUT_JUMP = 1343024425,
        INPUT_LOOK_BEHIND = 1409898132,
        INPUT_LOOK_DOWN = 1288166320,
        INPUT_LOOK_DOWN_ONLY = 2784207982,
        INPUT_LOOK_LEFT = 2536452494,
        INPUT_LOOK_LEFT_ONLY = 3154982392,
        INPUT_LOOK_LR = 2225916103,
        INPUT_LOOK_RIGHT = 119553153,
        INPUT_LOOK_RIGHT_ONLY = 2090960669,
        INPUT_LOOK_UD = 3022789941,
        INPUT_LOOK_UP = 748031491,
        INPUT_LOOK_UP_ONLY = 2810156915,
        INPUT_MAP = 935409323,
        INPUT_MAP_POI = 2623729804,
        INPUT_MELEE_ATTACK1 = 1375725663,
        INPUT_MELEE_ATTACK2 = 1170231264,
        INPUT_MELEE_ATTACK_ALTERNATE = 3429316540,
        INPUT_MELEE_ATTACK_HEAVY = 2619415568,
        INPUT_MELEE_ATTACK_LIGHT = 2658542066,
        INPUT_MELEE_BLOCK = 238345546,
        INPUT_MOVE_DOWN = 1623615953,
        INPUT_MOVE_DOWN_ONLY = 500088000,
        INPUT_MOVE_LEFT = 4114746370,
        INPUT_MOVE_LEFT_ONLY = 1251661165,
        INPUT_MOVE_LR = 3201376412,
        INPUT_MOVE_RIGHT = 3603782825,
        INPUT_MOVE_RIGHT_ONLY = 3852684660,
        INPUT_MOVE_UD = 1153382018,
        INPUT_MOVE_UP = 3878746983,
        INPUT_MOVE_UP_ONLY = 329349306,
        INPUT_MP_TEXT_CHAT_ALL = 408479604,
        INPUT_MP_TEXT_CHAT_CREW = 2134975594,
        INPUT_MP_TEXT_CHAT_FRIENDS = 650537792,
        INPUT_MP_TEXT_CHAT_TEAM = 2928576929,
        INPUT_MULTIPLAYER_INFO = 1391066457,
        INPUT_NEXT_CAMERA = 3512590661,
        INPUT_NEXT_WEAPON = 1727785064,
        INPUT_PARACHUTE_BRAKE_LEFT = 2608113132,
        INPUT_PARACHUTE_BRAKE_RIGHT = 1971150005,
        INPUT_PARACHUTE_DEPLOY = 2737472807,
        INPUT_PARACHUTE_DETACH = 643033301,
        INPUT_PARACHUTE_PITCH_DOWN_ONLY = 2537457327,
        INPUT_PARACHUTE_PITCH_UD = 2016891903,
        INPUT_PARACHUTE_PITCH_UP_ONLY = 1172442440,
        INPUT_PARACHUTE_PRECISION_LANDING = 1158839945,
        INPUT_PARACHUTE_SMOKE = 3557557527,
        INPUT_PARACHUTE_TURN_LEFT_ONLY = 743063936,
        INPUT_PARACHUTE_TURN_LR = 1709952455,
        INPUT_PARACHUTE_TURN_RIGHT_ONLY = 848004805,
        INPUT_PHONE = 625050389,
        INPUT_PICKUP = 2194230028,
        INPUT_PREV_WEAPON = 3020739035,
        INPUT_PUSH_TO_TALK = 1964948176,
        INPUT_QUAD_LOCO_REVERSE = 2235375047,
        INPUT_RADIO_WHEEL_LR = 3454485081,
        INPUT_RADIO_WHEEL_UD = 2603339831,
        INPUT_RAPPEL_JUMP = 1610367849,
        INPUT_RAPPEL_LONG_JUMP = 3182179406,
        INPUT_RAPPEL_SMASH_WINDOW = 1892073077,
        INPUT_RELOAD = 884854559,
        INPUT_REPLAY_ADVANCE = 3764521445,
        INPUT_REPLAY_BACK = 3119889322,
        INPUT_REPLAY_CAMERADOWN = 776731050,
        INPUT_REPLAY_CAMERAUP = 2855452051,
        INPUT_REPLAY_CLIP_DELETE = 3355217423,
        INPUT_REPLAY_CTRL = 2227111649,
        INPUT_REPLAY_CYCLEMARKERLEFT = 2226379461,
        INPUT_REPLAY_CYCLEMARKERRIGHT = 631661439,
        INPUT_REPLAY_ENDPOINT = 2685667865,
        INPUT_REPLAY_FFWD = 180542761,
        INPUT_REPLAY_FOVDECREASE = 1379776398,
        INPUT_REPLAY_FOVINCREASE = 2103117691,
        INPUT_REPLAY_HIDEHUD = 547837860,
        INPUT_REPLAY_MARKER_DELETE = 4280635620,
        INPUT_REPLAY_NEWMARKER = 925253493,
        INPUT_REPLAY_PAUSE = 2262270131,
        INPUT_REPLAY_PREVIEW = 431976419,
        INPUT_REPLAY_PREVIEW_AUDIO = 2918336066,
        INPUT_REPLAY_RECORD = 627988549,
        INPUT_REPLAY_RESTART = 507809449,
        INPUT_REPLAY_REWIND = 1663447887,
        INPUT_REPLAY_SAVE = 76895390,
        INPUT_REPLAY_SCREENSHOT = 4020608944,
        INPUT_REPLAY_SHOWHOTKEY = 3096802935,
        INPUT_REPLAY_SNAPMATIC_PHOTO = 3247285515,
        INPUT_REPLAY_STARTPOINT = 3417788986,
        INPUT_REPLAY_START_STOP_RECORDING = 4038195464,
        INPUT_REPLAY_START_STOP_RECORDING_SECONDARY = 3126202165,
        INPUT_REPLAY_TIMELINE_DUPLICATE_CLIP = 1925864500,
        INPUT_REPLAY_TIMELINE_PICKUP_CLIP = 3162639305,
        INPUT_REPLAY_TIMELINE_PLACE_CLIP = 3204284951,
        INPUT_REPLAY_TIMELINE_SAVE = 3022640124,
        INPUT_REPLAY_TOGGLETIME = 2084400190,
        INPUT_REPLAY_TOGGLETIPS = 3855061984,
        INPUT_REPLAY_TOGGLE_TIMELINE = 717974462,
        INPUT_REPLAY_TOOLS = 2797698276,
        INPUT_RESPAWN_FASTER = 3296882373,
        INPUT_SAVE_REPLAY_CLIP = 2703850841,
        INPUT_SCALED_LOOK_DOWN_ONLY = 3067253246,
        INPUT_SCALED_LOOK_LEFT_ONLY = 3678119471,
        INPUT_SCALED_LOOK_LR = 3204720014,
        INPUT_SCALED_LOOK_RIGHT_ONLY = 338437718,
        INPUT_SCALED_LOOK_UD = 883328637,
        INPUT_SCALED_LOOK_UP_ONLY = 4054770656,
        INPUT_SCRIPTED_FLY_LR = 3831690375,
        INPUT_SCRIPTED_FLY_UD = 1720615616,
        INPUT_SCRIPTED_FLY_ZDOWN = 362217418,
        INPUT_SCRIPTED_FLY_ZUP = 3134671158,
        INPUT_SCRIPT_LB = 3735155741,
        INPUT_SCRIPT_LEFT_AXIS_X = 1990155375,
        INPUT_SCRIPT_LEFT_AXIS_Y = 2223372348,
        INPUT_SCRIPT_LS = 3469235286,
        INPUT_SCRIPT_LT = 3783948762,
        INPUT_SCRIPT_PAD_DOWN = 2567758809,
        INPUT_SCRIPT_PAD_LEFT = 3970344293,
        INPUT_SCRIPT_PAD_RIGHT = 1755927531,
        INPUT_SCRIPT_PAD_UP = 2547147404,
        INPUT_SCRIPT_RB = 2679012595,
        INPUT_SCRIPT_RDOWN = 940075263,
        INPUT_SCRIPT_RIGHT_AXIS_X = 862515474,
        INPUT_SCRIPT_RIGHT_AXIS_Y = 649156543,
        INPUT_SCRIPT_RLEFT = 4071305340,
        INPUT_SCRIPT_RRIGHT = 338728142,
        INPUT_SCRIPT_RS = 4245174193,
        INPUT_SCRIPT_RT = 3326265895,
        INPUT_SCRIPT_RUP = 404161249,
        INPUT_SCRIPT_SELECT = 3808903465,
        INPUT_SELECT_CHARACTER_FRANKLIN = 3034237285,
        INPUT_SELECT_CHARACTER_MICHAEL = 3519919863,
        INPUT_SELECT_CHARACTER_MULTIPLAYER = 2600053024,
        INPUT_SELECT_CHARACTER_TREVOR = 3139661680,
        INPUT_SELECT_NEXT_WEAPON = 4268995938,
        INPUT_SELECT_PREV_WEAPON = 1414655949,
        INPUT_SELECT_WEAPON = 179289272,
        INPUT_SELECT_WEAPON_AUTO_RIFLE = 808663118,
        INPUT_SELECT_WEAPON_HANDGUN = 169184612,
        INPUT_SELECT_WEAPON_HEAVY = 4291814330,
        INPUT_SELECT_WEAPON_MELEE = 589126537,
        INPUT_SELECT_WEAPON_SHOTGUN = 3158319259,
        INPUT_SELECT_WEAPON_SMG = 4278488860,
        INPUT_SELECT_WEAPON_SNIPER = 2344828336,
        INPUT_SELECT_WEAPON_SPECIAL = 1148907708,
        INPUT_SELECT_WEAPON_UNARMED = 1830620984,
        INPUT_SKIP_CUTSCENE = 2808419464,
        INPUT_SNIPER_ZOOM = 829254971,
        INPUT_SNIPER_ZOOM_IN = 799112387,
        INPUT_SNIPER_ZOOM_IN_ALTERNATE = 2642641007,
        INPUT_SNIPER_ZOOM_IN_ONLY = 1111416703,
        INPUT_SNIPER_ZOOM_IN_SECONDARY = 2299678765,
        INPUT_SNIPER_ZOOM_OUT = 1204001560,
        INPUT_SNIPER_ZOOM_OUT_ALTERNATE = 1479967133,
        INPUT_SNIPER_ZOOM_OUT_ONLY = 3551708493,
        INPUT_SNIPER_ZOOM_OUT_SECONDARY = 3090723860,
        INPUT_SPECIAL_ABILITY = 1859199356,
        INPUT_SPECIAL_ABILITY_PC = 3719892208,
        INPUT_SPECIAL_ABILITY_SECONDARY = 2031468423,
        INPUT_SPRINT = 88070011,
        INPUT_SWITCH_VISOR = 359311739,
        INPUT_TALK = 3236847518,
        INPUT_THROW_GRENADE = 1841875526,
        INPUT_VEH_ACCELERATE = 47982572,
        INPUT_VEH_AIM = 59638093,
        INPUT_VEH_ATTACK = 3141727475,
        INPUT_VEH_ATTACK2 = 2115964689,
        INPUT_VEH_BIKE_WINGS = 181855776,
        INPUT_VEH_BRAKE = 840426685,
        INPUT_VEH_CAR_JUMP = 1502789112,
        INPUT_VEH_CINEMATIC_DOWN_ONLY = 2997101950,
        INPUT_VEH_CINEMATIC_LR = 1893950461,
        INPUT_VEH_CINEMATIC_UD = 1718419212,
        INPUT_VEH_CINEMATIC_UP_ONLY = 1225801262,
        INPUT_VEH_CIN_CAM = 2488558092,
        INPUT_VEH_DRIVE_LOOK = 2666822429,
        INPUT_VEH_DRIVE_LOOK2 = 3631598574,
        INPUT_VEH_DROP_PROJECTILE = 2073075309,
        INPUT_VEH_DUCK = 3435259568,
        INPUT_VEH_EXIT = 2815774396,
        INPUT_VEH_FLY_ATTACK = 4072317510,
        INPUT_VEH_FLY_ATTACK2 = 1749322681,
        INPUT_VEH_FLY_ATTACK_CAMERA = 3210694407,
        INPUT_VEH_FLY_BOMB_BAY = 1453660874,
        INPUT_VEH_FLY_BOOST = 1471352018,
        INPUT_VEH_FLY_COUNTER = 3565029129,
        INPUT_VEH_FLY_DUCK = 189430161,
        INPUT_VEH_FLY_MOUSE_CONTROL_OVERRIDE = 381792802,
        INPUT_VEH_FLY_PITCH_DOWN_ONLY = 2769556013,
        INPUT_VEH_FLY_PITCH_UD = 1403305021,
        INPUT_VEH_FLY_PITCH_UP_ONLY = 3643414310,
        INPUT_VEH_FLY_ROLL_LEFT_ONLY = 76673566,
        INPUT_VEH_FLY_ROLL_LR = 1834567154,
        INPUT_VEH_FLY_ROLL_RIGHT_ONLY = 2872467357,
        INPUT_VEH_FLY_SELECT_NEXT_WEAPON = 292062217,
        INPUT_VEH_FLY_SELECT_PREV_WEAPON = 3193714487,
        INPUT_VEH_FLY_SELECT_TARGET_LEFT = 408310876,
        INPUT_VEH_FLY_SELECT_TARGET_RIGHT = 897940990,
        INPUT_VEH_FLY_THROTTLE_DOWN = 130011569,
        INPUT_VEH_FLY_THROTTLE_UP = 3457551859,
        INPUT_VEH_FLY_UNDERCARRIAGE = 558981014,
        INPUT_VEH_FLY_VERTICAL_FLIGHT_MODE = 3469142594,
        INPUT_VEH_FLY_YAW_LEFT = 809359241,
        INPUT_VEH_FLY_YAW_RIGHT = 1046391663,
        INPUT_VEH_GRAPPLING_HOOK = 2621914537,
        INPUT_VEH_GUN_DOWN = 781412763,
        INPUT_VEH_GUN_LEFT = 3204561162,
        INPUT_VEH_GUN_LR = 3856540924,
        INPUT_VEH_GUN_RIGHT = 174039845,
        INPUT_VEH_GUN_UD = 2627697420,
        INPUT_VEH_GUN_UP = 1789237013,
        INPUT_VEH_HANDBRAKE = 203172460,
        INPUT_VEH_HEADLIGHT = 4081473041,
        INPUT_VEH_HORN = 2054145322,
        INPUT_VEH_HOTWIRE_LEFT = 1681858171,
        INPUT_VEH_HOTWIRE_RIGHT = 2897691151,
        INPUT_VEH_HYDRAULICS_CONTROL_DOWN = 2670244735,
        INPUT_VEH_HYDRAULICS_CONTROL_LEFT = 3768906261,
        INPUT_VEH_HYDRAULICS_CONTROL_LR = 2508921349,
        INPUT_VEH_HYDRAULICS_CONTROL_RIGHT = 3044573053,
        INPUT_VEH_HYDRAULICS_CONTROL_TOGGLE = 3933456627,
        INPUT_VEH_HYDRAULICS_CONTROL_UD = 4237324954,
        INPUT_VEH_HYDRAULICS_CONTROL_UP = 1966138277,
        INPUT_VEH_JUMP = 1684768168,
        INPUT_VEH_LOOK_BEHIND = 3357902730,
        INPUT_VEH_LOOK_LEFT = 885153785,
        INPUT_VEH_LOOK_RIGHT = 1275018444,
        INPUT_VEH_MELEE_HOLD = 3691810706,
        INPUT_VEH_MELEE_LEFT = 1478895958,
        INPUT_VEH_MELEE_RIGHT = 3175285777,
        INPUT_VEH_MOUSE_CONTROL_OVERRIDE = 1534070235,
        INPUT_VEH_MOVE_DOWN = 2333835617,
        INPUT_VEH_MOVE_DOWN_ONLY = 1393724998,
        INPUT_VEH_MOVE_LEFT = 2226041824,
        INPUT_VEH_MOVE_LEFT_ONLY = 1875727813,
        INPUT_VEH_MOVE_LR = 3673773705,
        INPUT_VEH_MOVE_RIGHT = 4079653481,
        INPUT_VEH_MOVE_RIGHT_ONLY = 630842363,
        INPUT_VEH_MOVE_UD = 2967008801,
        INPUT_VEH_MOVE_UP = 4102749572,
        INPUT_VEH_MOVE_UP_ONLY = 3218217476,
        INPUT_VEH_NEXT_RADIO = 3168363729,
        INPUT_VEH_NEXT_RADIO_TRACK = 3678970921,
        INPUT_VEH_PARACHUTE = 1178878044,
        INPUT_VEH_PASSENGER_AIM = 4196763550,
        INPUT_VEH_PASSENGER_ATTACK = 3477575942,
        INPUT_VEH_PREV_RADIO = 2052296516,
        INPUT_VEH_PREV_RADIO_TRACK = 2101387475,
        INPUT_VEH_PUSHBIKE_FRONT_BRAKE = 493726448,
        INPUT_VEH_PUSHBIKE_PEDAL = 3959957371,
        INPUT_VEH_PUSHBIKE_REAR_BRAKE = 2168474790,
        INPUT_VEH_PUSHBIKE_SPRINT = 3633944518,
        INPUT_VEH_RADIO_WHEEL = 762986085,
        INPUT_VEH_ROCKET_BOOST = 1497980673,
        INPUT_VEH_ROOF = 3019140202,
        INPUT_VEH_SELECT_NEXT_WEAPON = 1778383716,
        INPUT_VEH_SELECT_PREV_WEAPON = 1294241594,
        INPUT_VEH_SHUFFLE = 2578675640,
        INPUT_VEH_SLOWMO_DOWN_ONLY = 2710528782,
        INPUT_VEH_SLOWMO_UD = 1943269945,
        INPUT_VEH_SLOWMO_UP_ONLY = 2427253065,
        INPUT_VEH_SPECIAL = 3797895405,
        INPUT_VEH_SPECIAL_ABILITY_FRANKLIN = 4051339349,
        INPUT_VEH_STUNT_UD = 2250516087,
        INPUT_VEH_SUB_ASCEND = 2903129997,
        INPUT_VEH_SUB_DESCEND = 1546294775,
        INPUT_VEH_SUB_MOUSE_CONTROL_OVERRIDE = 1108250836,
        INPUT_VEH_SUB_PITCH_DOWN_ONLY = 1800156146,
        INPUT_VEH_SUB_PITCH_UD = 1550008645,
        INPUT_VEH_SUB_PITCH_UP_ONLY = 590716120,
        INPUT_VEH_SUB_THROTTLE_DOWN = 1975195744,
        INPUT_VEH_SUB_THROTTLE_UP = 3008682264,
        INPUT_VEH_SUB_TURN_HARD_LEFT = 4292162160,
        INPUT_VEH_SUB_TURN_HARD_RIGHT = 1490159289,
        INPUT_VEH_SUB_TURN_LEFT_ONLY = 1304913018,
        INPUT_VEH_SUB_TURN_LR = 155403714,
        INPUT_VEH_SUB_TURN_RIGHT_ONLY = 2931344732,
        INPUT_VEH_TRANSFORM = 2961507185,
        INPUT_WEAPON_SPECIAL = 2919440053,
        INPUT_WEAPON_SPECIAL_TWO = 4279699275,
        INPUT_WEAPON_WHEEL_LR = 3844898319,
        INPUT_WEAPON_WHEEL_NEXT = 3882584395,
        INPUT_WEAPON_WHEEL_PREV = 2351477924,
        INPUT_WEAPON_WHEEL_UD = 2327076976,
        INPUT_WHISTLE = 317509817,
        INSTANT_HIT = 1055676189,
        INT = 1183390195,
        INT64 = 609598946,
        INVALID = 4049052067,
        IOMS_DIGITALBUTTON_AXIS = 205904632,
        IOMS_FORCE32 = 685816510,
        IOMS_GAME_CONTROLLED = 4139224846,
        IOMS_JOYSTICK_AXIS = 1587012279,
        IOMS_JOYSTICK_AXIS_NEGATIVE = 4262056748,
        IOMS_JOYSTICK_AXIS_POSITIVE = 501002218,
        IOMS_JOYSTICK_BUTTON = 40227529,
        IOMS_JOYSTICK_IAXIS = 3043504654,
        IOMS_JOYSTICK_POV = 2134497902,
        IOMS_JOYSTICK_POV_AXIS = 1815801467,
        IOMS_KEYBOARD = 1758929672,
        IOMS_MKB_AXIS = 3818040865,
        IOMS_MOUSE_ABSOLUTEAXIS = 3186496143,
        IOMS_MOUSE_BUTTON = 2849699847,
        IOMS_MOUSE_BUTTONANY = 3785921450,
        IOMS_MOUSE_CENTEREDAXIS = 1586651573,
        IOMS_MOUSE_NORMALIZED = 2684940208,
        IOMS_MOUSE_RELATIVEAXIS = 2892490540,
        IOMS_MOUSE_SCALEDAXIS = 4196697743,
        IOMS_MOUSE_WHEEL = 4225263318,
        IOMS_PAD_ANALOGBUTTON = 2018953230,
        IOMS_PAD_AXIS = 2541568659,
        IOMS_PAD_DEBUGBUTTON = 325485481,
        IOMS_PAD_DIGITALBUTTON = 3096563302,
        IOMS_PAD_DIGITALBUTTONANY = 2903158239,
        IOMS_TOUCHPAD_ABSOLUTE_AXIS = 2119957173,
        IOMS_TOUCHPAD_CENTERED_AXIS = 3499887056,
        IOMS_UNDEFINED = 2540504455,
        IOM_ANY_BUTTON = 41172768,
        IOM_AXIS_DPADX = 687124234,
        IOM_AXIS_DPADY = 859227022,
        IOM_AXIS_LDL = 200723788,
        IOM_AXIS_LDOWN = 3900984257,
        IOM_AXIS_LDR = 2722494972,
        IOM_AXIS_LLEFT = 3033251377,
        IOM_AXIS_LRIGHT = 3774991424,
        IOM_AXIS_LUL = 263121013,
        IOM_AXIS_LUP = 1685328382,
        IOM_AXIS_LUR = 2315771173,
        IOM_AXIS_LX = 2931014176,
        IOM_AXIS_LX_LEFT = 3783518653,
        IOM_AXIS_LX_RIGHT = 2495959808,
        IOM_AXIS_LY = 1565595484,
        IOM_AXIS_LY_DOWN = 705434244,
        IOM_AXIS_LY_UP = 3904214413,
        IOM_AXIS_RDL = 3307696000,
        IOM_AXIS_RDOWN = 3915938973,
        IOM_AXIS_RDR = 4087401578,
        IOM_AXIS_RLEFT = 1825261852,
        IOM_AXIS_RRIGHT = 3839715530,
        IOM_AXIS_RUL = 3409441365,
        IOM_AXIS_RUP = 3530096823,
        IOM_AXIS_RUR = 924863004,
        IOM_AXIS_RX = 221769807,
        IOM_AXIS_RX_LEFT = 4078085248,
        IOM_AXIS_RX_RIGHT = 2348253211,
        IOM_AXIS_RY = 3480417430,
        IOM_AXIS_RY_DOWN = 123156857,
        IOM_AXIS_RY_UP = 384948296,
        IOM_AXIS_UNDEFINED = 1914196731,
        IOM_AXIS_WHEEL = 2497062215,
        IOM_AXIS_WHEEL_DELTA = 3282783820,
        IOM_AXIS_WHEEL_RELATIVE = 2457453293,
        IOM_AXIS_X = 2992732058,
        IOM_AXIS_X_LEFT = 3245412292,
        IOM_AXIS_X_RIGHT = 102253818,
        IOM_AXIS_Y = 3904791635,
        IOM_AXIS_Y_DOWN = 1985405305,
        IOM_AXIS_Y_UP = 2371538931,
        IOM_IAXIS_WHEEL = 287918064,
        IOM_IAXIS_WHEEL_DELTA = 504333125,
        IOM_IAXIS_WHEEL_RELATIVE = 2988191114,
        IOM_IAXIS_X = 181504241,
        IOM_IAXIS_Y = 4185220661,
        IOM_JOYSTICK_AXIS1 = 1028856113,
        IOM_JOYSTICK_AXIS2 = 4070474701,
        IOM_JOYSTICK_AXIS3 = 3827295944,
        IOM_JOYSTICK_AXIS4 = 723580113,
        IOM_JOYSTICK_AXIS5 = 140095299,
        IOM_JOYSTICK_AXIS6 = 3101495363,
        IOM_JOYSTICK_AXIS7 = 2872472822,
        IOM_JOYSTICK_AXIS8 = 3726105272,
        IOM_JOYSTICK_BUTTON1 = 99663245,
        IOM_JOYSTICK_BUTTON10 = 573737200,
        IOM_JOYSTICK_BUTTON11 = 868822045,
        IOM_JOYSTICK_BUTTON12 = 2121187687,
        IOM_JOYSTICK_BUTTON13 = 2419614970,
        IOM_JOYSTICK_BUTTON14 = 482573842,
        IOM_JOYSTICK_BUTTON15 = 3868004774,
        IOM_JOYSTICK_BUTTON16 = 4184913773,
        IOM_JOYSTICK_BUTTON17 = 1395813103,
        IOM_JOYSTICK_BUTTON18 = 2543383511,
        IOM_JOYSTICK_BUTTON19 = 2365775531,
        IOM_JOYSTICK_BUTTON2 = 3206459366,
        IOM_JOYSTICK_BUTTON20 = 917188189,
        IOM_JOYSTICK_BUTTON21 = 612600334,
        IOM_JOYSTICK_BUTTON22 = 323053450,
        IOM_JOYSTICK_BUTTON23 = 16696069,
        IOM_JOYSTICK_BUTTON24 = 2284605790,
        IOM_JOYSTICK_BUTTON25 = 1724518042,
        IOM_JOYSTICK_BUTTON26 = 1419536959,
        IOM_JOYSTICK_BUTTON27 = 1129662385,
        IOM_JOYSTICK_BUTTON28 = 3239166760,
        IOM_JOYSTICK_BUTTON29 = 3152394448,
        IOM_JOYSTICK_BUTTON3 = 3362505344,
        IOM_JOYSTICK_BUTTON30 = 3002935403,
        IOM_JOYSTICK_BUTTON31 = 2234928350,
        IOM_JOYSTICK_BUTTON32 = 2405916992,
        IOM_JOYSTICK_BUTTON4 = 2711811311,
        IOM_JOYSTICK_BUTTON5 = 2902133663,
        IOM_JOYSTICK_BUTTON6 = 2708862105,
        IOM_JOYSTICK_BUTTON7 = 2898266925,
        IOM_JOYSTICK_BUTTON8 = 2246720898,
        IOM_JOYSTICK_BUTTON9 = 2403684408,
        IOM_POV1_DOWN = 699771928,
        IOM_POV1_LEFT = 3241830413,
        IOM_POV1_RIGHT = 276960579,
        IOM_POV1_UP = 1251096478,
        IOM_POV2_DOWN = 1756838074,
        IOM_POV2_LEFT = 2172945817,
        IOM_POV2_RIGHT = 3640545514,
        IOM_POV2_UP = 3752163555,
        IOM_POV3_DOWN = 2550511608,
        IOM_POV3_LEFT = 308978158,
        IOM_POV3_RIGHT = 1432291911,
        IOM_POV3_UP = 3127415417,
        IOM_POV4_DOWN = 2158689992,
        IOM_POV4_LEFT = 4174001609,
        IOM_POV4_RIGHT = 2154597711,
        IOM_POV4_UP = 1805161023,
        IOM_POV_UNDEFINED = 706235126,
        IOM_UNDEFINED = 2244764150,
        IOM_WHEEL_DOWN = 4037058295,
        IOM_WHEEL_UNDEFINED = 2828673421,
        IOM_WHEEL_UP = 4231611583,
        IO_AND_IMPULSE_1 = 985643743,
        IO_OR_IMPULSE_1 = 3415911302,
        IS_COMBO_1 = 3858128101,
        IS_COMBO_2 = 4088854630,
        IS_COMBO_3 = 3169061569,
        IS_COMBO_ANY = 1122944859,
        IS_DOWN = 1194621368,
        IS_HELD_DOWN = 1096503938,
        IS_HELD_UP = 1036043138,
        IS_NONE = 482873228,
        IS_PRESSED = 1063934028,
        IS_PRESSED_NO_HISTORY = 3958400278,
        IS_RELEASED = 1595929134,
        I_ANALOG_FROM_CENTER = 1421213741,
        I_ANALOG_LEFT_RIGHT = 1273643255,
        I_ANALOG_UP_DOWN = 268291912,
        I_ATTACK_ALTERNATE = 1198477259,
        I_ATTACK_HEAVY = 1666594290,
        I_ATTACK_LIGHT = 707154474,
        I_BLOCK = 2019916721,
        I_FIRE = 3525163189,
        I_NONE = 1749798495,
        I_SPECIAL_ABILITY = 2198881676,
        I_SPECIAL_ABILITY_SECONDARY = 1061664740,
        Icon = 821894802,
        IdealTurnApproachRateSlow = 190400066,
        IdenticalMappingLists = 152454037,
        IdentsHistorySpace = 3817313015,
        IdentsHistoryWriteIndex = 988284272,
        IdleCamera = 3127376499,
        IdlePhaseBasedOnTrigger = 3144784229,
        IdleShakeRef = 3464513788,
        IgnoreAmmoCheck = 130044670,
        IgnoreAnimReloadRateModifiers = 1526482194,
        IgnoreDelaysOnGunshotEvents = 1707709329,
        IgnoreForcedFailure = 951289481,
        IgnoreFrontSeatsWhenOnVehicle = 3389529838,
        IgnoreHelmets = 1028631947,
        IgnoreHomingCloseThresholdCheck = 341603663,
        IgnoreHonkedAt = 2288030622,
        IgnoreHostility = 1124923891,
        IgnoreLowPriShockingEvents = 3958766309,
        IgnoreLowShockingEvents = 2752545550,
        IgnoreMovingTowardsLeaderTargetRadiusExpansion = 979824388,
        IgnoreNavMesh = 2379207187,
        IgnoreObjectMass = 872123473,
        IgnoreObstructions = 2136140159,
        IgnorePavementCheckWhenLeavingScenarios = 3213801984,
        IgnoreScenarioPointHeading = 2627991456,
        IgnoreScenarioPointHeadingOnExit = 777112328,
        IgnoreSlideToCoordOnArrival = 858270096,
        IgnoreSlideToCoordOnExit = 1339033576,
        IgnoreSmashWindowCheck = 2948765959,
        IgnoreStrafing = 486583235,
        IgnoreThreatsIfLosNotClear = 536864854,
        IgnoreTracerVfxMuzzleDirectionCheck = 3870113456,
        IgnoreWorldGeometryDuringExitProbeCheck = 3148082913,
        IkRecoilDisplacement = 3467969092,
        IkRecoilDisplacementScaleBackward = 3087466579,
        IkRecoilDisplacementScaleVertical = 1183738509,
        IkRecoilDisplacementScope = 3842999506,
        ImmediateDetectionRange = 2813819278,
        ImmediateExitBlendOutDuration = 356066671,
        Impulse = 1513043914,
        ImpulseOp = 3286539829,
        ImpulseTest = 1282034689,
        InCarPickupActions = 1283609491,
        InHeliRadiusMultiplier = 1832415970,
        InVehicleBulletBendingFarMaxVelocity = 493048149,
        InVehicleBulletBendingFarMinVelocity = 922516025,
        InVehicleBulletBendingMaxVelocity = 2549641570,
        InVehicleBulletBendingNearMaxVelocity = 3926385305,
        InVehicleBulletBendingNearMinVelocity = 1976544803,
        InVehicleMaxMouseSensitivity = 1985451076,
        InVehicleMinMouseSensitivity = 2801281328,
        InVehicleMouseSensitivityPower = 1465558728,
        InVehicleMoveNetwork = 3581703671,
        InVehicleOverrideInfos = 655391290,
        Incendiary = 1314104774,
        IncendiaryGuaranteedChance = 2899672565,
        InfiniteAmmo = 321565114,
        InflationScale = 929736238,
        InfoBlobName = 3047462439,
        InformationFlags = 3631358337,
        Initial = 2979914327,
        InitialAdjustFinishedHeadingTolerance = 2949666078,
        InitialAdjustFinishedPitchTolerance = 705780320,
        InitialRumbleDuration = 285327152,
        InitialRumbleDurationFps = 3064765784,
        InitialRumbleIntensity = 1641061951,
        InitialRumbleIntensityFps = 1077308171,
        InitialRumbleIntensityTrigger = 3552813012,
        InitialScreen = 3285682590,
        InitialState = 3763663756,
        InitiallyDisabled = 780604422,
        InitiallyInvisible = 193648491,
        InitiallyVisible = 1782025202,
        InjuredHealthThreshold = 1332715573,
        Input = 2649747373,
        InputGroup = 354937576,
        InputGroupDefinitions = 1486760678,
        InputThreshold = 1547357278,
        InputYAxisQuitValueAimDirect = 927329696,
        Input_NoBack = 1519323785,
        Input_NoBackIfNavigating = 2234132790,
        Input_NoTabChange = 2729828012,
        Inputs = 2236968009,
        InsideClipSetMap = 3124959932,
        InstMat = 2129054787,
        InstalledPackages = 1591181811,
        InstanceCreationTiedToSpawnProbability = 2587690362,
        Instances = 2391519885,
        Int64Data = 904190632,
        IntData = 140436044,
        IntensityFlickerFrequency = 3212516962,
        IntensityFlickerMax = 65514336,
        IntensityFlickerMin = 642868927,
        IntensityLevelDecayMax = 606620755,
        IntensityLevelDecayMin = 158579993,
        IntensityMax = 833220542,
        IntensityMin = 3465954584,
        IntensityMinClamp = 2108285692,
        InteriorBoxIDX = 968729076,
        InteriorMaxPosition = 2335404530,
        InteriorName = 1594663562,
        InteriorPosition = 4140712533,
        InterpolateOutDuration = 1044764307,
        InterpolationValue = 2057494,
        InterrelationTest = 4087820158,
        IntroBlendInDuration = 2550945774,
        IntroRateToPeekFPS = 2875886470,
        Invalid = 2396344338,
        InvalidForStationaryPeds = 2970212040,
        InvalidIfFriendlyWithTarget = 1157038138,
        InvalidIfHasARider = 1037291870,
        InvalidIfMissionPedInMP = 2397272138,
        InvalidIfOtherVehicleIsYourVehicle = 2323217040,
        InvalidIfSourceEntityIsOtherEntity = 3610098698,
        InvalidIfSourceIsAnAnimal = 1400985122,
        InvalidIfSourcePed = 936541012,
        InvalidIfTargetDoesNotInfluenceWanted = 2143774242,
        InvalidIfThereAreAttackingSharks = 2061716826,
        InvalidInAnInterior = 1798994321,
        InvalidInCrosswalk = 2483769483,
        InvalidWhenAfraid = 3042397046,
        InvertSense = 1412194645,
        Invincible = 3784312151,
        InvisibleWhenCarried = 1269350801,
        IsAggressive = 364410579,
        IsArrest = 89928852,
        IsConversation = 1229078097,
        IsExercising = 3489521999,
        IsExtraShuffleSeat = 1483044857,
        IsFixie = 1472311084,
        IsForcingMotionBlur = 2385481086,
        IsFriendFollowedByPlayer = 2617746299,
        IsFriendlyWithTarget = 3650804570,
        IsFrontSeat = 1637273836,
        IsHarassing = 198434010,
        IsHostile = 866540710,
        IsIdleSeat = 3022393878,
        IsIgnored = 3629724197,
        IsInGangTerritory = 1607722601,
        IsInsulting = 767340243,
        IsInvisible = 3868557273,
        IsLowerPrioritySeatInSP = 2747742530,
        IsMutuallyExclusive = 864287803,
        IsNotFriendlyWithTarget = 1902784515,
        IsNotThreatenedByTarget = 2819644999,
        IsPassengerOnlyEntry = 1606944129,
        IsPlaneHatchEntry = 307035319,
        IsRant = 1419170079,
        IsRidable = 3819408624,
        IsSkyDive = 65939262,
        IsSynchronized = 3299721188,
        IsTargetCop = 1395082312,
        IsTargetFat = 1966394767,
        IsTargetGang = 1726351689,
        IsTargetHot = 191344916,
        IsTargetMale = 3156765346,
        IsTargetNotFriendlyWithUs = 3042122830,
        IsTargetNotMale = 1561005276,
        IsTargetNotPlayer = 1720208513,
        IsTargetOnFoot = 3690754752,
        IsTargetPlayer = 2650093651,
        IsThreatenedByTarget = 1877320295,
        IsUsingScenario = 832147283,
        JackIncludesGetIn = 3403723175,
        JackVariationsIncludeGetIn = 122738419,
        JackingAnims = 195834659,
        JetpackData = 973020790,
        JointDOFs = 4094145160,
        JoystickParameter = 1972431045,
        JoystickSource = 2417005077,
        JumpClipSetHash = 2759572360,
        JumpMenuId = 1942845269,
        JumpNetworkName = 2456428196,
        JumpUpperbodyClipSetHash = 3594428407,
        JunctionMap = 3812595008,
        KEY_0 = 3467290491,
        KEY_1 = 3060922090,
        KEY_2 = 2812795222,
        KEY_3 = 2452368991,
        KEY_4 = 2230653937,
        KEY_5 = 1588873072,
        KEY_6 = 286239780,
        KEY_7 = 993198190,
        KEY_8 = 1837229323,
        KEY_9 = 600887718,
        KEY_A = 1358867457,
        KEY_ADD = 1974972064,
        KEY_APOSTROPHE = 796424548,
        KEY_APPS = 4191107328,
        KEY_B = 1138594239,
        KEY_BACK = 3831042796,
        KEY_BACKSLASH = 360996472,
        KEY_C = 2900714445,
        KEY_CAPITAL = 1876528061,
        KEY_CHATPAD_GREEN_SHIFT = 2139054883,
        KEY_CHATPAD_ORANGE_SHIFT = 4265517720,
        KEY_COMMA = 2354608696,
        KEY_D = 2655962784,
        KEY_DECIMAL = 2457960122,
        KEY_DELETE = 177228844,
        KEY_DIVIDE = 2052973622,
        KEY_DOWN = 3439712993,
        KEY_E = 394901780,
        KEY_END = 3390043815,
        KEY_EQUALS = 3196146303,
        KEY_ESCAPE = 1372861672,
        KEY_F = 165420473,
        KEY_F1 = 3889430405,
        KEY_F10 = 727838429,
        KEY_F11 = 3166704027,
        KEY_F12 = 3486169008,
        KEY_F13 = 3783580452,
        KEY_F14 = 1950089364,
        KEY_F15 = 2248582185,
        KEY_F16 = 1946484778,
        KEY_F17 = 2251531399,
        KEY_F18 = 2558052625,
        KEY_F19 = 2867752444,
        KEY_F2 = 1704360716,
        KEY_F20 = 1492341251,
        KEY_F21 = 1804990280,
        KEY_F22 = 2107382604,
        KEY_F23 = 2421965004,
        KEY_F24 = 2719933521,
        KEY_F3 = 1381717142,
        KEY_F4 = 1078571123,
        KEY_F5 = 787975631,
        KEY_F6 = 2404765310,
        KEY_F7 = 2064688628,
        KEY_F8 = 1807419209,
        KEY_F9 = 1501913822,
        KEY_G = 1933308027,
        KEY_GRAVE = 3783057065,
        KEY_H = 1701401814,
        KEY_HOME = 108247981,
        KEY_I = 3274805349,
        KEY_INSERT = 3243229678,
        KEY_J = 4101993216,
        KEY_K = 512771873,
        KEY_L = 3504450501,
        KEY_LBRACKET = 2369544130,
        KEY_LCONTROL = 3991008978,
        KEY_LEFT = 603088983,
        KEY_LMENU = 3977954873,
        KEY_LSHIFT = 339015384,
        KEY_LWIN = 2739406906,
        KEY_M = 2328666040,
        KEY_MINUS = 3129196875,
        KEY_MULTIPLY = 4275759379,
        KEY_N = 2626011946,
        KEY_NEXT = 3081012049,
        KEY_NULL = 4203281447,
        KEY_NUMLOCK = 3863113356,
        KEY_NUMPAD0 = 1771182672,
        KEY_NUMPAD1 = 3696263115,
        KEY_NUMPAD2 = 2239091223,
        KEY_NUMPAD3 = 2010789600,
        KEY_NUMPAD4 = 2701756734,
        KEY_NUMPAD5 = 322563485,
        KEY_NUMPAD6 = 3227207649,
        KEY_NUMPAD7 = 2929042518,
        KEY_NUMPAD8 = 1330079159,
        KEY_NUMPAD9 = 1098271253,
        KEY_NUMPADENTER = 3228616563,
        KEY_NUMPADEQUALS = 3099029281,
        KEY_O = 3855275415,
        KEY_OEM_1 = 88177605,
        KEY_OEM_102 = 2531356644,
        KEY_OEM_2 = 189761509,
        KEY_OEM_3 = 2312373484,
        KEY_OEM_4 = 2540150803,
        KEY_OEM_5 = 2925121015,
        KEY_OEM_6 = 3157289380,
        KEY_OEM_7 = 2304902160,
        KEY_P = 2547661267,
        KEY_PAGEDOWN = 1970286556,
        KEY_PAGEUP = 1928288120,
        KEY_PAUSE = 127638432,
        KEY_PERIOD = 1482287901,
        KEY_PLUS = 603020945,
        KEY_PRIOR = 564265317,
        KEY_Q = 1578354247,
        KEY_R = 283323363,
        KEY_RAGE_EXTRA1 = 3031527851,
        KEY_RAGE_EXTRA2 = 2163345965,
        KEY_RAGE_EXTRA3 = 2545792964,
        KEY_RAGE_EXTRA4 = 1615612130,
        KEY_RBRACKET = 2709617819,
        KEY_RCONTROL = 1188783888,
        KEY_RETURN = 1673858416,
        KEY_RIGHT = 3572745779,
        KEY_RMENU = 1475436421,
        KEY_RSHIFT = 3989000767,
        KEY_RWIN = 1176916833,
        KEY_S = 1495481446,
        KEY_SCROLL = 2587523467,
        KEY_SEMICOLON = 2901670769,
        KEY_SLASH = 3273901275,
        KEY_SNAPSHOT = 3066683257,
        KEY_SPACE = 411437366,
        KEY_SUBTRACT = 1136242254,
        KEY_SYSRQ = 568600977,
        KEY_T = 1801609444,
        KEY_TAB = 4246772708,
        KEY_U = 630609225,
        KEY_UP = 2686821249,
        KEY_V = 3621763549,
        KEY_W = 756276,
        KEY_X = 843738801,
        KEY_Y = 2417207874,
        KEY_Z = 2186940111,
        KeepCollisionOnWhenInVehicle = 2227548071,
        KeepMovingWhilePathingDistance = 1421246289,
        KeepOnHeadProp = 1214699252,
        KernelSizePercentage = 4109006279,
        KernelType = 4176827323,
        KeyFrameData = 2186176131,
        KeyframeTimes = 1168619570,
        Keys = 1156641315,
        KickbackAmplitude = 87081828,
        KickbackImpulse = 2679183047,
        KickbackOverrideTiming = 2849489675,
        KillshotImpulseScale = 3823177966,
        KneeHeight = 323867886,
        KnockdownCount = 2499026361,
        L1 = 1225374727,
        L1_INDEX = 1592498963,
        L2 = 2904261673,
        L2_INDEX = 1996633871,
        L3 = 495281403,
        L3_INDEX = 2636742755,
        LDOWN = 3738161258,
        LDOWN_INDEX = 2463587664,
        LEANING = 638030281,
        LIGHTSHAFT_VOLUMETYPE_SHAFT = 665241531,
        LLEFT = 1219734089,
        LLEFT_INDEX = 2824023615,
        LOADINGSCREEN_CONTEXT_INSTALL = 1975990625,
        LOADINGSCREEN_CONTEXT_INTRO_MOVIE = 3944950610,
        LOADINGSCREEN_CONTEXT_LAST_FRAME = 1743079409,
        LOADINGSCREEN_CONTEXT_LEGALMAIN = 3022848011,
        LOADINGSCREEN_CONTEXT_LEGALSPLASH = 952864438,
        LOADINGSCREEN_CONTEXT_LOADGAME = 1279658350,
        LOADINGSCREEN_CONTEXT_LOADLEVEL = 69439032,
        LOADINGSCREEN_CONTEXT_MAPCHANGE = 2411352648,
        LOADINGSCREEN_CONTEXT_NONE = 2534380047,
        LOADINGSCREEN_CONTEXT_PC_LANDING = 1824947221,
        LOADINGSCREEN_CONTEXT_SWAP = 178678383,
        LOW = 2507480953,
        LRIGHT = 259488555,
        LRIGHT_INDEX = 3678867350,
        LSTICK_ALL = 1989327376,
        LSTICK_CLICK = 2062176236,
        LSTICK_DOWN = 2461025452,
        LSTICK_LEFT = 14101174,
        LSTICK_LEFTRIGHT = 496507176,
        LSTICK_RIGHT = 3136572673,
        LSTICK_ROTATE = 3759878662,
        LSTICK_UP = 3822736928,
        LSTICK_UPDOWN = 3245717810,
        LT_Hard = 40312212,
        LT_None = 1924092278,
        LT_Soft = 2263813480,
        LUP = 355377422,
        LUP_INDEX = 2638357812,
        LabelHash = 282408340,
        LadderData = 747859007,
        LandRollSlopeThreshold = 4229439207,
        LandVehicleOnArrival = 2004780781,
        LaserSightBone = 1698101125,
        Lasso = 1762915240,
        LastClockTick = 2220794698,
        LastDistDriven = 3786378857,
        LastMatrices = 2806293012,
        LastTimeSpentInVehicle = 3855835461,
        LaunchSpeed = 382676512,
        Launched = 2526987068,
        LawSpawnDelayMax = 2992792859,
        LawSpawnDelayMin = 2531276563,
        LayoutChangedOnBack = 2749241956,
        LayoutFlags = 2066281830,
        LayoutNodeList = 136855559,
        LeanThresholdToAllowAltClipSet = 1233910025,
        LeaveScenarioIfGivenGroundPhysical = 2922384690,
        LeftHandIkOffset = 3184042885,
        LeftHandedFirstPersonAnims = 2935140840,
        LeftHandedProjctiles = 2831295519,
        LeftHandedUnarmedFirstPersonAnims = 2203444853,
        Length = 582814072,
        LengthDecay = 1498431280,
        LengthMax = 1148314443,
        LengthMin = 2143694355,
        LensArtefacts = 1300198536,
        LessThan = 2522645238,
        LicencePlateText = 3810156612,
        LicensePlateProbabilityNamed = 938618322,
        LicensePlateTexIndex = 378421228,
        LifeTimeAfterExplosion = 2837589829,
        LifeTimeAfterImpact = 1285934797,
        LifeTimePlayerVehicleLockedOverrideMP = 3281903614,
        Lifetime = 1662894593,
        LightBone = 2549062012,
        LightColor = 2875691937,
        LightColour = 4038115575,
        LightDeltaPos = 1797113750,
        LightDistance = 676795696,
        LightFalloffExp = 1785642331,
        LightFlickers = 3635516318,
        LightFrequency = 265828338,
        LightIntensity = 1478260579,
        LightOnlyActiveWhenStuck = 392357584,
        LightPower = 3089706763,
        LightRange = 1148368411,
        LightSourceExponentFalloff = 1715782163,
        LightSpeedsUp = 2430129625,
        Lighting_FogVolumes = 2653124133,
        LightlyArmouredDamageModifier = 3110148135,
        Lightning = 180335552,
        LightningBranchIntensity = 310320156,
        LightningFadeWidth = 385054418,
        LightningFadeWidthFalloffExp = 463884491,
        LightningMainIntensity = 1429263615,
        LimitMax = 3658722687,
        LimitMin = 2477299646,
        LinkMenuId = 4260195627,
        ListenTimer = 936883529,
        Livery = 2628819833,
        Livery2 = 3757765867,
        Livery2Id = 4211365056,
        LiveryId = 788314593,
        LoadEntireExtents = 2771067788,
        LoadOuts = 957215173,
        LoadSet = 1067369069,
        LoadingOrder = 3017701156,
        LoadingScreenContext = 1064676599,
        LocDesc = 3827856721,
        LocName = 518503966,
        LocalOrbitXVariance = 1758450129,
        LocalOrbitYVariance = 2372035632,
        LocationType = 1929620332,
        Locations = 3461715746,
        LockOnRange = 4285823976,
        LockOnRequiresAim = 1177519102,
        LockedForSpecialEdition = 3578283910,
        LodPixelSizeArray = 3554277602,
        LodScale = 3706043633,
        LodToApply = 533564220,
        LongStateTransitionBlendTime = 2334883967,
        LongWeapon = 95039140,
        LongestWheelieDist = 2935268777,
        LongestWheelieTime = 1902220616,
        LookBackApproachSpeedScale = 1530537150,
        LookBehindSpeedModifier = 459162028,
        Looping = 3027066958,
        LoopingAudioRef = 3532896193,
        LooseFormationTargetRadiusOverride = 2727612813,
        LowLODIdleAnim = 433656119,
        LowLodBaseAnim = 3402608936,
        LowLodPhysicsPitchIdealApproachRate = 2945548240,
        LowPriority = 2701417689,
        LowResTargetDistanceCutoff = 1733003537,
        LowriderArmWindowHeight = 1528308251,
        LowriderLeanAccelModifier = 2035266656,
        LowriderLeanClipSet = 3036480951,
        MAPPERS_MAX = 3019245775,
        MAX_INPUTGROUPS = 2012839543,
        MAX_INPUTS = 1715584209,
        MEDIUM = 189522863,
        MELEE = 4223413948,
        MENU_OPTION_ACTION_FILL_CONTENT = 3412271848,
        MENU_OPTION_ACTION_FILL_CONTENT_FROM_SCRIPT = 3789431115,
        MENU_OPTION_ACTION_INCEPT = 265887656,
        MENU_OPTION_ACTION_LINK = 3085252624,
        MENU_OPTION_ACTION_NONE = 3927245115,
        MENU_OPTION_ACTION_PREF_CHANGE = 1942779345,
        MENU_OPTION_ACTION_REFERENCE = 946424002,
        MENU_OPTION_ACTION_SEPARATOR = 466729737,
        MENU_OPTION_ACTION_TRIGGER = 3637664921,
        MENU_OPTION_CAMERA_HEIGHT = 2752423105,
        MENU_OPTION_CAMERA_ZOOM = 1448680539,
        MENU_OPTION_CAMERA_ZOOM_NO_FP = 1972423933,
        MENU_OPTION_CAM_VEH_OFF = 2423654363,
        MENU_OPTION_CONTROLLER_SENSITIVITY = 3639609772,
        MENU_OPTION_CONTROLS_CONTEXT = 959467363,
        MENU_OPTION_DISPLAY_CONTROL_CONFIG = 3909673919,
        MENU_OPTION_DISPLAY_CONTROL_DRIVEBY = 2584053581,
        MENU_OPTION_DISPLAY_GPS_SPEECH = 1501351337,
        MENU_OPTION_DISPLAY_INVERT_LOOK = 1702033447,
        MENU_OPTION_DISPLAY_LANGUAGE = 3871543192,
        MENU_OPTION_DISPLAY_MEASUREMENT = 1826395805,
        MENU_OPTION_DISPLAY_MINIMAP_MODE = 137251345,
        MENU_OPTION_DISPLAY_ON_OFF = 422915145,
        MENU_OPTION_DISPLAY_RADIO_STATIONS = 1799485722,
        MENU_OPTION_DISPLAY_RETICLE_MODE = 840302365,
        MENU_OPTION_DISPLAY_SPEAKER_OUTPUT = 3171890663,
        MENU_OPTION_DISPLAY_SS_FRONTREAR = 1117372992,
        MENU_OPTION_DISPLAY_SWHEADSET = 3454967671,
        MENU_OPTION_DISPLAY_TARGET_CONFIG = 3835123592,
        MENU_OPTION_DISPLAY_UR_PLAYMODE = 2050135628,
        MENU_OPTION_DISPLAY_VOICE_OUTPUT = 3394279565,
        MENU_OPTION_DISPLAY_VOICE_TYPE = 1800640711,
        MENU_OPTION_FEED_DELAY = 2888912979,
        MENU_OPTION_FPS_DEFAULT_AIM_TYPE = 3650999715,
        MENU_OPTION_GAME_FLOW = 159224217,
        MENU_OPTION_GFX_AMBIENTOCC = 1543836953,
        MENU_OPTION_GFX_ANISOT = 410527007,
        MENU_OPTION_GFX_DXVERSION = 3448862951,
        MENU_OPTION_GFX_MSAA = 2964971741,
        MENU_OPTION_GFX_NIGHTLIGHTS = 1764229168,
        MENU_OPTION_GFX_QUALITY = 4211183858,
        MENU_OPTION_GFX_REFLECTION = 2548012127,
        MENU_OPTION_GFX_SHADERQ = 1903177367,
        MENU_OPTION_GFX_SHADOWS = 4229938784,
        MENU_OPTION_GFX_SOFTNESS = 2258116596,
        MENU_OPTION_GFX_WATER = 2911434722,
        MENU_OPTION_MEMORY_GRAPH = 3487857531,
        MENU_OPTION_MOUSE_TYPE = 4262393422,
        MENU_OPTION_REPLAY_AUTO_RESUME_RECORDING = 2491061806,
        MENU_OPTION_REPLAY_AUTO_SAVE_RECORDING = 96888250,
        MENU_OPTION_REPLAY_MEM_LIMIT = 1166842548,
        MENU_OPTION_REPLAY_MODE = 1149002936,
        MENU_OPTION_ROLL_YAW_PITCH = 474970677,
        MENU_OPTION_SCREEN_TYPE = 3442859544,
        MENU_OPTION_SLIDER = 436610799,
        MENU_OPTION_VIDEO_UPLOAD_PRIVACY = 573702035,
        MENU_OPTION_VID_ASPECT = 2895575274,
        MENU_OPTION_VID_VSYNC = 46765721,
        MENU_OPTION_VOICE_FEEDBACK = 1562618607,
        MENU_UNIQUE_ID_AVAILABLE = 4250503661,
        MENU_UNIQUE_ID_BETTING = 1971156635,
        MENU_UNIQUE_ID_BETTING_INFOLIST = 4166007873,
        MENU_UNIQUE_ID_BETTING_LOBBYLIST = 306831558,
        MENU_UNIQUE_ID_BRIGHTNESS_CALIBRATION = 1274056691,
        MENU_UNIQUE_ID_COPS = 912135598,
        MENU_UNIQUE_ID_CORONA_DETAILS_LIST = 2098160867,
        MENU_UNIQUE_ID_CORONA_INVITE = 2706208791,
        MENU_UNIQUE_ID_CORONA_INVITE_CREWS = 4251722505,
        MENU_UNIQUE_ID_CORONA_INVITE_FRIENDS = 3888441264,
        MENU_UNIQUE_ID_CORONA_INVITE_LAST_JOB_PLAYERS = 1201680592,
        MENU_UNIQUE_ID_CORONA_INVITE_LIST = 3427957333,
        MENU_UNIQUE_ID_CORONA_INVITE_MATCHED_PLAYERS = 2072956497,
        MENU_UNIQUE_ID_CORONA_INVITE_PLAYERS = 2317092078,
        MENU_UNIQUE_ID_CORONA_JOINED_LIST = 1262335737,
        MENU_UNIQUE_ID_CORONA_JOINED_PLAYERS = 1725647798,
        MENU_UNIQUE_ID_CORONA_SETTINGS = 3775827690,
        MENU_UNIQUE_ID_CORONA_SETTINGS_LIST = 3105784826,
        MENU_UNIQUE_ID_CREATION_HERITAGE = 687985396,
        MENU_UNIQUE_ID_CREATION_HERITAGE_LIST = 3978125740,
        MENU_UNIQUE_ID_CREATION_LIFESTYLE = 1740402227,
        MENU_UNIQUE_ID_CREATION_LIFESTYLE_LIST = 414398284,
        MENU_UNIQUE_ID_CREATION_YOU = 1071456590,
        MENU_UNIQUE_ID_CREW = 2451587285,
        MENU_UNIQUE_ID_CREWS = 788875551,
        MENU_UNIQUE_ID_CREWS_CARD = 3842994035,
        MENU_UNIQUE_ID_CREWS_CATEGORY = 4005414493,
        MENU_UNIQUE_ID_CREWS_FILTER = 3360788321,
        MENU_UNIQUE_ID_CREW_FRIENDS = 1209104686,
        MENU_UNIQUE_ID_CREW_INVITES = 3280603938,
        MENU_UNIQUE_ID_CREW_LEADERBOARDS = 273150990,
        MENU_UNIQUE_ID_CREW_LIST = 3054392805,
        MENU_UNIQUE_ID_CREW_MINE = 713566660,
        MENU_UNIQUE_ID_CREW_OPTIONS = 1444669405,
        MENU_UNIQUE_ID_CREW_OPTIONS_LIST = 3126490204,
        MENU_UNIQUE_ID_CREW_REQUEST = 3300702678,
        MENU_UNIQUE_ID_CREW_ROCKSTAR = 1837140531,
        MENU_UNIQUE_ID_CUTSCENE_EMPTY = 2658992736,
        MENU_UNIQUE_ID_EXIT_TO_WINDOWS = 381263946,
        MENU_UNIQUE_ID_FREEMODE = 1966619376,
        MENU_UNIQUE_ID_FRIENDS = 4200530582,
        MENU_UNIQUE_ID_FRIENDS_LIST = 4238225388,
        MENU_UNIQUE_ID_FRIENDS_MP = 595353375,
        MENU_UNIQUE_ID_FRIENDS_OPTIONS = 2479817970,
        MENU_UNIQUE_ID_FRIENDS_OPTIONS_LIST = 2588188131,
        MENU_UNIQUE_ID_GALLERY = 1451093119,
        MENU_UNIQUE_ID_GALLERY_ITEM = 2446504489,
        MENU_UNIQUE_ID_GALLERY_OPTIONS = 1727133062,
        MENU_UNIQUE_ID_GALLERY_OPTIONS_LIST = 4073260233,
        MENU_UNIQUE_ID_GAME = 2157862577,
        MENU_UNIQUE_ID_GAME_MP = 3880704992,
        MENU_UNIQUE_ID_HEADER = 3932596160,
        MENU_UNIQUE_ID_HEADER_BETTING = 3722587445,
        MENU_UNIQUE_ID_HEADER_CORONA = 2252799478,
        MENU_UNIQUE_ID_HEADER_CORONA_INVITE_CREWS = 290824667,
        MENU_UNIQUE_ID_HEADER_CORONA_INVITE_FRIENDS = 1468579741,
        MENU_UNIQUE_ID_HEADER_CORONA_INVITE_LAST_JOB_PLAYERS = 2160269591,
        MENU_UNIQUE_ID_HEADER_CORONA_INVITE_MATCHED_PLAYERS = 302221966,
        MENU_UNIQUE_ID_HEADER_CORONA_INVITE_PLAYERS = 3468639811,
        MENU_UNIQUE_ID_HEADER_CORONA_JOINED_PLAYERS = 2122598829,
        MENU_UNIQUE_ID_HEADER_CORONA_LOBBY = 652147207,
        MENU_UNIQUE_ID_HEADER_EMPTY = 1041105312,
        MENU_UNIQUE_ID_HEADER_JOINING_SCREEN = 378041258,
        MENU_UNIQUE_ID_HEADER_LANDING_KEYMAPPING = 1799001157,
        MENU_UNIQUE_ID_HEADER_LANDING_PAGE = 2690093765,
        MENU_UNIQUE_ID_HEADER_LOBBY = 3791852475,
        MENU_UNIQUE_ID_HEADER_MP_CHARACTER_CREATION = 1613450548,
        MENU_UNIQUE_ID_HEADER_MP_CHARACTER_SELECT = 2575995188,
        MENU_UNIQUE_ID_HEADER_MULTIPLAYER = 4045081698,
        MENU_UNIQUE_ID_HEADER_MY_MP = 25035917,
        MENU_UNIQUE_ID_HEADER_PRE_LOBBY = 3885094186,
        MENU_UNIQUE_ID_HEADER_RACE = 3098690736,
        MENU_UNIQUE_ID_HEADER_SAVE_GAME = 168144498,
        MENU_UNIQUE_ID_HEADER_TEXT_SELECTION = 1390000797,
        MENU_UNIQUE_ID_HELP = 1248371652,
        MENU_UNIQUE_ID_HOME = 337438347,
        MENU_UNIQUE_ID_HOME_BRIEF = 3463710049,
        MENU_UNIQUE_ID_HOME_DIALOG = 2486263364,
        MENU_UNIQUE_ID_HOME_FEED = 914707018,
        MENU_UNIQUE_ID_HOME_HELP = 2110786720,
        MENU_UNIQUE_ID_HOME_MISSION = 919753201,
        MENU_UNIQUE_ID_HOME_NEWSWIRE = 3795648582,
        MENU_UNIQUE_ID_HOME_OPEN_JOBS = 3610540381,
        MENU_UNIQUE_ID_INCEPT_TRIGGER = 201204327,
        MENU_UNIQUE_ID_INFO = 2822420400,
        MENU_UNIQUE_ID_INVALID = 2751837979,
        MENU_UNIQUE_ID_KEYMAP = 560861696,
        MENU_UNIQUE_ID_KEYMAP_LIST = 2680882701,
        MENU_UNIQUE_ID_KEYMAP_LISTITEM = 3876854282,
        MENU_UNIQUE_ID_LEAVE_GAME = 403313600,
        MENU_UNIQUE_ID_LOAD_GAME = 143514294,
        MENU_UNIQUE_ID_LOBBY = 1799690408,
        MENU_UNIQUE_ID_LOBBY_LIST = 592657712,
        MENU_UNIQUE_ID_LOBBY_LIST_ITEM = 837233574,
        MENU_UNIQUE_ID_LOST = 3413549531,
        MENU_UNIQUE_ID_MAP = 1629974146,
        MENU_UNIQUE_ID_MAP_LEGEND = 2377806605,
        MENU_UNIQUE_ID_MEDALS = 2513038772,
        MENU_UNIQUE_ID_MISSION_CREATOR = 2911458275,
        MENU_UNIQUE_ID_MISSION_CREATOR_CATEGORY = 475829508,
        MENU_UNIQUE_ID_MISSION_CREATOR_LISTITEM = 3729760762,
        MENU_UNIQUE_ID_MISSION_CREATOR_STAT = 2395277608,
        MENU_UNIQUE_ID_MOVIE_EDITOR = 728898411,
        MENU_UNIQUE_ID_MP_CHAR_1 = 271279934,
        MENU_UNIQUE_ID_MP_CHAR_2 = 3932756922,
        MENU_UNIQUE_ID_MP_CHAR_3 = 4222598727,
        MENU_UNIQUE_ID_MP_CHAR_4 = 1170428525,
        MENU_UNIQUE_ID_MP_CHAR_5 = 1426911488,
        MENU_UNIQUE_ID_NEW_GAME = 3358867461,
        MENU_UNIQUE_ID_PARTY = 3871002154,
        MENU_UNIQUE_ID_PARTY_LIST = 951704967,
        MENU_UNIQUE_ID_PARTY_OPTIONS = 563159073,
        MENU_UNIQUE_ID_PARTY_OPTIONS_LIST = 1141239736,
        MENU_UNIQUE_ID_PLACEHOLDER = 1549336171,
        MENU_UNIQUE_ID_PLAYERS = 905332394,
        MENU_UNIQUE_ID_PLAYERS_LIST = 2297677119,
        MENU_UNIQUE_ID_PLAYERS_OPTIONS = 367630613,
        MENU_UNIQUE_ID_PLAYERS_OPTIONS_LIST = 3528554893,
        MENU_UNIQUE_ID_RACE_INFO = 1998279882,
        MENU_UNIQUE_ID_RACE_INFOLIST = 3924244871,
        MENU_UNIQUE_ID_RACE_LOBBYLIST = 3709934802,
        MENU_UNIQUE_ID_REPLAY_EDITOR = 1344172430,
        MENU_UNIQUE_ID_REPLAY_MISSION = 364722445,
        MENU_UNIQUE_ID_REPLAY_MISSION_ACTIVITY = 2458951370,
        MENU_UNIQUE_ID_REPLAY_MISSION_LIST = 3663875005,
        MENU_UNIQUE_ID_REPLAY_RANDOM = 666556770,
        MENU_UNIQUE_ID_SAVE_GAME = 1672430896,
        MENU_UNIQUE_ID_SAVE_GAME_LIST = 1225469646,
        MENU_UNIQUE_ID_SETTINGS = 3984435912,
        MENU_UNIQUE_ID_SETTINGS_ADVANCED_GFX = 2419548993,
        MENU_UNIQUE_ID_SETTINGS_AUDIO = 2206503895,
        MENU_UNIQUE_ID_SETTINGS_CAMERA = 3344483460,
        MENU_UNIQUE_ID_SETTINGS_CONTROLS = 173436091,
        MENU_UNIQUE_ID_SETTINGS_DISPLAY = 708986128,
        MENU_UNIQUE_ID_SETTINGS_FACEBOOK = 1234235308,
        MENU_UNIQUE_ID_SETTINGS_FEED = 2129107249,
        MENU_UNIQUE_ID_SETTINGS_FIRST_PERSON = 852188635,
        MENU_UNIQUE_ID_SETTINGS_GRAPHICS = 440483432,
        MENU_UNIQUE_ID_SETTINGS_LIST = 1624086928,
        MENU_UNIQUE_ID_SETTINGS_MISC_CONTROLS = 363776800,
        MENU_UNIQUE_ID_SETTINGS_REPLAY = 3771443005,
        MENU_UNIQUE_ID_SETTINGS_SAVEGAME = 4031278428,
        MENU_UNIQUE_ID_SETTINGS_SIXAXIS = 282078385,
        MENU_UNIQUE_ID_SETTINGS_VOICE_CHAT = 3756643752,
        MENU_UNIQUE_ID_SHOW_ACCOUNT_PICKER = 2373085163,
        MENU_UNIQUE_ID_SOCIALCLUB = 3502439427,
        MENU_UNIQUE_ID_SPECTATOR = 1851913543,
        MENU_UNIQUE_ID_START = 1854977142,
        MENU_UNIQUE_ID_STATS = 2817433813,
        MENU_UNIQUE_ID_STATS_CATEGORY = 468484210,
        MENU_UNIQUE_ID_STATS_LISTITEM = 703216550,
        MENU_UNIQUE_ID_STORE = 3433584766,
        MENU_UNIQUE_ID_TEAM_SELECT = 523353125,
        MENU_UNIQUE_ID_VAGOS = 2062085540,
        MENU_UNIQUE_ID_WEAPONS = 3038256646,
        MID_LEFT = 3336985754,
        MID_RIGHT = 354491692,
        MM_BITMAP_VERSION = 1049598006,
        MM_BITMAP_VERSION_ALPHA = 3250863043,
        MM_BITMAP_VERSION_MINIMAP = 3999177563,
        MM_BITMAP_VERSION_SEA = 1600411487,
        MOLOTOV = 662824419,
        MOUNTED_DRIVEBY = 3422081660,
        MOUNTED_THROW = 675110053,
        MOUNT_ANIMAL = 3842267310,
        MOUSE_AXIS_MAX = 73345939,
        MOUSE_EXTRABTN1 = 1356633751,
        MOUSE_EXTRABTN2 = 1613051176,
        MOUSE_EXTRABTN3 = 2873936734,
        MOUSE_EXTRABTN4 = 3114297349,
        MOUSE_EXTRABTN5 = 2138895295,
        MOUSE_LEFT = 2368039487,
        MOUSE_MIDDLE = 2675187924,
        MOUSE_RIGHT = 2549774435,
        MPApparelData = 995741528,
        MPApparelDataFemale = 1203351670,
        MPApparelDataMale = 3638876379,
        MPDarkGlowIntensity = 3384585433,
        MPEntryPickUpPullUpRate = 192421777,
        MPGlowIntensity = 2651287898,
        MPOnly = 734337902,
        MPOutfits = 2693076183,
        MPOutfitsData = 172580186,
        MPOutfitsDataFemale = 3115183968,
        MPOutfitsDataMale = 3631654840,
        MPPickupHash = 2668247964,
        MPRate = 3168494142,
        MPWarpInOut = 2386863346,
        MR_SSAO_AllScenePresets = 2210679135,
        MSAA = 1032784526,
        MSAAFragments = 553256719,
        MSAAQuality = 2656141982,
        MS_ANY = 3575387437,
        MS_RUNNING = 2349295608,
        MS_STILL = 1787290339,
        MS_STRAFING = 3643221904,
        MS_WALKING = 2707750148,
        MTLION = 530543246,
        MainLightColor = 2389910798,
        MainLightCoronaIntensity = 1215983784,
        MainLightCoronaSize = 337868710,
        MainLightFalloffExponent = 2556461302,
        MainLightInnerAngle = 2895771504,
        MainLightIntensity = 1264599592,
        MainLightOuterAngle = 917942949,
        MainLightRange = 3851177901,
        MainLightShadowFadeDistance = 2638554555,
        MainLightSpecularFadeDistance = 791756972,
        MainLightVolumeExponent = 2458026536,
        MainLightVolumeIntensity = 3328691019,
        MainLightVolumeOuterColor = 2740722527,
        MainLightVolumeSize = 2547776810,
        MainWaterTune = 2154841935,
        MaleGestureClipSetId = 647652741,
        ManualDetonation = 3734212329,
        ManualPickUp = 1780659358,
        ManualUpdate = 823307664,
        Mapper = 2050821897,
        MapperAssignements = 670601866,
        MappingList = 2673811695,
        Mappings = 2283288845,
        Maps = 3758047655,
        MaskFlashAlpha = 3269987179,
        MaskNormalAlpha = 2014573657,
        Mass = 1810619094,
        Master = 609911719,
        MaxAimSweepHeadingAngleDegs = 1395636308,
        MaxAimSweepPitchAngleDegs = 1511506365,
        MaxAngleToUseDesiredAngle = 3067513344,
        MaxAngularHeadingVelocityPlayerFPS = 2412106599,
        MaxAnimPitch = 4102381397,
        MaxArmour = 436447855,
        MaxAttrsAudio = 3206635669,
        MaxAttrsBuoyancy = 2328318878,
        MaxAttrsDecal = 869974569,
        MaxAttrsExplosion = 3413304729,
        MaxAttrsLadder = 3466630106,
        MaxAttrsLightShaft = 4116971351,
        MaxAttrsParticle = 4051229524,
        MaxAttrsProcObj = 3015578221,
        MaxAttrsScrollBar = 1000501984,
        MaxAttrsSpawnPoint = 1467030992,
        MaxAttrsWindDisturbance = 4034937159,
        MaxAttrsWorldPoint = 3446387962,
        MaxBaseModelInfos = 3205642095,
        MaxBeastJumpInitialVelocity = 1477129396,
        MaxBikeVelocityForAmbientIdles = 465067306,
        MaxBrakeDistance = 4205239830,
        MaxClimbHeight = 3034997867,
        MaxClothCollisionsExtensions = 3186063951,
        MaxCompEntityModelInfos = 3432311395,
        MaxComponent = 4221964475,
        MaxDelayDistance = 4108300187,
        MaxDescriptionLength = 1707664714,
        MaxDist = 2745323338,
        MaxDistanceDelay = 1818772152,
        MaxDistanceForBurst = 3702159393,
        MaxDistanceForExposureReset = 2968896940,
        MaxDistanceFromPlayer = 2856570506,
        MaxDistanceMayAdjustPathEndPosition = 3194262000,
        MaxDistanceMayAdjustPathSearchOnExit = 3516788473,
        MaxDistanceToHear = 580123193,
        MaxDistanceToHearEvents = 2537523062,
        MaxDistanceToHearEventsUsingLOS = 2663492665,
        MaxDoorExtensions = 3431443691,
        MaxDotToTarget = 1574495683,
        MaxDropHeight = 1848259314,
        MaxDuckBreakLockOnTime = 342194320,
        MaxEffects2d = 4234006806,
        MaxEffectsWorld2d = 4173659803,
        MaxExpressionExtensions = 1715476143,
        MaxExtraPedModelInfos = 38281477,
        MaxExtraVehicleModelInfos = 2732175770,
        MaxExtraWeaponModelInfos = 685154160,
        MaxForwardsPitchFast = 2530102209,
        MaxForwardsPitchSlow = 1146363465,
        MaxHeadShotDistanceAI = 1599562442,
        MaxHeadShotDistancePlayer = 3082158928,
        MaxHeadingDeltaTurnSpeed = 2073783636,
        MaxHealth = 495965803,
        MaxHeightForStrike = 3376154821,
        MaxImpulseTestDelay = 1356121632,
        MaxInVehicleOrderDistance = 2274603071,
        MaxKernel_Lod0 = 2597750900,
        MaxKernel_Lod1 = 3378308480,
        MaxLateralLeanBlendWeightDelta = 1748909865,
        MaxLightExtensions = 1843942032,
        MaxLodScale = 337718157,
        MaxLongitudinalLeanBlendWeightDelta = 4175904306,
        MaxMedResTargetsPerFrame = 3544648937,
        MaxMloInstances = 2145993387,
        MaxMloModelInfos = 1558391040,
        MaxMvPitchToPlayAimDownShunt = 1546988642,
        MaxNoInRange = 2753279101,
        MaxNormalZForFlatten = 1488898307,
        MaxNormalZForFlatten_Movable = 2969357470,
        MaxNumBounds = 3677044377,
        MaxNumDescriptions = 2403290576,
        MaxNumPassengers = 237984842,
        MaxNumberPedsNearTarget = 2422052515,
        MaxNumberVehiclesNearTarget = 1955661253,
        MaxParticipants = 976655929,
        MaxPedModelInfos = 2467847454,
        MaxPitchForBikeAltAnims = 1182962200,
        MaxPixels = 4113052602,
        MaxPlayerBloodWoundsMP = 2756831142,
        MaxPlayerBloodWoundsSP = 3501837273,
        MaxPlayerToCoverDistFPS = 1534623417,
        MaxRandomDelay = 977600457,
        MaxReactions = 3062817899,
        MaxRestrictedAimSweepHeadingAngleDegs = 3589044452,
        MaxReverseSpeed = 2004585270,
        MaxRollAngleSin = 1554552254,
        MaxShootingDistance = 1563796099,
        MaxSize = 367931761,
        MaxSmashWindowAngleDegs = 15087375,
        MaxSmashWindowAngleFirstPersonDegs = 1924928437,
        MaxSpawnPointOverrideExtensions = 513018020,
        MaxSpeedAtBrakeDistance = 2930139220,
        MaxSpeedParam = 2927064106,
        MaxStartAlpha = 373327623,
        MaxSwing = 2149224705,
        MaxT = 283749439,
        MaxTargetSpeed = 1668642837,
        MaxThrottleForAltLowRiderPose = 868848233,
        MaxTimeAfterDropOffBeforeFlee = 143141277,
        MaxTimeCollidingBeforeExit = 3618878970,
        MaxTimeModelInfos = 2120007297,
        MaxTimeSinceTargetLastHostileForLawDriveby = 1726607124,
        MaxTimeSpentLandedBeforeExit = 2892876798,
        MaxTimeSpentLandedBeforeFlee = 3905663903,
        MaxTimeToNextFirstPersonAdditiveIdle = 402428981,
        MaxTimeToWander = 683308669,
        MaxTotalPeds = 3741928315,
        MaxTotalPeds_Base = 2677344826,
        MaxTotalTargetsPerFrame = 172614776,
        MaxTwist = 3085782674,
        MaxUnarmedDrivebyYawIfWindowRolledUp = 220820735,
        MaxVehVelocityToKeepStairsDown = 3306188437,
        MaxVehicleModelInfos = 2991067200,
        MaxVelocityToAllowAltClipSet = 2266547610,
        MaxVelocityToAllowAltClipSetWheelie = 1896779219,
        MaxWeaponModelInfos = 965242339,
        MaxWheelOffsetY = 1332850459,
        MaxXAcceleration = 328965171,
        MaximumNumber = 761599882,
        MaximumWantedLevel = 2029631230,
        MayClimb = 3568028141,
        MayDrop = 1080740638,
        MayEnterWater = 3601719553,
        MayFly = 3895874142,
        MayJump = 115871632,
        MayUseLadders = 2979049931,
        MedResTargetDistanceCutoff = 265133197,
        MeleeBaseClipSetHash = 1022944094,
        MeleeBlade = 1737323813,
        MeleeCardinalFatalAttackCheck = 3376363794,
        MeleeClipSetHash = 2197341476,
        MeleeClub = 391630826,
        MeleeFist = 1543693299,
        MeleeHatchet = 2422262252,
        MeleeMachete = 3717207160,
        MeleeMovementMBR = 3628292502,
        MeleeRightFistTargetHealthDamageScaler = 2891268472,
        MeleeScale = 2349916591,
        MeleeStealthClipSetHash = 493700690,
        MeleeSupportTauntClipSetHash = 3891555823,
        MeleeTauntClipSetHash = 2324130509,
        MeleeVariationClipSetHash = 1600756539,
        MemoryFootprint = 612474939,
        MemoryProfileLocation = 3009268084,
        MemoryProfileLocationList = 3245177310,
        MemoryProfileModuleStat = 3089985158,
        MenuAction = 2310567669,
        MenuDisplayOptions = 3165850744,
        MenuHeader = 687916889,
        MenuId = 1807671525,
        MenuItemColour = 2936616693,
        MenuItems = 1798385641,
        MenuOption = 966843644,
        MenuPref = 2800471402,
        MenuScreen = 3584304290,
        MenuScreens = 3651322953,
        MenuUniqueId = 77113455,
        MenuVersionId = 1632737378,
        MenuVersions = 701713812,
        MillisecondsPerGameMinute = 4061988757,
        MinAimSweepHeadingAngleDegs = 2320083730,
        MinAimSweepPitchAngleDegs = 1431075532,
        MinAnimPitch = 4093217060,
        MinBeastJumpInitialVelocity = 3568425813,
        MinBlockedLOSTimeToBlockAimIntro = 4269476531,
        MinBrakeDistance = 3667602731,
        MinComponent = 2416921960,
        MinDamageForce = 4033686626,
        MinDelayDistance = 1405855513,
        MinDist = 1255895735,
        MinDistanceFromOtherPedsToFilm = 1440458015,
        MinDistanceFromPlayer = 3240307439,
        MinDistanceToBlockAimIntro = 3129989164,
        MinDotToTarget = 3288004161,
        MinFleeOnBikeDistance = 945475130,
        MinForcedInitialBrakeTime = 2940289635,
        MinForcedStillToSitTime = 2602014375,
        MinForwardsPitchFast = 188571932,
        MinForwardsPitchSlow = 1777804477,
        MinHeadShotDistanceAI = 3002573495,
        MinHeadShotDistancePlayer = 96866546,
        MinHeadingDeltaToAdjust = 2556074717,
        MinHeadingDeltaTurnSpeed = 171275597,
        MinHeightAboveGroundForHighFallAbort = 866980885,
        MinHeightForFlatten = 2888868586,
        MinHeightForFlattenInteriorOffset = 127177666,
        MinInVehicleOrderDistance = 3001528763,
        MinMvPitchToPlayAimUpShunt = 1057562451,
        MinNormalZForFlatten = 1886956905,
        MinNumPassengers = 253179038,
        MinPitchToDoExtraTest = 3034610967,
        MinRandomDelay = 2579479361,
        MinRestrictedAimSweepHeadingAngleDegs = 838255503,
        MinRollToDoExtraTest = 2552082535,
        MinSize = 1829871748,
        MinSmashWindowAngleDegs = 743643049,
        MinSmashWindowAngleFirstPersonDegs = 3587004827,
        MinStartAlpha = 437719241,
        MinT = 834331353,
        MinTargetSpeed = 4061343117,
        MinTimeBeforeOrderChangeDueToBlockedLocation = 3555374966,
        MinTimeBetweenRecoilShakes = 2628303304,
        MinTimeDucked = 3061913457,
        MinTimeInIdleState = 2183745831,
        MinTimeInIdleStateAiOrRemote = 943989780,
        MinTimeInLowRiderClipset = 1798674235,
        MinTimeInStandFreewheelState = 3892213778,
        MinTimeInStandStateFPS = 1621924028,
        MinTimeInStateToAllowRagdollFleeExit = 3909498748,
        MinTimeInTurnState = 1027124968,
        MinTimeInTurnStateAiOrRemote = 3114603561,
        MinTimeOnFootTargetStillForArrest = 305536610,
        MinTimeSinceDriveByForAgitate = 56684479,
        MinTimeSinceDriveByForCloseDoor = 345487015,
        MinTimeSinceDriverValidToShuffle = 599372255,
        MinTimeSpentLandedBeforeExit = 490178156,
        MinTimeStationaryToIgnorePlayerDriveTest = 2217815195,
        MinTimeToNextFirstPersonAdditiveIdle = 137806659,
        MinTimeTurningForWobble = 2624331049,
        MinTwist = 1883734996,
        MinUnarmedDrivebyYawIfWindowRolledUp = 552589613,
        MinVelocityToAllowAltClipSet = 2714021858,
        MinVelocityToConsiderMoving = 119275101,
        MinWantedLevel = 470009224,
        MinimumDistanceToTarget = 1575384910,
        MinimumWaitTime = 3299999596,
        MissionCreatorAssetData = 165968612,
        MissionNameHash = 3891405998,
        MistSettingName = 359183552,
        MobilePhoneConversation = 1313153327,
        ModIndex = 1577097072,
        ModKit = 1434292342,
        ModType = 4140515434,
        Model = 183184774,
        ModelHashKey = 1442269562,
        ModelNames = 4220578691,
        ModelSets = 127947372,
        ModelVariations = 498857511,
        Models = 3065078871,
        Mods = 2347038985,
        Money = 1516081330,
        MoodAiming = 1080750882,
        MoodAngry = 443110810,
        MoodExcited = 427972558,
        MoodFrustrated = 1481087903,
        MoodHappy = 1837598021,
        MoodInjured = 3377492779,
        MoodNormal = 272842986,
        MoodStressed = 3171805118,
        MoodTalking = 1523171490,
        MotionAnimRateScale = 3594603567,
        MotionClipSetHash = 3268115627,
        MotionClipSetHashForClone = 2520414108,
        MotionCrouchClipSetHash = 3620103634,
        MotionFilterHash = 527231457,
        MotionState_ActionMode_Idle = 1327559195,
        MotionState_ActionMode_Run = 3448650179,
        MotionState_ActionMode_Walk = 1953677838,
        MotionState_Aiming = 2987662387,
        MotionState_Crouch_Idle = 229883528,
        MotionState_Crouch_Run = 2402391844,
        MotionState_Crouch_Walk = 3442566086,
        MotionState_Dead = 1351316935,
        MotionState_Diving_Idle = 2949180470,
        MotionState_Diving_Swim = 1418365882,
        MotionState_DoNothing = 4215516295,
        MotionState_Idle = 3880877974,
        MotionState_InVehicle = 2963219965,
        MotionState_None = 3598785220,
        MotionState_Parachuting = 979295347,
        MotionState_Run = 3335755946,
        MotionState_Sprint = 3642599615,
        MotionState_Stealth_Idle = 2214646052,
        MotionState_Stealth_Run = 1785826039,
        MotionState_Stealth_Walk = 3803917604,
        MotionState_Swimming_TreadWater = 359410098,
        MotionState_Walk = 232030521,
        MotionStrafingClipSetHash = 1518315271,
        MotionStrafingStealthClipSetHash = 2268367128,
        MotionStrafingUpperBodyClipSetHash = 152585184,
        MotionTaskType = 3661879642,
        MountPoint = 3698970193,
        MountPromptDistance = 1447073898,
        Mounts = 1880724086,
        MouseSettings = 2025436629,
        MoveFollowLeaderHeadingTolerance = 2804323948,
        MovementModeConditionalIdle = 2800805670,
        MovementModeIdle = 1606599833,
        MovementModeType = 4100497466,
        MovementOverrideClipSetHash = 1035853972,
        MovementSpeed = 2041830013,
        MovieMeshInfo = 1275600804,
        MovieMeshInfoList = 2149129132,
        MovieSettings = 643845403,
        MpTintData = 2418442923,
        MpVehiclesDriven = 3613624610,
        MultiPlayer = 4228569259,
        MultiplayerHiddenEvasionTimes = 1639029141,
        MultiplayerSessionTemplateName = 4277541878,
        MultiplayerWantedLevelRadius = 3442729467,
        MusicHistorySpace = 636959427,
        MusicHistoryWriteIndex = 1102695527,
        MustBeInVehicle = 1578634119,
        MustBeOnFoot = 3861224459,
        MustBeStationary = 2277176680,
        MustBeUsingATerritorialScenario = 202626263,
        MustBeUsingScenario = 710476088,
        MustBeUsingScenarioBeforeInitialReaction = 3860073253,
        MustBeWanderingBeforeInitialReaction = 751899928,
        MustBeWitnessed = 1077086536,
        MustCloseDoor = 2860274457,
        MustNotifyLawEnforcement = 2777675431,
        MustUseRealVehiclePhysics = 1610742422,
        MuzzleBone = 3071446970,
        MuzzleOverrideOffset = 1610604408,
        MuzzleSmokeFx = 2420843914,
        MuzzleSmokeFxDecPerSec = 1439680610,
        MuzzleSmokeFxFP = 1788967960,
        MuzzleSmokeFxIncPerShot = 4167752177,
        MuzzleSmokeFxMinLevel = 2962778408,
        NMBT_AIMFROMGROUND = 2567731300,
        NMBT_CRAWL = 3074589133,
        NMBT_DIRECTBLENDOUT = 1469727245,
        NMBT_DIRECTIONALBLEND = 3331690126,
        NMBT_DISALLOWBLENDOUT = 2367123143,
        NMBT_FORCEMOTIONSTATE = 1940943537,
        NMBT_NONE = 3252361141,
        NMBT_SETBLEND = 1719812776,
        NMBT_SINGLECLIP = 1343281555,
        NMBT_UPPERBODYREACTION = 3450802238,
        NMExtraTunables = 2272591939,
        NMJumpFromVehicleTuningSet = 1584541912,
        NMTaskSimpleTunableEntry = 1650561249,
        NMTuningSetEntry = 633754617,
        NONE = 3417664498,
        NOTHING = 1696665290,
        NUMBUTTONS = 1534292555,
        NameHash = 3742647683,
        NameHashOfGarage = 256315552,
        NameOfScriptTextLine = 767690622,
        NavigateToWarpEntryPoint = 3279406684,
        NavmeshBlocking = 1200931011,
        NeckBound = 711890948,
        NeckBoundFwdOffset = 2649229933,
        NeckBoundHeightOffset = 1814708564,
        NeckBoundLength = 3492321036,
        NeckBoundRadius = 2170143152,
        NeckBoundRotation = 1063044025,
        NeckBoundSlot = 148717917,
        NeckDeltaLimits = 2653820320,
        NeedToOpenDoors = 2173285351,
        NeedsGunCockingInCover = 4058971613,
        Negative = 875768585,
        Network = 1534814353,
        NetworkHeadShotPlayerDamageModifier = 1265683809,
        NetworkHitLimbsDamageModifier = 2801236431,
        NetworkPedDamageModifier = 572078681,
        NetworkPlayerDamageModifier = 3900738384,
        NeverGenerateMenuData = 3974153718,
        NeverStopNavmeshTaskEarlyInFollowLeader = 3812790738,
        NewWeatherType = 2112260731,
        NewsReportHistorySpace = 2075816460,
        NewsReportHistoryWriteIndex = 4031447237,
        NewsStoryState = 494998257,
        NextIdleTime = 189410462,
        NightVision = 2347591660,
        NmBraceOverrideSet = 764736170,
        NmReactionSet = 308965519,
        NmShotTuningSet = 2857407423,
        NoAmmoDisplay = 3276122860,
        NoAnimCombatEntry = 1783762370,
        NoAnimCombatExit = 1625330602,
        NoAnimCombatInVehicle = 3223053041,
        NoAnimTimeslicingShadowRange = 1388183900,
        NoArmIkOnInsideCloseDoor = 376777533,
        NoArmIkOnOutsideCloseDoor = 2097006420,
        NoArmIkOnOutsideOpenDoor = 1313745218,
        NoAutoRunWhenFiring = 3441743144,
        NoBulkyItems = 1471377798,
        NoDriver = 2060210646,
        NoFriendlyFireDamage = 976268688,
        NoIK = 1452886412,
        NoIncomingLinks = 3760789936,
        NoIndirectExit = 1873739151,
        NoLeftHandIK = 3527668515,
        NoLeftHandIKWhenBlocked = 424315124,
        NoLineOfSightNeeded = 3500944575,
        NoMeleeTakedowns = 1135260919,
        NoOutgoingLinks = 3846161847,
        NoPullPin = 2751062123,
        NoRepeat = 1846548887,
        NoRespawnUntilStreamedOut = 2247631388,
        NoResprays = 1377080091,
        NoRoof = 1123406392,
        NoShunts = 2915315744,
        NoStencil = 361483059,
        NoTurnControlThreshold = 2982819675,
        NoVehicleSpawnMaxDistance = 4100708934,
        NoWheelStats = 2412251482,
        NoiseAmpMaxDistLerp = 3803105534,
        NoiseAmpMinDistLerp = 4081326625,
        NoiseAmplitude = 3663046539,
        NoiseTexScale = 2790272424,
        NonGroupMaxDistToAdjustSpeed = 1105460826,
        NonGroupMinDistToAdjustSpeed = 1982510107,
        NonLethal = 2995573357,
        NonPinVert0 = 4204841601,
        NonPinVert1 = 1877193989,
        NonPlayerRoadDensityDec = 4119327539,
        NonPlayerRoadDensityDec_Base = 1137483971,
        NonViolent = 2265025215,
        NormalEntry = 3260386120,
        NormalExit = 52087478,
        NormalInVehicle = 505070069,
        NormalScale = 2902170264,
        NormalWeightPower = 794553529,
        NotAWeapon = 3008852441,
        NotAllowedForDriveby = 1262814245,
        NotAvailableInMultiplayer = 2814406404,
        NotDimmable = 485254715,
        NotUnarmed = 3755063764,
        NotUsableOutsideVehicle = 1815026032,
        NotValidInComplexScenario = 4073176552,
        NumAirLaunches = 904346525,
        NumAirLaunchesOver40m = 2784949220,
        NumAirLaunchesOver5m = 3500175792,
        NumAirLaunchesOver5s = 3367789028,
        NumBounds = 985129514,
        NumControlPoints = 2892791904,
        NumDriven = 872663611,
        NumEdges = 4232328141,
        NumFlips = 3999703076,
        NumInstances = 389769493,
        NumLargeAccidents = 1524694912,
        NumPedsRundown = 1175487222,
        NumPedsToSpawn = 1537679858,
        NumPinVerts = 2068781797,
        NumPlaneLandings = 1912296356,
        NumSections = 2099247533,
        NumSpins = 972223133,
        NumStolen = 2441920641,
        NumVerts = 2223035803,
        NumWheelies = 3894110320,
        NumWoundsToScarsOnDeathMP = 1891101140,
        NumWoundsToScarsOnDeathSP = 344997018,
        NumberOfStacksOfThisSize = 2215898394,
        NumberOfTimesPickupHelpTextDisplayed = 1274285303,
        ON_BOARD_JACK = 4210432811,
        ObjectModels = 2530748696,
        ObjectScale = 2835371216,
        OceanBumpiness = 4053553931,
        OceanFoamIntensity = 3695941626,
        OceanFoamScale = 825939807,
        OceanNoiseMinAmplitude = 3009786503,
        OceanWaveAmplitude = 2116103159,
        OceanWaveMaxAmplitude = 1133074179,
        OceanWaveMinAmplitude = 1425491906,
        OceanWaveWindScale = 829249696,
        Offset = 2435984497,
        Offset_1Right = 341133718,
        Offset_2Right = 2480211088,
        Offsets = 227290338,
        OldWeatherType = 1523407928,
        OnFootClipSets = 319867937,
        OnFootHoming = 1910090186,
        OnFootMaxMouseSensitivity = 2964029144,
        OnFootMinMouseSensitivity = 2461986587,
        OnFootMouseSensitivityPower = 2490703656,
        OnFootOrderDistance = 3705805397,
        OnFootPickupActions = 2345324447,
        OnHitDamageAmountMax = 4253119169,
        OnHitDamageAmountMin = 982138330,
        OnScreenImmediateDetectionRange = 2100987542,
        OnShotPickupActions = 3397083693,
        Online = 1414027167,
        OnlyAllowFiring = 961562279,
        OnlyExitIfDoorIsClosed = 2907769844,
        OnlyFireOneShot = 2270924775,
        OnlyFireOneShotPerTriggerPress = 2328125228,
        OnlyJackDeadPedsInTurret = 3854657159,
        OnlySpawnInSameInterior = 3257836369,
        OnlyUseAimingInfoInFPS = 3707988585,
        OnlyUseIdleVehicleSeats = 3372568306,
        OnlyVictimCanNotifyLawEnforcement = 1113197060,
        OpenDoorHeadingChange = 1133407824,
        OpenDoorTranslation = 1588939459,
        OptimalCoverDistance = 577039464,
        Option = 2522598331,
        OrbitDirXVariance = 2438323799,
        OrbitDirYVarianceMax = 4131341061,
        OrbitDirYVarianceMin = 975668549,
        OrderNumber = 1607165241,
        OrientateUpright = 3362263175,
        Orientation = 568303802,
        OriginalPos = 2206909700,
        OscillatorRef = 3866719227,
        OutputIndex = 507009305,
        OutputMax = 944271256,
        OutputMin = 2741522250,
        OutroBlendInDuration = 2176857505,
        OutroBlendOutDuration = 3734923619,
        OutroClip1Id = 2291961208,
        OutroRateFromPeekFPS = 2575356761,
        OverallEnvelopeRef = 1260823161,
        OverriddenShotForFirstPersonOnFoot = 3492363034,
        OverrideForces = 516701977,
        OverrideMaxAimAngle = 3451250298,
        OverrideMaxRestrictedAimAngle = 1697411370,
        OverrideMinAimAngle = 1229710228,
        OverrideMinRestrictedAimAngle = 2170434581,
        OverrideOnFootClipSetWithBase = 68991964,
        OverrideWeaponClipSetWithBase = 1091152117,
        OwnedTypeAndIncludeFlags = 1102327114,
        PAFT_AI = 2505224476,
        PAFT_ANY = 3154113678,
        PAFT_NOT_ANIMAL = 2103037081,
        PAFT_NOT_FISH = 1182191524,
        PAFT_PLAYER_MP = 3536418886,
        PAFT_PLAYER_SP = 964971487,
        PARACHUTE = 4236445781,
        PEDGRP_FILE = 337231870,
        PED_IN_WATER = 790829262,
        PED_ON_FOOT = 112381047,
        PETROL_PUMP = 1524753707,
        PICK_UP_POINT = 4092668996,
        PIG = 2749421222,
        PIG_ON_FOOT = 1913712760,
        PLANE_ROCKET = 1974857664,
        PLAYER_BLIND_FIRE_MODIFIER_MAX = 139544692,
        PLAYER_BLIND_FIRE_MODIFIER_MIN = 1143912238,
        PLAYER_RECENTLY_DAMAGED_MODIFIER = 1878852931,
        PLAYER_RECOIL_CROUCHED_MODIFIER = 120846638,
        PLAYER_RECOIL_MODIFIER_MAX = 1421118077,
        PLAYER_RECOIL_MODIFIER_MIN = 1597367764,
        POINT_TYPE_MAX = 3188552252,
        POVTuningInfo = 3007648776,
        POVTuningInfos = 365677612,
        PREF_ADV_GFX_HD_FLIGHT = 1782714119,
        PREF_ADV_GFX_LONG_SHADOWS = 529871863,
        PREF_ADV_GFX_MAX_LOD = 3271055977,
        PREF_ADV_GFX_SHADOWS_DIST_MULT = 2275670728,
        PREF_ADV_GFX_ULTRA_SHADOWS = 2366717321,
        PREF_AIM_ACCELERATION = 3904564002,
        PREF_AIM_DEADZONE = 2238232941,
        PREF_ALTERNATE_DRIVEBY = 463265955,
        PREF_ALTERNATE_HANDBRAKE = 4085781072,
        PREF_AUDIO_MUTE_ON_FOCUS_LOSS = 3494416745,
        PREF_AUTOSAVE = 3015810528,
        PREF_BIG_RADAR = 1763351810,
        PREF_BIG_RADAR_NAMES = 24283942,
        PREF_CAMERA_HEIGHT = 3979717039,
        PREF_CINEMATIC_SHOOTING = 3020453532,
        PREF_CONTROLLER_LIGHT_EFFECT = 3158213599,
        PREF_CONTROLLER_SENSITIVITY = 2478601056,
        PREF_CONTROLS_CONTEXT = 2860898892,
        PREF_CONTROL_CONFIG = 321466298,
        PREF_CONTROL_CONFIG_FPS = 469970614,
        PREF_CTRL_SPEAKER = 307615515,
        PREF_CTRL_SPEAKER_HEADPHONE = 1943625854,
        PREF_CTRL_SPEAKER_VOL = 2174602145,
        PREF_CURRENT_LANGUAGE = 2572578851,
        PREF_DIAG_BOOST = 1476722378,
        PREF_DISPLAY_GPS = 3638564831,
        PREF_DISPLAY_HUD = 959129895,
        PREF_DOF = 3312008376,
        PREF_FACEBOOK_UPDATES = 913847481,
        PREF_FEED_CREW = 2711239703,
        PREF_FEED_DELAY = 1367631000,
        PREF_FEED_FRIENDS = 2609479957,
        PREF_FEED_PHONE = 1428282324,
        PREF_FEED_SOCIAL = 1805135722,
        PREF_FEED_STATS = 3197967160,
        PREF_FEED_STORE = 1248455932,
        PREF_FEED_TOOLTIP = 4211505749,
        PREF_FPS_AIM_ACCELERATION = 3554995276,
        PREF_FPS_AIM_DEADZONE = 1629949197,
        PREF_FPS_AIM_SENSITIVITY = 186472035,
        PREF_FPS_AUTO_LEVEL = 3672719884,
        PREF_FPS_COMBATROLL = 3547799001,
        PREF_FPS_DEFAULT_AIM_TYPE = 1463532803,
        PREF_FPS_FIELD_OF_VIEW = 544376168,
        PREF_FPS_HEADBOB = 1831292032,
        PREF_FPS_LOOK_SENSITIVITY = 3166977923,
        PREF_FPS_PERSISTANT_VIEW = 1376532764,
        PREF_FPS_RAGDOLL = 2030653411,
        PREF_FPS_RELATIVE_VEHICLE_CAMERA_DRIVEBY_AIMING = 801601362,
        PREF_FPS_THIRD_PERSON_COVER = 2124820993,
        PREF_FPS_VEH_AUTO_CENTER = 2760652309,
        PREF_GAMMA = 1676214369,
        PREF_GFX_AMBIENT_OCCLUSION = 3112036537,
        PREF_GFX_ANISOTROPIC_FILTERING = 1108704306,
        PREF_GFX_CITY_DENSITY = 578170733,
        PREF_GFX_DIST_SCALE = 2803579968,
        PREF_GFX_DOF = 610199086,
        PREF_GFX_DXVERSION = 1333946115,
        PREF_GFX_FXAA = 3449388499,
        PREF_GFX_GRASS_QUALITY = 567272906,
        PREF_GFX_MB_STRENGTH = 4285284704,
        PREF_GFX_MSAA = 714683063,
        PREF_GFX_PARTICLES_QUALITY = 3604568860,
        PREF_GFX_POP_VARIETY = 4293551319,
        PREF_GFX_POST_FX = 4231182218,
        PREF_GFX_REFLECTION_MSAA = 3744221571,
        PREF_GFX_REFLECTION_QUALITY = 1104997207,
        PREF_GFX_SCALING = 1978956077,
        PREF_GFX_SHADER_QUALITY = 1951197721,
        PREF_GFX_SHADOW_QUALITY = 2629073819,
        PREF_GFX_SHADOW_SOFTNESS = 2838151230,
        PREF_GFX_TESSELLATION = 1954569789,
        PREF_GFX_TEXTURE_QUALITY = 3246224886,
        PREF_GFX_TXAA = 1173240403,
        PREF_GFX_VID_OVERRIDE = 3325408817,
        PREF_GFX_WATER_QUALITY = 2299748418,
        PREF_GPS_SPEECH = 1606091352,
        PREF_HDR = 2130619729,
        PREF_HOOD_CAMERA = 4007689014,
        PREF_INVERT_LOOK = 2485693567,
        PREF_INVERT_MOUSE = 2414141853,
        PREF_INVERT_MOUSE_FLYING = 1895180314,
        PREF_INVERT_MOUSE_SUB = 1081645029,
        PREF_KBM_TOGGLE_AIM = 3555768181,
        PREF_LANDING_PAGE = 267484866,
        PREF_LOOK_AROUND_SENSITIVITY = 3535895531,
        PREF_MEASUREMENT_SYSTEM = 2727185039,
        PREF_MEMORY_BAR = 3633129659,
        PREF_MOUSE_ACCELERATION = 2036742413,
        PREF_MOUSE_AUTOCENTER_BIKE = 1639479391,
        PREF_MOUSE_AUTOCENTER_CAR = 149696348,
        PREF_MOUSE_AUTOCENTER_PLANE = 1465916781,
        PREF_MOUSE_DRIVE = 3967281588,
        PREF_MOUSE_DRIVING_SCALE = 2377408150,
        PREF_MOUSE_FLY = 1636070090,
        PREF_MOUSE_HELI_SCALE = 3012234226,
        PREF_MOUSE_ON_FOOT_SCALE = 2982906134,
        PREF_MOUSE_PLANE_SCALE = 2142507903,
        PREF_MOUSE_SUB = 2726913843,
        PREF_MOUSE_SUB_SCALE = 3837940318,
        PREF_MOUSE_TYPE = 3915673976,
        PREF_MOUSE_WEIGHT_SCALE = 3718520480,
        PREF_MP_CAMERA_ZOOM_IN_AIRCRAFT = 1100390361,
        PREF_MP_CAMERA_ZOOM_IN_BOAT = 769526617,
        PREF_MP_CAMERA_ZOOM_IN_HELI = 135983118,
        PREF_MP_CAMERA_ZOOM_IN_VEHICLE = 1545753533,
        PREF_MP_CAMERA_ZOOM_ON_BIKE = 2115054216,
        PREF_MP_CAMERA_ZOOM_ON_FOOT = 2246313447,
        PREF_MUSIC_VOLUME = 1953525014,
        PREF_MUSIC_VOLUME_IN_MP = 3505556176,
        PREF_PCGAMEPAD = 3283241646,
        PREF_PREVIOUS_LANGUAGE = 3185977143,
        PREF_PULSE_HEADSET = 3812563796,
        PREF_RADAR_MODE = 2495119658,
        PREF_RADIO_STATION = 2644361665,
        PREF_REPLAY_AUTO_RESUME_RECORDING = 3039333259,
        PREF_REPLAY_AUTO_SAVE_RECORDING = 874932679,
        PREF_REPLAY_MEM_LIMIT = 3396884589,
        PREF_REPLAY_MODE = 1913581289,
        PREF_RESTORE_DEFAULT = 4111407448,
        PREF_RETICULE = 3473780512,
        PREF_RETICULE_SIZE = 652067317,
        PREF_ROCKSTAR_EDITOR_EXPORT_GRAPHICS_UPGRADE = 2432416921,
        PREF_ROCKSTAR_EDITOR_TOOLTIP = 632774964,
        PREF_SAFEZONE_SIZE = 950937996,
        PREF_SFX_VOLUME = 3766114148,
        PREF_SIXAXIS_ACTIVITY = 4284720026,
        PREF_SIXAXIS_AFTERTOUCH = 1009448171,
        PREF_SIXAXIS_BIKE = 290645929,
        PREF_SIXAXIS_BOAT = 4220519746,
        PREF_SIXAXIS_CALIBRATION = 2444859923,
        PREF_SIXAXIS_HELI = 1639213080,
        PREF_SIXAXIS_RELOAD = 3086969225,
        PREF_SKFX = 3309403606,
        PREF_SNIPER_ZOOM = 380232496,
        PREF_SPEAKER_OUTPUT = 4284211633,
        PREF_SS_FRONT = 294964992,
        PREF_SS_REAR = 931354392,
        PREF_STARTUP_FLOW = 4152421220,
        PREF_SUBTITLES = 2905662092,
        PREF_SWAP_ROLL_YAW_MOUSE_FLYING = 2446803408,
        PREF_SYSTEM_LANGUAGE = 3570680472,
        PREF_TARGET_CONFIG = 4042198688,
        PREF_UR_AUTOSCAN = 59110735,
        PREF_UR_PLAYMODE = 2252323396,
        PREF_VIBRATION = 3518619278,
        PREF_VIDEO_UPLOAD_PRIVACY = 1474618422,
        PREF_VID_ADAPTER = 513764933,
        PREF_VID_ASPECT = 4272299556,
        PREF_VID_MONITOR = 2778315284,
        PREF_VID_PAUSE_ON_FOCUS_LOSS = 2712666514,
        PREF_VID_REFRESH = 3592047720,
        PREF_VID_RESOLUTION = 2199913978,
        PREF_VID_SCREEN_TYPE = 3197243854,
        PREF_VID_STEREO = 1505759530,
        PREF_VID_STEREO_CONVERGENCE = 2946614552,
        PREF_VID_STEREO_SEPARATION = 3220649890,
        PREF_VID_VSYNC = 376443120,
        PREF_VOICE_CHAT_MODE = 4267439465,
        PREF_VOICE_ENABLE = 2366940411,
        PREF_VOICE_FEEDBACK = 3775377360,
        PREF_VOICE_INPUT_DEVICE = 709264567,
        PREF_VOICE_MIC_SENSITIVITY = 1343663347,
        PREF_VOICE_MIC_VOLUME = 726783695,
        PREF_VOICE_MUSIC_VOLUME = 3159605261,
        PREF_VOICE_OUTPUT = 3204042080,
        PREF_VOICE_OUTPUT_DEVICE = 1574014984,
        PREF_VOICE_OUTPUT_VOLUME = 3537546154,
        PREF_VOICE_SOUND_VOLUME = 4275879432,
        PREF_VOICE_SPEAKERS = 3244270344,
        PREF_VOICE_TALK_ENABLED = 2081794932,
        PREF_WIRELESS_STEREO_HEADSET = 4058568955,
        PRIO_ABOVE_NORMAL = 2656127821,
        PRIO_BELOW_NORMAL = 1291609238,
        PRIO_HIGHEST = 2687051358,
        PRIO_IDLE = 953311807,
        PRIO_INHERIT = 2866048273,
        PRIO_LOWEST = 4285326861,
        PRIO_NORMAL = 2538635493,
        PRIO_TIME_CRITICAL = 3131513902,
        PROJECTILE = 4164277166,
        PULL_UP_POINT = 1228270561,
        PadParameter = 1152550856,
        PaidPacks = 3880608165,
        PanicBaseAnims = 3067651217,
        PanicClipSet = 3564543097,
        PanicExitBlendInDuration = 1318731192,
        PanicExits = 262370572,
        PanicIntros = 2212333616,
        PanicOutros = 4089537226,
        PanicShuntToIdleBlendDuration = 2286839301,
        PanicVariations = 1425718621,
        Parameter = 3756725548,
        Parameters = 475963768,
        Parent = 2888440999,
        ParkType = 1808728496,
        Park_Parallel = 2047483215,
        Park_PassengerExit = 3322024794,
        Park_Perpendicular_BackIn = 3362605572,
        Park_Perpendicular_NoseIn = 1831996422,
        Park_PullOver = 404711935,
        ParoleDuration = 619688275,
        PartDeletionChance = 1365456239,
        PartIndex = 292443687,
        PartialHash = 2692702019,
        ParticleQuality = 376555564,
        PathFormatString = 172080853,
        PathZoneMappings = 2351915966,
        PathZones = 1937813094,
        Paths = 2429694906,
        PauseMenuPostFXManager = 2286115964,
        PauseOnFocusLoss = 1282695477,
        PedAimReloadClipId = 2359244935,
        PedAimReloadEmptyClipId = 2154960099,
        PedCapsuleRadiusOverride = 765218362,
        PedCapusleOffset = 3828717882,
        PedClipHash = 2801649672,
        PedDamageHash = 682322888,
        PedDecorationCollection = 3099705199,
        PedDecorationPreset = 61524411,
        PedHolsterClipId = 3313536499,
        PedHolsterCoverClipId = 156692634,
        PedHolsterCrouchClipId = 4146396849,
        PedHolsterCrouchDiscardClipId = 1831678863,
        PedHolsterDiscardClipId = 2995340962,
        PedHolsterWeaponClipId = 3191058412,
        PedIdleReloadClipId = 3513391616,
        PedIdleReloadEmptyClipId = 3787927013,
        PedInSeatTargetable = 630166198,
        PedLodBias = 242256109,
        PedLowLeftCoverReloadClipId = 299247150,
        PedLowRightCoverReloadClipId = 2172108480,
        PedMemoryMultiplier = 4122838043,
        PedModels = 2484998659,
        PedPopulationCyclesPerFrame = 3236396439,
        PedPopulationCyclesPerFrameMP = 2125483566,
        PedPopulationCyclesPerFrameMP_Base = 882061370,
        PedPopulationCyclesPerFrame_Base = 411038053,
        PedPopulationFrameRate = 891302393,
        PedPopulationFrameRateMP = 3504125953,
        PedPopulationFrameRateMP_Base = 2154800712,
        PedPopulationFrameRate_Base = 864949538,
        PedRicochetTolerance = 316211129,
        PedTypes = 1659885497,
        PedUnHolsterClipId = 3439420259,
        PedUnHolsterCrouchClipId = 263830963,
        PedUnHolsterLeftCoverClipId = 3191574200,
        PedUnHolsterRightCoverClipId = 3376422411,
        PedUnHolsterWeaponClipId = 163193844,
        PedVariations = 3827766551,
        PedVarietyMultiplier = 1312579283,
        PedalToFreewheelBlendDuration = 3825821514,
        PedsForVehicles = 4242927954,
        PedsForVehicles_Base = 2267067870,
        PedsKilledOfThisType = 4129008872,
        Penetration = 4207662252,
        PerformEncroachmentChecksIn3D = 999225709,
        Personalities = 112932637,
        Phase = 369413731,
        PhaseStiffnessAdjustHigh = 999233684,
        PhaseStiffnessAdjustLow = 152716673,
        PhysicalMemory = 2030878907,
        PhysicalStreamingBuffer = 2335468885,
        PickupFlags = 3808716310,
        PickupHash = 2874676605,
        PinRadius = 141165022,
        PinVert = 599754167,
        PitchApproachRate = 1235675432,
        PitchLimit = 2202434349,
        PivotHeight = 2096757718,
        PlanarAngularRange = 3566490329,
        PlaneCoeffs = 1133783601,
        PlantInfoFlags = 1247137385,
        Platforms = 685843359,
        PlayListSlots = 923541501,
        PlayNudgeAnimationForBumps = 2070318363,
        PlayOutOfAmmoAnim = 2165980475,
        PlayTauntBeforeAttacking = 2829971830,
        PlayerBirdFlappingSpeedMultiplier = 532301444,
        PlayerBirdGlidingSpeedMultiplier = 3804317324,
        PlayerBroadcastData = 2825161296,
        PlayerControlCamera = 951644869,
        PlayerFlags = 3896972053,
        PlayerFlappingIdealTurnRate = 291845288,
        PlayerFlappingTurnAcceleration = 961953658,
        PlayerGlideIdealTurnRate = 171073592,
        PlayerGlideTurnAcceleration = 2122727094,
        PlayerHeadingDeadZoneThresholdDegrees = 578605354,
        PlayerOutOfWaterThreshold = 1246801857,
        PlayerPitchAcceleration = 2691956573,
        PlayerPitchIdealRate = 677105748,
        PlayerPos = 3065132320,
        PlayerRoadDensityInc = 2704494507,
        PlayerRoadDensityInc_Base = 4006688120,
        PlayerStandEnterCoverAnimStateInfos = 1120845094,
        PlayerTiltedDownSpeedBoost = 2575647854,
        PlayerTiltedDownToleranceDegrees = 27278755,
        PlayerTiltedSpeedCap = 3370383430,
        PlayerTurnControlThreshold = 1811862646,
        PlayerWalkCapsuleRadius = 325409255,
        PlayersRoadScanDistance = 36687211,
        PlayersRoadScanDistance_Base = 3161551940,
        Playlists = 3059901733,
        PointType = 1743038105,
        PointsOfInterestList = 2404677133,
        PoolName = 1188249865,
        PoolSize = 2991655592,
        PoolSizes = 891034988,
        Poses = 239113593,
        PositionAtPetrolTank = 218547915,
        PositionInBoundingBox = 971517740,
        Positive = 1781648578,
        PosixHigh = 1275027139,
        PosixLow = 2663749202,
        PostFX = 1668682387,
        PovCameraHash = 1261448360,
        PovCameraVerticalAdjustmentForRollCage = 4278280695,
        PovDriveByCamera = 1438316471,
        PovPassengerCameraOffset = 2644761776,
        PovRearPassengerCameraOffset = 4035686390,
        PovTurretCameraHash = 3986289617,
        PowerForMaxAdjustmentNetwork = 1745227706,
        PreferFleeOnPavements = 96586447,
        PreferMeleeRagdoll = 2179624041,
        PreferNearWaterSurface = 2227775799,
        PreferToAvoidWater = 246661178,
        PresetFrontRef = 2721634605,
        PresetLeftRef = 2648380967,
        PresetRearRef = 2132680058,
        PresetRightRef = 491767013,
        PreventInterruptAfterClimbUp = 554953479,
        PreventInterruptAfterOpenDoor = 183666737,
        PreventJackInterrupt = 3813711779,
        PreventJustPullingOut = 213361678,
        PreventShuffleJack = 2149205528,
        Price = 169683220,
        PrimedFx = 980007986,
        PrimedFxFP = 169708188,
        Probability = 407978896,
        ProbabilityForDriver = 1429597516,
        ProbabilityForPassengers = 1915471566,
        ProbabilityForTrailer = 1594107934,
        ProbabilityToBeDazedMax = 3346651530,
        ProbabilityToBeDazedMin = 2097303124,
        ProbabilityWeight = 3387860954,
        ProbeDepthFromRoot = 2298122779,
        ProbeForCollisionsInScenarioFlee = 292818937,
        ProbeRadius = 2150248864,
        ProbeYOffset = 1806490034,
        ProcTagLookup = 3343541253,
        ProcTagLookupFlags = 1599521754,
        ProcessGripAnim = 715855819,
        ProcessImpacts = 298405391,
        ProcessLeader = 1811590695,
        ProductId = 488755589,
        ProjectileFlags = 675456238,
        ProjectileForce = 2213357742,
        PropBlocker = 338428843,
        PropBlockerLength = 806415616,
        PropBlockerRadius = 150389370,
        PropBlockerSlot = 3105800423,
        PropBlockerY = 3151490181,
        PropBlockerZ = 790811421,
        PropClipHash = 2028074979,
        PropDescription = 1246509506,
        PropEndOfLifeTimeoutMS = 2080248880,
        PropIndex = 583101016,
        PropIndices = 2738590106,
        PropModelSet = 2715208242,
        PropName = 1462141302,
        PropSet = 2444595376,
        PropSlot = 3282138503,
        PropTextures = 2532045474,
        ProximityActivationTime = 3078567084,
        ProximityDetonation = 315321599,
        ProximityFuseTimePed = 3685057008,
        ProximityFuseTimeVehicleMax = 1767575850,
        ProximityFuseTimeVehicleMin = 314198294,
        ProximityFuseTimeVehicleSpeed = 3747243191,
        ProximityFx = 2802461676,
        ProximityLightColourUntriggered = 498387634,
        ProximityLightFrequencyMultiplierTriggered = 359654397,
        ProximityRadius = 3891186728,
        ProximityTriggerRadius = 4274382301,
        Purchasable = 1873939652,
        PutHelmetVisorDownClipId = 2091354753,
        PutHelmetVisorDownPOVClipId = 2273702662,
        PutHelmetVisorUpClipId = 1851449258,
        PutHelmetVisorUpPOVClipId = 1023392893,
        PutOnHelmetFPSClipId = 1430534928,
        QSFadeInEnd = 2787500128,
        QSFadeInStart = 402935976,
        QSRadius = 1506761814,
        QSRelativeStrength = 1774748567,
        QS_SSAO_ScenePreset = 701113093,
        QUICK_GET_ON_POINT = 2869162963,
        QuadRunSprintTransitionTime = 2445921518,
        QuadRunTurnScaleFactor = 2029088191,
        QuadRunTurnScaleFactorPlayer = 827570153,
        QuadRunWalkTransitionTime = 1355937892,
        QuadSprintRunTransitionTime = 1912282789,
        QuadSprintTurnScaleFactor = 2080668262,
        QuadSprintTurnScaleFactorPlayer = 656760750,
        QuadWalkRunTransitionTime = 4159902888,
        QuadWalkTurnScaleFactor = 1635014245,
        QuadWalkTurnScaleFactorPlayer = 1485594259,
        Quality = 1122932139,
        QualityLevels = 270801642,
        QuickExitsFromHassling = 4069899244,
        QuitTransitionToIdleIntroOnWeaponChange = 460200582,
        R1 = 2638175745,
        R1_INDEX = 1518051711,
        R2 = 2726815902,
        R2_INDEX = 3436221138,
        R3 = 2487307281,
        R3_INDEX = 3192979355,
        RABBIT_ON_FOOT = 1504180964,
        RAGDOLL_LOWER_ARM_RIGHT = 937951079,
        RAT = 201286725,
        RAT_ON_FOOT = 2741333222,
        RA_ACTIVATE_RAGDOLL_ON_COLLISION = 3720332708,
        RA_ADD_ORIENT_TO_SPINE_Z_OFFSET = 3204062202,
        RA_AI_IS_UPPERBODY_ONLY = 1205045384,
        RA_ALLOW_ADDITIVE_ANIMS = 1290077854,
        RA_ALLOW_AIM_INTERRUPT = 3667833757,
        RA_ALLOW_DAZED_REACTION = 1924463811,
        RA_ALLOW_INITIAL_ACTION_COMBO = 2855982449,
        RA_ALLOW_MELEE_TARGET_EVALUATION = 1320928091,
        RA_ALLOW_NO_TARGET_BRANCHES = 2418330681,
        RA_ALLOW_NO_TARGET_INTERRUPT = 101000364,
        RA_ALLOW_PLAYER_EARLY_OUT = 3733166747,
        RA_ALLOW_SCRIPT_TASK_ABORT = 3504723874,
        RA_ALLOW_STRAFING = 490772066,
        RA_DISABLE_PED_TO_PED_RAGDOLL = 2547912438,
        RA_ENDS_IN_IDLE_POSE = 1917431719,
        RA_FORCE_DAMAGE = 2164986929,
        RA_GIVE_THREAT_RESPONSE_AFTER_ACTION = 684609993,
        RA_IGNORE_HIT_DOT_THRESHOLD = 1227167367,
        RA_INTERRUPT_WHEN_OUT_OF_WATER = 4042659633,
        RA_IS_BLOCK = 1127390305,
        RA_IS_COUNTER_ATTACK = 3163957647,
        RA_IS_DAZED_HIT_REACTION = 3462312823,
        RA_IS_HIT_REACTION = 4102035862,
        RA_IS_INTRO = 2173810502,
        RA_IS_KNOCKOUT = 421847048,
        RA_IS_LETHAL = 730303400,
        RA_IS_NON_MELEE_HIT_REACTION = 674596527,
        RA_IS_RECOIL = 2405960867,
        RA_IS_STANDARD_ATTACK = 4081255358,
        RA_IS_STEALTH_KILL = 4160624106,
        RA_IS_TAKEDOWN = 4136387342,
        RA_IS_TAUNT = 989922312,
        RA_PLAYER_IS_UPPERBODY_ONLY = 1659014265,
        RA_PROCESS_POST_HIT_RESULTS_ON_CONTACT_FRAME = 594056020,
        RA_QUIT_TASK_AFTER_ACTION = 3821196575,
        RA_RESET_COMBO = 1704212601,
        RA_RESET_MIN_TIME_IN_MELEE = 2263747265,
        RA_TAG_SYNC_BLEND_OUT = 3092883094,
        RA_UPDATE_MOVEBLENDRATIO = 3723741604,
        RA_USE_CACHED_DESIRED_HEADING = 2909197840,
        RA_USE_KINEMATIC_PHYSICS = 1945979279,
        RA_USE_LEG_IK = 4061757611,
        RA_VALID_FOR_RECOIL = 1507314754,
        RBF_BULLET_IMPACT = 1787990452,
        RBF_DROWNING = 3131137919,
        RBF_ELECTROCUTION = 751464020,
        RBF_EXPLOSION = 487244472,
        RBF_FALLING = 1383543145,
        RBF_FIRE = 2044471925,
        RBF_IMPACT_OBJECT = 4028924317,
        RBF_MELEE = 2462770644,
        RBF_PED_RAGDOLL_BUMP = 640857133,
        RBF_PLAYER_BUMP = 757969282,
        RBF_PLAYER_IMPACT = 3918980554,
        RBF_PLAYER_RAGDOLL_BUMP = 2159802836,
        RBF_RUBBER_BULLET = 155207462,
        RBF_SMOKE_GRENADE = 2098640803,
        RBF_VEHICLE_GRAB = 468716598,
        RBF_VEHICLE_IMPACT = 2523193769,
        RBF_WATER_JET = 2179355917,
        RDOWN = 3840745596,
        RDOWN_INDEX = 1644777409,
        RD_CUSTOM = 3304720255,
        RD_FEMALE = 3972129487,
        RD_MALE = 890725960,
        RD_MALE_LARGE = 1662286774,
        REAR_HELI_DRIVEBY = 2694698705,
        REAR_LEFT = 3979894261,
        REAR_RIGHT = 4176198404,
        REAR_WINDSCREEN = 3993862980,
        REPLAY = 1640390030,
        RETRIEVER = 146457261,
        RETRIEVER_ON_FOOT = 2167962651,
        RLEFT = 2400174695,
        RLEFT_INDEX = 4122098896,
        ROCKET = 1477216026,
        ROTTWEILER = 62404389,
        ROTTWEILER_ON_FOOT = 1611996768,
        RRA_ALLOW_PED_DEAD_GROUND_OVERRIDE = 2505219383,
        RRA_ALLOW_PED_GETUP_GROUND_OVERRIDE = 1024099105,
        RRA_CHECK_ANGULAR_RANGE = 3483662483,
        RRA_CHECK_DISTANCE_RANGE = 1721178953,
        RRA_CHECK_GROUND_RANGE = 2857119816,
        RRA_CHECK_HEIGHT_RANGE = 2534229725,
        RRIGHT = 4293111688,
        RRIGHT_INDEX = 3616451717,
        RSTICK_ALL = 2347367241,
        RSTICK_CLICK = 3952934161,
        RSTICK_DOWN = 879636774,
        RSTICK_LEFT = 3626784484,
        RSTICK_LEFTRIGHT = 3995012327,
        RSTICK_RIGHT = 3916497619,
        RSTICK_ROTATE = 703956159,
        RSTICK_UP = 156783142,
        RSTICK_UPDOWN = 2928482261,
        RUP = 2209694786,
        RUP_INDEX = 3991245044,
        RWT_ANY = 2495165824,
        RWT_HATCHET = 156750106,
        RWT_KNIFE = 2262283722,
        RWT_MACHETE = 1304731725,
        RWT_MELEE_FIST = 312605598,
        RWT_ONE_HANDED_CLUB = 2807354900,
        RWT_ONE_HANDED_CLUB_NO_HATCHET = 1984063490,
        RWT_ONE_HANDED_GUN = 283831585,
        RWT_PISTOL = 2415826370,
        RWT_THROWN = 3098389374,
        RWT_THROWN_SPECIAL = 987734898,
        RWT_TWO_HANDED_CLUB = 4225562510,
        RWT_TWO_HANDED_GUN = 1884983890,
        RWT_UNARMED = 477992374,
        RadioGenre = 3207569683,
        RadioStation = 541003778,
        RadioStationName = 3374055181,
        RadiusAroundCentroid = 2077997379,
        RadiusCrouched = 2685908332,
        RadiusCrouchedinCover = 2167701380,
        RadiusFPSHeadBlocker = 3910433511,
        RadiusGrowSpeed = 1775601195,
        RadiusInCover = 4094064833,
        RadiusMobilePhone = 2994736990,
        RadiusOrAmpDir = 364013743,
        RadiusRunning = 785505199,
        RadiusWeaponBlocked = 200031265,
        RagdollAtExtremeVehicleOrientation = 4270692346,
        RagdollComponent = 3509057257,
        RagdollEasilyFromPlayerContact = 2650586575,
        RagdollPanicExit = 3943710912,
        RagdollScale = 4083383333,
        RagdollType = 3052093264,
        RagdollWhenVehicleUpsideDown = 2208386234,
        Rain = 3424644413,
        RandomizeSpawnedPedHeading = 2363489050,
        Range = 3904102106,
        RangeModifier = 2289954282,
        Ranges = 1410978337,
        RawButtonIcon = 359347310,
        Reaction = 3584669432,
        Reactions = 1593113632,
        RearSeatLink = 1835436571,
        ReassessGroundExitThreshold = 2658900198,
        RecoilAccuracyMax = 434207713,
        RecoilAccuracyToAllowHeadShotAI = 3708020341,
        RecoilAccuracyToAllowHeadShotPlayer = 69979745,
        RecoilErrorTime = 1834435576,
        RecoilRecoveryRate = 571930056,
        RecoilShakeAmplitude = 2849394050,
        RecoilShakeAmplitudeModifier = 4139999934,
        RecoilShakeHash = 2248249481,
        RecoilShakeHashFirstPerson = 4063744033,
        RefList = 3292665010,
        ReferenceMassForDefaultTuning = 2833356187,
        ReflectionMSAA = 1104123574,
        ReflectionQuality = 2609506441,
        Reflection_MipBlur = 646676776,
        RefractionBlend = 2814330875,
        RefractionExponent = 3576976600,
        RefreshRate = 3704241550,
        RegenerationTime = 2682544077,
        RejectApproachIfTooSteep = 2606969503,
        RejectRadius = 352633583,
        RelatedInputs = 947093145,
        RelativeRange = 1126169,
        RelativeRangeAttrs = 3275882620,
        ReloadData = 2256649950,
        ReloadTimeMP = 1607799251,
        ReloadTimeSP = 111686106,
        ReloadUpperBodyFixupExpressionData = 1257996840,
        RemoteOrAiPedStuckThreshold = 3098186043,
        RemoteOrAiPedTurnDelta = 1460193378,
        RemoteOrAiTurnControlThreshold = 216639291,
        RemoveEarlyWhenEnteringVehicles = 802281944,
        RemoveWeapons = 3713579690,
        RemoveWhenUnequipped = 331403679,
        ReportDelay = 1011875804,
        ReportLink = 355336828,
        ReportLinkId = 2094952935,
        ReportLink_CommendRoot = 4024068926,
        ReportLink_Confirmation = 2520009722,
        ReportLink_Content = 2680875257,
        ReportLink_Crew = 1974496320,
        ReportLink_None = 880527478,
        ReportLink_Other = 2879645186,
        ReportLink_PlayerMadeMissions = 1574563647,
        ReportLink_ReportRoot = 333890418,
        ReportLink_Successful = 1706083836,
        ReportLink_UGCReportRoot = 4238777432,
        ReportLists = 1212101567,
        ReportOptions = 4168269643,
        ReportType = 522149456,
        ReportType_Exploit = 584249475,
        ReportType_Friendly = 4189780101,
        ReportType_GameExploit = 2876002080,
        ReportType_Griefing = 597235603,
        ReportType_Helpful = 4234382097,
        ReportType_None = 2329018113,
        ReportType_OffensiveCrewEmblem = 3070830310,
        ReportType_OffensiveCrewMotto = 3566289759,
        ReportType_OffensiveCrewName = 4237464810,
        ReportType_OffensiveCrewStatus = 2442647422,
        ReportType_OffensiveLanguage = 3659211270,
        ReportType_OffensiveLicensePlate = 2579452216,
        ReportType_OffensiveUGC = 4021347911,
        ReportType_Other = 2659943483,
        ReportType_PlayerMade_Content = 1720138758,
        ReportType_PlayerMade_Description = 2309269426,
        ReportType_PlayerMade_Photo = 3468206970,
        ReportType_PlayerMade_Title = 4087965574,
        ReportType_TextChat_Annoying = 4248136643,
        ReportType_TextChat_Hate = 743402485,
        ReportType_VoiceChat_Annoying = 2038319921,
        ReportType_VoiceChat_Hate = 1477484195,
        RequiredMovies = 3463881268,
        RequiresButtonPressToPickup = 2455381601,
        Resolutions = 2545132005,
        ResourceTypeName = 3785513074,
        Response = 830880534,
        ResponseHash = 1418133031,
        Responses = 1586895156,
        RespraysAreFree = 3725757729,
        RestartIdleBlendDuration = 1797630730,
        RestartIdleBlendDurationpassenger = 2658529211,
        RestrictedDriveByClipSet = 3510444657,
        RestrictionTags = 282130242,
        Result = 1233430953,
        ResultAttrs = 1465974863,
        ReticuleHash = 1765739942,
        ReticuleHudPosition = 3851766621,
        ReticuleHudPositionOffsetForPOVTurret = 2103337012,
        ReticuleMinSizeCrouched = 2104616783,
        ReticuleMinSizeStanding = 1539608208,
        ReticuleScale = 2080720095,
        ReticuleStyleHash = 1812355067,
        ReversingHeadingChangeDegreesForBreakout = 3492404675,
        ReversingTimeBeforeAllowingBreakout = 3330274310,
        Rewards = 3529628698,
        RicochetTolerance = 3214260675,
        RippleBumpiness = 3217779982,
        RippleBumpinessWindScale = 1755066497,
        RippleDisturb = 633645880,
        RippleMaxBumpiness = 1095002525,
        RippleMinBumpiness = 703125147,
        RippleScale = 2566336877,
        RippleSpeed = 652200245,
        RippleVelocityTransfer = 2528390832,
        Role = 3218818994,
        RollChangeRate = 583993112,
        RoofIsDown = 139733356,
        RoofIsUp = 2105771243,
        RoofState = 2459938576,
        RoomList = 3955702344,
        RootOffsetZ = 13480969,
        RootOrbitXVariance = 1453990363,
        RootOrbitYVarianceMax = 2399532568,
        RootOrbitYVarianceMin = 3778744185,
        RosScVersion = 1961720951,
        RosTitleName = 2282044994,
        RosTitleVersion = 3584692794,
        RotateBarrelBone = 3713132424,
        RotateBarrelBone2 = 1109826101,
        Rotates = 1983695253,
        RotationLimits = 3239097603,
        RotationRate = 3766032136,
        RotationType = 1353339497,
        RouteInterceptionCheckDefaultMaxForwardDistance = 182226933,
        RouteInterceptionCheckDefaultMaxSideDistance = 3847831913,
        RouteInterceptionCheckMaxTime = 2588997912,
        RouteInterceptionCheckMinTime = 964747565,
        RouteInterceptionCheckVehicleMaxForwardDistance = 55450154,
        RouteInterceptionCheckVehicleMaxSideDistance = 3494668944,
        Rpg = 3521572160,
        RumbleDamageIntensity = 509978146,
        RumbleDurationFps = 2117130686,
        RumbleIntensity = 1983682980,
        RumbleIntensityFps = 3686333465,
        RumbleIntensityTrigger = 814156383,
        Run = 799929549,
        RunAndGunAccuracyMinOverride = 1231966032,
        RunAndGunAccuracyModifier = 251198907,
        RunAndGunAlternativeOrScopedCameraHash = 3044995813,
        RunAndGunCameraHash = 1018393744,
        RunAngAccelDirectBlend = 1350763236,
        RunAngAccelLookBehindTransition = 3611401160,
        RunTurnRate = 2552160989,
        RungSpacing = 3639595115,
        SAC_Maximum = 1413720671,
        SAC_Minimum = 485311651,
        SAT_ENRAGED = 2826768389,
        SAT_GHOST = 159271419,
        SAT_SPRINT_SPEED_BOOST = 2022733813,
        SCRIPTED_INPUT_FIRST = 1811093789,
        SCRIPTED_INPUT_LAST = 962199866,
        SCR_CHAR_ANY = 1983356119,
        SCR_CHAR_FRANKLIN = 3555809957,
        SCR_CHAR_MICHAEL = 4129620041,
        SCR_CHAR_MULTIPLAYER = 3193042708,
        SCR_CHAR_MULTIPLAYER_F = 1880604192,
        SCR_CHAR_TREVOR = 3000998908,
        SContentUnlocks = 1774562927,
        SDialogueCharacters = 3306405926,
        SDialogueCharacters__SCharacterData = 85929242,
        SEAT_RELATIVE = 4272467955,
        SELECT = 2378948445,
        SELECT_INDEX = 1979878098,
        SExtraFolderMount = 2768177821,
        SExtraFolderMountData = 1285719764,
        SExtraTitleUpdateData = 765149907,
        SExtraTitleUpdateMount = 242813301,
        SF_CallImmediately = 2425949470,
        SF_HURRIEDFEMALES_SEXY = 296569367,
        SF_NoChangeLayout = 1790030972,
        SF_NoClearRootColumns = 3079842390,
        SF_NoMenuAdvance = 2863036399,
        SGeneralMovieData = 4290538470,
        SGeneralPauseDataConfig = 344919223,
        SHIP_DESTROY = 3629717396,
        SIDE_LEFT = 1218763474,
        SIDE_REAR = 134452657,
        SIDE_RIGHT = 1468874127,
        SIXAXIS_PITCH = 3612903668,
        SIXAXIS_ROLL = 3382747331,
        SIXAXIS_YAW = 3313349652,
        SInteriorOrderData = 2231356525,
        SMALL_MAMMAL = 461177019,
        SMC_AUTO = 1836230501,
        SMC_DEMO = 4159148650,
        SMC_FIXED = 2245894411,
        SMC_MEDIUM = 1081406934,
        SMC_SAFE = 2706867724,
        SMC_UNKNOWN = 1165950864,
        SMOKE = 1662498694,
        SMOKEGRENADE = 1861981606,
        SMOKEGRENADELAUNCHER = 3456652865,
        SMandatoryPacksData = 3474618280,
        SPEntryAllowedAlso = 4127805431,
        SPOnly = 1137904516,
        SPRate = 1763022491,
        SPedPerceptionInfo = 2795260492,
        SSAO = 1605225689,
        SSetupData = 3638229241,
        START = 3056759242,
        START_INDEX = 2600162950,
        STD_CAR_DRIVEBY = 4075933424,
        STICKYBOMB = 792094205,
        STICK_CLICKS = 553722366,
        SWANKNESS_0 = 2638350917,
        SWANKNESS_1 = 3539563955,
        SWANKNESS_2 = 3234713948,
        SWANKNESS_3 = 4164534327,
        SWANKNESS_4 = 3863452755,
        SWANKNESS_5 = 471533561,
        SYSTEM_TYPE_DROP = 2068290571,
        SYSTEM_TYPE_GROUND = 2642451978,
        SYSTEM_TYPE_MIST = 3958926964,
        SafeHouses = 1490745283,
        SafeRadius = 1270606758,
        SamplingMode = 2009314841,
        Sandstorm = 3880472197,
        SavedGarages = 2190420755,
        Say = 439324394,
        ScAuthTitleId = 790985611,
        ScaleLimits = 1058935210,
        ScanNearbyMountsDistance = 4178328957,
        ScarName = 4079592680,
        ScarStartTime = 1328215439,
        Scary = 3192835789,
        ScenarioActionType = 2566952525,
        ScenarioAttractionDistance = 3600751823,
        ScenarioGivesCombatRadio = 2267178004,
        ScenarioGrantsExtraCash = 901452319,
        ScenarioLayoutForPeds = 1531132287,
        ScenarioLayoutOrigin = 1042154475,
        ScenarioPedsMultiplier = 4275944304,
        ScenarioPedsMultiplier_Base = 3654225919,
        ScenarioTypeGroups = 1756894503,
        Scenarios = 3775021170,
        SceneType = 2655744356,
        ScopeWeaponClipSet = 211234316,
        ScreenHeight = 681732794,
        ScreenRatio = 2530290762,
        ScreenWidth = 3380198161,
        ScriptName = 1431319643,
        ScriptOverlayTime = 717614933,
        ScriptPatchName = 4187269719,
        ScriptedCameraRef = 3308601968,
        ScriptedGlow = 7905517,
        ScriptedGlowList = 2282050426,
        ScriptedGunTaskInfos = 2454557993,
        ScrollBarFlags = 3062939427,
        SearchForPathsAbovePed = 960177391,
        SeatAmbientContext = 868877942,
        SeatAnimFlags = 1459537245,
        SeatAnimInfo = 2113719695,
        SeatBoneName = 3648527223,
        SeatCollisionBoundsOffset = 1574554194,
        SeatDisplacementSmoothingStandUpOnJetski = 3038905403,
        SeatFlags = 828767101,
        SeatInfo = 1526756773,
        SeatOverrideAnimFlags = 2159943747,
        SeatOverrideAnimInfo = 23283940,
        SeatOverrideAnimInfos = 3865895947,
        SeatOverrideClipSet = 4026010045,
        SeatOverrideInfos = 748188607,
        SeatedOffset = 504099935,
        SeatedScenario = 1261472063,
        SecondDoorBoneName = 2176687250,
        SecondaryLightColor = 536422421,
        SecondaryLightFadeDistance = 3685692068,
        SecondaryLightFalloffExponent = 3337796027,
        SecondaryLightInnerAngle = 2180486438,
        SecondaryLightIntensity = 526824795,
        SecondaryLightOuterAngle = 3488176012,
        SecondaryLightRange = 3874133259,
        SecondaryLightVolumeExponent = 4234837826,
        SecondaryLightVolumeIntensity = 2302201623,
        SecondaryLightVolumeOuterColor = 895680918,
        SecondaryLightVolumeSize = 4117173443,
        SectionCreated = 3718643366,
        Sections = 1044449629,
        SeeingRange = 3855852838,
        SeeingRangePeripheral = 757780653,
        SeekModeScanTimeMax = 3930581995,
        SeekModeScanTimeMin = 750708712,
        SelectThisWeapon = 150632230,
        SelectionRouletteBias = 4293934845,
        SelfDamageAmount = 4209379861,
        SelfFilter = 143447113,
        Separation = 2628349887,
        SeparationTime = 2601690794,
        Set = 2407558278,
        SetOnFireOnImpact = 3570131386,
        SettingsMap = 3768791577,
        SfxWindEvalModulationDisplacementAmp = 2809681028,
        SfxWindEvalModulationFreq = 1565056603,
        SfxWindValueModulationProportion = 321016301,
        ShaderQuality = 969284075,
        Shader_SSA = 3008345057,
        ShadowQuality = 515636354,
        Shadow_DisableScreenSizeCheck = 2296614450,
        Shadow_Distance = 2458130305,
        Shadow_LongShadows = 2787439662,
        Shadow_ParticleShadows = 1314784538,
        Shadow_SoftShadows = 405681403,
        Shadow_SplitZEnd = 3718252095,
        Shadow_SplitZStart = 4253024499,
        Shadow_aircraftExpWeight = 3049835554,
        ShareWithPassengers = 3229376308,
        SharkAddRangeInViewMinFar = 3653722296,
        SharkSpawnProbability = 1235067475,
        ShellFx = 616207081,
        ShellFxFP = 3120070733,
        ShellShockedClipSetHash = 3714774609,
        ShopData = 2515711516,
        ShopPedApparel = 4043902091,
        ShopPedComponent = 1689299432,
        ShopPedOutfit = 2252589263,
        ShopPedProp = 1228791529,
        ShopVehicleData = 1352485814,
        ShopVehicleDataArray = 1011741924,
        ShopVehicleMod = 3597691447,
        ShopWeaponComponent = 3500336042,
        ShoreWaveAmplitude = 2129580030,
        ShoreWaveMaxAmplitude = 1689313211,
        ShoreWaveMinAmplitude = 3009911615,
        ShoreWaveWindScale = 3807050929,
        ShortStateTransitionBlendTime = 487169156,
        ShotList = 1224413346,
        ShouldInhibitFirstPersonOnFoot = 1217076542,
        ShouldIntepolateToCatchUp = 218418817,
        ShouldOverlay = 1442682932,
        ShouldPerformFrontClearTest = 3708225791,
        ShouldSilence = 504674867,
        Shuffle2ClipId = 3905015036,
        Shuffle2_180ClipId = 3309036906,
        ShuffleClipId = 2509236171,
        ShuffleLink = 3456159015,
        ShuffleLink2 = 3471770806,
        Shuffle_180ClipId = 939217889,
        ShuntBackClipId = 3278999439,
        ShuntDownClipId = 1558752243,
        ShuntFrontClipId = 2077576253,
        ShuntLeftClipId = 1114189303,
        ShuntRightClipId = 531096295,
        ShuntUpClipId = 4038706223,
        SideDragCoeff = 1152026206,
        Silenced = 4088843462,
        SimulateBumpiness = 3894451581,
        SinglePlayer = 3309860874,
        SingleplayerWantedLevelRadius = 3288138684,
        SitPedalGearApproachRate = 3888455650,
        SitToStandPedalAccelerationScalar = 434213970,
        SitToStandPedalMaxRate = 3900479770,
        SitToStillForceTriggerVelocity = 2083391331,
        SitTransitionJumpPrepBlendDuration = 281193301,
        SizeMax = 43693757,
        SizeMin = 2404272098,
        SizeOfData = 1935971465,
        SizeOfDescriptionBuffer = 3673547431,
        SizeOfStack = 3352347010,
        SkipProjectileLOSCheck = 3227933500,
        SkipVehiclePetrolTankDamage = 1064542030,
        Slave = 89593430,
        SlidingEnterCoverAnimStateInfos = 611524654,
        SlopeScrambleClipSetHash = 1196904267,
        Slot = 1557069762,
        SlotBestOrder = 2500385827,
        SlotNavigateOrder = 839352309,
        Snow = 4073383434,
        SnowMist = 3012329188,
        SoakColor = 2018136978,
        SoakDryingTime = 364737520,
        SoakEndSize = 2621969608,
        SoakEndSizeGravity = 3244240482,
        SoakIntensityDry = 3613729188,
        SoakIntensityWet = 3734209108,
        SoakScaleTime = 3356734092,
        SoakStartSize = 3127784639,
        SoakStartSizeGravity = 1736567263,
        SoakTexture = 3360585842,
        SoakTextureGravity = 2751246897,
        SoftLimitScale = 1972446339,
        SoftLockTimeToAcquireTargetInCover = 2167138628,
        Sound = 1758782715,
        Sound_NoAccept = 3516987878,
        Source = 2679225357,
        SourceNameHash = 445057488,
        SpSessionIdHigh = 2318827786,
        SpSessionIdLow = 3189616982,
        SpVehiclesDriven = 2852803638,
        SpawnFemalePedsOnly = 3874810507,
        SpawnHistoryRange = 3858748618,
        SpawnInterval = 997624951,
        SpawnMalePedsOnly = 1805280030,
        SpawnProbability = 4039386313,
        SpawnPropInLeftHand = 1523876547,
        SpawnPropIntroAnim = 4064751916,
        SpawnPropIntroDict = 908504134,
        SpawnPropOffset = 3251427990,
        SpawnPropRotation = 995447605,
        SpawnedPedIsArrestable = 2165609255,
        Spec2Color = 1824098779,
        Spec2ColorInt = 743459441,
        Spec2Factor = 2689937125,
        SpecFalloffMult = 3175411324,
        SpecFresnel = 3969602784,
        SpecIntMult = 3919648186,
        SpecialCondition = 2172655611,
        SpecialConditionProbability = 3926238724,
        SpecialScopeType = 4107447559,
        SpecialTest = 3841875616,
        SpecificallyPreventArtPoints = 1035513142,
        SpecularFalloff = 2198937011,
        SpeechHash = 4267991997,
        Speed = 2054727018,
        SpeedForMaxLength = 4154217054,
        SpeedForMinLength = 3879165256,
        SpeedToFleeInVehicle = 3995749587,
        SpeedToTriggerBicycleLean = 3737911380,
        SpeedToTriggerStillTransition = 1681463867,
        Sphere = 1419470234,
        SpinDownTime = 2281595383,
        SpinTime = 3405603745,
        SpinUpTime = 3512370407,
        SpineAdditiveBlendInDelay = 2076136146,
        SpineAdditiveBlendInDuration = 2431899696,
        SpineAdditiveBlendInDurationStill = 3197923938,
        SpineAdditiveBlendOutDelay = 706483272,
        SpineAdditiveBlendOutDuration = 2856473752,
        Spinner = 4284370618,
        SplatterDryingTime = 4185196984,
        SplatterIntensityDry = 3300558121,
        SplatterIntensityWet = 4088642047,
        SplatterMaxSize = 1395969014,
        SplatterMinSize = 1110413592,
        SplatterTexture = 1418426473,
        SplineCameraRef = 1044888659,
        Sprint = 302492261,
        SprintReplenishFinishedPercentageBicycle = 3763989739,
        SprintTurnRate = 2623260242,
        SrcKey = 1938679842,
        StackName = 1081444102,
        StackSizeData = 252681370,
        Stand = 3379658339,
        StandExitAnimStateInfos = 1123873278,
        StandPedalGearApproachRate = 3229341008,
        Stat = 2568897139,
        StatName = 2664635642,
        State = 1395005542,
        States = 3953979788,
        StaticReticulePosition = 2181921318,
        StationaryReactHash = 3383553219,
        Stealth = 2446089009,
        StealthAimingBreathingAdditiveWeight = 4172261019,
        StealthAimingLeanAdditiveWeight = 1109011021,
        StealthFiringBreathingAdditiveWeight = 919797803,
        StealthFiringLeanAdditiveWeight = 3259164739,
        StealthKillAction = 807158622,
        SteamAppId = 1584479094,
        SteeringSmoothing = 2913834556,
        SteeringWheelBlendInApproachSpeed = 640640576,
        SteeringWheelBlendOutApproachSpeed = 445721091,
        SteeringWheelOffset = 978694652,
        Stereo = 1185885368,
        StickCenteredBodyLeanYFastMax = 57337560,
        StickCenteredBodyLeanYFastMin = 995876853,
        StickCenteredBodyLeanYSlowMax = 3906612716,
        StickCenteredBodyLeanYSlowMin = 4255127387,
        Sticky = 711480731,
        StillLeaderSpacingEpsilon = 2654008777,
        StillToSitToSitBlendOutDuration = 1380473272,
        StrafeWhenMovingChance = 1335234903,
        StreamAnims = 1570757968,
        StreamedUnarmedCoverMovementFPSClipSetId = 1804897490,
        Strength = 1347918379,
        StrikeBoneSet = 2669027511,
        StrikeBoneTag = 427138322,
        StrikeSettings = 2391928313,
        StringData = 565343801,
        SubHandlingData = 3279284851,
        SubdivisionCount = 963405481,
        SubdivisionPatternMask = 2547979107,
        SubtitleHash = 2531251426,
        Sun = 975871519,
        SuperJumpDurationMult = 358840176,
        SuperJumpIntensityMult = 2719065213,
        SupportsInAirState = 2342791615,
        SuppressGunshotEvent = 1107510860,
        SurfaceSwimmingDepthOffset = 3397337383,
        SwapToUnarmedWhenOutOfThrownAmmo = 2968445534,
        SwapWeaponFilterHash = 1193247110,
        SwapWeaponInLowCoverFilterHash = 2156084932,
        SweepHeadingChangeRate = 1324859893,
        SweepPitchMax = 1284494068,
        SweepPitchMin = 798527498,
        SwimStraightInSwimmingWander = 2277144878,
        SwimmingClipRate = 2181619027,
        SwimmingClipSetBaseHash = 1298983431,
        SwimmingClipSetHash = 4234222477,
        SwimmingWanderPointRange = 1989032516,
        SyncSoakWithWound = 3724201893,
        SystemType = 218700103,
        TANKSHELL = 651698392,
        TASK_DRIVE_WANDER = 1898273177,
        TATTOO_BACK = 2657600110,
        TATTOO_BACK_LEFT = 1147235692,
        TATTOO_BACK_RIGHT = 3391494435,
        TATTOO_FRONT = 1149313842,
        TATTOO_FRONT_LEFT = 867004612,
        TATTOO_FRONT_RIGHT = 2782423976,
        TATTOO_LEFT = 209278732,
        TATTOO_MP_FM = 3070195500,
        TATTOO_MP_FM_F = 3790424175,
        TATTOO_RIGHT = 4072558419,
        TATTOO_SP_FRANKLIN = 3099006483,
        TATTOO_SP_MICHAEL = 3718861294,
        TATTOO_SP_TREVOR = 680493422,
        TC_Maximum = 1541573135,
        TC_Minimum = 1410481380,
        TET_ANY = 2238163376,
        TET_BIPED = 1843126680,
        TET_QUADRUPED = 1406027822,
        TET_SURFACE = 2180505488,
        TIR_Count = 370833650,
        TIR_Execute = 3508167287,
        TIR_TreatAsDead = 1443881968,
        TLR_ExitTask = 2307078756,
        TLR_NeverLoseTarget = 1725892792,
        TLR_SearchForTarget = 152005644,
        TOUCH = 1396704204,
        TOUCH_INDEX = 3972331102,
        TRAILER_DRIVEBY = 4230735098,
        TRANQUILIZER = 479091118,
        TRUCK = 2742470629,
        TT_ENTITY_ROOT = 3770324753,
        TT_ENTITY_ROOT_PREDICTED = 3381011574,
        TT_PED_CHEST = 4004518345,
        TT_PED_CLOSEST_BONE = 1237117667,
        TT_PED_NECK = 1948262397,
        TT_SURFACE_PROBE = 3588444177,
        TVPlayListSlotNames = 691306603,
        TVVideoInfoNames = 1543086052,
        TXAA_Enabled = 4253927984,
        TYPE_BADGE = 3599321036,
        TYPE_INVALID = 3076072567,
        TYPE_MEDAL = 612351581,
        TYPE_TATTOO = 2338236835,
        TalkResponse = 1823962272,
        TalkResponses = 2137002320,
        TargetEntity = 4277693286,
        TargetHeading = 2825931529,
        TargetInjuredReaction = 2095027304,
        TargetLossResponse = 1324470689,
        TargetMustBeDead = 458127407,
        TargetMustBeInCombat = 2555236857,
        TargetMustBeKnockedDown = 1215877188,
        TargetMustBeOnFoot = 2202606465,
        TargetMustHaveResponse = 969779631,
        TargetScale = 2928729788,
        TargetSequenceGroup = 963941856,
        TargetType = 3674102009,
        TaskRef = 1136507244,
        TaskType = 1715812214,
        TaskWanderConditionalAnimsGroup = 1795081127,
        TattooHashes = 3859236512,
        TattooShopItem = 2469662237,
        TattooShopItemArray = 2721857609,
        TattooShopItems = 3133383019,
        TattooTintAdjust = 812793388,
        TauntFrequencyMaxInMs = 1221237951,
        TauntFrequencyMinInMs = 2808750640,
        TauntFrequencyQueuedMaxInMs = 1849101730,
        TauntFrequencyQueuedMinInMs = 861555102,
        TauntProbability = 1586299319,
        TauntProbabilityQueued = 2311592187,
        TaxiPlaneOnGround = 2583152330,
        Tessellation = 2400584054,
        TexGridCols = 993163657,
        TexGridRows = 2069867255,
        Text = 3047673159,
        TextBlockName = 281467385,
        TextTable = 816207049,
        Texture = 1521389609,
        TextureIndex = 926768550,
        TextureName = 3027636643,
        TextureQuality = 2292317827,
        TextureVariations = 3504215824,
        ThermalVision = 3944602408,
        TheySaid = 3934078266,
        ThirdPersonAnimStateInfos = 3920645611,
        ThirdPersonBlindFirePitchAngles = 3127121455,
        Threads = 665402789,
        Threshold = 903885548,
        ThresholdDegrees = 3645267300,
        ThresholdMult = 3659610001,
        ThrowLongFaceCoverClipId = 1925480184,
        ThrowOnly = 2785451743,
        ThrowProjectileFPSClipSetId = 3576155857,
        ThrowShortFaceCoverClipId = 3487669030,
        Thrown = 1514789741,
        ThrownForce = 4264190949,
        ThrownForceFromVehicle = 3003019355,
        ThrustUnderwater = 1860726055,
        Time = 1600645089,
        TimeAfterInitialReactionFailure = 1655591820,
        TimeAfterLastSuccessfulReaction = 1374102023,
        TimeBeforeHoming = 3280026404,
        TimeBeforeInitialReaction = 591873795,
        TimeBeforeSwitchTargetMax = 906828770,
        TimeBeforeSwitchTargetMin = 2470820978,
        TimeBetweenBurstsInCover = 441596179,
        TimeBetweenEscalatingReactions = 2171009901,
        TimeBetweenExitVehicleRetries = 527303977,
        TimeBetweenPeeks = 3324688190,
        TimeBetweenPositionUpdates = 3408785399,
        TimeBetweenShots = 3256479393,
        TimeCycleFilename = 3962850565,
        TimeDriven = 613352583,
        TimeInMilliseconds = 3245297199,
        TimeLeftBetweenShotsWhereShouldFireIsCached = 703241280,
        TimeMult = 1627956429,
        TimeOfDayFlags = 1046770373,
        TimeOnBikeWithoutFleeingBeforeExitVehicle = 909291779,
        TimeSinceLastDamageToAllowAltLowRiderPoseLowRiderPose = 647907606,
        TimeSpentInVehicle = 34256250,
        TimeTilPedLeaves = 3554475036,
        TimeToCrouch = 37156704,
        TimeToIncreaseFriendlyFirePlayer2PlayerPriority = 3508597107,
        TimeToInvalidateInjuredTarget = 1918040165,
        TimeToListen = 2674892547,
        TimeToReachTarget = 2004493994,
        Tint = 760513247,
        TintIndexOverride = 2033860066,
        TintSpecValues = 3432794322,
        Tints = 220458541,
        Tired = 529310733,
        TiredRate = 4198707696,
        TitleDirectoryName = 1072161696,
        ToggleValue = 1471071330,
        ToggleWhenAiming = 2924440875,
        TorsoAimOffset = 2680149834,
        TorsoCrouchedAimOffset = 3657641816,
        TorsoDeltaLimits = 1483348357,
        TorsoIKAngleLimit = 2640922038,
        TorsoIKForWeaponBlock = 3115723786,
        TotalNumCollectables = 116537555,
        Tracer = 1364522772,
        TracerFx = 2239364947,
        TracerFxChanceMP = 2835126311,
        TracerFxChanceSP = 2666101256,
        TracerFxForceLast = 1306494685,
        TracerFxSpacing = 4222468484,
        Track = 151920205,
        TrackIdIndices = 3364828596,
        TrackNumber = 3909095508,
        TrackRopeOrientation = 2097344901,
        TrailFx = 2655653318,
        TrailFxFadeInTime = 265621274,
        TrailFxFadeOutTime = 1058228670,
        TrailFxInactiveOnceWet = 1847541470,
        TrailFxRemovedOnImpact = 780868976,
        TrailFxUnderWater = 3861265230,
        TranscodingBuffer = 1951009942,
        TranscodingMaxPointers = 979371061,
        TranscodingSmallObjectBuffer = 863188010,
        TranscodingSmallObjectMaxPointers = 4014444259,
        TransformA = 1220027836,
        TransformB = 1927379470,
        TransformC = 2911137619,
        TransformD = 2546090959,
        TransitionInfo = 2047945136,
        TransitionToScenario = 3242561151,
        TransitionToScenarioConditionalAnims = 3048359732,
        Translation = 3743696412,
        TranslationLimits = 4265829374,
        TreatAsOneHandedInCover = 2063593465,
        TriIndices = 3820418487,
        TriggerAction = 2837169258,
        TriggerChargeTime_Far = 184804796,
        TriggerChargeTime_Near = 3788390370,
        TriggerMenuId = 1020742058,
        Triggers = 2345687458,
        True = 1504406153,
        TrunkStiffnessAdjustHigh = 1927632977,
        TrunkStiffnessAdjustLow = 4098334536,
        TryLockedDoorOnGround = 1291767722,
        TunableObjects = 3060371587,
        TurnAccelerationSlow = 2035076014,
        TurnAngleDegrees = 3231148850,
        TurnDecelerationThreshold = 1934656831,
        TurnLeftFastDownClipId = 3042448153,
        TurnLeftFastUpClipId = 3713053450,
        TurnLeftSlowDownClipId = 2567235955,
        TurnLeftSlowUpClipId = 1206230540,
        TurnRightFastDownClipId = 3874294070,
        TurnRightFastUpClipId = 413072568,
        TurnRightSlowDownClipId = 2463362878,
        TurnRightSlowUpClipId = 1611862735,
        TurnSpeedApproachRate = 2737439830,
        TurnToFacePlayerStanding = 395430985,
        TurnVelocityThreshold = 1012095486,
        Turret = 1286494682,
        TurretFireClipId = 4031618294,
        TurretPitchLimitData = 3124276594,
        TwistAxis = 4071150139,
        TwistLimitMax = 2055841315,
        TwistLimitMin = 2073932195,
        TwoHanded = 1457464978,
        TxdHash = 620627702,
        TxdName = 2595414426,
        TxtHash = 2752599836,
        Type = 4013319625,
        TypeAndIncludeFlags = 4214278911,
        TypeData = 3770963207,
        Types = 1413429950,
        UI3DDrawManager = 3098759929,
        UIGlobalRenderData = 3127239521,
        UILightData = 2492003825,
        UILightRig = 1919276539,
        UIScenePreset = 1543996069,
        UInt16Data = 2709138475,
        UInt32Data = 1089353365,
        UInt64Data = 2535662089,
        UInt8Data = 1164633916,
        UNDEFINED_INPUT = 917718433,
        UNDEFINED_MAPPER = 1507587849,
        UNKNOWN = 2753687934,
        UPSIDE_DOWN_EXIT = 918138612,
        UVCoords = 1443086166,
        UVScale = 457173517,
        UltraShadows_Enabled = 506154431,
        UnapprovedCameraLists = 3770321882,
        UniqueId = 4249924615,
        UnmappableList = 3821730225,
        UpperBodyFixupExpressionData = 934731519,
        UsableClimbing = 1807193604,
        UsableInCover = 2977207426,
        UsableOnFoot = 1540829291,
        UsableUnderwater = 1418895095,
        Use2DBodyBlend = 2916870002,
        UseAABB = 4238595643,
        UseAdaptiveMbrInMoveFollowLeader = 1705612869,
        UseAdditiveFiring = 62215774,
        UseAlternateFPDrivebyClipset = 4005134136,
        UseAmbientScaling = 3736977166,
        UseAquaticRoamMode = 2449136247,
        UseArmsOutForCops = 920671881,
        UseBasicAnims = 693150086,
        UseBikeInVehicleAnims = 2483844082,
        UseBlockingAnimsOutsideAimRange = 730668970,
        UseBoatBlocker = 1072544988,
        UseBoatInVehicleAnims = 4069701669,
        UseCameraHeadingForHomingTargetCheck = 1445286107,
        UseCloseDoorBlendAnims = 2336893696,
        UseDirectEntryOnlyWhenEntering = 3769034134,
        UseDirectionalBreatheAdditives = 696516126,
        UseDistanceFromScenario = 111723216,
        UseDoorOscillation = 2040669839,
        UseFPSAimIK = 2940845366,
        UseFPSAnimatedRecoil = 966420421,
        UseFPSHeadBlocker = 3010188740,
        UseFPSSecondaryMotion = 232733080,
        UseFilter = 1759296596,
        UseFinerAlignTolerance = 3585922686,
        UseFirstMulipleAccessSeatForDirectEntryPoint = 1340013364,
        UseFirstPersonStickyAim = 3742855719,
        UseFromStrafeUpperBodyAimNetwork = 2429082126,
        UseGetUpAfterJack = 2853581353,
        UseHelmet = 3534643469,
        UseHolsterAnimation = 3513333191,
        UseHorseMapCollision = 3550175875,
        UseInVehicleCombatRates = 1212787581,
        UseInactiveRagdollCollision = 1895793562,
        UseInterior = 3280803678,
        UseJetSkiInVehicleAnims = 1138777096,
        UseLeanSteerAnims = 102559799,
        UseLeftHandIKAllowTags = 1301434997,
        UseLeftHandIkWhenAiming = 1886023584,
        UseLegDamageVoice = 1411573475,
        UseLongerBlendsInFishLocomotion = 1824673603,
        UseLooseCrowdAroundMetrics = 761348666,
        UseLooseHeadingAdjustmentsInMelee = 2286989593,
        UseLowerDoorBlockTest = 2603443111,
        UseLowerLegBound = 622223837,
        UseManualTargetingMode = 3393019104,
        UseMountedProjectileTask = 1614139486,
        UseNMGetupWhenExiting = 4151415857,
        UseNewPlaneSystem = 2014293764,
        UseOpenDoorBlendAnims = 3068350599,
        UseOverrideAngles = 614700810,
        UsePedAsCamEntity = 3024543506,
        UsePerControlTwistLimits = 1246620320,
        UsePickUpPullUp = 3181826513,
        UsePlaneExplosionDamageCapInMP = 1344444454,
        UsePropFromEnvironment = 3669920001,
        UseQuadrupedJump = 2809500111,
        UseRestrictedTorsoLeanIK = 2038737791,
        UseRevolverBehaviour = 2525374418,
        UseRoamTask = 1844612485,
        UseRouteInterceptionCheckToExitVehicle = 2923989237,
        UseSeatClipSetAnims = 170764465,
        UseSimplePitchingInFishLocomotion = 4174290680,
        UseSimpleWander = 982345091,
        UseSingleActionBehaviour = 661086933,
        UseSlowPlayerFishPitchAcceleration = 2629796034,
        UseSpineAdditive = 4280980977,
        UseStandOnGetIn = 166996895,
        UseStandardInVehicleAnims = 1497801847,
        UseSteeringWheelIk = 2582688268,
        UseStillToSitTransition = 729576074,
        UseSweepLoopsForTurret = 1788179298,
        UseSweepsForTurret = 889675530,
        UseThreatWeightingFPS = 1978058747,
        UseThreeAnimIntroOutro = 3525003174,
        UseThreeAnimThrow = 1062195061,
        UseTorsoLeanIK = 306225138,
        UseTwistLimits = 1001677280,
        UseVanOpenDoorBlendParams = 2375237870,
        UseVehicleBurnoutTexture = 3199896839,
        UseVehicleFrontForArrival = 1111379709,
        UseVehicleRelativeEntryPosition = 1799201085,
        UseVehicleWeaponBoneForward = 3775356878,
        UseWeaponRangeForTargetProbe = 2869231615,
        UseWhenForcedAudioFails = 1793283514,
        UserData = 3019099605,
        Users = 3012992578,
        UsesNoDoorTransitionForEnter = 957353473,
        UsesNoDoorTransitionForExit = 1821015784,
        UsesRagdollReactionIfShoved = 2581645775,
        VAULT_HAND_HOLD = 2918595187,
        VC_BOAT = 3596377529,
        VC_COMMERCIAL = 2392270012,
        VC_COMPACT = 3428976494,
        VC_COUPE = 1002019256,
        VC_CYCLE = 3396222426,
        VC_EMERGENCY = 371517297,
        VC_HELICOPTER = 1549447246,
        VC_INDUSTRIAL = 3727973297,
        VC_MILITARY = 2928543544,
        VC_MOTORCYCLE = 422489486,
        VC_MUSCLE = 3213132682,
        VC_OFF_ROAD = 270926745,
        VC_OPEN_WHEEL = 3540184535,
        VC_PLANE = 4231865335,
        VC_RAIL = 2009998507,
        VC_SEDAN = 1641581178,
        VC_SERVICE = 2143138412,
        VC_SPORT = 1720012997,
        VC_SPORT_CLASSIC = 1181357550,
        VC_SUPER = 1825474953,
        VC_SUV = 2332054041,
        VC_UTILITY = 2958565642,
        VC_VAN = 3777613678,
        VDT_BANSHEE = 229777377,
        VDT_BOBCAT = 1417373761,
        VDT_CAVALCADE = 1343556362,
        VDT_COMET = 1107972217,
        VDT_DUKES = 3007254817,
        VDT_FACTION = 366723343,
        VDT_FELTZER = 3883886136,
        VDT_FEROCI = 287261491,
        VDT_FUTO = 1930173306,
        VDT_GENTAXI = 2469174307,
        VDT_INFERNUS = 3029003078,
        VDT_LAZER = 2177074605,
        VDT_LAZER_VINTAGE = 181123195,
        VDT_MAVERICK = 1562634157,
        VDT_PEYOTE = 146676221,
        VDT_RACE = 1808771949,
        VDT_RUINER = 726779715,
        VDT_SPEEDO = 1939189990,
        VDT_SPORTBK = 2188449695,
        VDT_SULTAN = 1700743456,
        VDT_SUPERGT = 3687038905,
        VDT_TAILGATER = 1906009124,
        VDT_TRUCK = 876543862,
        VDT_TRUCKDIGI = 10003043,
        VDT_ZTYPE = 2162928500,
        VEHICLE_BICYCLE = 2076493325,
        VEHICLE_DEFAULT = 569674238,
        VEHICLE_TURRET_SEATED = 4124472110,
        VEHICLE_TURRET_STANDING = 3555963792,
        VEHICLE_TYPE_AMPHIBIOUS_AUTOMOBILE = 4083207208,
        VEHICLE_TYPE_AMPHIBIOUS_QUADBIKE = 3248760281,
        VEHICLE_TYPE_AUTOGYRO = 1130582924,
        VEHICLE_TYPE_BICYCLE = 2203633545,
        VEHICLE_TYPE_BIKE = 2020650354,
        VEHICLE_TYPE_BLIMP = 1612126845,
        VEHICLE_TYPE_BOAT = 2998572331,
        VEHICLE_TYPE_CAR = 3840911933,
        VEHICLE_TYPE_DRAFT = 1456222661,
        VEHICLE_TYPE_HELI = 1038765505,
        VEHICLE_TYPE_NONE = 49461692,
        VEHICLE_TYPE_PLANE = 785118857,
        VEHICLE_TYPE_QUADBIKE = 3835783565,
        VEHICLE_TYPE_SUBMARINE = 2074589778,
        VEHICLE_TYPE_SUBMARINECAR = 804677811,
        VEHICLE_TYPE_TRAILER = 50845064,
        VEHICLE_TYPE_TRAIN = 1434209639,
        VEH_EXT_BONNET = 2887462765,
        VEH_EXT_BOOT = 2505057132,
        VEH_EXT_DOOR_DSIDE_F = 1198997807,
        VEH_EXT_DOOR_DSIDE_R = 1172553228,
        VEH_EXT_DOOR_PSIDE_F = 2945141002,
        VEH_EXT_DOOR_PSIDE_R = 1727412185,
        VFXCullRange = 1143936780,
        VFXData = 651876627,
        VMT_LIGHTBAR = 3409280882,
        VMT_NITROUS = 3278520444,
        VMT_SUBWOOFER = 1675686396,
        VOLUMETRIC_PARTICLE = 2666760331,
        VPT_BACK_PLATES = 1204593434,
        VPT_FRONT_AND_BACK_PLATES = 871644006,
        VPT_FRONT_PLATES = 991146403,
        VPT_NONE = 3301192807,
        VSync = 1434278859,
        VWT_BIKE = 3951064264,
        VWT_HIEND = 498389919,
        VWT_LOWRIDER = 2587831073,
        VWT_MUSCLE = 3123539565,
        VWT_OFFROAD = 1046406813,
        VWT_SPORT = 2667717968,
        VWT_SUPERMOD1 = 1751498700,
        VWT_SUPERMOD2 = 2442531376,
        VWT_SUPERMOD3 = 2220193707,
        VWT_SUPERMOD4 = 3575650687,
        VWT_SUPERMOD5 = 3343154632,
        VWT_SUV = 324333411,
        VWT_TUNER = 1979425808,
        ValidForTargetInsideVehicle = 1949626664,
        ValidForTargetOutsideVehicle = 3709385782,
        ValidInCar = 2536351774,
        ValidInHeli = 1038034379,
        ValidOnBicycle = 569616945,
        ValidOnFoot = 40358752,
        ValidOnlyForDrivers = 2508866928,
        ValidOnlyForPassengersWithDriver = 2056363040,
        ValidOnlyForPassengersWithNoDriver = 3557317647,
        ValidOnlyForStationaryPeds = 1935204311,
        ValidOnlyIfFriendlyWithTarget = 1605836964,
        ValidOnlyIfInsideScenarioRadius = 370855043,
        ValidOnlyIfMissionPedInMP = 2559178905,
        ValidOnlyIfNoScenarioRadius = 1009653044,
        ValidOnlyIfOtherVehicleIsYourVehicle = 867231936,
        ValidOnlyIfOutsideScenarioRadius = 1622167408,
        ValidOnlyIfRandom = 3315575247,
        ValidOnlyIfSource = 1751171761,
        ValidOnlyIfSourceEntityIsOtherEntity = 3325552551,
        ValidOnlyIfSourceIsAnAnimal = 1099678423,
        ValidOnlyIfSourceIsInvalid = 4248277690,
        ValidOnlyIfSourceIsNotThreatening = 2425500412,
        ValidOnlyIfSourceIsPlayer = 2548931325,
        ValidOnlyIfSourceIsThreatening = 1262509762,
        ValidOnlyIfSourcePed = 397904262,
        ValidOnlyIfTargetIsInvalidOrFriendly = 2341603987,
        ValidOnlyIfTargetIsValidAndNotFriendly = 965709313,
        ValidOnlyInAnInterior = 1866321645,
        ValidOnlyInComplexScenario = 4131816627,
        ValidOnlyInCrosswalk = 687838035,
        ValidateExitsWithProbeChecks = 402667713,
        Values = 616148362,
        VarClipSetId = 2088465006,
        VariationMood = 3950258083,
        VehEntryCapsuleRadiusScale = 1964009554,
        Vehicle = 4043274417,
        VehicleActivationForceMultiplierRC = 948117045,
        VehicleAmbientDensityMultiplier = 1970824661,
        VehicleAmbientDensityMultiplier_Base = 4044049866,
        VehicleAttackAngle = 3172632646,
        VehicleChargedLaunch = 3405177958,
        VehicleCoverBoundOffsetInfos = 215981491,
        VehicleCreationRuleBrokenDown = 3108932744,
        VehicleCullRange = 2621891958,
        VehicleCullRangeOffScreen = 4072084512,
        VehicleCullRangeOffScreen_Base = 984327733,
        VehicleCullRangeOnScreenScale = 2958374066,
        VehicleCullRangeOnScreenScale_Base = 2680940560,
        VehicleCullRange_Base = 128096827,
        VehicleDamageModifier = 453838135,
        VehicleDriveByAnimInfos = 163906102,
        VehicleDriveByInfos = 3702479320,
        VehicleEntryPointAnimInfos = 4100779773,
        VehicleEntryPointInfos = 457596809,
        VehicleExplosionInfos = 3221124449,
        VehicleExplosionLODs = 2013600442,
        VehicleExtraPointsInfo = 1232778519,
        VehicleExtraPointsInfos = 3439014114,
        VehicleFragImpulseFunction = 3546701780,
        VehicleFragImpulseRange = 498352297,
        VehicleId = 3613953302,
        VehicleKeyholeShapeInnerRadius = 4292943117,
        VehicleKeyholeShapeInnerRadius_Base = 465067067,
        VehicleKeyholeShapeInnerThickness = 3108378920,
        VehicleKeyholeShapeInnerThickness_Base = 2682858142,
        VehicleKeyholeShapeOuterRadius = 2910627433,
        VehicleKeyholeShapeOuterRadius_Base = 1510347293,
        VehicleKeyholeShapeOuterThickness = 2589510009,
        VehicleKeyholeShapeOuterThickness_Base = 107173663,
        VehicleKeyholeSideWallThickness = 2725888348,
        VehicleKeyholeSideWallThickness_Base = 1776137888,
        VehicleLayoutInfos = 849193768,
        VehicleLodBias = 467056011,
        VehicleLowPrioParkedDensityMultiplier = 4246739166,
        VehicleLowPrioParkedDensityMultiplier_Base = 210188698,
        VehicleMaxCreationDistance = 3548228549,
        VehicleMaxCreationDistanceOffscreen = 3529503514,
        VehicleMaxCreationDistanceOffscreen_Base = 2021802462,
        VehicleMaxCreationDistance_Base = 2552362361,
        VehicleMeleeClipSet = 3659817538,
        VehicleMemoryMultiplier = 1857695184,
        VehicleModelSet = 150429734,
        VehicleModels = 375889271,
        VehicleMods = 1269855236,
        VehicleParkedDensityMultiplier = 1902390439,
        VehicleParkedDensityMultiplier_Base = 3719958594,
        VehicleParkedUpperLimit = 3293582467,
        VehicleParkedUpperLimit_Base = 727724041,
        VehiclePopulationCyclesPerFrame = 3005507567,
        VehiclePopulationCyclesPerFrameMP = 1559668882,
        VehiclePopulationCyclesPerFrameMP_Base = 2325499367,
        VehiclePopulationCyclesPerFrame_Base = 4218706663,
        VehiclePopulationFrameRate = 2258390593,
        VehiclePopulationFrameRateMP = 922579099,
        VehiclePopulationFrameRateMP_Base = 1331353171,
        VehiclePopulationFrameRate_Base = 1184531380,
        VehicleReloadTime = 2645112160,
        VehicleRicochetTolerance = 1526694350,
        VehicleScenarioLayoutInfos = 870960140,
        VehicleSeatAnimInfos = 1363257774,
        VehicleSeatInfos = 1487993593,
        VehicleSets = 1759365079,
        VehicleSetupBrokenDown = 351124677,
        VehicleSide = 1263183222,
        VehicleSpacing = 1113897558,
        VehicleSpacing_Base = 3517110930,
        VehicleTimesliceMaxUpdatesPerFrame = 417348187,
        VehicleTimesliceMaxUpdatesPerFrame_Base = 1566029428,
        VehicleTrailerModelSet = 3553876853,
        VehicleType = 1213782229,
        VehicleUpperLimit = 1524766071,
        VehicleUpperLimitMP = 2780086869,
        VehicleUpperLimit_Base = 2068927110,
        VehicleVarietyMultiplier = 4099109697,
        VehicleWeaponHash = 2246090531,
        VehicleWeaponInfos = 2582916917,
        Vehicles = 2119620164,
        VehiclesSavedInThisSafeHouse = 642989194,
        Version = 1393859097,
        VersionFlags = 2115161503,
        Vertex0 = 2830240759,
        Vertex1 = 231921207,
        VertexPinnedPositions = 2780551786,
        VertexPositions = 1618374541,
        VertexPrevPositions = 2579903500,
        VertexWeight = 2095993823,
        VerticalLaunchAdjustment = 2444130604,
        VerticalOffset = 2304352978,
        Vfx = 4029040229,
        VfxLightningCloudBurstCommonSettings = 2208748908,
        VfxLightningCloudBurstSettings = 2556813649,
        VfxLightningDirectionalBurstSettings = 1503223493,
        VfxLightningKeyFrames = 1169857666,
        VfxLightningSettings = 3301609155,
        VfxLightningStrikeForkPointSettings = 2594427203,
        VfxLightningStrikeSettings = 605135787,
        VfxLightningStrikeSplitPointSettings = 3903814343,
        VfxLightningStrikeVariationSettings = 1604210131,
        VfxLightningTimeCycleSettings = 2839518619,
        VfxName = 2499677161,
        VfxPedBoneWadeInfo = 1073939452,
        VfxPedBoneWaterInfo = 2217981082,
        VfxPedFootDecalInfo = 3745427162,
        VfxPedFootInfo = 2425920550,
        VfxPedFootPtFxInfo = 1299390333,
        VfxPedWadeDecalInfo = 1811001251,
        VfxPedWadeInfo = 4188307664,
        VfxPedWadePtFxInfo = 1559486096,
        VideoCardDescription = 675322965,
        VideoFileName = 2232119195,
        Videos = 2005389215,
        VirtualMemory = 1474445366,
        VirtualStreamingBuffer = 2866594886,
        VisualFieldMaxAzimuthAngle = 1631580138,
        VisualFieldMaxElevationAngle = 3672339510,
        VisualFieldMinAzimuthAngle = 2460900858,
        VisualFieldMinElevationAngle = 2177191255,
        VoiceNameHash = 3482135467,
        VolumeDistribution = 1579671908,
        WANDER = 3934424087,
        WANTED_CLEAN = 4188560519,
        WANTED_LEVEL1 = 4258526076,
        WANTED_LEVEL2 = 2390856921,
        WANTED_LEVEL3 = 2697640299,
        WANTED_LEVEL4 = 3003932142,
        WANTED_LEVEL5 = 2630824312,
        WANTED_LEVEL_LAST = 3431516459,
        WATER_CANNON = 3442972437,
        WEAPON_EFFECT_GROUP_EXPLOSION = 2206634374,
        WEAPON_EFFECT_GROUP_FIRE = 2245616295,
        WEAPON_EFFECT_GROUP_GRENADE = 2989897761,
        WEAPON_EFFECT_GROUP_HEAVY_MG = 2067441938,
        WEAPON_EFFECT_GROUP_LASER = 3064764863,
        WEAPON_EFFECT_GROUP_MELEE_GENERIC = 637945825,
        WEAPON_EFFECT_GROUP_MELEE_METAL = 1726510709,
        WEAPON_EFFECT_GROUP_MELEE_SHARP = 783089623,
        WEAPON_EFFECT_GROUP_MELEE_WOOD = 2936049267,
        WEAPON_EFFECT_GROUP_MOLOTOV = 2865310058,
        WEAPON_EFFECT_GROUP_PISTOL_LARGE = 1160123190,
        WEAPON_EFFECT_GROUP_PISTOL_SILENCED = 613547133,
        WEAPON_EFFECT_GROUP_PISTOL_SMALL = 1024364371,
        WEAPON_EFFECT_GROUP_PUNCH_KICK = 143680721,
        WEAPON_EFFECT_GROUP_RIFLE_ASSAULT = 1123413023,
        WEAPON_EFFECT_GROUP_RIFLE_SNIPER = 3097470125,
        WEAPON_EFFECT_GROUP_ROCKET = 1673794592,
        WEAPON_EFFECT_GROUP_RUBBER = 2783822632,
        WEAPON_EFFECT_GROUP_SHOTGUN = 2175562005,
        WEAPON_EFFECT_GROUP_SMG = 4002581990,
        WEAPON_EFFECT_GROUP_STUNGUN = 2421951135,
        WEAPON_EFFECT_GROUP_VEHICLE_MG = 664328240,
        WHEEL_GROUND_RELATIVE = 3588848591,
        WHEEL_HEAVY = 236830963,
        WHEEL_PISTOL = 1250137536,
        WHEEL_RIFLE = 824520071,
        WHEEL_SHOTGUN = 769129188,
        WHEEL_SMG = 715830599,
        WHEEL_SNIPER = 1647355800,
        WHEEL_THROWABLE_SPECIAL = 3748302545,
        WHEEL_UNARMED_MELEE = 1852482523,
        WOODEN_LADDER = 3202617440,
        WaitForExistingAudioToFinish = 2405467278,
        WaitForRerservationInGroup = 3480579079,
        WaitOnStreamingBeforeNavigatingToStartPosition = 1284753900,
        WaitUntilFacing = 4140184633,
        Walk = 2832929207,
        WalkAngAccelDirectBlend = 1722146938,
        WalkAngAccelLookBehindTransition = 3375971933,
        WalkTurnRate = 432589915,
        WalkWhenStrafingChance = 3708777721,
        WanderRadius = 2912182269,
        WanderScenarioToUseAfter = 2700089416,
        WantedLevelThresholds = 1998206634,
        WantedOverlayTime = 81490677,
        WantedResponses = 3441386479,
        WarningText = 2537961603,
        WarpInWhenStoodOnTop = 611768790,
        WarpIntoAndOut = 3482849308,
        WarpIntoSeatIfStoodOnIt = 3281540861,
        WarpOut = 2773777012,
        WarpOutInPlace = 1039126571,
        WaterColor = 3225853545,
        WaterCycleDepth = 2719833613,
        WaterCycleFade = 601887577,
        WaterData = 3592188702,
        WaterLightningDepth = 1531230966,
        WaterLightningFade = 2825761859,
        WaterOpenDoorClipId = 26377711,
        WaterQuad = 1942421670,
        WaterQuads = 2506553557,
        WaterQuality = 1465777109,
        WaveQuad = 3407574063,
        WaveQuads = 1821793588,
        WeSaid = 4121764149,
        Weapon = 1789903425,
        WeaponAimReloadClipId = 1475420704,
        WeaponAimReloadEmptyClipId = 780676973,
        WeaponAnimationsSets = 94647987,
        WeaponAttachedToLeftHand = 2559351486,
        WeaponAttachedToLeftHand1HOnly = 3896134955,
        WeaponBlockingLengthLongWeaponOffset = 1214766569,
        WeaponBlockingLengthLongWeaponOffsetFPS = 2018978213,
        WeaponBlockingLengthOffsetFPS = 2717483602,
        WeaponBlockingOffsetInLeftCoverFPS = 3824828934,
        WeaponBlockingOffsetInRightCoverFPS = 3593181124,
        WeaponClipSetHash = 1591538607,
        WeaponClipSetHashForClone = 2909139325,
        WeaponClipSetHashHiCover = 3359362088,
        WeaponClipSetHashInjured = 3219476940,
        WeaponClipSetHashStealth = 845722084,
        WeaponClipSetStreamedHash = 3351090124,
        WeaponFlags = 661838282,
        WeaponGroup = 2790476765,
        WeaponGroupDamageForArmouredVehicleGlass = 648099283,
        WeaponGroupNames = 799937553,
        WeaponHealth = 1792342177,
        WeaponHoldingFilterId = 3535710087,
        WeaponIdleReloadClipId = 1049437926,
        WeaponIdleReloadEmptyClipId = 3568045133,
        WeaponLongBlockingOffsetInHighLeftCover = 3668359056,
        WeaponLongBlockingOffsetInLeftCoverFPS = 2805643991,
        WeaponLowLeftCoverReloadClipId = 3661806650,
        WeaponLowRightCoverReloadClipId = 2797760231,
        WeaponName = 1610987145,
        WeaponRange = 901139850,
        WeaponRef = 410782369,
        WeaponRemainsVisible = 2837754041,
        WeaponScale = 1086837752,
        WeaponSeats = 2888748318,
        WeaponShootRateModifier = 1619477036,
        WeaponShopItem = 1445491126,
        WeaponShopItemArray = 326160511,
        WeaponSlots = 3050434139,
        WeaponSwapClipSetHash = 3967936358,
        WeaponSwapData = 638480927,
        WeaponType = 2845577227,
        WeaponTypeNames = 478062417,
        WeaponVehicleModType = 2981235819,
        WeaponVisibleAttachedToRightHand = 1368248484,
        WeatherCycles = 2538049430,
        WeatherGpuFx = 3518093567,
        WeatherReportHistorySpace = 2589842610,
        WeatherReportHistoryWriteIndex = 2417421283,
        WeatherTypeInList = 2780538209,
        Weight0 = 1319110805,
        WeightIndex = 1277839684,
        WheelAngleLimits = 2549513194,
        WheelAngleOffset = 1493926114,
        WheelClipInfo = 3390615972,
        WheelClipLerpInRate = 3516075649,
        WheelClipLerpOutRate = 3346997176,
        WheelSlot = 262177454,
        WidthLevelDecayMax = 2859636620,
        WidthLevelDecayMin = 881365302,
        WidthMax = 2755833743,
        WidthMin = 2650901505,
        WidthMinClamp = 727166988,
        Width_1 = 649996638,
        Width_2 = 2030390763,
        Width_3 = 3054684097,
        WillAttractPeds = 4095658933,
        WillAttractVehicles = 2487466084,
        WillCallLawEnforcement = 1976443414,
        WillJeerAtHotPeds = 2383663879,
        WillMoveToLawEnforcement = 2154752464,
        WindMax = 2223554248,
        WindMin = 3927802072,
        WindSmoothChangeControlPointInterval = 1792572133,
        WindSpeedSoftClamp = 3019765187,
        WindSpeedSoftClampUnrestrictedProportion = 2251693473,
        WindVariationBlendWaveFreq = 2439605238,
        WindVariationRange = 2023386123,
        WindVariationScales = 3501394466,
        WindowId = 547763731,
        WindowTint = 3000111445,
        Windowed = 1328135069,
        WitnessInformation = 768813304,
        WorldSpace = 2510574119,
        WoundBumpAdjust = 1433946275,
        WoundDryingTime = 3593613421,
        WoundIntensityDry = 4025547682,
        WoundIntensityWet = 2104015333,
        WoundMaxSize = 832702013,
        WoundMinSize = 4077854923,
        WoundTexture = 1688904422,
        WrappingPoint = 1116450322,
        WritheFromBulletDamageTheshold = 2890110810,
        XDirection = 940751164,
        XInputs = 4160342529,
        XLeftInputs = 2761796112,
        XRightInputs = 87520475,
        XShakeRef = 784117005,
        XYDistLimitFromAimVector = 3957255740,
        YDirection = 2550845348,
        YDownInputs = 3303221704,
        YInputs = 3437264677,
        YOffset = 561603815,
        YUpInputs = 2390335211,
        YawChangeRate = 1360273452,
        ZDistLimitFromAimVector = 3799655237,
        ZONE_HEAD = 135559250,
        ZONE_INVALID = 2914329495,
        ZONE_LEFT_ARM = 1187323368,
        ZONE_LEFT_LEG = 3907914655,
        ZONE_MEDALS = 2022820778,
        ZONE_RIGHT_ARM = 146062379,
        ZONE_RIGHT_LEG = 3795360398,
        ZONE_TORSO = 4145215689,
        ZOffset = 4110785897,
        ZShakeRef = 4083769430,
        ZeroRotationEulers = 2294964354,
        ZigZagSplitPoint = 1927071790,
        Zone = 2686972086,
        ZoneAreaHull = 2847133566,
        ZoneAreas = 1894757208,
        ZoneKey = 2270628922,
        ZoneType = 3026504196,
        Zones = 3151517163,
        ZoomFactorForAccurateMode = 3619798890,
        a1 = 3553245742,
        a2 = 2729793545,
        a3 = 2844026279,
        a4 = 758148345,
        aActionBranches = 127080310,
        aActionResults = 3726167561,
        aBrawlingData = 1862960718,
        aBrawlingStyles = 2530146790,
        aCondSpecials = 995758842,
        aDefaultTaskData = 1514252138,
        aFacialAnimClipIds = 2053935047,
        aHealthConfig = 2783191749,
        aImpulses = 1655812367,
        aMotionTaskData = 2781060117,
        aPedCapsule = 3424774218,
        aPedIKSettings = 173662082,
        aPedMotivation = 2369895031,
        aPedNavCapabilities = 1528468355,
        aPedPerceptionInfoData = 1599043856,
        aStationPlayTime = 510430164,
        aStrikeBones = 2675585071,
        aTaskData = 1410485796,
        aWeaponActionResultList = 1814108394,
        aWeaponActionResults = 3794583409,
        actionData = 2095171669,
        actionScriptEnum = 323132243,
        actiontypes = 2962859062,
        activationDataThing = 176298773,
        addToPointCloud = 1571951904,
        additionalTrailers = 1233683940,
        additionalVfxWaterSamples = 597887806,
        aging = 3663056802,
        aimCameraName = 297602479,
        allowDuplicates = 3261419154,
        allowInstantBlendToAim = 3537088672,
        alpha = 767087018,
        alt = 3081385586,
        alternate = 645927854,
        alternates = 587583353,
        ambientBaseCol = 1153613275,
        ambientBaseMult = 2766098492,
        ambientDownCol = 1615354867,
        ambientDownMult = 3241553373,
        ambientDownWrap = 461254137,
        ammoCost = 3642106123,
        amount = 2178674873,
        animConvRoofDictName = 1935744787,
        animConvRoofName = 1896156115,
        animConvRoofWindowsAffected = 986055327,
        animDict = 3014265773,
        animFlags = 3180424870,
        animName = 1207997563,
        animatedModel = 3091399856,
        animations = 490102724,
        armedAIEarlyOutPhase = 1757274698,
        arrFlareFX = 4033366283,
        arrFlareTypeFX = 3114834621,
        assetData = 4082165037,
        associatedMap = 1444197829,
        attachments = 2740828529,
        audFootstepEventTuning = 2212433529,
        audio = 3087821544,
        audioNameHash = 890352393,
        automatic = 1960029243,
        availableInSP = 2865078620,
        avoidForwardExtraOffset = 444775360,
        avoidMinFarExtension = 1438517312,
        award = 914197110,
        awardLevel = 3707701107,
        bActive = 1583319234,
        bAlignRotationToSun = 3382102916,
        bAlwaysDrawBitmap = 1388742013,
        bAnimorphicBehavesLikeArtefact = 1526154784,
        bCanBeHassledByGangs = 2123147925,
        bCanBePickedUpByCargobob = 3327762824,
        bCanDoDriveBy = 2978589556,
        bClosestSaveHouseDataIsValid = 1487017515,
        bDependsOnSharedComponents = 9474471,
        bDrawVectorSeaMinimap = 866622976,
        bDrawVectorSeaPaused = 142519492,
        bEmpty = 2401827478,
        bFadeInAfterLoad = 4174381762,
        bHasDisplayedPlayerQuitEnterCarHelpText = 3928235632,
        bIgnoresExplosions = 1983399964,
        bInInterior = 3481537825,
        bIncludeLastStationOnSinglePlayerStat = 2608559031,
        bIsSelectable = 2495137469,
        bIsSet = 3669392268,
        bLeaveCameraAlone = 844016658,
        bManualSection = 3077057714,
        bNotDamagedByBullets = 2386424170,
        bNotDamagedByCollisions = 1473572232,
        bNotDamagedByFlames = 779245171,
        bNotDamagedByMelee = 2407176912,
        bNotOnDisk = 3458051631,
        bPlayerHasHelmet = 396338166,
        bPlayerShouldSnapToGroundOnSpawn = 1268896038,
        bRequiredForSync = 4037131618,
        bRequiresMovieView = 2513905882,
        bSavingVehilclesEnabled = 3861231232,
        bShownOnWheel = 990264677,
        bTyresDontBurst = 601072703,
        bUnreachableByMeleeNavigation = 2375313435,
        bUseRange = 4275923305,
        bUsed = 1697766853,
        backgroundDistortionAlphaBooster = 2054468590,
        backgroundDistortionAmount = 2540936225,
        backgroundDistortionBlurLevel = 634804625,
        backgroundDistortionVisibilityPercentage = 1469396426,
        barberAccsColors = 2949093874,
        barberBlushColors = 3383694912,
        barberHairColors = 3018914614,
        barberLipstickColors = 2870155472,
        baseClipSet = 1251192420,
        baseDetail = 819830158,
        baseMaximumPlaybackTime = 167519961,
        baseMinimumPlaybackTime = 4119488508,
        baseOffset = 2056881007,
        behaviors = 708441477,
        bevelSizeMax = 579138800,
        bgCrackPlacementType = 1516875249,
        bgCrackRotationType = 3239281526,
        bgCrackScalingType = 2014163416,
        bgDecalChannel = 3921023571,
        bgGlassPieceMaxNum = 2726843522,
        bgRectColor = 2082841093,
        bgRectXYWH = 1683532023,
        bgRectXYWH_43 = 2678342941,
        bitShift = 1524100428,
        bitSize = 3827443239,
        blackWhiteWeights = 2624767146,
        blemishes = 1192001882,
        blendColor = 141874196,
        blendDuration = 3741439319,
        blendInDuration = 1557187794,
        blendInTime = 784293992,
        blendIndices = 3042483864,
        blendOutDuration = 959649497,
        blendOutTime = 3304734120,
        blue = 2320856042,
        blusher = 3619287365,
        body = 2351258280,
        bodyOverlay1 = 274368784,
        bodyOverlay2 = 1236171703,
        bodyOverlay3 = 1000660900,
        bone1 = 900097340,
        bone2 = 3288531447,
        boneId = 3393954417,
        boneName = 1307494321,
        boneid = 2904438756,
        bonnetCameraName = 1132818522,
        boundIndexForWaterSamples = 1984508768,
        boxCentreOffset = 2819134350,
        boxInstances = 3199604160,
        boxSize = 2498072179,
        boxTypes = 316874012,
        boxes = 2001383126,
        breakPieceSizeMax = 2652954840,
        breakPieceSizeMin = 3954897903,
        breathPtFxName = 740137113,
        breathPtFxSpeedEvoMax = 886073686,
        breathPtFxSpeedEvoMin = 1841095686,
        breathScubaPtFxName = 2631634259,
        breathScubaPtFxSpeedEvoMax = 2821295083,
        breathScubaPtFxSpeedEvoMin = 3959299203,
        breathWaterPtFxName = 1349459576,
        breathWaterPtFxSpeedEvoMax = 194784077,
        breathWaterPtFxSpeedEvoMin = 2366514623,
        bumpersNeedToCollideWithMap = 1498474993,
        buoyancyDragFactor = 1066284461,
        buoyancyFactor = 1223566388,
        buoyancySphereOffset = 320461316,
        buoyancySphereSizeScale = 3786676713,
        c0 = 622975660,
        c1 = 988350014,
        c2 = 1252828613,
        c3 = 1484407136,
        cAnimDictName = 2234207977,
        cAnimName = 176867356,
        cAnimName2 = 3351587412,
        cAudioTrackName = 2340744294,
        cBoneName = 2260542057,
        cCameraAnimName = 2680173734,
        cCompression = 2709422649,
        cEffectAnim = 3420961041,
        cEffectName = 1784557081,
        cEvoName = 2293413050,
        cGfxFilename = 810029688,
        cHeaderFilename = 3859304837,
        cHeaderNamespace = 565960713,
        cLightName = 626542062,
        cMissionTextName = 3390751505,
        cModelName = 1644371555,
        cObjectName = 3668865896,
        cOriginalEffectName = 3636773674,
        cTextId = 3718403803,
        cTextOutput = 3160235089,
        cached = 585334047,
        camAimCameraMetadata = 336537506,
        camBaseCameraMetadata = 2743580885,
        camBaseCinematicTrackingCameraMetadata = 3971684619,
        camBaseDirectorMetadata = 1556270939,
        camBaseObjectMetadata = 1745663080,
        camBaseShakeMetadata = 1694476654,
        camBaseSplineCameraMetadata = 2512904157,
        camBaseSwitchHelperMetadata = 4245383685,
        camCinematicContextMetadata = 2922865428,
        camCinematicDirectorMetadataAssistedAimingSettings = 2393752128,
        camCinematicInTrainShotMetadata = 958221744,
        camCinematicInVehicleConvertibleRoofContextMetadata = 3548249816,
        camCinematicInVehicleCrashContextMetadata = 605729178,
        camCinematicMeleeShotMetadata = 1284166712,
        camCinematicMissileKillContextMetadata = 3995928235,
        camCinematicOnFootAssistedAimingReactionShotMetadata = 1458019486,
        camCinematicOnFootSpectatingShotMetadata = 4059215640,
        camCinematicShotMetadata = 792485189,
        camCinematicWaterCrashContextMetadata = 1990925977,
        camFirstPersonAimCameraMetadata = 2828477782,
        camFollowCameraMetadata = 1111059525,
        camFollowObjectCameraMetadata = 3212888257,
        camInconsistentBehaviourZoomHelperBaseSettings = 3167612398,
        camReplayBaseCameraMetadata = 2063777938,
        camStickyAimHelperMetadata = 2482626077,
        camThirdPersonAimCameraMetadata = 1519557833,
        camThirdPersonCameraMetadata = 3923406894,
        cameraMtx = 2450322274,
        cameraName = 839330614,
        cameraSettings = 869408005,
        catalog = 102952355,
        ceilingHeight = 1999982939,
        ceilingLodLevel = 4066870372,
        changeSet = 871349634,
        changeSetGroupToExecuteWith = 3665241258,
        charSlot = 891840574,
        characterInfo = 3394803286,
        cinematicPartCamera = 2783287839,
        clampToGround = 2113106769,
        clip = 3877360426,
        clipName = 620531492,
        clipSet = 3295369873,
        clipSetName = 2326431882,
        collection = 681842085,
        collidesWithLowLodVehicleChassis = 4200319075,
        color1 = 339378721,
        color2 = 2286316087,
        color3 = 2129614729,
        color4 = 1809854827,
        color5 = 1646140903,
        color6 = 1453590271,
        colours = 2357618729,
        columnDataType = 1936040237,
        columnId = 844151870,
        columnType = 1150402363,
        component = 1373051002,
        componentDesc = 445999962,
        componentName = 3332664269,
        comps = 3063702438,
        condition = 1771412351,
        configSource = 1479302767,
        contentChangeSetGroups = 349365059,
        contextOption = 857754767,
        contextOptions = 533145877,
        continuous = 2642638077,
        cost = 970089808,
        coverBoundOffsets = 1282865083,
        crackArray = 3933510404,
        crackInBetweenPiecesSizeMax = 3519293470,
        crackMapCenterLocation = 1473614343,
        crackMapOverwriteScalingX = 758974093,
        crackMapOverwriteScalingY = 1022338546,
        crackMapRotationType = 181328521,
        crackMapScalingType = 2935578606,
        crackRadiusImpactShowValueMax = 2852498201,
        crackRadiusImpactShowValueMin = 3259477485,
        crackTypes = 932376122,
        cracks = 1231331629,
        creatorAccsColors = 1810234268,
        creatorBlushColors = 3923946693,
        creatorHairColors = 3381799366,
        creatorLipstickColors = 2436331478,
        creatureMetaData = 279028359,
        culledContainerHashes = 4022397219,
        currCountAsFacebookDriven = 1964573190,
        cutf_ = 1851598786,
        cutf_bool = 1289798959,
        cutf_float = 1674696498,
        cutf_int = 1626675902,
        cutf_string = 557437386,
        damage = 1125348833,
        damageMapScale = 1255738992,
        damageOffsetScale = 4187730551,
        damageVelThreshold = 3889541463,
        dashboardType = 1760417081,
        datFile = 577829042,
        data = 1588979285,
        dataId = 4142080042,
        debugLocation = 1909691728,
        debugLocationList = 3211693794,
        debugModelName = 2324972083,
        debugPedName = 473273908,
        decalColB = 1596752989,
        decalColG = 1201263928,
        decalColR = 1369041264,
        decalInfoName = 3741812782,
        decalName = 1202643824,
        decalRadiusImpactShowValueMax = 2177412266,
        decalRadiusImpactShowValueMin = 3878294151,
        decalTextureChannel = 2199470713,
        decalTextureScaleMax = 2224141308,
        decalTextureScaleMin = 2217516418,
        decalType = 3413493659,
        decalWetColB = 2318441304,
        decalWetColG = 1822646338,
        decalWetColR = 2768457985,
        defaultBodyHealth = 2930066408,
        defaultPlayerName = 2489619803,
        defaultProloguePlayerName = 213639717,
        defaultSecondaryColor = 33307658,
        defaultValue = 278756702,
        delay = 1491124644,
        densityMultiplier = 1586784085,
        dependencyPackHash = 182688775,
        depth = 3165221590,
        description = 3602990230,
        deviceName = 1788770711,
        dictionaries = 1116624301,
        dictionaryName = 2733027896,
        diffuseName = 1983930742,
        diffuseSplashName = 1994184493,
        diffuseTint = 1112950415,
        dirVelAddCamSpeedMinMaxMult = 1245740153,
        directionalLightShadowAmount = 485655270,
        directionalZOffsetMinMax = 3705017082,
        dirtLevelMax = 195579508,
        dirtLevelMin = 2141334886,
        distanceMappingScale = 1201517125,
        distanceMultiplier = 1354602257,
        distortionTexture = 4165161729,
        dlcHash = 3997551979,
        dlcNameHash = 1654656498,
        dmgPackName = 164499637,
        doorEnumHash = 340594178,
        doorId = 3433505109,
        doorState = 1807799203,
        doorStiffnessMultipliers = 3020752020,
        doorsWithCollisionWhenClosed = 2906321638,
        downAvoidLockDurationMaintain = 2436197334,
        downHitZDeltaBuffer = 3009403254,
        drawableIndex = 3592036793,
        driveType = 642843492,
        driveableDoors = 3410537685,
        driverName = 1345153124,
        drivers = 3057379684,
        dropDownPhase = 3259273311,
        durationMax = 1833037662,
        durationMin = 3003800332,
        dynamicBakeBoostMax = 1182594434,
        dynamicBakeBoostMin = 4281392423,
        eAgilityFlags = 2675594832,
        eAnchorPoint = 192937431,
        eAnimSceneFlags = 482423162,
        eBitmapForMinimap = 1737696498,
        eBitmapForPause = 3712817443,
        eBraveryFlags = 3079935216,
        eCameraSettings = 3972381740,
        eCharacter = 1759148841,
        eCompType = 4243941617,
        eCreditType = 1795685103,
        eCriminalityFlags = 1639628591,
        eDamageType = 3503772671,
        eDepth = 4002433734,
        eDoorId = 3593639295,
        eDriveType = 288423563,
        eEventType = 2357557800,
        eExplosionTag = 2330092246,
        eExtraContentPackType = 4051055832,
        eExtraIncludes = 4118136445,
        eFacing = 1267113277,
        eFaction = 3951967475,
        eFireType = 2326832389,
        eHandlingType = 3640111155,
        eIkControlFlags = 587988216,
        eInstructionButtons = 823124840,
        eLookAtImportance = 3253470445,
        eMenuAction = 1523003873,
        eMenuItemBits = 1514803502,
        eMenuOption = 48911619,
        eMenuPref = 3696091185,
        eMenuScreen = 1047335845,
        eMenuScreenBits = 680400738,
        eMenuScrollBits = 3510456514,
        eMenuVersionBits = 1600533539,
        ePackFileMetaDataAssetType = 3387532954,
        ePackFileMetaDataImapGroupType = 1193003611,
        ePedCompFlags = 3643495144,
        ePedConfigFlags = 3425142912,
        ePedDamageZones = 1749523801,
        ePedDecorationType = 610583491,
        ePedDecorationZone = 3991104495,
        ePedVehicleTypes = 2920442291,
        ePopGroupFlags = 4186696686,
        ePushType = 2299021566,
        eRagdollBlockingFlags = 330426831,
        eRagdollType = 329870941,
        eRandomEventType = 3799765345,
        eReportLink = 2214796059,
        eReportType = 827447775,
        eScenarioActionCombatExit = 2374295,
        eScenarioActionCowardExit = 2689253330,
        eScenarioActionFlee = 744391852,
        eScenarioActionHeadTrack = 4190343113,
        eScenarioActionShockReaction = 1314249807,
        eScenarioActionThreatResponseExit = 2678198829,
        eScenarioActionType = 1199771768,
        eScriptedAnimFlags = 3726330130,
        eSettingsManagerConfig = 1775154270,
        eShop = 880500594,
        eShopEnum = 4287397678,
        eSwankness = 699112100,
        eSystemType = 2594217109,
        eTattooFacing = 4228316920,
        eTattooFaction = 1505768495,
        eVehicleClass = 839787204,
        eVehicleDashboardType = 2880085065,
        eVehicleFlags = 3505896161,
        eVehiclePlateType = 2897186134,
        eVehicleScenarioType = 3971689874,
        eVehicleWheelType = 1790759257,
        eWantedLevel = 2744902142,
        eWeaponEffectGroup = 2779228777,
        eWeaponWheelSlot = 2153456197,
        eWindowId = 347144579,
        earlyOutPhase = 1349313370,
        edgeSoftness = 3885192456,
        elements = 2120029714,
        emitterSettingsName = 887711154,
        enableSequentialHit = 4267693302,
        endImapFile = 2355522151,
        endModel = 2604481509,
        endPos = 3932138849,
        endRot = 1355559705,
        endTime = 724616715,
        entity = 961558953,
        entityId = 3284738635,
        enumValue = 3431983277,
        envEffScaleMax = 3048867315,
        envEffScaleMax2 = 3551159380,
        envEffScaleMin = 411166393,
        envEffScaleMin2 = 2771156491,
        eulerRotation = 2054241921,
        eventArgsDefList = 3932371821,
        eventDecisionMaker = 1701948467,
        eventDecisionMakerResponseData = 2755273644,
        eventDefList = 1585341921,
        eventResponseTaskData = 1129810032,
        events = 3674287931,
        exhaust_17 = 4240562588,
        exhaust_18 = 389222022,
        exhaust_19 = 1368490814,
        exhaust_20 = 2819663955,
        exhaust_21 = 1653316942,
        exhaust_22 = 1969406716,
        exhaust_23 = 3203782177,
        exhaust_24 = 3519282109,
        exhaust_25 = 729952060,
        exhaust_26 = 973655113,
        exhaust_27 = 2224709995,
        exhaust_28 = 383976958,
        exhaust_29 = 4263990367,
        exhaust_30 = 2113099045,
        exhaust_31 = 2235818938,
        exhaust_32 = 2189418034,
        explosionInfo = 1978955991,
        expressionDictName = 2849363610,
        expressionSets = 1782315801,
        expressions = 2261737514,
        extraIncludes = 1659935257,
        eyebrow = 1023558241,
        fAfterburnerEffectDistance = 2117178389,
        fAfterburnerEffectForceMulti = 2524722744,
        fAfterburnerEffectRadius = 3067323712,
        fAltimeterOffset = 4158832075,
        fAltimeterTilt = 1912611271,
        fAnimorphicScaleFactorU = 1037289575,
        fAnimorphicScaleFactorV = 1342532810,
        fAntiRollBarBiasFront = 3245031039,
        fAntiRollBarForce = 1907950179,
        fAquaplaneForce = 2469684978,
        fAquaplanePushWaterApply = 942014410,
        fAquaplanePushWaterCap = 674301906,
        fAquaplanePushWaterMult = 2324358599,
        fArgumentDistanceMaxSq = 990057437,
        fArgumentDistanceMinSq = 110858295,
        fArtefactDistanceFadeFactor = 2327929087,
        fArtefactGradientFactor = 339047291,
        fArtefactRotationFactor = 333898965,
        fArtefactScaleFactor = 3195567347,
        fAttachLimitPitch = 2837705256,
        fAttachLimitRoll = 3282302858,
        fAttachLimitYaw = 2939624569,
        fAttachRaiseZ = 108781614,
        fAttachedMaxDistance = 4249804786,
        fAttachedMaxPenetration = 3546965691,
        fAttackDiveMult = 499931534,
        fAttackLiftMult = 1979208430,
        fBackEndPopUpBuildingImpulseMult = 1990944363,
        fBackEndPopUpCarImpulseMult = 2584040900,
        fBackEndPopUpMaxDeltaSpeed = 2357933314,
        fBackwardAngleMax = 1436702958,
        fBackwardAngleMid = 1971748422,
        fBackwardAngleMin = 2421863390,
        fBackwardForcedPitch = 2455811331,
        fBigmapOffset = 1723892124,
        fBigmapTilt = 2229181525,
        fBikeGroundSideFrictionMult = 1066303826,
        fBikeOnStandLeanAngle = 2633531215,
        fBikeOnStandSteerAngle = 4037323246,
        fBikeWheelGroundSideFrictionMult = 3046282826,
        fBitmapRequiredZoom = 1172300147,
        fBodyDamageControlEffectMult = 788114504,
        fBoostMaxSpeed = 2493728169,
        fBoxFrontMult = 3686878359,
        fBoxRearMult = 1258733677,
        fBoxSideMult = 615209840,
        fBrakeBiasFront = 497893473,
        fBrakeForce = 3834657051,
        fBrakingStabilityMult = 230763605,
        fBulletVelocityForGravity = 726768416,
        fCamberFront = 2476918954,
        fCamberRear = 3624620650,
        fCamberStiffnesss = 2224353298,
        fCastor = 1640088456,
        fChromaticFadeFactor = 4075552577,
        fChromaticTexUSize = 1093275192,
        fClimbCostModifier = 3513392638,
        fClutchChangeRateScaleDownShift = 2113714858,
        fClutchChangeRateScaleUpShift = 3873946885,
        fCollisionDamageMult = 1161378225,
        fCoronaDistanceAdditionalSize = 4278313499,
        fDampening = 613659463,
        fDeepWaterSampleBuoyancyMult = 598931757,
        fDeformationDamageMult = 2286171811,
        fDesLeanReturnFrac = 2719615518,
        fDinghySphereBuoyConst = 871157145,
        fDistFromLight = 763772243,
        fDistance = 3762245277,
        fDistanceInnerOffset = 2684996109,
        fDiveSpeed = 371954360,
        fDownforceModifier = 1749337465,
        fDragCoefficient = 3751257616,
        fDriveBiasFront = 3801553570,
        fDriveInertia = 3335348387,
        fEngineDamageMult = 1459002167,
        fEngineOffGlideMulti = 1950483525,
        fEngineResistance = 309331188,
        fEvoValue = 2249072622,
        fExposureIntensityFactor = 3794010227,
        fExposureRotationFactor = 456094139,
        fExposureScaleFactor = 117142835,
        fExteriorFootOffset = 187030077,
        fExteriorFootTilt = 1296848312,
        fExtraLiftWithRoll = 2569081970,
        fFarClip = 3528235255,
        fFleeRangeExtended = 1817496588,
        fFormLiftMult = 1082379505,
        fForwardAngleMax = 512099174,
        fForwardAngleMin = 1409747503,
        fFrontBalanceMult = 45613732,
        fFullAnimAngle = 3913404937,
        fGearDoorFrontOpen = 2122189605,
        fGearDoorRearMOpen = 1185626813,
        fGearDoorRearOpen = 1245337594,
        fGearDoorRearOpen2 = 3687646336,
        fGearDownDragV = 401997078,
        fGearDownLiftMult = 2783333998,
        fGradientMultiplier = 1832572669,
        fHandBrakeForce = 1125642897,
        fHeadingOfClosestSaveHouse = 2520233369,
        fHeadingOffset = 2005378256,
        fHealth = 137683408,
        fImpellerForceMult = 1680879352,
        fImpellerOffset = 357869302,
        fInAirSteerMult = 458923630,
        fInitalOverheadAssist = 777925079,
        fInitialDragCoeff = 2253040349,
        fInitialDriveForce = 740237963,
        fInitialDriveMaxFlatVel = 2534707071,
        fInitialPitchMult = 1627844028,
        fInitialRollMult = 3107524956,
        fInitialThrust = 2965806136,
        fInitialYawMult = 2999140529,
        fInputSensitivityForDifficulty = 2620536973,
        fIntensityFade = 2403647053,
        fIntensityScale = 3267708189,
        fInteriorFootOffset = 2075786872,
        fInteriorFootTilt = 2652932444,
        fJumpForce = 2885780557,
        fJumpForceScale = 2903020012,
        fKeelSphereSize = 3205410615,
        fLeanBakCOMMult = 4121297301,
        fLeanBakForceMult = 2683855360,
        fLeanFwdCOMMult = 3865664070,
        fLeanFwdForceMult = 1188932995,
        fLeftPontoonComponentId = 994711799,
        fLook_L_R_CamHeight = 1926300001,
        fLowLodAngOffset = 2905822962,
        fLowLodDraughtOffset = 2550904159,
        fLowSpeedTractionLossMult = 3268775799,
        fMass = 594945077,
        fMaxBankAngle = 4108661285,
        fMaxDriveBiasTransfer = 3335241175,
        fMaxExposureIntensity = 1239801191,
        fMaxExposureScale = 2907308889,
        fMaxLosBlockedTimeToForceClearLos = 2878670581,
        fMinExposureIntensity = 2719737152,
        fMinExposureScale = 212809191,
        fMiscGadgetVar = 1263837376,
        fMoveRes = 2778642137,
        fMoveResXY = 535351072,
        fMoveResZ = 3478325083,
        fMultiplayerParkedVehicleDensityMultiplier = 4028385349,
        fMultiplayerRandomVehicleDensityMultiplier = 831319638,
        fNearClip = 320764279,
        fOilVolume = 79442313,
        fOnGroundYawBoostSpeedCap = 1969390427,
        fOnGroundYawBoostSpeedPeak = 2088283223,
        fPauseMenuTilt = 3708284943,
        fPercentSubmerged = 4221308057,
        fPetrolTankVolume = 454561579,
        fPitchAngle = 3764664368,
        fPitchMult = 2619869645,
        fPitchStabilise = 2323059969,
        fPontoonBuoyConst = 2876708412,
        fPontoonDragCoefficient = 3280168147,
        fPontoonLengthFractionForSamples = 2963905875,
        fPontoonSampleSizeFront = 2771250052,
        fPontoonSampleSizeMiddle = 3060212379,
        fPontoonSampleSizeRear = 2238622063,
        fPontoonVerticalDampingCoefficientDown = 2145660492,
        fPontoonVerticalDampingCoefficientUp = 123041174,
        fPopUpLightRotation = 1460282965,
        fPosConstraintMassRatio = 160497194,
        fPositionOffsetU = 2040603470,
        fPropRadius = 2516176743,
        fProwRaiseMult = 1009098751,
        fRangeEnd = 1373847595,
        fRangeStart = 3158412256,
        fRearBalanceMult = 491012577,
        fRightPontoonComponentId = 2426342049,
        fRocketBoostCapacity = 1896097205,
        fRollCentreHeightFront = 1937351940,
        fRollCentreHeightRear = 2004550816,
        fRollMult = 3435319499,
        fRollStab = 3515048878,
        fRollStabilise = 172571325,
        fRudderForce = 2366546183,
        fRudderOffsetForce = 3652866225,
        fRudderOffsetForceZMult = 841471263,
        fRudderOffsetSubmerge = 3603345552,
        fSampleBottom = 3162036929,
        fSampleBottomTestCorrection = 2468304440,
        fSampleTop = 2109161037,
        fScrollSpeed = 2048871210,
        fSeatOffsetDistX = 593667784,
        fSeatOffsetDistY = 287375941,
        fSeatOffsetDistZ = 1205497783,
        fSideSlipMult = 1582425976,
        fSize = 3579168290,
        fSoundRange_ProjectileLanding = 60903513,
        fStabilityAssist = 554574363,
        fSteeringLock = 3654120267,
        fStickLeanMult = 31953987,
        fStoppieBalancePoint = 484025653,
        fSubmergeLevelToPullHeliUnderwater = 2650403167,
        fSunFogFactor = 388475155,
        fSunVisibilityFactor = 688841759,
        fSuspensionBiasFront = 3941258667,
        fSuspensionCompDamp = 4021640101,
        fSuspensionForce = 982289796,
        fSuspensionLowerLimit = 1317843829,
        fSuspensionRaise = 1926373385,
        fSuspensionReboundDamp = 4180333153,
        fSuspensionUpperLimit = 4056579948,
        fTargetDistalongAimCamera = 2546440310,
        fTargetInAircraftWeighting = 1742395925,
        fTextureColorDesaturate = 2456900707,
        fThrust = 4208593926,
        fThrustFallOff = 387692762,
        fThrustVectoring = 2976431702,
        fTimeLosBlockedForReturnToInitialPosition = 2186966715,
        fToeFront = 1641347290,
        fToeRear = 4226566674,
        fTopAlpha = 2170322240,
        fTractionBiasFront = 530397889,
        fTractionCurveLateral = 4019591723,
        fTractionCurveMax = 3114647433,
        fTractionCurveMin = 238130583,
        fTractionLossMult = 854431453,
        fTractionMultiplier = 2127435515,
        fTractionSpringDeltaMax = 1612832104,
        fTransmissionMultiplier = 526508617,
        fTurretCamPitchMax = 452599455,
        fTurretCamPitchMin = 4287983534,
        fTurretPitchForwardMin = 916627993,
        fTurretPitchMax = 3869618603,
        fTurretPitchMin = 19015468,
        fTurretSpeed = 1799001417,
        fTurublenceForceMulti = 3725631724,
        fTurublenceMagnitudeMax = 1931684929,
        fTurublencePitchTorqueMulti = 1105811614,
        fTurublenceRollTorqueMulti = 826211408,
        fUprightDampingConstant = 1045322806,
        fUprightSpringConstant = 694513566,
        fUvAnimationMult = 357858585,
        fValue2 = 663632862,
        fWaveAudioMult = 1943283018,
        fWeaponDamageMult = 1482706210,
        fWeaponDamageScaledToVehHealthMult = 1061924052,
        fWheelImpactOffset = 954096748,
        fWheelieBalancePoint = 3567533893,
        fWheelieSteerMult = 2932429266,
        fWidthRotate = 3419479974,
        fWindMult = 3646252726,
        fYawMult = 1009003140,
        fYawStabilise = 4016085005,
        fZoomScale = 2017135317,
        fZoomSpeed = 2749377655,
        facialClipSetGroups = 4050606873,
        facialHair = 3153620542,
        faction = 2175389151,
        fadeDistEnd = 1768347469,
        fadeDistStart = 4135301713,
        fadeFar = 2092702953,
        fadeGrdOffLoHi = 2678723374,
        fadeInOut = 1009996819,
        fadeNear = 3814432579,
        fadeNearFar = 2276152950,
        fallbackSet = 1982931455,
        females = 1903979191,
        filePathHash = 278817785,
        filter = 1239184307,
        firePtFxSpeedEvoMax = 717291862,
        firePtFxSpeedEvoMin = 2002559884,
        firstPersonDrivebyData = 2880736435,
        firstPersonSteerWheelMult = 3628992419,
        flatAlpha = 187180413,
        flip = 1612469413,
        float2VarDefaults = 2458827615,
        float2Vars = 1157992572,
        float4VarDefaults = 2348746723,
        float4Vars = 1178082469,
        floatVarDefaults = 3781434069,
        floatVars = 1686857043,
        fogOfWar = 3683015302,
        footInfoName = 3557178741,
        footPtFxSpeedEvoMax = 815580680,
        footPtFxSpeedEvoMin = 898188953,
        forceRestart = 4173338011,
        forceSquared = 2556353423,
        forcedComponents = 1056653653,
        forcedProps = 3721614456,
        forkliftAttachAngledAreaDims = 3472315837,
        forkliftAttachAngledAreaOrigin = 2469177275,
        forkliftCanAttachWhenFragBroken = 3998719416,
        fpsPropModel = 2329072004,
        fpsPropModelOffset = 3744165743,
        freqAndAmp = 2958941882,
        frequency = 838802376,
        frequencyMax_1 = 1657108591,
        frequencyMax_2 = 1350521827,
        frequencyMin_1 = 1532229943,
        frequencyMin_2 = 2940510487,
        fullBlendHeadingInterpRate = 2623058480,
        fullDlcName = 2580954258,
        fwAllConfigs = 2622161552,
        fwClipDictionaryBuildMetadata = 368570120,
        fwClipRpfBuildMetadata = 4111958819,
        fwConfig = 3388500356,
        fwConfigManager__fwPoolSizeEntry = 597035195,
        fwConfigManager__fwPoolSizeEntryArray = 664508554,
        fwConfigWithFilter = 1670071527,
        fwConfigWithFilterBase = 2439415461,
        fwExpressionSet = 707073765,
        fwExpressionSetManager = 914924483,
        fwFacialClipSetGroup = 745873492,
        fwFacialClipSetGroupManager = 571444630,
        fwFacialClipSetVariationInfo = 2857880760,
        fwFrameFilter = 2446903092,
        fwFrameFilterDictionary = 2134017913,
        fwFrameFilterDictionaryStore = 1789734963,
        fwFrameFilter_TrackIdIndex = 757849241,
        fwMemorySituation = 3219912345,
        fwMemorySituation__Adjustment = 2356519750,
        fwMoveNetworkDefs = 2494480745,
        fxData = 449216489,
        gameName = 302929974,
        garages = 3962124699,
        garment = 983945622,
        gender = 554494895,
        genericConditions = 2141703142,
        glassCenter = 160653803,
        glassFrameFlags = 26449104,
        glassImpactLocation = 2294205496,
        glassRandom = 2826492330,
        glassSize = 19848756,
        glassSizes = 3847153201,
        glassType = 3795685080,
        glassTypes = 1342037020,
        globalRenderData = 1037327587,
        gpuPtFxInterpRate = 4204794351,
        gpuPtFxName = 28713766,
        gpuPtFxSunThresh = 3099312282,
        gpuPtFxTempThresh = 2437695423,
        gpuPtFxTimeMax = 1202806570,
        gpuPtFxTimeMin = 1775217766,
        gpuPtFxWindThresh = 3614737265,
        graphics = 3154743001,
        gravity = 2311087134,
        green = 1439605128,
        hButtonHash = 2302829819,
        handlingId = 3963731356,
        handlingName = 3506546160,
        handlingType = 184071535,
        hasAdditionalText = 3629713783,
        hasGlobalTextFile = 4124526012,
        headInfo = 1327421948,
        header = 3308140543,
        heading = 1140182852,
        height = 1392374582,
        heightBetweenJumps = 3240384895,
        hiddenAlpha = 1006360873,
        hiddenObjects = 1594224340,
        highWind = 3126562441,
        highWindAmplitude = 2342470781,
        highWindSpeed = 2771232716,
        hour = 1605056896,
        iAttachedTo = 863788975,
        iAttachmentCount = 556152156,
        iBitmapTilesX = 2262853888,
        iBitmapTilesY = 735818480,
        iBlockingBoundCount = 1676679523,
        iBone = 4227504912,
        iBoneTag = 1129778557,
        iCamcorderOverlayCount = 2166990736,
        iColour = 1467080115,
        iComponentId = 1726286800,
        iDirtLevel = 456791546,
        iDrawDistanceCount = 2323283412,
        iDrawableId = 1806741254,
        iEffectCount = 2288645107,
        iEffectId = 1356471327,
        iEndFrame = 257902965,
        iEndTime = 1657270719,
        iEventArgsDefIndex = 370762184,
        iEventArgsIndexList = 2652985976,
        iEventArgsTypeOffset = 600723835,
        iEventIdOffset = 954748165,
        iFixupObjectCount = 1603667057,
        iFrameOffset = 956057998,
        iFrontX = 139310760,
        iFrontY = 3899553486,
        iFrontZ = 3054604821,
        iHiddenObjectCount = 3725555564,
        iId = 3928202460,
        iLightCount = 2500841050,
        iManualSectionCreatedIn = 1560155386,
        iManualSectionToUse = 1133562964,
        iManualSectionToUseForAudio = 2532693679,
        iModelCount = 3884485937,
        iModelSize = 3929295594,
        iNameHash = 3155848091,
        iOppositeEventIdOffset = 1510909013,
        iPlayerId = 406658221,
        iPropCount = 2771540439,
        iRank = 4112244135,
        iSectionCount = 4019709044,
        iSectionCreatedIn = 3744377967,
        iSectionSplitFrameCount = 877816009,
        iSectionSplitFrames = 4097110709,
        iStartFrame = 3364840797,
        iStartTime = 2763302298,
        iStaticSize = 983235720,
        iSubtitleCount = 1407085052,
        iSunVisibilityAlphaClip = 111665655,
        iTextDuration = 3203723255,
        iTextStartTime = 421933061,
        iTextureId = 1511426829,
        iVariationCount = 2647019029,
        iVehicleCount = 3594628894,
        iVehicleRemovalCount = 3423319568,
        identicalModelSpawnDistance = 3890250857,
        ikFlags = 4025263192,
        ikSolverTypeArm = 3196788199,
        ikSolverTypeBodyLook = 243876621,
        ikSolverTypeBodyRecoil = 2226163232,
        ikSolverTypeCount = 1088728558,
        ikSolverTypeHead = 1389139139,
        ikSolverTypeLeg = 134818039,
        ikSolverTypeRootSlopeFixup = 2658492121,
        ikSolverTypeTorso = 3246529242,
        ikSolverTypeTorsoReact = 2238484714,
        ikSolverTypeTorsoVehicle = 2839801584,
        inWater = 591424730,
        includedPedComponents = 700699453,
        includedPedProps = 3270934877,
        index = 2437943609,
        info = 1745727664,
        init = 305198855,
        initDatas = 817570641,
        initialImpactKillRadius1 = 1116366463,
        initialImpactKillRadius2 = 1447398901,
        isEnclosed = 551914457,
        isInOutfit = 3788287408,
        isLevelPack = 4041186048,
        isMPGarage = 88694924,
        isTitleUpdate = 2344531221,
        itemKey = 3173039231,
        items = 3308786431,
        kAllHighlighted = 1184426069,
        kAllowBackingOut = 911923277,
        kAllowBackingOutInMenu = 46247505,
        kAllowStartButton = 3890643601,
        kAutoDetectRotation = 2506541684,
        kAutoShiftDepth = 1418353791,
        kCanHide = 1927085963,
        kClothOnly = 3591585384,
        kDamageZoneHead = 1730855309,
        kDamageZoneLeftArm = 2924882599,
        kDamageZoneLeftLeg = 1581517787,
        kDamageZoneRightArm = 340456844,
        kDamageZoneRightLeg = 3110936023,
        kDamageZoneTorso = 2155686558,
        kDelayAudioUntilUnsuppressed = 2052366534,
        kFadesIn = 2692016683,
        kForceButtonRender = 449368751,
        kForceProcessInput = 274983291,
        kGeneratesMenuData = 3233051303,
        kGravityRotation = 3921864217,
        kHideHeaders = 3643905859,
        kLayoutOriginVehicle = 1234310608,
        kLayoutOriginVehicleBack = 2474035373,
        kLayoutOriginVehicleFront = 3370744424,
        kMenuSectionJump = 1611525914,
        kNoBackground = 1320159285,
        kNoHeaderText = 1576936463,
        kNoPeds = 546166292,
        kNoPlayerInfo = 2421487068,
        kNoRotation = 556100428,
        kNoSwitchDelay = 989241993,
        kNoTabChange = 4204140205,
        kNoTabChangeWhileLocked = 2753959907,
        kNoTimeWarp = 3898244661,
        kNotDimmable = 909489091,
        kPushRadialU = 3897150517,
        kPushSine = 2576846893,
        kRandomRotation = 3330848297,
        kRenderMenusInitially = 3893805748,
        kSkinOnly = 847818119,
        kTabsAreColumns = 3295922521,
        kUseAlternateContentPos = 1978677890,
        key = 3917505287,
        keyEntryData = 805781336,
        keyhash = 3698406096,
        kitID_U16 = 2275620044,
        kitIdx = 2393392848,
        knockOffBikeImpulseScalar = 1844488646,
        labels = 523099886,
        lastGenMapping = 2281855409,
        layout = 790219145,
        left = 1872971840,
        leftArmInfo = 2777464895,
        leftLegInfo = 558480717,
        lengthScale = 526679687,
        lifeMinMax = 2662907595,
        lightRigs = 3929666203,
        lightningOccurranceChance = 2750210937,
        lightningShakeIntensity = 732277161,
        lightningTimeCycleMods = 4102815076,
        lights = 2759356478,
        listOfUnlocks = 4073326358,
        loadingScreenContext = 911789342,
        localDrawableIndex = 1047078585,
        localIndex = 780090987,
        localLightsMultiplier = 2597104839,
        localPropIndex = 2826551643,
        locate = 3227881038,
        location = 4223740370,
        locationData = 4025223550,
        locationList = 2005266464,
        lockHash = 1907095960,
        lockOnPositionOffset = 1167504128,
        lodDistances = 3069632142,
        looping = 3373143253,
        lowLodBuoyancyDistance = 1244749121,
        lowLodBuoyancyHeightOffset = 115693582,
        lowLodBuoyancyNoCollision = 1812668140,
        lowWind = 4094448737,
        lowWindAmplitude = 2592912321,
        lowWindSpeed = 2516586435,
        mAltitudeScrollScaler = 2928740722,
        mAngularVelocity = 1819602162,
        mAnimBlendWeights = 3032535228,
        mAnimMode = 4076082737,
        mBits = 1014049497,
        mCamPositionScaler = 2550795233,
        mCamPositionScalerAdjust = 3538558457,
        mCloudHatFrags = 2299219051,
        mCostFactor = 1079984755,
        mDesiredTransitionTimeSec = 2977590635,
        mEnableAnimations = 1018768000,
        mEnabled = 601968405,
        mFilename = 1086081964,
        mHeightFadeRange = 1745582549,
        mHeightTigger = 3847221835,
        mLayers = 477656267,
        mName = 3548916773,
        mPosition = 2283091179,
        mProbability = 1628425461,
        mRotation = 2463369033,
        mRotationScale = 249046947,
        mScale = 3375320117,
        mShowLayer = 3016673491,
        mTransitionAlphaRange = 3928429592,
        mTransitionInDelayPercent = 3492381881,
        mTransitionInTimePercent = 4143994714,
        mTransitionMidPoint = 3568961478,
        mTransitionOutDelayPercent = 929191274,
        mTransitionOutTimePercent = 4025641465,
        mUVVelocity = 4073225414,
        maintainHeightMaxZDelta = 3623227512,
        makeup = 1403120684,
        males = 760220351,
        matrix = 837004614,
        matrix34 = 487099107,
        matrix34V = 3949029090,
        matrixCount = 1425897880,
        matrixGlobalVarName = 484274629,
        maxAlpha = 208313892,
        maxFileStoreSize = 3120069994,
        maxHealth = 1309097368,
        maxIntensity = 2709250928,
        maxNum = 1657539152,
        maxNumOfSameColor = 3938477208,
        maxNumPieces = 2797408358,
        maxPitchAngle = 3992129857,
        maxPlaybackRate = 2748753401,
        maxPos = 2054700136,
        maxReverseSpeed = 2245311725,
        maxSizeOfStreamingReplay = 1859098392,
        maxSteeringWheelAngle = 507472223,
        maxTimeToStayInStartupModeOnLongRangeDescent = 374286939,
        maxVelocity = 185810337,
        maxX = 3077488755,
        maxY = 3392431614,
        maximumPlaybackTime = 774565876,
        medalLocations = 2436493202,
        medalScale = 2781097588,
        memory = 3010803161,
        memorySituations = 3532340754,
        minAlpha = 3897418615,
        minHeightAbove = 950683894,
        minPlaybackRate = 2416444661,
        minPos = 385242302,
        minSeatHeight = 382687742,
        minSequentialHitPieceSize = 3479797909,
        minThickness = 966406980,
        minVelocity = 3072359124,
        minVelocityFrequency = 476261326,
        minX = 610102571,
        minY = 4094004348,
        minimumPlaybackTime = 3753263867,
        minimumResidentTime = 1040578349,
        minorOrder = 2647060672,
        miscwobble_1 = 3695645231,
        miscwobble_2 = 3959468450,
        miscwobble_3 = 1086348072,
        miscwobble_4 = 1391918997,
        miscwobble_5 = 2204328045,
        miscwobble_6 = 362808552,
        miscwobble_7 = 3364383402,
        modVariation = 2212324080,
        mode = 1746230403,
        modelInfoHash = 3848606972,
        modelNameHash = 628609127,
        mods = 3207858859,
        moneyCheated = 2743108181,
        mood = 2671123052,
        motionStartPhase = 2194641308,
        motionState = 3072902158,
        mount = 2692356500,
        mountAs = 223074869,
        moveNetworkDefs = 2382549738,
        movementBreakOutPhase = 798505352,
        nArmour = 3562964998,
        nCurrentWeaponSlot = 3011659568,
        nDisableExtras = 3056245938,
        nInitialDriveGears = 2339950440,
        nLastBustMessageNumber = 1795623689,
        nMaximumWantedLevel = 2834054593,
        nMonetaryValue = 1656203401,
        nStoredHatPropIdx = 3539735150,
        nStoredHatTexIdx = 1758104510,
        nSubGroup = 1317007586,
        nTexture = 1270049807,
        naOcclusionInteriorMetadata = 3730683074,
        naOcclusionPathNodeChildMetadata = 2301425487,
        naOcclusionPathNodeMetadata = 1998468471,
        naOcclusionPortalEntityMetadata = 4133637881,
        naOcclusionPortalInfoMetadata = 2166096847,
        nameHash = 2546986278,
        nameId = 168120687,
        needsRopeTexture = 2408349863,
        neonColB = 117552945,
        neonColG = 2890957252,
        neonColR = 1346029982,
        neonFlags = 1097807168,
        netCatalog = 1346814180,
        netCatalogBaseItem = 4202268203,
        netCatalogGeneralItem = 4099998853,
        netCatalogInventoryItem = 3600870304,
        netCatalogOnlyItem = 936381274,
        netCatalogOnlyItemWithStat = 3884344935,
        netCatalogPackedStatInventoryItem = 2100175500,
        netCatalogServiceItem = 762410778,
        netCatalogServiceLimitedItem = 83623382,
        netCatalogServiceWithThresholdItem = 836100046,
        netInventoryBaseItem = 18755640,
        netInventoryPackedStatsItem = 1403865233,
        nextItemId = 3684394878,
        no180Blend = 531799021,
        notDamagedByFlames = 1476686082,
        npcName = 3443271910,
        numBytesPerReplayBlock = 2383880563,
        numJumpsMax = 1248407122,
        numJumpsMin = 3214212668,
        numKeyEntries = 250483642,
        numReplayBlocks = 978419806,
        numSeatsOverride = 2895309336,
        objectAngularSpeedDamping = 1692275950,
        objectAngularVelocityDamping = 1713544932,
        objectAngularVelocitySquaredDamping = 1864136579,
        objectCentreOfMassOffset = 3221812353,
        objectLinearSpeedDamping = 1621774100,
        objectLinearVelocityDamping = 3593974229,
        objectLinearVelocitySquaredDamping = 751763785,
        objectMass = 2987407275,
        objectName = 3976286705,
        objectStrength = 4133471955,
        objects = 1621540074,
        onFoot = 1565447681,
        optional = 1685853253,
        order = 1167033931,
        overlayInfos = 2334557128,
        overwrite = 1025428972,
        overwriteSquared = 2759159718,
        pBehavior = 880872840,
        pBlockingBounds = 3467282549,
        pCamcorderOverlays = 35958147,
        pChildren = 2282313352,
        pDefnName = 2654844514,
        pDrawDistances = 3980145602,
        pEffects = 2706382237,
        pFixupObjects = 2448439940,
        pOverrideRagdollThreshold = 3838243090,
        pProps = 780961380,
        pRuleName = 1332611795,
        pSections = 1661959852,
        pSubtitles = 1523691914,
        pVariations = 837502985,
        paletteRow = 42248814,
        panSpeed = 1819421691,
        parachuteDeployPtFxName = 789559375,
        parachuteSmokePtFxName = 3414327374,
        particleColorPercentage = 1503004897,
        partitionDesc = 3644473712,
        partitionName = 2573200828,
        path = 2911533749,
        ped = 886638433,
        pedComponents = 545014668,
        pedName = 899553242,
        pedOutfits = 1655823897,
        pedProps = 2221605251,
        peds = 2376147223,
        permittedVehicleType = 1068737713,
        perspectiveShear = 4158529868,
        phMaterialMgrGta__RumbleProfileList = 1232792841,
        phRumbleProfile = 2623870311,
        pickupData = 2575949783,
        plateType = 890277329,
        platform = 800999469,
        playbackList = 1427450494,
        playbackLists = 1533425965,
        playerAimOrFireBreakOutPhase = 3586377483,
        playerPos = 670661031,
        points = 2280921924,
        popAllocation = 1105639458,
        popBaseRangeScale = 2304154060,
        popRangeMultiplier = 1457405649,
        popRangeScaleEnd = 2056852733,
        popRangeScaleStart = 1430479029,
        pos_x = 627174607,
        pos_y = 234241532,
        position_43 = 1089842706,
        postfxData = 2082883036,
        postion = 3220373130,
        povCameraName = 469480805,
        povTurretCameraName = 1001486822,
        preset = 2973707311,
        presets = 3337863816,
        pretendOccupantsScale = 1695066281,
        price = 4294619357,
        pricepaid = 4201563898,
        primaryColor = 1389712537,
        profileName = 3416605148,
        prop = 2376473656,
        propIndex = 4109930547,
        propertyId = 1218176152,
        proxies = 2045976454,
        ptFxExtras = 1768151411,
        ptFxInfoName = 2206302043,
        ptFxOffset = 1568553803,
        ptFxRange = 3076451235,
        ptfxAssetName = 2440601339,
        push = 1960114521,
        pushAreas = 1183854610,
        putOnAnim = 1950800141,
        radiusOfStreamedScenarioPedCheck = 904449331,
        ragdollBlockingFlags = 2958215960,
        ragdollFrameBlendDuration = 1094701388,
        rage__ControlInput__AxisDefinition = 1952646734,
        rage__ControlInput__ConflictList = 2919146252,
        rage__ControlInput__ControlSettings = 1870433316,
        rage__ControlInput__DeviceSettings = 4175639622,
        rage__ControlInput__DynamicMappingList = 1680399780,
        rage__ControlInput__DynamicMappings = 3194848940,
        rage__ControlInput__Gamepad__Definition = 1968075445,
        rage__ControlInput__Gamepad__DefinitionList = 2794072405,
        rage__ControlInput__Gamepad__Source = 371356830,
        rage__ControlInput__InputGroupDefinition = 3031434609,
        rage__ControlInput__InputList = 2886468128,
        rage__ControlInput__InputSettings = 2407405115,
        rage__ControlInput__Keyboard__KeyInfo = 1061406939,
        rage__ControlInput__Keyboard__Layout = 1727850024,
        rage__ControlInput__Mapping = 781730360,
        rage__ControlInput__MappingList = 1926730419,
        rage__ControlInput__MappingSettings = 3501664348,
        rage__ControlInput__MouseSettings = 2286380171,
        rage__ControlInput__RelatedInputs = 714766949,
        rage__InputCalibration__Calibration = 3854872155,
        rage__InputCalibration__Calibrations = 2518940893,
        rage__InputCalibration__Data = 1442119111,
        rage__InputGroup = 76089772,
        rage__InputType = 3461769743,
        rage__Mapper = 2654410252,
        rage__NMBehavior = 3541433893,
        rage__NMBehaviorInst = 1231093604,
        rage__NMBehaviorPool = 2314680758,
        rage__NMParam = 1425473919,
        rage__NMValue = 1959136211,
        rage__NMValueBool = 1966384833,
        rage__NMValueFloat = 602463151,
        rage__NMValueInt = 2816130104,
        rage__NMValueString = 3761657159,
        rage__NMValueVector3 = 3155418783,
        rage__SAttachmentDetails = 1495254421,
        rage__SBlockDetails = 1576173745,
        rage__SCamcorderOverlay = 2498463666,
        rage__SDrawDistanceDetails = 2137817411,
        rage__SEffectsDetails = 494157433,
        rage__SFixupObjectDetails = 1593369920,
        rage__SHiddenObjectDetails = 2590457679,
        rage__SLightDetails = 1277362999,
        rage__SModelDetails = 492377920,
        rage__SPropDetails = 2658642242,
        rage__STextIdDetails = 1265991194,
        rage__SVariationDetails = 498211511,
        rage__SVehicleDetails = 4085730374,
        rage__SVehicleRemoval = 3417253330,
        rage__SimpleScaleform = 3249772165,
        rage__bgConfig = 4005502905,
        rage__bgCrackStarMap = 2526195971,
        rage__bgCrackType = 896936605,
        rage__bgFloat2VarData = 2212110961,
        rage__bgFloat4VarData = 3635288970,
        rage__bgFloatVarData = 1925678758,
        rage__bgGlassSize = 2589387164,
        rage__bgGlassTypeConfig = 4065981122,
        rage__bgShaderVars = 1415489259,
        rage__bgTextureVarData = 4240181151,
        rage__characterCloth = 4077720414,
        rage__characterClothController = 1524681036,
        rage__characterClothControllerTuning = 3759040165,
        rage__characterClothControllerTuning__enFlags = 1060442929,
        rage__characterClothController__BindingInfo = 3844391068,
        rage__characterClothDebug = 3762281096,
        rage__clothBridgeSimGfx = 3644642879,
        rage__clothInstanceTuning = 1335508268,
        rage__clothInstanceTuning__enCLOTH_TUNE_FLAGS = 2123839183,
        rage__clothVertexBlend = 892965980,
        rage__crJointData = 977851099,
        rage__cutfAttachmentEventArgs = 2690718402,
        rage__cutfAttribute = 1136956436,
        rage__cutfChildEvents = 2022249959,
        rage__cutfCutsceneFile = 2799240353,
        rage__cutfCutsceneFile2__SDiscardedFrameData = 220202594,
        rage__cutfCutsceneSection = 3353095820,
        rage__cutfEventArgsDef = 2851029372,
        rage__cutfEventArgsList = 3912094742,
        rage__cutfEventDef = 2300595922,
        rage__cutfEventDefs = 2174674738,
        rage__cutfEventObject = 2314185296,
        rage__cutfFinalNamedObject = 2915538097,
        rage__cutfFindModelObject = 3985246766,
        rage__cutfFloatBoolValueEventArgs = 2764578633,
        rage__cutfModelObject = 3452621141,
        rage__cutfNamedAnimatedObject = 1303271874,
        rage__cutfNamedAnimatedStreamedObject = 34692363,
        rage__cutfNamedObject = 2509877589,
        rage__cutfNamedStreamedObject = 1512942736,
        rage__cutfObject = 3350491418,
        rage__cutfObjectIdListEvent = 1650421055,
        rage__cutfObjectIdPartialHashEventArgs = 1768320299,
        rage__cutfRemovalBoundsObject = 2396548561,
        rage__cutfTwoFloatValuesEventArgs = 890738001,
        rage__dataVec3V = 2443664083,
        rage__environmentCloth = 3828403297,
        rage__fiDeviceInstaller__InitData = 1416236018,
        rage__fiDeviceInstaller__InitDataList = 1279474309,
        rage__fragTuneBreakPreset = 1003006277,
        rage__fragTuneStruct = 2402479241,
        rage__fwArchetypeDef = 1828301650,
        rage__fwEntityDef = 1161480445,
        rage__fwExtensionDef = 2516794929,
        rage__fwExtraTextFiles = 620994190,
        rage__fwExtraTextPackage = 1455890208,
        rage__fwMapData = 3006493421,
        rage__fwMapTypes = 2501015278,
        rage__fwPropInstanceListDef__InstanceData = 3932895894,
        rage__fwTextDatabaseEntry = 2207119242,
        rage__fwTextDatabaseSource = 2977389460,
        rage__ioMapperParameter = 2898322075,
        rage__ioMapperSource = 813702875,
        rage__phBound = 285763780,
        rage__phBoundCapsule = 3036484496,
        rage__phBoundComposite = 3639080237,
        rage__phCapsuleBoundDef = 1701774085,
        rage__phCapsuleBoundDef__enCollisionBoundDef = 3044470860,
        rage__phClothData = 3444108840,
        rage__phClothDataDebug = 4216915179,
        rage__phEdgeData = 3242434333,
        rage__phVec3V = 668988190,
        rage__phVerletCloth = 4082189131,
        rage__ptxDrawable = 2260124507,
        rage__ptxKeyframe = 3207319858,
        rage__ptxKeyframeSpec = 1379378129,
        rage__ptxKeyframeXmlData = 835906368,
        rage__ptxgpuDropEmitterSettings = 1886875051,
        rage__ptxgpuDropRenderSettings = 531244172,
        rage__ropeData = 2230835041,
        rage__ropeDataManager = 3750425397,
        rage__ropeMesh = 1170461874,
        rage__ropeReins = 3639568258,
        rage__ropeThin = 618648335,
        rage__ropeThin4 = 1007593509,
        rage__ropeThinWire32 = 4291288555,
        rage__ropeWire32 = 3245888457,
        rage__ropeWire6 = 357498065,
        rage__spdPlane = 4191391348,
        rage__tcInstBoxInst = 380938155,
        rage__tcInstBoxInstLoader = 3207094665,
        rage__tcInstBoxType = 2371818365,
        rage__tcInstBoxTypeLoader = 2235834026,
        randomAll = 3173107755,
        randomRedGreen = 3406312314,
        randomRedGreenAlpha = 2508490465,
        rate = 2120794248,
        readOnly = 3177591815,
        rectangle = 1728072774,
        rectangleFlip = 1003190020,
        red = 2557620812,
        renderSettingsName = 2255786310,
        requiredExtras = 571676183,
        requiredVersion = 3808371558,
        restartState = 3814420125,
        restrictionTags = 3992637828,
        reversinglight_l = 1550779230,
        reversinglight_r = 1199528315,
        rewardData = 3836416713,
        rewards = 2736600648,
        right = 3100427065,
        rightArmInfo = 1770560117,
        rightLegInfo = 3429237052,
        rotSpeedMinMax = 4161653491,
        rotationXYZ = 1626220772,
        rotationZ = 1125138672,
        ruleType = 3635867417,
        rumbleProfiles = 2540254603,
        runtime = 232288346,
        sDefaultTaskData = 3427356452,
        sMapZoomData = 3354079501,
        sMapZoomData__sMapZoomLevel = 1844936755,
        sMotionTaskData = 3859530250,
        sOverlayInfo = 2535360664,
        sOverlayInfos = 648602920,
        sPedAccuracyModifiers = 4184071332,
        sWeaponInfoList = 2529289019,
        savedDoorStates = 576219275,
        sblade_1_lfast = 3237490897,
        sblade_1_rfast = 3375838140,
        sblade_1mod = 1086719913,
        sblade_2_1fast = 3607058940,
        sblade_2mod = 2381840182,
        sblade_3_lfast = 303656220,
        sblade_3_rfast = 660207018,
        sblade_3mod = 1208798824,
        scenarioAnimsTimeout = 3569107303,
        scenarioLayout = 1118714389,
        sceneName = 1419559321,
        sceneOrigin = 2708928640,
        scenePresets = 4039253031,
        scenes = 1346030497,
        schedules = 967565117,
        scriptCallstackSize = 1685119934,
        scriptName = 1424087696,
        seDamage = 1184450396,
        seEnvironment = 2962909320,
        seWeather = 4292903156,
        secondaryAccsColor = 895887934,
        secondaryHairColor = 1808760944,
        sections = 851876526,
        shaderVars = 3135596209,
        shotPtFxName = 423449081,
        shouldCameraIgnoreExiting = 1289313015,
        shouldCameraTransitionOnClimbUpDown = 3147867771,
        shouldUseCinematicViewMode = 293833780,
        shownAlpha = 370377812,
        sirenRotation = 1356743507,
        sirenSettings__sequencerData = 188820339,
        sizeAfter = 990428008,
        sizeBefore = 3857591758,
        sizeMinMax = 1363449472,
        size_x = 3794883390,
        size_y = 4107499650,
        skin = 3836508208,
        skinDetail1 = 1393933797,
        skinDetail2 = 188657212,
        skipPanRange = 2588261606,
        slowdownDist = 1549737482,
        smokeColB = 2428283409,
        smokeColG = 4163041496,
        smokeColR = 3809562301,
        smoulderPtFxName = 1437576219,
        sourceAssets = 1607236820,
        sourceFile = 4026974963,
        specularFalloff = 1024535195,
        specularFresnel = 1906192426,
        specularIntensity = 709949768,
        spike_1ped_col = 3045655218,
        spike_2car_col = 1123212214,
        spike_2ped_col = 1122332083,
        spike_3car_col = 2320654166,
        spike_3ped_col = 4011591561,
        splashEntryPtFxName = 3950900138,
        splashEntryPtFxSpeedEvoMax = 1327278534,
        splashEntryPtFxSpeedEvoMin = 4131076032,
        splashInPtFxSpeedEvoMax = 4258146773,
        splashInPtFxSpeedEvoMin = 1335117116,
        splashLodPtFxName = 4143286255,
        splashLodPtFxSpeedEvoMax = 4224134658,
        splashLodPtFxSpeedEvoMin = 1079949132,
        splashOutPtFxSpeedEvoMax = 1518647754,
        splashOutPtFxSpeedEvoMin = 4020845257,
        sprintMultiplier = 2697673433,
        staminaMultiplier = 131113652,
        startFrom = 1445713221,
        startImapFile = 2615560996,
        startModel = 2164506086,
        startPos = 2421107423,
        startRot = 3792447440,
        startTime = 2459809677,
        startedWithVehicleSavingEnabled = 3340092031,
        startupScript = 825086320,
        statEnumValue = 463793407,
        statName = 2019330033,
        statValue = 397757477,
        statvalue = 158478724,
        steerWheelMult = 3742923904,
        steeringMultiplier = 2803635749,
        step = 10812617,
        stepOf90 = 147249832,
        stepsSprint = 618136263,
        stiffnessMult = 830849092,
        storageType = 1201759490,
        strAdvancedFlags = 1269590471,
        strDamageFlags = 3605368469,
        strFlags = 1514195573,
        strHandlingFlags = 1282416630,
        strModelFlags = 3040490582,
        subPackCount = 1077695440,
        subsequentImpactKillRadiusMax = 2311341585,
        subsequentImpactKillRadiusMin = 2307373780,
        sve = 3505982113,
        sveArray = 3258242601,
        sveBool = 1686168914,
        sveDict = 3023911292,
        sveFloat = 2894387562,
        sveInt = 3520721129,
        sveNode = 3426486420,
        sveString = 2878018411,
        sveVec3 = 613249968,
        swankness = 2375403165,
        switchSettings = 360411330,
        switches = 2942144325,
        system = 2353411106,
        tagNameHash = 1154431572,
        tagSync = 2124274509,
        takeOffAnim = 2510448135,
        taskMessage = 2750788767,
        tcLightningCloudBurst = 2757964312,
        tcLightningDirectionalBurst = 1216502554,
        tcLightningDirectionalBurstWithStrike = 1328592070,
        tcLightningStrikeOnly = 1134223788,
        tcModFadeOffSecs = 1840671857,
        tcModInterpType = 1649756020,
        templateId = 165748335,
        texIndex = 1470473755,
        text = 2134593963,
        textId = 1846741770,
        textLabel = 1563516354,
        textureAnimRateScaleOverLifeStart2End2 = 1178525237,
        textureId = 2869838527,
        textureIndex = 2493120425,
        textureRowsColsStartEnd = 2262064189,
        textureVarDefaults = 1079162919,
        textureVars = 2553958546,
        timeCycleMod = 1161264632,
        timeCycleMods = 3123014229,
        timeStamp = 217292005,
        tintColor = 473471511,
        topBone = 3254176849,
        topOffset = 3009931618,
        torsoInfo = 2602108594,
        trackerPathWidth = 1704379053,
        trailers = 3417488910,
        transactiontypes = 3272102116,
        trigger = 3283079265,
        triggerInterval = 183104878,
        triggerProbability = 2103374023,
        tuningSet = 3597332783,
        turnBreakOutPhase = 632615568,
        txd = 190030222,
        txdHash = 1498617559,
        txdName = 3228764362,
        txtHash = 858666971,
        typeInventory = 4027959036,
        typeName = 3499577235,
        uAvoidanceProbeInterval = 3328108206,
        uExitingCoverLookAtTime = 3044687592,
        uFirstPersonMinTimeToSprint = 270252777,
        uFirstPersonRunAndGunWhileSprintTime = 3228655867,
        uWeaponHash = 3762693192,
        uiName = 852371380,
        uint64 = 3955380943,
        umHighWind = 4120628420,
        umLowWind = 2929976964,
        underwaterDisturbPtFxSpeedEvoMax = 4222549442,
        underwaterDisturbPtFxSpeedEvoMin = 460277230,
        uniqueFemales = 3451689625,
        uniqueMales = 3938434210,
        uniqueNameHash = 1846792403,
        updateGroup = 895825232,
        useCacheLoader = 2306505273,
        useLineIntersection = 2884615608,
        usesTintColor = 3003328912,
        uvPos = 3132175077,
        vBitmapStart = 3205558428,
        vBitmapTileSize = 4138858726,
        vCoordsOfClosestSaveHouse = 1006353833,
        vDestination = 804758827,
        vDir = 3610687809,
        vMax = 3427164682,
        vMin = 142710247,
        vMiniMapWorldSize = 2152230135,
        vMiniMapWorldStart = 4201231105,
        vPlayerStartingPos = 3889491845,
        vPosRight = 3521046749,
        vSize = 1699103095,
        vTiles = 1087504888,
        vTurnRes = 2193467325,
        valueHash = 2172573604,
        valueNumber = 631756370,
        valueString = 850100823,
        values = 860003925,
        varName = 3465927695,
        variantComponents = 2697090886,
        variantProps = 1496797558,
        variation = 3489090097,
        variations = 1773442490,
        vecCentreOfMassOffset = 3434897018,
        vecInertiaMultiplier = 3668970244,
        vecMoveResistance = 441279025,
        vecSpeedRes = 2144723834,
        vecTurnRes = 2355271178,
        vecTurnResistance = 751478520,
        vehicleClass = 2288796045,
        vehicleFlags = 921659356,
        vehicleMakeName = 1035525950,
        vehicleMods = 1551018855,
        vehicleRecords = 467733616,
        vehicleRemovals = 1810609212,
        vehicles = 1957895139,
        velocityMax = 263948083,
        velocityMin = 3344343578,
        vertIndices = 3268380262,
        vfxExtraInfos = 2388094401,
        vfxInfoName = 2471947700,
        vfxName = 996455327,
        vfxPedBoneWadeInfos = 670699231,
        vfxPedBoneWaterInfos = 161646760,
        vfxPedFootDecalInfos = 1639857157,
        vfxPedFootInfos = 866013965,
        vfxPedFootPtFxInfos = 190681942,
        vfxPedWadeDecalInfos = 619497315,
        vfxPedWadeInfos = 2436902422,
        vfxPedWadePtFxInfos = 1719780883,
        video = 1717858450,
        visibleInMenu = 1421817750,
        visibleSpawnDistScale = 2690820221,
        waterDripPtFxEnabled = 2545172352,
        waterDripPtFxName = 3919360765,
        waterDripPtFxRange = 1146082049,
        weaponComponents = 1649101945,
        weaponDesc = 430140199,
        weaponForceMult = 3811943251,
        weaponShopItems = 302274180,
        weaponTT = 3817518766,
        weaponUppercase = 214691827,
        weights = 3416705058,
        wheelScale = 2469593534,
        wheelScaleRear = 1987076664,
        wheelType = 2733182056,
        windInfluence = 2488741711,
        windowTint = 3806865411,
        zeroBlendHeadingInterpRate = 3436596602,
        zone = 4176651683,
        zoomLevels = 3487617189,
        countryside_ground = 3562022151,
        desert_ground = 3058489211,
        desert_ground_heavy = 3376072566,
        env_snow_flakes = 119760577,
        env_wind_debris = 1318711596,
        env_wind_debris_city = 2141994130,
        env_wind_debris_desert = 2969685141,
        env_wind_debris_mountain = 3913560305,
        env_wind_debris_woodland = 2725669279,
        lake_fog_drop = 1763065767,
        lake_fog_ground = 2343701897,
        vfxregioninfo_coastal = 4253054311,
        vfxregioninfo_desert_heavy = 1116439995,
        vfxregioninfo_lake = 3702648742,
        vfxregioninfo_snow = 3023501349,
        vfxregioninfo_wetland = 1959519183,
        vfxregioninfo_woodland_dense = 3085166585,
        wetland_flies_drop = 907634280,
        woodland_firefly_drop = 2380660330,
        woodland_mist_ground = 1024959356,
        woodland_pollen_drop = 2445487209,









        //MRF related hashes from Disquse
        statemachine = 429383484,
        success = 975994832,
        cutting = 1599956773,
        leftfailure = 1765753571,
        enterfinish = 663756144,
        approach = 61579965,
        win = 3732660434,
        loss = 42942348,
        altwalk = 2629052680,
        standidle = 1244639780,
        bottlehold = 1250922115,
        bottleshake = 2761060053,
        champagnespray = 2153350042,
        back = 927041140,
        front = 2314350754,
        partone = 1335537449,
        parttwo = 2585437493,
        partthree = 3894308744,
        partfour = 4103663607,
        partfive = 288022579,
        backpartone = 3350093298,
        backparttwo = 3195341626,
        backpartthree = 3228129062,
        backpartfour = 1672309095,
        backpartfive = 3417257801,
        wobble = 3603821314,
        x_axis = 3546530265,
        y_axis = 2645075825,
        z_axis = 1604254135,
        drill_force = 1362721915,
        shake_intensity = 612782192,
        horizontal_aim = 3036116190,
        verticle_aim = 3709155216,
        direction_up_down = 1282217224,
        phase_out = 3243435260,
        upperbodyonoff = 2718654972,
        introphase = 3905075704,
        pitch = 1061927116,
        isblocked = 2611301023,
        isfirstperson = 1776409970,
        idle2 = 2046496619,
        idle3 = 2202608135,
        idle4 = 1261318610,
        lossfinished = 2337837154,
        winfinished = 3589054106,
        introfinished = 3677288433,
        outrofinished = 601717917,
        leftfailfinish = 1788424853,
        readyforfadein = 3896574076,
        idlestarted = 1321201090,
        blendout = 1842457532,
        idle_a = 3851133436,
        escape = 3655182927,
        upperbodyclipended = 3141014298,
        result_perfect = 2007828787,
        result_good = 1148916770,
        result_average = 1939741573,
        result_bad = 1402208964,
        perfectresult = 452682106,
        goodresult = 1109180461,
        averageresult = 2674371639,
        badresult = 3234678822,
        cancelneutral = 3758646108,
        dance = 1152043290,
        stage_1_loop = 2623060900,
        stage_2_loop = 3632312862,
        stage_3_loop = 125163859,
        stage_4_loop = 931907947,
        no_bag = 429567348,
        nomover_filter = 819979025,
        botharms_filter = 384947232,
        rightarm_nospine_filter = 1924927269,
        upperbodyfeathered_filter = 265147401,
        ignoremoverblend_filter = 2738335535,
        upperbodyandik_filter = 4248997943,
        bonemask_head_neck_and_l_arm = 3177231635,
        bonemask_head_neck_and_r_arm = 3921347753,
        bonemask_head_neck_and_arms = 1573924551,
        bonemask_headonly = 697476694,
        bonemask_upperonly = 3633914286,
        bonemask_armonly_l = 1739926164,
        bonemask_armonly_r = 3772128476,
    }


}
